(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define scheme/process-context-impl#get-environment-variable
    (lambda (_var3660_) (getenv _var3660_ '#f)))
  (c-declare
   "#include <unistd.h>\nextern char **environ;\nstatic int ffi_count_envvars ()\n{\n int x;\n char **env;\n for (env = environ;\n      *env;\n      ++env) ++x;\n return x;\n}\n\nstatic char *ffi_get_envvar (int x)\n{\n return environ[x];\n}")
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (##symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-c-lambda
   scheme/process-context-impl#count-envvars
   ()
   int
   "ffi_count_envvars")
  (define-c-lambda
   scheme/process-context-impl#get-envvar
   (int)
   char-string
   "ffi_get_envvar")
  (define-c-lambda scheme/process-context-impl#_exit (int) void "_exit")
  (define scheme/process-context-impl#get-environment-variables
    (lambda ()
      (letrec ((_envvar3647_
                (lambda (_str3656_)
                  (let ((_ix3658_ (string-index _str3656_ '#\=)))
                    (cons (substring _str3656_ '0 _ix3658_)
                          (substring
                           _str3656_
                           (fx+ _ix3658_ '1)
                           (string-length _str3656_)))))))
        (let ((_count3649_ (scheme/process-context-impl#count-envvars)))
          (let _lp3651_ ((_x3653_ '0) (_vars3654_ '()))
            (if (fx< _x3653_ _count3649_)
                (_lp3651_
                 (fx+ _x3653_ '1)
                 (cons (_envvar3647_
                        (scheme/process-context-impl#get-envvar _x3653_))
                       _vars3654_))
                (reverse _vars3654_)))))))
  (define scheme/process-context-impl#r7rs-exit__%
    (lambda (_normally?3636_) (exit (if _normally?3636_ '0 '1))))
  (define scheme/process-context-impl#r7rs-exit__0
    (lambda ()
      (let ((_normally?3642_ '#t))
        (scheme/process-context-impl#r7rs-exit__% _normally?3642_))))
  (define scheme/process-context-impl#r7rs-exit
    (lambda _g10783_
      (let ((_g10782_ (let () (declare (not safe)) (##length _g10783_))))
        (cond ((let () (declare (not safe)) (##fx= _g10782_ 0))
               (apply scheme/process-context-impl#r7rs-exit__0 _g10783_))
              ((let () (declare (not safe)) (##fx= _g10782_ 1))
               (apply scheme/process-context-impl#r7rs-exit__% _g10783_))
              (else
               (##raise-wrong-number-of-arguments-exception
                scheme/process-context-impl#r7rs-exit
                _g10783_)))))))
