(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/proto/null#rpc-proto-accept-e
    (lambda (_ibuf254337_ _obuf254338_ _proto-t254339_ _K254340_)
      (letrec ((_connection-closed254342_
                (lambda ()
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-accept
                   '"connection closed")))
               (_bad-hello254343_
                (lambda (_e254349_)
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-accept
                   '"bad hello"
                   _e254349_))))
        (let ((_e254345_ (std/net/bio/input#bio-read-u8 _ibuf254337_)))
          (if (eof-object? _e254345_)
              (_connection-closed254342_)
              (if (eq? _e254345_
                       std/actor/rpc/proto/message#rpc-proto-connect-hello)
                  (let ((_e254347_
                         (std/net/bio/input#bio-read-u8 _ibuf254337_)))
                    (if (eof-object? _e254347_)
                        (_connection-closed254342_)
                        (if (eq? _e254347_ _proto-t254339_)
                            (begin
                              (std/net/bio/output#bio-write-u8
                               std/actor/rpc/proto/message#rpc-proto-connect-accept
                               _obuf254338_)
                              (_K254340_ _ibuf254337_ _obuf254338_))
                            (begin
                              (std/net/bio/output#bio-write-u8
                               std/actor/rpc/proto/message#rpc-proto-connect-reject
                               _obuf254338_)
                              (std/net/bio/output#bio-force-output
                               _obuf254338_)
                              (_bad-hello254343_ _e254347_)))))
                  (_bad-hello254343_ _e254345_)))))))
  (define std/actor/rpc/proto/null#rpc-proto-connect-e
    (lambda (_ibuf254323_ _obuf254324_ _proto-t254325_ _K254326_)
      (letrec ((_connection-rejected254328_
                (lambda ()
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-connect
                   '"Connection hello rejected by peer")))
               (_connection-closed254329_
                (lambda ()
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-connect
                   '"connection closed")))
               (_bad-hello254330_
                (lambda ()
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-connect
                   '"bad hello"))))
        (std/net/bio/output#bio-write-u8
         std/actor/rpc/proto/message#rpc-proto-connect-hello
         _obuf254324_)
        (std/net/bio/output#bio-write-u8 _proto-t254325_ _obuf254324_)
        (std/net/bio/output#bio-force-output _obuf254324_)
        (let ((_e254332_ (std/net/bio/input#bio-read-u8 _ibuf254323_)))
          (if (eof-object? _e254332_)
              (_connection-closed254329_)
              (if (eq? _e254332_
                       std/actor/rpc/proto/message#rpc-proto-connect-accept)
                  (_K254326_ _ibuf254323_ _obuf254324_)
                  (if (eq? _e254332_
                           std/actor/rpc/proto/message#rpc-proto-connect-reject)
                      (_connection-rejected254328_)
                      (_bad-hello254330_))))))))
  (define std/actor/rpc/proto/null#rpc-null-proto-accept
    (lambda (_ibuf254317_ _obuf254318_)
      (std/actor/rpc/proto/null#rpc-proto-accept-e
       _ibuf254317_
       _obuf254318_
       std/actor/rpc/proto/message#rpc-proto-null
       (lambda (_ibuf254320_ _obuf254321_)
         (std/net/bio/output#bio-force-output _obuf254321_)
         (values std/actor/rpc/proto/null#rpc-null-proto-read
                 std/actor/rpc/proto/null#rpc-null-proto-write)))))
  (define std/actor/rpc/proto/null#rpc-null-proto-connect
    (lambda (_ibuf254311_ _obuf254312_)
      (std/actor/rpc/proto/null#rpc-proto-connect-e
       _ibuf254311_
       _obuf254312_
       std/actor/rpc/proto/message#rpc-proto-null
       (lambda (_ibuf254314_ _obuf254315_)
         (values std/actor/rpc/proto/null#rpc-null-proto-read
                 std/actor/rpc/proto/null#rpc-null-proto-write)))))
  (define std/actor/rpc/proto/null#rpc-null-proto-read
    (lambda (_ibuf254302_ _bytes254303_)
      (let ((_e254305_ (std/net/bio/input#bio-read-u8 _ibuf254302_)))
        (if (eq? _e254305_ std/actor/rpc/proto/message#rpc-proto-keep-alive)
            '#!void
            (if (eq? _e254305_ std/actor/rpc/proto/message#rpc-proto-message)
                (let ((_len254307_
                       (std/net/bio/input#bio-read-u32 _ibuf254302_)))
                  (if (fx<= _len254307_
                            std/actor/rpc/proto/message#rpc-proto-message-max-length)
                      (let ((_bytes254309_
                             (if (fx< (u8vector-length _bytes254303_)
                                      _len254307_)
                                 (make-u8vector _len254307_)
                                 _bytes254303_)))
                        (std/net/bio/input#bio-read-subu8vector-unbuffered
                         _bytes254309_
                         '0
                         _len254307_
                         _ibuf254302_)
                        (values _bytes254309_ _len254307_))
                      (std/actor/proto#raise-rpc-io-error
                       'rpc-proto-read
                       '"message too long"
                       _len254307_)))
                (if (eof-object? _e254305_)
                    _e254305_
                    (std/actor/proto#raise-rpc-io-error
                     'rpc-proto-read
                     '"bad message"
                     _e254305_)))))))
  (define std/actor/rpc/proto/null#rpc-null-proto-write
    (lambda (_obuf254290_ _obj254291_)
      (if (eq? _obj254291_ '#!void)
          (begin
            (std/net/bio/output#bio-write-u8
             std/actor/rpc/proto/message#rpc-proto-keep-alive
             _obuf254290_)
            (std/net/bio/output#bio-force-output _obuf254290_))
          (if (u8vector? _obj254291_)
              (begin
                (std/net/bio/output#bio-write-u8
                 std/actor/rpc/proto/message#rpc-proto-message
                 _obuf254290_)
                (std/net/bio/output#bio-write-u32
                 (u8vector-length _obj254291_)
                 _obuf254290_)
                (std/net/bio/output#bio-write-bytes _obj254291_ _obuf254290_)
                (std/net/bio/output#bio-force-output _obuf254290_))
              (if (##structure-instance-of?
                   _obj254291_
                   'std/net/bio/buffer#chunked-output-buffer::t)
                  (let* ((_len254293_
                          (std/net/bio/buffer#chunked-output-length
                           _obj254291_))
                         (_chunks254295_
                          (std/net/bio/buffer#chunked-output-chunks
                           _obj254291_)))
                    (std/net/bio/output#bio-write-u8
                     std/actor/rpc/proto/message#rpc-proto-message
                     _obuf254290_)
                    (std/net/bio/output#bio-write-u32 _len254293_ _obuf254290_)
                    (for-each
                     (lambda (_g254297254299_)
                       (std/net/bio/output#bio-write-bytes
                        _g254297254299_
                        _obuf254290_))
                     _chunks254295_)
                    (std/net/bio/output#bio-force-output _obuf254290_))
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-write
                   '"unexpected object"
                   _obj254291_))))))
  (define std/actor/rpc/proto/null#rpc-null-proto
    (lambda ()
      (##structure
       std/actor/rpc/base#!rpc-protocol::t
       std/actor/rpc/proto/null#rpc-null-proto-connect
       std/actor/rpc/proto/null#rpc-null-proto-accept))))
