(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/etc#libcrypto-error::t
    (make-struct-type
     'std/crypto/etc#libcrypto-error::t
     error::t
     '0
     'libcrypto-error
     '()
     ':init!
     '()))
  (define std/crypto/etc#libcrypto-error?
    (make-struct-predicate std/crypto/etc#libcrypto-error::t))
  (define std/crypto/etc#make-libcrypto-error
    (lambda _$args173979_
      (apply make-struct-instance
             std/crypto/etc#libcrypto-error::t
             _$args173979_)))
  (define std/crypto/etc#libcrypto-error:::init!
    (lambda (_self173966_ _errno173967_ _irritants173968_)
      (if (let ((__tmp301415
                 (let () (declare (not safe)) (##vector-length _self173966_))))
            (declare (not safe))
            (##fx< '3 __tmp301415))
          (begin
            (let ((__tmp301416
                   (let ((_$e173970_
                          (std/crypto/libcrypto#ERR_reason_error_string
                           _errno173967_)))
                     (if _$e173970_ _$e173970_ '"Unknown error"))))
              (declare (not safe))
              (##vector-set! _self173966_ '1 __tmp301416))
            (let ((__tmp301417 (cons _errno173967_ _irritants173968_)))
              (declare (not safe))
              (##vector-set! _self173966_ '2 __tmp301417))
            (let ((__tmp301418
                   (string-append
                    (let ((_$e173973_
                           (std/crypto/libcrypto#ERR_lib_error_string
                            _errno173967_)))
                      (if _$e173973_ _$e173973_ '"?"))
                    '":"
                    (let ((_$e173976_
                           (std/crypto/libcrypto#ERR_func_error_string
                            _errno173967_)))
                      (if _$e173976_ _$e173976_ '"?")))))
              (declare (not safe))
              (##vector-set! _self173966_ '3 __tmp301418)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self173966_))))
  (bind-method!
   std/crypto/etc#libcrypto-error::t
   ':init!
   std/crypto/etc#libcrypto-error:::init!
   '#f)
  (define std/crypto/etc#libcrypto-error::display-exception
    (lambda (_self173841_ _port173842_)
      (std/format#fprintf
       _port173842_
       '"Libcrypto error [~a]: ~a ~a~n"
       (error-trace _self173841_)
       (error-message _self173841_)
       (error-irritants _self173841_))))
  (bind-method!
   std/crypto/etc#libcrypto-error::t
   'display-exception
   std/crypto/etc#libcrypto-error::display-exception
   '#f)
  (define std/crypto/etc#raise-libcrypto-error
    (lambda _irritants173717_
      (raise (make-struct-instance
              std/crypto/etc#libcrypto-error::t
              (std/crypto/libcrypto#ERR_get_error)
              _irritants173717_))))
  (define std/crypto/etc#call-with-binary-input
    (lambda (_proc173713_ _in173714_ . _args173715_)
      (if (u8vector? _in173714_)
          (apply std/crypto/etc#call-with-binary-input-u8vector
                 _proc173713_
                 _in173714_
                 _args173715_)
          (if (string? _in173714_)
              (apply std/crypto/etc#call-with-binary-input-string
                     _proc173713_
                     _in173714_
                     _args173715_)
              (if (input-port? _in173714_)
                  (apply std/crypto/etc#call-with-binary-input-port
                         _proc173713_
                         _in173714_
                         _args173715_)
                  (error '"Unexpected input source" _in173714_))))))
  (define std/crypto/etc#call-with-binary-input-u8vector__0
    (lambda (_proc173701_ _in173702_)
      (_proc173701_
       _in173702_
       '0
       (let () (declare (not safe)) (##u8vector-length _in173702_)))))
  (define std/crypto/etc#call-with-binary-input-u8vector__1
    (lambda (_proc173704_ _in173705_ _start173706_)
      (_proc173704_
       _in173705_
       _start173706_
       (let () (declare (not safe)) (##u8vector-length _in173705_)))))
  (define std/crypto/etc#call-with-binary-input-u8vector__2
    (lambda (_proc173708_ _in173709_ _start173710_ _end173711_)
      (_proc173708_ _in173709_ _start173710_ _end173711_)))
  (define std/crypto/etc#call-with-binary-input-u8vector
    (lambda _g301420_
      (let ((_g301419_ (let () (declare (not safe)) (##length _g301420_))))
        (cond ((let () (declare (not safe)) (##fx= _g301419_ 2))
               (apply std/crypto/etc#call-with-binary-input-u8vector__0
                      _g301420_))
              ((let () (declare (not safe)) (##fx= _g301419_ 3))
               (apply std/crypto/etc#call-with-binary-input-u8vector__1
                      _g301420_))
              ((let () (declare (not safe)) (##fx= _g301419_ 4))
               (apply std/crypto/etc#call-with-binary-input-u8vector__2
                      _g301420_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/etc#call-with-binary-input-u8vector
                _g301420_))))))
  (define std/crypto/etc#call-with-binary-input-string__0
    (lambda (_proc173689_ _in173690_)
      (std/crypto/etc#call-with-binary-input-u8vector__0
       _proc173689_
       (std/text/utf8#string->utf8__0 _in173690_))))
  (define std/crypto/etc#call-with-binary-input-string__1
    (lambda (_proc173692_ _in173693_ _start173694_)
      (std/crypto/etc#call-with-binary-input-u8vector__0
       _proc173692_
       (std/text/utf8#utf8-encode
        _in173693_
        _start173694_
        (let () (declare (not safe)) (##string-length _in173693_))))))
  (define std/crypto/etc#call-with-binary-input-string__2
    (lambda (_proc173696_ _in173697_ _start173698_ _end173699_)
      (std/crypto/etc#call-with-binary-input-u8vector__0
       _proc173696_
       (std/text/utf8#utf8-encode _in173697_ _start173698_ _end173699_))))
  (define std/crypto/etc#call-with-binary-input-string
    (lambda _g301422_
      (let ((_g301421_ (let () (declare (not safe)) (##length _g301422_))))
        (cond ((let () (declare (not safe)) (##fx= _g301421_ 2))
               (apply std/crypto/etc#call-with-binary-input-string__0
                      _g301422_))
              ((let () (declare (not safe)) (##fx= _g301421_ 3))
               (apply std/crypto/etc#call-with-binary-input-string__1
                      _g301422_))
              ((let () (declare (not safe)) (##fx= _g301421_ 4))
               (apply std/crypto/etc#call-with-binary-input-string__2
                      _g301422_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/etc#call-with-binary-input-string
                _g301422_))))))
  (define std/crypto/etc#call-with-binary-input-port__%
    (lambda (_proc173673_ _in173674_ _fill?173675_)
      (if (macro-byte-input-port? _in173674_)
          (std/crypto/etc#call-with-binary-input-byte-port
           _proc173673_
           _in173674_
           _fill?173675_)
          (if (macro-character-input-port? _in173674_)
              (std/crypto/etc#call-with-binary-input-character-port
               _proc173673_
               _in173674_
               _fill?173675_)
              (error '"Unusable input-port; need a character or byte port"
                     _in173674_)))))
  (define std/crypto/etc#call-with-binary-input-port__0
    (lambda (_proc173680_ _in173681_)
      (let ((_fill?173683_ '#t))
        (std/crypto/etc#call-with-binary-input-port__%
         _proc173680_
         _in173681_
         _fill?173683_))))
  (define std/crypto/etc#call-with-binary-input-port
    (lambda _g301424_
      (let ((_g301423_ (let () (declare (not safe)) (##length _g301424_))))
        (cond ((let () (declare (not safe)) (##fx= _g301423_ 2))
               (apply std/crypto/etc#call-with-binary-input-port__0 _g301424_))
              ((let () (declare (not safe)) (##fx= _g301423_ 3))
               (apply std/crypto/etc#call-with-binary-input-port__% _g301424_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/etc#call-with-binary-input-port
                _g301424_))))))
  (define std/crypto/etc#call-with-binary-input-byte-port
    (lambda (_proc173658_ _in173659_ _fill?173660_)
      (let ((_bytes173662_
             (std/crypto/etc#drain-input-character-buffer _in173659_)))
        (if _bytes173662_
            (_proc173658_
             _bytes173662_
             '0
             (let () (declare (not safe)) (##u8vector-length _bytes173662_)))
            '#!void))
      (let ((_buf173664_ (let () (declare (not safe)) (##make-u8vector '1024)))
            (_need173665_ (if _fill?173660_ '1 absent-obj)))
        (let _lp173667_ ()
          (let ((_rd173670_
                 (let ()
                   (declare (not safe))
                   (##read-subu8vector
                    _buf173664_
                    '0
                    '1024
                    _in173659_
                    _need173665_))))
            (if (let () (declare (not safe)) (##fxzero? _rd173670_))
                '#!void
                (begin
                  (_proc173658_ _buf173664_ '0 _rd173670_)
                  (_lp173667_))))))))
  (define std/crypto/etc#call-with-binary-input-character-port
    (lambda (_proc173644_ _in173645_ _fill?173646_)
      (let ((_buf173648_ (let () (declare (not safe)) (##make-string '512)))
            (_need173649_ (if _fill?173646_ '1 absent-obj)))
        (let _lp173651_ ()
          (let ((_rd173654_
                 (let ()
                   (declare (not safe))
                   (##read-substring
                    _buf173648_
                    '0
                    '512
                    _in173645_
                    _need173649_))))
            (if (let () (declare (not safe)) (##fxzero? _rd173654_))
                '#!void
                (let ((_bytes173656_
                       (std/text/utf8#utf8-encode _buf173648_ '0 _rd173654_)))
                  (_proc173644_
                   _bytes173656_
                   '0
                   (let ()
                     (declare (not safe))
                     (##u8vector-length _bytes173656_)))
                  (_lp173651_))))))))
  (define std/crypto/etc#drain-input-character-buffer
    (lambda (_port173639_)
      (gerbil/gambit/threads#with-lock
       (macro-port-mutex _port173639_)
       (lambda ()
         (if (let ((__tmp301426 (macro-character-port-rlo _port173639_))
                   (__tmp301425 (macro-character-port-rhi _port173639_)))
               (declare (not safe))
               (##fx< __tmp301426 __tmp301425))
             (let ((_buf173642_
                    (std/text/utf8#utf8-encode
                     (macro-character-port-rbuf _port173639_)
                     (macro-character-port-rlo _port173639_)
                     (macro-character-port-rhi _port173639_))))
               (macro-character-port-rlo-set!
                _port173639_
                (macro-character-port-rhi _port173639_))
               _buf173642_)
             '#f)))))
  (define std/crypto/etc#*urandom* (open-input-file '"/dev/urandom"))
  (define std/crypto/etc#random-bytes
    (lambda (_len173635_)
      (let ((_bytes173637_ (make-u8vector _len173635_)))
        (std/crypto/etc#random-bytes!__% _bytes173637_ '0 _len173635_)
        _bytes173637_)))
  (define std/crypto/etc#random-bytes!__%
    (lambda (_bytes173611_ _start173612_ _end173613_)
      (let ((_count173615_
             (read-subu8vector
              _bytes173611_
              _start173612_
              _end173613_
              std/crypto/etc#*urandom*)))
        (if (eq? _count173615_
                 (let ()
                   (declare (not safe))
                   (##fx- _end173613_ _start173612_)))
            '#!void
            (error '"Could not read enough random bytes"
                   _count173615_
                   _start173612_
                   _end173613_)))))
  (define std/crypto/etc#random-bytes!__0
    (lambda (_bytes173620_)
      (let* ((_start173622_ '0) (_end173624_ (u8vector-length _bytes173620_)))
        (std/crypto/etc#random-bytes!__%
         _bytes173620_
         _start173622_
         _end173624_))))
  (define std/crypto/etc#random-bytes!__1
    (lambda (_bytes173626_ _start173627_)
      (let ((_end173629_ (u8vector-length _bytes173626_)))
        (std/crypto/etc#random-bytes!__%
         _bytes173626_
         _start173627_
         _end173629_))))
  (define std/crypto/etc#random-bytes!
    (lambda _g301428_
      (let ((_g301427_ (let () (declare (not safe)) (##length _g301428_))))
        (cond ((let () (declare (not safe)) (##fx= _g301427_ 1))
               (apply std/crypto/etc#random-bytes!__0 _g301428_))
              ((let () (declare (not safe)) (##fx= _g301427_ 2))
               (apply std/crypto/etc#random-bytes!__1 _g301428_))
              ((let () (declare (not safe)) (##fx= _g301427_ 3))
               (apply std/crypto/etc#random-bytes!__% _g301428_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/etc#random-bytes!
                _g301428_)))))))
