(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/dbi#connection::t
    (make-struct-type
     'std/db/dbi#connection::t
     '#f
     '4
     'connection
     '()
     ':init!
     '(e txn-begin txn-commit txn-abort)))
  (define std/db/dbi#connection?
    (make-struct-predicate std/db/dbi#connection::t))
  (define std/db/dbi#make-connection
    (lambda _$args259569_
      (apply make-struct-instance std/db/dbi#connection::t _$args259569_)))
  (define std/db/dbi#connection-e
    (make-struct-field-accessor std/db/dbi#connection::t '0))
  (define std/db/dbi#connection-txn-begin
    (make-struct-field-accessor std/db/dbi#connection::t '1))
  (define std/db/dbi#connection-txn-commit
    (make-struct-field-accessor std/db/dbi#connection::t '2))
  (define std/db/dbi#connection-txn-abort
    (make-struct-field-accessor std/db/dbi#connection::t '3))
  (define std/db/dbi#connection-e-set!
    (make-struct-field-mutator std/db/dbi#connection::t '0))
  (define std/db/dbi#connection-txn-begin-set!
    (make-struct-field-mutator std/db/dbi#connection::t '1))
  (define std/db/dbi#connection-txn-commit-set!
    (make-struct-field-mutator std/db/dbi#connection::t '2))
  (define std/db/dbi#connection-txn-abort-set!
    (make-struct-field-mutator std/db/dbi#connection::t '3))
  (define std/db/dbi#statement::t
    (make-struct-type 'std/db/dbi#statement::t '#f '1 'statement '() '#f '(e)))
  (define std/db/dbi#statement?
    (make-struct-predicate std/db/dbi#statement::t))
  (define std/db/dbi#make-statement
    (lambda _$args259566_
      (apply make-struct-instance std/db/dbi#statement::t _$args259566_)))
  (define std/db/dbi#statement-e
    (make-struct-field-accessor std/db/dbi#statement::t '0))
  (define std/db/dbi#statement-e-set!
    (make-struct-field-mutator std/db/dbi#statement::t '0))
  (define std/db/dbi#connection:::init!
    (lambda (_self259563_ _e259564_)
      (if (let ((__tmp311179
                 (let () (declare (not safe)) (##vector-length _self259563_))))
            (declare (not safe))
            (##fx< '1 __tmp311179))
          (let ()
            (declare (not safe))
            (##vector-set! _self259563_ '1 _e259564_))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self259563_))))
  (bind-method!
   std/db/dbi#connection::t
   ':init!
   std/db/dbi#connection:::init!
   '#f)
  (define std/db/dbi#sql-error::t
    (make-struct-type
     'std/db/dbi#sql-error::t
     error::t
     '0
     'sql-error
     '()
     '#f
     '()))
  (define std/db/dbi#sql-error?
    (make-struct-predicate std/db/dbi#sql-error::t))
  (define std/db/dbi#make-sql-error
    (lambda _$args259438_
      (apply make-struct-instance std/db/dbi#sql-error::t _$args259438_)))
  (define std/db/dbi#raise-sql-error
    (lambda (_where259434_ _what259435_ . _irritants259436_)
      (raise (make-struct-instance
              std/db/dbi#sql-error::t
              _what259435_
              _irritants259436_
              _where259434_))))
  (define std/db/dbi#sql-connect
    (lambda (_connect259429_ . _args259430_)
      (let ((_conn259432_ (apply _connect259429_ _args259430_)))
        (make-will _conn259432_ std/db/dbi#sql-close)
        _conn259432_)))
  (define std/db/dbi#sql-close
    (lambda (_conn259379_)
      (let* ((_conn259380259389_ _conn259379_)
             (_E259382259393_
              (lambda () (error '"No clause matching" _conn259380259389_)))
             (_K259383259406_
              (lambda (_txn-abort259396_
                       _txn-commit259397_
                       _txn-begin259398_
                       _e259399_)
                (if _e259399_
                    (with-unwind-protect
                     (lambda ()
                       (if _txn-begin259398_
                           (with-exception-catcher
                            void
                            (lambda ()
                              (let ((__method311160
                                     (method-ref _txn-begin259398_ 'finalize)))
                                (if __method311160
                                    (__method311160 _txn-begin259398_)
                                    (error '"Missing method"
                                           _txn-begin259398_
                                           'finalize)))))
                           '#!void)
                       (if _txn-commit259397_
                           (with-exception-catcher
                            void
                            (lambda ()
                              (let ((__method311161
                                     (method-ref
                                      _txn-commit259397_
                                      'finalize)))
                                (if __method311161
                                    (__method311161 _txn-commit259397_)
                                    (error '"Missing method"
                                           _txn-commit259397_
                                           'finalize)))))
                           '#!void)
                       (if _txn-abort259396_
                           (with-exception-catcher
                            void
                            (lambda ()
                              (let ((__method311162
                                     (method-ref _txn-abort259396_ 'finalize)))
                                (if __method311162
                                    (__method311162 _txn-abort259396_)
                                    (error '"Missing method"
                                           _txn-abort259396_
                                           'finalize)))))
                           '#!void)
                       (let ((__method311163 (method-ref _conn259379_ 'close)))
                         (if __method311163
                             (__method311163 _conn259379_)
                             (error '"Missing method" _conn259379_ 'close))))
                     (lambda ()
                       (##structure-set!
                        _conn259379_
                        '#f
                        '1
                        std/db/dbi#connection::t
                        '#f)
                       (##structure-set!
                        _conn259379_
                        '#f
                        '2
                        std/db/dbi#connection::t
                        '#f)
                       (##structure-set!
                        _conn259379_
                        '#f
                        '3
                        std/db/dbi#connection::t
                        '#f)
                       (##structure-set!
                        _conn259379_
                        '#f
                        '4
                        std/db/dbi#connection::t
                        '#f)))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of?
               _conn259380259389_
               'std/db/dbi#connection::t))
            (let* ((_e259384259409_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _conn259380259389_ '1)))
                   (_e259412_ _e259384259409_)
                   (_e259385259414_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _conn259380259389_ '2)))
                   (_txn-begin259417_ _e259385259414_)
                   (_e259386259419_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _conn259380259389_ '3)))
                   (_txn-commit259422_ _e259386259419_)
                   (_e259387259424_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _conn259380259389_ '4)))
                   (_txn-abort259427_ _e259387259424_))
              (_K259383259406_
               _txn-abort259427_
               _txn-commit259422_
               _txn-begin259417_
               _e259412_))
            (_E259382259393_)))))
  (define std/db/dbi#connection::destroy std/db/dbi#sql-close)
  (bind-method!
   std/db/dbi#connection::t
   'destroy
   std/db/dbi#connection::destroy
   '#f)
  (define std/db/dbi#sql-txn-do
    (lambda (_conn259225_ _sql259226_ _getf259227_ _setf259228_)
      (let* ((_conn259229259235_ _conn259225_)
             (_E259231259239_
              (lambda () (error '"No clause matching" _conn259229259235_)))
             (_K259232259249_
              (lambda (_e259242_)
                (if (not _e259242_)
                    (error '"Invalid operation; connection closed"
                           _conn259225_)
                    (let ((_$e259244_ (_getf259227_ _conn259225_)))
                      (if _$e259244_
                          (std/db/dbi#sql-exec _$e259244_)
                          (let ((_stmt259247_
                                 (let ((__method311164
                                        (method-ref _conn259225_ 'prepare)))
                                   (if __method311164
                                       (__method311164
                                        _conn259225_
                                        _sql259226_)
                                       (error '"Missing method"
                                              _conn259225_
                                              'prepare)))))
                            (_setf259228_ _conn259225_ _stmt259247_)
                            (std/db/dbi#sql-exec _stmt259247_))))))))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of?
               _conn259229259235_
               'std/db/dbi#connection::t))
            (let* ((_e259233259252_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _conn259229259235_ '1)))
                   (_e259255_ _e259233259252_))
              (_K259232259249_ _e259255_))
            (_E259231259239_)))))
  (define std/db/dbi#sql-txn-begin
    (lambda (_conn259223_)
      (std/db/dbi#sql-txn-do
       _conn259223_
       '"BEGIN TRANSACTION"
       std/db/dbi#connection-txn-begin
       std/db/dbi#connection-txn-begin-set!)))
  (define std/db/dbi#sql-txn-commit
    (lambda (_conn259221_)
      (std/db/dbi#sql-txn-do
       _conn259221_
       '"COMMIT"
       std/db/dbi#connection-txn-commit
       std/db/dbi#connection-txn-commit-set!)))
  (define std/db/dbi#sql-txn-abort
    (lambda (_conn259219_)
      (std/db/dbi#sql-txn-do
       _conn259219_
       '"ROLLBACK"
       std/db/dbi#connection-txn-abort
       std/db/dbi#connection-txn-abort-set!)))
  (define std/db/dbi#sql-prepare
    (lambda (_conn259214_ _text259215_)
      (if (##structure-ref _conn259214_ '1 std/db/dbi#connection::t '#f)
          (let ((_stmt259217_
                 (let ((__method311165 (method-ref _conn259214_ 'prepare)))
                   (if __method311165
                       (__method311165 _conn259214_ _text259215_)
                       (error '"Missing method" _conn259214_ 'prepare)))))
            (make-will _stmt259217_ std/db/dbi#sql-finalize)
            _stmt259217_)
          (error '"Invalid operation; connection closed" _conn259214_))))
  (define std/db/dbi#sql-finalize
    (lambda (_stmt259210_)
      (if (##structure-ref _stmt259210_ '1 std/db/dbi#statement::t '#f)
          (with-unwind-protect
           (lambda ()
             (let ((__method311166 (method-ref _stmt259210_ 'finalize)))
               (if __method311166
                   (__method311166 _stmt259210_)
                   (error '"Missing method" _stmt259210_ 'finalize))))
           (lambda ()
             (##structure-set!
              _stmt259210_
              '#f
              '1
              std/db/dbi#statement::t
              '#f)))
          '#!void)))
  (define std/db/dbi#statement::destroy std/db/dbi#sql-finalize)
  (bind-method!
   std/db/dbi#statement::t
   'destroy
   std/db/dbi#statement::destroy
   '#f)
  (define std/db/dbi#sql-bind
    (lambda (_stmt259085_ . _args259086_)
      (if (##structure-ref _stmt259085_ '1 std/db/dbi#statement::t '#f)
          (apply call-method _stmt259085_ 'bind _args259086_)
          (error '"Invalid operation; statement finalized" _stmt259085_))))
  (define std/db/dbi#sql-clear
    (lambda (_stmt259083_)
      (if (##structure-ref _stmt259083_ '1 std/db/dbi#statement::t '#f)
          (let ((__method311167 (method-ref _stmt259083_ 'clear)))
            (if __method311167
                (__method311167 _stmt259083_)
                (error '"Missing method" _stmt259083_ 'clear)))
          (error '"Invalid operation; statement finalized" _stmt259083_))))
  (define std/db/dbi#sql-reset
    (lambda (_stmt259081_)
      (if (##structure-ref _stmt259081_ '1 std/db/dbi#statement::t '#f)
          (let ((__method311168 (method-ref _stmt259081_ 'reset)))
            (if __method311168
                (__method311168 _stmt259081_)
                (error '"Missing method" _stmt259081_ 'reset)))
          (error '"Invalid operation; statement finalized" _stmt259081_))))
  (define std/db/dbi#sql-reset/clear
    (lambda (_stmt259079_)
      (if (##structure-ref _stmt259079_ '1 std/db/dbi#statement::t '#f)
          (begin
            (let ((__method311169 (method-ref _stmt259079_ 'reset)))
              (if __method311169
                  (__method311169 _stmt259079_)
                  (error '"Missing method" _stmt259079_ 'reset)))
            (let ((__method311170 (method-ref _stmt259079_ 'clear)))
              (if __method311170
                  (__method311170 _stmt259079_)
                  (error '"Missing method" _stmt259079_ 'clear))))
          (error '"Invalid operation; statement finalized" _stmt259079_))))
  (define std/db/dbi#sql-eval-e
    (lambda (_eval-e259070_ _conn259071_ _sql259072_ _args259073_)
      (let ((_stmt259075_ (std/db/dbi#sql-prepare _conn259071_ _sql259072_)))
        (with-unwind-protect
         (lambda ()
           (if (null? _args259073_)
               '#!void
               (apply std/db/dbi#sql-bind _stmt259075_ _args259073_))
           (_eval-e259070_ _stmt259075_))
         (lambda () (std/db/dbi#sql-finalize _stmt259075_))))))
  (define std/db/dbi#sql-eval
    (lambda (_conn259066_ _sql259067_ . _args259068_)
      (std/db/dbi#sql-eval-e
       std/db/dbi#sql-exec
       _conn259066_
       _sql259067_
       _args259068_)))
  (define std/db/dbi#sql-eval-query
    (lambda (_conn259062_ _sql259063_ . _args259064_)
      (std/db/dbi#sql-eval-e
       std/db/dbi#sql-query
       _conn259062_
       _sql259063_
       _args259064_)))
  (define std/db/dbi#sql-exec
    (lambda (_stmt259060_)
      (if (##structure-ref _stmt259060_ '1 std/db/dbi#statement::t '#f)
          (begin
            (let ((__method311171 (method-ref _stmt259060_ 'exec)))
              (if __method311171
                  (__method311171 _stmt259060_)
                  (error '"Missing method" _stmt259060_ 'exec)))
            (let ((__method311172 (method-ref _stmt259060_ 'reset)))
              (if __method311172
                  (__method311172 _stmt259060_)
                  (error '"Missing method" _stmt259060_ 'reset)))
            '#!void)
          (error '"Invalid operation; statement finalized" _stmt259060_))))
  (define std/db/dbi#sql-query
    (lambda (_stmt258999_)
      (let ((_iterable259022_ (std/db/dbi#in-sql-query _stmt258999_))
            (_iter-do259024_
             (lambda (_val259001_)
               (let* ((_val259003259008_ _val259001_)
                      (_E259005259012_
                       (lambda ()
                         (error '"No clause matching" _val259003259008_)))
                      (_K259006259017_ (lambda (_row259015_) _row259015_))
                      (_row259020_ _val259003259008_))
                 (_K259006259017_ _row259020_)))))
        (if (pair? _iterable259022_)
            (map _iter-do259024_ _iterable259022_)
            (if (null? _iterable259022_)
                '()
                (let* ((_it259027_ (std/iter#iter _iterable259022_))
                       (_next!259030_
                        (let ()
                          (declare (not safe))
                          (##unchecked-structure-ref
                           _it259027_
                           '2
                           std/iter#iterator::t
                           '#f))))
                  (declare (not safe))
                  (let ((_root259035_ (cons '#f '())))
                    (let _lp259038_ ((_tl259041_ _root259035_))
                      (let ((_val259044_ (_next!259030_ _it259027_)))
                        (if (eq? std/iter#iter-end _val259044_)
                            (begin
                              (let ((_$e259046_
                                     (##unchecked-structure-ref
                                      _it259027_
                                      '3
                                      std/iter#iterator::t
                                      '#f)))
                                (if _$e259046_
                                    ((lambda (_g259048259050_)
                                       (_g259048259050_ _it259027_))
                                     _$e259046_)
                                    '#!void))
                              (cdr _root259035_))
                            (let* ((_xval259053_ (_iter-do259024_ _val259044_))
                                   (_tl*259056_ (cons _xval259053_ '())))
                              (set-cdr! _tl259041_ _tl*259056_)
                              (_lp259038_ _tl*259056_))))))))))))
  (define std/db/dbi#:iter::statement
    (lambda (_stmt258997_) (std/db/dbi#in-sql-query _stmt258997_)))
  (std/generic/dispatch#generic-bind!
   std/iter#:iter::t
   (cons (std/generic/dispatch#type-linearize-class std/db/dbi#statement::t)
         '())
   std/db/dbi#:iter::statement)
  (define std/db/dbi#in-sql-query
    (lambda (_stmt258874_)
      (letrec ((_next258876_
                (lambda (_it258905_)
                  (let* ((_it258906258912_ _it258905_)
                         (_E258908258916_
                          (lambda ()
                            (error '"No clause matching" _it258906258912_)))
                         (_K258909258923_
                          (lambda (_stmt258919_)
                            (let ((_r258921_
                                   (let ((__method311173
                                          (method-ref
                                           _stmt258919_
                                           'query-fetch)))
                                     (if __method311173
                                         (__method311173 _stmt258919_)
                                         (error '"Missing method"
                                                _stmt258919_
                                                'query-fetch)))))
                              (if (std/iter#iter-end? _r258921_)
                                  std/iter#iter-end
                                  (let ((__method311174
                                         (method-ref _stmt258919_ 'query-row)))
                                    (if __method311174
                                        (__method311174 _stmt258919_)
                                        (error '"Missing method"
                                               _stmt258919_
                                               'query-row))))))))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _it258906258912_
                           'std/iter#iterator::t))
                        (let* ((_e258910258926_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _it258906258912_ '1)))
                               (_stmt258929_ _e258910258926_))
                          (_K258909258923_ _stmt258929_))
                        (_E258908258916_)))))
               (_fini258877_
                (lambda (_it258881_)
                  (let* ((_it258882258888_ _it258881_)
                         (_E258884258892_
                          (lambda ()
                            (error '"No clause matching" _it258882258888_)))
                         (_K258885258897_
                          (lambda (_stmt258895_)
                            (if _stmt258895_
                                (begin
                                  (let ((__method311175
                                         (method-ref
                                          _stmt258895_
                                          'query-fini)))
                                    (if __method311175
                                        (__method311175 _stmt258895_)
                                        (error '"Missing method"
                                               _stmt258895_
                                               'query-fini)))
                                  (##direct-structure-set!
                                   _it258881_
                                   '#f
                                   '1
                                   std/iter#iterator::t
                                   '#f))
                                '#!void))))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _it258882258888_
                           'std/iter#iterator::t))
                        (let* ((_e258886258900_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _it258882258888_ '1)))
                               (_stmt258903_ _e258886258900_))
                          (_K258885258897_ _stmt258903_))
                        (_E258884258892_))))))
        (if (##structure-ref _stmt258874_ '1 std/db/dbi#statement::t '#f)
            (let ((_it258879_
                   (let ((__obj311176 (make-object std/iter#iterator::t '3)))
                     (if (let ((__tmp311180
                                (let ()
                                  (declare (not safe))
                                  (##vector-length __obj311176))))
                           (declare (not safe))
                           (##fx< '3 __tmp311180))
                         (begin
                           (let ()
                             (declare (not safe))
                             (##vector-set! __obj311176 '1 _stmt258874_))
                           (let ()
                             (declare (not safe))
                             (##vector-set! __obj311176 '2 _next258876_))
                           (let ()
                             (declare (not safe))
                             (##vector-set! __obj311176 '3 _fini258877_)))
                         (error '"struct-instance-init!: too many arguments for struct"
                                __obj311176))
                     __obj311176)))
              (make-will _it258879_ _fini258877_)
              (let ((__method311177 (method-ref _stmt258874_ 'query-start)))
                (if __method311177
                    (__method311177 _stmt258874_)
                    (error '"Missing method" _stmt258874_ 'query-start)))
              _it258879_)
            (error '"Invalid operation; statement finalized" _stmt258874_)))))
  (define std/db/dbi#sql-columns
    (lambda (_stmt258872_)
      (if (##structure-ref _stmt258872_ '1 std/db/dbi#statement::t '#f)
          (let ((__method311178 (method-ref _stmt258872_ 'columns)))
            (if __method311178
                (__method311178 _stmt258872_)
                (error '"Missing method" _stmt258872_ 'columns)))
          (error '"Invalid operation; statement finalized" _stmt258872_)))))
