(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/debug/heap#memory-usage
    (lambda ()
      (let ((_stats55983_
             (let () (declare (not safe)) (##process-statistics))))
        (cons (cons 'gc-heap-size
                    (inexact->exact (f64vector-ref _stats55983_ '15)))
              (cons (cons 'gc-alloc
                          (inexact->exact (f64vector-ref _stats55983_ '16)))
                    (cons (cons 'gc-live
                                (inexact->exact
                                 (f64vector-ref _stats55983_ '17)))
                          (cons (cons 'gc-movable
                                      (inexact->exact
                                       (f64vector-ref _stats55983_ '18)))
                                (cons (cons 'gc-still
                                            (inexact->exact
                                             (f64vector-ref _stats55983_ '19)))
                                      '()))))))))
  (define std/debug/heap#heap-type-stats
    (lambda ()
      (let* ((_live55973_
              (std/debug/heap#walk-heap!__% '#f absent-value absent-value))
             (_types55975_ (make-table 'test: eq?)))
        (table-for-each
         (lambda (_obj55978_ _g293981_)
           (let ((_t55980_ (std/generic/dispatch#type-of _obj55978_)))
             (hash-update! _types55975_ _t55980_ 1+ '0)))
         _live55973_)
        (values (table-length _live55973_) _types55975_))))
  (define std/debug/heap#dump-heap-stats!__%
    (lambda (_port55885_)
      (let () (declare (not safe)) (##gc))
      (let* ((_mem55887_ (std/debug/heap#memory-usage))
             (_g293982_ (std/debug/heap#count-still1)))
        (begin
          (let ((_g293983_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g293982_) (##vector-length _g293982_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g293983_ 2)))
                (error "Context expects 2 values" _g293983_)))
          (let ((_still55889_
                 (let () (declare (not safe)) (##vector-ref _g293982_ 0)))
                (_refcounted55890_
                 (let () (declare (not safe)) (##vector-ref _g293982_ 1))))
            (let ((_g293984_ (std/debug/heap#heap-type-stats)))
              (begin
                (let ((_g293985_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g293984_)
                             (##vector-length _g293984_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g293985_ 2)))
                      (error "Context expects 2 values" _g293985_)))
                (let ((_count55892_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g293984_ 0)))
                      (_types55893_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g293984_ 1))))
                  (let ()
                    (call-with-parameters
                     (lambda ()
                       (displayln '"=== memory usage ===")
                       (for-each
                        (lambda (_e5589655898_)
                          (let* ((_g5590055907_ _e5589655898_)
                                 (_E5590255911_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _g5590055907_)))
                                 (_K5590355917_
                                  (lambda (_val55914_ _key55915_)
                                    (displayln _key55915_ '": " _val55914_))))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _g5590055907_))
                                (let ((_hd5590455920_
                                       (let ()
                                         (declare (not safe))
                                         (##car _g5590055907_)))
                                      (_tl5590555922_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _g5590055907_))))
                                  (let* ((_key55925_ _hd5590455920_)
                                         (_val55927_ _tl5590555922_))
                                    (_K5590355917_ _val55927_ _key55925_)))
                                (_E5590255911_))))
                        _mem55887_)
                       (displayln '"=== heap summary ===")
                       (displayln '"objects: " _count55892_)
                       (displayln '"still: " _still55889_)
                       (displayln '"refcounted: " _refcounted55890_)
                       (displayln '"=== heap type counts ===")
                       (for-each
                        (lambda (_e5592855930_)
                          (let* ((_g5593255939_ _e5592855930_)
                                 (_E5593455943_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _g5593255939_)))
                                 (_K5593555949_
                                  (lambda (_val55946_ _key55947_)
                                    (displayln _key55947_ '" " _val55946_))))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _g5593255939_))
                                (let ((_hd5593655952_
                                       (let ()
                                         (declare (not safe))
                                         (##car _g5593255939_)))
                                      (_tl5593755954_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _g5593255939_))))
                                  (let* ((_key55957_ _hd5593655952_)
                                         (_val55959_ _tl5593755954_))
                                    (_K5593555949_ _val55959_ _key55957_)))
                                (_E5593455943_))))
                        (std/sort#sort
                         (table->list _types55893_)
                         (lambda (_a55961_ _b55962_)
                           (> (cdr _a55961_) (cdr _b55962_))))))
                     current-output-port
                     _port55885_))))))))))
  (define std/debug/heap#dump-heap-stats!__0
    (lambda ()
      (let ((_port55968_ (current-error-port)))
        (std/debug/heap#dump-heap-stats!__% _port55968_))))
  (define std/debug/heap#dump-heap-stats!
    (lambda _g293987_
      (let ((_g293986_ (let () (declare (not safe)) (##length _g293987_))))
        (cond ((let () (declare (not safe)) (##fx= _g293986_ 0))
               (apply std/debug/heap#dump-heap-stats!__0 _g293987_))
              ((let () (declare (not safe)) (##fx= _g293986_ 1))
               (apply std/debug/heap#dump-heap-stats!__% _g293987_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/debug/heap#dump-heap-stats!
                _g293987_))))))
  (define std/debug/heap#count-still (lambda () (std/debug/heap#count-still1)))
  (define std/debug/heap#count-still1
    (lambda ()
      (let ((_still55880_ (std/debug/heap#count-still-objects))
            (_refcounted55881_ (std/debug/heap#count-still-objects/refcount)))
        (values _still55880_ _refcounted55881_))))
  (define std/debug/heap#still-objects/refcount
    (lambda ()
      (std/debug/heap#get-still1
       std/debug/heap#count-still-objects/refcount
       std/debug/heap#get-still-objects/refcount)))
  (define std/debug/heap#still-objects
    (lambda ()
      (std/debug/heap#get-still1
       std/debug/heap#count-still-objects
       std/debug/heap#get-still-objects)))
  (define std/debug/heap#get-still
    (lambda (_countf55874_ _getf55875_)
      (std/debug/heap#get-still1 _countf55874_ _getf55875_)))
  (define std/debug/heap#get-still1
    (lambda (_countf55864_ _getf55865_)
      (let ((_count55867_ (_countf55864_)))
        (if (fx> _count55867_ '0)
            (let* ((_vec55869_ (make-vector (fx+ _count55867_ '1)))
                   (_count55871_ (_getf55865_ _vec55869_)))
              (if (fx< _count55871_ (vector-length _vec55869_))
                  (vector-shrink! _vec55869_ _count55871_)
                  '#!void)
              _vec55869_)
            '#()))))
  (define std/debug/heap#walk-heap!__%
    (lambda (_g293988_ _walk5582955833_ _root5583055835_)
      (let* ((_walk55838_
              (if (eq? _walk5582955833_ absent-value) '#f _walk5582955833_))
             (_root55840_
              (if (eq? _root5583055835_ absent-value) '#f _root5583055835_))
             (_seen55842_ (make-table 'test: eq?)))
        (letrec ((_visit55844_
                  (lambda (_container55846_ _i55847_ _obj55848_)
                    (if (table-ref _seen55842_ _obj55848_ '#f)
                        absent-obj
                        (if (eq? _seen55842_ _obj55848_)
                            absent-obj
                            (if (let ()
                                  (declare (not safe))
                                  (##mem-allocated? _obj55848_))
                                (begin
                                  (table-set! _seen55842_ _obj55848_ '#t)
                                  (if _walk55838_
                                      (_walk55838_
                                       _container55846_
                                       _i55847_
                                       _obj55848_)
                                      '#f))
                                '#f))))))
          (if _root55840_
              (std/debug/heap#walk-from-object! _root55840_ _visit55844_)
              (std/debug/heap#walk-from-roots! _visit55844_))
          _seen55842_))))
  (define std/debug/heap#walk-heap!__@
    (lambda (_keys5582855853_ . _args55855_)
      (apply std/debug/heap#walk-heap!__%
             _keys5582855853_
             (table-ref _keys5582855853_ 'walk: absent-value)
             (table-ref _keys5582855853_ 'root: absent-value)
             _args55855_)))
  (define std/debug/heap#walk-heap!
    (lambda _args5583155861_
      (apply keyword-dispatch
             '#(walk: root:)
             std/debug/heap#walk-heap!__@
             _args5583155861_)))
  (define std/debug/heap#walk-from-roots!
    (lambda (_visit55807_)
      (letrec ((_scan-symbol-and-global-var55809_
                (lambda (_obj55817_)
                  (let ((_$e55819_
                         (std/debug/heap#walk-from-object!
                          _obj55817_
                          _visit55807_)))
                    (if _$e55819_
                        _$e55819_
                        (if (let ()
                              (declare (not safe))
                              (##global-var? _obj55817_))
                            (let* ((_var55822_
                                    (let ()
                                      (declare (not safe))
                                      (##make-global-var _obj55817_)))
                                   (_val55824_
                                    (let ()
                                      (declare (not safe))
                                      (##global-var-ref _obj55817_))))
                              (std/debug/heap#walk-from-object!
                               _val55824_
                               _visit55807_))
                            '#f)))))
               (_scan-keyword55810_
                (lambda (_obj55815_)
                  (std/debug/heap#walk-from-object! _obj55815_ _visit55807_)))
               (_scan-still55811_
                (lambda (_obj55813_)
                  (std/debug/heap#walk-from-object! _obj55813_ _visit55807_))))
        (std/debug/heap#walk-interned-symbols!
         _scan-symbol-and-global-var55809_)
        (std/debug/heap#walk-interned-keywords! _scan-keyword55810_)
        (std/debug/heap#walk-still-objects! _scan-still55811_))))
  (define std/debug/heap#walk-still-objects!
    (lambda (_scan55796_)
      (let* ((_still55798_ (std/debug/heap#still-objects/refcount))
             (_count55800_ (vector-length _still55798_)))
        (let _lp55803_ ((_i55805_ '0))
          (if (fx< _i55805_ _count55800_)
              (begin
                (_scan55796_
                 (let ()
                   (declare (not safe))
                   (##vector-ref _still55798_ _i55805_)))
                (_lp55803_ (fx+ _i55805_ '1)))
              '#!void)))))
  (namespace
   ("std/debug/heap#"
    walk-interned-symbols!
    walk-interned-keywords!
    walk-from-object!))
  (define-macro (macro-symbol-next s) `(macro-slot 2 ,s))
  (define-macro (macro-keyword-next k) `(macro-slot 2 ,k))
  (define-macro (macro-walk-seq expr1 expr2) `(or ,expr1 ,expr2))
  (define-macro (macro-walk-continue) `#f)
  (define-macro (macro-walk-no-recursive-scan) `(macro-absent-obj))
  (define-macro (macro-case-type obj)
    `(let ((obj ,obj))
       (if (##not (##mem-allocated? obj))
           (macro-handle-type-atomic)
           (let ((subtype (##subtype obj)))
             (cond ((##fx= subtype (macro-subtype-pair))
                    (macro-handle-type-simple
                     ##cons
                     (##car ##set-car!)
                     (##cdr ##set-cdr!)))
                   ((macro-subtype-ovector? subtype)
                    (macro-handle-type-object-vector ovector))
                   ((##fx= subtype (macro-subtype-foreign))
                    (macro-handle-type-mixed-vector
                     foreign
                     (##foreign-tags ignore)))
                   ((macro-subtype-bvector? subtype)
                    (macro-handle-type-mixed-vector bvector))
                   ((##fx= subtype (macro-subtype-symbol))
                    (macro-handle-type-mixed-vector
                     symbol
                     (##symbol-name ignore)))
                   ((##fx= subtype (macro-subtype-keyword))
                    (macro-handle-type-mixed-vector
                     keyword
                     (##keyword-name ignore)))
                   ((##fx= subtype (macro-subtype-frame))
                    (macro-handle-type-frame))
                   ((##fx= subtype (macro-subtype-continuation))
                    (##continuation-frame obj)
                    (macro-handle-type-simple
                     macro-make-continuation
                     (macro-continuation-frame ignore)
                     (macro-continuation-denv ignore)))
                   ((##fx= subtype (macro-subtype-weak))
                    (if (##will? obj)
                        (macro-handle-type-simple
                         macro-make-will
                         (macro-will-testator ignore)
                         (macro-will-action ignore))
                        (macro-handle-type-object-vector gc-hash-table)))
                   ((##fx= subtype (macro-subtype-procedure))
                    (if (##closure? obj)
                        (macro-handle-type-object-vector closure)
                        (macro-handle-type-atomic)))
                   ((##fx= subtype (macro-subtype-return))
                    (macro-handle-type-atomic))
                   ((##fx= subtype (macro-subtype-promise))
                    (macro-handle-type-object-vector promise))
                   (else (macro-handle-type-atomic)))))))
  (define-macro (macro-walk-object obj)
    `(let ()
       (define (walk-object container i obj)
         (define-macro (macro-handle-type-atomic) `(handle-type-atomic))
         (define (handle-type-atomic) (macro-walk-continue))
         (define-macro (macro-handle-type-object-vector type)
           `(handle-type-object-vector))
         (define (handle-type-object-vector)
           (let ((len (##vector-length obj)))
             (let loop ((i 0))
               (if (##fx< i len)
                   (macro-walk-object-seq
                    obj
                    i
                    (##vector-ref obj i)
                    (loop (##fx+ i 1)))
                   (macro-walk-continue)))))
         (define-macro (macro-handle-type-simple constructor . fields)
           `(macro-handle-fields 0 ,@fields))
         (define-macro (macro-handle-type-mixed-vector type . fields)
           `(macro-handle-fields 0 ,@fields))
         (define-macro (macro-handle-fields i . fields)
           (if (pair? fields)
               (let ((field (car fields)))
                 `(macro-walk-object-seq
                   obj
                   ,i
                   (,(car field) obj)
                   (macro-handle-fields ,(+ i 1) ,@(cdr fields))))
               `(macro-walk-continue)))
         (define-macro (macro-handle-type-frame) `(handle-type-frame))
         (define (handle-type-frame)
           (macro-walk-object-seq
            obj
            0
            (##frame-ret obj)
            (let ((fs (##frame-fs obj)))
              (let loop ((i 1))
                (if (##fx< fs i)
                    (macro-walk-continue)
                    (if (##frame-slot-live? obj i)
                        (macro-walk-object-seq
                         obj
                         i
                         (##frame-ref obj i)
                         (loop (##fx+ i 1)))
                        (loop (##fx+ i 1))))))))
         (macro-walk-visit (macro-case-type obj)))
       (walk-object #t 0 obj)))
  (define (walk-interned-symbols! proc)
    (let ((tbl (##symbol-table)))
      (let loop1 ((i (##fx- (##vector-length tbl) 1)))
        (if (##fx> i 0)
            (let loop2 ((obj (##vector-ref tbl i)))
              (if (##null? obj)
                  (loop1 (##fx- i 1))
                  (macro-walk-seq (proc obj) (loop2 (macro-symbol-next obj)))))
            (macro-walk-continue)))))
  (define (walk-interned-keywords! proc)
    (let ((tbl (##keyword-table)))
      (let loop1 ((i (##fx- (##vector-length tbl) 1)))
        (if (##fx> i 0)
            (let loop2 ((obj (##vector-ref tbl i)))
              (if (##null? obj)
                  (loop1 (##fx- i 1))
                  (macro-walk-seq
                   (proc obj)
                   (loop2 (macro-keyword-next obj)))))
            (macro-walk-continue)))))
  (define (walk-from-object! obj visit)
    (define-macro (macro-walk-visit recursive-scan)
      `(let ((result (visit container i obj)))
         (if (##eq? result (macro-walk-no-recursive-scan))
             (macro-walk-continue)
             (macro-walk-seq result ,recursive-scan))))
    (define-macro (macro-walk-object-seq container i subobject continue)
      `(let* ((container ,container) (i ,i) (subobject ,subobject))
         (macro-walk-seq (walk-object container i subobject) ,continue)))
    (macro-walk-object obj))
  (namespace
   ("std/debug/heap#"
    count-still-objects
    count-still-objects/refcount
    get-still-objects
    get-still-objects/refcount))
  (c-declare
   "// these are defined in gambit/lib/mem.c\n#define ___PSTATE_MEM(var) ___ps->mem.var\n#define still_objs ___PSTATE_MEM(still_objs_)\n#define ___STILL_LINK_OFS 0\n#define ___STILL_REFCOUNT_OFS 1\n#define ___STILL_BODY_OFS 6\n#define ___STILL_HAND_OFS ___STILL_BODY_OFS\n#ifndef ___BODY_OFS\n#define ___BODY_OFS 1\n#endif")
  (define count-still-objects
    (c-lambda
     ()
     int
     "int count = 0;\n___WORD *base = ___CAST(___WORD*,still_objs);\nwhile (base != 0)\n{\n count++;\n base = ___CAST(___WORD*,base[___STILL_LINK_OFS]);\n}\n___return(count);"))
  (define count-still-objects/refcount
    (c-lambda
     ()
     int
     "int count = 0;\n___WORD *base = ___CAST(___WORD*,still_objs);\nwhile (base != 0)\n{\n if (base[___STILL_REFCOUNT_OFS])\n  {\n   count++;\n  }\n base = ___CAST(___WORD*,base[___STILL_LINK_OFS]);\n}\n___return(count);"))
  (define get-still-objects
    (c-lambda
     (scheme-object)
     int
     "int count = 0;\nint max = ___INT(___VECTORLENGTH(___arg1));\n___WORD *base = ___CAST(___WORD*,still_objs);\nwhile (base != 0 && count < max)\n{\n ___SCMOBJ next = ___TAG((base + ___STILL_HAND_OFS - ___BODY_OFS),\n                         (___HD_SUBTYPE(base[___STILL_BODY_OFS-1]) == ___sPAIR?\n                          ___tPAIR : ___tSUBTYPED));\n ___VECTORSET(___arg1, ___FIX(count), next);\n count++;\n base = ___CAST(___WORD*,base[___STILL_LINK_OFS]);\n}\n___return(count);"))
  (define get-still-objects/refcount
    (c-lambda
     (scheme-object)
     int
     "int count = 0;\nint max = ___INT(___VECTORLENGTH(___arg1));\n___WORD *base = ___CAST(___WORD*,still_objs);\nwhile (base != 0 && count < max)\n{\n if (base[___STILL_REFCOUNT_OFS])\n  {\n   ___SCMOBJ next = ___TAG((base + ___STILL_HAND_OFS - ___BODY_OFS),\n                           (___HD_SUBTYPE(base[___STILL_BODY_OFS-1]) == ___sPAIR?\n                            ___tPAIR : ___tSUBTYPED));\n   ___VECTORSET(___arg1, ___FIX(count), next);\n    count++;\n  }\n base = ___CAST(___WORD*,base[___STILL_LINK_OFS]);\n}\n___return(count);")))
