(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/debug/memleak#heap-summary
    (lambda ()
      (let () (declare (not safe)) (##gc))
      (let* ((_mem56292_ (std/debug/heap#memory-usage))
             (_g293989_ (std/debug/heap#count-still1)))
        (begin
          (let ((_g293990_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g293989_) (##vector-length _g293989_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g293990_ 2)))
                (error "Context expects 2 values" _g293990_)))
          (let ((_still56294_
                 (let () (declare (not safe)) (##vector-ref _g293989_ 0)))
                (_refcounted56295_
                 (let () (declare (not safe)) (##vector-ref _g293989_ 1))))
            (let* ((_live56297_
                    (std/debug/heap#walk-heap!__%
                     '#f
                     absent-value
                     absent-value))
                   (_heap-stats56299_ (make-table 'test: eq?))
                   (_frame-stats56301_ (make-table 'test: eq?)))
              (table-for-each
               (lambda (_obj56304_ _g293991_)
                 (let ((_t56306_ (std/generic/dispatch#type-of _obj56304_)))
                   (hash-update! _heap-stats56299_ _t56306_ 1+ '0)
                   (if (eq? _t56306_ 'frame)
                       (let ((_c56308_
                              (std/debug/memleak#frame-creator-name
                               _obj56304_)))
                         (hash-update! _frame-stats56301_ _c56308_ 1+ '0))
                       '#!void)))
               _live56297_)
              (vector _mem56292_
                      (cons (table-length _live56297_)
                            (cons _still56294_ (cons _refcounted56295_ '())))
                      _heap-stats56299_
                      _frame-stats56301_)))))))
  (define std/debug/memleak#heap-summary-delta
    (lambda (_old56206_ _new56207_)
      (let ((_old5620856222_ _old56206_) (_new5620956224_ _new56207_))
        (let* ((_E5621156228_
                (lambda ()
                  (error '"No clause matching"
                         _old5620856222_
                         _new5620956224_)))
               (_K5621256248_
                (lambda (_frame-old56231_
                         _heap-old56232_
                         _counts-old56233_
                         _mem-old56234_
                         _frame-new56235_
                         _heap-new56236_
                         _counts-new56237_
                         _mem-new56238_)
                  (let ((_mem-delta56243_
                         (map (lambda (_a56240_ _b56241_)
                                (cons (car _a56240_)
                                      (- (cdr _a56240_) (cdr _b56241_))))
                              _mem-new56238_
                              _mem-old56234_))
                        (_counts-delta56244_
                         (map - _counts-new56237_ _counts-old56233_))
                        (_heap-delta56245_
                         (std/debug/memleak#hash-delta
                          _heap-new56236_
                          _heap-old56232_))
                        (_frame-delta56246_
                         (std/debug/memleak#hash-delta
                          _frame-new56235_
                          _frame-old56231_)))
                    (vector _mem-delta56243_
                            _counts-delta56244_
                            _heap-delta56245_
                            _frame-delta56246_)))))
          (if (let () (declare (not safe)) (##vector? _old5620856222_))
              (if (let ((__tmp293992
                         (let ()
                           (declare (not safe))
                           (##vector-length _old5620856222_))))
                    (declare (not safe))
                    (##fx= __tmp293992 '4))
                  (let* ((_e5621756251_
                          (let ()
                            (declare (not safe))
                            (##vector-ref _old5620856222_ '0)))
                         (_mem-old56254_ _e5621756251_)
                         (_e5621856256_
                          (let ()
                            (declare (not safe))
                            (##vector-ref _old5620856222_ '1)))
                         (_counts-old56259_ _e5621856256_)
                         (_e5621956261_
                          (let ()
                            (declare (not safe))
                            (##vector-ref _old5620856222_ '2)))
                         (_heap-old56264_ _e5621956261_)
                         (_e5622056266_
                          (let ()
                            (declare (not safe))
                            (##vector-ref _old5620856222_ '3)))
                         (_frame-old56269_ _e5622056266_))
                    (if (let ()
                          (declare (not safe))
                          (##vector? _new5620956224_))
                        (if (let ((__tmp293993
                                   (let ()
                                     (declare (not safe))
                                     (##vector-length _new5620956224_))))
                              (declare (not safe))
                              (##fx= __tmp293993 '4))
                            (let* ((_e5621356271_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _new5620956224_ '0)))
                                   (_mem-new56274_ _e5621356271_)
                                   (_e5621456276_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _new5620956224_ '1)))
                                   (_counts-new56279_ _e5621456276_)
                                   (_e5621556281_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _new5620956224_ '2)))
                                   (_heap-new56284_ _e5621556281_)
                                   (_e5621656286_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _new5620956224_ '3)))
                                   (_frame-new56289_ _e5621656286_))
                              (_K5621256248_
                               _frame-old56269_
                               _heap-old56264_
                               _counts-old56259_
                               _mem-old56254_
                               _frame-new56289_
                               _heap-new56284_
                               _counts-new56279_
                               _mem-new56274_))
                            (_E5621156228_))
                        (_E5621156228_)))
                  (_E5621156228_))
              (_E5621156228_))))))
  (define std/debug/memleak#hash-delta
    (lambda (_new56190_ _old56191_)
      (letrec* ((_delta56193_ (make-table 'test: eq?)))
        (table-for-each
         (lambda (_key56195_ _count56196_)
           (let ((_$e56198_ (table-ref _old56191_ _key56195_ '#f)))
             (if _$e56198_
                 ((lambda (_old-count56201_)
                    (table-set!
                     _delta56193_
                     _key56195_
                     (- _count56196_ _old-count56201_)))
                  _$e56198_)
                 (table-set! _delta56193_ _key56195_ _count56196_))))
         _new56190_)
        (table-for-each
         (lambda (_key56203_ _count56204_)
           (if (table-ref _delta56193_ _key56203_ '#f)
               '#!void
               (table-set! _delta56193_ _key56203_ (- _count56204_))))
         _old56191_)
        _delta56193_)))
  (define std/debug/memleak#dump-heap-summary!__%
    (lambda (_summary56055_ _port56056_)
      (letrec ((_display-pair56058_
                (lambda (_el56150_)
                  (let* ((_el5615156158_ _el56150_)
                         (_E5615356162_
                          (lambda ()
                            (error '"No clause matching" _el5615156158_)))
                         (_K5615456168_
                          (lambda (_val56165_ _key56166_)
                            (if (zero? _val56165_)
                                '#!void
                                (displayln _key56166_ '": " _val56165_)))))
                    (if (let () (declare (not safe)) (##pair? _el5615156158_))
                        (let ((_hd5615556171_
                               (let ()
                                 (declare (not safe))
                                 (##car _el5615156158_)))
                              (_tl5615656173_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _el5615156158_))))
                          (let* ((_key56176_ _hd5615556171_)
                                 (_val56178_ _tl5615656173_))
                            (_K5615456168_ _val56178_ _key56176_)))
                        (_E5615356162_)))))
               (_cmp-count56059_
                (lambda (_a56147_ _b56148_) (> (cdr _a56147_) (cdr _b56148_))))
               (_display-list?56060_
                (lambda (_lst56143_)
                  (find (lambda (_el56145_) (not (zero? (cdr _el56145_))))
                        _lst56143_))))
        (call-with-parameters
         (lambda ()
           (let* ((_summary5606256077_ _summary56055_)
                  (_E5606456081_
                   (lambda ()
                     (error '"No clause matching" _summary5606256077_)))
                  (_K5606556101_
                   (lambda (_frame56084_
                            _heap56085_
                            _refcounted56086_
                            _still56087_
                            _live56088_
                            _mem56089_)
                     (displayln '"==================================")
                     (displayln
                      '"timestamp: "
                      (let () (declare (not safe)) (##current-time-point)))
                     (let ((_lst56093_
                            (filter (lambda (_el56091_)
                                      (not (eq? (car _el56091_) 'gc-alloc)))
                                    _mem56089_)))
                       (if (_display-list?56060_ _lst56093_)
                           (begin
                             (displayln '"=== memory usage ===")
                             (for-each _display-pair56058_ _lst56093_))
                           '#!void))
                     (let ((_lst56095_
                            (cons (cons 'objects _live56088_)
                                  (cons (cons 'still _still56087_)
                                        (cons (cons 'refcounted
                                                    _refcounted56086_)
                                              '())))))
                       (if (_display-list?56060_ _lst56095_)
                           (begin
                             (displayln '"=== heap summary ===")
                             (for-each _display-pair56058_ _lst56095_))
                           '#!void))
                     (let ((_lst56097_
                            (std/sort#sort
                             (table->list _heap56085_)
                             _cmp-count56059_)))
                       (if (_display-list?56060_ _lst56097_)
                           (begin
                             (displayln '"=== heap type counts ===")
                             (for-each _display-pair56058_ _lst56097_))
                           '#!void))
                     (let ((_lst56099_
                            (std/sort#sort
                             (table->list _frame56084_)
                             _cmp-count56059_)))
                       (if (_display-list?56060_ _lst56099_)
                           (begin
                             (displayln '"=== frame counts ===")
                             (for-each _display-pair56058_ _lst56099_))
                           '#!void))
                     (displayln '"=================================="))))
             (if (let () (declare (not safe)) (##vector? _summary5606256077_))
                 (if (let ((__tmp293994
                            (let ()
                              (declare (not safe))
                              (##vector-length _summary5606256077_))))
                       (declare (not safe))
                       (##fx= __tmp293994 '4))
                     (let* ((_e5606656104_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _summary5606256077_ '0)))
                            (_mem56107_ _e5606656104_)
                            (_e5606756109_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _summary5606256077_ '1))))
                       (if (let ()
                             (declare (not safe))
                             (##pair? _e5606756109_))
                           (let ((_hd5607056112_
                                  (let ()
                                    (declare (not safe))
                                    (##car _e5606756109_)))
                                 (_tl5607156114_
                                  (let ()
                                    (declare (not safe))
                                    (##cdr _e5606756109_))))
                             (let ((_live56117_ _hd5607056112_))
                               (if (let ()
                                     (declare (not safe))
                                     (##pair? _tl5607156114_))
                                   (let ((_hd5607256119_
                                          (let ()
                                            (declare (not safe))
                                            (##car _tl5607156114_)))
                                         (_tl5607356121_
                                          (let ()
                                            (declare (not safe))
                                            (##cdr _tl5607156114_))))
                                     (let ((_still56124_ _hd5607256119_))
                                       (if (let ()
                                             (declare (not safe))
                                             (##pair? _tl5607356121_))
                                           (let ((_hd5607456126_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##car _tl5607356121_)))
                                                 (_tl5607556128_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##cdr _tl5607356121_))))
                                             (let ((_refcounted56131_
                                                    _hd5607456126_))
                                               (if (let ()
                                                     (declare (not safe))
                                                     (##null? _tl5607556128_))
                                                   (let* ((_e5606856133_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##vector-ref
                                                              _summary5606256077_
                                                              '2)))
                                                          (_heap56136_
                                                           _e5606856133_)
                                                          (_e5606956138_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##vector-ref
                                                              _summary5606256077_
                                                              '3)))
                                                          (_frame56141_
                                                           _e5606956138_))
                                                     (_K5606556101_
                                                      _frame56141_
                                                      _heap56136_
                                                      _refcounted56131_
                                                      _still56124_
                                                      _live56117_
                                                      _mem56107_))
                                                   (_E5606456081_))))
                                           (_E5606456081_))))
                                   (_E5606456081_))))
                           (_E5606456081_)))
                     (_E5606456081_))
                 (_E5606456081_))))
         current-output-port
         _port56056_))))
  (define std/debug/memleak#dump-heap-summary!__0
    (lambda (_summary56183_)
      (let ((_port56185_ (current-error-port)))
        (std/debug/memleak#dump-heap-summary!__% _summary56183_ _port56185_))))
  (define std/debug/memleak#dump-heap-summary!
    (lambda _g293996_
      (let ((_g293995_ (let () (declare (not safe)) (##length _g293996_))))
        (cond ((let () (declare (not safe)) (##fx= _g293995_ 1))
               (apply std/debug/memleak#dump-heap-summary!__0 _g293996_))
              ((let () (declare (not safe)) (##fx= _g293995_ 2))
               (apply std/debug/memleak#dump-heap-summary!__% _g293996_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/debug/memleak#dump-heap-summary!
                _g293996_))))))
  (define std/debug/memleak#watch-heap!__%__%
    (lambda (__5599756000_
             _initial-delay5599356002_
             _period5599456004_
             _dump!5599556006_
             _port56008_)
      (let* ((_initial-delay56010_
              (if (eq? _initial-delay5599356002_ absent-value)
                  '60
                  _initial-delay5599356002_))
             (_period56012_
              (if (eq? _period5599456004_ absent-value)
                  (* '60 '15)
                  _period5599456004_))
             (_dump!56014_
              (if (eq? _dump!5599556006_ absent-value)
                  std/debug/memleak#dump-heap-summary!
                  _dump!5599556006_)))
        (thread-sleep! _initial-delay56010_)
        (let ((_summary56016_ (std/debug/memleak#heap-summary)))
          (_dump!56014_ _summary56016_ _port56008_)
          (force-output _port56008_)
          (let _lp56018_ ((_prev-summary56020_ _summary56016_))
            (thread-sleep! _period56012_)
            (let ((_summary56022_ (std/debug/memleak#heap-summary)))
              (_dump!56014_
               (std/debug/memleak#heap-summary-delta
                _prev-summary56020_
                _summary56022_)
               _port56008_)
              (force-output _port56008_)
              (_lp56018_ _summary56022_)))))))
  (define std/debug/memleak#watch-heap!__%__0
    (lambda (__5599756027_
             _initial-delay5599356028_
             _period5599456029_
             _dump!5599556030_)
      (let ((_port56032_ (current-error-port)))
        (std/debug/memleak#watch-heap!__%__%
         __5599756027_
         _initial-delay5599356028_
         _period5599456029_
         _dump!5599556030_
         _port56032_))))
  (define std/debug/memleak#watch-heap!__%
    (lambda _g293998_
      (let ((_g293997_ (let () (declare (not safe)) (##length _g293998_))))
        (cond ((let () (declare (not safe)) (##fx= _g293997_ 4))
               (apply std/debug/memleak#watch-heap!__%__0 _g293998_))
              ((let () (declare (not safe)) (##fx= _g293997_ 5))
               (apply std/debug/memleak#watch-heap!__%__% _g293998_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/debug/memleak#watch-heap!__%
                _g293998_))))))
  (define std/debug/memleak#watch-heap!__@
    (lambda (_keys5599256043_ . _args56045_)
      (apply std/debug/memleak#watch-heap!__%
             _keys5599256043_
             (table-ref _keys5599256043_ 'delay: absent-value)
             (table-ref _keys5599256043_ 'period: absent-value)
             (table-ref _keys5599256043_ 'dump: absent-value)
             _args56045_)))
  (define std/debug/memleak#watch-heap!
    (lambda _args5599656051_
      (apply keyword-dispatch
             '#(#f #f delay: #f period: dump:)
             std/debug/memleak#watch-heap!__@
             _args5599656051_)))
  (define std/debug/memleak#frame-creator
    (lambda (_frame55989_)
      (let ((__tmp293999
             (let ()
               (declare (not safe))
               (##make-continuation _frame55989_ '#f))))
        (declare (not safe))
        (##continuation-creator __tmp293999))))
  (define std/debug/memleak#frame-creator-name
    (lambda (_frame55985_)
      (let ((_creator55987_ (std/debug/memleak#frame-creator _frame55985_)))
        (if (procedure? _creator55987_)
            (let () (declare (not safe)) (##procedure-name _creator55987_))
            '#f)))))
