(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/event#wait__%
    (lambda (_sel53768_ _timeo53769_)
      (if (std/event#maybe-timeout? _timeo53769_)
          (let ((_wait-e53771_ (std/event#selector-wait-e _sel53768_)))
            (if (_wait-e53771_ _sel53768_ _timeo53769_) _sel53768_ '#f))
          (error '"Bad argument; expected timeout or #f" _timeo53769_))))
  (define std/event#wait__0
    (lambda (_sel53776_)
      (let ((_timeo53778_ '#f)) (std/event#wait__% _sel53776_ _timeo53778_))))
  (define std/event#wait
    (lambda _g291121_
      (let ((_g291120_ (let () (declare (not safe)) (##length _g291121_))))
        (cond ((let () (declare (not safe)) (##fx= _g291120_ 1))
               (apply std/event#wait__0 _g291121_))
              ((let () (declare (not safe)) (##fx= _g291120_ 2))
               (apply std/event#wait__% _g291121_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/event#wait
                _g291121_))))))
  (define std/event#select__%
    (lambda (_sels53714_ _timeo53715_)
      (let* ((_sels5371653726_ _sels53714_)
             (_else5371953734_
              (lambda ()
                (if (std/event#maybe-timeout? _timeo53715_)
                    (std/event#do-select _sels53714_ _timeo53715_)
                    (error '"Bad argument; expected timeout or #f"
                           _timeo53715_)))))
        (let ((_K5372453754_ (lambda () (error '"empty selection set")))
              (_K5372153740_
               (lambda (_sel53738_)
                 (std/event#wait__% _sel53738_ _timeo53715_))))
          (let ((_try-match5371853750_
                 (lambda ()
                   (if (let () (declare (not safe)) (##pair? _sels5371653726_))
                       (let ((_tl5372353745_
                              (let ()
                                (declare (not safe))
                                (##cdr _sels5371653726_)))
                             (_hd5372253743_
                              (let ()
                                (declare (not safe))
                                (##car _sels5371653726_))))
                         (if (let ()
                               (declare (not safe))
                               (##null? _tl5372353745_))
                             (let ((_sel53748_ _hd5372253743_))
                               (_K5372153740_ _sel53748_))
                             (_else5371953734_)))
                       (_else5371953734_)))))
            (if (let () (declare (not safe)) (##null? _sels5371653726_))
                (_K5372453754_)
                (_try-match5371853750_)))))))
  (define std/event#select__0
    (lambda (_sels53760_)
      (let ((_timeo53762_ '#f))
        (std/event#select__% _sels53760_ _timeo53762_))))
  (define std/event#select
    (lambda _g291123_
      (let ((_g291122_ (let () (declare (not safe)) (##length _g291123_))))
        (cond ((let () (declare (not safe)) (##fx= _g291122_ 1))
               (apply std/event#select__0 _g291123_))
              ((let () (declare (not safe)) (##fx= _g291122_ 2))
               (apply std/event#select__% _g291123_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/event#select
                _g291123_))))))
  (define std/event#selection::t
    (make-struct-type
     'std/event#selection::t
     '#f
     '3
     'selection
     '((final: . #t))
     '#f
     '(e mx cv)))
  (define std/event#selection? (make-struct-predicate std/event#selection::t))
  (define std/event#make-selection
    (lambda _$args53710_
      (apply make-struct-instance std/event#selection::t _$args53710_)))
  (define std/event#selection-e
    (make-struct-field-accessor std/event#selection::t '0))
  (define std/event#selection-mx
    (make-struct-field-accessor std/event#selection::t '1))
  (define std/event#selection-cv
    (make-struct-field-accessor std/event#selection::t '2))
  (define std/event#selection-e-set!
    (make-struct-field-mutator std/event#selection::t '0))
  (define std/event#selection-mx-set!
    (make-struct-field-mutator std/event#selection::t '1))
  (define std/event#selection-cv-set!
    (make-struct-field-mutator std/event#selection::t '2))
  (define std/event#selector::t
    (make-struct-type
     'std/event#selector::t
     '#f
     '3
     'selector
     '((final: . #t))
     '#f
     '(sel wait abort)))
  (define std/event#selector? (make-struct-predicate std/event#selector::t))
  (define std/event#make-selector
    (lambda _$args53707_
      (apply make-struct-instance std/event#selector::t _$args53707_)))
  (define std/event#selector-sel
    (make-struct-field-accessor std/event#selector::t '0))
  (define std/event#selector-wait
    (make-struct-field-accessor std/event#selector::t '1))
  (define std/event#selector-abort
    (make-struct-field-accessor std/event#selector::t '2))
  (define std/event#selector-sel-set!
    (make-struct-field-mutator std/event#selector::t '0))
  (define std/event#selector-wait-set!
    (make-struct-field-mutator std/event#selector::t '1))
  (define std/event#selector-abort-set!
    (make-struct-field-mutator std/event#selector::t '2))
  (define std/event#do-select
    (lambda (_sels53676_ _timeo53677_)
      (let* ((_xsels53679_ (map std/event#wrap-selector _sels53676_))
             (_mx53681_ (make-mutex 'select))
             (_cv53683_ (make-condition-variable 'select))
             (_selection53685_
              (let ()
                (declare (not safe))
                (##structure std/event#selection::t '#f _mx53681_ _cv53683_)))
             (_threads53689_
              (map (lambda (_xsel53687_)
                     (gerbil/gambit/threads#spawn/name
                      'select
                      std/event#select1
                      _selection53685_
                      _xsel53687_))
                   _xsels53679_))
             (_abs-timeo53691_
              (if _timeo53677_
                  (std/event#timeout->abs-timeout _timeo53677_)
                  absent-obj))
             (_finalize!53696_
              (lambda ()
                (for-each thread-terminate! _threads53689_)
                (for-each
                 (lambda (_xsel53694_)
                   ((##direct-structure-ref
                     _xsel53694_
                     '3
                     std/event#selector::t
                     '#f)
                    (##direct-structure-ref
                     _xsel53694_
                     '1
                     std/event#selector::t
                     '#f)))
                 _xsels53679_))))
        (let _lp53699_ ()
          (mutex-lock! _mx53681_)
          (let ((_$e53702_
                 (##direct-structure-ref
                  _selection53685_
                  '1
                  std/event#selection::t
                  '#f)))
            (if _$e53702_
                ((lambda (_xsel53705_)
                   (mutex-unlock! _mx53681_)
                   (_finalize!53696_)
                   (##direct-structure-ref
                    _xsel53705_
                    '1
                    std/event#selector::t
                    '#f))
                 _$e53702_)
                (if (mutex-unlock! _mx53681_ _cv53683_ _abs-timeo53691_)
                    (_lp53699_)
                    (begin (_finalize!53696_) '#f))))))))
  (define std/event#select1
    (lambda (_selection53673_ _xsel53674_)
      (if ((##direct-structure-ref _xsel53674_ '2 std/event#selector::t '#f)
           (##direct-structure-ref _xsel53674_ '1 std/event#selector::t '#f)
           '#f)
          (begin
            (mutex-lock!
             (##direct-structure-ref
              _selection53673_
              '2
              std/event#selection::t
              '#f))
            (if (##direct-structure-ref
                 _selection53673_
                 '1
                 std/event#selection::t
                 '#f)
                '#!void
                (begin
                  (##direct-structure-set!
                   _selection53673_
                   _xsel53674_
                   '1
                   std/event#selection::t
                   '#f)
                  (condition-variable-signal!
                   (##direct-structure-ref
                    _selection53673_
                    '3
                    std/event#selection::t
                    '#f))))
            (mutex-unlock!
             (##direct-structure-ref
              _selection53673_
              '2
              std/event#selection::t
              '#f)))
          '#!void)))
  (define std/event#wrap-selector
    (lambda (_sel53671_)
      (if (thread? _sel53671_)
          (let ()
            (declare (not safe))
            (##structure
             std/event#selector::t
             _sel53671_
             std/event#selector-wait-thread
             void))
          (if (and (pair? _sel53671_)
                   (mutex? (car _sel53671_))
                   (condition-variable? (cdr _sel53671_)))
              (if (eq? (current-thread)
                       (macro-mutex-btq-owner (car _sel53671_)))
                  (let ()
                    (declare (not safe))
                    (##structure
                     std/event#selector::t
                     _sel53671_
                     std/event#selector-wait-condvar
                     std/event#selector-abort-condvar))
                  (error '"Illegal selector; mutex must be owned by current thread"
                         _sel53671_))
              (if (std/event#io-condition-variable? _sel53671_)
                  (let ()
                    (declare (not safe))
                    (##structure
                     std/event#selector::t
                     _sel53671_
                     std/event#selector-wait-io-condvar
                     void))
                  (error '"Illegal selector" _sel53671_))))))
  (define std/event#selector-wait-e
    (lambda (_sel53669_)
      (if (thread? _sel53669_)
          std/event#selector-wait-thread
          (if (and (pair? _sel53669_)
                   (mutex? (car _sel53669_))
                   (condition-variable? (cdr _sel53669_)))
              (if (eq? (current-thread)
                       (macro-mutex-btq-owner (car _sel53669_)))
                  std/event#selector-wait-condvar
                  (error '"Illegal selector; mutex must be owned by current thread"
                         _sel53669_))
              (if (std/event#io-condition-variable? _sel53669_)
                  std/event#selector-wait-io-condvar
                  (error '"Illegal selector" _sel53669_))))))
  (define std/event#selector-wait-thread
    (lambda (_sel53643_ _timeo53644_)
      (with-exception-catcher
       (lambda (_g5364553647_)
         (if ((lambda (_$obj53650_) (uncaught-exception? _$obj53650_))
              _g5364553647_)
             (let ((_e53653_ _g5364553647_)) '#t)
             (if ((lambda (_$obj53655_)
                    (terminated-thread-exception? _$obj53655_))
                  _g5364553647_)
                 (let ((_e53658_ _g5364553647_)) '#t)
                 (if ((lambda (_$obj53660_)
                        (join-timeout-exception? _$obj53660_))
                      _g5364553647_)
                     (let ((_e53663_ _g5364553647_)) '#f)
                     (raise _g5364553647_)))))
       (lambda ()
         (thread-join!
          _sel53643_
          (let ((_$e53666_ _timeo53644_)) (if _$e53666_ _$e53666_ absent-obj)))
         '#t))))
  (define std/event#selector-wait-condvar
    (lambda (_sel53609_ _timeo53610_)
      (let* ((_sel5361153618_ _sel53609_)
             (_E5361353622_
              (lambda () (error '"No clause matching" _sel5361153618_)))
             (_K5361453631_
              (lambda (_cv53625_ _mx53626_)
                (mutex-unlock!
                 _mx53626_
                 _cv53625_
                 (let ((_$e53628_ _timeo53610_))
                   (if _$e53628_ _$e53628_ absent-obj))))))
        (if (let () (declare (not safe)) (##pair? _sel5361153618_))
            (let ((_hd5361553634_
                   (let () (declare (not safe)) (##car _sel5361153618_)))
                  (_tl5361653636_
                   (let () (declare (not safe)) (##cdr _sel5361153618_))))
              (let* ((_mx53639_ _hd5361553634_) (_cv53641_ _tl5361653636_))
                (_K5361453631_ _cv53641_ _mx53639_)))
            (_E5361353622_)))))
  (define std/event#selector-abort-condvar
    (lambda (_sel53579_)
      (let* ((_sel5358053587_ _sel53579_)
             (_E5358253591_
              (lambda () (error '"No clause matching" _sel5358053587_)))
             (_K5358353597_
              (lambda (_cv53594_ _mx53595_)
                (if (eq? (current-thread) (macro-mutex-btq-owner _mx53595_))
                    (mutex-unlock! _mx53595_)
                    '#!void))))
        (if (let () (declare (not safe)) (##pair? _sel5358053587_))
            (let ((_hd5358453600_
                   (let () (declare (not safe)) (##car _sel5358053587_)))
                  (_tl5358553602_
                   (let () (declare (not safe)) (##cdr _sel5358053587_))))
              (let* ((_mx53605_ _hd5358453600_) (_cv53607_ _tl5358553602_))
                (_K5358353597_ _cv53607_ _mx53605_)))
            (_E5358253591_)))))
  (define std/event#selector-wait-io-condvar
    (lambda (_sel53576_ _timeo53577_)
      (let ((__tmp291124
             (if _timeo53577_
                 (time->seconds (std/event#timeout->abs-timeout _timeo53577_))
                 '#t)))
        (declare (not safe))
        (##wait-for-io! _sel53576_ __tmp291124))))
  (define std/event#maybe-timeout?
    (lambda (_obj53568_)
      (let ((_$e53570_ (not _obj53568_)))
        (if _$e53570_
            _$e53570_
            (let ((_$e53573_ (real? _obj53568_)))
              (if _$e53573_ _$e53573_ (time? _obj53568_)))))))
  (define std/event#timeout->abs-timeout
    (lambda (_timeo53566_)
      (if (time? _timeo53566_)
          _timeo53566_
          (seconds->time
           (+ (let () (declare (not safe)) (##current-time-point))
              _timeo53566_)))))
  (define std/event#io-condition-variable?
    (lambda (_obj53564_)
      (if (condition-variable? _obj53564_)
          (let ((__tmp291125 (macro-condvar-name _obj53564_)))
            (declare (not safe))
            (##foreign? __tmp291125))
          '#f)))
  (define std/event#event::t
    (make-struct-type
     'std/event#event::t
     '#f
     '4
     'event
     '((final: . #t))
     ':init!
     '(e poll ready abort)))
  (define std/event#event? (make-struct-predicate std/event#event::t))
  (define std/event#make-event
    (lambda _$args53561_
      (apply make-struct-instance std/event#event::t _$args53561_)))
  (define std/event#event-e (make-struct-field-accessor std/event#event::t '0))
  (define std/event#event-poll
    (make-struct-field-accessor std/event#event::t '1))
  (define std/event#event-ready
    (make-struct-field-accessor std/event#event::t '2))
  (define std/event#event-abort
    (make-struct-field-accessor std/event#event::t '3))
  (define std/event#event-e-set!
    (make-struct-field-mutator std/event#event::t '0))
  (define std/event#event-poll-set!
    (make-struct-field-mutator std/event#event::t '1))
  (define std/event#event-ready-set!
    (make-struct-field-mutator std/event#event::t '2))
  (define std/event#event-abort-set!
    (make-struct-field-mutator std/event#event::t '3))
  (define std/event#event-handler::t
    (make-struct-type
     'std/event#event-handler::t
     '#f
     '2
     'event-handler
     '((final: . #t))
     '#f
     '(e K)))
  (define std/event#event-handler?
    (make-struct-predicate std/event#event-handler::t))
  (define std/event#make-event-handler
    (lambda _$args53558_
      (apply make-struct-instance std/event#event-handler::t _$args53558_)))
  (define std/event#event-handler-e
    (make-struct-field-accessor std/event#event-handler::t '0))
  (define std/event#event-handler-K
    (make-struct-field-accessor std/event#event-handler::t '1))
  (define std/event#event-handler-e-set!
    (make-struct-field-mutator std/event#event-handler::t '0))
  (define std/event#event-handler-K-set!
    (make-struct-field-mutator std/event#event-handler::t '1))
  (define std/event#event-set::t
    (make-struct-type
     'std/event#event-set::t
     '#f
     '1
     'event-set
     '((final: . #t))
     '#f
     '(e)))
  (define std/event#event-set? (make-struct-predicate std/event#event-set::t))
  (define std/event#make-event-set
    (lambda _$args53555_
      (apply make-struct-instance std/event#event-set::t _$args53555_)))
  (define std/event#event-set-e
    (make-struct-field-accessor std/event#event-set::t '0))
  (define std/event#event-set-e-set!
    (make-struct-field-mutator std/event#event-set::t '0))
  (define std/event#event:::init!__%
    (lambda (_self53533_ _e53534_ _poll53535_ _ready53536_ _abort53537_)
      (if (let ((__tmp291126
                 (let () (declare (not safe)) (##vector-length _self53533_))))
            (declare (not safe))
            (##fx< '4 __tmp291126))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self53533_ '1 _e53534_))
            (let ()
              (declare (not safe))
              (##vector-set! _self53533_ '2 _poll53535_))
            (let ()
              (declare (not safe))
              (##vector-set! _self53533_ '3 _ready53536_))
            (let ()
              (declare (not safe))
              (##vector-set! _self53533_ '4 _abort53537_)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self53533_))))
  (define std/event#event:::init!__0
    (lambda (_self53542_ _e53543_ _poll53544_ _ready53545_)
      (let ((_abort53547_ void))
        (if (let ((__tmp291127
                   (let ()
                     (declare (not safe))
                     (##vector-length _self53542_))))
              (declare (not safe))
              (##fx< '4 __tmp291127))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self53542_ '1 _e53543_))
              (let ()
                (declare (not safe))
                (##vector-set! _self53542_ '2 _poll53544_))
              (let ()
                (declare (not safe))
                (##vector-set! _self53542_ '3 _ready53545_))
              (let ()
                (declare (not safe))
                (##vector-set! _self53542_ '4 _abort53547_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self53542_)))))
  (define std/event#event:::init!
    (lambda _g291129_
      (let ((_g291128_ (let () (declare (not safe)) (##length _g291129_))))
        (cond ((let () (declare (not safe)) (##fx= _g291128_ 4))
               (apply std/event#event:::init!__0 _g291129_))
              ((let () (declare (not safe)) (##fx= _g291128_ 5))
               (apply (lambda (_self53549_
                               _e53550_
                               _poll53551_
                               _ready53552_
                               _abort53553_)
                        (if (let ((__tmp291130
                                   (let ()
                                     (declare (not safe))
                                     (##vector-length _self53549_))))
                              (declare (not safe))
                              (##fx< '4 __tmp291130))
                            (begin
                              (let ()
                                (declare (not safe))
                                (##vector-set! _self53549_ '1 _e53550_))
                              (let ()
                                (declare (not safe))
                                (##vector-set! _self53549_ '2 _poll53551_))
                              (let ()
                                (declare (not safe))
                                (##vector-set! _self53549_ '3 _ready53552_))
                              (let ()
                                (declare (not safe))
                                (##vector-set! _self53549_ '4 _abort53553_)))
                            (error '"struct-instance-init!: too many arguments for struct"
                                   _self53549_)))
                      _g291129_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/event#event:::init!
                _g291129_))))))
  (bind-method! std/event#event::t ':init! std/event#event:::init! '#f)
  (define std/event#sync-object?
    (lambda (_obj53402_)
      (let ((_$e53404_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _obj53402_
                'std/event#event::t))))
        (if _$e53404_
            _$e53404_
            (let ((_$e53407_
                   (let ()
                     (declare (not safe))
                     (##structure-direct-instance-of?
                      _obj53402_
                      'std/event#event-handler::t))))
              (if _$e53407_
                  _$e53407_
                  (let ()
                    (declare (not safe))
                    (##structure-direct-instance-of?
                     _obj53402_
                     'std/event#event-set::t))))))))
  (define std/event#never-evt
    (let ((__obj291109 (make-object std/event#event::t '4)))
      (std/event#event:::init!__0 __obj291109 '#f false void)
      __obj291109))
  (define std/event#always-evt
    (let ((__obj291110 (make-object std/event#event::t '4)))
      (std/event#event:::init!__0 __obj291110 '#f true values)
      __obj291110))
  (define std/event#wrap-evt
    (lambda (_obj53397_)
      (if (std/event#sync-object? _obj53397_)
          _obj53397_
          (if (std/event#sync-selector? _obj53397_)
              (let ((__obj291111 (make-object std/event#event::t '4)))
                (if (let ((__tmp291131
                           (let ()
                             (declare (not safe))
                             (##vector-length __obj291111))))
                      (declare (not safe))
                      (##fx< '4 __tmp291131))
                    (begin
                      (let ()
                        (declare (not safe))
                        (##vector-set! __obj291111 '1 _obj53397_))
                      (let ()
                        (declare (not safe))
                        (##vector-set! __obj291111 '2 std/event#event-e))
                      (let ()
                        (declare (not safe))
                        (##vector-set! __obj291111 '3 std/event#event-e))
                      (let ()
                        (declare (not safe))
                        (##vector-set!
                         __obj291111
                         '4
                         std/event#event-abort-sync-selector)))
                    (error '"struct-instance-init!: too many arguments for struct"
                           __obj291111))
                __obj291111)
              (if (or (time? _obj53397_) (real? _obj53397_))
                  (let ((__obj291112 (make-object std/event#event::t '4)))
                    (std/event#event:::init!__0
                     __obj291112
                     (std/event#timeout->abs-timeout _obj53397_)
                     std/event#event-e
                     false)
                    __obj291112)
                  (if (input-port? _obj53397_)
                      (std/event#input-port-evt _obj53397_)
                      (std/event#wrap-evt
                       (let ((__method291113 (method-ref _obj53397_ ':event)))
                         (if __method291113
                             (__method291113 _obj53397_)
                             (error '"Missing method"
                                    _obj53397_
                                    ':event))))))))))
  (define std/event#handle-evt
    (lambda (_obj53388_ _K53389_)
      (let ((_evt53391_ (std/event#wrap-evt _obj53388_)))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _evt53391_
               'std/event#event-set::t))
            (let ((__tmp291132
                   (map (lambda (_g5339253394_)
                          (let ()
                            (declare (not safe))
                            (##structure
                             std/event#event-handler::t
                             _g5339253394_
                             _K53389_)))
                        (##direct-structure-ref
                         _evt53391_
                         '1
                         std/event#event-set::t
                         '#f))))
              (declare (not safe))
              (##structure std/event#event-set::t __tmp291132))
            (let ()
              (declare (not safe))
              (##structure std/event#event-handler::t _evt53391_ _K53389_))))))
  (define std/event#choice-evt
    (lambda _args53346_
      (let _lp53348_ ((_rest53350_ _args53346_) (_evts53351_ '()))
        (let* ((_rest5335253360_ _rest53350_)
               (_else5335453368_
                (lambda ()
                  (let ()
                    (declare (not safe))
                    (##structure std/event#event-set::t _evts53351_))))
               (_K5335653376_
                (lambda (_rest53371_ _obj53372_)
                  (let ((_evt53374_ (std/event#wrap-evt _obj53372_)))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _evt53374_
                           'std/event#event-set::t))
                        (if (null? _evts53351_)
                            (_lp53348_
                             _rest53371_
                             (##direct-structure-ref
                              _evt53374_
                              '1
                              std/event#event-set::t
                              '#f))
                            (_lp53348_
                             _rest53371_
                             (foldl1 cons
                                     _evts53351_
                                     (##direct-structure-ref
                                      _evt53374_
                                      '1
                                      std/event#event-set::t
                                      '#f))))
                        (_lp53348_
                         _rest53371_
                         (cons _evt53374_ _evts53351_)))))))
          (if (let () (declare (not safe)) (##pair? _rest5335253360_))
              (let ((_hd5335753379_
                     (let () (declare (not safe)) (##car _rest5335253360_)))
                    (_tl5335853381_
                     (let () (declare (not safe)) (##cdr _rest5335253360_))))
                (let* ((_obj53384_ _hd5335753379_)
                       (_rest53386_ _tl5335853381_))
                  (_K5335653376_ _rest53386_ _obj53384_)))
              (_else5335453368_))))))
  (define std/event#sync
    (lambda _args53182_
      (letrec* ((_mutexes53184_ (make-table 'test: eq?))
                (_loop53185_
                 (lambda (_rest53302_
                          _sels53303_
                          _sel-evts53304_
                          _timeo53305_
                          _timeo-evt53306_)
                   (let* ((_rest5330753315_ _rest53302_)
                          (_else5330953325_
                           (lambda ()
                             (if (not (null? _sels53303_))
                                 (let ((_rz53323_
                                        (std/event#select__%
                                         _sels53303_
                                         _timeo53305_)))
                                   (if _rz53323_
                                       (_dispatch-selector53189_
                                        _rz53323_
                                        _sels53303_
                                        _sel-evts53304_)
                                       (_dispatch-evt53188_ _timeo-evt53306_)))
                                 (if _timeo53305_
                                     (begin
                                       (thread-sleep! _timeo53305_)
                                       (_dispatch-evt53188_ _timeo-evt53306_))
                                     (thread-sleep! '+inf.0)))))
                          (_K5331153334_
                           (lambda (_rest53328_ _evt53329_)
                             (if (or (let ()
                                       (declare (not safe))
                                       (##structure-direct-instance-of?
                                        _evt53329_
                                        'std/event#event::t))
                                     (let ()
                                       (declare (not safe))
                                       (##structure-direct-instance-of?
                                        _evt53329_
                                        'std/event#event-handler::t)))
                                 (_poll53186_
                                  _evt53329_
                                  _rest53328_
                                  _sels53303_
                                  _sel-evts53304_
                                  _timeo53305_
                                  _timeo-evt53306_)
                                 (_loop53185_
                                  (foldl1 cons
                                          _rest53328_
                                          (std/misc/shuffle#shuffle
                                           (##direct-structure-ref
                                            _evt53329_
                                            '1
                                            std/event#event-set::t
                                            '#f)))
                                  _sels53303_
                                  _sel-evts53304_
                                  _timeo53305_
                                  _timeo-evt53306_)))))
                     (if (let ()
                           (declare (not safe))
                           (##pair? _rest5330753315_))
                         (let ((_hd5331253337_
                                (let ()
                                  (declare (not safe))
                                  (##car _rest5330753315_)))
                               (_tl5331353339_
                                (let ()
                                  (declare (not safe))
                                  (##cdr _rest5330753315_))))
                           (let* ((_evt53342_ _hd5331253337_)
                                  (_rest53344_ _tl5331353339_))
                             (_K5331153334_ _rest53344_ _evt53342_)))
                         (_else5330953325_)))))
                (_poll53186_
                 (lambda (_evt53292_
                          _rest53293_
                          _sels53294_
                          _sel-evts53295_
                          _timeo53296_
                          _timeo-evt53297_)
                   (let ((_rz53299_ (_poll-evt53187_ _evt53292_)))
                     (if (not _rz53299_)
                         (_loop53185_
                          _rest53293_
                          _sels53294_
                          _sel-evts53295_
                          _timeo53296_
                          _timeo-evt53297_)
                         (if (eq? _rz53299_ '#t)
                             (begin
                               (_abort-selectors!53192_
                                _rest53293_
                                _sels53294_)
                               (_dispatch-evt53188_ _evt53292_))
                             (if (time? _rz53299_)
                                 (if _timeo53296_
                                     (if (< (time->seconds _rz53299_)
                                            (time->seconds _timeo53296_))
                                         (_loop53185_
                                          _rest53293_
                                          _sels53294_
                                          _sel-evts53295_
                                          _rz53299_
                                          _evt53292_)
                                         (_loop53185_
                                          _rest53293_
                                          _sels53294_
                                          _sel-evts53295_
                                          _timeo53296_
                                          _timeo-evt53297_))
                                     (_loop53185_
                                      _rest53293_
                                      _sels53294_
                                      _sel-evts53295_
                                      _rz53299_
                                      _evt53292_))
                                 (if (std/event#sync-selector? _rz53299_)
                                     (begin
                                       (_check-mutex!53190_
                                        _rz53299_
                                        _rest53293_
                                        _sels53294_)
                                       (_loop53185_
                                        _rest53293_
                                        (cons _rz53299_ _sels53294_)
                                        (cons _evt53292_ _sel-evts53295_)
                                        _timeo53296_
                                        _timeo-evt53297_))
                                     (_abort!53191_
                                      _rest53293_
                                      _sels53294_
                                      (lambda ()
                                        (error '"Bad synchronizer"
                                               _evt53292_
                                               _rz53299_))))))))))
                (_poll-evt53187_
                 (lambda (_evt53286_)
                   (let _lp53288_ ((_evt53290_ _evt53286_))
                     (if (let ()
                           (declare (not safe))
                           (##structure-direct-instance-of?
                            _evt53290_
                            'std/event#event::t))
                         ((##direct-structure-ref
                           _evt53290_
                           '2
                           std/event#event::t
                           '#f)
                          _evt53290_)
                         (_lp53288_
                          (##direct-structure-ref
                           _evt53290_
                           '1
                           std/event#event-handler::t
                           '#f))))))
                (_dispatch-evt53188_
                 (lambda (_evt53279_)
                   (let _recur53281_ ((_evt53283_ _evt53279_))
                     (if (let ()
                           (declare (not safe))
                           (##structure-direct-instance-of?
                            _evt53283_
                            'std/event#event::t))
                         ((##direct-structure-ref
                           _evt53283_
                           '3
                           std/event#event::t
                           '#f)
                          _evt53283_)
                         (call-with-values
                          (lambda ()
                            (_recur53281_
                             (##direct-structure-ref
                              _evt53283_
                              '1
                              std/event#event-handler::t
                              '#f)))
                          (##direct-structure-ref
                           _evt53283_
                           '2
                           std/event#event-handler::t
                           '#f))))))
                (_dispatch-selector53189_
                 (lambda (_rz53214_ _sels53215_ _sel-evts53216_)
                   (let _lp53218_ ((_rest-sels53220_ _sels53215_)
                                   (_rest-evts53221_ _sel-evts53216_))
                     (let* ((_rest-sels5322253229_ _rest-sels53220_)
                            (_E5322453233_
                             (lambda ()
                               (error '"No clause matching"
                                      _rest-sels5322253229_)))
                            (_K5322553267_
                             (lambda (_rest-sels53236_ _sel53237_)
                               (let* ((_rest-evts5323853245_ _rest-evts53221_)
                                      (_E5324053249_
                                       (lambda ()
                                         (error '"No clause matching"
                                                _rest-evts5323853245_)))
                                      (_K5324153255_
                                       (lambda (_rest-evts53252_ _evt53253_)
                                         (if (eq? _sel53237_ _rz53214_)
                                             (_dispatch-evt53188_ _evt53253_)
                                             (_lp53218_
                                              _rest-sels53236_
                                              _rest-evts53252_)))))
                                 (if (let ()
                                       (declare (not safe))
                                       (##pair? _rest-evts5323853245_))
                                     (let ((_hd5324253258_
                                            (let ()
                                              (declare (not safe))
                                              (##car _rest-evts5323853245_)))
                                           (_tl5324353260_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _rest-evts5323853245_))))
                                       (let* ((_evt53263_ _hd5324253258_)
                                              (_rest-evts53265_
                                               _tl5324353260_))
                                         (_K5324153255_
                                          _rest-evts53265_
                                          _evt53263_)))
                                     (_E5324053249_))))))
                       (if (let ()
                             (declare (not safe))
                             (##pair? _rest-sels5322253229_))
                           (let ((_hd5322653270_
                                  (let ()
                                    (declare (not safe))
                                    (##car _rest-sels5322253229_)))
                                 (_tl5322753272_
                                  (let ()
                                    (declare (not safe))
                                    (##cdr _rest-sels5322253229_))))
                             (let* ((_sel53275_ _hd5322653270_)
                                    (_rest-sels53277_ _tl5322753272_))
                               (_K5322553267_ _rest-sels53277_ _sel53275_)))
                           (_E5322453233_))))))
                (_check-mutex!53190_
                 (lambda (_rz53207_ _rest53208_ _sels53209_)
                   (if (pair? _rz53207_)
                       (let ((_mx53211_ (car _rz53207_)))
                         (if (table-ref _mutexes53184_ _mx53211_ '#f)
                             (_abort!53191_
                              _rest53208_
                              _sels53209_
                              (lambda ()
                                (error '"Duplicate mutex synchronizer"
                                       _rz53207_)))
                             (table-set! _mutexes53184_ _mx53211_ '#t)))
                       '#!void)))
                (_abort!53191_
                 (lambda (_rest53203_ _sels53204_ _E53205_)
                   (_abort-selectors!53192_ _rest53203_ _sels53204_)
                   (_E53205_)))
                (_abort-selectors!53192_
                 (lambda (_rest53200_ _sels53201_)
                   (for-each _abort-selector!53193_ _sels53201_)
                   (for-each _abort-evt!53194_ _rest53200_)))
                (_abort-selector!53193_
                 (lambda (_sel53198_)
                   (if (pair? _sel53198_)
                       (mutex-unlock! (car _sel53198_))
                       '#!void)))
                (_abort-evt!53194_
                 (lambda (_evt53196_)
                   (if (let ()
                         (declare (not safe))
                         (##structure-direct-instance-of?
                          _evt53196_
                          'std/event#event::t))
                       ((##direct-structure-ref
                         _evt53196_
                         '4
                         std/event#event::t
                         '#f)
                        _evt53196_)
                       (if (let ()
                             (declare (not safe))
                             (##structure-direct-instance-of?
                              _evt53196_
                              'std/event#event-handler::t))
                           (_abort-evt!53194_
                            (##direct-structure-ref
                             _evt53196_
                             '1
                             std/event#event-handler::t
                             '#f))
                           (for-each
                            _abort-evt!53194_
                            (##direct-structure-ref
                             _evt53196_
                             '1
                             std/event#event-set::t
                             '#f)))))))
        (_loop53185_
         (std/misc/shuffle#shuffle (map std/event#wrap-evt _args53182_))
         '()
         '()
         '#f
         '#f))))
  (define std/event#sync-selector?
    (lambda (_obj53174_)
      (let ((_$e53176_ (thread? _obj53174_)))
        (if _$e53176_
            _$e53176_
            (let ((_$e53179_
                   (if (pair? _obj53174_)
                       (if (mutex? (car _obj53174_))
                           (condition-variable? (cdr _obj53174_))
                           '#f)
                       '#f)))
              (if _$e53179_
                  _$e53179_
                  (std/event#io-condition-variable? _obj53174_)))))))
  (define std/event#event-abort-sync-selector
    (lambda (_evt53170_)
      (let ((_sel53172_
             (##direct-structure-ref _evt53170_ '1 std/event#event::t '#f)))
        (if (pair? _sel53172_) (mutex-unlock! (car _sel53172_)) '#!void))))
  (define std/event#input-port-evt
    (lambda (_port53168_)
      (if (macro-u8vector-port? _port53168_)
          (std/event#make-u8vector-port-evt _port53168_)
          (if (macro-string-port? _port53168_)
              (std/event#make-string-port-evt _port53168_)
              (if (macro-vector-port? _port53168_)
                  (std/event#make-vector-port-evt _port53168_)
                  (if (macro-device-port? _port53168_)
                      (std/event#make-device-port-evt _port53168_)
                      (if (macro-tcp-server-port? _port53168_)
                          (std/event#make-tcp-server-port-evt _port53168_)
                          (if (macro-raw-device-port? _port53168_)
                              (std/event#make-raw-device-port-evt _port53168_)
                              (error '"can't wrap event around unknown port type"
                                     _port53168_)))))))))
  (define std/event#make-u8vector-port-evt
    (lambda (_port53153_)
      (letrec ((_rbuf-check53155_
                (lambda (_port53166_)
                  (let ((__tmp291134 (macro-byte-port-rlo _port53166_))
                        (__tmp291133 (macro-byte-port-rhi _port53166_)))
                    (declare (not safe))
                    (##fx< __tmp291134 __tmp291133))))
               (_rbuf-fill53156_
                (lambda (_port53164_) (macro-byte-port-rbuf-fill _port53164_)))
               (_condvar-e53157_
                (lambda (_port53162_)
                  (macro-u8vector-port-rcondvar _port53162_)))
               (_poll53158_
                (lambda (_evt53160_)
                  (std/event#user-port-poll
                   (##direct-structure-ref
                    _evt53160_
                    '1
                    std/event#event::t
                    '#f)
                   _rbuf-check53155_
                   _rbuf-fill53156_
                   _condvar-e53157_))))
        (let ((__obj291114 (make-object std/event#event::t '4)))
          (std/event#event:::init!__0
           __obj291114
           _port53153_
           _poll53158_
           std/event#event-e)
          __obj291114))))
  (define std/event#make-string-port-evt
    (lambda (_port53138_)
      (letrec ((_rbuf-check53140_
                (lambda (_port53151_)
                  (let ((__tmp291136 (macro-character-port-rlo _port53151_))
                        (__tmp291135 (macro-character-port-rhi _port53151_)))
                    (declare (not safe))
                    (##fx< __tmp291136 __tmp291135))))
               (_rbuf-fill53141_
                (lambda (_port53149_)
                  (macro-character-port-rbuf-fill _port53149_)))
               (_condvar-e53142_
                (lambda (_port53147_)
                  (macro-string-port-rcondvar _port53147_)))
               (_poll53143_
                (lambda (_evt53145_)
                  (std/event#user-port-poll
                   (##direct-structure-ref
                    _evt53145_
                    '1
                    std/event#event::t
                    '#f)
                   _rbuf-check53140_
                   _rbuf-fill53141_
                   _condvar-e53142_))))
        (let ((__obj291115 (make-object std/event#event::t '4)))
          (std/event#event:::init!__0
           __obj291115
           _port53138_
           _poll53143_
           std/event#event-e)
          __obj291115))))
  (define std/event#make-vector-port-evt
    (lambda (_port53123_)
      (letrec ((_rbuf-check53125_
                (lambda (_port53136_)
                  (let ((__tmp291138 (macro-vector-port-rlo _port53136_))
                        (__tmp291137 (macro-vector-port-rhi _port53136_)))
                    (declare (not safe))
                    (##fx< __tmp291138 __tmp291137))))
               (_rbuf-fill53126_
                (lambda (_port53134_)
                  (macro-vector-port-rbuf-fill _port53134_)))
               (_condvar-e53127_
                (lambda (_port53132_)
                  (macro-vector-port-rcondvar _port53132_)))
               (_poll53128_
                (lambda (_evt53130_)
                  (std/event#user-port-poll
                   (##direct-structure-ref
                    _evt53130_
                    '1
                    std/event#event::t
                    '#f)
                   _rbuf-check53125_
                   _rbuf-fill53126_
                   _condvar-e53127_))))
        (let ((__obj291116 (make-object std/event#event::t '4)))
          (std/event#event:::init!__0
           __obj291116
           _port53123_
           _poll53128_
           std/event#event-e)
          __obj291116))))
  (define std/event#user-port-poll
    (lambda (_port53111_ _rbuf-check53112_ _rbuf-fill53113_ _condvar-e53114_)
      (letrec ((_fill!53116_
                (lambda (_port53121_)
                  (std/event#input-port-rbuf-fill!
                   _port53121_
                   (_rbuf-fill53113_ _port53121_)))))
        (let ((_mx53118_ (macro-port-mutex _port53111_)))
          (mutex-lock! _mx53118_)
          (if (_rbuf-check53112_ _port53111_)
              (begin (mutex-unlock! _mx53118_) '#t)
              (if (_fill!53116_ _port53111_)
                  (begin (mutex-unlock! _mx53118_) '#t)
                  (cons _mx53118_ (_condvar-e53114_ _port53111_))))))))
  (define std/event#input-port-rbuf-fill!
    (lambda (_port53103_ _fill53104_)
      (let _lp53106_ ()
        (let ((_r53109_ (_fill53104_ _port53103_ '1 '#f)))
          (if (eq? _r53109_ ##err-code-EINTR)
              (_lp53106_)
              (if (eq? _r53109_ ##err-code-EAGAIN) '#f '#t))))))
  (define std/event#make-device-port-evt
    (lambda (_port53086_)
      (letrec ((_fill!53088_
                (lambda (_port53101_)
                  (std/event#input-port-rbuf-fill!
                   _port53101_
                   (macro-byte-port-rbuf-fill _port53101_))))
               (_poll53089_
                (lambda (_evt53091_)
                  (let* ((_port53093_
                          (##direct-structure-ref
                           _evt53091_
                           '1
                           std/event#event::t
                           '#f))
                         (_mx53095_ (macro-port-mutex _port53093_)))
                    (if (or (let ((__tmp291140
                                   (macro-byte-port-rlo _port53093_))
                                  (__tmp291139
                                   (macro-byte-port-rhi _port53093_)))
                              (declare (not safe))
                              (##fx< __tmp291140 __tmp291139))
                            (let ((__tmp291142
                                   (macro-character-port-rlo _port53093_))
                                  (__tmp291141
                                   (macro-character-port-rhi _port53093_)))
                              (declare (not safe))
                              (##fx< __tmp291142 __tmp291141)))
                        (begin (mutex-unlock! _mx53095_) '#t)
                        (if (_fill!53088_ _port53093_)
                            (begin (mutex-unlock! _mx53095_) '#t)
                            (begin
                              (mutex-unlock! _mx53095_)
                              (macro-device-port-rdevice-condvar
                               _port53093_))))))))
        (let ((__obj291117 (make-object std/event#event::t '4)))
          (std/event#event:::init!__0
           __obj291117
           _port53086_
           _poll53089_
           std/event#event-e)
          __obj291117))))
  (define std/event#make-tcp-server-port-evt
    (lambda (_port53078_)
      (letrec ((_poll53080_
                (lambda (_evt53082_)
                  (let ((_port53084_
                         (##direct-structure-ref
                          _evt53082_
                          '1
                          std/event#event::t
                          '#f)))
                    (macro-tcp-server-port-rdevice-condvar _port53084_)))))
        (let ((__obj291118 (make-object std/event#event::t '4)))
          (std/event#event:::init!__0
           __obj291118
           _port53078_
           _poll53080_
           std/event#event-e)
          __obj291118))))
  (define std/event#make-raw-device-port-evt
    (lambda (_port53070_)
      (letrec ((_poll53072_
                (lambda (_evt53074_)
                  (let ((_port53076_
                         (##direct-structure-ref
                          _evt53074_
                          '1
                          std/event#event::t
                          '#f)))
                    (macro-raw-device-port-rdevice-condvar _port53076_)))))
        (let ((__obj291119 (make-object std/event#event::t '4)))
          (std/event#event:::init!__0
           __obj291119
           _port53070_
           _poll53072_
           std/event#event-e)
          __obj291119)))))
