(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/concurrent-plan#max-actual-workers (make-parameter '0))
  (define std/misc/concurrent-plan#perform-plan/threads__%
    (lambda (_g302113_
             _perform3852338531_
             _announce3852438533_
             _on-success3852538535_
             _on-failure3852638537_
             _deterministic-order3852738539_
             _max-workers3852838541_
             _fg-queue38543_
             _bg-queue38544_)
      (let* ((_perform38546_
              (if (eq? _perform3852338531_ absent-value)
                  (error '"Missing required keyword argument" 'perform:)
                  _perform3852338531_))
             (_announce38548_
              (if (eq? _announce3852438533_ absent-value)
                  (error '"Missing required keyword argument" 'announce:)
                  _announce3852438533_))
             (_on-success38550_
              (if (eq? _on-success3852538535_ absent-value)
                  (error '"Missing required keyword argument" 'on-success:)
                  _on-success3852538535_))
             (_on-failure38552_
              (if (eq? _on-failure3852638537_ absent-value)
                  (error '"Missing required keyword argument" 'on-failure:)
                  _on-failure3852638537_))
             (_deterministic-order38554_
              (if (eq? _deterministic-order3852738539_ absent-value)
                  (error '"Missing required keyword argument"
                         'deterministic-order:)
                  _deterministic-order3852738539_))
             (_max-workers38556_
              (if (eq? _max-workers3852838541_ absent-value)
                  (max (let () (declare (not safe)) (##cpu-count)) '1)
                  _max-workers3852838541_)))
        (letrec* ((_foreground-thread38659_ (current-thread))
                  (_fg-perform38660_
                   (lambda (_item38752_)
                     (_announce38548_ _item38752_)
                     (with-exception-catcher
                      (lambda (_g3875338755_)
                        (_on-failure38552_ _item38752_ _g3875338755_))
                      (lambda ()
                        (_on-success38550_
                         _item38752_
                         (_perform38546_ _item38752_))))))
                  (_serial?38661_ (< _max-workers38556_ '2))
                  (_parallel?38662_ (not _serial?38661_))
                  (_workers38663_ '0))
          (let _loop38665_ ()
            (letrec* ((_no-fg-item?38668_
                       (std/misc/pqueue#pqueue-empty? _fg-queue38543_))
                      (_fg-item?38669_ (not _no-fg-item?38668_))
                      (_no-bg-item?38670_
                       (std/misc/pqueue#pqueue-empty? _bg-queue38544_))
                      (_bg-item?38671_ (not _no-bg-item?38670_))
                      (_no-workers?38672_ (zero? _workers38663_))
                      (_workers?38673_ (not _no-workers?38672_))
                      (_no-worker-slots?38674_
                       (>= _workers38663_ _max-workers38556_))
                      (_worker-slots?38675_ (not _no-worker-slots?38674_))
                      (_ready-to-spawn?38676_
                       (if _bg-item?38671_ _worker-slots?38675_ '#f))
                      (_wait?38677_
                       (if (not _ready-to-spawn?38676_)
                           (let ((_$e38749_ _no-fg-item?38668_))
                             (if _$e38749_
                                 _$e38749_
                                 _deterministic-order38554_))
                           '#f)))
              (let ((_$e38679_
                     (if _parallel?38662_
                         (if _workers?38673_
                             (thread-receive (if _wait?38677_ '#f '0) '#f)
                             '#f)
                         '#f)))
                (if _$e38679_
                    ((lambda (_e3868138683_)
                       (let* ((_g3868538696_ _e3868138683_)
                              (_E3868838700_
                               (lambda ()
                                 (error '"No clause matching" _g3868538696_))))
                         (let ((_K3869038722_
                                (lambda (_item38714_ _worker38715_)
                                  (set! _workers38663_ (- _workers38663_ '1))
                                  (with-exception-catcher
                                   (lambda (_g3871638718_)
                                     (_on-failure38552_
                                      _item38714_
                                      _g3871638718_))
                                   (lambda ()
                                     (_on-success38550_
                                      _item38714_
                                      (std/misc/concurrent-plan#worker-join!
                                       _worker38715_))))
                                  (_loop38665_)))
                               (_K3868938706_
                                (lambda (_m38704_)
                                  (error '"unexpected message" _m38704_))))
                           (if (let ()
                                 (declare (not safe))
                                 (##pair? _g3868538696_))
                               (let ((_tl3869238727_
                                      (let ()
                                        (declare (not safe))
                                        (##cdr _g3868538696_)))
                                     (_hd3869138725_
                                      (let ()
                                        (declare (not safe))
                                        (##car _g3868538696_))))
                                 (if (let ()
                                       (declare (not safe))
                                       (##pair? _tl3869238727_))
                                     (let ((_tl3869438734_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _tl3869238727_)))
                                           (_hd3869338732_
                                            (let ()
                                              (declare (not safe))
                                              (##car _tl3869238727_))))
                                       (if (let ()
                                             (declare (not safe))
                                             (##null? _tl3869438734_))
                                           (let ((_worker38730_ _hd3869138725_)
                                                 (_item38737_ _hd3869338732_))
                                             (_K3869038722_
                                              _item38737_
                                              _worker38730_))
                                           (let ((_m38709_ _g3868538696_))
                                             (_K3868938706_ _m38709_))))
                                     (let ((_m38709_ _g3868538696_))
                                       (_K3868938706_ _m38709_))))
                               (let ((_m38709_ _g3868538696_))
                                 (_K3868938706_ _m38709_))))))
                     _$e38679_)
                    (if (and _parallel?38662_ _ready-to-spawn?38676_)
                        (begin
                          (let ((_item38739_
                                 (std/misc/pqueue#pqueue-pop!__%
                                  _bg-queue38544_
                                  '#f)))
                            (_announce38548_ _item38739_)
                            (set! _workers38663_ (+ _workers38663_ '1))
                            (gerbil/gambit/threads#spawn/name
                             (cons 'worker: (cons _item38739_ '()))
                             (lambda ()
                               (with-unwind-protect
                                (lambda () (_perform38546_ _item38739_))
                                (lambda ()
                                  (thread-send
                                   _foreground-thread38659_
                                   (cons (current-thread)
                                         (cons _item38739_ '())))))))
                            (if (< (std/misc/concurrent-plan#max-actual-workers)
                                   _workers38663_)
                                (std/misc/concurrent-plan#max-actual-workers
                                 _workers38663_)
                                '#!void))
                          (_loop38665_))
                        (if (and _serial?38661_ _bg-item?38671_)
                            (begin
                              (_fg-perform38660_
                               (std/misc/pqueue#pqueue-pop!__%
                                _bg-queue38544_
                                '#f))
                              (_loop38665_))
                            (if (and _fg-item?38669_
                                     (not _deterministic-order38554_))
                                (begin
                                  (_fg-perform38660_
                                   (std/misc/pqueue#pqueue-pop!__%
                                    _fg-queue38543_
                                    '#f))
                                  (_loop38665_))
                                (if (and _fg-item?38669_
                                         _deterministic-order38554_
                                         _no-workers?38672_
                                         _no-bg-item?38670_)
                                    (begin
                                      (let _lp38744_ ()
                                        (if (std/misc/pqueue#pqueue-empty?
                                             _fg-queue38543_)
                                            '#!void
                                            (begin
                                              (_fg-perform38660_
                                               (std/misc/pqueue#pqueue-pop!__%
                                                _fg-queue38543_
                                                '#f))
                                              (_lp38744_))))
                                      (_loop38665_))
                                    (begin
                                      (let ()
                                        (if (and _no-fg-item?38668_
                                                 _no-bg-item?38670_
                                                 _no-workers?38672_)
                                            '#!void
                                            (std/assert#assert!/fail
                                             '"\"misc/concurrent-plan.ss\"@103.16"
                                             '(and no-fg-item?
                                                   no-bg-item?
                                                   no-workers?)
                                             '())))
                                      '#!void)))))))))))))
  (define std/misc/concurrent-plan#perform-plan/threads__@
    (lambda (_keys3852238762_ . _args38764_)
      (apply std/misc/concurrent-plan#perform-plan/threads__%
             _keys3852238762_
             (table-ref _keys3852238762_ 'perform: absent-value)
             (table-ref _keys3852238762_ 'announce: absent-value)
             (table-ref _keys3852238762_ 'on-success: absent-value)
             (table-ref _keys3852238762_ 'on-failure: absent-value)
             (table-ref _keys3852238762_ 'deterministic-order: absent-value)
             (table-ref _keys3852238762_ 'max-workers: absent-value)
             _args38764_)))
  (define std/misc/concurrent-plan#perform-plan/threads
    (lambda _args3852938770_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                announce:
                #f
                #f
                on-success:
                perform:
                max-workers:
                deterministic-order:
                on-failure:
                #f)
             std/misc/concurrent-plan#perform-plan/threads__@
             _args3852938770_)))
  (define std/misc/concurrent-plan#worker-join!
    (lambda (_thread38509_)
      (with-exception-catcher
       (lambda (_g3851038512_)
         (if ((lambda (_$obj38515_) (uncaught-exception? _$obj38515_))
              _g3851038512_)
             (let ((_exn38518_ _g3851038512_))
               (raise (make-struct-instance
                       std/misc/concurrent-plan#worker-error::t
                       _exn38518_)))
             (raise _g3851038512_)))
       (lambda () (thread-join! _thread38509_)))))
  (define std/misc/concurrent-plan#worker-error::t
    (make-struct-type
     'std/misc/concurrent-plan#worker-error::t
     exception::t
     '1
     'worker-error
     '()
     '#f
     '(e)))
  (define std/misc/concurrent-plan#worker-error?
    (make-struct-predicate std/misc/concurrent-plan#worker-error::t))
  (define std/misc/concurrent-plan#make-worker-error
    (lambda _$args38506_
      (apply make-struct-instance
             std/misc/concurrent-plan#worker-error::t
             _$args38506_)))
  (define std/misc/concurrent-plan#worker-error-e
    (make-struct-field-accessor std/misc/concurrent-plan#worker-error::t '0))
  (define std/misc/concurrent-plan#worker-error-e-set!
    (make-struct-field-mutator std/misc/concurrent-plan#worker-error::t '0))
  (define std/misc/concurrent-plan#worker-error::display-exception
    (lambda (_self38501_ _port38502_)
      (let ((_e38504_ (std/misc/concurrent-plan#worker-error-e _self38501_)))
        (display '"Uncaught exception: " _port38502_)
        (display-exception (uncaught-exception-reason _e38504_) _port38502_))))
  (bind-method!
   std/misc/concurrent-plan#worker-error::t
   'display-exception
   std/misc/concurrent-plan#worker-error::display-exception
   '#f))
