(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/hash#hash-empty?
    (lambda (_h30741_) (zero? (table-length _h30741_))))
  (define std/misc/hash#%none '#(none))
  (define std/misc/hash#hash-ref/default
    (lambda (_table30735_ _key30736_ _default30737_)
      (let ((_val30739_
             (table-ref _table30735_ _key30736_ std/misc/hash#%none)))
        (if (eq? _val30739_ std/misc/hash#%none)
            (_default30737_)
            _val30739_))))
  (define std/misc/hash#hash-ensure-ref
    (lambda (_table30728_ _key30729_ _default30730_)
      (std/misc/hash#hash-ref/default
       _table30728_
       _key30729_
       (lambda ()
         (let ((_value30733_ (_default30730_)))
           (table-set! _table30728_ _key30729_ _value30733_)
           _value30733_)))))
  (define std/misc/hash#invert-hash__%
    (lambda (_g304199_ _to3070230705_ _from30707_)
      (let ((_to30709_
             (if (eq? _to3070230705_ absent-value)
                 (make-table)
                 _to3070230705_)))
        (table-for-each
         (lambda (_k30711_ _v30712_) (table-set! _to30709_ _v30712_ _k30711_))
         _from30707_)
        _to30709_)))
  (define std/misc/hash#invert-hash__@
    (lambda (_keys3070130717_ . _args30719_)
      (apply std/misc/hash#invert-hash__%
             _keys3070130717_
             (table-ref _keys3070130717_ 'to: absent-value)
             _args30719_)))
  (define std/misc/hash#invert-hash
    (lambda _args3070330725_
      (apply keyword-dispatch
             '#(to:)
             std/misc/hash#invert-hash__@
             _args3070330725_)))
  (define std/misc/hash#invert-hash/fold__%
    (lambda (_g304200_
             _to3066430669_
             _nil3066530671_
             _cons3066630673_
             _from30675_)
      (let* ((_to30677_
              (if (eq? _to3066430669_ absent-value)
                  (make-table)
                  _to3066430669_))
             (_nil30679_
              (if (eq? _nil3066530671_ absent-value) '() _nil3066530671_))
             (_cons30681_
              (if (eq? _cons3066630673_ absent-value) cons _cons3066630673_)))
        (table-for-each
         (lambda (_k30683_ _v30684_)
           (table-set!
            _to30677_
            _v30684_
            (_cons30681_ _k30683_ (table-ref _to30677_ _v30684_ _nil30679_))))
         _from30675_)
        _to30677_)))
  (define std/misc/hash#invert-hash/fold__@
    (lambda (_keys3066330689_ . _args30691_)
      (apply std/misc/hash#invert-hash/fold__%
             _keys3066330689_
             (table-ref _keys3066330689_ 'to: absent-value)
             (table-ref _keys3066330689_ 'nil: absent-value)
             (table-ref _keys3066330689_ 'cons: absent-value)
             _args30691_)))
  (define std/misc/hash#invert-hash/fold
    (lambda _args3066730697_
      (apply keyword-dispatch
             '#(nil: cons: to:)
             std/misc/hash#invert-hash/fold__@
             _args3066730697_)))
  (define std/misc/hash#invert-hash<-vector__%
    (lambda (_g304201_
             _start3059630602_
             _end3059730604_
             _to3059830606_
             _key3059930608_
             _from30610_)
      (let* ((_start30612_
              (if (eq? _start3059630602_ absent-value) '0 _start3059630602_))
             (_end30614_
              (if (eq? _end3059730604_ absent-value)
                  (vector-length _from30610_)
                  _end3059730604_))
             (_to30616_
              (if (eq? _to3059830606_ absent-value)
                  (make-table)
                  _to3059830606_))
             (_key30618_
              (if (eq? _key3059930608_ absent-value)
                  identity
                  _key3059930608_)))
        (let* ((_iter-do30625_
                (lambda (_n30620_)
                  (let ((_i30623_ _n30620_))
                    (table-set!
                     _to30616_
                     (_key30618_ (vector-ref _from30610_ _i30623_))
                     _i30623_))))
               (_$start30628_ _start30612_)
               (_$end30631_ _end30614_)
               (_$step30634_ (if (> _$start30628_ _$end30631_) '-1 '1)))
          (if (negative? _$step30634_)
              (let _lp30638_ ((_val30641_ _$start30628_))
                (if (> _val30641_ _$end30631_)
                    (begin
                      (_iter-do30625_ _val30641_)
                      (_lp30638_ (+ _val30641_ _$step30634_)))
                    '#!void))
              (let _lp30644_ ((_val30646_ _$start30628_))
                (if (< _val30646_ _$end30631_)
                    (begin
                      (_iter-do30625_ _val30646_)
                      (_lp30644_ (+ _val30646_ _$step30634_)))
                    '#!void))))
        _to30616_)))
  (define std/misc/hash#invert-hash<-vector__@
    (lambda (_keys3059530651_ . _args30653_)
      (apply std/misc/hash#invert-hash<-vector__%
             _keys3059530651_
             (table-ref _keys3059530651_ 'start: absent-value)
             (table-ref _keys3059530651_ 'end: absent-value)
             (table-ref _keys3059530651_ 'to: absent-value)
             (table-ref _keys3059530651_ 'key: absent-value)
             _args30653_)))
  (define std/misc/hash#invert-hash<-vector
    (lambda _args3060030659_
      (apply keyword-dispatch
             '#(#f key: #f #f end: start: #f #f to:)
             std/misc/hash#invert-hash<-vector__@
             _args3060030659_)))
  (define std/misc/hash#invert-hash<-vector/fold__%
    (lambda (_g304202_
             _start3051630524_
             _end3051730526_
             _to3051830528_
             _nil3051930530_
             _cons3052030532_
             _key3052130534_
             _from30536_)
      (let* ((_start30538_
              (if (eq? _start3051630524_ absent-value) '0 _start3051630524_))
             (_end30540_
              (if (eq? _end3051730526_ absent-value)
                  (vector-length _from30536_)
                  _end3051730526_))
             (_to30542_
              (if (eq? _to3051830528_ absent-value)
                  (make-table)
                  _to3051830528_))
             (_nil30544_
              (if (eq? _nil3051930530_ absent-value) '() _nil3051930530_))
             (_cons30546_
              (if (eq? _cons3052030532_ absent-value) cons _cons3052030532_))
             (_key30548_
              (if (eq? _key3052130534_ absent-value)
                  identity
                  _key3052130534_)))
        (let* ((_iter-do30557_
                (lambda (_n30550_)
                  (let ((_i30553_ _n30550_))
                    (letrec* ((_val30555_ (vector-ref _from30536_ _i30553_)))
                      (table-set!
                       _to30542_
                       (_key30548_ _val30555_)
                       (_cons30546_
                        _i30553_
                        (table-ref _to30542_ _val30555_ _nil30544_)))))))
               (_$start30560_ _start30538_)
               (_$end30563_ _end30540_)
               (_$step30566_ (if (> _$start30560_ _$end30563_) '-1 '1)))
          (if (negative? _$step30566_)
              (let _lp30570_ ((_val30573_ _$start30560_))
                (if (> _val30573_ _$end30563_)
                    (begin
                      (_iter-do30557_ _val30573_)
                      (_lp30570_ (+ _val30573_ _$step30566_)))
                    '#!void))
              (let _lp30576_ ((_val30578_ _$start30560_))
                (if (< _val30578_ _$end30563_)
                    (begin
                      (_iter-do30557_ _val30578_)
                      (_lp30576_ (+ _val30578_ _$step30566_)))
                    '#!void))))
        _to30542_)))
  (define std/misc/hash#invert-hash<-vector/fold__@
    (lambda (_keys3051530583_ . _args30585_)
      (apply std/misc/hash#invert-hash<-vector/fold__%
             _keys3051530583_
             (table-ref _keys3051530583_ 'start: absent-value)
             (table-ref _keys3051530583_ 'end: absent-value)
             (table-ref _keys3051530583_ 'to: absent-value)
             (table-ref _keys3051530583_ 'nil: absent-value)
             (table-ref _keys3051530583_ 'cons: absent-value)
             (table-ref _keys3051530583_ 'key: absent-value)
             _args30585_)))
  (define std/misc/hash#invert-hash<-vector/fold
    (lambda _args3052230591_
      (apply keyword-dispatch
             '#(#f
                #f
                to:
                #f
                #f
                #f
                nil:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                end:
                #f
                #f
                #f
                #f
                #f
                cons:
                start:
                #f
                #f
                #f
                #f
                key:
                #f
                #f
                #f
                #f
                #f
                #f
                #f)
             std/misc/hash#invert-hash<-vector/fold__@
             _args3052230591_)))
  (define std/misc/hash#hash-restrict-keys
    (let ((_marker30503_ '#(fresh)))
      (lambda (_h30505_ _keys30506_)
        (let ((_table30508_ (make-table)))
          (for-each
           (lambda (_k30510_)
             (let ((_v30512_ (table-ref _h30505_ _k30510_ _marker30503_)))
               (if (eq? _v30512_ _marker30503_)
                   '#!void
                   (table-set! _table30508_ _k30510_ _v30512_))))
           _keys30506_)
          _table30508_))))
  (define std/misc/hash#hash-value-map
    (lambda (_h30468_ _f30469_)
      (list->table
       (map (lambda (_e3047030472_)
              (let* ((_g3047430481_ _e3047030472_)
                     (_E3047630485_
                      (lambda () (error '"No clause matching" _g3047430481_)))
                     (_K3047730491_
                      (lambda (_v30488_ _k30489_)
                        (cons _k30489_ (_f30469_ _v30488_)))))
                (if (let () (declare (not safe)) (##pair? _g3047430481_))
                    (let ((_hd3047830494_
                           (let () (declare (not safe)) (##car _g3047430481_)))
                          (_tl3047930496_
                           (let ()
                             (declare (not safe))
                             (##cdr _g3047430481_))))
                      (let* ((_k30499_ _hd3047830494_)
                             (_v30501_ _tl3047930496_))
                        (_K3047730491_ _v30501_ _k30499_)))
                    (_E3047630485_))))
            (table->list _h30468_)))))
  (define std/misc/hash#hash-key-value-map__%
    (lambda (_f30411_ _from30412_ _to30413_)
      (table-for-each
       (lambda (_k30415_ _v30416_)
         (let* ((_g3041730426_ (_f30411_ _k30415_ _v30416_))
                (_E3042030430_
                 (lambda () (error '"No clause matching" _g3041730426_))))
           (let ((_K3042230444_
                  (lambda (_v130441_ _k130442_)
                    (table-set! _to30413_ _k130442_ _v130441_)))
                 (_K3042130435_ (lambda () '#!void)))
             (let ((_try-match3041930438_
                    (lambda ()
                      (if (let ()
                            (declare (not safe))
                            (##eq? _g3041730426_ '#f))
                          '#!void
                          (_E3042030430_)))))
               (if (let () (declare (not safe)) (##pair? _g3041730426_))
                   (let ((_tl3042430449_
                          (let () (declare (not safe)) (##cdr _g3041730426_)))
                         (_hd3042330447_
                          (let () (declare (not safe)) (##car _g3041730426_))))
                     (let ((_k130452_ _hd3042330447_)
                           (_v130454_ _tl3042430449_))
                       (_K3042230444_ _v130454_ _k130452_)))
                   (_try-match3041930438_))))))
       _from30412_)
      _to30413_))
  (define std/misc/hash#hash-key-value-map__0
    (lambda (_f30459_ _from30460_)
      (let ((_to30462_ (make-table)))
        (std/misc/hash#hash-key-value-map__% _f30459_ _from30460_ _to30462_))))
  (define std/misc/hash#hash-key-value-map
    (lambda _g304204_
      (let ((_g304203_ (let () (declare (not safe)) (##length _g304204_))))
        (cond ((let () (declare (not safe)) (##fx= _g304203_ 2))
               (apply std/misc/hash#hash-key-value-map__0 _g304204_))
              ((let () (declare (not safe)) (##fx= _g304203_ 3))
               (apply std/misc/hash#hash-key-value-map__% _g304204_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/hash#hash-key-value-map
                _g304204_))))))
  (define std/misc/hash#hash-filter__%
    (lambda (_from30391_ _pred30392_ _to30393_)
      (table-for-each
       (lambda (_k30395_ _v30396_)
         (if (_pred30392_ _k30395_ _v30396_)
             (table-set! _to30393_ _k30395_ _v30396_)
             '#!void))
       _from30391_)
      _to30393_))
  (define std/misc/hash#hash-filter__0
    (lambda (_from30401_ _pred30402_)
      (let ((_to30404_ (make-table)))
        (std/misc/hash#hash-filter__% _from30401_ _pred30402_ _to30404_))))
  (define std/misc/hash#hash-filter
    (lambda _g304206_
      (let ((_g304205_ (let () (declare (not safe)) (##length _g304206_))))
        (cond ((let () (declare (not safe)) (##fx= _g304205_ 2))
               (apply std/misc/hash#hash-filter__0 _g304206_))
              ((let () (declare (not safe)) (##fx= _g304205_ 3))
               (apply std/misc/hash#hash-filter__% _g304206_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/hash#hash-filter
                _g304206_))))))
  (define std/misc/hash#hash-remove__%
    (lambda (_from30371_ _pred30372_ _to30373_)
      (table-for-each
       (lambda (_k30375_ _v30376_)
         (if (_pred30372_ _k30375_ _v30376_)
             '#!void
             (table-set! _to30373_ _k30375_ _v30376_)))
       _from30371_)
      _to30373_))
  (define std/misc/hash#hash-remove__0
    (lambda (_from30381_ _pred30382_)
      (let ((_to30384_ (make-table)))
        (std/misc/hash#hash-remove__% _from30381_ _pred30382_ _to30384_))))
  (define std/misc/hash#hash-remove
    (lambda _g304208_
      (let ((_g304207_ (let () (declare (not safe)) (##length _g304208_))))
        (cond ((let () (declare (not safe)) (##fx= _g304207_ 2))
               (apply std/misc/hash#hash-remove__0 _g304208_))
              ((let () (declare (not safe)) (##fx= _g304207_ 3))
               (apply std/misc/hash#hash-remove__% _g304208_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/hash#hash-remove
                _g304208_))))))
  (define std/misc/hash#hash-remove-value__%
    (lambda (_from30346_ _value30347_ _to30348_)
      (std/misc/hash#hash-remove__%
       _from30346_
       (lambda (_g304209_ _v30350_) (equal? _v30350_ _value30347_))
       _to30348_)))
  (define std/misc/hash#hash-remove-value__0
    (lambda (_from30355_)
      (let* ((_value30357_ '#f) (_to30359_ (make-table)))
        (std/misc/hash#hash-remove-value__%
         _from30355_
         _value30357_
         _to30359_))))
  (define std/misc/hash#hash-remove-value__1
    (lambda (_from30361_ _value30362_)
      (let ((_to30364_ (make-table)))
        (std/misc/hash#hash-remove-value__%
         _from30361_
         _value30362_
         _to30364_))))
  (define std/misc/hash#hash-remove-value
    (lambda _g304211_
      (let ((_g304210_ (let () (declare (not safe)) (##length _g304211_))))
        (cond ((let () (declare (not safe)) (##fx= _g304210_ 1))
               (apply std/misc/hash#hash-remove-value__0 _g304211_))
              ((let () (declare (not safe)) (##fx= _g304210_ 2))
               (apply std/misc/hash#hash-remove-value__1 _g304211_))
              ((let () (declare (not safe)) (##fx= _g304210_ 3))
               (apply std/misc/hash#hash-remove-value__% _g304211_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/hash#hash-remove-value
                _g304211_))))))
  (define std/misc/hash#hash-ensure-removed!
    (lambda (_table30340_ _key30341_)
      (let ((_val30343_
             (table-ref _table30340_ _key30341_ std/misc/hash#%none)))
        (if (eq? _val30343_ std/misc/hash#%none)
            (values '#f '#f)
            (begin
              (table-set! _table30340_ _key30341_)
              (values _val30343_ '#t))))))
  (define std/misc/hash#hash-ensure-modify!
    (lambda (_table30330_ _key30331_ _default30332_ _function30333_)
      (let* ((_val30335_
              (std/misc/hash#hash-ensure-ref
               _table30330_
               _key30331_
               _default30332_))
             (_new-val30337_ (_function30333_ _val30335_)))
        (table-set! _table30330_ _key30331_ _new-val30337_)
        _new-val30337_)))
  (define std/misc/hash#hash-merge/override
    (lambda (_base-table30324_ . _rest30325_)
      (foldl1 (lambda (_tab30327_ _r30328_)
                (table-merge _r30328_ _tab30327_ '#t))
              _base-table30324_
              _rest30325_)))
  (define std/misc/hash#hash-merge/override!
    (lambda (_base-table30318_ . _rest30319_)
      (foldl1 (lambda (_tab30321_ _r30322_)
                (table-merge! _r30322_ _tab30321_ '#t))
              _base-table30318_
              _rest30319_)))
  (define std/misc/hash#hash->list/sort
    (lambda (_hash30312_ _pred30313_)
      (std/sort#sort
       (table->list _hash30312_)
       (lambda (_x30315_ _y30316_)
         (_pred30313_ (car _x30315_) (car _y30316_))))))
  (define std/misc/hash#hash-get-set! hash-put!)
  (define std/misc/hash#hash-ref-set!__1
    (lambda (_h30307_ _k30308_ __d30309_ _v30310_)
      (table-set! _h30307_ _k30308_ _v30310_)))
  (define std/misc/hash#hash-ref-set!
    (lambda _g304213_
      (let ((_g304212_ (let () (declare (not safe)) (##length _g304213_))))
        (cond ((let () (declare (not safe)) (##fx= _g304212_ 3))
               (apply table-set! _g304213_))
              ((let () (declare (not safe)) (##fx= _g304212_ 4))
               (apply std/misc/hash#hash-ref-set!__1 _g304213_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/hash#hash-ref-set!
                _g304213_)))))))
