(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/bio/file#file-input-buffer::t
    (make-struct-type
     'std/net/bio/file#file-input-buffer::t
     std/net/bio/input#input-buffer::t
     '1
     'file-input-buffer
     '((final: . #t))
     '#f
     '(fd)))
  (define std/net/bio/file#file-input-buffer?
    (make-struct-predicate std/net/bio/file#file-input-buffer::t))
  (define std/net/bio/file#make-file-input-buffer
    (lambda _$args179469_
      (apply make-struct-instance
             std/net/bio/file#file-input-buffer::t
             _$args179469_)))
  (define std/net/bio/file#file-input-buffer-fd
    (make-struct-field-accessor std/net/bio/file#file-input-buffer::t '0))
  (define std/net/bio/file#file-input-buffer-fd-set!
    (make-struct-field-mutator std/net/bio/file#file-input-buffer::t '0))
  (define std/net/bio/file#&file-input-buffer-fd
    (make-struct-field-unchecked-accessor
     std/net/bio/file#file-input-buffer::t
     '0))
  (define std/net/bio/file#&file-input-buffer-fd-set!
    (make-struct-field-unchecked-mutator
     std/net/bio/file#file-input-buffer::t
     '0))
  (define std/net/bio/file#open-file-input-buffer__%
    (lambda (_path179456_ _bufsz179457_)
      (std/net/bio/file#open-fd-input-buffer__%
       (std/os/fdio#open__0 _path179456_ std/os/fcntl#O_RDONLY)
       _bufsz179457_)))
  (define std/net/bio/file#open-file-input-buffer__0
    (lambda (_path179462_)
      (let ((_bufsz179464_ '4096))
        (std/net/bio/file#open-file-input-buffer__%
         _path179462_
         _bufsz179464_))))
  (define std/net/bio/file#open-file-input-buffer
    (lambda _g301140_
      (let ((_g301139_ (##length _g301140_)))
        (cond ((##fx= _g301139_ 1)
               (apply std/net/bio/file#open-file-input-buffer__0 _g301140_))
              ((##fx= _g301139_ 2)
               (apply std/net/bio/file#open-file-input-buffer__% _g301140_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/file#open-file-input-buffer
                _g301140_))))))
  (define std/net/bio/file#open-fd-input-buffer__%
    (lambda (_fd179442_ _bufsz179443_)
      (##structure
       std/net/bio/file#file-input-buffer::t
       (make-u8vector _bufsz179443_)
       '0
       '0
       std/net/bio/file#file-input-fill!
       std/net/bio/file#file-input-read
       _fd179442_)))
  (define std/net/bio/file#open-fd-input-buffer__0
    (lambda (_fd179448_)
      (let ((_bufsz179450_ '4096))
        (std/net/bio/file#open-fd-input-buffer__% _fd179448_ _bufsz179450_))))
  (define std/net/bio/file#open-fd-input-buffer
    (lambda _g301142_
      (let ((_g301141_ (##length _g301142_)))
        (cond ((##fx= _g301141_ 1)
               (apply std/net/bio/file#open-fd-input-buffer__0 _g301142_))
              ((##fx= _g301141_ 2)
               (apply std/net/bio/file#open-fd-input-buffer__% _g301142_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/file#open-fd-input-buffer
                _g301142_))))))
  (define std/net/bio/file#close-file-input-buffer
    (lambda (_buf179432_)
      (let ((_$e179434_
             (##unchecked-structure-ref
              _buf179432_
              '6
              std/net/bio/file#file-input-buffer::t
              '#f)))
        (if _$e179434_
            ((lambda (_fd179437_)
               (std/os/fdio#close _fd179437_)
               (##unchecked-structure-set!
                _buf179432_
                '#f
                '6
                std/net/bio/file#file-input-buffer::t
                '#f)
               (##unchecked-structure-set!
                _buf179432_
                (lambda _g301143_ '0)
                '4
                std/net/bio/input#input-buffer::t
                '#f)
               (##unchecked-structure-set!
                _buf179432_
                (lambda _g301144_ '0)
                '5
                std/net/bio/input#input-buffer::t
                '#f))
             _$e179434_)
            '#!void))))
  (define std/net/bio/file#file-input-fill!
    (lambda (_buf179413_ _need179414_)
      (let ((_bytes179416_
             (##unchecked-structure-ref
              _buf179413_
              '1
              std/net/bio/input#input-buffer::t
              '#f))
            (_rlo179417_
             (##unchecked-structure-ref
              _buf179413_
              '2
              std/net/bio/input#input-buffer::t
              '#f))
            (_rhi179418_
             (##unchecked-structure-ref
              _buf179413_
              '3
              std/net/bio/input#input-buffer::t
              '#f)))
        (if (##fx> _rlo179417_ '0)
            (if (##fx= _rlo179417_ _rhi179418_)
                (begin
                  (##unchecked-structure-set!
                   _buf179413_
                   '0
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (##unchecked-structure-set!
                   _buf179413_
                   '0
                   '3
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (std/net/bio/file#file-input-fill! _buf179413_ _need179414_))
                (begin
                  (##subu8vector-move!
                   _bytes179416_
                   _rlo179417_
                   _rhi179418_
                   _bytes179416_
                   '0)
                  (##unchecked-structure-set!
                   _buf179413_
                   '0
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (##unchecked-structure-set!
                   _buf179413_
                   (##fx- _rhi179418_ _rlo179417_)
                   '3
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (std/net/bio/file#file-input-fill!
                   _buf179413_
                   _need179414_)))
            (let ((_fd179420_
                   (##unchecked-structure-ref
                    _buf179413_
                    '6
                    std/net/bio/file#file-input-buffer::t
                    '#f)))
              (let _lp179422_ ((_rhi179424_ _rhi179418_)
                               (_want179425_ (##fx- _need179414_ _rhi179418_))
                               (_count179426_ '0))
                (let ((_rd179428_
                       (std/os/fdio#fdread__%
                        _fd179420_
                        _bytes179416_
                        _rhi179424_
                        (##u8vector-length _bytes179416_))))
                  (if _rd179428_
                      (let ((_rhi+rd179430_ (##fx+ _rhi179424_ _rd179428_)))
                        (##unchecked-structure-set!
                         _buf179413_
                         _rhi+rd179430_
                         '3
                         std/net/bio/input#input-buffer::t
                         '#f)
                        (if (##fx< _rd179428_ _want179425_)
                            (if (##fx> _rd179428_ '0)
                                (_lp179422_
                                 _rhi+rd179430_
                                 (##fx- _want179425_ _rd179428_)
                                 (##fx+ _count179426_ _rd179428_))
                                _count179426_)
                            (##fx+ _count179426_ _rd179428_)))
                      (begin
                        (if (std/os/fd#fd? _fd179420_)
                            (##wait-for-io!
                             (std/os/fd#fd-io-in _fd179420_)
                             '#t)
                            '#!void)
                        (_lp179422_
                         _rhi179424_
                         _want179425_
                         _count179426_))))))))))
  (define std/net/bio/file#file-input-read
    (lambda (_bytes179399_ _start179400_ _end179401_ _buf179402_)
      (let ((_fd179404_
             (##unchecked-structure-ref
              _buf179402_
              '6
              std/net/bio/file#file-input-buffer::t
              '#f)))
        (let _lp179406_ ((_count179408_ '0) (_start179409_ _start179400_))
          (if (##fx>= _start179409_ _end179401_)
              _count179408_
              (let ((_r179411_
                     (std/os/fdio#fdread__%
                      _fd179404_
                      _bytes179399_
                      _start179409_
                      _end179401_)))
                (if (not _r179411_)
                    (begin
                      (if (std/os/fd#fd? _fd179404_)
                          (##wait-for-io! (std/os/fd#fd-io-in _fd179404_) '#t)
                          '#!void)
                      (_lp179406_ _count179408_ _start179409_))
                    (if (##fxzero? _r179411_)
                        _count179408_
                        (_lp179406_
                         (##fx+ _count179408_ _r179411_)
                         (##fx+ _start179409_ _r179411_))))))))))
  (define std/net/bio/file#file-output-buffer::t
    (make-struct-type
     'std/net/bio/file#file-output-buffer::t
     std/net/bio/output#output-buffer::t
     '1
     'file-output-buffer
     '((final: . #t))
     '#f
     '(fd)))
  (define std/net/bio/file#file-output-buffer?
    (make-struct-predicate std/net/bio/file#file-output-buffer::t))
  (define std/net/bio/file#make-file-output-buffer
    (lambda _$args179396_
      (apply make-struct-instance
             std/net/bio/file#file-output-buffer::t
             _$args179396_)))
  (define std/net/bio/file#file-output-buffer-fd
    (make-struct-field-accessor std/net/bio/file#file-output-buffer::t '0))
  (define std/net/bio/file#file-output-buffer-fd-set!
    (make-struct-field-mutator std/net/bio/file#file-output-buffer::t '0))
  (define std/net/bio/file#&file-output-buffer-fd
    (make-struct-field-unchecked-accessor
     std/net/bio/file#file-output-buffer::t
     '0))
  (define std/net/bio/file#&file-output-buffer-fd-set!
    (make-struct-field-unchecked-mutator
     std/net/bio/file#file-output-buffer::t
     '0))
  (define std/net/bio/file#open-file-output-buffer__%__%
    (lambda (__179350179353_
             _flags179347179355_
             _mode179348179357_
             _path179359_
             _bufsz179360_)
      (let* ((_flags179362_
              (if (eq? _flags179347179355_ absent-value)
                  (fxior std/os/fcntl#O_WRONLY
                         std/os/fcntl#O_CREAT
                         std/os/fcntl#O_EXCL)
                  _flags179347179355_))
             (_mode179364_
              (if (eq? _mode179348179357_ absent-value)
                  '384
                  _mode179348179357_)))
        (std/net/bio/file#open-fd-output-buffer__%
         (std/os/fdio#open__% _path179359_ _flags179362_ _mode179364_)
         _bufsz179360_))))
  (define std/net/bio/file#open-file-output-buffer__%__0
    (lambda (__179350179369_
             _flags179347179370_
             _mode179348179371_
             _path179372_)
      (let ((_bufsz179374_ '4096))
        (std/net/bio/file#open-file-output-buffer__%__%
         __179350179369_
         _flags179347179370_
         _mode179348179371_
         _path179372_
         _bufsz179374_))))
  (define std/net/bio/file#open-file-output-buffer__%
    (lambda _g301146_
      (let ((_g301145_ (##length _g301146_)))
        (cond ((##fx= _g301145_ 4)
               (apply std/net/bio/file#open-file-output-buffer__%__0
                      _g301146_))
              ((##fx= _g301145_ 5)
               (apply std/net/bio/file#open-file-output-buffer__%__%
                      _g301146_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/file#open-file-output-buffer__%
                _g301146_))))))
  (define std/net/bio/file#open-file-output-buffer__@
    (lambda (_keys179346179385_ . _args179387_)
      (apply std/net/bio/file#open-file-output-buffer__%
             _keys179346179385_
             (table-ref _keys179346179385_ 'flags: absent-value)
             (table-ref _keys179346179385_ 'mode: absent-value)
             _args179387_)))
  (define std/net/bio/file#open-file-output-buffer
    (lambda _args179349179393_
      (apply keyword-dispatch
             '#(flags: mode: #f)
             std/net/bio/file#open-file-output-buffer__@
             _args179349179393_)))
  (define std/net/bio/file#open-fd-output-buffer__%
    (lambda (_fd179332_ _bufsz179333_)
      (##structure
       std/net/bio/file#file-output-buffer::t
       (make-u8vector _bufsz179333_)
       '0
       _bufsz179333_
       std/net/bio/file#file-output-drain!
       std/net/bio/file#file-output-write
       _fd179332_)))
  (define std/net/bio/file#open-fd-output-buffer__0
    (lambda (_fd179338_)
      (let ((_bufsz179340_ '4096))
        (std/net/bio/file#open-fd-output-buffer__% _fd179338_ _bufsz179340_))))
  (define std/net/bio/file#open-fd-output-buffer
    (lambda _g301148_
      (let ((_g301147_ (##length _g301148_)))
        (cond ((##fx= _g301147_ 1)
               (apply std/net/bio/file#open-fd-output-buffer__0 _g301148_))
              ((##fx= _g301147_ 2)
               (apply std/net/bio/file#open-fd-output-buffer__% _g301148_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/file#open-fd-output-buffer
                _g301148_))))))
  (define std/net/bio/file#close-file-output-buffer
    (lambda (_buf179322_)
      (let ((_$e179324_
             (##unchecked-structure-ref
              _buf179322_
              '6
              std/net/bio/file#file-output-buffer::t
              '#f)))
        (if _$e179324_
            ((lambda (_fd179327_)
               (std/os/fdio#close _fd179327_)
               (##unchecked-structure-set!
                _buf179322_
                '#f
                '6
                std/net/bio/file#file-output-buffer::t
                '#f)
               (##unchecked-structure-set!
                _buf179322_
                (lambda _g301149_ (error '"device is closed" _fd179327_))
                '4
                std/net/bio/output#output-buffer::t
                '#f)
               (##unchecked-structure-set!
                _buf179322_
                (lambda _g301150_ (error '"device is closed" _fd179327_))
                '5
                std/net/bio/output#output-buffer::t
                '#f))
             _$e179324_)
            '#!void))))
  (define std/net/bio/file#file-output-drain!
    (lambda (_buf179319_ _need179320_)
      (std/net/bio/file#file-output-write
       (##unchecked-structure-ref
        _buf179319_
        '1
        std/net/bio/output#output-buffer::t
        '#f)
       '0
       (##unchecked-structure-ref
        _buf179319_
        '2
        std/net/bio/output#output-buffer::t
        '#f)
       _buf179319_)
      (##unchecked-structure-set!
       _buf179319_
       '0
       '2
       std/net/bio/output#output-buffer::t
       '#f)))
  (define std/net/bio/file#file-output-write
    (lambda (_bytes179305_ _start179306_ _end179307_ _buf179308_)
      (let ((_fd179310_
             (##unchecked-structure-ref
              _buf179308_
              '6
              std/net/bio/file#file-output-buffer::t
              '#f)))
        (let _lp179312_ ((_count179314_ '0) (_start179315_ _start179306_))
          (if (##fx< _start179315_ _end179307_)
              (let ((_r179317_
                     (std/os/fdio#fdwrite__%
                      _fd179310_
                      _bytes179305_
                      _start179315_
                      _end179307_)))
                (if _r179317_
                    (_lp179312_
                     (##fx+ _count179314_ _r179317_)
                     (##fx+ _start179315_ _r179317_))
                    (begin
                      (if (std/os/fd#fd? _fd179310_)
                          (##wait-for-io! (std/os/fd#fd-io-out _fd179310_) '#t)
                          '#!void)
                      (_lp179312_ _count179314_ _start179315_))))
              _count179314_))))))
