(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/bio/input#input-buffer::t
    (make-struct-type
     'std/net/bio/input#input-buffer::t
     '#f
     '5
     'input-buffer
     '()
     '#f
     '(e rlo rhi fill read)))
  (define std/net/bio/input#input-buffer?
    (make-struct-predicate std/net/bio/input#input-buffer::t))
  (define std/net/bio/input#make-input-buffer
    (lambda _$args178318_
      (apply make-struct-instance
             std/net/bio/input#input-buffer::t
             _$args178318_)))
  (define std/net/bio/input#input-buffer-e
    (make-struct-field-accessor std/net/bio/input#input-buffer::t '0))
  (define std/net/bio/input#input-buffer-rlo
    (make-struct-field-accessor std/net/bio/input#input-buffer::t '1))
  (define std/net/bio/input#input-buffer-rhi
    (make-struct-field-accessor std/net/bio/input#input-buffer::t '2))
  (define std/net/bio/input#input-buffer-fill
    (make-struct-field-accessor std/net/bio/input#input-buffer::t '3))
  (define std/net/bio/input#input-buffer-read
    (make-struct-field-accessor std/net/bio/input#input-buffer::t '4))
  (define std/net/bio/input#input-buffer-e-set!
    (make-struct-field-mutator std/net/bio/input#input-buffer::t '0))
  (define std/net/bio/input#input-buffer-rlo-set!
    (make-struct-field-mutator std/net/bio/input#input-buffer::t '1))
  (define std/net/bio/input#input-buffer-rhi-set!
    (make-struct-field-mutator std/net/bio/input#input-buffer::t '2))
  (define std/net/bio/input#input-buffer-fill-set!
    (make-struct-field-mutator std/net/bio/input#input-buffer::t '3))
  (define std/net/bio/input#input-buffer-read-set!
    (make-struct-field-mutator std/net/bio/input#input-buffer::t '4))
  (define std/net/bio/input#&input-buffer-e
    (make-struct-field-unchecked-accessor
     std/net/bio/input#input-buffer::t
     '0))
  (define std/net/bio/input#&input-buffer-rlo
    (make-struct-field-unchecked-accessor
     std/net/bio/input#input-buffer::t
     '1))
  (define std/net/bio/input#&input-buffer-rhi
    (make-struct-field-unchecked-accessor
     std/net/bio/input#input-buffer::t
     '2))
  (define std/net/bio/input#&input-buffer-fill
    (make-struct-field-unchecked-accessor
     std/net/bio/input#input-buffer::t
     '3))
  (define std/net/bio/input#&input-buffer-read
    (make-struct-field-unchecked-accessor
     std/net/bio/input#input-buffer::t
     '4))
  (define std/net/bio/input#&input-buffer-e-set!
    (make-struct-field-unchecked-mutator std/net/bio/input#input-buffer::t '0))
  (define std/net/bio/input#&input-buffer-rlo-set!
    (make-struct-field-unchecked-mutator std/net/bio/input#input-buffer::t '1))
  (define std/net/bio/input#&input-buffer-rhi-set!
    (make-struct-field-unchecked-mutator std/net/bio/input#input-buffer::t '2))
  (define std/net/bio/input#&input-buffer-fill-set!
    (make-struct-field-unchecked-mutator std/net/bio/input#input-buffer::t '3))
  (define std/net/bio/input#&input-buffer-read-set!
    (make-struct-field-unchecked-mutator std/net/bio/input#input-buffer::t '4))
  (define std/net/bio/input#bio-input-fill!
    (lambda (_buf178315_ _need178316_)
      ((##unchecked-structure-ref
        _buf178315_
        '4
        std/net/bio/input#input-buffer::t
        '#f)
       _buf178315_
       _need178316_)))
  (define std/net/bio/input#bio-input-read
    (lambda (_bytes178310_ _start178311_ _end178312_ _buf178313_)
      ((##unchecked-structure-ref
        _buf178313_
        '5
        std/net/bio/input#input-buffer::t
        '#f)
       _bytes178310_
       _start178311_
       _end178312_
       _buf178313_)))
  (define std/net/bio/input#bio-read-u8
    (lambda (_buf178296_)
      (let ((_rlo178298_
             (##unchecked-structure-ref
              _buf178296_
              '2
              std/net/bio/input#input-buffer::t
              '#f))
            (_rhi178299_
             (##unchecked-structure-ref
              _buf178296_
              '3
              std/net/bio/input#input-buffer::t
              '#f)))
        (if (##fx< _rlo178298_ _rhi178299_)
            (let ((_u8178301_
                   (##u8vector-ref
                    (##unchecked-structure-ref
                     _buf178296_
                     '1
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _rlo178298_)))
              (##unchecked-structure-set!
               _buf178296_
               (##fx+ _rlo178298_ '1)
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _u8178301_)
            (let ((_rd178303_
                   (std/net/bio/input#bio-input-fill! _buf178296_ '1)))
              (if (##fxzero? _rd178303_)
                  (eof-object)
                  (let* ((_rlo178305_
                          (##unchecked-structure-ref
                           _buf178296_
                           '2
                           std/net/bio/input#input-buffer::t
                           '#f))
                         (_u8178307_
                          (##u8vector-ref
                           (##unchecked-structure-ref
                            _buf178296_
                            '1
                            std/net/bio/input#input-buffer::t
                            '#f)
                           _rlo178305_)))
                    (##unchecked-structure-set!
                     _buf178296_
                     (##fx+ _rlo178305_ '1)
                     '2
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _u8178307_)))))))
  (define std/net/bio/input#bio-peek-u8
    (lambda (_buf178287_)
      (let ((_rlo178289_
             (##unchecked-structure-ref
              _buf178287_
              '2
              std/net/bio/input#input-buffer::t
              '#f))
            (_rhi178290_
             (##unchecked-structure-ref
              _buf178287_
              '3
              std/net/bio/input#input-buffer::t
              '#f)))
        (if (##fx< _rlo178289_ _rhi178290_)
            (##u8vector-ref
             (##unchecked-structure-ref
              _buf178287_
              '1
              std/net/bio/input#input-buffer::t
              '#f)
             _rlo178289_)
            (let ((_rd178292_
                   (std/net/bio/input#bio-input-fill! _buf178287_ '1)))
              (if (##fxzero? _rd178292_)
                  (eof-object)
                  (let ((_rlo178294_
                         (##unchecked-structure-ref
                          _buf178287_
                          '2
                          std/net/bio/input#input-buffer::t
                          '#f)))
                    (##u8vector-ref
                     (##unchecked-structure-ref
                      _buf178287_
                      '1
                      std/net/bio/input#input-buffer::t
                      '#f)
                     _rlo178294_))))))))
  (define std/net/bio/input#bio-read-subu8vector
    (lambda (_bytes178264_ _start178265_ _end178266_ _buf178267_)
      (let* ((_rlo178269_
              (##unchecked-structure-ref
               _buf178267_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178271_
              (##unchecked-structure-ref
               _buf178267_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_need178273_ (##fx- _end178266_ _start178265_))
             (_rlo+need178275_ (##fx+ _rlo178269_ _need178273_)))
        (if (##fx<= _rlo+need178275_ _rhi178271_)
            (begin
              (##subu8vector-move!
               (##unchecked-structure-ref
                _buf178267_
                '1
                std/net/bio/input#input-buffer::t
                '#f)
               _rlo178269_
               _rlo+need178275_
               _bytes178264_
               _start178265_)
              (##unchecked-structure-set!
               _buf178267_
               _rlo+need178275_
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _need178273_)
            (if (##fx< _rlo178269_ _rhi178271_)
                (begin
                  (##subu8vector-move!
                   (##unchecked-structure-ref
                    _buf178267_
                    '1
                    std/net/bio/input#input-buffer::t
                    '#f)
                   _rlo178269_
                   _rhi178271_
                   _bytes178264_
                   _start178265_)
                  (##unchecked-structure-set!
                   _buf178267_
                   _rhi178271_
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (let* ((_have178278_ (##fx- _rhi178271_ _rlo178269_))
                         (_need178280_ (##fx- _need178273_ _have178278_)))
                    (if (##fx< _need178280_
                               (##u8vector-length
                                (##unchecked-structure-ref
                                 _buf178267_
                                 '1
                                 std/net/bio/input#input-buffer::t
                                 '#f)))
                        (let ((_rd178283_
                               (std/net/bio/input#bio-input-fill!
                                _buf178267_
                                _need178280_)))
                          (if (##fx> _rd178283_ '0)
                              (##fx+ _have178278_
                                     (std/net/bio/input#bio-read-subu8vector
                                      _bytes178264_
                                      (##fx+ _start178265_ _have178278_)
                                      _end178266_
                                      _buf178267_))
                              _have178278_))
                        (##fx+ _have178278_
                               (std/net/bio/input#bio-input-read
                                _bytes178264_
                                (##fx+ _start178265_ _have178278_)
                                _end178266_
                                _buf178267_)))))
                (if (##fx< _need178273_
                           (##u8vector-length
                            (##unchecked-structure-ref
                             _buf178267_
                             '1
                             std/net/bio/input#input-buffer::t
                             '#f)))
                    (let ((_rd178285_
                           (std/net/bio/input#bio-input-fill!
                            _buf178267_
                            _need178273_)))
                      (if (##fx> _rd178285_ '0)
                          (std/net/bio/input#bio-read-subu8vector
                           _bytes178264_
                           _start178265_
                           _end178266_
                           _buf178267_)
                          '0))
                    (std/net/bio/input#bio-input-read
                     _bytes178264_
                     _start178265_
                     _end178266_
                     _buf178267_)))))))
  (define std/net/bio/input#bio-read-subu8vector*__%
    (lambda (_bytes178225_ _start178226_ _end178227_ _buf178228_ _need178229_)
      (let* ((_rlo178231_
              (##unchecked-structure-ref
               _buf178228_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178233_
              (##unchecked-structure-ref
               _buf178228_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_have178235_ (##fx- _rhi178233_ _rlo178231_))
             (_want178237_ (##fx- _end178227_ _start178226_))
             (_need178239_ (##fxmin _want178237_ _need178229_))
             (_copy178241_ (##fxmin _want178237_ _have178235_)))
        (if (##fx> _copy178241_ '0)
            (let ((_rlo+copy178244_ (##fx+ _rlo178231_ _copy178241_)))
              (##subu8vector-move!
               (##unchecked-structure-ref
                _buf178228_
                '1
                std/net/bio/input#input-buffer::t
                '#f)
               _rlo178231_
               _rlo+copy178244_
               _bytes178225_
               _start178226_)
              (##unchecked-structure-set!
               _buf178228_
               _rlo+copy178244_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
            '#!void)
        (if (##fx>= _copy178241_ _need178239_)
            _copy178241_
            (let ((_rd178246_
                   (std/net/bio/input#bio-input-fill! _buf178228_ '1)))
              (if (##fx> _rd178246_ '0)
                  (std/net/bio/input#bio-read-subu8vector*__%
                   _bytes178225_
                   (##fx+ _start178226_ _copy178241_)
                   _end178227_
                   _buf178228_
                   (##fx- _need178239_ _copy178241_))
                  _copy178241_))))))
  (define std/net/bio/input#bio-read-subu8vector*__0
    (lambda (_bytes178251_ _start178252_ _end178253_ _buf178254_)
      (let ((_need178256_ '0))
        (std/net/bio/input#bio-read-subu8vector*__%
         _bytes178251_
         _start178252_
         _end178253_
         _buf178254_
         _need178256_))))
  (define std/net/bio/input#bio-read-subu8vector*
    (lambda _g290394_
      (let ((_g290393_ (##length _g290394_)))
        (cond ((##fx= _g290393_ 4)
               (apply std/net/bio/input#bio-read-subu8vector*__0 _g290394_))
              ((##fx= _g290393_ 5)
               (apply std/net/bio/input#bio-read-subu8vector*__% _g290394_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/input#bio-read-subu8vector*
                _g290394_))))))
  (define std/net/bio/input#bio-read-subu8vector-unbuffered
    (lambda (_bytes178208_ _start178209_ _end178210_ _buf178211_)
      (let* ((_need178213_ (##fx- _end178210_ _start178209_))
             (_rlo178215_
              (##unchecked-structure-ref
               _buf178211_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178217_
              (##unchecked-structure-ref
               _buf178211_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_rlo+need178219_ (##fx+ _rlo178215_ _need178213_)))
        (if (##fx<= _rlo+need178219_ _rhi178217_)
            (begin
              (##subu8vector-move!
               (##unchecked-structure-ref
                _buf178211_
                '1
                std/net/bio/input#input-buffer::t
                '#f)
               _rlo178215_
               _rlo+need178219_
               _bytes178208_
               _start178209_)
              (##unchecked-structure-set!
               _buf178211_
               _rlo+need178219_
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _need178213_)
            (if (##fx< _rlo178215_ _rhi178217_)
                (let ((_have178222_ (##fx- _rhi178217_ _rlo178215_)))
                  (##subu8vector-move!
                   (##unchecked-structure-ref
                    _buf178211_
                    '1
                    std/net/bio/input#input-buffer::t
                    '#f)
                   _rlo178215_
                   _rhi178217_
                   _bytes178208_
                   _start178209_)
                  (##unchecked-structure-set!
                   _buf178211_
                   _rhi178217_
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (##fx+ _have178222_
                         (std/net/bio/input#bio-input-read
                          _bytes178208_
                          (##fx+ _start178209_ _have178222_)
                          _end178210_
                          _buf178211_)))
                (std/net/bio/input#bio-input-read
                 _bytes178208_
                 _start178209_
                 _end178210_
                 _buf178211_))))))
  (define std/net/bio/input#bio-read-bytes
    (lambda (_bytes178200_ _buf178201_)
      (let* ((_len178203_ (u8vector-length _bytes178200_))
             (_rd178205_
              (std/net/bio/input#bio-read-subu8vector
               _bytes178200_
               '0
               _len178203_
               _buf178201_)))
        (if (##fx= _rd178205_ _len178203_)
            '#!void
            (std/error#raise-io-error
             'bio-read-bytes
             '"premature end of input"
             _buf178201_
             _rd178205_
             _len178203_)))))
  (define std/net/bio/input#bio-read-bytes-unbuffered
    (lambda (_bytes178192_ _buf178193_)
      (let* ((_len178195_ (u8vector-length _bytes178192_))
             (_rd178197_
              (std/net/bio/input#bio-read-subu8vector-unbuffered
               _bytes178192_
               '0
               _len178195_
               _buf178193_)))
        (if (##fx= _rd178197_ _len178195_)
            '#!void
            (std/error#raise-io-error
             'bio-read-bytes
             '"premature end of input"
             _buf178193_
             _rd178197_
             _len178195_)))))
  (define std/net/bio/input#bio-read-u32
    (lambda (_buf178171_)
      (let* ((_rlo178173_
              (##unchecked-structure-ref
               _buf178171_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178175_
              (##unchecked-structure-ref
               _buf178171_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_rlo+4178177_ (##fx+ _rlo178173_ '4)))
        (if (##fx<= _rlo+4178177_ _rhi178175_)
            (let ((_u32178180_
                   (std/net/bio/input#bio-get-u32
                    (##unchecked-structure-ref
                     _buf178171_
                     '1
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _rlo178173_)))
              (##unchecked-structure-set!
               _buf178171_
               _rlo+4178177_
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _u32178180_)
            (let* ((_g290395_
                    (std/net/bio/input#bio-input-fill! _buf178171_ '4))
                   (_rlo178183_
                    (##unchecked-structure-ref
                     _buf178171_
                     '2
                     std/net/bio/input#input-buffer::t
                     '#f))
                   (_rhi178185_
                    (##unchecked-structure-ref
                     _buf178171_
                     '3
                     std/net/bio/input#input-buffer::t
                     '#f))
                   (_rlo+4178187_ (##fx+ _rlo178183_ '4)))
              (if (##fx<= _rlo+4178187_ _rhi178185_)
                  (let ((_u32178190_
                         (std/net/bio/input#bio-get-u32
                          (##unchecked-structure-ref
                           _buf178171_
                           '1
                           std/net/bio/input#input-buffer::t
                           '#f)
                          _rlo178183_)))
                    (##unchecked-structure-set!
                     _buf178171_
                     _rlo+4178187_
                     '2
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _u32178190_)
                  (std/error#raise-io-error
                   'bio-read-u32
                   '"Premature end of input"
                   _buf178171_
                   _rlo178183_
                   _rhi178185_)))))))
  (define std/net/bio/input#bio-get-u32
    (lambda (_u8v178163_ _start178164_)
      (let ((_$e178166_
             (##fxarithmetic-shift-left?
              (##u8vector-ref _u8v178163_ _start178164_)
              '24)))
        (if _$e178166_
            ((lambda (_bits178169_)
               (##fxior _bits178169_
                        (##fxarithmetic-shift-left
                         (##u8vector-ref _u8v178163_ (##fx+ _start178164_ '1))
                         '16)
                        (##fxarithmetic-shift-left
                         (##u8vector-ref _u8v178163_ (##fx+ _start178164_ '2))
                         '8)
                        (##u8vector-ref _u8v178163_ (##fx+ _start178164_ '3))))
             _$e178166_)
            (bitwise-ior
             (arithmetic-shift (##u8vector-ref _u8v178163_ _start178164_) '24)
             (##fxarithmetic-shift-left
              (##u8vector-ref _u8v178163_ (##fx+ _start178164_ '1))
              '16)
             (##fxarithmetic-shift-left
              (##u8vector-ref _u8v178163_ (##fx+ _start178164_ '2))
              '8)
             (##u8vector-ref _u8v178163_ (##fx+ _start178164_ '3)))))))
  (define std/net/bio/input#2^31 (expt '2 '31))
  (define std/net/bio/input#2^32 (expt '2 '32))
  (define std/net/bio/input#bio-read-s32
    (lambda (_buf178159_)
      (let ((_u32178161_ (std/net/bio/input#bio-read-u32 _buf178159_)))
        (if (> _u32178161_ std/net/bio/input#2^31)
            (- _u32178161_ std/net/bio/input#2^32)
            _u32178161_))))
  (define std/net/bio/input#bio-read-u16
    (lambda (_buf178138_)
      (let* ((_rlo178140_
              (##unchecked-structure-ref
               _buf178138_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178142_
              (##unchecked-structure-ref
               _buf178138_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_rlo+2178144_ (##fx+ _rlo178140_ '2)))
        (if (##fx<= _rlo+2178144_ _rhi178142_)
            (let ((_u16178147_
                   (std/net/bio/input#bio-get-u16
                    (##unchecked-structure-ref
                     _buf178138_
                     '1
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _rlo178140_)))
              (##unchecked-structure-set!
               _buf178138_
               _rlo+2178144_
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _u16178147_)
            (let* ((_g290396_
                    (std/net/bio/input#bio-input-fill! _buf178138_ '2))
                   (_rlo178150_
                    (##unchecked-structure-ref
                     _buf178138_
                     '2
                     std/net/bio/input#input-buffer::t
                     '#f))
                   (_rhi178152_
                    (##unchecked-structure-ref
                     _buf178138_
                     '3
                     std/net/bio/input#input-buffer::t
                     '#f))
                   (_rlo+2178154_ (##fx+ _rlo178150_ '2)))
              (if (##fx<= _rlo+2178154_ _rhi178152_)
                  (let ((_u16178157_
                         (std/net/bio/input#bio-get-u16
                          (##unchecked-structure-ref
                           _buf178138_
                           '1
                           std/net/bio/input#input-buffer::t
                           '#f)
                          _rlo178150_)))
                    (##unchecked-structure-set!
                     _buf178138_
                     _rlo+2178154_
                     '2
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _u16178157_)
                  (std/error#raise-io-error
                   'bio-read-u16
                   '"Premature end of input"
                   _buf178138_
                   _rlo178150_
                   _rhi178152_)))))))
  (define std/net/bio/input#bio-get-u16
    (lambda (_u8v178135_ _start178136_)
      (##fxior (##fxarithmetic-shift-left
                (##u8vector-ref _u8v178135_ _start178136_)
                '8)
               (##u8vector-ref _u8v178135_ (##fx+ _start178136_ '1)))))
  (define std/net/bio/input#2^15 (expt '2 '15))
  (define std/net/bio/input#2^16 (expt '2 '16))
  (define std/net/bio/input#bio-read-s16
    (lambda (_buf178131_)
      (let ((_u16178133_ (std/net/bio/input#bio-read-u16 _buf178131_)))
        (if (##fx> _u16178133_ std/net/bio/input#2^15)
            (##fx- _u16178133_ std/net/bio/input#2^16)
            _u16178133_))))
  (define std/net/bio/input#bio-read-char
    (lambda (_buf178098_)
      (letrec ((_fill+recur!178100_
                (lambda (_need178127_)
                  (let ((_rd178129_
                         (std/net/bio/input#bio-input-fill!
                          _buf178098_
                          _need178127_)))
                    (if (##fxzero? _rd178129_)
                        (std/error#raise-io-error
                         'bio-read-char
                         '"Incomplete character"
                         _buf178098_)
                        (std/net/bio/input#bio-read-char _buf178098_)))))
               (_get-byte178101_
                (lambda (_i178125_)
                  (##u8vector-ref
                   (##unchecked-structure-ref
                    _buf178098_
                    '1
                    std/net/bio/input#input-buffer::t
                    '#f)
                   _i178125_))))
        (let ((_rlo178103_
               (##unchecked-structure-ref
                _buf178098_
                '2
                std/net/bio/input#input-buffer::t
                '#f))
              (_rhi178104_
               (##unchecked-structure-ref
                _buf178098_
                '3
                std/net/bio/input#input-buffer::t
                '#f)))
          (if (##fx< _rlo178103_ _rhi178104_)
              (let ((_byte178106_ (_get-byte178101_ _rlo178103_)))
                (if (##fx<= _byte178106_ '127)
                    (begin
                      (##unchecked-structure-set!
                       _buf178098_
                       (##fx+ _rlo178103_ '1)
                       '2
                       std/net/bio/input#input-buffer::t
                       '#f)
                      (##integer->char _byte178106_))
                    (if (##fx<= _byte178106_ '223)
                        (let ((_rlo+1178108_ (##fx+ _rlo178103_ '1)))
                          (if (##fx< _rlo+1178108_ _rhi178104_)
                              (let ((_byte2178110_
                                     (_get-byte178101_ _rlo+1178108_)))
                                (##unchecked-structure-set!
                                 _buf178098_
                                 (##fx+ _rlo178103_ '2)
                                 '2
                                 std/net/bio/input#input-buffer::t
                                 '#f)
                                (##integer->char
                                 (##fxior (##fxarithmetic-shift-left
                                           (##fxand _byte178106_ '31)
                                           '6)
                                          (##fxand _byte2178110_ '63))))
                              (_fill+recur!178100_ '2)))
                        (if (##fx<= _byte178106_ '239)
                            (let ((_rlo+2178112_ (##fx+ _rlo178103_ '2)))
                              (if (##fx< _rlo+2178112_ _rhi178104_)
                                  (let ((_byte2178114_
                                         (_get-byte178101_
                                          (##fx+ _rlo178103_ '1)))
                                        (_byte3178115_
                                         (_get-byte178101_ _rlo+2178112_)))
                                    (##unchecked-structure-set!
                                     _buf178098_
                                     (##fx+ _rlo178103_ '3)
                                     '2
                                     std/net/bio/input#input-buffer::t
                                     '#f)
                                    (##integer->char
                                     (##fxior (##fxarithmetic-shift-left
                                               (##fxand _byte178106_ '15)
                                               '12)
                                              (##fxarithmetic-shift-left
                                               (##fxand _byte2178114_ '63)
                                               '6)
                                              (##fxand _byte3178115_ '63))))
                                  (_fill+recur!178100_ '3)))
                            (if (##fx<= _byte178106_ '244)
                                (let ((_rlo+3178117_ (##fx+ _rlo178103_ '3)))
                                  (if (##fx< _rlo+3178117_ _rhi178104_)
                                      (let ((_byte2178119_
                                             (_get-byte178101_
                                              (##fx+ _rlo178103_ '1)))
                                            (_byte3178120_
                                             (_get-byte178101_
                                              (##fx+ _rlo178103_ '2)))
                                            (_byte4178121_
                                             (_get-byte178101_ _rlo+3178117_)))
                                        (##unchecked-structure-set!
                                         _buf178098_
                                         (##integer->char
                                          (##fxior (##fxarithmetic-shift-left
                                                    (##fxand _byte178106_ '7)
                                                    '18)
                                                   (##fxarithmetic-shift-left
                                                    (##fxand _byte2178119_ '63)
                                                    '12)
                                                   (##fxarithmetic-shift-left
                                                    (##fxand _byte3178120_ '63)
                                                    '6)
                                                   (##fxand _byte4178121_
                                                            '63)))
                                         '2
                                         std/net/bio/input#input-buffer::t
                                         '#f))
                                      (_fill+recur!178100_ '4)))
                                (begin
                                  (##unchecked-structure-set!
                                   _buf178098_
                                   (##fx+ _rlo178103_ '1)
                                   '2
                                   std/net/bio/input#input-buffer::t
                                   '#f)
                                  '#\�))))))
              (let ((_rd178123_
                     (std/net/bio/input#bio-input-fill! _buf178098_ '1)))
                (if (##fxzero? _rd178123_)
                    (eof-object)
                    (std/net/bio/input#bio-read-char _buf178098_))))))))
  (define std/net/bio/input#bio-read-substring
    (lambda (_str178086_ _start178087_ _end178088_ _buf178089_)
      (let _lp178091_ ((_i178093_ _start178087_) (_count178094_ '0))
        (if (##fx< _i178093_ _end178088_)
            (let ((_char178096_ (std/net/bio/input#bio-read-char _str178086_)))
              (if (eof-object? _char178096_)
                  _count178094_
                  (begin
                    (##string-set! _str178086_ _i178093_ _char178096_)
                    (_lp178091_
                     (##fx+ _start178087_ '1)
                     (##fx+ _count178094_ '1)))))
            _count178094_))))
  (define std/net/bio/input#bio-read-string
    (lambda (_str178076_ _start178077_ _end178078_ _buf178079_)
      (let* ((_len178081_ (string-length _str178076_))
             (_rd178083_
              (std/net/bio/input#bio-read-substring
               _str178076_
               '0
               _len178081_
               _buf178079_)))
        (if (##fx= _rd178083_ _len178081_)
            '#!void
            (std/error#raise-io-error
             'bio-read-string
             '"premature end of input"
             _buf178079_
             _rd178083_
             _len178081_)))))
  (define std/net/bio/input#bio-read-line__%
    (lambda (_buf178026_ _sep178027_ _include-sep?178028_ _maxchars178029_)
      (let ((_root178031_ (cons '#f '())))
        (let _lp178033_ ((_tl178035_ _root178031_) (_count178036_ '0))
          (if (or (not _maxchars178029_)
                  (##fx< _count178036_ _maxchars178029_))
              (let ((_char178041_
                     (std/net/bio/input#bio-read-char _buf178026_)))
                (if (eof-object? _char178041_)
                    (if (null? (cdr _root178031_))
                        (eof-object)
                        (list->string (cdr _root178031_)))
                    (if (eq? _char178041_ _sep178027_)
                        (list->string
                         (if _include-sep?178028_
                             (let ((_tl*178043_ (cons _char178041_ '())))
                               (set-cdr! _tl178035_ _tl*178043_)
                               (cdr _root178031_))
                             (cdr _root178031_)))
                        (let ((_tl*178045_ (cons _char178041_ '())))
                          (set-cdr! _tl178035_ _tl*178045_)
                          (_lp178033_ _tl*178045_ (##fx+ _count178036_ '1))))))
              (list->string (cdr _root178031_)))))))
  (define std/net/bio/input#bio-read-line__0
    (lambda (_buf178050_)
      (let* ((_sep178052_ '#\newline)
             (_include-sep?178054_ '#f)
             (_maxchars178056_ '#f))
        (std/net/bio/input#bio-read-line__%
         _buf178050_
         _sep178052_
         _include-sep?178054_
         _maxchars178056_))))
  (define std/net/bio/input#bio-read-line__1
    (lambda (_buf178058_ _sep178059_)
      (let* ((_include-sep?178061_ '#f) (_maxchars178063_ '#f))
        (std/net/bio/input#bio-read-line__%
         _buf178058_
         _sep178059_
         _include-sep?178061_
         _maxchars178063_))))
  (define std/net/bio/input#bio-read-line__2
    (lambda (_buf178065_ _sep178066_ _include-sep?178067_)
      (let ((_maxchars178069_ '#f))
        (std/net/bio/input#bio-read-line__%
         _buf178065_
         _sep178066_
         _include-sep?178067_
         _maxchars178069_))))
  (define std/net/bio/input#bio-read-line
    (lambda _g290398_
      (let ((_g290397_ (##length _g290398_)))
        (cond ((##fx= _g290397_ 1)
               (apply std/net/bio/input#bio-read-line__0 _g290398_))
              ((##fx= _g290397_ 2)
               (apply std/net/bio/input#bio-read-line__1 _g290398_))
              ((##fx= _g290397_ 3)
               (apply std/net/bio/input#bio-read-line__2 _g290398_))
              ((##fx= _g290397_ 4)
               (apply std/net/bio/input#bio-read-line__% _g290398_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/input#bio-read-line
                _g290398_))))))
  (define std/net/bio/input#bio-input-utf8-decode
    (lambda (_count178013_ _buf178014_)
      (let* ((_rlo178016_
              (##unchecked-structure-ref
               _buf178014_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178018_
              (##unchecked-structure-ref
               _buf178014_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_rlo+count178020_ (##fx+ _rlo178016_ _count178013_)))
        (if (##fx<= _rlo+count178020_ _rhi178018_)
            (let ((_str178023_
                   (std/text/utf8#utf8-decode
                    (##unchecked-structure-ref
                     _buf178014_
                     '1
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _rlo178016_
                    _rlo+count178020_)))
              (##unchecked-structure-set!
               _buf178014_
               _rlo+count178020_
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _str178023_)
            (std/error#raise-io-error
             'bio-input-utf8-decode
             '"not enough bytes"
             _buf178014_
             _count178013_)))))
  (define std/net/bio/input#bio-input-skip
    (lambda (_count177993_ _buf177994_)
      (let _lp177996_ ((_count177998_ _count177993_))
        (let* ((_rlo178000_
                (##unchecked-structure-ref
                 _buf177994_
                 '2
                 std/net/bio/input#input-buffer::t
                 '#f))
               (_rhi178002_
                (##unchecked-structure-ref
                 _buf177994_
                 '3
                 std/net/bio/input#input-buffer::t
                 '#f))
               (_have178004_ (##fx- _rhi178002_ _rlo178000_)))
          (if (##fx< _have178004_ _count177998_)
              (let ((_need178007_ (##fx- _count177998_ _have178004_)))
                (##unchecked-structure-set!
                 _buf177994_
                 _rhi178002_
                 '2
                 std/net/bio/input#input-buffer::t
                 '#f)
                (let ((_rd178009_
                       (std/net/bio/input#bio-input-fill!
                        _buf177994_
                        _need178007_)))
                  (if (##fxzero? _rd178009_)
                      (std/error#raise-io-error
                       'bio-input-skip
                       '"premature end of input"
                       _buf177994_
                       _count177998_)
                      (_lp177996_ _need178007_))))
              (let ((_rlo+count178011_ (##fx+ _rlo178000_ _count177998_)))
                (##unchecked-structure-set!
                 _buf177994_
                 _rlo+count178011_
                 '2
                 std/net/bio/input#input-buffer::t
                 '#f)))))))
  (define std/net/bio/input#bio-input-count
    (lambda (_buf177988_)
      (let ((_rlo177990_
             (##unchecked-structure-ref
              _buf177988_
              '2
              std/net/bio/input#input-buffer::t
              '#f))
            (_rhi177991_
             (##unchecked-structure-ref
              _buf177988_
              '3
              std/net/bio/input#input-buffer::t
              '#f)))
        (##fx- _rhi177991_ _rlo177990_)))))
