(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/httpd/file#open-flags
    (if std/os/fcntl#O_NOATIME
        (fxior std/os/fcntl#O_RDONLY std/os/fcntl#O_NOATIME)
        std/os/fcntl#O_RDONLY))
  (define std/net/httpd/file#http-response-file
    (lambda (_res208064_ _headers208065_ _path208066_)
      (let ((_file208068_
             (std/os/fdio#open__0 _path208066_ std/net/httpd/file#open-flags)))
        (with-unwind-protect
         (lambda ()
           (std/net/httpd/file#http-response-write-file
            _res208064_
            _headers208065_
            _file208068_))
         (lambda () (close-port _file208068_))))))
  (define std/net/httpd/file#http-response-write-file
    (lambda (_res208053_ _headers208054_ _file208055_)
      (let ((_buf208057_ (std/net/httpd/file#get-file-buffer)))
        (std/net/httpd/handler#http-response-begin
         _res208053_
         '200
         _headers208054_)
        (let _lp208059_ ()
          (let ((_rd208062_ (std/os/fdio#fdread__0 _file208055_ _buf208057_)))
            (if (not _rd208062_)
                (begin
                  (std/event#wait__0 (std/os/fd#fd-io-in _file208055_))
                  (_lp208059_))
                (if (fx= _rd208062_ '0)
                    (begin
                      (std/net/httpd/file#put-file-buffer _buf208057_)
                      (std/net/httpd/handler#http-response-end _res208053_))
                    (begin
                      (std/net/httpd/handler#http-response-chunk__%
                       _res208053_
                       _buf208057_
                       '0
                       _rd208062_)
                      (_lp208059_)))))))))
  (define std/net/httpd/file#buffer-cache '())
  (define std/net/httpd/file#get-file-buffer
    (lambda ()
      (declare (not interrupts-enabled))
      (if (##pair? std/net/httpd/file#buffer-cache)
          (let ((_buf208051_ (##car std/net/httpd/file#buffer-cache)))
            (set! std/net/httpd/file#buffer-cache
                  (##cdr std/net/httpd/file#buffer-cache))
            _buf208051_)
          (make-u8vector '8192))))
  (define std/net/httpd/file#put-file-buffer
    (lambda (_buf208046_)
      (declare (not interrupts-enabled))
      (set! std/net/httpd/file#buffer-cache
            (##cons _buf208046_ std/net/httpd/file#buffer-cache)))))
