(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/socket/buffer#default-buffer-size '4096)
  (define std/net/socket/buffer#ssocket-input-buffer::t
    (make-struct-type
     'std/net/socket/buffer#ssocket-input-buffer::t
     std/net/bio/input#input-buffer::t
     '2
     'ssocket-input-buffer
     '((final: . #t))
     '#f
     '(sock timeo)))
  (define std/net/socket/buffer#ssocket-input-buffer?
    (make-struct-predicate std/net/socket/buffer#ssocket-input-buffer::t))
  (define std/net/socket/buffer#make-ssocket-input-buffer
    (lambda _$args202578_
      (apply make-struct-instance
             std/net/socket/buffer#ssocket-input-buffer::t
             _$args202578_)))
  (define std/net/socket/buffer#ssocket-input-buffer-sock
    (make-struct-field-accessor
     std/net/socket/buffer#ssocket-input-buffer::t
     '0))
  (define std/net/socket/buffer#ssocket-input-buffer-timeo
    (make-struct-field-accessor
     std/net/socket/buffer#ssocket-input-buffer::t
     '1))
  (define std/net/socket/buffer#ssocket-input-buffer-sock-set!
    (make-struct-field-mutator
     std/net/socket/buffer#ssocket-input-buffer::t
     '0))
  (define std/net/socket/buffer#ssocket-input-buffer-timeo-set!
    (make-struct-field-mutator
     std/net/socket/buffer#ssocket-input-buffer::t
     '1))
  (define std/net/socket/buffer#&ssocket-input-buffer-sock
    (make-struct-field-unchecked-accessor
     std/net/socket/buffer#ssocket-input-buffer::t
     '0))
  (define std/net/socket/buffer#&ssocket-input-buffer-timeo
    (make-struct-field-unchecked-accessor
     std/net/socket/buffer#ssocket-input-buffer::t
     '1))
  (define std/net/socket/buffer#&ssocket-input-buffer-sock-set!
    (make-struct-field-unchecked-mutator
     std/net/socket/buffer#ssocket-input-buffer::t
     '0))
  (define std/net/socket/buffer#&ssocket-input-buffer-timeo-set!
    (make-struct-field-unchecked-mutator
     std/net/socket/buffer#ssocket-input-buffer::t
     '1))
  (define std/net/socket/buffer#open-ssocket-input-buffer__%
    (lambda (_ssock202565_ _size202566_)
      (##structure
       std/net/socket/buffer#ssocket-input-buffer::t
       (make-u8vector _size202566_)
       '0
       '0
       std/net/socket/buffer#ssocket-input-fill!
       std/net/socket/buffer#ssocket-input-read
       _ssock202565_
       '#f)))
  (define std/net/socket/buffer#open-ssocket-input-buffer__0
    (lambda (_ssock202571_)
      (let ((_size202573_ std/net/socket/buffer#default-buffer-size))
        (std/net/socket/buffer#open-ssocket-input-buffer__%
         _ssock202571_
         _size202573_))))
  (define std/net/socket/buffer#open-ssocket-input-buffer
    (lambda _g309489_
      (let ((_g309488_ (##length _g309489_)))
        (cond ((##fx= _g309488_ 1)
               (apply std/net/socket/buffer#open-ssocket-input-buffer__0
                      _g309489_))
              ((##fx= _g309488_ 2)
               (apply std/net/socket/buffer#open-ssocket-input-buffer__%
                      _g309489_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/buffer#open-ssocket-input-buffer
                _g309489_))))))
  (define std/net/socket/buffer#ssocket-input-fill!
    (lambda (_buf202543_ _need202544_)
      (let ((_bytes202546_
             (##unchecked-structure-ref
              _buf202543_
              '1
              std/net/bio/input#input-buffer::t
              '#f))
            (_rlo202547_
             (##unchecked-structure-ref
              _buf202543_
              '2
              std/net/bio/input#input-buffer::t
              '#f))
            (_rhi202548_
             (##unchecked-structure-ref
              _buf202543_
              '3
              std/net/bio/input#input-buffer::t
              '#f)))
        (if (##fx> _rlo202547_ '0)
            (if (##fx= _rlo202547_ _rhi202548_)
                (begin
                  (##unchecked-structure-set!
                   _buf202543_
                   '0
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (##unchecked-structure-set!
                   _buf202543_
                   '0
                   '3
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (std/net/socket/buffer#ssocket-input-fill!
                   _buf202543_
                   _need202544_))
                (begin
                  (##subu8vector-move!
                   _bytes202546_
                   _rlo202547_
                   _rhi202548_
                   _bytes202546_
                   '0)
                  (##unchecked-structure-set!
                   _buf202543_
                   '0
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (##unchecked-structure-set!
                   _buf202543_
                   (##fx- _rhi202548_ _rlo202547_)
                   '3
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (std/net/socket/buffer#ssocket-input-fill!
                   _buf202543_
                   _need202544_)))
            (let ((_sock202550_
                   (##unchecked-structure-ref
                    _buf202543_
                    '6
                    std/net/socket/buffer#ssocket-input-buffer::t
                    '#f))
                  (_timeo202551_
                   (##unchecked-structure-ref
                    _buf202543_
                    '7
                    std/net/socket/buffer#ssocket-input-buffer::t
                    '#f)))
              (let _lp202553_ ((_rhi202555_ _rhi202548_)
                               (_want202556_ (##fx- _need202544_ _rhi202548_))
                               (_count202557_ '0))
                (let* ((_rd202559_
                        (std/net/socket/api#ssocket-recv__%
                         _sock202550_
                         _bytes202546_
                         _rhi202555_
                         (##u8vector-length _bytes202546_)
                         _timeo202551_))
                       (_rhi+rd202561_ (##fx+ _rhi202555_ _rd202559_)))
                  (##unchecked-structure-set!
                   _buf202543_
                   _rhi+rd202561_
                   '3
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (if (##fx< _rd202559_ _want202556_)
                      (if (##fx> _rd202559_ '0)
                          (_lp202553_
                           _rhi+rd202561_
                           (##fx- _want202556_ _rd202559_)
                           (##fx+ _count202557_ _rd202559_))
                          _count202557_)
                      (##fx+ _count202557_ _rd202559_)))))))))
  (define std/net/socket/buffer#ssocket-input-read
    (lambda (_bytes202538_ _start202539_ _end202540_ _buf202541_)
      (std/net/socket/api#ssocket-recv-all__%
       (##unchecked-structure-ref
        _buf202541_
        '6
        std/net/socket/buffer#ssocket-input-buffer::t
        '#f)
       _bytes202538_
       _start202539_
       _end202540_
       (##unchecked-structure-ref
        _buf202541_
        '7
        std/net/socket/buffer#ssocket-input-buffer::t
        '#f))))
  (define std/net/socket/buffer#ssocket-input-buffer-timeout-set!
    (lambda (_buf202533_ _timeo202534_)
      (let ((_timeo202536_ (std/net/socket/base#abs-timeout _timeo202534_)))
        (##direct-structure-set!
         _buf202533_
         _timeo202536_
         '7
         std/net/socket/buffer#ssocket-input-buffer::t
         '#f))))
  (define std/net/socket/buffer#ssocket-output-buffer::t
    (make-struct-type
     'std/net/socket/buffer#ssocket-output-buffer::t
     std/net/bio/output#output-buffer::t
     '2
     'ssocket-output-buffer
     '((final: . #t))
     '#f
     '(sock timeo)))
  (define std/net/socket/buffer#ssocket-output-buffer?
    (make-struct-predicate std/net/socket/buffer#ssocket-output-buffer::t))
  (define std/net/socket/buffer#make-ssocket-output-buffer
    (lambda _$args202530_
      (apply make-struct-instance
             std/net/socket/buffer#ssocket-output-buffer::t
             _$args202530_)))
  (define std/net/socket/buffer#ssocket-output-buffer-sock
    (make-struct-field-accessor
     std/net/socket/buffer#ssocket-output-buffer::t
     '0))
  (define std/net/socket/buffer#ssocket-output-buffer-timeo
    (make-struct-field-accessor
     std/net/socket/buffer#ssocket-output-buffer::t
     '1))
  (define std/net/socket/buffer#ssocket-output-buffer-sock-set!
    (make-struct-field-mutator
     std/net/socket/buffer#ssocket-output-buffer::t
     '0))
  (define std/net/socket/buffer#ssocket-output-buffer-timeo-set!
    (make-struct-field-mutator
     std/net/socket/buffer#ssocket-output-buffer::t
     '1))
  (define std/net/socket/buffer#&ssocket-output-buffer-sock
    (make-struct-field-unchecked-accessor
     std/net/socket/buffer#ssocket-output-buffer::t
     '0))
  (define std/net/socket/buffer#&ssocket-output-buffer-timeo
    (make-struct-field-unchecked-accessor
     std/net/socket/buffer#ssocket-output-buffer::t
     '1))
  (define std/net/socket/buffer#&ssocket-output-buffer-sock-set!
    (make-struct-field-unchecked-mutator
     std/net/socket/buffer#ssocket-output-buffer::t
     '0))
  (define std/net/socket/buffer#&ssocket-output-buffer-timeo-set!
    (make-struct-field-unchecked-mutator
     std/net/socket/buffer#ssocket-output-buffer::t
     '1))
  (define std/net/socket/buffer#open-ssocket-output-buffer__%
    (lambda (_ssock202517_ _size202518_)
      (##structure
       std/net/socket/buffer#ssocket-output-buffer::t
       (make-u8vector _size202518_)
       '0
       _size202518_
       std/net/socket/buffer#ssocket-output-drain!
       std/net/socket/buffer#ssocket-output-write
       _ssock202517_
       '#f)))
  (define std/net/socket/buffer#open-ssocket-output-buffer__0
    (lambda (_ssock202523_)
      (let ((_size202525_ std/net/socket/buffer#default-buffer-size))
        (std/net/socket/buffer#open-ssocket-output-buffer__%
         _ssock202523_
         _size202525_))))
  (define std/net/socket/buffer#open-ssocket-output-buffer
    (lambda _g309491_
      (let ((_g309490_ (##length _g309491_)))
        (cond ((##fx= _g309490_ 1)
               (apply std/net/socket/buffer#open-ssocket-output-buffer__0
                      _g309491_))
              ((##fx= _g309490_ 2)
               (apply std/net/socket/buffer#open-ssocket-output-buffer__%
                      _g309491_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/buffer#open-ssocket-output-buffer
                _g309491_))))))
  (define std/net/socket/buffer#ssocket-output-drain!
    (lambda (_buf202513_ _need202514_)
      (std/net/socket/api#ssocket-send-all__%
       (##unchecked-structure-ref
        _buf202513_
        '6
        std/net/socket/buffer#ssocket-output-buffer::t
        '#f)
       (##unchecked-structure-ref
        _buf202513_
        '1
        std/net/bio/output#output-buffer::t
        '#f)
       '0
       (##unchecked-structure-ref
        _buf202513_
        '2
        std/net/bio/output#output-buffer::t
        '#f)
       (##unchecked-structure-ref
        _buf202513_
        '7
        std/net/socket/buffer#ssocket-output-buffer::t
        '#f))
      (##unchecked-structure-set!
       _buf202513_
       '0
       '2
       std/net/bio/output#output-buffer::t
       '#f)))
  (define std/net/socket/buffer#ssocket-output-write
    (lambda (_bytes202508_ _start202509_ _end202510_ _buf202511_)
      (std/net/socket/api#ssocket-send-all__%
       (##unchecked-structure-ref
        _buf202511_
        '6
        std/net/socket/buffer#ssocket-output-buffer::t
        '#f)
       _bytes202508_
       _start202509_
       _end202510_
       (##unchecked-structure-ref
        _buf202511_
        '7
        std/net/socket/buffer#ssocket-output-buffer::t
        '#f))))
  (define std/net/socket/buffer#ssocket-output-buffer-timeout-set!
    (lambda (_buf202503_ _timeo202504_)
      (let ((_timeo202506_ (std/net/socket/base#abs-timeout _timeo202504_)))
        (##direct-structure-set!
         _buf202503_
         _timeo202506_
         '7
         std/net/socket/buffer#ssocket-output-buffer::t
         '#f))))
  (define std/net/socket/buffer#ssocket-input-buffer-reset!
    (lambda (_buf202500_ _sock202501_)
      (##unchecked-structure-set!
       _buf202500_
       '0
       '2
       std/net/bio/input#input-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202500_
       '0
       '3
       std/net/bio/input#input-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202500_
       _sock202501_
       '6
       std/net/socket/buffer#ssocket-input-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202500_
       '#f
       '7
       std/net/socket/buffer#ssocket-input-buffer::t
       '#f)))
  (define std/net/socket/buffer#ssocket-input-buffer-release!
    (lambda (_buf202498_)
      (##unchecked-structure-set!
       _buf202498_
       '#f
       '6
       std/net/socket/buffer#ssocket-input-buffer::t
       '#f)))
  (define std/net/socket/buffer#ssocket-output-buffer-reset!
    (lambda (_buf202495_ _sock202496_)
      (##unchecked-structure-set!
       _buf202495_
       '0
       '2
       std/net/bio/output#output-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202495_
       (u8vector-length
        (##unchecked-structure-ref
         _buf202495_
         '1
         std/net/bio/output#output-buffer::t
         '#f))
       '3
       std/net/bio/output#output-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202495_
       _sock202496_
       '6
       std/net/socket/buffer#ssocket-output-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202495_
       '#f
       '7
       std/net/socket/buffer#ssocket-output-buffer::t
       '#f)))
  (define std/net/socket/buffer#ssocket-output-buffer-release!
    (lambda (_buf202493_)
      (##unchecked-structure-set!
       _buf202493_
       '#f
       '6
       std/net/socket/buffer#ssocket-output-buffer::t
       '#f))))
