(declare (block) (standard-bindings) (extended-bindings))
(define std/net/socket/kqueue-server#kqueue-socket-server
  (lambda ()
    (letrec* ((_fdtab203090_ (make-table 'test: eq?))
              (_kq203091_ (std/os/kqueue#kqueue))
              (_maxevts203092_ '8192)
              (_evts203093_ (std/os/kqueue#make-kevents _maxevts203092_))
              (_ev-in203094_
               (let ()
                 (declare (not safe))
                 (##fxior std/os/kqueue#EVFILT_READ
                          std/os/kqueue#EV_EOF
                          std/os/kqueue#EV_ERROR)))
              (_ev-out203095_
               (let ()
                 (declare (not safe))
                 (##fxior std/os/kqueue#EVFILT_WRITE
                          std/os/kqueue#EV_EOF
                          std/os/kqueue#EV_ERROR)))
              (_do-kevent203096_
               (lambda ()
                 (let ((_count203318_
                        (std/os/kqueue#kqueue-poll
                         _kq203091_
                         _evts203093_
                         _maxevts203092_)))
                   (if (let ()
                         (declare (not safe))
                         (##fxpositive? _count203318_))
                       (let _lp203320_ ((_k203322_ '0))
                         (if (let ()
                               (declare (not safe))
                               (##fx< _k203322_ _count203318_))
                             (let ((_fd203324_
                                    (std/os/kqueue#kevent-ident
                                     _evts203093_
                                     _k203322_))
                                   (_ready203325_
                                    (std/os/kqueue#kevent-flags
                                     _evts203093_
                                     _k203322_)))
                               (let* ((_g203326203334_
                                       (table-ref _fdtab203090_ _fd203324_))
                                      (_E203328203338_
                                       (lambda ()
                                         (error '"No clause matching"
                                                _g203326203334_)))
                                      (_K203329203344_
                                       (lambda (_io-out203341_ _io-in203342_)
                                         (if (let ((__tmp309555
                                                    (let ()
                                                      (declare (not safe))
                                                      (##fxand _ready203325_
                                                               _ev-in203094_))))
                                               (declare (not safe))
                                               (##fxzero? __tmp309555))
                                             '#!void
                                             (if _io-in203342_
                                                 (std/net/socket/basic-server#io-state-signal-ready!
                                                  _io-in203342_
                                                  'ready)
                                                 '#!void))
                                         (if (let ((__tmp309556
                                                    (let ()
                                                      (declare (not safe))
                                                      (##fxand _ready203325_
                                                               _ev-out203095_))))
                                               (declare (not safe))
                                               (##fxzero? __tmp309556))
                                             '#!void
                                             (if _io-out203341_
                                                 (std/net/socket/basic-server#io-state-signal-ready!
                                                  _io-out203341_
                                                  'ready)
                                                 '#!void))
                                         (_lp203320_
                                          (let ()
                                            (declare (not safe))
                                            (##fx+ _k203322_ '1))))))
                                 (if (let ()
                                       (declare (not safe))
                                       (##structure-direct-instance-of?
                                        _g203326203334_
                                        'std/net/socket/base#!socket-state::t))
                                     (let* ((_e203330203347_
                                             (let ()
                                               (declare (not safe))
                                               (##vector-ref
                                                _g203326203334_
                                                '1)))
                                            (_e203331203350_
                                             (let ()
                                               (declare (not safe))
                                               (##vector-ref
                                                _g203326203334_
                                                '2)))
                                            (_io-in203353_ _e203331203350_)
                                            (_e203332203355_
                                             (let ()
                                               (declare (not safe))
                                               (##vector-ref
                                                _g203326203334_
                                                '3)))
                                            (_io-out203358_ _e203332203355_))
                                       (_K203329203344_
                                        _io-out203358_
                                        _io-in203353_))
                                     (_E203328203338_))))
                             '#!void))
                       '#!void))))
              (_add-socket203097_
               (lambda (_sock203280_)
                 (let* ((_self203282_ (current-thread))
                        (_fd203284_ (std/os/fd#fd-e _sock203280_))
                        (_io-in203286_
                         (if (std/os/fd#fd-io-in _sock203280_)
                             (let ((__obj309553
                                    (make-object
                                     std/net/socket/base#!io-state::t
                                     '3)))
                               (std/net/socket/basic-server#!io-state:::init!
                                __obj309553)
                               __obj309553)
                             '#f))
                        (_wait-in203291_
                         (if _io-in203286_
                             (lambda (_ssock203288_ _timeo203289_)
                               (std/net/socket/basic-server#io-state-wait-io!
                                _io-in203286_
                                _timeo203289_
                                'input))
                             '#f))
                        (_io-out203293_
                         (if (std/os/fd#fd-io-out _sock203280_)
                             (let ((__obj309554
                                    (make-object
                                     std/net/socket/base#!io-state::t
                                     '3)))
                               (std/net/socket/basic-server#!io-state:::init!
                                __obj309554)
                               __obj309554)
                             '#f))
                        (_wait-out203298_
                         (if _io-out203293_
                             (lambda (_ssock203295_ _timeo203296_)
                               (std/net/socket/basic-server#io-state-wait-io!
                                _io-out203293_
                                _timeo203296_
                                'output))
                             '#f))
                        (_close203304_
                         (lambda (_ssock203300_ _dir203301_ _shutdown203302_)
                           (std/actor/message#send-message__0
                            _self203282_
                            (let ((__tmp309557
                                   (let ()
                                     (declare (not safe))
                                     (##structure
                                      std/net/socket/base#socket-server.close::t
                                      _ssock203300_
                                      _dir203301_
                                      _shutdown203302_))))
                              (declare (not safe))
                              (##structure
                               std/actor/proto#!event::t
                               __tmp309557)))))
                        (_ssock203306_
                         (let ()
                           (declare (not safe))
                           (##structure
                            std/net/socket/base#!socket::t
                            _sock203280_
                            _wait-in203291_
                            _wait-out203298_
                            _close203304_)))
                        (_state203308_
                         (let ()
                           (declare (not safe))
                           (##structure
                            std/net/socket/base#!socket-state::t
                            _sock203280_
                            _io-in203286_
                            _io-out203293_)))
                        (_nchanges203310_ '0))
                   (if _io-in203286_
                       (begin
                         (std/os/kqueue#kevent-set!__%
                          '#f
                          (std/os/fd#fd-e _sock203280_)
                          std/os/kqueue#EVFILT_READ
                          (let ()
                            (declare (not safe))
                            (##fxior std/os/kqueue#EV_ADD
                                     std/os/kqueue#EV_CLEAR))
                          std/os/kqueue#NOTE_LOWAT
                          '1
                          absent-value
                          _evts203093_
                          _nchanges203310_)
                         (set! _nchanges203310_ (+ _nchanges203310_ '1)))
                       '#!void)
                   (if _io-out203293_
                       (begin
                         (std/os/kqueue#kevent-set!__%
                          '#f
                          (std/os/fd#fd-e _sock203280_)
                          std/os/kqueue#EVFILT_WRITE
                          (let ()
                            (declare (not safe))
                            (##fxior std/os/kqueue#EV_ADD
                                     std/os/kqueue#EV_CLEAR))
                          std/os/kqueue#NOTE_LOWAT
                          '1
                          absent-value
                          _evts203093_
                          _nchanges203310_)
                         (set! _nchanges203310_ (+ _nchanges203310_ '1)))
                       '#!void)
                   (std/os/kqueue#kevent
                    _kq203091_
                    _evts203093_
                    _nchanges203310_
                    '#f
                    '0)
                   (make-will
                    _ssock203306_
                    (lambda (_g203312203314_)
                      (_close203304_ _g203312203314_ 'inout '#f)))
                   (table-set! _fdtab203090_ _fd203284_ _state203308_)
                   _ssock203306_)))
              (_close-socket203098_
               (lambda (_ssock203185_ _dir203186_ _shutdown203187_)
                 (letrec ((_close-io-in!203189_
                           (lambda (_io-in203277_ _sock203278_)
                             (std/net/socket/basic-server#io-state-close-in!
                              _io-in203277_
                              _sock203278_
                              _shutdown203187_)))
                          (_close-io-out!203190_
                           (lambda (_io-out203274_ _sock203275_)
                             (std/net/socket/basic-server#io-state-close-out!
                              _io-out203274_
                              _sock203275_
                              _shutdown203187_))))
                   (let* ((_ssock203191203199_ _ssock203185_)
                          (_E203193203203_
                           (lambda ()
                             (error '"No clause matching"
                                    _ssock203191203199_)))
                          (_K203194203256_
                           (lambda (_wait-out203206_
                                    _wait-in203207_
                                    _sock203208_)
                             (if (or _wait-in203207_ _wait-out203206_)
                                 (let* ((_state203213_
                                         (table-ref
                                          _fdtab203090_
                                          (std/os/fd#fd-e _sock203208_)
                                          '#f))
                                        (_state203214203223_ _state203213_)
                                        (_else203216203231_
                                         (lambda () '#!void))
                                        (_K203218203240_
                                         (lambda (_io-out203234_ _io-in203235_)
                                           (let ((_$e203237_ _dir203186_))
                                             (if (eq? 'in _$e203237_)
                                                 (begin
                                                   (if _io-out203234_
                                                       (std/os/kqueue#kqueue-kevent-disable
                                                        _kq203091_
                                                        _sock203208_
                                                        std/os/kqueue#EVFILT_READ)
                                                       (begin
                                                         (std/os/kqueue#kqueue-kevent-del
                                                          _kq203091_
                                                          _sock203208_
                                                          std/os/kqueue#EVFILT_READ)
                                                         (table-set!
                                                          _fdtab203090_
                                                          (std/os/fd#fd-e
                                                           _sock203208_))))
                                                   (##direct-structure-set!
                                                    _ssock203185_
                                                    '#f
                                                    '2
                                                    std/net/socket/base#!socket::t
                                                    '#f)
                                                   (##direct-structure-set!
                                                    _state203213_
                                                    '#f
                                                    '2
                                                    std/net/socket/base#!socket-state::t
                                                    '#f)
                                                   (_close-io-in!203189_
                                                    _io-in203235_
                                                    _sock203208_)
                                                   (if _io-out203234_
                                                       '#!void
                                                       (close-port
                                                        _sock203208_)))
                                                 (if (eq? 'out _$e203237_)
                                                     (begin
                                                       (if _io-in203235_
                                                           (std/os/kqueue#kqueue-kevent-disable
                                                            _kq203091_
                                                            _sock203208_
                                                            std/os/kqueue#EVFILT_WRITE)
                                                           (begin
                                                             (std/os/kqueue#kqueue-kevent-del
                                                              _kq203091_
                                                              _sock203208_
                                                              std/os/kqueue#EVFILT_WRITE)
                                                             (table-set!
                                                              _fdtab203090_
                                                              (std/os/fd#fd-e
                                                               _sock203208_))))
                                                       (##direct-structure-set!
                                                        _ssock203185_
                                                        '#f
                                                        '3
                                                        std/net/socket/base#!socket::t
                                                        '#f)
                                                       (##direct-structure-set!
                                                        _state203213_
                                                        '#f
                                                        '3
                                                        std/net/socket/base#!socket-state::t
                                                        '#f)
                                                       (_close-io-out!203190_
                                                        _io-out203234_
                                                        _sock203208_)
                                                       (if _io-in203235_
                                                           '#!void
                                                           (close-port
                                                            _sock203208_)))
                                                     (if (eq? 'inout
                                                              _$e203237_)
                                                         (begin
                                                           (std/os/kqueue#kevent-set!__%
                                                            '#f
                                                            (std/os/fd#fd-e
                                                             _sock203208_)
                                                            std/os/kqueue#EVFILT_READ
                                                            std/os/kqueue#EV_DELETE
                                                            absent-value
                                                            absent-value
                                                            absent-value
                                                            _evts203093_
                                                            '0)
                                                           (std/os/kqueue#kevent-set!__%
                                                            '#f
                                                            (std/os/fd#fd-e
                                                             _sock203208_)
                                                            std/os/kqueue#EVFILT_WRITE
                                                            std/os/kqueue#EV_DELETE
                                                            absent-value
                                                            absent-value
                                                            absent-value
                                                            _evts203093_
                                                            '1)
                                                           (std/os/kqueue#kevent
                                                            _kq203091_
                                                            _evts203093_
                                                            '2
                                                            '#f
                                                            '0)
                                                           (table-set!
                                                            _fdtab203090_
                                                            (std/os/fd#fd-e
                                                             _sock203208_))
                                                           (if _io-in203235_
                                                               (begin
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (##direct-structure-set!
                          _ssock203185_
                          '#f
                          '2
                          std/net/socket/base#!socket::t
                          '#f)
                         (##direct-structure-set!
                          _state203213_
                          '#f
                          '2
                          std/net/socket/base#!socket-state::t
                          '#f)
                         (_close-io-in!203189_ _io-in203235_ _sock203208_))
                       '#!void)
                   (if _io-out203234_
                       (begin
                         (##direct-structure-set!
                          _ssock203185_
                          '#f
                          '3
                          std/net/socket/base#!socket::t
                          '#f)
                         (##direct-structure-set!
                          _state203213_
                          '#f
                          '3
                          std/net/socket/base#!socket-state::t
                          '#f)
                         (_close-io-out!203190_ _io-out203234_ _sock203208_))
                       '#!void)
                   (close-port _sock203208_))
                 (error '"Bad direction" _dir203186_))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                   (if (let ()
                                         (declare (not safe))
                                         (##structure-direct-instance-of?
                                          _state203214203223_
                                          'std/net/socket/base#!socket-state::t))
                                       (let* ((_e203219203243_
                                               (let ()
                                                 (declare (not safe))
                                                 (##vector-ref
                                                  _state203214203223_
                                                  '1)))
                                              (_e203220203246_
                                               (let ()
                                                 (declare (not safe))
                                                 (##vector-ref
                                                  _state203214203223_
                                                  '2)))
                                              (_io-in203249_ _e203220203246_)
                                              (_e203221203251_
                                               (let ()
                                                 (declare (not safe))
                                                 (##vector-ref
                                                  _state203214203223_
                                                  '3)))
                                              (_io-out203254_ _e203221203251_))
                                         (_K203218203240_
                                          _io-out203254_
                                          _io-in203249_))
                                       '#!void))
                                 '#!void))))
                     (if (let ()
                           (declare (not safe))
                           (##structure-direct-instance-of?
                            _ssock203191203199_
                            'std/net/socket/base#!socket::t))
                         (let* ((_e203195203259_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _ssock203191203199_ '1)))
                                (_sock203262_ _e203195203259_)
                                (_e203196203264_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _ssock203191203199_ '2)))
                                (_wait-in203267_ _e203196203264_)
                                (_e203197203269_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _ssock203191203199_ '3)))
                                (_wait-out203272_ _e203197203269_))
                           (_K203194203256_
                            _wait-out203272_
                            _wait-in203267_
                            _sock203262_))
                         (_E203193203203_))))))
              (_shutdown!203099_
               (lambda ()
                 (close-port _kq203091_)
                 (let ((_iterable203159_
                        (std/iter#in-hash-values _fdtab203090_))
                       (_iter-do203161_
                        (lambda (_val203102_)
                          (let* ((_val203104203109_ _val203102_)
                                 (_E203106203113_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _val203104203109_)))
                                 (_K203107203154_
                                  (lambda (_state203116_)
                                    (let* ((_state203117203125_ _state203116_)
                                           (_E203119203129_
                                            (lambda ()
                                              (error '"No clause matching"
                                                     _state203117203125_)))
                                           (_K203120203136_
                                            (lambda (_io-out203132_
                                                     _io-in203133_
                                                     _sock203134_)
                                              (if _io-in203133_
                                                  (std/net/socket/basic-server#io-state-close-in!
                                                   _io-in203133_
                                                   _sock203134_
                                                   '#f)
                                                  '#!void)
                                              (if _io-out203132_
                                                  (std/net/socket/basic-server#io-state-close-out!
                                                   _io-out203132_
                                                   _sock203134_
                                                   '#f)
                                                  '#!void)
                                              (close-port _sock203134_))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##structure-direct-instance-of?
                                             _state203117203125_
                                             'std/net/socket/base#!socket-state::t))
                                          (let* ((_e203121203139_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _state203117203125_
                                                     '1)))
                                                 (_sock203142_ _e203121203139_)
                                                 (_e203122203144_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _state203117203125_
                                                     '2)))
                                                 (_io-in203147_
                                                  _e203122203144_)
                                                 (_e203123203149_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _state203117203125_
                                                     '3)))
                                                 (_io-out203152_
                                                  _e203123203149_))
                                            (_K203120203136_
                                             _io-out203152_
                                             _io-in203147_
                                             _sock203142_))
                                          (_E203119203129_)))))
                                 (_state203157_ _val203104203109_))
                            (_K203107203154_ _state203157_)))))
                   (if (pair? _iterable203159_)
                       (for-each _iter-do203161_ _iterable203159_)
                       (if (null? _iterable203159_)
                           '#!void
                           (let* ((_it203164_ (std/iter#iter _iterable203159_))
                                  (_next!203167_
                                   (let ()
                                     (declare (not safe))
                                     (##unchecked-structure-ref
                                      _it203164_
                                      '2
                                      std/iter#iterator::t
                                      '#f))))
                             (declare (not safe))
                             (begin
                               (let _lp203172_ ()
                                 (let ((_val203176_
                                        (_next!203167_ _it203164_)))
                                   (if (eq? std/iter#iter-end _val203176_)
                                       '#!void
                                       (begin
                                         (_iter-do203161_ _val203176_)
                                         (_lp203172_)))))
                               (let ((_$e203178_
                                      (##unchecked-structure-ref
                                       _it203164_
                                       '3
                                       std/iter#iterator::t
                                       '#f)))
                                 (if _$e203178_
                                     ((lambda (_g203180203182_)
                                        (_g203180203182_ _it203164_))
                                      _$e203178_)
                                     '#!void))
                               '#!void)))))
                 (set! _fdtab203090_ '#f)
                 (set! _kq203091_ '#f))))
      (std/net/socket/basic-server#server-loop
       (std/os/fd#fd-io-in _kq203091_)
       _do-kevent203096_
       _add-socket203097_
       _close-socket203098_
       _shutdown!203099_))))
