(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/uri#uri-unreserved-chars
    '"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-._~")
  (define std/net/uri#uri-gendelim-chars '":/?#[]@")
  (define std/net/uri#uri-subdelim-chars '"!$&'()*+,;=")
  (define std/net/uri#make-uri-encoding-table__%
    (lambda (_self-chars171776_ _sub-chars171777_)
      (let ((_vt171779_ (make-vector '256 '#f))
            (_len171780_ (string-length _self-chars171776_)))
        (let _lp171782_ ((_n171784_ '0))
          (if (let () (declare (not safe)) (##fx< _n171784_ _len171780_))
              (let ((_char171786_
                     (let ()
                       (declare (not safe))
                       (##string-ref _self-chars171776_ _n171784_))))
                (vector-set!
                 _vt171779_
                 (char->integer _char171786_)
                 _char171786_)
                (_lp171782_
                 (let () (declare (not safe)) (##fx+ _n171784_ '1))))
              '#!void))
        (for-each
         (lambda (_e171787171789_)
           (let* ((_g171791171798_ _e171787171789_)
                  (_E171793171802_
                   (lambda () (error '"No clause matching" _g171791171798_)))
                  (_K171794171808_
                   (lambda (_sub171805_ _char171806_)
                     (vector-set!
                      _vt171779_
                      (char->integer _char171806_)
                      _sub171805_))))
             (if (let () (declare (not safe)) (##pair? _g171791171798_))
                 (let ((_hd171795171811_
                        (let () (declare (not safe)) (##car _g171791171798_)))
                       (_tl171796171813_
                        (let () (declare (not safe)) (##cdr _g171791171798_))))
                   (let* ((_char171816_ _hd171795171811_)
                          (_sub171818_ _tl171796171813_))
                     (_K171794171808_ _sub171818_ _char171816_)))
                 (_E171793171802_))))
         _sub-chars171777_)
        _vt171779_)))
  (define std/net/uri#make-uri-encoding-table__0
    (lambda (_self-chars171823_)
      (let ((_sub-chars171825_ '()))
        (std/net/uri#make-uri-encoding-table__%
         _self-chars171823_
         _sub-chars171825_))))
  (define std/net/uri#make-uri-encoding-table
    (lambda _g290375_
      (let ((_g290374_ (let () (declare (not safe)) (##length _g290375_))))
        (cond ((let () (declare (not safe)) (##fx= _g290374_ 1))
               (apply std/net/uri#make-uri-encoding-table__0 _g290375_))
              ((let () (declare (not safe)) (##fx= _g290374_ 2))
               (apply std/net/uri#make-uri-encoding-table__% _g290375_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/uri#make-uri-encoding-table
                _g290375_))))))
  (define std/net/uri#uri-encoding
    (std/net/uri#make-uri-encoding-table__0 std/net/uri#uri-unreserved-chars))
  (define std/net/uri#uri-space-encoding
    (std/net/uri#make-uri-encoding-table__%
     std/net/uri#uri-unreserved-chars
     '((#\space . #\+))))
  (define std/net/uri#uri-encode__%
    (lambda (_str171761_ _vt171762_)
      (if (and (vector? _vt171762_)
               (let ((__tmp290376 (vector-length _vt171762_)))
                 (declare (not safe))
                 (##fx= __tmp290376 '256)))
          '#!void
          (error '"Bad encoding table" _vt171762_))
      (with-output-to-string
       '()
       (lambda () (std/net/uri#write-uri-encoded _str171761_ _vt171762_)))))
  (define std/net/uri#uri-encode__0
    (lambda (_str171768_)
      (let ((_vt171770_ std/net/uri#uri-encoding))
        (std/net/uri#uri-encode__% _str171768_ _vt171770_))))
  (define std/net/uri#uri-encode
    (lambda _g290378_
      (let ((_g290377_ (let () (declare (not safe)) (##length _g290378_))))
        (cond ((let () (declare (not safe)) (##fx= _g290377_ 1))
               (apply std/net/uri#uri-encode__0 _g290378_))
              ((let () (declare (not safe)) (##fx= _g290377_ 2))
               (apply std/net/uri#uri-encode__% _g290378_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/uri#uri-encode
                _g290378_))))))
  (define std/net/uri#form-url-encode__%
    (lambda (_fields171673_ _+space?171674_)
      (letrec* ((_encoding171676_
                 (if _+space?171674_
                     std/net/uri#uri-space-encoding
                     std/net/uri#uri-encoding))
                (_encode-field171677_
                 (lambda (_field171720_)
                   (let* ((_field171721171728_ _field171720_)
                          (_E171723171732_
                           (lambda ()
                             (error '"No clause matching"
                                    _field171721171728_)))
                          (_K171724171738_
                           (lambda (_val171735_ _key171736_)
                             (std/net/uri#write-uri-encoded
                              _key171736_
                              _encoding171676_)
                             (if _val171735_
                                 (begin
                                   (write-char '#\=)
                                   (std/net/uri#write-uri-encoded
                                    _val171735_
                                    _encoding171676_))
                                 '#!void))))
                     (if (let ()
                           (declare (not safe))
                           (##pair? _field171721171728_))
                         (let ((_hd171725171741_
                                (let ()
                                  (declare (not safe))
                                  (##car _field171721171728_)))
                               (_tl171726171743_
                                (let ()
                                  (declare (not safe))
                                  (##cdr _field171721171728_))))
                           (let* ((_key171746_ _hd171725171741_)
                                  (_val171748_ _tl171726171743_))
                             (_K171724171738_ _val171748_ _key171746_)))
                         (_E171723171732_))))))
        (let* ((_fields171678171687_ _fields171673_)
               (_E171681171691_
                (lambda ()
                  (error '"No clause matching" _fields171678171687_))))
          (let ((_K171683171708_
                 (lambda (_rest171702_ _first171703_)
                   (with-output-to-string
                    '()
                    (lambda ()
                      (_encode-field171677_ _first171703_)
                      (for-each
                       (lambda (_field171706_)
                         (write-char '#\&)
                         (_encode-field171677_ _field171706_))
                       _rest171702_)))))
                (_K171682171696_ (lambda () '"")))
            (let ((_try-match171680171699_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##null? _fields171678171687_))
                         (_K171682171696_)
                         (_E171681171691_)))))
              (if (let () (declare (not safe)) (##pair? _fields171678171687_))
                  (let ((_tl171685171713_
                         (let ()
                           (declare (not safe))
                           (##cdr _fields171678171687_)))
                        (_hd171684171711_
                         (let ()
                           (declare (not safe))
                           (##car _fields171678171687_))))
                    (let ((_first171716_ _hd171684171711_)
                          (_rest171718_ _tl171685171713_))
                      (_K171683171708_ _rest171718_ _first171716_)))
                  (_try-match171680171699_))))))))
  (define std/net/uri#form-url-encode__0
    (lambda (_fields171753_)
      (let ((_+space?171755_ '#t))
        (std/net/uri#form-url-encode__% _fields171753_ _+space?171755_))))
  (define std/net/uri#form-url-encode
    (lambda _g290380_
      (let ((_g290379_ (let () (declare (not safe)) (##length _g290380_))))
        (cond ((let () (declare (not safe)) (##fx= _g290379_ 1))
               (apply std/net/uri#form-url-encode__0 _g290380_))
              ((let () (declare (not safe)) (##fx= _g290379_ 2))
               (apply std/net/uri#form-url-encode__% _g290380_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/uri#form-url-encode
                _g290380_))))))
  (define std/net/uri#write-uri-encoded
    (lambda (_str171651_ _encoding171652_)
      (letrec ((_write-hex171654_
                (lambda (_n171670_)
                  (write-char
                   (let ()
                     (declare (not safe))
                     (##string-ref '"0123456789ABCDEF" _n171670_))))))
        (let* ((_utf8171656_ (std/text/utf8#string->utf8__0 _str171651_))
               (_len171658_ (u8vector-length _utf8171656_)))
          (let _lp171661_ ((_n171663_ '0))
            (if (let () (declare (not safe)) (##fx< _n171663_ _len171658_))
                (let ((_byte171665_
                       (let ()
                         (declare (not safe))
                         (##u8vector-ref _utf8171656_ _n171663_))))
                  (let ((_$e171667_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _encoding171652_ _byte171665_))))
                    (if _$e171667_
                        (write-char _$e171667_)
                        (begin
                          (write-char '#\%)
                          (_write-hex171654_
                           (let ((__tmp290381
                                  (let ()
                                    (declare (not safe))
                                    (##fxarithmetic-shift _byte171665_ '-4))))
                             (declare (not safe))
                             (##fxand __tmp290381 '15)))
                          (_write-hex171654_
                           (let ()
                             (declare (not safe))
                             (##fxand _byte171665_ '15))))))
                  (_lp171661_
                   (let () (declare (not safe)) (##fx+ _n171663_ '1))))
                '#!void))))))
  (define std/net/uri#hex-bytes
    (let ((_ht171645_ (make-table 'test: eq?)))
      (for-each
       (lambda (_n171647_)
         (let ((_char171649_
                (let ()
                  (declare (not safe))
                  (##string-ref '"0123456789ABCDEF" _n171647_))))
           (table-set! _ht171645_ _char171649_ _n171647_)
           (table-set! _ht171645_ (char-downcase _char171649_) _n171647_)))
       (iota '16))
      _ht171645_))
  (define std/net/uri#uri-decode__%
    (lambda (_str171599_ _encoding171600_)
      (letrec ((_hex-byte171602_
                (lambda (_byte171628_)
                  (let* ((_char171630_ (integer->char _byte171628_))
                         (_$e171632_
                          (table-ref std/net/uri#hex-bytes _char171630_ '#f)))
                    (if _$e171632_
                        (values _$e171632_)
                        (error '"Malformed uri encoding" _char171630_))))))
        (if _encoding171600_
            (if (and (vector? _encoding171600_)
                     (let ((__tmp290382 (vector-length _encoding171600_)))
                       (declare (not safe))
                       (##fx= __tmp290382 '256)))
                '#!void
                (error '"Bad encoding table" _encoding171600_))
            '#!void)
        (let* ((_utf8171604_ (std/text/utf8#string->utf8__0 _str171599_))
               (_len171606_ (u8vector-length _utf8171604_))
               (_pct171608_ (char->integer '#\%)))
          (std/text/utf8#utf8->string__0
           (with-output-to-u8vector
            '()
            (lambda ()
              (let _lp171612_ ((_n171614_ '0))
                (if (let () (declare (not safe)) (##fx< _n171614_ _len171606_))
                    (let* ((_next171616_
                            (let ()
                              (declare (not safe))
                              (##u8vector-ref _utf8171604_ _n171614_)))
                           (_$e171618_
                            (if _encoding171600_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _encoding171600_ _next171616_))
                                '#f)))
                      (if _$e171618_
                          ((lambda (_char171621_)
                             (write-char _char171621_)
                             (_lp171612_
                              (let ()
                                (declare (not safe))
                                (##fx+ _n171614_ '1))))
                           _$e171618_)
                          (if (eq? _next171616_ _pct171608_)
                              (let ((_n171623_
                                     (let ()
                                       (declare (not safe))
                                       (##fx+ _n171614_ '1))))
                                (if (let ((__tmp290383
                                           (let ()
                                             (declare (not safe))
                                             (##fx+ _n171623_ '1))))
                                      (declare (not safe))
                                      (##fx< __tmp290383 _len171606_))
                                    (let ((_hi171625_
                                           (let ()
                                             (declare (not safe))
                                             (##u8vector-ref
                                              _utf8171604_
                                              _n171623_)))
                                          (_lo171626_
                                           (let ((__tmp290384
                                                  (let ()
                                                    (declare (not safe))
                                                    (##fx+ _n171623_ '1))))
                                             (declare (not safe))
                                             (##u8vector-ref
                                              _utf8171604_
                                              __tmp290384))))
                                      (write-u8
                                       (let ((__tmp290386
                                              (let ((__tmp290387
                                                     (_hex-byte171602_
                                                      _hi171625_)))
                                                (declare (not safe))
                                                (##fxarithmetic-shift
                                                 __tmp290387
                                                 '4)))
                                             (__tmp290385
                                              (_hex-byte171602_ _lo171626_)))
                                         (declare (not safe))
                                         (##fxior __tmp290386 __tmp290385)))
                                      (_lp171612_
                                       (let ()
                                         (declare (not safe))
                                         (##fx+ _n171623_ '2))))
                                    (error '"Malformed uri component")))
                              (begin
                                (write-u8 _next171616_)
                                (_lp171612_
                                 (let ()
                                   (declare (not safe))
                                   (##fx+ _n171614_ '1)))))))
                    '#!void)))))))))
  (define std/net/uri#uri-decode__0
    (lambda (_str171638_)
      (let ((_encoding171640_ '#f))
        (std/net/uri#uri-decode__% _str171638_ _encoding171640_))))
  (define std/net/uri#uri-decode
    (lambda _g290389_
      (let ((_g290388_ (let () (declare (not safe)) (##length _g290389_))))
        (cond ((let () (declare (not safe)) (##fx= _g290388_ 1))
               (apply std/net/uri#uri-decode__0 _g290389_))
              ((let () (declare (not safe)) (##fx= _g290388_ 2))
               (apply std/net/uri#uri-decode__% _g290389_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/uri#uri-decode
                _g290389_))))))
  (define std/net/uri#uri-space-decoding
    (std/net/uri#make-uri-encoding-table__% '"" '((#\+ . #\space))))
  (define std/net/uri#form-url-decode
    (lambda (_str171534_)
      (filter-map1
       (lambda (_part171536_)
         (if (not (string-empty? _part171536_))
             (let* ((_g171537171551_ (string-split _part171536_ '#\=))
                    (_else171540171559_
                     (lambda ()
                       (error '"Malformed form component" _part171536_))))
               (let ((_K171545171581_
                      (lambda (_val171578_ _key171579_)
                        (cons (std/net/uri#uri-decode__%
                               _key171579_
                               std/net/uri#uri-space-decoding)
                              (std/net/uri#uri-decode__%
                               _val171578_
                               std/net/uri#uri-space-decoding))))
                     (_K171542171565_
                      (lambda (_key171563_)
                        (cons (std/net/uri#uri-decode__%
                               _key171563_
                               std/net/uri#uri-space-decoding)
                              '#f))))
                 (if (let () (declare (not safe)) (##pair? _g171537171551_))
                     (let ((_tl171547171586_
                            (let ()
                              (declare (not safe))
                              (##cdr _g171537171551_)))
                           (_hd171546171584_
                            (let ()
                              (declare (not safe))
                              (##car _g171537171551_))))
                       (if (let ()
                             (declare (not safe))
                             (##pair? _tl171547171586_))
                           (let ((_tl171549171593_
                                  (let ()
                                    (declare (not safe))
                                    (##cdr _tl171547171586_)))
                                 (_hd171548171591_
                                  (let ()
                                    (declare (not safe))
                                    (##car _tl171547171586_))))
                             (if (let ()
                                   (declare (not safe))
                                   (##null? _tl171549171593_))
                                 (let ((_key171589_ _hd171546171584_)
                                       (_val171596_ _hd171548171591_))
                                   (_K171545171581_ _val171596_ _key171589_))
                                 (_else171540171559_)))
                           (if (let ()
                                 (declare (not safe))
                                 (##null? _tl171547171586_))
                               (let ((_key171573_ _hd171546171584_))
                                 (_K171542171565_ _key171573_))
                               (_else171540171559_))))
                     (_else171540171559_))))
             '#f))
       (string-split _str171534_ '#\&)))))
