(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/fdio#fdread__%
    (lambda (_raw179263_ _bytes179264_ _start179265_ _end179266_)
      (let ((_fd179268_
             (if (std/os/fd#fd? _raw179263_)
                 (std/os/fd#fd-e _raw179263_)
                 _raw179263_)))
        (let _lp179270_ ()
          (let ((_r179274_
                 (std/os/fdio#_read
                  _fd179268_
                  _bytes179264_
                  _start179265_
                  _end179266_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r179274_)))
                _r179274_
                (let ((_errno179277_
                       (let () (declare (not safe)) (##fx- _r179274_))))
                  (if (or (eq? _errno179277_ std/os/error#EAGAIN)
                          (eq? _errno179277_ std/os/error#EWOULDBLOCK))
                      '#f
                      (if (eq? _errno179277_ std/os/error#EINTR)
                          (_lp179270_)
                          (std/os/error#raise-os-error
                           _errno179277_
                           std/os/fdio#fdread
                           _raw179263_
                           _bytes179264_
                           _start179265_
                           _end179266_))))))))))
  (define std/os/fdio#fdread__0
    (lambda (_raw179286_ _bytes179287_)
      (let* ((_start179289_ '0) (_end179291_ (u8vector-length _bytes179287_)))
        (std/os/fdio#fdread__%
         _raw179286_
         _bytes179287_
         _start179289_
         _end179291_))))
  (define std/os/fdio#fdread__1
    (lambda (_raw179293_ _bytes179294_ _start179295_)
      (let ((_end179297_ (u8vector-length _bytes179294_)))
        (std/os/fdio#fdread__%
         _raw179293_
         _bytes179294_
         _start179295_
         _end179297_))))
  (define std/os/fdio#fdread
    (lambda _g300984_
      (let ((_g300983_ (let () (declare (not safe)) (##length _g300984_))))
        (cond ((let () (declare (not safe)) (##fx= _g300983_ 2))
               (apply std/os/fdio#fdread__0 _g300984_))
              ((let () (declare (not safe)) (##fx= _g300983_ 3))
               (apply std/os/fdio#fdread__1 _g300984_))
              ((let () (declare (not safe)) (##fx= _g300983_ 4))
               (apply std/os/fdio#fdread__% _g300984_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/fdio#fdread
                _g300984_))))))
  (define std/os/fdio#fdwrite__%
    (lambda (_raw179221_ _bytes179222_ _start179223_ _end179224_)
      (let ((_fd179226_
             (if (std/os/fd#fd? _raw179221_)
                 (std/os/fd#fd-e _raw179221_)
                 _raw179221_)))
        (let _lp179228_ ()
          (let ((_r179232_
                 (std/os/fdio#_write
                  _fd179226_
                  _bytes179222_
                  _start179223_
                  _end179224_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r179232_)))
                _r179232_
                (let ((_errno179235_
                       (let () (declare (not safe)) (##fx- _r179232_))))
                  (if (or (eq? _errno179235_ std/os/error#EAGAIN)
                          (eq? _errno179235_ std/os/error#EWOULDBLOCK))
                      '#f
                      (if (eq? _errno179235_ std/os/error#EINTR)
                          (_lp179228_)
                          (std/os/error#raise-os-error
                           _errno179235_
                           std/os/fdio#fdwrite
                           _raw179221_
                           _bytes179222_
                           _start179223_
                           _end179224_))))))))))
  (define std/os/fdio#fdwrite__0
    (lambda (_raw179244_ _bytes179245_)
      (let* ((_start179247_ '0) (_end179249_ (u8vector-length _bytes179245_)))
        (std/os/fdio#fdwrite__%
         _raw179244_
         _bytes179245_
         _start179247_
         _end179249_))))
  (define std/os/fdio#fdwrite__1
    (lambda (_raw179251_ _bytes179252_ _start179253_)
      (let ((_end179255_ (u8vector-length _bytes179252_)))
        (std/os/fdio#fdwrite__%
         _raw179251_
         _bytes179252_
         _start179253_
         _end179255_))))
  (define std/os/fdio#fdwrite
    (lambda _g300986_
      (let ((_g300985_ (let () (declare (not safe)) (##length _g300986_))))
        (cond ((let () (declare (not safe)) (##fx= _g300985_ 2))
               (apply std/os/fdio#fdwrite__0 _g300986_))
              ((let () (declare (not safe)) (##fx= _g300985_ 3))
               (apply std/os/fdio#fdwrite__1 _g300986_))
              ((let () (declare (not safe)) (##fx= _g300985_ 4))
               (apply std/os/fdio#fdwrite__% _g300986_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/fdio#fdwrite
                _g300986_))))))
  (define std/os/fdio#open__%
    (lambda (_path179196_ _flags179197_ _mode179198_)
      (let* ((_fd179203_
              (let ((_r179200_
                     (std/os/fdio#_open
                      _path179196_
                      _flags179197_
                      _mode179198_)))
                (if (not (let ()
                           (declare (not safe))
                           (##fxnegative? _r179200_)))
                    _r179200_
                    (std/os/error#raise-os-error
                     (let () (declare (not safe)) (##fx- _r179200_))
                     std/os/fdio#open
                     _path179196_
                     _flags179197_
                     _mode179198_))))
             (_raw179205_
              (std/os/fd#fdopen
               _fd179203_
               (std/os/fdio#file-direction _flags179197_)
               'file)))
        (std/os/fcntl#fd-set-nonblock/closeonexec _raw179205_)
        _raw179205_)))
  (define std/os/fdio#open__0
    (lambda (_path179211_ _flags179212_)
      (let ((_mode179214_ '0))
        (std/os/fdio#open__% _path179211_ _flags179212_ _mode179214_))))
  (define std/os/fdio#open
    (lambda _g300988_
      (let ((_g300987_ (let () (declare (not safe)) (##length _g300988_))))
        (cond ((let () (declare (not safe)) (##fx= _g300987_ 2))
               (apply std/os/fdio#open__0 _g300988_))
              ((let () (declare (not safe)) (##fx= _g300987_ 3))
               (apply std/os/fdio#open__% _g300988_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/fdio#open
                _g300988_))))))
  (define std/os/fdio#close
    (lambda (_raw179183_)
      (if (std/os/fd#fd? _raw179183_)
          (close-port _raw179183_)
          (let _lp179185_ ()
            (let ((_r179189_ (std/os/fdio#_close _raw179183_)))
              (if (not (let () (declare (not safe)) (##fxnegative? _r179189_)))
                  _r179189_
                  (let ((_errno179192_
                         (let () (declare (not safe)) (##fx- _r179189_))))
                    (if '#f
                        '#f
                        (if (eq? _errno179192_ std/os/error#EINTR)
                            (_lp179185_)
                            (std/os/error#raise-os-error
                             _errno179192_
                             std/os/fdio#close
                             _raw179183_))))))))))
  (define std/os/fdio#file-direction
    (lambda (_flags179181_)
      (if (let ((__tmp300989
                 (let ()
                   (declare (not safe))
                   (##fxand _flags179181_ std/os/fcntl#O_RDWR))))
            (declare (not safe))
            (##fx= __tmp300989 std/os/fcntl#O_RDWR))
          'inout
          (if (let ((__tmp300990
                     (let ()
                       (declare (not safe))
                       (##fxand _flags179181_ std/os/fcntl#O_RDONLY))))
                (declare (not safe))
                (##fx= __tmp300990 std/os/fcntl#O_RDONLY))
              'in
              (if (let ((__tmp300991
                         (let ()
                           (declare (not safe))
                           (##fxand _flags179181_ std/os/fcntl#O_WRONLY))))
                    (declare (not safe))
                    (##fx= __tmp300991 std/os/fcntl#O_WRONLY))
                  'out
                  (error '"Unspecified file direction" _flags179181_))))))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace
   ("std/os/fdio#"
    S_IXOTH
    S_IWOTH
    S_IROTH
    S_IRWXO
    S_IXGRP
    S_IWGRP
    S_IRGRP
    S_IRWXG
    S_IXUSR
    S_IRUSR
    S_IWUSR
    S_IRWXU
    _close
    _open
    _write
    _read))
  (c-declare "#include <unistd.h>")
  (c-declare "#include <sys/types.h>")
  (c-declare "#include <sys/stat.h>")
  (c-declare "#include <fcntl.h>")
  (define-const S_IRWXU)
  (define-const S_IRUSR)
  (define-const S_IWUSR)
  (define-const S_IXUSR)
  (define-const S_IRWXG)
  (define-const S_IRGRP)
  (define-const S_IWGRP)
  (define-const S_IXGRP)
  (define-const S_IRWXO)
  (define-const S_IROTH)
  (define-const S_IWOTH)
  (define-const S_IXOTH)
  (namespace ("std/os/fdio#" __read __write __open __close))
  (c-declare
   "static int ffi_fdio_read (int fd, ___SCMOBJ bytes, int start, int end);")
  (c-declare
   "static int ffi_fdio_write (int fd, ___SCMOBJ bytes, int start, int end);")
  (define-c-lambda __read (int scheme-object int int) int "ffi_fdio_read")
  (define-c-lambda __write (int scheme-object int int) int "ffi_fdio_write")
  (define-c-lambda __open (UTF-8-string int int) int "open")
  (define-c-lambda __close (int) int "close")
  (define-with-errno _read __read (fd bytes start end))
  (define-with-errno _write __write (fd bytes start end))
  (define-with-errno _open __open (path flags mode))
  (define-with-errno _close __close (fd))
  (c-declare
   "int ffi_fdio_read (int fd, ___SCMOBJ bytes, int start, int end)\n{\n return read (fd, U8_DATA (bytes) + start, end - start);\n}\n\nint ffi_fdio_write (int fd, ___SCMOBJ bytes, int start, int end)\n{\n return write (fd, U8_DATA (bytes) + start, end - start);\n}\n")
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif"))
