(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/socket#open-socket
    (lambda (_domain199365_ _type199366_ _proto199367_ _dir199368_)
      (let* ((_fd199373_
              (let ((_r199370_
                     (std/os/_socket#_socket
                      _domain199365_
                      _type199366_
                      _proto199367_)))
                (if (not (let ()
                           (declare (not safe))
                           (##fxnegative? _r199370_)))
                    _r199370_
                    (std/os/error#raise-os-error
                     (let () (declare (not safe)) (##fx- _r199370_))
                     std/os/socket#socket
                     _domain199365_
                     _type199366_
                     _proto199367_))))
             (_raw199375_ (std/os/fd#fdopen _fd199373_ _dir199368_ 'socket)))
        (std/os/fcntl#fd-set-nonblock/closeonexec _raw199375_)
        _raw199375_)))
  (define std/os/socket#socket__%
    (lambda (_domain199349_ _type199350_ _proto199351_)
      (std/os/socket#open-socket
       _domain199349_
       _type199350_
       _proto199351_
       'inout)))
  (define std/os/socket#socket__0
    (lambda (_domain199356_ _type199357_)
      (let ((_proto199359_ '0))
        (std/os/socket#socket__% _domain199356_ _type199357_ _proto199359_))))
  (define std/os/socket#socket
    (lambda _g301094_
      (let ((_g301093_ (let () (declare (not safe)) (##length _g301094_))))
        (cond ((let () (declare (not safe)) (##fx= _g301093_ 2))
               (apply std/os/socket#socket__0 _g301094_))
              ((let () (declare (not safe)) (##fx= _g301093_ 3))
               (apply std/os/socket#socket__% _g301094_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket
                _g301094_))))))
  (define std/os/socket#server-socket__%
    (lambda (_domain199332_ _type199333_ _proto199334_)
      (std/os/socket#open-socket
       _domain199332_
       _type199333_
       _proto199334_
       'in)))
  (define std/os/socket#server-socket__0
    (lambda (_domain199339_ _type199340_)
      (let ((_proto199342_ '0))
        (std/os/socket#server-socket__%
         _domain199339_
         _type199340_
         _proto199342_))))
  (define std/os/socket#server-socket
    (lambda _g301096_
      (let ((_g301095_ (let () (declare (not safe)) (##length _g301096_))))
        (cond ((let () (declare (not safe)) (##fx= _g301095_ 2))
               (apply std/os/socket#server-socket__0 _g301096_))
              ((let () (declare (not safe)) (##fx= _g301095_ 3))
               (apply std/os/socket#server-socket__% _g301096_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#server-socket
                _g301096_))))))
  (define std/os/socket#socket?
    (lambda (_obj199329_) (std/os/fd#fd-type? _obj199329_ 'socket)))
  (define std/os/socket#socket-bind
    (lambda (_sock199323_ _addr199324_)
      (let ((_r199326_
             (std/os/_socket#_bind
              (std/os/fd#fd-e _sock199323_)
              (std/os/socket#socket-address _addr199324_))))
        (if (not (let () (declare (not safe)) (##fxnegative? _r199326_)))
            _r199326_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r199326_))
             std/os/socket#socket-bind
             _sock199323_
             _addr199324_)))))
  (define std/os/socket#socket-listen__%
    (lambda (_sock199307_ _backlog199308_)
      (let ((_r199310_
             (std/os/_socket#_listen
              (std/os/fd#fd-e _sock199307_)
              _backlog199308_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r199310_)))
            _r199310_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r199310_))
             std/os/socket#socket-listen
             _sock199307_
             _backlog199308_)))))
  (define std/os/socket#socket-listen__0
    (lambda (_sock199316_)
      (let ((_backlog199318_ '10))
        (std/os/socket#socket-listen__% _sock199316_ _backlog199318_))))
  (define std/os/socket#socket-listen
    (lambda _g301098_
      (let ((_g301097_ (let () (declare (not safe)) (##length _g301098_))))
        (cond ((let () (declare (not safe)) (##fx= _g301097_ 1))
               (apply std/os/socket#socket-listen__0 _g301098_))
              ((let () (declare (not safe)) (##fx= _g301097_ 2))
               (apply std/os/socket#socket-listen__% _g301098_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-listen
                _g301098_))))))
  (define std/os/socket#socket-accept__%
    (lambda (_sock199272_ _sa199273_)
      (let ((_fd199274199289_
             (let _lp199276_ ()
               (let ((_r199280_
                      (std/os/_socket#_accept
                       (std/os/fd#fd-e _sock199272_)
                       _sa199273_)))
                 (if (not (let ()
                            (declare (not safe))
                            (##fxnegative? _r199280_)))
                     _r199280_
                     (let ((_errno199283_
                            (let () (declare (not safe)) (##fx- _r199280_))))
                       (if (or (eq? _errno199283_ std/os/error#EAGAIN)
                               (eq? _errno199283_ std/os/error#EWOULDBLOCK))
                           '#f
                           (if (eq? _errno199283_ std/os/error#EINTR)
                               (_lp199276_)
                               (std/os/error#raise-os-error
                                _errno199283_
                                std/os/socket#socket-accept
                                _sock199272_
                                _sa199273_)))))))))
        (if _fd199274199289_
            (let* ((_fd199292_ _fd199274199289_)
                   (_raw199294_ (std/os/fd#fdopen _fd199292_ 'inout 'socket)))
              (std/os/fcntl#fd-set-nonblock _raw199294_)
              (std/os/fcntl#fd-set-closeonexec _raw199294_)
              _raw199294_)
            '#f))))
  (define std/os/socket#socket-accept__0
    (lambda (_sock199299_)
      (let ((_sa199301_ '#f))
        (std/os/socket#socket-accept__% _sock199299_ _sa199301_))))
  (define std/os/socket#socket-accept
    (lambda _g301100_
      (let ((_g301099_ (let () (declare (not safe)) (##length _g301100_))))
        (cond ((let () (declare (not safe)) (##fx= _g301099_ 1))
               (apply std/os/socket#socket-accept__0 _g301100_))
              ((let () (declare (not safe)) (##fx= _g301099_ 2))
               (apply std/os/socket#socket-accept__% _g301100_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-accept
                _g301100_))))))
  (define std/os/socket#socket-connect
    (lambda (_sock199256_ _sa199257_)
      (let ((_sa199259_ (std/os/socket#socket-address _sa199257_)))
        (let _lp199261_ ()
          (let ((_r199265_
                 (std/os/_socket#_connect
                  (std/os/fd#fd-e _sock199256_)
                  _sa199259_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r199265_)))
                _r199265_
                (let ((_errno199268_
                       (let () (declare (not safe)) (##fx- _r199265_))))
                  (if (eq? _errno199268_ std/os/error#EINPROGRESS)
                      '#f
                      (if (eq? _errno199268_ std/os/error#EINTR)
                          (_lp199261_)
                          (std/os/error#raise-os-error
                           _errno199268_
                           std/os/socket#socket-connect
                           _sock199256_
                           _sa199259_))))))))))
  (define std/os/socket#socket-shutdown
    (lambda (_sock199250_ _how199251_)
      (let ((_r199253_
             (std/os/_socket#_shutdown
              (std/os/fd#fd-e _sock199250_)
              _how199251_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r199253_)))
            _r199253_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r199253_))
             std/os/socket#socket-shutdown
             _sock199250_
             _how199251_)))
      (if (eq? _how199251_ std/os/_socket#SHUT_RD)
          (close-input-port _sock199250_)
          (if (eq? _how199251_ std/os/_socket#SHUT_WR)
              (close-output-port _sock199250_)
              (if (eq? _how199251_ std/os/_socket#SHUT_RDWR)
                  (close-port _sock199250_)
                  '#!void)))))
  (define std/os/socket#socket-close
    (lambda (_sock199248_) (close-port _sock199248_)))
  (define std/os/socket#socket-send__%
    (lambda (_sock199196_
             _bytes199197_
             _start199198_
             _end199199_
             _flags199200_)
      (let _lp199202_ ()
        (let ((_r199206_
               (std/os/_socket#_send
                (std/os/fd#fd-e _sock199196_)
                _bytes199197_
                _start199198_
                _end199199_
                _flags199200_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r199206_)))
              _r199206_
              (let ((_errno199209_
                     (let () (declare (not safe)) (##fx- _r199206_))))
                (if (or (eq? _errno199209_ std/os/error#EAGAIN)
                        (eq? _errno199209_ std/os/error#EWOULDBLOCK))
                    '#f
                    (if (eq? _errno199209_ std/os/error#EINTR)
                        (_lp199202_)
                        (std/os/error#raise-os-error
                         _errno199209_
                         std/os/socket#socket-send
                         _sock199196_
                         _bytes199197_
                         _start199198_
                         _end199199_
                         _flags199200_)))))))))
  (define std/os/socket#socket-send__0
    (lambda (_sock199218_ _bytes199219_)
      (let* ((_start199221_ '0)
             (_end199223_ (u8vector-length _bytes199219_))
             (_flags199225_ '0))
        (std/os/socket#socket-send__%
         _sock199218_
         _bytes199219_
         _start199221_
         _end199223_
         _flags199225_))))
  (define std/os/socket#socket-send__1
    (lambda (_sock199227_ _bytes199228_ _start199229_)
      (let* ((_end199231_ (u8vector-length _bytes199228_)) (_flags199233_ '0))
        (std/os/socket#socket-send__%
         _sock199227_
         _bytes199228_
         _start199229_
         _end199231_
         _flags199233_))))
  (define std/os/socket#socket-send__2
    (lambda (_sock199235_ _bytes199236_ _start199237_ _end199238_)
      (let ((_flags199240_ '0))
        (std/os/socket#socket-send__%
         _sock199235_
         _bytes199236_
         _start199237_
         _end199238_
         _flags199240_))))
  (define std/os/socket#socket-send
    (lambda _g301102_
      (let ((_g301101_ (let () (declare (not safe)) (##length _g301102_))))
        (cond ((let () (declare (not safe)) (##fx= _g301101_ 2))
               (apply std/os/socket#socket-send__0 _g301102_))
              ((let () (declare (not safe)) (##fx= _g301101_ 3))
               (apply std/os/socket#socket-send__1 _g301102_))
              ((let () (declare (not safe)) (##fx= _g301101_ 4))
               (apply std/os/socket#socket-send__2 _g301102_))
              ((let () (declare (not safe)) (##fx= _g301101_ 5))
               (apply std/os/socket#socket-send__% _g301102_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-send
                _g301102_))))))
  (define std/os/socket#socket-sendto__%
    (lambda (_sock199136_
             _bytes199137_
             _sa199138_
             _start199139_
             _end199140_
             _flags199141_)
      (let ((_sa199143_ (std/os/socket#socket-address _sa199138_)))
        (let _lp199145_ ()
          (let ((_r199149_
                 (std/os/_socket#_sendto
                  (std/os/fd#fd-e _sock199136_)
                  _bytes199137_
                  _start199139_
                  _end199140_
                  _flags199141_
                  _sa199143_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r199149_)))
                _r199149_
                (let ((_errno199152_
                       (let () (declare (not safe)) (##fx- _r199149_))))
                  (if (or (eq? _errno199152_ std/os/error#EAGAIN)
                          (eq? _errno199152_ std/os/error#EWOULDBLOCK))
                      '#f
                      (if (eq? _errno199152_ std/os/error#EINTR)
                          (_lp199145_)
                          (std/os/error#raise-os-error
                           _errno199152_
                           std/os/socket#socket-sendto
                           _sock199136_
                           _bytes199137_
                           _sa199143_
                           _start199139_
                           _end199140_
                           _flags199141_))))))))))
  (define std/os/socket#socket-sendto__0
    (lambda (_sock199161_ _bytes199162_ _sa199163_)
      (let* ((_start199165_ '0)
             (_end199167_ (u8vector-length _bytes199162_))
             (_flags199169_ '0))
        (std/os/socket#socket-sendto__%
         _sock199161_
         _bytes199162_
         _sa199163_
         _start199165_
         _end199167_
         _flags199169_))))
  (define std/os/socket#socket-sendto__1
    (lambda (_sock199171_ _bytes199172_ _sa199173_ _start199174_)
      (let* ((_end199176_ (u8vector-length _bytes199172_)) (_flags199178_ '0))
        (std/os/socket#socket-sendto__%
         _sock199171_
         _bytes199172_
         _sa199173_
         _start199174_
         _end199176_
         _flags199178_))))
  (define std/os/socket#socket-sendto__2
    (lambda (_sock199180_ _bytes199181_ _sa199182_ _start199183_ _end199184_)
      (let ((_flags199186_ '0))
        (std/os/socket#socket-sendto__%
         _sock199180_
         _bytes199181_
         _sa199182_
         _start199183_
         _end199184_
         _flags199186_))))
  (define std/os/socket#socket-sendto
    (lambda _g301104_
      (let ((_g301103_ (let () (declare (not safe)) (##length _g301104_))))
        (cond ((let () (declare (not safe)) (##fx= _g301103_ 3))
               (apply std/os/socket#socket-sendto__0 _g301104_))
              ((let () (declare (not safe)) (##fx= _g301103_ 4))
               (apply std/os/socket#socket-sendto__1 _g301104_))
              ((let () (declare (not safe)) (##fx= _g301103_ 5))
               (apply std/os/socket#socket-sendto__2 _g301104_))
              ((let () (declare (not safe)) (##fx= _g301103_ 6))
               (apply std/os/socket#socket-sendto__% _g301104_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-sendto
                _g301104_))))))
  (define std/os/socket#socket-sendmsg
    (lambda (_sock199116_
             _name-bytes199117_
             _io-bytes199118_
             _ctl-bytes199119_
             _flags199120_)
      (let _lp199122_ ()
        (let ((_r199126_
               (std/os/_socket#_sendmsg
                (std/os/fd#fd-e _sock199116_)
                _name-bytes199117_
                _io-bytes199118_
                _ctl-bytes199119_
                _flags199120_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r199126_)))
              _r199126_
              (let ((_errno199129_
                     (let () (declare (not safe)) (##fx- _r199126_))))
                (if (or (eq? _errno199129_ std/os/error#EAGAIN)
                        (eq? _errno199129_ std/os/error#EWOULDBLOCK))
                    '#f
                    (if (eq? _errno199129_ std/os/error#EINTR)
                        (_lp199122_)
                        (std/os/error#raise-os-error
                         _errno199129_
                         std/os/socket#socket-sendmsg
                         _sock199116_
                         _name-bytes199117_
                         _io-bytes199118_
                         _ctl-bytes199119_
                         _flags199120_)))))))))
  (define std/os/socket#socket-recv__%
    (lambda (_sock199064_
             _bytes199065_
             _start199066_
             _end199067_
             _flags199068_)
      (let _lp199070_ ()
        (let ((_r199074_
               (std/os/_socket#_recv
                (std/os/fd#fd-e _sock199064_)
                _bytes199065_
                _start199066_
                _end199067_
                _flags199068_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r199074_)))
              _r199074_
              (let ((_errno199077_
                     (let () (declare (not safe)) (##fx- _r199074_))))
                (if (or (eq? _errno199077_ std/os/error#EAGAIN)
                        (eq? _errno199077_ std/os/error#EWOULDBLOCK))
                    '#f
                    (if (eq? _errno199077_ std/os/error#EINTR)
                        (_lp199070_)
                        (std/os/error#raise-os-error
                         _errno199077_
                         std/os/socket#socket-recv
                         _sock199064_
                         _bytes199065_
                         _start199066_
                         _end199067_
                         _flags199068_)))))))))
  (define std/os/socket#socket-recv__0
    (lambda (_sock199086_ _bytes199087_)
      (let* ((_start199089_ '0)
             (_end199091_ (u8vector-length _bytes199087_))
             (_flags199093_ '0))
        (std/os/socket#socket-recv__%
         _sock199086_
         _bytes199087_
         _start199089_
         _end199091_
         _flags199093_))))
  (define std/os/socket#socket-recv__1
    (lambda (_sock199095_ _bytes199096_ _start199097_)
      (let* ((_end199099_ (u8vector-length _bytes199096_)) (_flags199101_ '0))
        (std/os/socket#socket-recv__%
         _sock199095_
         _bytes199096_
         _start199097_
         _end199099_
         _flags199101_))))
  (define std/os/socket#socket-recv__2
    (lambda (_sock199103_ _bytes199104_ _start199105_ _end199106_)
      (let ((_flags199108_ '0))
        (std/os/socket#socket-recv__%
         _sock199103_
         _bytes199104_
         _start199105_
         _end199106_
         _flags199108_))))
  (define std/os/socket#socket-recv
    (lambda _g301106_
      (let ((_g301105_ (let () (declare (not safe)) (##length _g301106_))))
        (cond ((let () (declare (not safe)) (##fx= _g301105_ 2))
               (apply std/os/socket#socket-recv__0 _g301106_))
              ((let () (declare (not safe)) (##fx= _g301105_ 3))
               (apply std/os/socket#socket-recv__1 _g301106_))
              ((let () (declare (not safe)) (##fx= _g301105_ 4))
               (apply std/os/socket#socket-recv__2 _g301106_))
              ((let () (declare (not safe)) (##fx= _g301105_ 5))
               (apply std/os/socket#socket-recv__% _g301106_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-recv
                _g301106_))))))
  (define std/os/socket#socket-recvfrom__%
    (lambda (_sock199006_
             _bytes199007_
             _sa199008_
             _start199009_
             _end199010_
             _flags199011_)
      (let _lp199013_ ()
        (let ((_r199017_
               (std/os/_socket#_recvfrom
                (std/os/fd#fd-e _sock199006_)
                _bytes199007_
                _start199009_
                _end199010_
                _flags199011_
                _sa199008_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r199017_)))
              _r199017_
              (let ((_errno199020_
                     (let () (declare (not safe)) (##fx- _r199017_))))
                (if (or (eq? _errno199020_ std/os/error#EAGAIN)
                        (eq? _errno199020_ std/os/error#EWOULDBLOCK))
                    '#f
                    (if (eq? _errno199020_ std/os/error#EINTR)
                        (_lp199013_)
                        (std/os/error#raise-os-error
                         _errno199020_
                         std/os/socket#socket-recvfrom
                         _sock199006_
                         _bytes199007_
                         _sa199008_
                         _start199009_
                         _end199010_
                         _flags199011_)))))))))
  (define std/os/socket#socket-recvfrom__0
    (lambda (_sock199029_ _bytes199030_ _sa199031_)
      (let* ((_start199033_ '0)
             (_end199035_ (u8vector-length _bytes199030_))
             (_flags199037_ '0))
        (std/os/socket#socket-recvfrom__%
         _sock199029_
         _bytes199030_
         _sa199031_
         _start199033_
         _end199035_
         _flags199037_))))
  (define std/os/socket#socket-recvfrom__1
    (lambda (_sock199039_ _bytes199040_ _sa199041_ _start199042_)
      (let* ((_end199044_ (u8vector-length _bytes199040_)) (_flags199046_ '0))
        (std/os/socket#socket-recvfrom__%
         _sock199039_
         _bytes199040_
         _sa199041_
         _start199042_
         _end199044_
         _flags199046_))))
  (define std/os/socket#socket-recvfrom__2
    (lambda (_sock199048_ _bytes199049_ _sa199050_ _start199051_ _end199052_)
      (let ((_flags199054_ '0))
        (std/os/socket#socket-recvfrom__%
         _sock199048_
         _bytes199049_
         _sa199050_
         _start199051_
         _end199052_
         _flags199054_))))
  (define std/os/socket#socket-recvfrom
    (lambda _g301108_
      (let ((_g301107_ (let () (declare (not safe)) (##length _g301108_))))
        (cond ((let () (declare (not safe)) (##fx= _g301107_ 3))
               (apply std/os/socket#socket-recvfrom__0 _g301108_))
              ((let () (declare (not safe)) (##fx= _g301107_ 4))
               (apply std/os/socket#socket-recvfrom__1 _g301108_))
              ((let () (declare (not safe)) (##fx= _g301107_ 5))
               (apply std/os/socket#socket-recvfrom__2 _g301108_))
              ((let () (declare (not safe)) (##fx= _g301107_ 6))
               (apply std/os/socket#socket-recvfrom__% _g301108_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-recvfrom
                _g301108_))))))
  (define std/os/socket#socket-recvmsg*
    (lambda (_sock198983_
             _name-bytes198984_
             _rname198985_
             _io-bytes198986_
             _ctl-bytes198987_
             _rctl198988_
             _flags198989_
             _rflags198990_)
      (let _lp198992_ ()
        (let ((_r198996_
               (std/os/_socket#_recvmsg
                (std/os/fd#fd-e _sock198983_)
                _name-bytes198984_
                _rname198985_
                _io-bytes198986_
                _ctl-bytes198987_
                _rctl198988_
                _flags198989_
                _rflags198990_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198996_)))
              _r198996_
              (let ((_errno198999_
                     (let () (declare (not safe)) (##fx- _r198996_))))
                (if (or (eq? _errno198999_ std/os/error#EAGAIN)
                        (eq? _errno198999_ std/os/error#EWOULDBLOCK))
                    '#f
                    (if (eq? _errno198999_ std/os/error#EINTR)
                        (_lp198992_)
                        (std/os/error#raise-os-error
                         _errno198999_
                         std/os/socket#socket-recvmsg
                         _sock198983_
                         _name-bytes198984_
                         _io-bytes198986_
                         _ctl-bytes198987_
                         _flags198989_)))))))))
  (define std/os/socket#socket-recvmsg
    (lambda (_sock198962_ _name198963_ _io198964_ _ctl198965_ _flags198966_)
      (let* ((_rname198971_
              (if _name198963_
                  (let ((_r198968_ (std/os/_socket#make_int_ptr)))
                    (if _r198968_
                        _r198968_
                        (error '"Error allocating memory" 'make_int_ptr)))
                  '#f))
             (_rctl198976_
              (if _ctl198965_
                  (let ((_r198973_ (std/os/_socket#make_int_ptr)))
                    (if _r198973_
                        _r198973_
                        (error '"Error allocating memory" 'make_int_ptr)))
                  '#f))
             (_rflags198978_ (std/os/_socket#make_int_ptr))
             (_r198980_
              (std/os/socket#socket-recvmsg*
               _sock198962_
               _name198963_
               _rname198971_
               _io198964_
               _ctl198965_
               _rctl198976_
               _flags198966_
               _rflags198978_)))
        (if _r198980_
            (values _r198980_
                    (if _rname198971_
                        (std/os/_socket#int_ptr_value _rname198971_)
                        '#f)
                    (if _rctl198976_
                        (std/os/_socket#int_ptr_value _rctl198976_)
                        '#f)
                    (std/os/_socket#int_ptr_value _rflags198978_))
            '#f))))
  (define std/os/socket#socket-getpeername__%
    (lambda (_sock198941_ _sa198942_)
      (let ((_sa198947_
             (let ((_$e198944_ _sa198942_))
               (if _$e198944_
                   _$e198944_
                   (std/os/socket#make-socket-address
                    (std/os/socket#socket-domain _sock198941_))))))
        (let ((_r198949_
               (std/os/_socket#_getpeername
                (std/os/fd#fd-e _sock198941_)
                _sa198947_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198949_)))
              _r198949_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198949_))
               std/os/socket#socket-getpeername
               _sock198941_)))
        _sa198947_)))
  (define std/os/socket#socket-getpeername__0
    (lambda (_sock198955_)
      (let ((_sa198957_ '#f))
        (std/os/socket#socket-getpeername__% _sock198955_ _sa198957_))))
  (define std/os/socket#socket-getpeername
    (lambda _g301110_
      (let ((_g301109_ (let () (declare (not safe)) (##length _g301110_))))
        (cond ((let () (declare (not safe)) (##fx= _g301109_ 1))
               (apply std/os/socket#socket-getpeername__0 _g301110_))
              ((let () (declare (not safe)) (##fx= _g301109_ 2))
               (apply std/os/socket#socket-getpeername__% _g301110_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-getpeername
                _g301110_))))))
  (define std/os/socket#socket-getsockname__%
    (lambda (_sock198919_ _sa198920_)
      (let ((_sa198925_
             (let ((_$e198922_ _sa198920_))
               (if _$e198922_
                   _$e198922_
                   (std/os/socket#make-socket-address
                    (std/os/socket#socket-domain _sock198919_))))))
        (let ((_r198927_
               (std/os/_socket#_getsockname
                (std/os/fd#fd-e _sock198919_)
                _sa198925_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198927_)))
              _r198927_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198927_))
               std/os/socket#socket-getsockname
               _sock198919_)))
        _sa198925_)))
  (define std/os/socket#socket-getsockname__0
    (lambda (_sock198933_)
      (let ((_sa198935_ '#f))
        (std/os/socket#socket-getsockname__% _sock198933_ _sa198935_))))
  (define std/os/socket#socket-getsockname
    (lambda _g301112_
      (let ((_g301111_ (let () (declare (not safe)) (##length _g301112_))))
        (cond ((let () (declare (not safe)) (##fx= _g301111_ 1))
               (apply std/os/socket#socket-getsockname__0 _g301112_))
              ((let () (declare (not safe)) (##fx= _g301111_ 2))
               (apply std/os/socket#socket-getsockname__% _g301112_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-getsockname
                _g301112_))))))
  (define std/os/socket#socket-domain
    (lambda (_sock198916_)
      (std/os/socket#socket-getsockopt
       _sock198916_
       std/os/_socket#SOL_SOCKET
       std/os/_socket#SO_DOMAIN)))
  (define std/os/socket#socket-address?
    (lambda (_obj198914_) (std/os/_socket#sockaddr? _obj198914_)))
  (define std/os/socket#make-socket-address
    (lambda (_af198909_)
      (let ((_r198911_ (std/os/_socket#make_sockaddr _af198909_)))
        (if _r198911_
            _r198911_
            (error '"Error allocating memory" 'make_sockaddr)))))
  (define std/os/socket#make-socket-address-in
    (lambda () (std/os/socket#make-socket-address std/os/_socket#AF_INET)))
  (define std/os/socket#make-socket-address-in6
    (lambda () (std/os/socket#make-socket-address std/os/_socket#AF_INET6)))
  (define std/os/socket#make-socket-address-un
    (lambda () (std/os/socket#make-socket-address std/os/_socket#AF_UNIX)))
  (define std/os/socket#socket-address-in
    (lambda (_host198898_ _port198899_)
      (let* ((_ip4198901_ (std/net/address#ip4-address _host198898_))
             (_sa198903_ (std/os/socket#make-socket-address-in)))
        (std/os/_socket#sockaddr_in_addr_set _sa198903_ _ip4198901_)
        (std/os/_socket#sockaddr_in_port_set _sa198903_ _port198899_)
        _sa198903_)))
  (define std/os/socket#socket-address-in6
    (lambda (_host198890_ _port198891_)
      (let* ((_ip6198893_ (std/net/address#ip6-address _host198890_))
             (_sa198895_ (std/os/socket#make-socket-address-in6)))
        (std/os/_socket#sockaddr_in6_addr_set _sa198895_ _ip6198893_)
        (std/os/_socket#sockaddr_in6_port_set _sa198895_ _port198891_)
        _sa198895_)))
  (define std/os/socket#socket-address-un
    (lambda (_path198884_)
      (let ((_pathlen198886_
             (std/text/utf8#string-utf8-length__0 _path198884_)))
        (if (let ()
              (declare (not safe))
              (##fx< _pathlen198886_ std/os/_socket#UNIX_MAX_PATH))
            (let ((_sa198888_ (std/os/socket#make-socket-address-un)))
              (std/os/_socket#sockaddr_un_path_set _sa198888_ _path198884_)
              _sa198888_)
            (error '"Malformed address; path is too long")))))
  (define std/os/socket#socket-address-family
    (lambda (_sa198882_) (std/os/_socket#sockaddr_family _sa198882_)))
  (define std/os/socket#socket-address
    (lambda (_addr198877_)
      (if (std/os/_socket#sockaddr? _addr198877_)
          _addr198877_
          (if (or (std/net/address#inet-address? _addr198877_)
                  (std/net/address#inet-address-string? _addr198877_))
              (std/os/socket#inet-address->socket-address _addr198877_)
              (std/os/socket#socket-address-un _addr198877_)))))
  (define std/os/socket#inet-address->socket-address
    (lambda (_addr198847_)
      (let* ((_g198848198855_ (std/net/address#resolve-address _addr198847_))
             (_E198850198859_
              (lambda () (error '"No clause matching" _g198848198855_)))
             (_K198851198865_
              (lambda (_port198862_ _ip198863_)
                (if (std/net/address#ip4-address? _ip198863_)
                    (std/os/socket#socket-address-in _ip198863_ _port198862_)
                    (if (std/net/address#ip6-address? _ip198863_)
                        (std/os/socket#socket-address-in6
                         _ip198863_
                         _port198862_)
                        (error '"Bad address; expected ip4 or ip6 inet-address"
                               _addr198847_))))))
        (if (let () (declare (not safe)) (##pair? _g198848198855_))
            (let ((_hd198852198868_
                   (let () (declare (not safe)) (##car _g198848198855_)))
                  (_tl198853198870_
                   (let () (declare (not safe)) (##cdr _g198848198855_))))
              (let* ((_ip198873_ _hd198852198868_)
                     (_port198875_ _tl198853198870_))
                (_K198851198865_ _port198875_ _ip198873_)))
            (_E198850198859_)))))
  (define std/os/socket#socket-address->address
    (lambda (_sa198831_)
      (let ((_saf198833_ (std/os/_socket#sockaddr_family _sa198831_)))
        (if (eq? _saf198833_ std/os/_socket#AF_INET)
            (let* ((_ip4198835_ (make-u8vector '4))
                   (_g301113_
                    (std/os/_socket#sockaddr_in_addr _sa198831_ _ip4198835_))
                   (_port198838_ (std/os/_socket#sockaddr_in_port _sa198831_)))
              (cons _ip4198835_ _port198838_))
            (if (eq? _saf198833_ std/os/_socket#AF_INET6)
                (let* ((_ip6198841_ (make-u8vector '16))
                       (_g301114_
                        (std/os/_socket#sockaddr_in6_addr
                         _sa198831_
                         _ip6198841_))
                       (_port198844_
                        (std/os/_socket#sockaddr_in6_port _sa198831_)))
                  (cons _ip6198841_ _port198844_))
                (if (eq? _saf198833_ std/os/_socket#AF_UNIX)
                    (std/os/_socket#sockaddr_un_path _sa198831_)
                    (error '"Unknown address family"
                           _sa198831_
                           _saf198833_)))))))
  (define std/os/socket#socket-address->string
    (lambda (_sa198815_)
      (let ((_saf198817_ (std/os/_socket#sockaddr_family _sa198815_)))
        (if (eq? _saf198817_ std/os/_socket#AF_INET)
            (let* ((_ip4198819_ (make-u8vector '4))
                   (_g301115_
                    (std/os/_socket#sockaddr_in_addr _sa198815_ _ip4198819_))
                   (_port198822_ (std/os/_socket#sockaddr_in_port _sa198815_)))
              (string-append
               (std/net/address#ip4-address->string _ip4198819_)
               '":"
               (number->string _port198822_)))
            (if (eq? _saf198817_ std/os/_socket#AF_INET6)
                (let* ((_ip6198825_ (make-u8vector '16))
                       (_g301116_
                        (std/os/_socket#sockaddr_in6_addr
                         _sa198815_
                         _ip6198825_))
                       (_port198828_
                        (std/os/_socket#sockaddr_in6_port _sa198815_)))
                  (string-append
                   (std/net/address#ip6-address->string _ip6198825_)
                   '":"
                   (number->string _port198828_)))
                (if (eq? _saf198817_ std/os/_socket#AF_UNIX)
                    (std/os/_socket#sockaddr_un_path _sa198815_)
                    (error '"Unknown address family"
                           _sa198815_
                           _saf198817_)))))))
  (define std/os/socket#socket-getsockopt
    (lambda (_sock198769_ _level198770_ _opt198771_ . _args198772_)
      (let ((_$e198774_
             (table-ref std/os/socket#socket-sockopts _level198770_ '#f)))
        (if _$e198774_
            ((lambda (_ht198777_)
               (let ((_$e198779_ (table-ref _ht198777_ _opt198771_ '#f)))
                 (if _$e198779_
                     ((lambda (_e198781198783_)
                        (let* ((_g198785198792_ _e198781198783_)
                               (_E198787198796_
                                (lambda ()
                                  (error '"No clause matching"
                                         _g198785198792_)))
                               (_K198788198802_
                                (lambda (_setf198799_ _getf198800_)
                                  (if _getf198800_
                                      (apply _getf198800_
                                             _sock198769_
                                             _level198770_
                                             _opt198771_
                                             _args198772_)
                                      (error '"No getsockopt operation defined for option"
                                             _level198770_
                                             _opt198771_)))))
                          (if (let ((__tmp301117
                                     (if (let ()
                                           (declare (not safe))
                                           (##values? _g198785198792_))
                                         (let ()
                                           (declare (not safe))
                                           (##vector-length _g198785198792_))
                                         '1)))
                                (declare (not safe))
                                (##fx= __tmp301117 '2))
                              (let* ((_e198789198805_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _g198785198792_ '0)))
                                     (_getf198808_ _e198789198805_)
                                     (_e198790198810_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _g198785198792_ '1)))
                                     (_setf198813_ _e198790198810_))
                                (_K198788198802_ _setf198813_ _getf198808_))
                              (_E198787198796_))))
                      _$e198779_)
                     (error '"Unknown socket option"
                            _level198770_
                            _opt198771_))))
             _$e198774_)
            (error '"Unknown socket level" _level198770_ _opt198771_)))))
  (define std/os/socket#socket-setsockopt
    (lambda (_sock198722_ _level198723_ _opt198724_ _val198725_ . _args198726_)
      (let ((_$e198728_
             (table-ref std/os/socket#socket-sockopts _level198723_ '#f)))
        (if _$e198728_
            ((lambda (_ht198731_)
               (let ((_$e198733_ (table-ref _ht198731_ _opt198724_ '#f)))
                 (if _$e198733_
                     ((lambda (_e198735198737_)
                        (let* ((_g198739198746_ _e198735198737_)
                               (_E198741198750_
                                (lambda ()
                                  (error '"No clause matching"
                                         _g198739198746_)))
                               (_K198742198756_
                                (lambda (_setf198753_ _getf198754_)
                                  (if _setf198753_
                                      (apply _setf198753_
                                             _sock198722_
                                             _level198723_
                                             _opt198724_
                                             _val198725_
                                             _args198726_)
                                      (error '"No setsockopt operation defined for option"
                                             _level198723_
                                             _opt198724_)))))
                          (if (let ((__tmp301118
                                     (if (let ()
                                           (declare (not safe))
                                           (##values? _g198739198746_))
                                         (let ()
                                           (declare (not safe))
                                           (##vector-length _g198739198746_))
                                         '1)))
                                (declare (not safe))
                                (##fx= __tmp301118 '2))
                              (let* ((_e198743198759_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _g198739198746_ '0)))
                                     (_getf198762_ _e198743198759_)
                                     (_e198744198764_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _g198739198746_ '1)))
                                     (_setf198767_ _e198744198764_))
                                (_K198742198756_ _setf198767_ _getf198762_))
                              (_E198741198750_))))
                      _$e198733_)
                     (error '"Unknown socket option"
                            _level198723_
                            _opt198724_))))
             _$e198728_)
            (error '"Unknown socket level" _level198723_ _opt198724_)))))
  (define std/os/socket#socket-getsockopt-int
    (lambda (_sock198715_ _level198716_ _opt198717_)
      (let ((_r198719_
             (std/os/_socket#_getsockopt_int
              (std/os/fd#fd-e _sock198715_)
              _level198716_
              _opt198717_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r198719_)))
            _r198719_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r198719_))
             std/os/socket#socket-getsockopt
             _sock198715_
             _level198716_
             _opt198717_)))))
  (define std/os/socket#socket-setsockopt-int
    (lambda (_sock198707_ _level198708_ _opt198709_ _val198710_)
      (if (fixnum? _val198710_)
          (let ((_r198712_
                 (std/os/_socket#_setsockopt_int
                  (std/os/fd#fd-e _sock198707_)
                  _level198708_
                  _opt198709_
                  _val198710_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r198712_)))
                _r198712_
                (std/os/error#raise-os-error
                 (let () (declare (not safe)) (##fx- _r198712_))
                 std/os/socket#socket-setsockopt
                 _sock198707_
                 _level198708_
                 _opt198709_
                 _val198710_)))
          (error '"Bad argument; expected fixnum" _val198710_))))
  (define std/os/socket#socket-getsockopt-tv
    (lambda (_sock198695_ _level198696_ _opt198697_)
      (let ((_tv198702_
             (let ((_r198699_ (std/os/_socket#make_tv)))
               (if _r198699_
                   _r198699_
                   (error '"Error allocating memory" 'make_tv)))))
        (let ((_r198704_
               (std/os/_socket#_getsockopt_tv
                (std/os/fd#fd-e _sock198695_)
                _level198696_
                _opt198697_
                _tv198702_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198704_)))
              _r198704_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198704_))
               std/os/socket#socket-getsockopt
               _sock198695_
               _level198696_
               _opt198697_)))
        (+ (std/os/_socket#tv_sec _tv198702_)
           (/ (std/os/_socket#tv_usec _tv198702_) '1000000.)))))
  (define std/os/socket#socket-setsockopt-tv
    (lambda (_sock198675_ _level198676_ _opt198677_ _tm198678_)
      (if (real? _tm198678_)
          (let* ((_tm-sec198680_ (floor _tm198678_))
                 (_tm-frac198682_ (- _tm198678_ _tm-sec198680_))
                 (_tm-usec198684_ (floor (* _tm-frac198682_ '1000000.)))
                 (_tv198689_
                  (let ((_r198686_ (std/os/_socket#make_tv)))
                    (if _r198686_
                        _r198686_
                        (error '"Error allocating memory" 'make_tv)))))
            (std/os/_socket#tv_sec_set
             _tv198689_
             (inexact->exact _tm-sec198680_))
            (std/os/_socket#tv_usec_set
             _tv198689_
             (inexact->exact _tm-usec198684_))
            (let ((_r198692_
                   (std/os/_socket#_setsockopt_tv
                    (std/os/fd#fd-e _sock198675_)
                    _level198676_
                    _opt198677_
                    _tv198689_)))
              (if (not (let () (declare (not safe)) (##fxnegative? _r198692_)))
                  _r198692_
                  (std/os/error#raise-os-error
                   (let () (declare (not safe)) (##fx- _r198692_))
                   std/os/socket#socket-setsockopt
                   _sock198675_
                   _level198676_
                   _opt198677_
                   _tm198678_))))
          (error '"Bad argument; expected real" _tm198678_))))
  (define std/os/socket#socket-getsockopt-addr-in
    (lambda (_sock198666_ _level198667_ _opt198668_)
      (let ((_sa198670_ (std/os/socket#make-socket-address-in)))
        (let ((_r198672_
               (std/os/_socket#_getsockopt_sa
                (std/os/fd#fd-e _sock198666_)
                _level198667_
                _opt198668_
                _sa198670_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198672_)))
              _r198672_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198672_))
               std/os/socket#socket-getsockopt
               _sock198666_
               _level198667_
               _opt198668_)))
        _sa198670_)))
  (define std/os/socket#socket-getsockopt-addr-in6
    (lambda (_sock198657_ _level198658_ _opt198659_)
      (let ((_sa198661_ (std/os/socket#make-socket-address-in6)))
        (let ((_r198663_
               (std/os/_socket#_getsockopt_sa
                (std/os/fd#fd-e _sock198657_)
                _level198658_
                _opt198659_
                _sa198661_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198663_)))
              _r198663_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198663_))
               std/os/socket#socket-getsockopt
               _sock198657_
               _level198658_
               _opt198659_)))
        _sa198661_)))
  (define std/os/socket#socket-setsockopt-addr
    (lambda (_sock198647_ _level198648_ _opt198649_ _addr198650_)
      (let* ((_sa198652_ (std/os/socket#socket-address _addr198650_))
             (_r198654_
              (std/os/_socket#_setsockopt_sa
               (std/os/fd#fd-e _sock198647_)
               _level198648_
               _opt198649_
               _sa198652_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r198654_)))
            _r198654_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r198654_))
             std/os/socket#socket-setsockopt
             _sock198647_
             _level198648_
             _opt198649_
             _addr198650_)))))
  (define std/os/socket#socket-getsockopt-bytes
    (lambda (_sock198639_ _level198640_ _opt198641_ _bytes198642_)
      (if (u8vector? _bytes198642_)
          (let ((_r198644_
                 (std/os/_socket#_getsockopt_bytes
                  (std/os/fd#fd-e _sock198639_)
                  _level198640_
                  _opt198641_
                  _bytes198642_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r198644_)))
                _r198644_
                (std/os/error#raise-os-error
                 (let () (declare (not safe)) (##fx- _r198644_))
                 std/os/socket#socket-getsockopt
                 _sock198639_
                 _level198640_
                 _opt198641_
                 _bytes198642_)))
          (error '"Bad argument; expected bytes" _bytes198642_))))
  (define std/os/socket#socket-setsockopt-bytes
    (lambda (_sock198631_ _level198632_ _opt198633_ _bytes198634_)
      (if (u8vector? _bytes198634_)
          (let ((_r198636_
                 (std/os/_socket#_setsockopt_bytes
                  (std/os/fd#fd-e _sock198631_)
                  _level198632_
                  _opt198633_
                  _bytes198634_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r198636_)))
                _r198636_
                (std/os/error#raise-os-error
                 (let () (declare (not safe)) (##fx- _r198636_))
                 std/os/socket#socket-setsockopt
                 _sock198631_
                 _level198632_
                 _opt198633_
                 _bytes198634_)))
          (error '"Bad argument; expected bytes" _bytes198634_))))
  (define std/os/socket#socket-setsockopt-mreq
    (lambda (_sock198587_ _level198588_ _opt198589_ _ips198590_)
      (let* ((_ips198591198599_ _ips198590_)
             (_else198593198607_
              (lambda ()
                (error '"Bad argument; expected pair of ip4 addresses"
                       _ips198590_)))
             (_K198595198619_
              (lambda (_laddr198610_ _maddr198611_)
                (let ((_maddr198613_
                       (std/net/address#ip4-address _maddr198611_))
                      (_laddr198614_
                       (std/net/address#ip4-address _laddr198610_)))
                  (let ((_r198616_
                         (std/os/_socket#_setsockopt_mreq
                          (std/os/fd#fd-e _sock198587_)
                          _level198588_
                          _opt198589_
                          _maddr198613_
                          _laddr198614_)))
                    (if (not (let ()
                               (declare (not safe))
                               (##fxnegative? _r198616_)))
                        _r198616_
                        (std/os/error#raise-os-error
                         (let () (declare (not safe)) (##fx- _r198616_))
                         std/os/socket#socket-setsockopt
                         _sock198587_
                         _level198588_
                         _opt198589_
                         _ips198590_)))))))
        (if (let () (declare (not safe)) (##pair? _ips198591198599_))
            (let ((_hd198596198622_
                   (let () (declare (not safe)) (##car _ips198591198599_)))
                  (_tl198597198624_
                   (let () (declare (not safe)) (##cdr _ips198591198599_))))
              (let* ((_maddr198627_ _hd198596198622_)
                     (_laddr198629_ _tl198597198624_))
                (_K198595198619_ _laddr198629_ _maddr198627_)))
            (_else198593198607_)))))
  (define std/os/socket#socket-setsockopt-mreq-src
    (lambda (_sock198525_ _level198526_ _opt198527_ _ips198528_)
      (let* ((_ips198529198541_ _ips198528_)
             (_else198531198549_
              (lambda ()
                (error '"Bad argument; expected list with 3 ip4 addresses"
                       _ips198528_)))
             (_K198533198563_
              (lambda (_saddr198552_ _iaddr198553_ _maddr198554_)
                (let ((_maddr198556_
                       (std/net/address#ip4-address _maddr198554_))
                      (_iaddr198557_
                       (std/net/address#ip4-address _iaddr198553_))
                      (_saddr198558_
                       (std/net/address#ip4-address _saddr198552_)))
                  (let ((_r198560_
                         (std/os/_socket#_setsockopt_mreq_src
                          (std/os/fd#fd-e _sock198525_)
                          _level198526_
                          _opt198527_
                          _maddr198556_
                          _iaddr198557_
                          _saddr198558_)))
                    (if (not (let ()
                               (declare (not safe))
                               (##fxnegative? _r198560_)))
                        _r198560_
                        (std/os/error#raise-os-error
                         (let () (declare (not safe)) (##fx- _r198560_))
                         std/os/socket#socket-setsockopt
                         _sock198525_
                         _level198526_
                         _opt198527_
                         _ips198528_)))))))
        (if (let () (declare (not safe)) (##pair? _ips198529198541_))
            (let ((_hd198534198566_
                   (let () (declare (not safe)) (##car _ips198529198541_)))
                  (_tl198535198568_
                   (let () (declare (not safe)) (##cdr _ips198529198541_))))
              (let ((_maddr198571_ _hd198534198566_))
                (if (let () (declare (not safe)) (##pair? _tl198535198568_))
                    (let ((_hd198536198573_
                           (let ()
                             (declare (not safe))
                             (##car _tl198535198568_)))
                          (_tl198537198575_
                           (let ()
                             (declare (not safe))
                             (##cdr _tl198535198568_))))
                      (let ((_iaddr198578_ _hd198536198573_))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl198537198575_))
                            (let ((_hd198538198580_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl198537198575_)))
                                  (_tl198539198582_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl198537198575_))))
                              (let ((_saddr198585_ _hd198538198580_))
                                (if (let ()
                                      (declare (not safe))
                                      (##null? _tl198539198582_))
                                    (_K198533198563_
                                     _saddr198585_
                                     _iaddr198578_
                                     _maddr198571_)
                                    (_else198531198549_))))
                            (_else198531198549_))))
                    (_else198531198549_))))
            (_else198531198549_)))))
  (define std/os/socket#socket-setsockopt-mreq6
    (lambda (_sock198482_ _level198483_ _opt198484_ _ips198485_)
      (let* ((_ips198486198494_ _ips198485_)
             (_else198488198502_
              (lambda ()
                (error '"Bad argument; expected pair of ip6 addresses"
                       _ips198485_)))
             (_K198490198513_
              (lambda (_ifindex198505_ _maddr198506_)
                (let* ((_maddr198508_
                        (std/net/address#ip6-address _maddr198506_))
                       (_r198510_
                        (std/os/_socket#_setsockopt_mreq6
                         (std/os/fd#fd-e _sock198482_)
                         _level198483_
                         _opt198484_
                         _maddr198508_
                         _ifindex198505_)))
                  (if (not (let ()
                             (declare (not safe))
                             (##fxnegative? _r198510_)))
                      _r198510_
                      (std/os/error#raise-os-error
                       (let () (declare (not safe)) (##fx- _r198510_))
                       std/os/socket#socket-setsockopt
                       _sock198482_
                       _level198483_
                       _opt198484_
                       _ips198485_))))))
        (if (let () (declare (not safe)) (##pair? _ips198486198494_))
            (let ((_hd198491198516_
                   (let () (declare (not safe)) (##car _ips198486198494_)))
                  (_tl198492198518_
                   (let () (declare (not safe)) (##cdr _ips198486198494_))))
              (let* ((_maddr198521_ _hd198491198516_)
                     (_ifindex198523_ _tl198492198518_))
                (_K198490198513_ _ifindex198523_ _maddr198521_)))
            (_else198488198502_)))))
  (define std/os/socket#socket-getsockopt-linger
    (lambda (_sock198470_ _level198471_ _opt198472_)
      (let ((_linger198477_
             (let ((_r198474_ (std/os/_socket#make_linger)))
               (if _r198474_
                   _r198474_
                   (error '"Error allocating memory" 'make_linger)))))
        (let ((_r198479_
               (std/os/_socket#_getsockopt_linger
                _sock198470_
                _level198471_
                _opt198472_
                _linger198477_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198479_)))
              _r198479_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198479_))
               std/os/socket#socket-getsockopt
               _sock198470_
               _level198471_
               _opt198472_)))
        (if (let ((__tmp301119 (std/os/_socket#linger_onoff _linger198477_)))
              (declare (not safe))
              (##fxzero? __tmp301119))
            '#f
            (std/os/_socket#linger_linger _linger198477_)))))
  (define std/os/socket#socket-setsockopt-linger
    (lambda (_sock198457_ _level198458_ _opt198459_ _val198460_)
      (let ((_linger198465_
             (let ((_r198462_ (std/os/_socket#make_linger)))
               (if _r198462_
                   _r198462_
                   (error '"Error allocating memory" 'make_linger)))))
        (if (fixnum? _val198460_)
            (begin
              (std/os/_socket#linger_onoff_set _linger198465_ '1)
              (std/os/_socket#linger_linger_set _linger198465_ _val198460_))
            (if (not _val198460_)
                (begin
                  (std/os/_socket#linger_onoff_set _linger198465_ '0)
                  (std/os/_socket#linger_linger_set _linger198465_ '0))
                (error '"Bad argument; expected fixnum or #f" _val198460_)))
        (let ((_r198467_
               (std/os/_socket#_setsockopt_linger
                _sock198457_
                _level198458_
                _opt198459_
                _linger198465_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198467_)))
              _r198467_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198467_))
               std/os/socket#socket-setsockopt
               _sock198457_
               _level198458_
               _opt198459_
               _val198460_))))))
  (define std/os/socket#socket-sockopts
    (let ((_ht198454_ (make-table 'test: eq? 'size: '4)))
      (table-set! _ht198454_ std/os/_socket#SOL_SOCKET (make-table 'test: eq?))
      (table-set! _ht198454_ std/os/_socket#IPPROTO_IP (make-table 'test: eq?))
      (table-set!
       _ht198454_
       std/os/_socket#IPPROTO_IPV6
       (make-table 'test: eq?))
      (table-set!
       _ht198454_
       std/os/_socket#IPPROTO_TCP
       (make-table 'test: eq?))
      _ht198454_))
  (if std/os/_socket#SO_ACCEPTCONN
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_ACCEPTCONN
       (values std/os/socket#socket-getsockopt-int '#f))
      '#!void)
  (if std/os/_socket#SO_BINDTODEVICE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_BINDTODEVICE
       (values std/os/socket#socket-getsockopt-bytes
               std/os/socket#socket-setsockopt-bytes))
      '#!void)
  (if std/os/_socket#SO_BROADCAST
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_BROADCAST
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_DEBUG
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_DEBUG
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_DOMAIN
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_DOMAIN
       (values std/os/socket#socket-getsockopt-int '#f))
      '#!void)
  (if std/os/_socket#SO_DONTROUTE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_DONTROUTE
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_ERROR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_ERROR
       (values std/os/socket#socket-getsockopt-int '#f))
      '#!void)
  (if std/os/_socket#SO_KEEPALIVE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_KEEPALIVE
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_LINGER
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_LINGER
       (values std/os/socket#socket-getsockopt-linger
               std/os/socket#socket-setsockopt-linger))
      '#!void)
  (if std/os/_socket#SO_OOBLINE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_OOBLINE
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_PASSCRED
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_PASSCRED
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_PEERCRED
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_PEERCRED
       (values std/os/socket#socket-getsockopt-bytes
               std/os/socket#socket-setsockopt-bytes))
      '#!void)
  (if std/os/_socket#SO_PEEK_OFF
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_PEEK_OFF
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_PROTOCOL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_PROTOCOL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_RCVBUF
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_RCVBUF
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_SNDBUF
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_SNDBUF
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_RCVLOWAT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_RCVLOWAT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_SNDLOWAT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_SNDLOWAT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_RCVTIMEO
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_RCVTIMEO
       (values std/os/socket#socket-getsockopt-tv
               std/os/socket#socket-setsockopt-tv))
      '#!void)
  (if std/os/_socket#SO_SNDTIMEO
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_SNDTIMEO
       (values std/os/socket#socket-getsockopt-tv
               std/os/socket#socket-setsockopt-tv))
      '#!void)
  (if std/os/_socket#SO_REUSEADDR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_REUSEADDR
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_REUSEPORT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_REUSEPORT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_TYPE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_TYPE
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_TIMESTAMP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_TIMESTAMP
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_USELOOPBACK
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_USELOOPBACK
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_ADD_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_ADD_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq))
      '#!void)
  (if std/os/_socket#IP_DROP_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_DROP_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq))
      '#!void)
  (if std/os/_socket#IP_ADD_SOURCE_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_ADD_SOURCE_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq-src))
      '#!void)
  (if std/os/_socket#IP_DROP_SOURCE_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_DROP_SOURCE_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq-src))
      '#!void)
  (if std/os/_socket#IP_BLOCK_SOURCE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_BLOCK_SOURCE
       (values '#f std/os/socket#socket-setsockopt-mreq-src))
      '#!void)
  (if std/os/_socket#IP_UNBLOCK_SOURCE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_UNBLOCK_SOURCE
       (values '#f std/os/socket#socket-setsockopt-mreq-src))
      '#!void)
  (if std/os/_socket#IP_FREEBIND
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_FREEBIND
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_HDRINCL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_HDRINCL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_MTU
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MTU
       (values std/os/socket#socket-getsockopt-int '#f))
      '#!void)
  (if std/os/_socket#IP_MTU_DISCOVER
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MTU_DISCOVER
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_MULTICAST_ALL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MULTICAST_ALL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_MULTICAST_IF
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MULTICAST_IF
       (values '#f std/os/socket#socket-setsockopt-mreq))
      '#!void)
  (if std/os/_socket#IP_MULTICAST_LOOP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MULTICAST_LOOP
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_MULTICAST_TTL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MULTICAST_TTL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_NODEFRAG
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_NODEFRAG
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_OPTIONS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_OPTIONS
       (values std/os/socket#socket-getsockopt-bytes
               std/os/socket#socket-setsockopt-bytes))
      '#!void)
  (if std/os/_socket#IP_PKTINFO
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_PKTINFO
       (values std/os/socket#socket-getsockopt-bytes
               std/os/socket#socket-setsockopt-bytes))
      '#!void)
  (if std/os/_socket#IP_RECVERR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RECVERR
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_RECVORIGDSTADDR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RECVORIGDSTADDR
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_RECVOPTS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RECVOPTS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_RECVTOS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RECVTOS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_RECVTTL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RECVTTL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_RETOPTS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RETOPTS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_ROUTER_ALERT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_ROUTER_ALERT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_TOS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_TOS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_TTL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_TTL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_ADDRFORM
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_ADDRFORM
       (values '#f std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_ADD_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_ADD_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq6))
      '#!void)
  (if std/os/_socket#IPV6_DROP_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_DROP_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq6))
      '#!void)
  (if std/os/_socket#IPV6_MTU
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_MTU
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_MTU_DISCOVER
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_MTU_DISCOVER
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_MULTICAST_HOPS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_MULTICAST_HOPS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_MULTICAST_IF
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_MULTICAST_IF
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_MULTICAST_LOOP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_MULTICAST_LOOP
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_RECVPKTINFO
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_RECVPKTINFO
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_RTHDR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_RTHDR
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_AUTHHDR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_AUTHHDR
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_DSTOPTS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_DSTOPTS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_HOPOPTS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_HOPOPTS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_FLOWINFO
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_FLOWINFO
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_HOPLIMIT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_HOPLIMIT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_ROUTER_ALERT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_ROUTER_ALERT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_UNICAST_HOPS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_UNICAST_HOPS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_V6ONLY
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_V6ONLY
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_CONGESTION
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_CONGESTION
       (values '#f std/os/socket#socket-setsockopt-bytes))
      '#!void)
  (if std/os/_socket#TCP_CORK
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_CORK
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_DEFER_ACCEPT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_DEFER_ACCEPT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_KEEPCNT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_KEEPCNT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_KEEPIDLE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_KEEPIDLE
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_KEEPINTVL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_KEEPINTVL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_MAXSEG
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_MAXSEG
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_NODELAY
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_NODELAY
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_SYNCNT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_SYNCNT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void))
