(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/121#any
    (lambda (_pred96330_ _ls96331_)
      (if (null? (cdr _ls96331_))
          (_pred96330_ (car _ls96331_))
          ((lambda (_x96333_)
             (if _x96333_
                 _x96333_
                 (std/srfi/121#any _pred96330_ (cdr _ls96331_))))
           (_pred96330_ (car _ls96331_))))))
  (define std/srfi/121#every
    (lambda (_pred96327_ _ls96328_)
      (if (null? (cdr _ls96328_))
          (_pred96327_ (car _ls96328_))
          (if (_pred96327_ (car _ls96328_))
              (std/srfi/121#every _pred96327_ (cdr _ls96328_))
              '#f))))
  (define std/srfi/121#generator
    (lambda _args96322_
      (lambda ()
        (if (null? _args96322_)
            (eof-object)
            (let ((_next96325_ (car _args96322_)))
              (set! _args96322_ (cdr _args96322_))
              _next96325_)))))
  (define std/srfi/121#make-iota-generator__0
    (lambda (_count96313_) (std/srfi/121#make-iota _count96313_ '0 '1)))
  (define std/srfi/121#make-iota-generator__1
    (lambda (_count96315_ _start96316_)
      (std/srfi/121#make-iota _count96315_ _start96316_ '1)))
  (define std/srfi/121#make-iota-generator
    (lambda _g289293_
      (let ((_g289292_ (let () (declare (not safe)) (##length _g289293_))))
        (cond ((let () (declare (not safe)) (##fx= _g289292_ 1))
               (apply std/srfi/121#make-iota-generator__0 _g289293_))
              ((let () (declare (not safe)) (##fx= _g289292_ 2))
               (apply std/srfi/121#make-iota-generator__1 _g289293_))
              ((let () (declare (not safe)) (##fx= _g289292_ 3))
               (apply std/srfi/121#make-iota _g289293_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#make-iota-generator
                _g289293_))))))
  (define std/srfi/121#make-iota
    (lambda (_count96306_ _start96307_ _step96308_)
      (lambda ()
        (if (<= _count96306_ '0)
            (eof-object)
            (let ((_result96311_ _start96307_))
              (set! _count96306_ (- _count96306_ '1))
              (set! _start96307_ (+ _start96307_ _step96308_))
              _result96311_)))))
  (define std/srfi/121#make-range-generator__0
    (lambda (_start96294_ _end96295_)
      (std/srfi/121#make-range-generator__2 _start96294_ _end96295_ '1)))
  (define std/srfi/121#make-range-generator__2
    (lambda (_start96299_ _end96300_ _step96301_)
      (set! _start96299_ (- (+ _start96299_ _step96301_) _step96301_))
      (lambda ()
        (if (< _start96299_ _end96300_)
            (let ((_v96304_ _start96299_))
              (set! _start96299_ (+ _start96299_ _step96301_))
              _v96304_)
            (eof-object)))))
  (define std/srfi/121#make-range-generator
    (lambda _g289295_
      (let ((_g289294_ (let () (declare (not safe)) (##length _g289295_))))
        (cond ((let () (declare (not safe)) (##fx= _g289294_ 2))
               (apply std/srfi/121#make-range-generator__0 _g289295_))
              ((let () (declare (not safe)) (##fx= _g289294_ 1))
               (apply std/srfi/121#make-infinite-range-generator _g289295_))
              ((let () (declare (not safe)) (##fx= _g289294_ 3))
               (apply std/srfi/121#make-range-generator__2 _g289295_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#make-range-generator
                _g289295_))))))
  (define std/srfi/121#make-infinite-range-generator
    (lambda (_start96289_)
      (lambda ()
        (let ((_result96292_ _start96289_))
          (set! _start96289_ (+ _start96289_ '1))
          _result96292_))))
  (define std/srfi/121#make-coroutine-generator
    (lambda (_proc96274_)
      (letrec* ((_return96276_ '#f)
                (_resume96277_ '#f)
                (_yield96278_
                 (lambda (_v96285_)
                   (call-with-current-continuation
                    (lambda (_r96287_)
                      (set! _resume96277_ _r96287_)
                      (_return96276_ _v96285_))))))
        (lambda ()
          (call-with-current-continuation
           (lambda (_cc96281_)
             (set! _return96276_ _cc96281_)
             (if _resume96277_
                 (_resume96277_ (if '#f '#f '#!void))
                 (begin
                   (_proc96274_ _yield96278_)
                   (set! _resume96277_
                         (lambda (_v96283_) (_return96276_ (eof-object))))
                   (_return96276_ (eof-object))))))))))
  (define std/srfi/121#list->generator
    (lambda (_lst96269_)
      (lambda ()
        (if (null? _lst96269_)
            (eof-object)
            (let ((_next96272_ (car _lst96269_)))
              (set! _lst96269_ (cdr _lst96269_))
              _next96272_)))))
  (define std/srfi/121#vector->generator__0
    (lambda (_vec96257_)
      (std/srfi/121#vector->generator__2
       _vec96257_
       '0
       (vector-length _vec96257_))))
  (define std/srfi/121#vector->generator__1
    (lambda (_vec96259_ _start96260_)
      (std/srfi/121#vector->generator__2
       _vec96259_
       _start96260_
       (vector-length _vec96259_))))
  (define std/srfi/121#vector->generator__2
    (lambda (_vec96262_ _start96263_ _end96264_)
      (lambda ()
        (if (>= _start96263_ _end96264_)
            (eof-object)
            (let ((_next96267_ (vector-ref _vec96262_ _start96263_)))
              (set! _start96263_ (+ _start96263_ '1))
              _next96267_)))))
  (define std/srfi/121#vector->generator
    (lambda _g289297_
      (let ((_g289296_ (let () (declare (not safe)) (##length _g289297_))))
        (cond ((let () (declare (not safe)) (##fx= _g289296_ 1))
               (apply std/srfi/121#vector->generator__0 _g289297_))
              ((let () (declare (not safe)) (##fx= _g289296_ 2))
               (apply std/srfi/121#vector->generator__1 _g289297_))
              ((let () (declare (not safe)) (##fx= _g289296_ 3))
               (apply std/srfi/121#vector->generator__2 _g289297_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#vector->generator
                _g289297_))))))
  (define std/srfi/121#reverse-vector->generator__0
    (lambda (_vec96245_)
      (std/srfi/121#reverse-vector->generator__2
       _vec96245_
       '0
       (vector-length _vec96245_))))
  (define std/srfi/121#reverse-vector->generator__1
    (lambda (_vec96247_ _start96248_)
      (std/srfi/121#reverse-vector->generator__2
       _vec96247_
       _start96248_
       (vector-length _vec96247_))))
  (define std/srfi/121#reverse-vector->generator__2
    (lambda (_vec96250_ _start96251_ _end96252_)
      (lambda ()
        (if (>= _start96251_ _end96252_)
            (eof-object)
            (let ((_next96255_ (vector-ref _vec96250_ (- _end96252_ '1))))
              (set! _end96252_ (- _end96252_ '1))
              _next96255_)))))
  (define std/srfi/121#reverse-vector->generator
    (lambda _g289299_
      (let ((_g289298_ (let () (declare (not safe)) (##length _g289299_))))
        (cond ((let () (declare (not safe)) (##fx= _g289298_ 1))
               (apply std/srfi/121#reverse-vector->generator__0 _g289299_))
              ((let () (declare (not safe)) (##fx= _g289298_ 2))
               (apply std/srfi/121#reverse-vector->generator__1 _g289299_))
              ((let () (declare (not safe)) (##fx= _g289298_ 3))
               (apply std/srfi/121#reverse-vector->generator__2 _g289299_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#reverse-vector->generator
                _g289299_))))))
  (define std/srfi/121#string->generator__0
    (lambda (_str96233_)
      (std/srfi/121#string->generator__2
       _str96233_
       '0
       (string-length _str96233_))))
  (define std/srfi/121#string->generator__1
    (lambda (_str96235_ _start96236_)
      (std/srfi/121#string->generator__2
       _str96235_
       _start96236_
       (string-length _str96235_))))
  (define std/srfi/121#string->generator__2
    (lambda (_str96238_ _start96239_ _end96240_)
      (lambda ()
        (if (>= _start96239_ _end96240_)
            (eof-object)
            (let ((_next96243_ (string-ref _str96238_ _start96239_)))
              (set! _start96239_ (+ _start96239_ '1))
              _next96243_)))))
  (define std/srfi/121#string->generator
    (lambda _g289301_
      (let ((_g289300_ (let () (declare (not safe)) (##length _g289301_))))
        (cond ((let () (declare (not safe)) (##fx= _g289300_ 1))
               (apply std/srfi/121#string->generator__0 _g289301_))
              ((let () (declare (not safe)) (##fx= _g289300_ 2))
               (apply std/srfi/121#string->generator__1 _g289301_))
              ((let () (declare (not safe)) (##fx= _g289300_ 3))
               (apply std/srfi/121#string->generator__2 _g289301_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#string->generator
                _g289301_))))))
  (define std/srfi/121#bytevector->generator__0
    (lambda (_str96221_)
      (std/srfi/121#bytevector->generator__2
       _str96221_
       '0
       (u8vector-length _str96221_))))
  (define std/srfi/121#bytevector->generator__1
    (lambda (_str96223_ _start96224_)
      (std/srfi/121#bytevector->generator__2
       _str96223_
       _start96224_
       (u8vector-length _str96223_))))
  (define std/srfi/121#bytevector->generator__2
    (lambda (_str96226_ _start96227_ _end96228_)
      (lambda ()
        (if (>= _start96227_ _end96228_)
            (eof-object)
            (let ((_next96231_ (u8vector-ref _str96226_ _start96227_)))
              (set! _start96227_ (+ _start96227_ '1))
              _next96231_)))))
  (define std/srfi/121#bytevector->generator
    (lambda _g289303_
      (let ((_g289302_ (let () (declare (not safe)) (##length _g289303_))))
        (cond ((let () (declare (not safe)) (##fx= _g289302_ 1))
               (apply std/srfi/121#bytevector->generator__0 _g289303_))
              ((let () (declare (not safe)) (##fx= _g289302_ 2))
               (apply std/srfi/121#bytevector->generator__1 _g289303_))
              ((let () (declare (not safe)) (##fx= _g289302_ 3))
               (apply std/srfi/121#bytevector->generator__2 _g289303_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#bytevector->generator
                _g289303_))))))
  (define std/srfi/121#make-for-each-generator
    (lambda (_for-each96216_ _obj96217_)
      (std/srfi/121#make-coroutine-generator
       (lambda (_yield96219_) (_for-each96216_ _yield96219_ _obj96217_)))))
  (define std/srfi/121#make-unfold-generator
    (lambda (_stop?96205_ _mapper96206_ _successor96207_ _seed96208_)
      (std/srfi/121#make-coroutine-generator
       (lambda (_yield96210_)
         (let _loop96212_ ((_s96214_ _seed96208_))
           (if (_stop?96205_ _s96214_)
               (if '#f '#f '#!void)
               (begin
                 (_yield96210_ (_mapper96206_ _s96214_))
                 (_loop96212_ (_successor96207_ _s96214_)))))))))
  (define std/srfi/121#gcons*
    (lambda _args96200_
      (lambda ()
        (if (null? _args96200_)
            (eof-object)
            (if (= (length _args96200_) '1)
                ((car _args96200_))
                (let ((_v96203_ (car _args96200_)))
                  (set! _args96200_ (cdr _args96200_))
                  _v96203_))))))
  (define std/srfi/121#gappend
    (lambda _args96193_
      (lambda ()
        (if (null? _args96193_)
            (eof-object)
            (let _loop96196_ ((_v96198_ ((car _args96193_))))
              (if (eof-object? _v96198_)
                  (begin
                    (set! _args96193_ (cdr _args96193_))
                    (if (null? _args96193_)
                        (eof-object)
                        (_loop96196_ ((car _args96193_)))))
                  _v96198_))))))
  (define std/srfi/121#gcombine
    (lambda (_proc96180_ _seed96181_ . _gens96182_)
      (lambda ()
        (letrec* ((_items96185_
                   (map (lambda (_x96191_) (_x96191_)) _gens96182_)))
          (if (std/srfi/121#any eof-object? _items96185_)
              (eof-object)
              (let ()
                (letrec* ((_g289304_
                           (let ((_g289305_
                                  (apply _proc96180_
                                         (append _items96185_
                                                 (list _seed96181_)))))
                             (let ((_g289306_
                                    (let ()
                                      (declare (not safe))
                                      (if (##values? _g289305_)
                                          (##vector-length _g289305_)
                                          1))))
                               (if (not (let ()
                                          (declare (not safe))
                                          (##fx= _g289306_ 2)))
                                   (error "Context expects 2 values"
                                          _g289306_)))
                             _g289305_))
                          (_value96188_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g289304_ 0)))
                          (_newseed96189_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g289304_ 1))))
                  (begin (set! _seed96181_ _newseed96189_) _value96188_))))))))
  (define std/srfi/121#gfilter
    (lambda (_pred96168_ _gen96169_)
      (lambda ()
        (let _loop96172_ ()
          (let ((_next96175_ (_gen96169_)))
            (if (or (eof-object? _next96175_) (_pred96168_ _next96175_))
                _next96175_
                (_loop96172_)))))))
  (define std/srfi/121#gremove
    (lambda (_pred96163_ _gen96164_)
      (std/srfi/121#gfilter
       (lambda (_v96166_) (not (_pred96163_ _v96166_)))
       _gen96164_)))
  (define std/srfi/121#gtake__0
    (lambda (_gen96149_ _k96150_)
      (std/srfi/121#gtake__1 _gen96149_ _k96150_ (eof-object))))
  (define std/srfi/121#gtake__1
    (lambda (_gen96152_ _k96153_ _padding96154_)
      (std/srfi/121#make-coroutine-generator
       (lambda (_yield96156_)
         (if (> _k96153_ '0)
             (let _loop96158_ ((_i96160_ '0) (_v96161_ (_gen96152_)))
               (if (eof-object? _v96161_)
                   (_yield96156_ _padding96154_)
                   (_yield96156_ _v96161_))
               (if (< (+ '1 _i96160_) _k96153_)
                   (_loop96158_ (+ '1 _i96160_) (_gen96152_))
                   (eof-object)))
             (eof-object))))))
  (define std/srfi/121#gtake
    (lambda _g289308_
      (let ((_g289307_ (let () (declare (not safe)) (##length _g289308_))))
        (cond ((let () (declare (not safe)) (##fx= _g289307_ 2))
               (apply std/srfi/121#gtake__0 _g289308_))
              ((let () (declare (not safe)) (##fx= _g289307_ 3))
               (apply std/srfi/121#gtake__1 _g289308_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#gtake
                _g289308_))))))
  (define std/srfi/121#gdrop
    (lambda (_gen96141_ _k96142_)
      (lambda ()
        (let _$loop96145_ ()
          (if (<= _k96142_ '0)
              '#!void
              (begin
                (set! _k96142_ (- _k96142_ '1))
                (_gen96141_)
                (_$loop96145_))))
        (_gen96141_))))
  (define std/srfi/121#gdrop-while
    (lambda (_pred96130_ _gen96131_)
      (letrec* ((_found96133_ '#f))
        (lambda ()
          (let _loop96136_ ()
            (let ((_val96139_ (_gen96131_)))
              (if _found96133_
                  _val96139_
                  (if (and (not (eof-object? _val96139_))
                           (_pred96130_ _val96139_))
                      (_loop96136_)
                      (begin (set! _found96133_ '#t) _val96139_)))))))))
  (define std/srfi/121#gtake-while
    (lambda (_pred96124_ _gen96125_)
      (lambda ()
        (let ((_next96128_ (_gen96125_)))
          (if (eof-object? _next96128_)
              _next96128_
              (if (_pred96124_ _next96128_)
                  _next96128_
                  (begin
                    (set! _gen96125_ (std/srfi/121#generator))
                    (_gen96125_))))))))
  (define std/srfi/121#gdelete__0
    (lambda (_item96112_ _gen96113_)
      (std/srfi/121#gdelete__1 _item96112_ _gen96113_ equal?)))
  (define std/srfi/121#gdelete__1
    (lambda (_item96115_ _gen96116_ _==96117_)
      (lambda ()
        (let _loop96120_ ((_v96122_ (_gen96116_)))
          (if (eof-object? _v96122_)
              (eof-object)
              (if (_==96117_ _item96115_ _v96122_)
                  (_loop96120_ (_gen96116_))
                  _v96122_))))))
  (define std/srfi/121#gdelete
    (lambda _g289310_
      (let ((_g289309_ (let () (declare (not safe)) (##length _g289310_))))
        (cond ((let () (declare (not safe)) (##fx= _g289309_ 2))
               (apply std/srfi/121#gdelete__0 _g289310_))
              ((let () (declare (not safe)) (##fx= _g289309_ 3))
               (apply std/srfi/121#gdelete__1 _g289310_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#gdelete
                _g289310_))))))
  (define std/srfi/121#gdelete-neighbor-dups__0
    (lambda (_gen96099_)
      (std/srfi/121#gdelete-neighbor-dups__1 _gen96099_ equal?)))
  (define std/srfi/121#gdelete-neighbor-dups__1
    (lambda (_gen96101_ _==96102_)
      (letrec* ((_firsttime96104_ '#t) (_prev96105_ '#f))
        (lambda ()
          (if _firsttime96104_
              (begin
                (set! _firsttime96104_ '#f)
                (set! _prev96105_ (_gen96101_))
                _prev96105_)
              (let _loop96108_ ((_v96110_ (_gen96101_)))
                (if (eof-object? _v96110_)
                    _v96110_
                    (if (_==96102_ _prev96105_ _v96110_)
                        (_loop96108_ (_gen96101_))
                        (begin (set! _prev96105_ _v96110_) _v96110_)))))))))
  (define std/srfi/121#gdelete-neighbor-dups
    (lambda _g289312_
      (let ((_g289311_ (let () (declare (not safe)) (##length _g289312_))))
        (cond ((let () (declare (not safe)) (##fx= _g289311_ 1))
               (apply std/srfi/121#gdelete-neighbor-dups__0 _g289312_))
              ((let () (declare (not safe)) (##fx= _g289311_ 2))
               (apply std/srfi/121#gdelete-neighbor-dups__1 _g289312_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#gdelete-neighbor-dups
                _g289312_))))))
  (define std/srfi/121#gindex
    (lambda (_value-gen96084_ _index-gen96085_)
      (let ((_done?96087_ '#f) (_count96088_ '0))
        (lambda ()
          (if _done?96087_
              (eof-object)
              (let _loop96091_ ((_value96093_ (_value-gen96084_))
                                (_index96094_ (_index-gen96085_)))
                (if (or (eof-object? _value96093_) (eof-object? _index96094_))
                    (begin (set! _done?96087_ '#t) (eof-object))
                    (if (= _index96094_ _count96088_)
                        (begin
                          (set! _count96088_ (+ _count96088_ '1))
                          _value96093_)
                        (begin
                          (set! _count96088_ (+ _count96088_ '1))
                          (_loop96091_
                           (_value-gen96084_)
                           _index96094_))))))))))
  (define std/srfi/121#gselect
    (lambda (_value-gen96070_ _truth-gen96071_)
      (let ((_done?96073_ '#f))
        (lambda ()
          (if _done?96073_
              (eof-object)
              (let _loop96076_ ((_value96078_ (_value-gen96070_))
                                (_truth96079_ (_truth-gen96071_)))
                (if (or (eof-object? _value96078_) (eof-object? _truth96079_))
                    (begin (set! _done?96073_ '#t) (eof-object))
                    (if _truth96079_
                        _value96078_
                        (_loop96076_
                         (_value-gen96070_)
                         (_truth-gen96071_))))))))))
  (define std/srfi/121#generator->list__0
    (lambda (_gen96065_ _n96066_)
      (std/srfi/121#generator->list__1
       (std/srfi/121#gtake__0 _gen96065_ _n96066_))))
  (define std/srfi/121#generator->list__1
    (lambda (_gen96068_)
      (reverse (std/srfi/121#generator->reverse-list__1 _gen96068_))))
  (define std/srfi/121#generator->list
    (lambda _g289314_
      (let ((_g289313_ (let () (declare (not safe)) (##length _g289314_))))
        (cond ((let () (declare (not safe)) (##fx= _g289313_ 2))
               (apply std/srfi/121#generator->list__0 _g289314_))
              ((let () (declare (not safe)) (##fx= _g289313_ 1))
               (apply std/srfi/121#generator->list__1 _g289314_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#generator->list
                _g289314_))))))
  (define std/srfi/121#generator->reverse-list__0
    (lambda (_gen96060_ _n96061_)
      (std/srfi/121#generator->reverse-list__1
       (std/srfi/121#gtake__0 _gen96060_ _n96061_))))
  (define std/srfi/121#generator->reverse-list__1
    (lambda (_gen96063_) (std/srfi/121#generator-fold cons '() _gen96063_)))
  (define std/srfi/121#generator->reverse-list
    (lambda _g289316_
      (let ((_g289315_ (let () (declare (not safe)) (##length _g289316_))))
        (cond ((let () (declare (not safe)) (##fx= _g289315_ 2))
               (apply std/srfi/121#generator->reverse-list__0 _g289316_))
              ((let () (declare (not safe)) (##fx= _g289315_ 1))
               (apply std/srfi/121#generator->reverse-list__1 _g289316_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#generator->reverse-list
                _g289316_))))))
  (define std/srfi/121#generator->vector__0
    (lambda (_gen96055_)
      (list->vector (std/srfi/121#generator->list__1 _gen96055_))))
  (define std/srfi/121#generator->vector__1
    (lambda (_gen96057_ _n96058_)
      (list->vector (std/srfi/121#generator->list__0 _gen96057_ _n96058_))))
  (define std/srfi/121#generator->vector
    (lambda _g289318_
      (let ((_g289317_ (let () (declare (not safe)) (##length _g289318_))))
        (cond ((let () (declare (not safe)) (##fx= _g289317_ 1))
               (apply std/srfi/121#generator->vector__0 _g289318_))
              ((let () (declare (not safe)) (##fx= _g289317_ 2))
               (apply std/srfi/121#generator->vector__1 _g289318_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#generator->vector
                _g289318_))))))
  (define std/srfi/121#generator->vector!
    (lambda (_vector96045_ _at96046_ _gen96047_)
      (let _loop96049_ ((_value96051_ (_gen96047_))
                        (_count96052_ '0)
                        (_at96053_ _at96046_))
        (if (eof-object? _value96051_)
            _count96052_
            (if (>= _at96053_ (vector-length _vector96045_))
                _count96052_
                (begin
                  (vector-set! _vector96045_ _at96053_ _value96051_)
                  (_loop96049_
                   (_gen96047_)
                   (+ _count96052_ '1)
                   (+ _at96053_ '1))))))))
  (define std/srfi/121#generator->string__0
    (lambda (_gen96040_)
      (list->string (std/srfi/121#generator->list__1 _gen96040_))))
  (define std/srfi/121#generator->string__1
    (lambda (_gen96042_ _n96043_)
      (list->string (std/srfi/121#generator->list__0 _gen96042_ _n96043_))))
  (define std/srfi/121#generator->string
    (lambda _g289320_
      (let ((_g289319_ (let () (declare (not safe)) (##length _g289320_))))
        (cond ((let () (declare (not safe)) (##fx= _g289319_ 1))
               (apply std/srfi/121#generator->string__0 _g289320_))
              ((let () (declare (not safe)) (##fx= _g289319_ 2))
               (apply std/srfi/121#generator->string__1 _g289320_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/121#generator->string
                _g289320_))))))
  (define std/srfi/121#generator-fold
    (lambda (_f96028_ _seed96029_ . _gs96030_)
      (letrec ((_inner-fold96032_
                (lambda (_seed96034_)
                  (let ((_vs96038_
                         (map (lambda (_g96036_) (_g96036_)) _gs96030_)))
                    (if (std/srfi/121#any eof-object? _vs96038_)
                        _seed96034_
                        (_inner-fold96032_
                         (apply _f96028_
                                (append _vs96038_ (list _seed96034_)))))))))
        (_inner-fold96032_ _seed96029_))))
  (define std/srfi/121#generator-for-each
    (lambda (_f96018_ . _gs96019_)
      (let _loop96021_ ()
        (let ((_vs96026_ (map (lambda (_g96024_) (_g96024_)) _gs96019_)))
          (if (std/srfi/121#any eof-object? _vs96026_)
              (if '#f '#f '#!void)
              (begin (apply _f96018_ _vs96026_) (_loop96021_)))))))
  (define std/srfi/121#generator-find
    (lambda (_pred96008_ _g96009_)
      (let _loop96011_ ((_v96013_ (_g96009_)))
        (if (or (_pred96008_ _v96013_) (eof-object? _v96013_))
            _v96013_
            (_loop96011_ (_g96009_))))))
  (define std/srfi/121#generator-count
    (lambda (_pred96002_ _g96003_)
      (std/srfi/121#generator-fold
       (lambda (_v96005_ _n96006_)
         (if (_pred96002_ _v96005_) (+ '1 _n96006_) _n96006_))
       '0
       _g96003_)))
  (define std/srfi/121#generator-any
    (lambda (_pred95995_ _g95996_)
      (let _loop95998_ ((_v96000_ (_g95996_)))
        (if (eof-object? _v96000_)
            '#f
            (if (_pred95995_ _v96000_) '#t (_loop95998_ (_g95996_)))))))
  (define std/srfi/121#generator-every
    (lambda (_pred95988_ _g95989_)
      (let _loop95991_ ((_v95993_ (_g95989_)))
        (if (eof-object? _v95993_)
            '#t
            (if (_pred95988_ _v95993_) (_loop95991_ (_g95989_)) '#f)))))
  (define std/srfi/121#generator-unfold
    (lambda (_g95980_ _unfold95981_ . _args95982_)
      (apply _unfold95981_
             eof-object?
             (lambda (_x95984_) _x95984_)
             (lambda (_x95986_) (_g95980_))
             (_g95980_)
             _args95982_))))
