(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/130#errmsg (lambda (_key96802_) '"illegal argument(s)"))
  (define std/srfi/130#assertion-violation
    (lambda (_procname96798_ _msg96799_ . _irritants96800_)
      (apply error _msg96799_ _irritants96800_)))
  (define std/srfi/130#mod
    (lambda (_x96795_ _y96796_) (fxremainder _x96795_ _y96796_)))
  (declare (fixnum))
  (define std/srfi/130#string-cursor?
    (lambda (_x96793_)
      (if (fixnum? _x96793_)
          (let () (declare (not safe)) (##fx>= _x96793_ '0))
          '#f)))
  (define std/srfi/130#string-cursor-start (lambda (_s96791_) '0))
  (define std/srfi/130#string-cursor-end
    (lambda (_s96789_) (string-length _s96789_)))
  (define std/srfi/130#string-cursor-next
    (lambda (_s96786_ _curs96787_) (+ _curs96787_ '1)))
  (define std/srfi/130#string-cursor-prev
    (lambda (_s96783_ _curs96784_) (- _curs96784_ '1)))
  (define std/srfi/130#string-cursor-forward
    (lambda (_s96779_ _curs96780_ _n96781_) (+ _curs96780_ _n96781_)))
  (define std/srfi/130#string-cursor-back
    (lambda (_s96775_ _curs96776_ _n96777_) (- _curs96776_ _n96777_)))
  (define std/srfi/130#string-cursor=?
    (lambda (_curs196772_ _curs296773_) (= _curs196772_ _curs296773_)))
  (define std/srfi/130#string-cursor<?
    (lambda (_curs196769_ _curs296770_) (< _curs196769_ _curs296770_)))
  (define std/srfi/130#string-cursor>?
    (lambda (_curs196766_ _curs296767_) (> _curs196766_ _curs296767_)))
  (define std/srfi/130#string-cursor<=?
    (lambda (_curs196763_ _curs296764_) (<= _curs196763_ _curs296764_)))
  (define std/srfi/130#string-cursor>=?
    (lambda (_curs196760_ _curs296761_) (>= _curs196760_ _curs296761_)))
  (define std/srfi/130#string-cursor-diff
    (lambda (_s96756_ _start96757_ _end96758_) (- _end96758_ _start96757_)))
  (define std/srfi/130#string-cursor->index
    (lambda (_s96753_ _curs96754_) _curs96754_))
  (define std/srfi/130#string-index->cursor
    (lambda (_s96750_ _idx96751_) _idx96751_))
  (define std/srfi/130#string->list/cursors string->list)
  (define std/srfi/130#string->vector/cursors string->vector)
  (define std/srfi/130#string-ref/cursor string-ref)
  (define std/srfi/130#substring/cursors substring)
  (define std/srfi/130#string-copy/cursors string-copy)
  (define std/srfi/130#string-index__0
    (lambda (_s96735_ _pred96736_)
      (std/srfi/130#string-index__2
       _s96735_
       _pred96736_
       '0
       (string-length _s96735_))))
  (define std/srfi/130#string-index__1
    (lambda (_s96738_ _pred96739_ _start96740_)
      (std/srfi/130#string-index__2
       _s96738_
       _pred96739_
       _start96740_
       (string-length _s96738_))))
  (define std/srfi/130#string-index__2
    (lambda (_s96742_ _pred96743_ _start96744_ _end96745_)
      (let ((_$e96747_
             (std/srfi/13#string-index__%
              _s96742_
              _pred96743_
              _start96744_
              _end96745_)))
        (if _$e96747_ _$e96747_ _end96745_))))
  (define std/srfi/130#string-index
    (lambda _g295180_
      (let ((_g295179_ (let () (declare (not safe)) (##length _g295180_))))
        (cond ((let () (declare (not safe)) (##fx= _g295179_ 2))
               (apply std/srfi/130#string-index__0 _g295180_))
              ((let () (declare (not safe)) (##fx= _g295179_ 3))
               (apply std/srfi/130#string-index__1 _g295180_))
              ((let () (declare (not safe)) (##fx= _g295179_ 4))
               (apply std/srfi/130#string-index__2 _g295180_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/130#string-index
                _g295180_))))))
  (define std/srfi/130#string-index-right__0
    (lambda (_s96721_ _pred96722_)
      (std/srfi/130#string-index-right__2
       _s96721_
       _pred96722_
       '0
       (string-length _s96721_))))
  (define std/srfi/130#string-index-right__1
    (lambda (_s96724_ _pred96725_ _start96726_)
      (std/srfi/130#string-index-right__2
       _s96724_
       _pred96725_
       _start96726_
       (string-length _s96724_))))
  (define std/srfi/130#string-index-right__2
    (lambda (_s96728_ _pred96729_ _start96730_ _end96731_)
      (let ((_i96733_
             (std/srfi/13#string-index-right__%
              _s96728_
              _pred96729_
              _start96730_
              _end96731_)))
        (if _i96733_ (+ _i96733_ '1) _start96730_))))
  (define std/srfi/130#string-index-right
    (lambda _g295182_
      (let ((_g295181_ (let () (declare (not safe)) (##length _g295182_))))
        (cond ((let () (declare (not safe)) (##fx= _g295181_ 2))
               (apply std/srfi/130#string-index-right__0 _g295182_))
              ((let () (declare (not safe)) (##fx= _g295181_ 3))
               (apply std/srfi/130#string-index-right__1 _g295182_))
              ((let () (declare (not safe)) (##fx= _g295181_ 4))
               (apply std/srfi/130#string-index-right__2 _g295182_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/130#string-index-right
                _g295182_))))))
  (define std/srfi/130#string-skip
    (lambda (_s96715_ _pred96716_ . _rest96717_)
      (apply std/srfi/130#string-index
             _s96715_
             (lambda (_x96719_) (not (_pred96716_ _x96719_)))
             _rest96717_)))
  (define std/srfi/130#string-skip-right
    (lambda (_s96709_ _pred96710_ . _rest96711_)
      (apply std/srfi/130#string-index-right
             _s96709_
             (lambda (_x96713_) (not (_pred96710_ _x96713_)))
             _rest96711_)))
  (define std/srfi/130#string-contains-right__0
    (lambda (_s196679_ _s296680_)
      (std/srfi/130#string-contains-right__4
       _s196679_
       _s296680_
       '0
       (string-length _s196679_)
       '0
       (string-length _s296680_))))
  (define std/srfi/130#string-contains-right__1
    (lambda (_s196682_ _s296683_ _start196684_)
      (std/srfi/130#string-contains-right__4
       _s196682_
       _s296683_
       _start196684_
       (string-length _s196682_)
       '0
       (string-length _s296683_))))
  (define std/srfi/130#string-contains-right__2
    (lambda (_s196686_ _s296687_ _start196688_ _end196689_)
      (std/srfi/130#string-contains-right__4
       _s196686_
       _s296687_
       _start196688_
       _end196689_
       '0
       (string-length _s296687_))))
  (define std/srfi/130#string-contains-right__3
    (lambda (_s196691_ _s296692_ _start196693_ _end196694_ _start296695_)
      (std/srfi/130#string-contains-right__4
       _s196691_
       _s296692_
       _start196693_
       _end196694_
       _start296695_
       (string-length _s296692_))))
  (define std/srfi/130#string-contains-right__4
    (lambda (_s196697_
             _s296698_
             _start196699_
             _end196700_
             _start296701_
             _end296702_)
      (if (= _start296701_ _end296702_)
          _end196700_
          (let _loop96704_ ((_i96706_ '#f)
                            (_j96707_
                             (std/srfi/13#string-contains__%
                              _s196697_
                              _s296698_
                              _start196699_
                              _end196700_
                              _start296701_
                              _end296702_)))
            (if (and _j96707_ (< _j96707_ _end196700_))
                (_loop96704_
                 _j96707_
                 (std/srfi/13#string-contains__%
                  _s196697_
                  _s296698_
                  (+ _j96707_ '1)
                  _end196700_
                  _start296701_
                  _end296702_))
                _i96706_)))))
  (define std/srfi/130#string-contains-right
    (lambda _g295184_
      (let ((_g295183_ (let () (declare (not safe)) (##length _g295184_))))
        (cond ((let () (declare (not safe)) (##fx= _g295183_ 2))
               (apply std/srfi/130#string-contains-right__0 _g295184_))
              ((let () (declare (not safe)) (##fx= _g295183_ 3))
               (apply std/srfi/130#string-contains-right__1 _g295184_))
              ((let () (declare (not safe)) (##fx= _g295183_ 4))
               (apply std/srfi/130#string-contains-right__2 _g295184_))
              ((let () (declare (not safe)) (##fx= _g295183_ 5))
               (apply std/srfi/130#string-contains-right__3 _g295184_))
              ((let () (declare (not safe)) (##fx= _g295183_ 6))
               (apply std/srfi/130#string-contains-right__4 _g295184_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/130#string-contains-right
                _g295184_))))))
  (define std/srfi/130#string-for-each-cursor__0
    (lambda (_proc96662_ _s96663_)
      (std/srfi/130#string-for-each-cursor__2
       _proc96662_
       _s96663_
       '0
       (string-length _s96663_))))
  (define std/srfi/130#string-for-each-cursor__1
    (lambda (_proc96665_ _s96666_ _start96667_)
      (std/srfi/130#string-for-each-cursor__2
       _proc96665_
       _s96666_
       _start96667_
       (string-length _s96666_))))
  (define std/srfi/130#string-for-each-cursor__2
    (lambda (_proc96669_ _s96670_ _start96671_ _end96672_)
      (let _$loop96674_ ((_i96677_ _start96671_))
        (if (>= _i96677_ _end96672_)
            '#!void
            (begin (_proc96669_ _i96677_) (_$loop96674_ (+ _i96677_ '1)))))))
  (define std/srfi/130#string-for-each-cursor
    (lambda _g295186_
      (let ((_g295185_ (let () (declare (not safe)) (##length _g295186_))))
        (cond ((let () (declare (not safe)) (##fx= _g295185_ 2))
               (apply std/srfi/130#string-for-each-cursor__0 _g295186_))
              ((let () (declare (not safe)) (##fx= _g295185_ 3))
               (apply std/srfi/130#string-for-each-cursor__1 _g295186_))
              ((let () (declare (not safe)) (##fx= _g295185_ 4))
               (apply std/srfi/130#string-for-each-cursor__2 _g295186_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/130#string-for-each-cursor
                _g295186_))))))
  (define std/srfi/130#string-replicate__0
    (lambda (_s96628_ _from96629_ _to96630_ _start96631_ _end96632_)
      (std/srfi/130#string-replicate__2
       (substring _s96628_ _start96631_ _end96632_)
       _from96629_
       _to96630_)))
  (define std/srfi/130#string-replicate__1
    (lambda (_s96634_ _from96635_ _to96636_ _start96637_)
      (std/srfi/130#string-replicate__2
       (substring _s96634_ _start96637_ (string-length _s96634_))
       _from96635_
       _to96636_)))
  (define std/srfi/130#string-replicate__2
    (lambda (_s96639_ _from96640_ _to96641_)
      (let* ((_n96643_ (- _to96641_ _from96640_))
             (_len96645_ (string-length _s96639_)))
        (if (= _n96643_ '0)
            '""
            (if (or (< _n96643_ '0) (= _len96645_ '0))
                (std/srfi/130#assertion-violation
                 'string-replicate
                 (std/srfi/130#errmsg 'msg:illegalargs)
                 _s96639_
                 _from96640_
                 _to96641_)
                (let* ((_from96651_ (fxremainder _from96640_ _len96645_))
                       (_to96653_ (+ _from96651_ _n96643_)))
                  (let _$loop96656_ ((_replicates96659_ '())
                                     (_replicates-length96660_ '0))
                    (if (>= _replicates-length96660_ _to96653_)
                        (substring
                         (apply string-append _replicates96659_)
                         _from96651_
                         _to96653_)
                        (_$loop96656_
                         (cons _s96639_ _replicates96659_)
                         (+ _replicates-length96660_ _len96645_))))))))))
  (define std/srfi/130#string-replicate
    (lambda _g295188_
      (let ((_g295187_ (let () (declare (not safe)) (##length _g295188_))))
        (cond ((let () (declare (not safe)) (##fx= _g295187_ 5))
               (apply std/srfi/130#string-replicate__0 _g295188_))
              ((let () (declare (not safe)) (##fx= _g295187_ 4))
               (apply std/srfi/130#string-replicate__1 _g295188_))
              ((let () (declare (not safe)) (##fx= _g295187_ 3))
               (apply std/srfi/130#string-replicate__2 _g295188_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/130#string-replicate
                _g295188_))))))
  (define std/srfi/130#string-split__0
    (lambda (_s96586_
             _delimiter96587_
             _grammar96588_
             _limit96589_
             _start96590_
             _end96591_)
      (std/srfi/130#string-split__4
       (substring _s96586_ _start96590_ _end96591_)
       _delimiter96587_
       _grammar96588_
       _limit96589_)))
  (define std/srfi/130#string-split__1
    (lambda (_s96593_
             _delimiter96594_
             _grammar96595_
             _limit96596_
             _start96597_)
      (std/srfi/130#string-split__4
       (substring _s96593_ _start96597_ (string-length _s96593_))
       _delimiter96594_
       _grammar96595_
       _limit96596_)))
  (define std/srfi/130#string-split__2
    (lambda (_s96599_ _delimiter96600_)
      (std/srfi/130#string-split__4 _s96599_ _delimiter96600_ 'infix '#f)))
  (define std/srfi/130#string-split__3
    (lambda (_s96602_ _delimiter96603_ _grammar96604_)
      (std/srfi/130#string-split__4
       _s96602_
       _delimiter96603_
       _grammar96604_
       '#f)))
  (define std/srfi/130#string-split__4
    (lambda (_s96606_ _delimiter96607_ _grammar96608_ _limit96609_)
      (letrec ((_complain96611_
                (lambda ()
                  (std/srfi/130#assertion-violation
                   'string-split
                   (std/srfi/130#errmsg 'msg:illegalargs)
                   _s96606_
                   _delimiter96607_
                   _grammar96608_
                   _limit96609_))))
        (let* ((_limit96616_
                (let ((_$e96613_ _limit96609_))
                  (if _$e96613_ _$e96613_ (string-length _s96606_))))
               (_splits96618_
                (if (= '0 (string-length _delimiter96607_))
                    (std/srfi/130#string-split-into-characters
                     _s96606_
                     _limit96616_)
                    (std/srfi/130#string-split-using-word
                     _s96606_
                     _delimiter96607_
                     _limit96616_))))
          (let ((_$e96621_ _grammar96608_))
            (if (or (eq? 'infix _$e96621_) (eq? 'strict-infix _$e96621_))
                (if (= '0 (string-length _s96606_))
                    (if (eq? _grammar96608_ 'infix) '() (_complain96611_))
                    _splits96618_)
                (if (eq? 'prefix _$e96621_)
                    (if (and (pair? _splits96618_)
                             (= '0 (string-length (car _splits96618_))))
                        (cdr _splits96618_)
                        _splits96618_)
                    (if (eq? 'suffix _$e96621_)
                        (if (and (pair? _splits96618_)
                                 (= '0
                                    (string-length
                                     (car (last-pair _splits96618_)))))
                            (reverse (cdr (reverse _splits96618_)))
                            _splits96618_)
                        (_complain96611_)))))))))
  (define std/srfi/130#string-split
    (lambda _g295190_
      (let ((_g295189_ (let () (declare (not safe)) (##length _g295190_))))
        (cond ((let () (declare (not safe)) (##fx= _g295189_ 6))
               (apply std/srfi/130#string-split__0 _g295190_))
              ((let () (declare (not safe)) (##fx= _g295189_ 5))
               (apply std/srfi/130#string-split__1 _g295190_))
              ((let () (declare (not safe)) (##fx= _g295189_ 2))
               (apply std/srfi/130#string-split__2 _g295190_))
              ((let () (declare (not safe)) (##fx= _g295189_ 3))
               (apply std/srfi/130#string-split__3 _g295190_))
              ((let () (declare (not safe)) (##fx= _g295189_ 4))
               (apply std/srfi/130#string-split__4 _g295190_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/130#string-split
                _g295190_))))))
  (define std/srfi/130#string-split-into-characters
    (lambda (_s96581_ _limit96582_)
      (let ((_n96584_ (string-length _s96581_)))
        (if (> _n96584_ (+ _limit96582_ '1))
            (append (std/srfi/130#string-split-into-characters
                     (substring _s96581_ '0 _limit96582_)
                     _limit96582_)
                    (substring _s96581_ _limit96582_ _n96584_))
            (map string (string->list _s96581_))))))
  (define std/srfi/130#string-split-using-word
    (lambda (_s96575_ _sep96576_ _limit96577_)
      (if (= '0 _limit96577_)
          (list _s96575_)
          (let ((_i96579_
                 (std/srfi/13#string-contains__0 _s96575_ _sep96576_)))
            (if _i96579_
                (cons (substring _s96575_ '0 _i96579_)
                      (std/srfi/130#string-split-using-word
                       (substring
                        _s96575_
                        (+ _i96579_ (string-length _sep96576_))
                        (string-length _s96575_))
                       _sep96576_
                       (- _limit96577_ '1)))
                (list _s96575_))))))
  (define std/srfi/130#string-remove
    (lambda (_pred96569_ _s96570_ . _args96571_)
      (apply std/srfi/13#string-filter
             (lambda (_c96573_) (not (_pred96569_ _c96573_)))
             _s96570_
             _args96571_))))
