(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/s16#s16vector-unfold
    (lambda (_f140227_ _len140229_ _seed140231_)
      (declare (not safe))
      (begin
        (if (procedure? _f140227_)
            '#!void
            (error '"Bad argument; expected procedure" _f140227_))
        (let ((_v140235_ (make-s16vector _len140229_)))
          (let _lp140238_ ((_i140241_ '0) (_state140243_ _seed140231_))
            (if (fx< _i140241_ _len140229_)
                (let ((_g299098_ (_f140227_ _i140241_ _state140243_)))
                  (begin
                    (let ((_g299099_
                           (if (##values? _g299098_)
                               (##vector-length _g299098_)
                               1)))
                      (if (not (##fx= _g299099_ 2))
                          (error "Context expects 2 values" _g299099_)))
                    (let ((_x140246_ (##vector-ref _g299098_ 0))
                          (_state140248_ (##vector-ref _g299098_ 1)))
                      (begin
                        (if (std/srfi/160/base#s16? _x140246_)
                            '#!void
                            (error '"Bad generated value" _x140246_))
                        (s16vector-set! _v140235_ _i140241_ _x140246_)
                        (_lp140238_ (fx+ _i140241_ '1) _state140248_)))))
                _v140235_))))))
  (define std/srfi/160/s16#s16vector-unfold-right
    (lambda (_f140204_ _len140206_ _seed140208_)
      (declare (not safe))
      (begin
        (if (procedure? _f140204_)
            '#!void
            (error '"Bad argument; expected procedure" _f140204_))
        (let ((_v140212_ (make-s16vector _len140206_)))
          (let _lp140215_ ((_i140218_ (fx- _len140206_ '1))
                           (_state140220_ _seed140208_))
            (if (fx>= _i140218_ '0)
                (let ((_g299100_ (_f140204_ _i140218_ _state140220_)))
                  (begin
                    (let ((_g299101_
                           (if (##values? _g299100_)
                               (##vector-length _g299100_)
                               1)))
                      (if (not (##fx= _g299101_ 2))
                          (error "Context expects 2 values" _g299101_)))
                    (let ((_x140223_ (##vector-ref _g299100_ 0))
                          (_state140225_ (##vector-ref _g299100_ 1)))
                      (begin
                        (if (std/srfi/160/base#s16? _x140223_)
                            '#!void
                            (error '"Bad generated value" _x140223_))
                        (s16vector-set! _v140212_ _i140218_ _x140223_)
                        (_lp140215_ (fx- _i140218_ '1) _state140225_)))))
                _v140212_))))))
  (define std/srfi/160/s16#s16vector-copy__%
    (lambda (_vec140176_ _start140178_ _end140180_)
      (let ((_v140183_ (make-s16vector (fx- _end140180_ _start140178_))))
        (std/srfi/160/s16#s16vector-copy!
         _v140183_
         '0
         _vec140176_
         _start140178_
         _end140180_)
        _v140183_)))
  (define std/srfi/160/s16#s16vector-copy__0
    (lambda (_vec140189_)
      (let* ((_start140191_ '0) (_end140193_ (s16vector-length _vec140189_)))
        (std/srfi/160/s16#s16vector-copy__%
         _vec140189_
         _start140191_
         _end140193_))))
  (define std/srfi/160/s16#s16vector-copy__1
    (lambda (_vec140195_ _start140196_)
      (let ((_end140198_ (s16vector-length _vec140195_)))
        (std/srfi/160/s16#s16vector-copy__%
         _vec140195_
         _start140196_
         _end140198_))))
  (define std/srfi/160/s16#s16vector-copy
    (lambda _g299103_
      (let ((_g299102_ (let () (declare (not safe)) (##length _g299103_))))
        (cond ((let () (declare (not safe)) (##fx= _g299102_ 1))
               (apply std/srfi/160/s16#s16vector-copy__0 _g299103_))
              ((let () (declare (not safe)) (##fx= _g299102_ 2))
               (apply std/srfi/160/s16#s16vector-copy__1 _g299103_))
              ((let () (declare (not safe)) (##fx= _g299102_ 3))
               (apply std/srfi/160/s16#s16vector-copy__% _g299103_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-copy
                _g299103_))))))
  (define std/srfi/160/s16#s16vector-copy!
    (lambda (_to140155_ _at140157_ _from140159_ _start140161_ _end140163_)
      (declare (not safe))
      (begin
        (if (s16vector? _to140155_) '#!void (error '"Bad argument" _to140155_))
        (if (s16vector? _from140159_)
            '#!void
            (error '"Bad argument" _from140159_))
        (if (and (fixnum? _at140157_)
                 (fx<= '0 _at140157_ (fx- (s16vector-length _at140157_) '1)))
            '#!void
            (error '"Index out of range" _to140155_ _at140157_))
        (if (and (fixnum? _start140161_)
                 (fx<= '0
                       _start140161_
                       (fx- (s16vector-length _from140159_) '1)))
            '#!void
            (error '"Index out of range" _from140159_ _start140161_))
        (if (and (fixnum? _end140163_)
                 (fx<= _start140161_
                       _end140163_
                       (s16vector-length _from140159_)))
            '#!void
            (error '"Index out of range" _from140159_ _end140163_))
        (if (fx<= (fx- _end140163_ _start140161_)
                  (fx- (s16vector-length _to140155_) _at140157_))
            '#!void
            (error '"Destination area too small"
                   _to140155_
                   _at140157_
                   _from140159_
                   _start140161_
                   _end140163_))
        (let _lp140167_ ((_i140170_ _start140161_) (_j140172_ _at140157_))
          (if (fx< _i140170_ _end140163_)
              (begin
                (s16vector-set!
                 _to140155_
                 _j140172_
                 (s16vector-ref _from140159_ _i140170_))
                (_lp140167_ (fx+ _i140170_ '1) (fx+ _j140172_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-reverse-copy__%
    (lambda (_vec140127_ _start140129_ _end140131_)
      (let ((_v140134_ (make-s16vector (fx- _end140131_ _start140129_))))
        (std/srfi/160/s16#s16vector-reverse-copy!
         _v140134_
         '0
         _vec140127_
         _start140129_
         _end140131_)
        _v140134_)))
  (define std/srfi/160/s16#s16vector-reverse-copy__0
    (lambda (_vec140140_)
      (let* ((_start140142_ '0) (_end140144_ (s16vector-length _vec140140_)))
        (std/srfi/160/s16#s16vector-reverse-copy__%
         _vec140140_
         _start140142_
         _end140144_))))
  (define std/srfi/160/s16#s16vector-reverse-copy__1
    (lambda (_vec140146_ _start140147_)
      (let ((_end140149_ (s16vector-length _vec140146_)))
        (std/srfi/160/s16#s16vector-reverse-copy__%
         _vec140146_
         _start140147_
         _end140149_))))
  (define std/srfi/160/s16#s16vector-reverse-copy
    (lambda _g299105_
      (let ((_g299104_ (let () (declare (not safe)) (##length _g299105_))))
        (cond ((let () (declare (not safe)) (##fx= _g299104_ 1))
               (apply std/srfi/160/s16#s16vector-reverse-copy__0 _g299105_))
              ((let () (declare (not safe)) (##fx= _g299104_ 2))
               (apply std/srfi/160/s16#s16vector-reverse-copy__1 _g299105_))
              ((let () (declare (not safe)) (##fx= _g299104_ 3))
               (apply std/srfi/160/s16#s16vector-reverse-copy__% _g299105_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-reverse-copy
                _g299105_))))))
  (define std/srfi/160/s16#s16vector-reverse-copy!
    (lambda (_to140106_ _at140108_ _from140110_ _start140112_ _end140114_)
      (declare (not safe))
      (begin
        (if (s16vector? _to140106_) '#!void (error '"Bad argument" _to140106_))
        (if (s16vector? _from140110_)
            '#!void
            (error '"Bad argument" _from140110_))
        (if (and (fixnum? _at140108_)
                 (fx<= '0 _at140108_ (fx- (s16vector-length _at140108_) '1)))
            '#!void
            (error '"Index out of range" _to140106_ _at140108_))
        (if (and (fixnum? _start140112_)
                 (fx<= '0
                       _start140112_
                       (fx- (s16vector-length _from140110_) '1)))
            '#!void
            (error '"Index out of range" _from140110_ _start140112_))
        (if (and (fixnum? _end140114_)
                 (fx<= _start140112_
                       _end140114_
                       (s16vector-length _from140110_)))
            '#!void
            (error '"Index out of range" _from140110_ _end140114_))
        (if (fx<= (fx- _end140114_ _start140112_)
                  (fx- (s16vector-length _to140106_) _at140108_))
            '#!void
            (error '"Destination area too small"
                   _to140106_
                   _at140108_
                   _from140110_
                   _start140112_
                   _end140114_))
        (let _lp140118_ ((_i140121_ (fx- _end140114_ '1))
                         (_j140123_ _at140108_))
          (if (fx>= _i140121_ _start140112_)
              (begin
                (s16vector-set!
                 _to140106_
                 _j140123_
                 (s16vector-ref _from140110_ _i140121_))
                (_lp140118_ (fx- _i140121_ '1) (fx+ _j140123_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-append
    (lambda _args140103_
      (std/srfi/160/s16#s16vector-concatenate _args140103_)))
  (define std/srfi/160/s16#s16vector-concatenate
    (lambda (_lst140043_)
      (let* ((_len140051_
              (foldl1 (lambda (_v140046_ _r140048_)
                        (fx+ (s16vector-length _v140046_) _r140048_))
                      '0
                      _lst140043_))
             (_v140054_ (make-s16vector _len140051_)))
        (declare (not safe))
        (let _lp140058_ ((_rest140061_ _lst140043_) (_at140063_ '0))
          (let* ((_rest140065140073_ _rest140061_)
                 (_else140067140081_ (lambda () _v140054_))
                 (_K140069140091_
                  (lambda (_rest140084_ _u140085_)
                    (let ((_ulen140088_ (s16vector-length _u140085_)))
                      (std/srfi/160/s16#s16vector-copy!
                       _v140054_
                       _at140063_
                       _u140085_
                       '0
                       _ulen140088_)
                      (_lp140058_
                       _rest140084_
                       (fx+ _at140063_ _ulen140088_))))))
            (if (##pair? _rest140065140073_)
                (let ((_hd140070140094_ (##car _rest140065140073_))
                      (_tl140071140096_ (##cdr _rest140065140073_)))
                  (let* ((_u140099_ _hd140070140094_)
                         (_rest140101_ _tl140071140096_))
                    (_K140069140091_ _rest140101_ _u140099_)))
                (_else140067140081_)))))))
  (define std/srfi/160/s16#s16vector-append-subvectors
    (lambda _args139915_
      (let* ((_len139976_
              (let _lp139918_ ((_rest139921_ _args139915_) (_r139923_ '0))
                (let* ((_rest139925139937_ _rest139921_)
                       (_else139927139945_ (lambda () _r139923_))
                       (_K139929139954_
                        (lambda (_rest139948_ _end139949_ _start139951_)
                          (_lp139918_
                           _rest139948_
                           (fx+ _r139923_ (fx- _end139949_ _start139951_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest139925139937_))
                      (let ((_tl139931139957_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest139925139937_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl139931139957_))
                            (let ((_hd139932139960_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl139931139957_)))
                                  (_tl139933139962_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl139931139957_))))
                              (let ((_start139965_ _hd139932139960_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl139933139962_))
                                    (let ((_hd139934139967_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl139933139962_)))
                                          (_tl139935139969_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl139933139962_))))
                                      (let* ((_end139972_ _hd139934139967_)
                                             (_rest139974_ _tl139935139969_))
                                        (_K139929139954_
                                         _rest139974_
                                         _end139972_
                                         _start139965_)))
                                    (_else139927139945_))))
                            (_else139927139945_)))
                      (_else139927139945_)))))
             (_v139979_ (make-s16vector _len139976_)))
        (let _lp139983_ ((_rest139985_ _args139915_) (_at139986_ '0))
          (let* ((_rest139988140000_ _rest139985_)
                 (_else139990140008_ (lambda () _v139979_))
                 (_K139992140017_
                  (lambda (_rest140011_ _end140012_ _start140013_ _u140014_)
                    (std/srfi/160/s16#s16vector-copy!
                     _v139979_
                     _at139986_
                     _u140014_
                     _start140013_
                     _end140012_)
                    (_lp139983_
                     _rest140011_
                     (fx+ _at139986_ (fx- _end140012_ _start140013_))))))
            (if (let () (declare (not safe)) (##pair? _rest139988140000_))
                (let ((_hd139993140020_
                       (let ()
                         (declare (not safe))
                         (##car _rest139988140000_)))
                      (_tl139994140022_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest139988140000_))))
                  (let ((_u140025_ _hd139993140020_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl139994140022_))
                        (let ((_hd139995140027_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl139994140022_)))
                              (_tl139996140029_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl139994140022_))))
                          (let ((_start140032_ _hd139995140027_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl139996140029_))
                                (let ((_hd139997140034_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl139996140029_)))
                                      (_tl139998140036_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl139996140029_))))
                                  (let* ((_end140039_ _hd139997140034_)
                                         (_rest140041_ _tl139998140036_))
                                    (_K139992140017_
                                     _rest140041_
                                     _end140039_
                                     _start140032_
                                     _u140025_)))
                                (_else139990140008_))))
                        (_else139990140008_))))
                (_else139990140008_)))))))
  (define std/srfi/160/s16#s16vector-empty?
    (lambda (_v139912_) (fxzero? (s16vector-length _v139912_))))
  (define std/srfi/160/s16#s16vector=
    (lambda (_v139854_ . _args139856_)
      (declare (not safe))
      (begin
        (if (s16vector? _v139854_) '#!void (error '"Bad argument" _v139854_))
        (let ((_vlen139860_ (s16vector-length _v139854_)))
          (let _lp139863_ ((_rest139866_ _args139856_))
            (let* ((_rest139868139876_ _rest139866_)
                   (_else139870139884_ (lambda () '#t))
                   (_K139872139900_
                    (lambda (_rest139887_ _u139888_)
                      (if (s16vector? _u139888_)
                          '#!void
                          (error '"Bad argument" _u139888_))
                      (let ((_ulen139891_ (s16vector-length _u139888_)))
                        (if (fx= _vlen139860_ _ulen139891_)
                            (let _cmp139894_ ((_i139897_ '0))
                              (if (fx< _i139897_ _vlen139860_)
                                  (if (= (s16vector-ref _v139854_ _i139897_)
                                         (s16vector-ref _u139888_ _i139897_))
                                      (_cmp139894_ (fx+ _i139897_ '1))
                                      '#f)
                                  (_lp139863_ _rest139887_)))
                            '#f)))))
              (if (##pair? _rest139868139876_)
                  (let ((_hd139873139903_ (##car _rest139868139876_))
                        (_tl139874139905_ (##cdr _rest139868139876_)))
                    (let* ((_u139908_ _hd139873139903_)
                           (_rest139910_ _tl139874139905_))
                      (_K139872139900_ _rest139910_ _u139908_)))
                  (_else139870139884_))))))))
  (define std/srfi/160/s16#s16vector-take
    (lambda (_v139846_ _n139848_)
      (let ((_u139851_ (make-s16vector _n139848_)))
        (std/srfi/160/s16#s16vector-copy! _u139851_ '0 _v139846_ '0 _n139848_)
        _u139851_)))
  (define std/srfi/160/s16#s16vector-take-right
    (lambda (_v139831_ _n139833_)
      (let* ((_vlen139836_ (s16vector-length _v139831_))
             (_ulen139839_ (fx- _vlen139836_ _n139833_))
             (_u139842_ (make-s16vector _ulen139839_)))
        (std/srfi/160/s16#s16vector-copy!
         _u139842_
         '0
         _v139831_
         _n139833_
         _vlen139836_)
        _u139842_)))
  (define std/srfi/160/s16#s16vector-drop
    (lambda (_v139816_ _n139818_)
      (let* ((_vlen139821_ (s16vector-length _v139816_))
             (_ulen139824_ (fx- _vlen139821_ _n139818_))
             (_u139827_ (make-s16vector _ulen139824_)))
        (std/srfi/160/s16#s16vector-copy!
         _u139827_
         '0
         _v139816_
         _n139818_
         _vlen139821_)
        _u139827_)))
  (define std/srfi/160/s16#s16vector-drop-right
    (lambda (_v139801_ _n139803_)
      (let* ((_vlen139806_ (s16vector-length _v139801_))
             (_ulen139809_ (fx- _vlen139806_ _n139803_))
             (_u139812_ (make-s16vector _ulen139809_)))
        (std/srfi/160/s16#s16vector-copy!
         _u139812_
         '0
         _v139801_
         '0
         _ulen139809_)
        _u139812_)))
  (define std/srfi/160/s16#s16vector-segment
    (lambda (_v139783_ _n139785_)
      (let _lp139788_ ((_i139791_ '0)
                       (_rest139793_ (s16vector-length _v139783_))
                       (_r139795_ '()))
        (if (fx> _r139795_ '0)
            (let ((_size139798_ (fxmin _n139785_ _rest139793_)))
              (_lp139788_
               (fx+ _i139791_ _size139798_)
               (fx- _rest139793_ _size139798_)
               (cons (std/srfi/160/s16#s16vector-copy__%
                      _v139783_
                      _i139791_
                      (fx+ _i139791_ _size139798_))
                     _r139795_)))
            (reverse _r139795_)))))
  (define std/srfi/160/s16#s16vector-fold__0
    (lambda (_kons139743_ _knil139745_ _v139747_)
      (if (procedure? _kons139743_)
          '#!void
          (error '"Bad argument; expected procedure" _kons139743_))
      (let ((_end139750_ (s16vector-length _v139747_)))
        (declare (not safe))
        (let _lp139754_ ((_i139757_ '0) (_r139759_ _knil139745_))
          (if (fx< _i139757_ _end139750_)
              (_lp139754_
               (fx+ _i139757_ '1)
               (_kons139743_ _r139759_ (s16vector-ref _v139747_ _i139757_)))
              _r139759_)))))
  (define std/srfi/160/s16#s16vector-fold__1
    (lambda (_kons139762_ _knil139763_ _v139764_ . _vs139765_)
      (if (procedure? _kons139762_)
          '#!void
          (error '"Bad argument; expected procedure" _kons139762_))
      (let* ((_vs139768_ (cons _v139764_ _vs139765_))
             (_end139770_ (apply fxmin (map s16vector-length _vs139768_))))
        (declare (not safe))
        (let _lp139774_ ((_i139776_ '0) (_r139777_ _knil139763_))
          (if (fx< _i139776_ _end139770_)
              (_lp139774_
               (fx+ _i139776_ '1)
               (apply _kons139762_
                      _r139777_
                      (map (lambda (_g139778139780_)
                             (s16vector-ref _g139778139780_ _i139776_))
                           _vs139768_)))
              _r139777_)))))
  (define std/srfi/160/s16#s16vector-fold
    (lambda _g299107_
      (let ((_g299106_ (let () (declare (not safe)) (##length _g299107_))))
        (cond ((let () (declare (not safe)) (##fx= _g299106_ 3))
               (apply std/srfi/160/s16#s16vector-fold__0 _g299107_))
              ((let () (declare (not safe)) (##fx>= _g299106_ 3))
               (apply std/srfi/160/s16#s16vector-fold__1 _g299107_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-fold
                _g299107_))))))
  (define std/srfi/160/s16#s16vector-fold-right__0
    (lambda (_kons139703_ _knil139705_ _v139707_)
      (if (procedure? _kons139703_)
          '#!void
          (error '"Bad argument; expected procedure" _kons139703_))
      (let ((_last139710_ (fx- (s16vector-length _v139707_) '1)))
        (declare (not safe))
        (let _lp139714_ ((_i139717_ _last139710_) (_r139719_ _knil139705_))
          (if (fx>= _i139717_ '0)
              (_lp139714_
               (fx- _i139717_ '1)
               (_kons139703_ _r139719_ (s16vector-ref _v139707_ _i139717_)))
              _r139719_)))))
  (define std/srfi/160/s16#s16vector-fold-right__1
    (lambda (_kons139722_ _knil139723_ _v139724_ . _vs139725_)
      (if (procedure? _kons139722_)
          '#!void
          (error '"Bad argument; expected procedure" _kons139722_))
      (let* ((_vs139728_ (cons _v139724_ _vs139725_))
             (_last139730_
              (fx- (apply min (map s16vector-length _vs139728_)) '1)))
        (declare (not safe))
        (let _lp139734_ ((_i139736_ _last139730_) (_r139737_ _knil139723_))
          (if (fx>= _i139736_ '0)
              (_lp139734_
               (fx- _i139736_ '1)
               (apply _kons139722_
                      _r139737_
                      (map (lambda (_g139738139740_)
                             (s16vector-ref _g139738139740_ _i139736_))
                           _vs139728_)))
              _r139737_)))))
  (define std/srfi/160/s16#s16vector-fold-right
    (lambda _g299109_
      (let ((_g299108_ (let () (declare (not safe)) (##length _g299109_))))
        (cond ((let () (declare (not safe)) (##fx= _g299108_ 3))
               (apply std/srfi/160/s16#s16vector-fold-right__0 _g299109_))
              ((let () (declare (not safe)) (##fx>= _g299108_ 3))
               (apply std/srfi/160/s16#s16vector-fold-right__1 _g299109_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-fold-right
                _g299109_))))))
  (define std/srfi/160/s16#s16vector-map__0
    (lambda (_f139663_ _v139665_)
      (if (procedure? _f139663_)
          '#!void
          (error '"Bad argument; expected procedure" _f139663_))
      (let* ((_len139668_ (s16vector-length _v139665_))
             (_u139671_ (make-s16vector _len139668_)))
        (declare (not safe))
        (let _lp139676_ ((_i139679_ '0))
          (if (fx< _i139679_ _len139668_)
              (begin
                (s16vector-set!
                 _u139671_
                 _i139679_
                 (s16vector-ref _v139665_ _i139679_))
                (_lp139676_ (fx+ _i139679_ '1)))
              _u139671_)))))
  (define std/srfi/160/s16#s16vector-map__1
    (lambda (_f139682_ _v139683_ . _vs139684_)
      (if (procedure? _f139682_)
          '#!void
          (error '"Bad argument; expected procedure" _f139682_))
      (let* ((_vs139687_ (cons _v139683_ _vs139684_))
             (_len139689_ (apply fxmin (map s16vector-length _vs139687_)))
             (_u139691_ (make-s16vector _len139689_)))
        (declare (not safe))
        (let _lp139695_ ((_i139697_ '0))
          (if (fx< _i139697_ _len139689_)
              (begin
                (s16vector-set!
                 _u139691_
                 _i139697_
                 (apply _f139682_
                        (map (lambda (_g139698139700_)
                               (s16vector-ref _g139698139700_ _i139697_))
                             _vs139687_)))
                (_lp139695_ (fx+ _i139697_ '1)))
              _u139691_)))))
  (define std/srfi/160/s16#s16vector-map
    (lambda _g299111_
      (let ((_g299110_ (let () (declare (not safe)) (##length _g299111_))))
        (cond ((let () (declare (not safe)) (##fx= _g299110_ 2))
               (apply std/srfi/160/s16#s16vector-map__0 _g299111_))
              ((let () (declare (not safe)) (##fx>= _g299110_ 2))
               (apply std/srfi/160/s16#s16vector-map__1 _g299111_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-map
                _g299111_))))))
  (define std/srfi/160/s16#s16vector-map!__0
    (lambda (_f139629_ _v139631_)
      (if (procedure? _f139629_)
          '#!void
          (error '"Bad argument; expected procedure" _f139629_))
      (let ((_len139634_ (s16vector-length _v139631_)))
        (declare (not safe))
        (let _lp139638_ ((_i139641_ '0))
          (if (fx< _i139641_ _len139634_)
              (begin
                (s16vector-set!
                 _v139631_
                 _i139641_
                 (_f139629_ (s16vector-ref _v139631_ _i139641_)))
                (_lp139638_ (fx+ _i139641_ '1)))
              _v139631_)))))
  (define std/srfi/160/s16#s16vector-map!__1
    (lambda (_f139644_ _v139645_ . _vs139646_)
      (if (procedure? _f139644_)
          '#!void
          (error '"Bad argument; expected procedure" _f139644_))
      (let* ((_vs139649_ (cons _v139645_ _vs139646_))
             (_len139651_ (apply fxmin (map s16vector-length _vs139649_))))
        (declare (not safe))
        (let _lp139655_ ((_i139657_ '0))
          (if (fx< _i139657_ _len139651_)
              (begin
                (s16vector-set!
                 _v139645_
                 _i139657_
                 (apply _f139644_
                        (map (lambda (_g139658139660_)
                               (s16vector-ref _g139658139660_ _i139657_))
                             _vs139649_)))
                (_lp139655_ (fx+ _i139657_ '1)))
              _v139645_)))))
  (define std/srfi/160/s16#s16vector-map!
    (lambda _g299113_
      (let ((_g299112_ (let () (declare (not safe)) (##length _g299113_))))
        (cond ((let () (declare (not safe)) (##fx= _g299112_ 2))
               (apply std/srfi/160/s16#s16vector-map!__0 _g299113_))
              ((let () (declare (not safe)) (##fx>= _g299112_ 2))
               (apply std/srfi/160/s16#s16vector-map!__1 _g299113_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-map!
                _g299113_))))))
  (define std/srfi/160/s16#s16vector-for-each__0
    (lambda (_f139595_ _v139597_)
      (if (procedure? _f139595_)
          '#!void
          (error '"Bad argument; expected procedure" _f139595_))
      (let ((_len139600_ (s16vector-length _v139597_)))
        (declare (not safe))
        (let _lp139604_ ((_i139607_ '0))
          (if (fx< _i139607_ _len139600_)
              (begin
                (_f139595_ (s16vector-ref _v139597_ _i139607_))
                (_lp139604_ (fx+ _i139607_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-for-each__1
    (lambda (_f139610_ _v139611_ . _vs139612_)
      (let* ((_vs139615_ (cons _v139611_ _vs139612_))
             (_len139617_ (apply fxmin (map s16vector-length _vs139615_))))
        (declare (not safe))
        (let _lp139621_ ((_i139623_ '0))
          (if (fx< _i139623_ _len139617_)
              (begin
                (apply _f139610_
                       (map (lambda (_g139624139626_)
                              (s16vector-ref _g139624139626_ _i139623_))
                            _vs139615_))
                (_lp139621_ (fx+ _i139623_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-for-each
    (lambda _g299115_
      (let ((_g299114_ (let () (declare (not safe)) (##length _g299115_))))
        (cond ((let () (declare (not safe)) (##fx= _g299114_ 2))
               (apply std/srfi/160/s16#s16vector-for-each__0 _g299115_))
              ((let () (declare (not safe)) (##fx>= _g299114_ 2))
               (apply std/srfi/160/s16#s16vector-for-each__1 _g299115_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-for-each
                _g299115_))))))
  (define std/srfi/160/s16#s16vector-count__0
    (lambda (_pred139558_ _v139560_)
      (if (procedure? _pred139558_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139558_))
      (let ((_end139563_ (s16vector-length _v139560_)))
        (declare (not safe))
        (let _lp139567_ ((_i139570_ '0) (_r139572_ '0))
          (if (fx< _i139570_ _end139563_)
              (if (_pred139558_ (s16vector-ref _v139560_ _i139570_))
                  (_lp139567_ (fx+ _i139570_ '1) (fx+ _r139572_ '1))
                  (_lp139567_ (fx+ _i139570_ '1) _r139572_))
              _r139572_)))))
  (define std/srfi/160/s16#s16vector-count__1
    (lambda (_pred139575_ _v139576_ . _vs139577_)
      (if (procedure? _pred139575_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139575_))
      (let* ((_vs139580_ (cons _v139576_ _vs139577_))
             (_end139582_ (apply fxmin (map s16vector-length _vs139580_))))
        (declare (not safe))
        (let _lp139586_ ((_i139588_ '0) (_r139589_ '0))
          (if (fx< _i139588_ _end139582_)
              (if (apply _pred139575_
                         (map (lambda (_g139590139592_)
                                (s16vector-ref _g139590139592_ _i139588_))
                              _vs139580_))
                  (_lp139586_ (fx+ _i139588_ '1) (fx+ _r139589_ '1))
                  (_lp139586_ (fx+ _i139588_ '1) _r139589_))
              _r139589_)))))
  (define std/srfi/160/s16#s16vector-count
    (lambda _g299117_
      (let ((_g299116_ (let () (declare (not safe)) (##length _g299117_))))
        (cond ((let () (declare (not safe)) (##fx= _g299116_ 2))
               (apply std/srfi/160/s16#s16vector-count__0 _g299117_))
              ((let () (declare (not safe)) (##fx>= _g299116_ 2))
               (apply std/srfi/160/s16#s16vector-count__1 _g299117_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-count
                _g299117_))))))
  (define std/srfi/160/s16#s16vector-cumulate
    (lambda (_f139533_ _knil139535_ _v139537_)
      (if (procedure? _f139533_)
          '#!void
          (error '"Bad argument; expected procedure" _f139533_))
      (let* ((_len139540_ (s16vector-length _v139537_))
             (_r139543_ (make-s16vector _len139540_)))
        (declare (not safe))
        (let _lp139548_ ((_i139551_ '0) (_r139553_ _knil139535_))
          (if (fx< _i139551_ _len139540_)
              (let ((_next139555_
                     (_f139533_
                      _r139553_
                      (s16vector-ref _v139537_ _i139551_))))
                (s16vector-set! _v139537_ _i139551_ _next139555_)
                (_lp139548_ (fx+ _i139551_ '1) _next139555_))
              _v139537_)))))
  (define std/srfi/160/s16#s16vector-take-while
    (lambda (_pred139516_ _v139518_)
      (let* ((_len139521_ (s16vector-length _v139518_))
             (_idx139524_
              (std/srfi/160/s16#s16vector-skip__0 _pred139516_ _v139518_))
             (_idx139530_
              (let ((_$e139527_ _idx139524_))
                (if _$e139527_ _$e139527_ _len139521_))))
        (std/srfi/160/s16#s16vector-copy__% _v139518_ '0 _idx139530_))))
  (define std/srfi/160/s16#s16vector-take-while-right
    (lambda (_pred139502_ _v139504_)
      (let* ((_len139507_ (s16vector-length _v139504_))
             (_idx139510_
              (std/srfi/160/s16#s16vector-skip-right__0
               _pred139502_
               _v139504_))
             (_idx139513_ (if _idx139510_ (fx+ _idx139510_ '1) '0)))
        (std/srfi/160/s16#s16vector-copy__%
         _v139504_
         _idx139513_
         _len139507_))))
  (define std/srfi/160/s16#s16vector-drop-while
    (lambda (_pred139485_ _v139487_)
      (let* ((_len139490_ (s16vector-length _v139487_))
             (_idx139493_
              (std/srfi/160/s16#s16vector-skip__0 _pred139485_ _v139487_))
             (_idx139499_
              (let ((_$e139496_ _idx139493_))
                (if _$e139496_ _$e139496_ _len139490_))))
        (std/srfi/160/s16#s16vector-copy__%
         _v139487_
         _idx139499_
         _len139490_))))
  (define std/srfi/160/s16#s16vector-drop-while-right
    (lambda (_pred139471_ _v139473_)
      (let* ((_len139476_ (s16vector-length _v139473_))
             (_idx139479_
              (std/srfi/160/s16#s16vector-skip-right__0
               _pred139471_
               _v139473_))
             (_idx139482_ (if _idx139479_ (fx+ _idx139479_ '1) '0)))
        (std/srfi/160/s16#s16vector-copy__% _v139473_ '0 _idx139482_))))
  (define std/srfi/160/s16#s16vector-index__0
    (lambda (_pred139437_ _v139439_)
      (if (procedure? _pred139437_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139437_))
      (let ((_end139442_ (s16vector-length _v139439_)))
        (declare (not safe))
        (let _lp139446_ ((_i139449_ '0))
          (if (fx< _i139449_ _end139442_)
              (if (_pred139437_ (s16vector-ref _v139439_ _i139449_))
                  _i139449_
                  (_lp139446_ (fx+ _i139449_ '1)))
              '#f)))))
  (define std/srfi/160/s16#s16vector-index__1
    (lambda (_pred139452_ _v139453_ . _vs139454_)
      (if (procedure? _pred139452_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139452_))
      (let* ((_vs139457_ (cons _v139453_ _vs139454_))
             (_end139459_ (apply fxmin (map s16vector-length _vs139457_))))
        (declare (not safe))
        (let _lp139463_ ((_i139465_ '0))
          (if (fx< _i139465_ _end139459_)
              (if (apply _pred139452_
                         (map (lambda (_g139466139468_)
                                (s16vector-ref _g139466139468_ _i139465_))
                              _vs139457_))
                  _i139465_
                  (_lp139463_ (fx+ _i139465_ '1)))
              '#f)))))
  (define std/srfi/160/s16#s16vector-index
    (lambda _g299119_
      (let ((_g299118_ (let () (declare (not safe)) (##length _g299119_))))
        (cond ((let () (declare (not safe)) (##fx= _g299118_ 2))
               (apply std/srfi/160/s16#s16vector-index__0 _g299119_))
              ((let () (declare (not safe)) (##fx>= _g299118_ 2))
               (apply std/srfi/160/s16#s16vector-index__1 _g299119_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-index
                _g299119_))))))
  (define std/srfi/160/s16#s16vector-index-right__0
    (lambda (_pred139403_ _v139405_)
      (if (procedure? _pred139403_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139403_))
      (let ((_start139408_ (fx- (s16vector-length _v139405_) '1)))
        (declare (not safe))
        (let _lp139412_ ((_i139415_ _start139408_))
          (if (fx>= _i139415_ '0)
              (if (_pred139403_ (s16vector-ref _v139405_ _i139415_))
                  _i139415_
                  (_lp139412_ (fx- _i139415_ '1)))
              '#f)))))
  (define std/srfi/160/s16#s16vector-index-right__1
    (lambda (_pred139418_ _v139419_ . _vs139420_)
      (if (procedure? _pred139418_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139418_))
      (let* ((_vs139423_ (cons _v139419_ _vs139420_))
             (_start139425_
              (fx- (apply fxmin (map s16vector-length _vs139423_)) '1)))
        (declare (not safe))
        (let _lp139429_ ((_i139431_ _start139425_))
          (if (fx>= _i139431_ '0)
              (if (apply _pred139418_
                         (map (lambda (_g139432139434_)
                                (s16vector-ref _g139432139434_ _i139431_))
                              _vs139423_))
                  _i139431_
                  (_lp139429_ (fx- _i139431_ '1)))
              '#f)))))
  (define std/srfi/160/s16#s16vector-index-right
    (lambda _g299121_
      (let ((_g299120_ (let () (declare (not safe)) (##length _g299121_))))
        (cond ((let () (declare (not safe)) (##fx= _g299120_ 2))
               (apply std/srfi/160/s16#s16vector-index-right__0 _g299121_))
              ((let () (declare (not safe)) (##fx>= _g299120_ 2))
               (apply std/srfi/160/s16#s16vector-index-right__1 _g299121_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-index-right
                _g299121_))))))
  (define std/srfi/160/s16#s16vector-skip__0
    (lambda (_pred139387_ _v139389_)
      (std/srfi/160/s16#s16vector-index__0
       (lambda (_$obj139392_) (not (_pred139387_ _$obj139392_)))
       _v139389_)))
  (define std/srfi/160/s16#s16vector-skip__1
    (lambda (_pred139395_ _v139396_ . _vs139397_)
      (apply std/srfi/160/s16#s16vector-index
             (lambda (_$obj139400_) (not (_pred139395_ _$obj139400_)))
             _v139396_
             _vs139397_)))
  (define std/srfi/160/s16#s16vector-skip
    (lambda _g299123_
      (let ((_g299122_ (let () (declare (not safe)) (##length _g299123_))))
        (cond ((let () (declare (not safe)) (##fx= _g299122_ 2))
               (apply std/srfi/160/s16#s16vector-skip__0 _g299123_))
              ((let () (declare (not safe)) (##fx>= _g299122_ 2))
               (apply std/srfi/160/s16#s16vector-skip__1 _g299123_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-skip
                _g299123_))))))
  (define std/srfi/160/s16#s16vector-skip-right__0
    (lambda (_pred139371_ _v139373_)
      (std/srfi/160/s16#s16vector-index-right__0
       (lambda (_$obj139376_) (not (_pred139371_ _$obj139376_)))
       _v139373_)))
  (define std/srfi/160/s16#s16vector-skip-right__1
    (lambda (_pred139379_ _v139380_ . _vs139381_)
      (apply std/srfi/160/s16#s16vector-index-right
             (lambda (_$obj139384_) (not (_pred139379_ _$obj139384_)))
             _v139380_
             _vs139381_)))
  (define std/srfi/160/s16#s16vector-skip-right
    (lambda _g299125_
      (let ((_g299124_ (let () (declare (not safe)) (##length _g299125_))))
        (cond ((let () (declare (not safe)) (##fx= _g299124_ 2))
               (apply std/srfi/160/s16#s16vector-skip-right__0 _g299125_))
              ((let () (declare (not safe)) (##fx>= _g299124_ 2))
               (apply std/srfi/160/s16#s16vector-skip-right__1 _g299125_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-skip-right
                _g299125_))))))
  (define std/srfi/160/s16#s16vector-any__0
    (lambda (_pred139331_ _v139333_)
      (if (procedure? _pred139331_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139331_))
      (let ((_end139336_ (s16vector-length _v139333_)))
        (declare (not safe))
        (let _lp139340_ ((_i139343_ '0))
          (if (fx< _i139343_ _end139336_)
              (let ((_$e139346_
                     (_pred139331_ (s16vector-ref _v139333_ _i139343_))))
                (if _$e139346_
                    (values _$e139346_)
                    (_lp139340_ (fx+ _i139343_ '1))))
              '#f)))))
  (define std/srfi/160/s16#s16vector-any__1
    (lambda (_pred139349_ _v139350_ . _vs139351_)
      (if (procedure? _pred139349_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139349_))
      (let* ((_v139354_ (cons _v139350_ _vs139351_))
             (_end139356_ (apply fxmin (map s16vector-length _vs139351_))))
        (declare (not safe))
        (let _lp139360_ ((_i139362_ '0))
          (if (fx< _i139362_ _end139356_)
              (let ((_$e139368_
                     (apply _pred139349_
                            (map (lambda (_g139363139365_)
                                   (s16vector-ref _g139363139365_ _i139362_))
                                 _vs139351_))))
                (if _$e139368_
                    (values _$e139368_)
                    (_lp139360_ (fx+ _i139362_ '1))))
              '#f)))))
  (define std/srfi/160/s16#s16vector-any
    (lambda _g299127_
      (let ((_g299126_ (let () (declare (not safe)) (##length _g299127_))))
        (cond ((let () (declare (not safe)) (##fx= _g299126_ 2))
               (apply std/srfi/160/s16#s16vector-any__0 _g299127_))
              ((let () (declare (not safe)) (##fx>= _g299126_ 2))
               (apply std/srfi/160/s16#s16vector-any__1 _g299127_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-any
                _g299127_))))))
  (define std/srfi/160/s16#s16vector-every__0
    (lambda (_pred139280_ _v139282_)
      (if (procedure? _pred139280_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139280_))
      (let ((_end139285_ (s16vector-length _v139282_)))
        (declare (not safe))
        (let _lp139289_ ((_i139292_ '0) (_r139294_ '#t))
          (if (fx< _i139292_ _end139285_)
              (let ((_$e139297_
                     (_pred139280_ (s16vector-ref _v139282_ _i139292_))))
                (if _$e139297_
                    ((lambda (_g139299139301_)
                       (_lp139289_ (fx+ _i139292_ '1) _g139299139301_))
                     _$e139297_)
                    '#f))
              _r139294_)))))
  (define std/srfi/160/s16#s16vector-every__1
    (lambda (_pred139304_ _v139305_ . _vs139306_)
      (if (procedure? _pred139304_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139304_))
      (let* ((_v139309_ (cons _v139305_ _vs139306_))
             (_end139311_ (apply fxmin (map s16vector-length _vs139306_))))
        (declare (not safe))
        (let _lp139315_ ((_i139317_ '0) (_r139318_ '#t))
          (if (fx< _i139317_ _end139311_)
              (let ((_$e139324_
                     (apply _pred139304_
                            (map (lambda (_g139319139321_)
                                   (s16vector-ref _g139319139321_ _i139317_))
                                 _vs139306_))))
                (if _$e139324_
                    ((lambda (_g139326139328_)
                       (_lp139315_ (fx+ _i139317_ '1) _g139326139328_))
                     _$e139324_)
                    '#f))
              _r139318_)))))
  (define std/srfi/160/s16#s16vector-every
    (lambda _g299129_
      (let ((_g299128_ (let () (declare (not safe)) (##length _g299129_))))
        (cond ((let () (declare (not safe)) (##fx= _g299128_ 2))
               (apply std/srfi/160/s16#s16vector-every__0 _g299129_))
              ((let () (declare (not safe)) (##fx>= _g299128_ 2))
               (apply std/srfi/160/s16#s16vector-every__1 _g299129_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-every
                _g299129_))))))
  (define std/srfi/160/s16#s16vector-partition
    (lambda (_pred139251_ _v139253_)
      (let* ((_count139256_
              (std/srfi/160/s16#s16vector-count__0 _pred139251_ _v139253_))
             (_len139259_ (s16vector-length _v139253_))
             (_u139262_ (make-s16vector _len139259_)))
        (declare (not safe))
        (let _lp139267_ ((_i139270_ '0)
                         (_left139272_ '0)
                         (_right139274_ _count139256_))
          (if (fx< _i139270_ _len139259_)
              (let ((_x139277_ (s16vector-ref _v139253_ _i139270_)))
                (if (_pred139251_ _x139277_)
                    (begin
                      (s16vector-set! _u139262_ _left139272_ _x139277_)
                      (_lp139267_
                       (fx+ _i139270_ '1)
                       (fx+ _left139272_ '1)
                       _right139274_))
                    (begin
                      (s16vector-set! _u139262_ _right139274_ _x139277_)
                      (_lp139267_
                       (fx+ _i139270_ '1)
                       _left139272_
                       (fx+ _right139274_ '1)))))
              _u139262_)))))
  (define std/srfi/160/s16#s16vector-filter
    (lambda (_pred139224_ _v139226_)
      (let* ((_count139229_
              (std/srfi/160/s16#s16vector-count__0 _pred139224_ _v139226_))
             (_u139232_ (make-s16vector _count139229_))
             (_end139235_ (s16vector-length _v139226_)))
        (declare (not safe))
        (let _lp139240_ ((_i139243_ '0) (_j139245_ '0))
          (if (fx< _i139243_ _end139235_)
              (let ((_x139248_ (s16vector-ref _v139226_ _i139243_)))
                (if (_pred139224_ _x139248_)
                    (begin
                      (s16vector-set! _u139232_ _j139245_ _x139248_)
                      (_lp139240_ (fx+ _i139243_ '1) (fx+ _j139245_ '1)))
                    (_lp139240_ (fx+ _i139243_ '1) _j139245_)))
              _u139232_)))))
  (define std/srfi/160/s16#s16vector-remove
    (lambda (_pred139216_ _v139218_)
      (std/srfi/160/s16#s16vector-filter
       (lambda (_$obj139221_) (not (_pred139216_ _$obj139221_)))
       _v139218_)))
  (define std/srfi/160/s16#s16vector-swap
    (lambda (_v139203_ _i139205_ _j139207_)
      (let ((_iv139210_ (s16vector-ref _v139203_ _i139205_))
            (_jv139212_ (s16vector-ref _v139203_ _j139207_)))
        (declare (not safe))
        (begin
          (s16vector-set! _v139203_ _i139205_ _jv139212_)
          (s16vector-set! _v139203_ _j139207_ _iv139210_)))))
  (define std/srfi/160/s16#s16vector-fill!__%
    (lambda (_v139166_ _fill139168_ _start139170_ _end139172_)
      (declare (not safe))
      (begin
        (if (s16vector? _v139166_) '#!void (error '"Bad argument" _v139166_))
        (if (std/srfi/160/base#s16? _fill139168_)
            '#!void
            (error '"Bad argument" _fill139168_))
        (if (and (fixnum? _start139170_)
                 (fx<= '0 _start139170_ (fx- (s16vector-length _v139166_) '1)))
            '#!void
            (error '"Index out of range" _start139170_))
        (if (and (fixnum? _end139172_)
                 (fx<= _start139170_ _end139172_ (s16vector-length _v139166_)))
            '#!void
            (error '"Index out of range" _end139172_))
        (let _lp139176_ ((_i139179_ _start139170_))
          (if (fx< _i139179_ _end139172_)
              (begin
                (s16vector-set! _v139166_ _i139179_ _fill139168_)
                (_lp139176_ (fx+ _i139179_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-fill!__0
    (lambda (_v139185_ _fill139186_)
      (let* ((_start139188_ '0) (_end139190_ (s16vector-length _v139185_)))
        (std/srfi/160/s16#s16vector-fill!__%
         _v139185_
         _fill139186_
         _start139188_
         _end139190_))))
  (define std/srfi/160/s16#s16vector-fill!__1
    (lambda (_v139192_ _fill139193_ _start139194_)
      (let ((_end139196_ (s16vector-length _v139192_)))
        (std/srfi/160/s16#s16vector-fill!__%
         _v139192_
         _fill139193_
         _start139194_
         _end139196_))))
  (define std/srfi/160/s16#s16vector-fill!
    (lambda _g299131_
      (let ((_g299130_ (let () (declare (not safe)) (##length _g299131_))))
        (cond ((let () (declare (not safe)) (##fx= _g299130_ 2))
               (apply std/srfi/160/s16#s16vector-fill!__0 _g299131_))
              ((let () (declare (not safe)) (##fx= _g299130_ 3))
               (apply std/srfi/160/s16#s16vector-fill!__1 _g299131_))
              ((let () (declare (not safe)) (##fx= _g299130_ 4))
               (apply std/srfi/160/s16#s16vector-fill!__% _g299131_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-fill!
                _g299131_))))))
  (define std/srfi/160/s16#s16vector-reverse!__%
    (lambda (_v139126_ _start139128_ _end139130_)
      (declare (not safe))
      (begin
        (if (s16vector? _v139126_) '#!void (error '"Bad argument" _v139126_))
        (if (and (fixnum? _start139128_)
                 (fx<= '0 _start139128_ (fx- (s16vector-length _v139126_) '1)))
            '#!void
            (error '"Index out of range" _start139128_))
        (if (and (fixnum? _end139130_)
                 (fx<= _start139128_ _end139130_ (s16vector-length _v139126_)))
            '#!void
            (error '"Index out of range" _end139130_))
        (let _lp139134_ ((_i139137_ _start139128_)
                         (_j139139_ (fx- _end139130_ '1)))
          (if (fx< _i139137_ _j139139_)
              (let ((_iv139142_ (s16vector-ref _v139126_ _i139137_))
                    (_jv139144_ (s16vector-ref _v139126_ _j139139_)))
                (s16vector-set! _v139126_ _i139137_ _jv139144_)
                (s16vector-set! _v139126_ _j139139_ _iv139142_)
                (_lp139134_ (fx+ _i139137_ '1) (fx- _j139139_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-reverse!__0
    (lambda (_v139150_)
      (let* ((_start139152_ '0) (_end139154_ (s16vector-length _v139150_)))
        (std/srfi/160/s16#s16vector-reverse!__%
         _v139150_
         _start139152_
         _end139154_))))
  (define std/srfi/160/s16#s16vector-reverse!__1
    (lambda (_v139156_ _start139157_)
      (let ((_end139159_ (s16vector-length _v139156_)))
        (std/srfi/160/s16#s16vector-reverse!__%
         _v139156_
         _start139157_
         _end139159_))))
  (define std/srfi/160/s16#s16vector-reverse!
    (lambda _g299133_
      (let ((_g299132_ (let () (declare (not safe)) (##length _g299133_))))
        (cond ((let () (declare (not safe)) (##fx= _g299132_ 1))
               (apply std/srfi/160/s16#s16vector-reverse!__0 _g299133_))
              ((let () (declare (not safe)) (##fx= _g299132_ 2))
               (apply std/srfi/160/s16#s16vector-reverse!__1 _g299133_))
              ((let () (declare (not safe)) (##fx= _g299132_ 3))
               (apply std/srfi/160/s16#s16vector-reverse!__% _g299133_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-reverse!
                _g299133_))))))
  (define std/srfi/160/s16#s16vector-unfold!
    (lambda (_f139101_ _v139103_ _start139105_ _end139107_ _seed139109_)
      (declare (not safe))
      (begin
        (if (procedure? _f139101_)
            '#!void
            (error '"Bad argument; expected procedure" _f139101_))
        (if (s16vector? _v139103_) '#!void (error '"Bad argument" _v139103_))
        (if (and (fixnum? _start139105_)
                 (fx<= '0 _start139105_ (fx- (s16vector-length _v139103_) '1)))
            '#!void
            (error '"Index out of range" _start139105_))
        (if (and (fixnum? _end139107_)
                 (fx<= _start139105_ _end139107_ (s16vector-length _v139103_)))
            '#!void
            (error '"Index out of range" _end139107_))
        (let _lp139113_ ((_i139116_ _start139105_)
                         (_state139118_ _seed139109_))
          (if (fx< _i139116_ _end139107_)
              (let ((_g299134_ (_f139101_ _state139118_)))
                (begin
                  (let ((_g299135_
                         (if (##values? _g299134_)
                             (##vector-length _g299134_)
                             1)))
                    (if (not (##fx= _g299135_ 2))
                        (error "Context expects 2 values" _g299135_)))
                  (let ((_x139121_ (##vector-ref _g299134_ 0))
                        (_state139123_ (##vector-ref _g299134_ 1)))
                    (begin
                      (s16vector-set! _v139103_ _i139116_ _x139121_)
                      (_lp139113_ (fx+ _i139116_ '1) _state139123_)))))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-unfold-right!
    (lambda (_f139077_ _v139079_ _start139081_ _end139083_ _seed139085_)
      (declare (not safe))
      (begin
        (if (procedure? _f139077_)
            '#!void
            (error '"Bad argument; expected procedure" _f139077_))
        (if (s16vector? _v139079_) '#!void (error '"Bad argument" _v139079_))
        (if (and (fixnum? _start139081_)
                 (fx<= '0 _start139081_ (fx- (s16vector-length _v139079_) '1)))
            '#!void
            (error '"Index out of range" _start139081_))
        (if (and (fixnum? _end139083_)
                 (fx<= _start139081_ _end139083_ (s16vector-length _v139079_)))
            '#!void
            (error '"Index out of range" _end139083_))
        (let _lp139089_ ((_i139092_ (fx- _end139083_ '1))
                         (_state139094_ _seed139085_))
          (if (fx>= _i139092_ _start139081_)
              (let ((_g299136_ (_f139077_ _state139094_)))
                (begin
                  (let ((_g299137_
                         (if (##values? _g299136_)
                             (##vector-length _g299136_)
                             1)))
                    (if (not (##fx= _g299137_ 2))
                        (error "Context expects 2 values" _g299137_)))
                  (let ((_x139097_ (##vector-ref _g299136_ 0))
                        (_state139099_ (##vector-ref _g299136_ 1)))
                    (begin
                      (s16vector-set! _v139079_ _i139092_ _x139097_)
                      (_lp139089_ (fx- _i139092_ '1) _state139099_)))))
              '#!void)))))
  (define std/srfi/160/s16#reverse-s16vector->list__%
    (lambda (_v139043_ _start139045_ _end139047_)
      (declare (not safe))
      (begin
        (if (s16vector? _v139043_) '#!void (error '"Bad argument" _v139043_))
        (if (and (fixnum? _start139045_)
                 (fx<= '0 _start139045_ (fx- (s16vector-length _v139043_) '1)))
            '#!void
            (error '"Index out of range" _start139045_))
        (if (and (fixnum? _end139047_)
                 (fx<= _start139045_ _end139047_ (s16vector-length _v139043_)))
            '#!void
            (error '"Index out of range" _end139047_))
        (let _lp139051_ ((_i139054_ _start139045_) (_r139056_ '()))
          (if (fx< _i139054_ _end139047_)
              (_lp139051_
               (fx+ _i139054_ '1)
               (cons (s16vector-ref _v139043_ _i139054_) _r139056_))
              _r139056_)))))
  (define std/srfi/160/s16#reverse-s16vector->list__0
    (lambda (_v139062_)
      (let* ((_start139064_ '0) (_end139066_ (s16vector-length _v139062_)))
        (std/srfi/160/s16#reverse-s16vector->list__%
         _v139062_
         _start139064_
         _end139066_))))
  (define std/srfi/160/s16#reverse-s16vector->list__1
    (lambda (_v139068_ _start139069_)
      (let ((_end139071_ (s16vector-length _v139068_)))
        (std/srfi/160/s16#reverse-s16vector->list__%
         _v139068_
         _start139069_
         _end139071_))))
  (define std/srfi/160/s16#reverse-s16vector->list
    (lambda _g299139_
      (let ((_g299138_ (let () (declare (not safe)) (##length _g299139_))))
        (cond ((let () (declare (not safe)) (##fx= _g299138_ 1))
               (apply std/srfi/160/s16#reverse-s16vector->list__0 _g299139_))
              ((let () (declare (not safe)) (##fx= _g299138_ 2))
               (apply std/srfi/160/s16#reverse-s16vector->list__1 _g299139_))
              ((let () (declare (not safe)) (##fx= _g299138_ 3))
               (apply std/srfi/160/s16#reverse-s16vector->list__% _g299139_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#reverse-s16vector->list
                _g299139_))))))
  (define std/srfi/160/s16#reverse-list->s16vector
    (lambda (_lst138989_)
      (let* ((_len138992_ (length _lst138989_))
             (_v138995_ (make-s16vector _len138992_)))
        (declare (not safe))
        (let _lp139000_ ((_rest139003_ _lst138989_) (_i139005_ '0))
          (let* ((_rest139007139015_ _rest139003_)
                 (_else139009139023_ (lambda () _v138995_))
                 (_K139011139030_
                  (lambda (_rest139026_ _x139027_)
                    (if (std/srfi/160/base#s16? _x139027_)
                        '#!void
                        (error '"Bad element" _x139027_))
                    (s16vector-set! _v138995_ _i139005_ _x139027_)
                    (_lp139000_ _rest139026_ (fx+ _i139005_ '1)))))
            (if (##pair? _rest139007139015_)
                (let ((_hd139012139033_ (##car _rest139007139015_))
                      (_tl139013139035_ (##cdr _rest139007139015_)))
                  (let* ((_x139038_ _hd139012139033_)
                         (_rest139040_ _tl139013139035_))
                    (_K139011139030_ _rest139040_ _x139038_)))
                (_else139009139023_)))))))
  (define std/srfi/160/s16#s16vector->vector__%
    (lambda (_v138950_ _start138952_ _end138954_)
      (declare (not safe))
      (begin
        (if (s16vector? _v138950_) '#!void (error '"Bad argument" _v138950_))
        (if (and (fixnum? _start138952_)
                 (fx<= '0 _start138952_ (fx- (s16vector-length _v138950_) '1)))
            '#!void
            (error '"Index out of range" _start138952_))
        (if (and (fixnum? _end138954_)
                 (fx<= _start138952_ _end138954_ (s16vector-length _v138950_)))
            '#!void
            (error '"Index out of range" _end138954_))
        (let* ((_len138958_ (s16vector-length _v138950_))
               (_u138961_ (make-vector _len138958_)))
          (let _lp138965_ ((_i138968_ '0))
            (if (fx< _i138968_ _len138958_)
                (begin
                  (vector-set!
                   _u138961_
                   _i138968_
                   (s16vector-ref _v138950_ _i138968_))
                  (_lp138965_ (fx+ _i138968_ '1)))
                _u138961_))))))
  (define std/srfi/160/s16#s16vector->vector__0
    (lambda (_v138974_)
      (let* ((_start138976_ '0) (_end138978_ (s16vector-length _v138974_)))
        (std/srfi/160/s16#s16vector->vector__%
         _v138974_
         _start138976_
         _end138978_))))
  (define std/srfi/160/s16#s16vector->vector__1
    (lambda (_v138980_ _start138981_)
      (let ((_end138983_ (s16vector-length _v138980_)))
        (std/srfi/160/s16#s16vector->vector__%
         _v138980_
         _start138981_
         _end138983_))))
  (define std/srfi/160/s16#s16vector->vector
    (lambda _g299141_
      (let ((_g299140_ (let () (declare (not safe)) (##length _g299141_))))
        (cond ((let () (declare (not safe)) (##fx= _g299140_ 1))
               (apply std/srfi/160/s16#s16vector->vector__0 _g299141_))
              ((let () (declare (not safe)) (##fx= _g299140_ 2))
               (apply std/srfi/160/s16#s16vector->vector__1 _g299141_))
              ((let () (declare (not safe)) (##fx= _g299140_ 3))
               (apply std/srfi/160/s16#s16vector->vector__% _g299141_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector->vector
                _g299141_))))))
  (define std/srfi/160/s16#vector->s16vector__%
    (lambda (_v138910_ _start138912_ _end138914_)
      (declare (not safe))
      (begin
        (if (vector? _v138910_)
            '#!void
            (error '"Bad argument; expected vector" _v138910_))
        (if (and (fixnum? _start138912_)
                 (fx<= '0 _start138912_ (fx- (vector-length _v138910_) '1)))
            '#!void
            (error '"Index out of range" _start138912_))
        (if (and (fixnum? _end138914_)
                 (fx<= _start138912_ _end138914_ (vector-length _v138910_)))
            '#!void
            (error '"Index out of range" _end138914_))
        (let* ((_len138918_ (vector-length _v138910_))
               (_u138921_ (make-s16vector _len138918_)))
          (let _lp138925_ ((_i138928_ '0))
            (if (fx< _i138928_ _len138918_)
                (begin
                  (s16vector-set!
                   _u138921_
                   _i138928_
                   (vector-ref _v138910_ _i138928_))
                  (_lp138925_ (fx+ _i138928_ '1)))
                _u138921_))))))
  (define std/srfi/160/s16#vector->s16vector__0
    (lambda (_v138934_)
      (let* ((_start138936_ '0) (_end138938_ (vector-length _v138934_)))
        (std/srfi/160/s16#vector->s16vector__%
         _v138934_
         _start138936_
         _end138938_))))
  (define std/srfi/160/s16#vector->s16vector__1
    (lambda (_v138940_ _start138941_)
      (let ((_end138943_ (vector-length _v138940_)))
        (std/srfi/160/s16#vector->s16vector__%
         _v138940_
         _start138941_
         _end138943_))))
  (define std/srfi/160/s16#vector->s16vector
    (lambda _g299143_
      (let ((_g299142_ (let () (declare (not safe)) (##length _g299143_))))
        (cond ((let () (declare (not safe)) (##fx= _g299142_ 1))
               (apply std/srfi/160/s16#vector->s16vector__0 _g299143_))
              ((let () (declare (not safe)) (##fx= _g299142_ 2))
               (apply std/srfi/160/s16#vector->s16vector__1 _g299143_))
              ((let () (declare (not safe)) (##fx= _g299142_ 3))
               (apply std/srfi/160/s16#vector->s16vector__% _g299143_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#vector->s16vector
                _g299143_))))))
  (define std/srfi/160/s16#make-s16vector-generator__%
    (lambda (_v138876_ _start138878_ _end138880_)
      (declare (not safe))
      (begin
        (if (s16vector? _v138876_) '#!void (error '"Bad argument" _v138876_))
        (if (and (fixnum? _start138878_)
                 (fx<= '0 _start138878_ (fx- (s16vector-length _v138876_) '1)))
            '#!void
            (error '"Index out of range" _start138878_))
        (if (and (fixnum? _end138880_)
                 (fx<= _start138878_ _end138880_ (s16vector-length _v138876_)))
            '#!void
            (error '"Index out of range" _end138880_))
        (let ((_i138884_ _start138878_))
          (lambda ()
            (if (fx< _i138884_ _end138880_)
                (let ((_next138888_ (s16vector-ref _v138876_ _i138884_)))
                  (set! _i138884_ (fx+ _i138884_ '1))
                  _next138888_)
                '#!eof))))))
  (define std/srfi/160/s16#make-s16vector-generator__0
    (lambda (_v138894_)
      (let* ((_start138896_ '0) (_end138898_ (s16vector-length _v138894_)))
        (std/srfi/160/s16#make-s16vector-generator__%
         _v138894_
         _start138896_
         _end138898_))))
  (define std/srfi/160/s16#make-s16vector-generator__1
    (lambda (_v138900_ _start138901_)
      (let ((_end138903_ (s16vector-length _v138900_)))
        (std/srfi/160/s16#make-s16vector-generator__%
         _v138900_
         _start138901_
         _end138903_))))
  (define std/srfi/160/s16#make-s16vector-generator
    (lambda _g299145_
      (let ((_g299144_ (let () (declare (not safe)) (##length _g299145_))))
        (cond ((let () (declare (not safe)) (##fx= _g299144_ 1))
               (apply std/srfi/160/s16#make-s16vector-generator__0 _g299145_))
              ((let () (declare (not safe)) (##fx= _g299144_ 2))
               (apply std/srfi/160/s16#make-s16vector-generator__1 _g299145_))
              ((let () (declare (not safe)) (##fx= _g299144_ 3))
               (apply std/srfi/160/s16#make-s16vector-generator__% _g299145_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#make-s16vector-generator
                _g299145_))))))
  (define std/srfi/160/s16#s16vector-comparator
    (let ()
      (letrec ((_<?138847_
                (lambda (_a138850_ _b138852_)
                  (let ((_len-a138855_ (s16vector-length _a138850_))
                        (_len-b138857_ (s16vector-length _b138852_)))
                    (declare (not safe))
                    (if (fx< _len-a138855_ _len-b138857_)
                        '#t
                        (if (fx> _len-a138855_ _len-b138857_)
                            '#f
                            (let ((_end138861_ _len-a138855_))
                              (let _lp138864_ ((_i138867_ '0))
                                (if (fx< _i138867_ _end138861_)
                                    (let ((_x138870_
                                           (s16vector-ref _a138850_ _i138867_))
                                          (_y138872_
                                           (s16vector-ref
                                            _b138852_
                                            _i138867_)))
                                      (if (< _x138870_ _y138872_)
                                          '#t
                                          (if (> _x138870_ _y138872_)
                                              '#f
                                              (_lp138864_
                                               (fx+ _i138867_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           s16vector?
           std/srfi/160/s16#s16vector=
           _<?138847_
           equal?-hash)))))
  (define std/srfi/160/s16#write-s16vector__%
    (lambda (_v138824_ _port138826_)
      (let ((_$e138829_ (find-method _v138824_ ':write)))
        (if _$e138829_
            ((lambda (_g138831138833_)
               (_g138831138833_ _v138824_ _port138826_))
             _$e138829_)
            (write _v138824_ (current-output-port))))))
  (define std/srfi/160/s16#write-s16vector__0
    (lambda (_v138839_)
      (let ((_port138841_ (current-output-port)))
        (std/srfi/160/s16#write-s16vector__% _v138839_ _port138841_))))
  (define std/srfi/160/s16#write-s16vector
    (lambda _g299147_
      (let ((_g299146_ (let () (declare (not safe)) (##length _g299147_))))
        (cond ((let () (declare (not safe)) (##fx= _g299146_ 1))
               (apply std/srfi/160/s16#write-s16vector__0 _g299147_))
              ((let () (declare (not safe)) (##fx= _g299146_ 2))
               (apply std/srfi/160/s16#write-s16vector__% _g299147_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#write-s16vector
                _g299147_)))))))
