(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/u32#u32vector-unfold
    (lambda (_f141654_ _len141656_ _seed141658_)
      (declare (not safe))
      (begin
        (if (procedure? _f141654_)
            '#!void
            (error '"Bad argument; expected procedure" _f141654_))
        (let ((_v141662_ (make-u32vector _len141656_)))
          (let _lp141665_ ((_i141668_ '0) (_state141670_ _seed141658_))
            (if (fx< _i141668_ _len141656_)
                (let ((_g299148_ (_f141654_ _i141668_ _state141670_)))
                  (begin
                    (let ((_g299149_
                           (if (##values? _g299148_)
                               (##vector-length _g299148_)
                               1)))
                      (if (not (##fx= _g299149_ 2))
                          (error "Context expects 2 values" _g299149_)))
                    (let ((_x141673_ (##vector-ref _g299148_ 0))
                          (_state141675_ (##vector-ref _g299148_ 1)))
                      (begin
                        (if (std/srfi/160/base#u32? _x141673_)
                            '#!void
                            (error '"Bad generated value" _x141673_))
                        (u32vector-set! _v141662_ _i141668_ _x141673_)
                        (_lp141665_ (fx+ _i141668_ '1) _state141675_)))))
                _v141662_))))))
  (define std/srfi/160/u32#u32vector-unfold-right
    (lambda (_f141631_ _len141633_ _seed141635_)
      (declare (not safe))
      (begin
        (if (procedure? _f141631_)
            '#!void
            (error '"Bad argument; expected procedure" _f141631_))
        (let ((_v141639_ (make-u32vector _len141633_)))
          (let _lp141642_ ((_i141645_ (fx- _len141633_ '1))
                           (_state141647_ _seed141635_))
            (if (fx>= _i141645_ '0)
                (let ((_g299150_ (_f141631_ _i141645_ _state141647_)))
                  (begin
                    (let ((_g299151_
                           (if (##values? _g299150_)
                               (##vector-length _g299150_)
                               1)))
                      (if (not (##fx= _g299151_ 2))
                          (error "Context expects 2 values" _g299151_)))
                    (let ((_x141650_ (##vector-ref _g299150_ 0))
                          (_state141652_ (##vector-ref _g299150_ 1)))
                      (begin
                        (if (std/srfi/160/base#u32? _x141650_)
                            '#!void
                            (error '"Bad generated value" _x141650_))
                        (u32vector-set! _v141639_ _i141645_ _x141650_)
                        (_lp141642_ (fx- _i141645_ '1) _state141652_)))))
                _v141639_))))))
  (define std/srfi/160/u32#u32vector-copy__%
    (lambda (_vec141603_ _start141605_ _end141607_)
      (let ((_v141610_ (make-u32vector (fx- _end141607_ _start141605_))))
        (std/srfi/160/u32#u32vector-copy!
         _v141610_
         '0
         _vec141603_
         _start141605_
         _end141607_)
        _v141610_)))
  (define std/srfi/160/u32#u32vector-copy__0
    (lambda (_vec141616_)
      (let* ((_start141618_ '0) (_end141620_ (u32vector-length _vec141616_)))
        (std/srfi/160/u32#u32vector-copy__%
         _vec141616_
         _start141618_
         _end141620_))))
  (define std/srfi/160/u32#u32vector-copy__1
    (lambda (_vec141622_ _start141623_)
      (let ((_end141625_ (u32vector-length _vec141622_)))
        (std/srfi/160/u32#u32vector-copy__%
         _vec141622_
         _start141623_
         _end141625_))))
  (define std/srfi/160/u32#u32vector-copy
    (lambda _g299153_
      (let ((_g299152_ (let () (declare (not safe)) (##length _g299153_))))
        (cond ((let () (declare (not safe)) (##fx= _g299152_ 1))
               (apply std/srfi/160/u32#u32vector-copy__0 _g299153_))
              ((let () (declare (not safe)) (##fx= _g299152_ 2))
               (apply std/srfi/160/u32#u32vector-copy__1 _g299153_))
              ((let () (declare (not safe)) (##fx= _g299152_ 3))
               (apply std/srfi/160/u32#u32vector-copy__% _g299153_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-copy
                _g299153_))))))
  (define std/srfi/160/u32#u32vector-copy!
    (lambda (_to141582_ _at141584_ _from141586_ _start141588_ _end141590_)
      (declare (not safe))
      (begin
        (if (u32vector? _to141582_) '#!void (error '"Bad argument" _to141582_))
        (if (u32vector? _from141586_)
            '#!void
            (error '"Bad argument" _from141586_))
        (if (and (fixnum? _at141584_)
                 (fx<= '0 _at141584_ (fx- (u32vector-length _at141584_) '1)))
            '#!void
            (error '"Index out of range" _to141582_ _at141584_))
        (if (and (fixnum? _start141588_)
                 (fx<= '0
                       _start141588_
                       (fx- (u32vector-length _from141586_) '1)))
            '#!void
            (error '"Index out of range" _from141586_ _start141588_))
        (if (and (fixnum? _end141590_)
                 (fx<= _start141588_
                       _end141590_
                       (u32vector-length _from141586_)))
            '#!void
            (error '"Index out of range" _from141586_ _end141590_))
        (if (fx<= (fx- _end141590_ _start141588_)
                  (fx- (u32vector-length _to141582_) _at141584_))
            '#!void
            (error '"Destination area too small"
                   _to141582_
                   _at141584_
                   _from141586_
                   _start141588_
                   _end141590_))
        (let _lp141594_ ((_i141597_ _start141588_) (_j141599_ _at141584_))
          (if (fx< _i141597_ _end141590_)
              (begin
                (u32vector-set!
                 _to141582_
                 _j141599_
                 (u32vector-ref _from141586_ _i141597_))
                (_lp141594_ (fx+ _i141597_ '1) (fx+ _j141599_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-reverse-copy__%
    (lambda (_vec141554_ _start141556_ _end141558_)
      (let ((_v141561_ (make-u32vector (fx- _end141558_ _start141556_))))
        (std/srfi/160/u32#u32vector-reverse-copy!
         _v141561_
         '0
         _vec141554_
         _start141556_
         _end141558_)
        _v141561_)))
  (define std/srfi/160/u32#u32vector-reverse-copy__0
    (lambda (_vec141567_)
      (let* ((_start141569_ '0) (_end141571_ (u32vector-length _vec141567_)))
        (std/srfi/160/u32#u32vector-reverse-copy__%
         _vec141567_
         _start141569_
         _end141571_))))
  (define std/srfi/160/u32#u32vector-reverse-copy__1
    (lambda (_vec141573_ _start141574_)
      (let ((_end141576_ (u32vector-length _vec141573_)))
        (std/srfi/160/u32#u32vector-reverse-copy__%
         _vec141573_
         _start141574_
         _end141576_))))
  (define std/srfi/160/u32#u32vector-reverse-copy
    (lambda _g299155_
      (let ((_g299154_ (let () (declare (not safe)) (##length _g299155_))))
        (cond ((let () (declare (not safe)) (##fx= _g299154_ 1))
               (apply std/srfi/160/u32#u32vector-reverse-copy__0 _g299155_))
              ((let () (declare (not safe)) (##fx= _g299154_ 2))
               (apply std/srfi/160/u32#u32vector-reverse-copy__1 _g299155_))
              ((let () (declare (not safe)) (##fx= _g299154_ 3))
               (apply std/srfi/160/u32#u32vector-reverse-copy__% _g299155_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-reverse-copy
                _g299155_))))))
  (define std/srfi/160/u32#u32vector-reverse-copy!
    (lambda (_to141533_ _at141535_ _from141537_ _start141539_ _end141541_)
      (declare (not safe))
      (begin
        (if (u32vector? _to141533_) '#!void (error '"Bad argument" _to141533_))
        (if (u32vector? _from141537_)
            '#!void
            (error '"Bad argument" _from141537_))
        (if (and (fixnum? _at141535_)
                 (fx<= '0 _at141535_ (fx- (u32vector-length _at141535_) '1)))
            '#!void
            (error '"Index out of range" _to141533_ _at141535_))
        (if (and (fixnum? _start141539_)
                 (fx<= '0
                       _start141539_
                       (fx- (u32vector-length _from141537_) '1)))
            '#!void
            (error '"Index out of range" _from141537_ _start141539_))
        (if (and (fixnum? _end141541_)
                 (fx<= _start141539_
                       _end141541_
                       (u32vector-length _from141537_)))
            '#!void
            (error '"Index out of range" _from141537_ _end141541_))
        (if (fx<= (fx- _end141541_ _start141539_)
                  (fx- (u32vector-length _to141533_) _at141535_))
            '#!void
            (error '"Destination area too small"
                   _to141533_
                   _at141535_
                   _from141537_
                   _start141539_
                   _end141541_))
        (let _lp141545_ ((_i141548_ (fx- _end141541_ '1))
                         (_j141550_ _at141535_))
          (if (fx>= _i141548_ _start141539_)
              (begin
                (u32vector-set!
                 _to141533_
                 _j141550_
                 (u32vector-ref _from141537_ _i141548_))
                (_lp141545_ (fx- _i141548_ '1) (fx+ _j141550_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-append
    (lambda _args141530_
      (std/srfi/160/u32#u32vector-concatenate _args141530_)))
  (define std/srfi/160/u32#u32vector-concatenate
    (lambda (_lst141470_)
      (let* ((_len141478_
              (foldl1 (lambda (_v141473_ _r141475_)
                        (fx+ (u32vector-length _v141473_) _r141475_))
                      '0
                      _lst141470_))
             (_v141481_ (make-u32vector _len141478_)))
        (declare (not safe))
        (let _lp141485_ ((_rest141488_ _lst141470_) (_at141490_ '0))
          (let* ((_rest141492141500_ _rest141488_)
                 (_else141494141508_ (lambda () _v141481_))
                 (_K141496141518_
                  (lambda (_rest141511_ _u141512_)
                    (let ((_ulen141515_ (u32vector-length _u141512_)))
                      (std/srfi/160/u32#u32vector-copy!
                       _v141481_
                       _at141490_
                       _u141512_
                       '0
                       _ulen141515_)
                      (_lp141485_
                       _rest141511_
                       (fx+ _at141490_ _ulen141515_))))))
            (if (##pair? _rest141492141500_)
                (let ((_hd141497141521_ (##car _rest141492141500_))
                      (_tl141498141523_ (##cdr _rest141492141500_)))
                  (let* ((_u141526_ _hd141497141521_)
                         (_rest141528_ _tl141498141523_))
                    (_K141496141518_ _rest141528_ _u141526_)))
                (_else141494141508_)))))))
  (define std/srfi/160/u32#u32vector-append-subvectors
    (lambda _args141342_
      (let* ((_len141403_
              (let _lp141345_ ((_rest141348_ _args141342_) (_r141350_ '0))
                (let* ((_rest141352141364_ _rest141348_)
                       (_else141354141372_ (lambda () _r141350_))
                       (_K141356141381_
                        (lambda (_rest141375_ _end141376_ _start141378_)
                          (_lp141345_
                           _rest141375_
                           (fx+ _r141350_ (fx- _end141376_ _start141378_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest141352141364_))
                      (let ((_tl141358141384_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest141352141364_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl141358141384_))
                            (let ((_hd141359141387_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl141358141384_)))
                                  (_tl141360141389_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl141358141384_))))
                              (let ((_start141392_ _hd141359141387_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl141360141389_))
                                    (let ((_hd141361141394_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl141360141389_)))
                                          (_tl141362141396_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl141360141389_))))
                                      (let* ((_end141399_ _hd141361141394_)
                                             (_rest141401_ _tl141362141396_))
                                        (_K141356141381_
                                         _rest141401_
                                         _end141399_
                                         _start141392_)))
                                    (_else141354141372_))))
                            (_else141354141372_)))
                      (_else141354141372_)))))
             (_v141406_ (make-u32vector _len141403_)))
        (let _lp141410_ ((_rest141412_ _args141342_) (_at141413_ '0))
          (let* ((_rest141415141427_ _rest141412_)
                 (_else141417141435_ (lambda () _v141406_))
                 (_K141419141444_
                  (lambda (_rest141438_ _end141439_ _start141440_ _u141441_)
                    (std/srfi/160/u32#u32vector-copy!
                     _v141406_
                     _at141413_
                     _u141441_
                     _start141440_
                     _end141439_)
                    (_lp141410_
                     _rest141438_
                     (fx+ _at141413_ (fx- _end141439_ _start141440_))))))
            (if (let () (declare (not safe)) (##pair? _rest141415141427_))
                (let ((_hd141420141447_
                       (let ()
                         (declare (not safe))
                         (##car _rest141415141427_)))
                      (_tl141421141449_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest141415141427_))))
                  (let ((_u141452_ _hd141420141447_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl141421141449_))
                        (let ((_hd141422141454_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl141421141449_)))
                              (_tl141423141456_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl141421141449_))))
                          (let ((_start141459_ _hd141422141454_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl141423141456_))
                                (let ((_hd141424141461_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl141423141456_)))
                                      (_tl141425141463_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl141423141456_))))
                                  (let* ((_end141466_ _hd141424141461_)
                                         (_rest141468_ _tl141425141463_))
                                    (_K141419141444_
                                     _rest141468_
                                     _end141466_
                                     _start141459_
                                     _u141452_)))
                                (_else141417141435_))))
                        (_else141417141435_))))
                (_else141417141435_)))))))
  (define std/srfi/160/u32#u32vector-empty?
    (lambda (_v141339_) (fxzero? (u32vector-length _v141339_))))
  (define std/srfi/160/u32#u32vector=
    (lambda (_v141281_ . _args141283_)
      (declare (not safe))
      (begin
        (if (u32vector? _v141281_) '#!void (error '"Bad argument" _v141281_))
        (let ((_vlen141287_ (u32vector-length _v141281_)))
          (let _lp141290_ ((_rest141293_ _args141283_))
            (let* ((_rest141295141303_ _rest141293_)
                   (_else141297141311_ (lambda () '#t))
                   (_K141299141327_
                    (lambda (_rest141314_ _u141315_)
                      (if (u32vector? _u141315_)
                          '#!void
                          (error '"Bad argument" _u141315_))
                      (let ((_ulen141318_ (u32vector-length _u141315_)))
                        (if (fx= _vlen141287_ _ulen141318_)
                            (let _cmp141321_ ((_i141324_ '0))
                              (if (fx< _i141324_ _vlen141287_)
                                  (if (= (u32vector-ref _v141281_ _i141324_)
                                         (u32vector-ref _u141315_ _i141324_))
                                      (_cmp141321_ (fx+ _i141324_ '1))
                                      '#f)
                                  (_lp141290_ _rest141314_)))
                            '#f)))))
              (if (##pair? _rest141295141303_)
                  (let ((_hd141300141330_ (##car _rest141295141303_))
                        (_tl141301141332_ (##cdr _rest141295141303_)))
                    (let* ((_u141335_ _hd141300141330_)
                           (_rest141337_ _tl141301141332_))
                      (_K141299141327_ _rest141337_ _u141335_)))
                  (_else141297141311_))))))))
  (define std/srfi/160/u32#u32vector-take
    (lambda (_v141273_ _n141275_)
      (let ((_u141278_ (make-u32vector _n141275_)))
        (std/srfi/160/u32#u32vector-copy! _u141278_ '0 _v141273_ '0 _n141275_)
        _u141278_)))
  (define std/srfi/160/u32#u32vector-take-right
    (lambda (_v141258_ _n141260_)
      (let* ((_vlen141263_ (u32vector-length _v141258_))
             (_ulen141266_ (fx- _vlen141263_ _n141260_))
             (_u141269_ (make-u32vector _ulen141266_)))
        (std/srfi/160/u32#u32vector-copy!
         _u141269_
         '0
         _v141258_
         _n141260_
         _vlen141263_)
        _u141269_)))
  (define std/srfi/160/u32#u32vector-drop
    (lambda (_v141243_ _n141245_)
      (let* ((_vlen141248_ (u32vector-length _v141243_))
             (_ulen141251_ (fx- _vlen141248_ _n141245_))
             (_u141254_ (make-u32vector _ulen141251_)))
        (std/srfi/160/u32#u32vector-copy!
         _u141254_
         '0
         _v141243_
         _n141245_
         _vlen141248_)
        _u141254_)))
  (define std/srfi/160/u32#u32vector-drop-right
    (lambda (_v141228_ _n141230_)
      (let* ((_vlen141233_ (u32vector-length _v141228_))
             (_ulen141236_ (fx- _vlen141233_ _n141230_))
             (_u141239_ (make-u32vector _ulen141236_)))
        (std/srfi/160/u32#u32vector-copy!
         _u141239_
         '0
         _v141228_
         '0
         _ulen141236_)
        _u141239_)))
  (define std/srfi/160/u32#u32vector-segment
    (lambda (_v141210_ _n141212_)
      (let _lp141215_ ((_i141218_ '0)
                       (_rest141220_ (u32vector-length _v141210_))
                       (_r141222_ '()))
        (if (fx> _r141222_ '0)
            (let ((_size141225_ (fxmin _n141212_ _rest141220_)))
              (_lp141215_
               (fx+ _i141218_ _size141225_)
               (fx- _rest141220_ _size141225_)
               (cons (std/srfi/160/u32#u32vector-copy__%
                      _v141210_
                      _i141218_
                      (fx+ _i141218_ _size141225_))
                     _r141222_)))
            (reverse _r141222_)))))
  (define std/srfi/160/u32#u32vector-fold__0
    (lambda (_kons141170_ _knil141172_ _v141174_)
      (if (procedure? _kons141170_)
          '#!void
          (error '"Bad argument; expected procedure" _kons141170_))
      (let ((_end141177_ (u32vector-length _v141174_)))
        (declare (not safe))
        (let _lp141181_ ((_i141184_ '0) (_r141186_ _knil141172_))
          (if (fx< _i141184_ _end141177_)
              (_lp141181_
               (fx+ _i141184_ '1)
               (_kons141170_ _r141186_ (u32vector-ref _v141174_ _i141184_)))
              _r141186_)))))
  (define std/srfi/160/u32#u32vector-fold__1
    (lambda (_kons141189_ _knil141190_ _v141191_ . _vs141192_)
      (if (procedure? _kons141189_)
          '#!void
          (error '"Bad argument; expected procedure" _kons141189_))
      (let* ((_vs141195_ (cons _v141191_ _vs141192_))
             (_end141197_ (apply fxmin (map u32vector-length _vs141195_))))
        (declare (not safe))
        (let _lp141201_ ((_i141203_ '0) (_r141204_ _knil141190_))
          (if (fx< _i141203_ _end141197_)
              (_lp141201_
               (fx+ _i141203_ '1)
               (apply _kons141189_
                      _r141204_
                      (map (lambda (_g141205141207_)
                             (u32vector-ref _g141205141207_ _i141203_))
                           _vs141195_)))
              _r141204_)))))
  (define std/srfi/160/u32#u32vector-fold
    (lambda _g299157_
      (let ((_g299156_ (let () (declare (not safe)) (##length _g299157_))))
        (cond ((let () (declare (not safe)) (##fx= _g299156_ 3))
               (apply std/srfi/160/u32#u32vector-fold__0 _g299157_))
              ((let () (declare (not safe)) (##fx>= _g299156_ 3))
               (apply std/srfi/160/u32#u32vector-fold__1 _g299157_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-fold
                _g299157_))))))
  (define std/srfi/160/u32#u32vector-fold-right__0
    (lambda (_kons141130_ _knil141132_ _v141134_)
      (if (procedure? _kons141130_)
          '#!void
          (error '"Bad argument; expected procedure" _kons141130_))
      (let ((_last141137_ (fx- (u32vector-length _v141134_) '1)))
        (declare (not safe))
        (let _lp141141_ ((_i141144_ _last141137_) (_r141146_ _knil141132_))
          (if (fx>= _i141144_ '0)
              (_lp141141_
               (fx- _i141144_ '1)
               (_kons141130_ _r141146_ (u32vector-ref _v141134_ _i141144_)))
              _r141146_)))))
  (define std/srfi/160/u32#u32vector-fold-right__1
    (lambda (_kons141149_ _knil141150_ _v141151_ . _vs141152_)
      (if (procedure? _kons141149_)
          '#!void
          (error '"Bad argument; expected procedure" _kons141149_))
      (let* ((_vs141155_ (cons _v141151_ _vs141152_))
             (_last141157_
              (fx- (apply min (map u32vector-length _vs141155_)) '1)))
        (declare (not safe))
        (let _lp141161_ ((_i141163_ _last141157_) (_r141164_ _knil141150_))
          (if (fx>= _i141163_ '0)
              (_lp141161_
               (fx- _i141163_ '1)
               (apply _kons141149_
                      _r141164_
                      (map (lambda (_g141165141167_)
                             (u32vector-ref _g141165141167_ _i141163_))
                           _vs141155_)))
              _r141164_)))))
  (define std/srfi/160/u32#u32vector-fold-right
    (lambda _g299159_
      (let ((_g299158_ (let () (declare (not safe)) (##length _g299159_))))
        (cond ((let () (declare (not safe)) (##fx= _g299158_ 3))
               (apply std/srfi/160/u32#u32vector-fold-right__0 _g299159_))
              ((let () (declare (not safe)) (##fx>= _g299158_ 3))
               (apply std/srfi/160/u32#u32vector-fold-right__1 _g299159_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-fold-right
                _g299159_))))))
  (define std/srfi/160/u32#u32vector-map__0
    (lambda (_f141090_ _v141092_)
      (if (procedure? _f141090_)
          '#!void
          (error '"Bad argument; expected procedure" _f141090_))
      (let* ((_len141095_ (u32vector-length _v141092_))
             (_u141098_ (make-u32vector _len141095_)))
        (declare (not safe))
        (let _lp141103_ ((_i141106_ '0))
          (if (fx< _i141106_ _len141095_)
              (begin
                (u32vector-set!
                 _u141098_
                 _i141106_
                 (u32vector-ref _v141092_ _i141106_))
                (_lp141103_ (fx+ _i141106_ '1)))
              _u141098_)))))
  (define std/srfi/160/u32#u32vector-map__1
    (lambda (_f141109_ _v141110_ . _vs141111_)
      (if (procedure? _f141109_)
          '#!void
          (error '"Bad argument; expected procedure" _f141109_))
      (let* ((_vs141114_ (cons _v141110_ _vs141111_))
             (_len141116_ (apply fxmin (map u32vector-length _vs141114_)))
             (_u141118_ (make-u32vector _len141116_)))
        (declare (not safe))
        (let _lp141122_ ((_i141124_ '0))
          (if (fx< _i141124_ _len141116_)
              (begin
                (u32vector-set!
                 _u141118_
                 _i141124_
                 (apply _f141109_
                        (map (lambda (_g141125141127_)
                               (u32vector-ref _g141125141127_ _i141124_))
                             _vs141114_)))
                (_lp141122_ (fx+ _i141124_ '1)))
              _u141118_)))))
  (define std/srfi/160/u32#u32vector-map
    (lambda _g299161_
      (let ((_g299160_ (let () (declare (not safe)) (##length _g299161_))))
        (cond ((let () (declare (not safe)) (##fx= _g299160_ 2))
               (apply std/srfi/160/u32#u32vector-map__0 _g299161_))
              ((let () (declare (not safe)) (##fx>= _g299160_ 2))
               (apply std/srfi/160/u32#u32vector-map__1 _g299161_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-map
                _g299161_))))))
  (define std/srfi/160/u32#u32vector-map!__0
    (lambda (_f141056_ _v141058_)
      (if (procedure? _f141056_)
          '#!void
          (error '"Bad argument; expected procedure" _f141056_))
      (let ((_len141061_ (u32vector-length _v141058_)))
        (declare (not safe))
        (let _lp141065_ ((_i141068_ '0))
          (if (fx< _i141068_ _len141061_)
              (begin
                (u32vector-set!
                 _v141058_
                 _i141068_
                 (_f141056_ (u32vector-ref _v141058_ _i141068_)))
                (_lp141065_ (fx+ _i141068_ '1)))
              _v141058_)))))
  (define std/srfi/160/u32#u32vector-map!__1
    (lambda (_f141071_ _v141072_ . _vs141073_)
      (if (procedure? _f141071_)
          '#!void
          (error '"Bad argument; expected procedure" _f141071_))
      (let* ((_vs141076_ (cons _v141072_ _vs141073_))
             (_len141078_ (apply fxmin (map u32vector-length _vs141076_))))
        (declare (not safe))
        (let _lp141082_ ((_i141084_ '0))
          (if (fx< _i141084_ _len141078_)
              (begin
                (u32vector-set!
                 _v141072_
                 _i141084_
                 (apply _f141071_
                        (map (lambda (_g141085141087_)
                               (u32vector-ref _g141085141087_ _i141084_))
                             _vs141076_)))
                (_lp141082_ (fx+ _i141084_ '1)))
              _v141072_)))))
  (define std/srfi/160/u32#u32vector-map!
    (lambda _g299163_
      (let ((_g299162_ (let () (declare (not safe)) (##length _g299163_))))
        (cond ((let () (declare (not safe)) (##fx= _g299162_ 2))
               (apply std/srfi/160/u32#u32vector-map!__0 _g299163_))
              ((let () (declare (not safe)) (##fx>= _g299162_ 2))
               (apply std/srfi/160/u32#u32vector-map!__1 _g299163_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-map!
                _g299163_))))))
  (define std/srfi/160/u32#u32vector-for-each__0
    (lambda (_f141022_ _v141024_)
      (if (procedure? _f141022_)
          '#!void
          (error '"Bad argument; expected procedure" _f141022_))
      (let ((_len141027_ (u32vector-length _v141024_)))
        (declare (not safe))
        (let _lp141031_ ((_i141034_ '0))
          (if (fx< _i141034_ _len141027_)
              (begin
                (_f141022_ (u32vector-ref _v141024_ _i141034_))
                (_lp141031_ (fx+ _i141034_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-for-each__1
    (lambda (_f141037_ _v141038_ . _vs141039_)
      (let* ((_vs141042_ (cons _v141038_ _vs141039_))
             (_len141044_ (apply fxmin (map u32vector-length _vs141042_))))
        (declare (not safe))
        (let _lp141048_ ((_i141050_ '0))
          (if (fx< _i141050_ _len141044_)
              (begin
                (apply _f141037_
                       (map (lambda (_g141051141053_)
                              (u32vector-ref _g141051141053_ _i141050_))
                            _vs141042_))
                (_lp141048_ (fx+ _i141050_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-for-each
    (lambda _g299165_
      (let ((_g299164_ (let () (declare (not safe)) (##length _g299165_))))
        (cond ((let () (declare (not safe)) (##fx= _g299164_ 2))
               (apply std/srfi/160/u32#u32vector-for-each__0 _g299165_))
              ((let () (declare (not safe)) (##fx>= _g299164_ 2))
               (apply std/srfi/160/u32#u32vector-for-each__1 _g299165_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-for-each
                _g299165_))))))
  (define std/srfi/160/u32#u32vector-count__0
    (lambda (_pred140985_ _v140987_)
      (if (procedure? _pred140985_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140985_))
      (let ((_end140990_ (u32vector-length _v140987_)))
        (declare (not safe))
        (let _lp140994_ ((_i140997_ '0) (_r140999_ '0))
          (if (fx< _i140997_ _end140990_)
              (if (_pred140985_ (u32vector-ref _v140987_ _i140997_))
                  (_lp140994_ (fx+ _i140997_ '1) (fx+ _r140999_ '1))
                  (_lp140994_ (fx+ _i140997_ '1) _r140999_))
              _r140999_)))))
  (define std/srfi/160/u32#u32vector-count__1
    (lambda (_pred141002_ _v141003_ . _vs141004_)
      (if (procedure? _pred141002_)
          '#!void
          (error '"Bad argument; expected procedure" _pred141002_))
      (let* ((_vs141007_ (cons _v141003_ _vs141004_))
             (_end141009_ (apply fxmin (map u32vector-length _vs141007_))))
        (declare (not safe))
        (let _lp141013_ ((_i141015_ '0) (_r141016_ '0))
          (if (fx< _i141015_ _end141009_)
              (if (apply _pred141002_
                         (map (lambda (_g141017141019_)
                                (u32vector-ref _g141017141019_ _i141015_))
                              _vs141007_))
                  (_lp141013_ (fx+ _i141015_ '1) (fx+ _r141016_ '1))
                  (_lp141013_ (fx+ _i141015_ '1) _r141016_))
              _r141016_)))))
  (define std/srfi/160/u32#u32vector-count
    (lambda _g299167_
      (let ((_g299166_ (let () (declare (not safe)) (##length _g299167_))))
        (cond ((let () (declare (not safe)) (##fx= _g299166_ 2))
               (apply std/srfi/160/u32#u32vector-count__0 _g299167_))
              ((let () (declare (not safe)) (##fx>= _g299166_ 2))
               (apply std/srfi/160/u32#u32vector-count__1 _g299167_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-count
                _g299167_))))))
  (define std/srfi/160/u32#u32vector-cumulate
    (lambda (_f140960_ _knil140962_ _v140964_)
      (if (procedure? _f140960_)
          '#!void
          (error '"Bad argument; expected procedure" _f140960_))
      (let* ((_len140967_ (u32vector-length _v140964_))
             (_r140970_ (make-u32vector _len140967_)))
        (declare (not safe))
        (let _lp140975_ ((_i140978_ '0) (_r140980_ _knil140962_))
          (if (fx< _i140978_ _len140967_)
              (let ((_next140982_
                     (_f140960_
                      _r140980_
                      (u32vector-ref _v140964_ _i140978_))))
                (u32vector-set! _v140964_ _i140978_ _next140982_)
                (_lp140975_ (fx+ _i140978_ '1) _next140982_))
              _v140964_)))))
  (define std/srfi/160/u32#u32vector-take-while
    (lambda (_pred140943_ _v140945_)
      (let* ((_len140948_ (u32vector-length _v140945_))
             (_idx140951_
              (std/srfi/160/u32#u32vector-skip__0 _pred140943_ _v140945_))
             (_idx140957_
              (let ((_$e140954_ _idx140951_))
                (if _$e140954_ _$e140954_ _len140948_))))
        (std/srfi/160/u32#u32vector-copy__% _v140945_ '0 _idx140957_))))
  (define std/srfi/160/u32#u32vector-take-while-right
    (lambda (_pred140929_ _v140931_)
      (let* ((_len140934_ (u32vector-length _v140931_))
             (_idx140937_
              (std/srfi/160/u32#u32vector-skip-right__0
               _pred140929_
               _v140931_))
             (_idx140940_ (if _idx140937_ (fx+ _idx140937_ '1) '0)))
        (std/srfi/160/u32#u32vector-copy__%
         _v140931_
         _idx140940_
         _len140934_))))
  (define std/srfi/160/u32#u32vector-drop-while
    (lambda (_pred140912_ _v140914_)
      (let* ((_len140917_ (u32vector-length _v140914_))
             (_idx140920_
              (std/srfi/160/u32#u32vector-skip__0 _pred140912_ _v140914_))
             (_idx140926_
              (let ((_$e140923_ _idx140920_))
                (if _$e140923_ _$e140923_ _len140917_))))
        (std/srfi/160/u32#u32vector-copy__%
         _v140914_
         _idx140926_
         _len140917_))))
  (define std/srfi/160/u32#u32vector-drop-while-right
    (lambda (_pred140898_ _v140900_)
      (let* ((_len140903_ (u32vector-length _v140900_))
             (_idx140906_
              (std/srfi/160/u32#u32vector-skip-right__0
               _pred140898_
               _v140900_))
             (_idx140909_ (if _idx140906_ (fx+ _idx140906_ '1) '0)))
        (std/srfi/160/u32#u32vector-copy__% _v140900_ '0 _idx140909_))))
  (define std/srfi/160/u32#u32vector-index__0
    (lambda (_pred140864_ _v140866_)
      (if (procedure? _pred140864_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140864_))
      (let ((_end140869_ (u32vector-length _v140866_)))
        (declare (not safe))
        (let _lp140873_ ((_i140876_ '0))
          (if (fx< _i140876_ _end140869_)
              (if (_pred140864_ (u32vector-ref _v140866_ _i140876_))
                  _i140876_
                  (_lp140873_ (fx+ _i140876_ '1)))
              '#f)))))
  (define std/srfi/160/u32#u32vector-index__1
    (lambda (_pred140879_ _v140880_ . _vs140881_)
      (if (procedure? _pred140879_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140879_))
      (let* ((_vs140884_ (cons _v140880_ _vs140881_))
             (_end140886_ (apply fxmin (map u32vector-length _vs140884_))))
        (declare (not safe))
        (let _lp140890_ ((_i140892_ '0))
          (if (fx< _i140892_ _end140886_)
              (if (apply _pred140879_
                         (map (lambda (_g140893140895_)
                                (u32vector-ref _g140893140895_ _i140892_))
                              _vs140884_))
                  _i140892_
                  (_lp140890_ (fx+ _i140892_ '1)))
              '#f)))))
  (define std/srfi/160/u32#u32vector-index
    (lambda _g299169_
      (let ((_g299168_ (let () (declare (not safe)) (##length _g299169_))))
        (cond ((let () (declare (not safe)) (##fx= _g299168_ 2))
               (apply std/srfi/160/u32#u32vector-index__0 _g299169_))
              ((let () (declare (not safe)) (##fx>= _g299168_ 2))
               (apply std/srfi/160/u32#u32vector-index__1 _g299169_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-index
                _g299169_))))))
  (define std/srfi/160/u32#u32vector-index-right__0
    (lambda (_pred140830_ _v140832_)
      (if (procedure? _pred140830_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140830_))
      (let ((_start140835_ (fx- (u32vector-length _v140832_) '1)))
        (declare (not safe))
        (let _lp140839_ ((_i140842_ _start140835_))
          (if (fx>= _i140842_ '0)
              (if (_pred140830_ (u32vector-ref _v140832_ _i140842_))
                  _i140842_
                  (_lp140839_ (fx- _i140842_ '1)))
              '#f)))))
  (define std/srfi/160/u32#u32vector-index-right__1
    (lambda (_pred140845_ _v140846_ . _vs140847_)
      (if (procedure? _pred140845_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140845_))
      (let* ((_vs140850_ (cons _v140846_ _vs140847_))
             (_start140852_
              (fx- (apply fxmin (map u32vector-length _vs140850_)) '1)))
        (declare (not safe))
        (let _lp140856_ ((_i140858_ _start140852_))
          (if (fx>= _i140858_ '0)
              (if (apply _pred140845_
                         (map (lambda (_g140859140861_)
                                (u32vector-ref _g140859140861_ _i140858_))
                              _vs140850_))
                  _i140858_
                  (_lp140856_ (fx- _i140858_ '1)))
              '#f)))))
  (define std/srfi/160/u32#u32vector-index-right
    (lambda _g299171_
      (let ((_g299170_ (let () (declare (not safe)) (##length _g299171_))))
        (cond ((let () (declare (not safe)) (##fx= _g299170_ 2))
               (apply std/srfi/160/u32#u32vector-index-right__0 _g299171_))
              ((let () (declare (not safe)) (##fx>= _g299170_ 2))
               (apply std/srfi/160/u32#u32vector-index-right__1 _g299171_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-index-right
                _g299171_))))))
  (define std/srfi/160/u32#u32vector-skip__0
    (lambda (_pred140814_ _v140816_)
      (std/srfi/160/u32#u32vector-index__0
       (lambda (_$obj140819_) (not (_pred140814_ _$obj140819_)))
       _v140816_)))
  (define std/srfi/160/u32#u32vector-skip__1
    (lambda (_pred140822_ _v140823_ . _vs140824_)
      (apply std/srfi/160/u32#u32vector-index
             (lambda (_$obj140827_) (not (_pred140822_ _$obj140827_)))
             _v140823_
             _vs140824_)))
  (define std/srfi/160/u32#u32vector-skip
    (lambda _g299173_
      (let ((_g299172_ (let () (declare (not safe)) (##length _g299173_))))
        (cond ((let () (declare (not safe)) (##fx= _g299172_ 2))
               (apply std/srfi/160/u32#u32vector-skip__0 _g299173_))
              ((let () (declare (not safe)) (##fx>= _g299172_ 2))
               (apply std/srfi/160/u32#u32vector-skip__1 _g299173_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-skip
                _g299173_))))))
  (define std/srfi/160/u32#u32vector-skip-right__0
    (lambda (_pred140798_ _v140800_)
      (std/srfi/160/u32#u32vector-index-right__0
       (lambda (_$obj140803_) (not (_pred140798_ _$obj140803_)))
       _v140800_)))
  (define std/srfi/160/u32#u32vector-skip-right__1
    (lambda (_pred140806_ _v140807_ . _vs140808_)
      (apply std/srfi/160/u32#u32vector-index-right
             (lambda (_$obj140811_) (not (_pred140806_ _$obj140811_)))
             _v140807_
             _vs140808_)))
  (define std/srfi/160/u32#u32vector-skip-right
    (lambda _g299175_
      (let ((_g299174_ (let () (declare (not safe)) (##length _g299175_))))
        (cond ((let () (declare (not safe)) (##fx= _g299174_ 2))
               (apply std/srfi/160/u32#u32vector-skip-right__0 _g299175_))
              ((let () (declare (not safe)) (##fx>= _g299174_ 2))
               (apply std/srfi/160/u32#u32vector-skip-right__1 _g299175_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-skip-right
                _g299175_))))))
  (define std/srfi/160/u32#u32vector-any__0
    (lambda (_pred140758_ _v140760_)
      (if (procedure? _pred140758_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140758_))
      (let ((_end140763_ (u32vector-length _v140760_)))
        (declare (not safe))
        (let _lp140767_ ((_i140770_ '0))
          (if (fx< _i140770_ _end140763_)
              (let ((_$e140773_
                     (_pred140758_ (u32vector-ref _v140760_ _i140770_))))
                (if _$e140773_
                    (values _$e140773_)
                    (_lp140767_ (fx+ _i140770_ '1))))
              '#f)))))
  (define std/srfi/160/u32#u32vector-any__1
    (lambda (_pred140776_ _v140777_ . _vs140778_)
      (if (procedure? _pred140776_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140776_))
      (let* ((_v140781_ (cons _v140777_ _vs140778_))
             (_end140783_ (apply fxmin (map u32vector-length _vs140778_))))
        (declare (not safe))
        (let _lp140787_ ((_i140789_ '0))
          (if (fx< _i140789_ _end140783_)
              (let ((_$e140795_
                     (apply _pred140776_
                            (map (lambda (_g140790140792_)
                                   (u32vector-ref _g140790140792_ _i140789_))
                                 _vs140778_))))
                (if _$e140795_
                    (values _$e140795_)
                    (_lp140787_ (fx+ _i140789_ '1))))
              '#f)))))
  (define std/srfi/160/u32#u32vector-any
    (lambda _g299177_
      (let ((_g299176_ (let () (declare (not safe)) (##length _g299177_))))
        (cond ((let () (declare (not safe)) (##fx= _g299176_ 2))
               (apply std/srfi/160/u32#u32vector-any__0 _g299177_))
              ((let () (declare (not safe)) (##fx>= _g299176_ 2))
               (apply std/srfi/160/u32#u32vector-any__1 _g299177_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-any
                _g299177_))))))
  (define std/srfi/160/u32#u32vector-every__0
    (lambda (_pred140707_ _v140709_)
      (if (procedure? _pred140707_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140707_))
      (let ((_end140712_ (u32vector-length _v140709_)))
        (declare (not safe))
        (let _lp140716_ ((_i140719_ '0) (_r140721_ '#t))
          (if (fx< _i140719_ _end140712_)
              (let ((_$e140724_
                     (_pred140707_ (u32vector-ref _v140709_ _i140719_))))
                (if _$e140724_
                    ((lambda (_g140726140728_)
                       (_lp140716_ (fx+ _i140719_ '1) _g140726140728_))
                     _$e140724_)
                    '#f))
              _r140721_)))))
  (define std/srfi/160/u32#u32vector-every__1
    (lambda (_pred140731_ _v140732_ . _vs140733_)
      (if (procedure? _pred140731_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140731_))
      (let* ((_v140736_ (cons _v140732_ _vs140733_))
             (_end140738_ (apply fxmin (map u32vector-length _vs140733_))))
        (declare (not safe))
        (let _lp140742_ ((_i140744_ '0) (_r140745_ '#t))
          (if (fx< _i140744_ _end140738_)
              (let ((_$e140751_
                     (apply _pred140731_
                            (map (lambda (_g140746140748_)
                                   (u32vector-ref _g140746140748_ _i140744_))
                                 _vs140733_))))
                (if _$e140751_
                    ((lambda (_g140753140755_)
                       (_lp140742_ (fx+ _i140744_ '1) _g140753140755_))
                     _$e140751_)
                    '#f))
              _r140745_)))))
  (define std/srfi/160/u32#u32vector-every
    (lambda _g299179_
      (let ((_g299178_ (let () (declare (not safe)) (##length _g299179_))))
        (cond ((let () (declare (not safe)) (##fx= _g299178_ 2))
               (apply std/srfi/160/u32#u32vector-every__0 _g299179_))
              ((let () (declare (not safe)) (##fx>= _g299178_ 2))
               (apply std/srfi/160/u32#u32vector-every__1 _g299179_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-every
                _g299179_))))))
  (define std/srfi/160/u32#u32vector-partition
    (lambda (_pred140678_ _v140680_)
      (let* ((_count140683_
              (std/srfi/160/u32#u32vector-count__0 _pred140678_ _v140680_))
             (_len140686_ (u32vector-length _v140680_))
             (_u140689_ (make-u32vector _len140686_)))
        (declare (not safe))
        (let _lp140694_ ((_i140697_ '0)
                         (_left140699_ '0)
                         (_right140701_ _count140683_))
          (if (fx< _i140697_ _len140686_)
              (let ((_x140704_ (u32vector-ref _v140680_ _i140697_)))
                (if (_pred140678_ _x140704_)
                    (begin
                      (u32vector-set! _u140689_ _left140699_ _x140704_)
                      (_lp140694_
                       (fx+ _i140697_ '1)
                       (fx+ _left140699_ '1)
                       _right140701_))
                    (begin
                      (u32vector-set! _u140689_ _right140701_ _x140704_)
                      (_lp140694_
                       (fx+ _i140697_ '1)
                       _left140699_
                       (fx+ _right140701_ '1)))))
              _u140689_)))))
  (define std/srfi/160/u32#u32vector-filter
    (lambda (_pred140651_ _v140653_)
      (let* ((_count140656_
              (std/srfi/160/u32#u32vector-count__0 _pred140651_ _v140653_))
             (_u140659_ (make-u32vector _count140656_))
             (_end140662_ (u32vector-length _v140653_)))
        (declare (not safe))
        (let _lp140667_ ((_i140670_ '0) (_j140672_ '0))
          (if (fx< _i140670_ _end140662_)
              (let ((_x140675_ (u32vector-ref _v140653_ _i140670_)))
                (if (_pred140651_ _x140675_)
                    (begin
                      (u32vector-set! _u140659_ _j140672_ _x140675_)
                      (_lp140667_ (fx+ _i140670_ '1) (fx+ _j140672_ '1)))
                    (_lp140667_ (fx+ _i140670_ '1) _j140672_)))
              _u140659_)))))
  (define std/srfi/160/u32#u32vector-remove
    (lambda (_pred140643_ _v140645_)
      (std/srfi/160/u32#u32vector-filter
       (lambda (_$obj140648_) (not (_pred140643_ _$obj140648_)))
       _v140645_)))
  (define std/srfi/160/u32#u32vector-swap
    (lambda (_v140630_ _i140632_ _j140634_)
      (let ((_iv140637_ (u32vector-ref _v140630_ _i140632_))
            (_jv140639_ (u32vector-ref _v140630_ _j140634_)))
        (declare (not safe))
        (begin
          (u32vector-set! _v140630_ _i140632_ _jv140639_)
          (u32vector-set! _v140630_ _j140634_ _iv140637_)))))
  (define std/srfi/160/u32#u32vector-fill!__%
    (lambda (_v140593_ _fill140595_ _start140597_ _end140599_)
      (declare (not safe))
      (begin
        (if (u32vector? _v140593_) '#!void (error '"Bad argument" _v140593_))
        (if (std/srfi/160/base#u32? _fill140595_)
            '#!void
            (error '"Bad argument" _fill140595_))
        (if (and (fixnum? _start140597_)
                 (fx<= '0 _start140597_ (fx- (u32vector-length _v140593_) '1)))
            '#!void
            (error '"Index out of range" _start140597_))
        (if (and (fixnum? _end140599_)
                 (fx<= _start140597_ _end140599_ (u32vector-length _v140593_)))
            '#!void
            (error '"Index out of range" _end140599_))
        (let _lp140603_ ((_i140606_ _start140597_))
          (if (fx< _i140606_ _end140599_)
              (begin
                (u32vector-set! _v140593_ _i140606_ _fill140595_)
                (_lp140603_ (fx+ _i140606_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-fill!__0
    (lambda (_v140612_ _fill140613_)
      (let* ((_start140615_ '0) (_end140617_ (u32vector-length _v140612_)))
        (std/srfi/160/u32#u32vector-fill!__%
         _v140612_
         _fill140613_
         _start140615_
         _end140617_))))
  (define std/srfi/160/u32#u32vector-fill!__1
    (lambda (_v140619_ _fill140620_ _start140621_)
      (let ((_end140623_ (u32vector-length _v140619_)))
        (std/srfi/160/u32#u32vector-fill!__%
         _v140619_
         _fill140620_
         _start140621_
         _end140623_))))
  (define std/srfi/160/u32#u32vector-fill!
    (lambda _g299181_
      (let ((_g299180_ (let () (declare (not safe)) (##length _g299181_))))
        (cond ((let () (declare (not safe)) (##fx= _g299180_ 2))
               (apply std/srfi/160/u32#u32vector-fill!__0 _g299181_))
              ((let () (declare (not safe)) (##fx= _g299180_ 3))
               (apply std/srfi/160/u32#u32vector-fill!__1 _g299181_))
              ((let () (declare (not safe)) (##fx= _g299180_ 4))
               (apply std/srfi/160/u32#u32vector-fill!__% _g299181_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-fill!
                _g299181_))))))
  (define std/srfi/160/u32#u32vector-reverse!__%
    (lambda (_v140553_ _start140555_ _end140557_)
      (declare (not safe))
      (begin
        (if (u32vector? _v140553_) '#!void (error '"Bad argument" _v140553_))
        (if (and (fixnum? _start140555_)
                 (fx<= '0 _start140555_ (fx- (u32vector-length _v140553_) '1)))
            '#!void
            (error '"Index out of range" _start140555_))
        (if (and (fixnum? _end140557_)
                 (fx<= _start140555_ _end140557_ (u32vector-length _v140553_)))
            '#!void
            (error '"Index out of range" _end140557_))
        (let _lp140561_ ((_i140564_ _start140555_)
                         (_j140566_ (fx- _end140557_ '1)))
          (if (fx< _i140564_ _j140566_)
              (let ((_iv140569_ (u32vector-ref _v140553_ _i140564_))
                    (_jv140571_ (u32vector-ref _v140553_ _j140566_)))
                (u32vector-set! _v140553_ _i140564_ _jv140571_)
                (u32vector-set! _v140553_ _j140566_ _iv140569_)
                (_lp140561_ (fx+ _i140564_ '1) (fx- _j140566_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-reverse!__0
    (lambda (_v140577_)
      (let* ((_start140579_ '0) (_end140581_ (u32vector-length _v140577_)))
        (std/srfi/160/u32#u32vector-reverse!__%
         _v140577_
         _start140579_
         _end140581_))))
  (define std/srfi/160/u32#u32vector-reverse!__1
    (lambda (_v140583_ _start140584_)
      (let ((_end140586_ (u32vector-length _v140583_)))
        (std/srfi/160/u32#u32vector-reverse!__%
         _v140583_
         _start140584_
         _end140586_))))
  (define std/srfi/160/u32#u32vector-reverse!
    (lambda _g299183_
      (let ((_g299182_ (let () (declare (not safe)) (##length _g299183_))))
        (cond ((let () (declare (not safe)) (##fx= _g299182_ 1))
               (apply std/srfi/160/u32#u32vector-reverse!__0 _g299183_))
              ((let () (declare (not safe)) (##fx= _g299182_ 2))
               (apply std/srfi/160/u32#u32vector-reverse!__1 _g299183_))
              ((let () (declare (not safe)) (##fx= _g299182_ 3))
               (apply std/srfi/160/u32#u32vector-reverse!__% _g299183_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-reverse!
                _g299183_))))))
  (define std/srfi/160/u32#u32vector-unfold!
    (lambda (_f140528_ _v140530_ _start140532_ _end140534_ _seed140536_)
      (declare (not safe))
      (begin
        (if (procedure? _f140528_)
            '#!void
            (error '"Bad argument; expected procedure" _f140528_))
        (if (u32vector? _v140530_) '#!void (error '"Bad argument" _v140530_))
        (if (and (fixnum? _start140532_)
                 (fx<= '0 _start140532_ (fx- (u32vector-length _v140530_) '1)))
            '#!void
            (error '"Index out of range" _start140532_))
        (if (and (fixnum? _end140534_)
                 (fx<= _start140532_ _end140534_ (u32vector-length _v140530_)))
            '#!void
            (error '"Index out of range" _end140534_))
        (let _lp140540_ ((_i140543_ _start140532_)
                         (_state140545_ _seed140536_))
          (if (fx< _i140543_ _end140534_)
              (let ((_g299184_ (_f140528_ _state140545_)))
                (begin
                  (let ((_g299185_
                         (if (##values? _g299184_)
                             (##vector-length _g299184_)
                             1)))
                    (if (not (##fx= _g299185_ 2))
                        (error "Context expects 2 values" _g299185_)))
                  (let ((_x140548_ (##vector-ref _g299184_ 0))
                        (_state140550_ (##vector-ref _g299184_ 1)))
                    (begin
                      (u32vector-set! _v140530_ _i140543_ _x140548_)
                      (_lp140540_ (fx+ _i140543_ '1) _state140550_)))))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-unfold-right!
    (lambda (_f140504_ _v140506_ _start140508_ _end140510_ _seed140512_)
      (declare (not safe))
      (begin
        (if (procedure? _f140504_)
            '#!void
            (error '"Bad argument; expected procedure" _f140504_))
        (if (u32vector? _v140506_) '#!void (error '"Bad argument" _v140506_))
        (if (and (fixnum? _start140508_)
                 (fx<= '0 _start140508_ (fx- (u32vector-length _v140506_) '1)))
            '#!void
            (error '"Index out of range" _start140508_))
        (if (and (fixnum? _end140510_)
                 (fx<= _start140508_ _end140510_ (u32vector-length _v140506_)))
            '#!void
            (error '"Index out of range" _end140510_))
        (let _lp140516_ ((_i140519_ (fx- _end140510_ '1))
                         (_state140521_ _seed140512_))
          (if (fx>= _i140519_ _start140508_)
              (let ((_g299186_ (_f140504_ _state140521_)))
                (begin
                  (let ((_g299187_
                         (if (##values? _g299186_)
                             (##vector-length _g299186_)
                             1)))
                    (if (not (##fx= _g299187_ 2))
                        (error "Context expects 2 values" _g299187_)))
                  (let ((_x140524_ (##vector-ref _g299186_ 0))
                        (_state140526_ (##vector-ref _g299186_ 1)))
                    (begin
                      (u32vector-set! _v140506_ _i140519_ _x140524_)
                      (_lp140516_ (fx- _i140519_ '1) _state140526_)))))
              '#!void)))))
  (define std/srfi/160/u32#reverse-u32vector->list__%
    (lambda (_v140470_ _start140472_ _end140474_)
      (declare (not safe))
      (begin
        (if (u32vector? _v140470_) '#!void (error '"Bad argument" _v140470_))
        (if (and (fixnum? _start140472_)
                 (fx<= '0 _start140472_ (fx- (u32vector-length _v140470_) '1)))
            '#!void
            (error '"Index out of range" _start140472_))
        (if (and (fixnum? _end140474_)
                 (fx<= _start140472_ _end140474_ (u32vector-length _v140470_)))
            '#!void
            (error '"Index out of range" _end140474_))
        (let _lp140478_ ((_i140481_ _start140472_) (_r140483_ '()))
          (if (fx< _i140481_ _end140474_)
              (_lp140478_
               (fx+ _i140481_ '1)
               (cons (u32vector-ref _v140470_ _i140481_) _r140483_))
              _r140483_)))))
  (define std/srfi/160/u32#reverse-u32vector->list__0
    (lambda (_v140489_)
      (let* ((_start140491_ '0) (_end140493_ (u32vector-length _v140489_)))
        (std/srfi/160/u32#reverse-u32vector->list__%
         _v140489_
         _start140491_
         _end140493_))))
  (define std/srfi/160/u32#reverse-u32vector->list__1
    (lambda (_v140495_ _start140496_)
      (let ((_end140498_ (u32vector-length _v140495_)))
        (std/srfi/160/u32#reverse-u32vector->list__%
         _v140495_
         _start140496_
         _end140498_))))
  (define std/srfi/160/u32#reverse-u32vector->list
    (lambda _g299189_
      (let ((_g299188_ (let () (declare (not safe)) (##length _g299189_))))
        (cond ((let () (declare (not safe)) (##fx= _g299188_ 1))
               (apply std/srfi/160/u32#reverse-u32vector->list__0 _g299189_))
              ((let () (declare (not safe)) (##fx= _g299188_ 2))
               (apply std/srfi/160/u32#reverse-u32vector->list__1 _g299189_))
              ((let () (declare (not safe)) (##fx= _g299188_ 3))
               (apply std/srfi/160/u32#reverse-u32vector->list__% _g299189_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#reverse-u32vector->list
                _g299189_))))))
  (define std/srfi/160/u32#reverse-list->u32vector
    (lambda (_lst140416_)
      (let* ((_len140419_ (length _lst140416_))
             (_v140422_ (make-u32vector _len140419_)))
        (declare (not safe))
        (let _lp140427_ ((_rest140430_ _lst140416_) (_i140432_ '0))
          (let* ((_rest140434140442_ _rest140430_)
                 (_else140436140450_ (lambda () _v140422_))
                 (_K140438140457_
                  (lambda (_rest140453_ _x140454_)
                    (if (std/srfi/160/base#u32? _x140454_)
                        '#!void
                        (error '"Bad element" _x140454_))
                    (u32vector-set! _v140422_ _i140432_ _x140454_)
                    (_lp140427_ _rest140453_ (fx+ _i140432_ '1)))))
            (if (##pair? _rest140434140442_)
                (let ((_hd140439140460_ (##car _rest140434140442_))
                      (_tl140440140462_ (##cdr _rest140434140442_)))
                  (let* ((_x140465_ _hd140439140460_)
                         (_rest140467_ _tl140440140462_))
                    (_K140438140457_ _rest140467_ _x140465_)))
                (_else140436140450_)))))))
  (define std/srfi/160/u32#u32vector->vector__%
    (lambda (_v140377_ _start140379_ _end140381_)
      (declare (not safe))
      (begin
        (if (u32vector? _v140377_) '#!void (error '"Bad argument" _v140377_))
        (if (and (fixnum? _start140379_)
                 (fx<= '0 _start140379_ (fx- (u32vector-length _v140377_) '1)))
            '#!void
            (error '"Index out of range" _start140379_))
        (if (and (fixnum? _end140381_)
                 (fx<= _start140379_ _end140381_ (u32vector-length _v140377_)))
            '#!void
            (error '"Index out of range" _end140381_))
        (let* ((_len140385_ (u32vector-length _v140377_))
               (_u140388_ (make-vector _len140385_)))
          (let _lp140392_ ((_i140395_ '0))
            (if (fx< _i140395_ _len140385_)
                (begin
                  (vector-set!
                   _u140388_
                   _i140395_
                   (u32vector-ref _v140377_ _i140395_))
                  (_lp140392_ (fx+ _i140395_ '1)))
                _u140388_))))))
  (define std/srfi/160/u32#u32vector->vector__0
    (lambda (_v140401_)
      (let* ((_start140403_ '0) (_end140405_ (u32vector-length _v140401_)))
        (std/srfi/160/u32#u32vector->vector__%
         _v140401_
         _start140403_
         _end140405_))))
  (define std/srfi/160/u32#u32vector->vector__1
    (lambda (_v140407_ _start140408_)
      (let ((_end140410_ (u32vector-length _v140407_)))
        (std/srfi/160/u32#u32vector->vector__%
         _v140407_
         _start140408_
         _end140410_))))
  (define std/srfi/160/u32#u32vector->vector
    (lambda _g299191_
      (let ((_g299190_ (let () (declare (not safe)) (##length _g299191_))))
        (cond ((let () (declare (not safe)) (##fx= _g299190_ 1))
               (apply std/srfi/160/u32#u32vector->vector__0 _g299191_))
              ((let () (declare (not safe)) (##fx= _g299190_ 2))
               (apply std/srfi/160/u32#u32vector->vector__1 _g299191_))
              ((let () (declare (not safe)) (##fx= _g299190_ 3))
               (apply std/srfi/160/u32#u32vector->vector__% _g299191_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector->vector
                _g299191_))))))
  (define std/srfi/160/u32#vector->u32vector__%
    (lambda (_v140337_ _start140339_ _end140341_)
      (declare (not safe))
      (begin
        (if (vector? _v140337_)
            '#!void
            (error '"Bad argument; expected vector" _v140337_))
        (if (and (fixnum? _start140339_)
                 (fx<= '0 _start140339_ (fx- (vector-length _v140337_) '1)))
            '#!void
            (error '"Index out of range" _start140339_))
        (if (and (fixnum? _end140341_)
                 (fx<= _start140339_ _end140341_ (vector-length _v140337_)))
            '#!void
            (error '"Index out of range" _end140341_))
        (let* ((_len140345_ (vector-length _v140337_))
               (_u140348_ (make-u32vector _len140345_)))
          (let _lp140352_ ((_i140355_ '0))
            (if (fx< _i140355_ _len140345_)
                (begin
                  (u32vector-set!
                   _u140348_
                   _i140355_
                   (vector-ref _v140337_ _i140355_))
                  (_lp140352_ (fx+ _i140355_ '1)))
                _u140348_))))))
  (define std/srfi/160/u32#vector->u32vector__0
    (lambda (_v140361_)
      (let* ((_start140363_ '0) (_end140365_ (vector-length _v140361_)))
        (std/srfi/160/u32#vector->u32vector__%
         _v140361_
         _start140363_
         _end140365_))))
  (define std/srfi/160/u32#vector->u32vector__1
    (lambda (_v140367_ _start140368_)
      (let ((_end140370_ (vector-length _v140367_)))
        (std/srfi/160/u32#vector->u32vector__%
         _v140367_
         _start140368_
         _end140370_))))
  (define std/srfi/160/u32#vector->u32vector
    (lambda _g299193_
      (let ((_g299192_ (let () (declare (not safe)) (##length _g299193_))))
        (cond ((let () (declare (not safe)) (##fx= _g299192_ 1))
               (apply std/srfi/160/u32#vector->u32vector__0 _g299193_))
              ((let () (declare (not safe)) (##fx= _g299192_ 2))
               (apply std/srfi/160/u32#vector->u32vector__1 _g299193_))
              ((let () (declare (not safe)) (##fx= _g299192_ 3))
               (apply std/srfi/160/u32#vector->u32vector__% _g299193_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#vector->u32vector
                _g299193_))))))
  (define std/srfi/160/u32#make-u32vector-generator__%
    (lambda (_v140303_ _start140305_ _end140307_)
      (declare (not safe))
      (begin
        (if (u32vector? _v140303_) '#!void (error '"Bad argument" _v140303_))
        (if (and (fixnum? _start140305_)
                 (fx<= '0 _start140305_ (fx- (u32vector-length _v140303_) '1)))
            '#!void
            (error '"Index out of range" _start140305_))
        (if (and (fixnum? _end140307_)
                 (fx<= _start140305_ _end140307_ (u32vector-length _v140303_)))
            '#!void
            (error '"Index out of range" _end140307_))
        (let ((_i140311_ _start140305_))
          (lambda ()
            (if (fx< _i140311_ _end140307_)
                (let ((_next140315_ (u32vector-ref _v140303_ _i140311_)))
                  (set! _i140311_ (fx+ _i140311_ '1))
                  _next140315_)
                '#!eof))))))
  (define std/srfi/160/u32#make-u32vector-generator__0
    (lambda (_v140321_)
      (let* ((_start140323_ '0) (_end140325_ (u32vector-length _v140321_)))
        (std/srfi/160/u32#make-u32vector-generator__%
         _v140321_
         _start140323_
         _end140325_))))
  (define std/srfi/160/u32#make-u32vector-generator__1
    (lambda (_v140327_ _start140328_)
      (let ((_end140330_ (u32vector-length _v140327_)))
        (std/srfi/160/u32#make-u32vector-generator__%
         _v140327_
         _start140328_
         _end140330_))))
  (define std/srfi/160/u32#make-u32vector-generator
    (lambda _g299195_
      (let ((_g299194_ (let () (declare (not safe)) (##length _g299195_))))
        (cond ((let () (declare (not safe)) (##fx= _g299194_ 1))
               (apply std/srfi/160/u32#make-u32vector-generator__0 _g299195_))
              ((let () (declare (not safe)) (##fx= _g299194_ 2))
               (apply std/srfi/160/u32#make-u32vector-generator__1 _g299195_))
              ((let () (declare (not safe)) (##fx= _g299194_ 3))
               (apply std/srfi/160/u32#make-u32vector-generator__% _g299195_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#make-u32vector-generator
                _g299195_))))))
  (define std/srfi/160/u32#u32vector-comparator
    (let ()
      (letrec ((_<?140274_
                (lambda (_a140277_ _b140279_)
                  (let ((_len-a140282_ (u32vector-length _a140277_))
                        (_len-b140284_ (u32vector-length _b140279_)))
                    (declare (not safe))
                    (if (fx< _len-a140282_ _len-b140284_)
                        '#t
                        (if (fx> _len-a140282_ _len-b140284_)
                            '#f
                            (let ((_end140288_ _len-a140282_))
                              (let _lp140291_ ((_i140294_ '0))
                                (if (fx< _i140294_ _end140288_)
                                    (let ((_x140297_
                                           (u32vector-ref _a140277_ _i140294_))
                                          (_y140299_
                                           (u32vector-ref
                                            _b140279_
                                            _i140294_)))
                                      (if (< _x140297_ _y140299_)
                                          '#t
                                          (if (> _x140297_ _y140299_)
                                              '#f
                                              (_lp140291_
                                               (fx+ _i140294_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           u32vector?
           std/srfi/160/u32#u32vector=
           _<?140274_
           equal?-hash)))))
  (define std/srfi/160/u32#write-u32vector__%
    (lambda (_v140251_ _port140253_)
      (let ((_$e140256_ (find-method _v140251_ ':write)))
        (if _$e140256_
            ((lambda (_g140258140260_)
               (_g140258140260_ _v140251_ _port140253_))
             _$e140256_)
            (write _v140251_ (current-output-port))))))
  (define std/srfi/160/u32#write-u32vector__0
    (lambda (_v140266_)
      (let ((_port140268_ (current-output-port)))
        (std/srfi/160/u32#write-u32vector__% _v140266_ _port140268_))))
  (define std/srfi/160/u32#write-u32vector
    (lambda _g299197_
      (let ((_g299196_ (let () (declare (not safe)) (##length _g299197_))))
        (cond ((let () (declare (not safe)) (##fx= _g299196_ 1))
               (apply std/srfi/160/u32#write-u32vector__0 _g299197_))
              ((let () (declare (not safe)) (##fx= _g299196_ 2))
               (apply std/srfi/160/u32#write-u32vector__% _g299197_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#write-u32vector
                _g299197_)))))))
