(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/u64#u64vector-unfold
    (lambda (_f144508_ _len144510_ _seed144512_)
      (declare (not safe))
      (begin
        (if (procedure? _f144508_)
            '#!void
            (error '"Bad argument; expected procedure" _f144508_))
        (let ((_v144516_ (make-u64vector _len144510_)))
          (let _lp144519_ ((_i144522_ '0) (_state144524_ _seed144512_))
            (if (fx< _i144522_ _len144510_)
                (let ((_g299248_ (_f144508_ _i144522_ _state144524_)))
                  (begin
                    (let ((_g299249_
                           (if (##values? _g299248_)
                               (##vector-length _g299248_)
                               1)))
                      (if (not (##fx= _g299249_ 2))
                          (error "Context expects 2 values" _g299249_)))
                    (let ((_x144527_ (##vector-ref _g299248_ 0))
                          (_state144529_ (##vector-ref _g299248_ 1)))
                      (begin
                        (if (std/srfi/160/base#u64? _x144527_)
                            '#!void
                            (error '"Bad generated value" _x144527_))
                        (u64vector-set! _v144516_ _i144522_ _x144527_)
                        (_lp144519_ (fx+ _i144522_ '1) _state144529_)))))
                _v144516_))))))
  (define std/srfi/160/u64#u64vector-unfold-right
    (lambda (_f144485_ _len144487_ _seed144489_)
      (declare (not safe))
      (begin
        (if (procedure? _f144485_)
            '#!void
            (error '"Bad argument; expected procedure" _f144485_))
        (let ((_v144493_ (make-u64vector _len144487_)))
          (let _lp144496_ ((_i144499_ (fx- _len144487_ '1))
                           (_state144501_ _seed144489_))
            (if (fx>= _i144499_ '0)
                (let ((_g299250_ (_f144485_ _i144499_ _state144501_)))
                  (begin
                    (let ((_g299251_
                           (if (##values? _g299250_)
                               (##vector-length _g299250_)
                               1)))
                      (if (not (##fx= _g299251_ 2))
                          (error "Context expects 2 values" _g299251_)))
                    (let ((_x144504_ (##vector-ref _g299250_ 0))
                          (_state144506_ (##vector-ref _g299250_ 1)))
                      (begin
                        (if (std/srfi/160/base#u64? _x144504_)
                            '#!void
                            (error '"Bad generated value" _x144504_))
                        (u64vector-set! _v144493_ _i144499_ _x144504_)
                        (_lp144496_ (fx- _i144499_ '1) _state144506_)))))
                _v144493_))))))
  (define std/srfi/160/u64#u64vector-copy__%
    (lambda (_vec144457_ _start144459_ _end144461_)
      (let ((_v144464_ (make-u64vector (fx- _end144461_ _start144459_))))
        (std/srfi/160/u64#u64vector-copy!
         _v144464_
         '0
         _vec144457_
         _start144459_
         _end144461_)
        _v144464_)))
  (define std/srfi/160/u64#u64vector-copy__0
    (lambda (_vec144470_)
      (let* ((_start144472_ '0) (_end144474_ (u64vector-length _vec144470_)))
        (std/srfi/160/u64#u64vector-copy__%
         _vec144470_
         _start144472_
         _end144474_))))
  (define std/srfi/160/u64#u64vector-copy__1
    (lambda (_vec144476_ _start144477_)
      (let ((_end144479_ (u64vector-length _vec144476_)))
        (std/srfi/160/u64#u64vector-copy__%
         _vec144476_
         _start144477_
         _end144479_))))
  (define std/srfi/160/u64#u64vector-copy
    (lambda _g299253_
      (let ((_g299252_ (let () (declare (not safe)) (##length _g299253_))))
        (cond ((let () (declare (not safe)) (##fx= _g299252_ 1))
               (apply std/srfi/160/u64#u64vector-copy__0 _g299253_))
              ((let () (declare (not safe)) (##fx= _g299252_ 2))
               (apply std/srfi/160/u64#u64vector-copy__1 _g299253_))
              ((let () (declare (not safe)) (##fx= _g299252_ 3))
               (apply std/srfi/160/u64#u64vector-copy__% _g299253_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-copy
                _g299253_))))))
  (define std/srfi/160/u64#u64vector-copy!
    (lambda (_to144436_ _at144438_ _from144440_ _start144442_ _end144444_)
      (declare (not safe))
      (begin
        (if (u64vector? _to144436_) '#!void (error '"Bad argument" _to144436_))
        (if (u64vector? _from144440_)
            '#!void
            (error '"Bad argument" _from144440_))
        (if (and (fixnum? _at144438_)
                 (fx<= '0 _at144438_ (fx- (u64vector-length _at144438_) '1)))
            '#!void
            (error '"Index out of range" _to144436_ _at144438_))
        (if (and (fixnum? _start144442_)
                 (fx<= '0
                       _start144442_
                       (fx- (u64vector-length _from144440_) '1)))
            '#!void
            (error '"Index out of range" _from144440_ _start144442_))
        (if (and (fixnum? _end144444_)
                 (fx<= _start144442_
                       _end144444_
                       (u64vector-length _from144440_)))
            '#!void
            (error '"Index out of range" _from144440_ _end144444_))
        (if (fx<= (fx- _end144444_ _start144442_)
                  (fx- (u64vector-length _to144436_) _at144438_))
            '#!void
            (error '"Destination area too small"
                   _to144436_
                   _at144438_
                   _from144440_
                   _start144442_
                   _end144444_))
        (let _lp144448_ ((_i144451_ _start144442_) (_j144453_ _at144438_))
          (if (fx< _i144451_ _end144444_)
              (begin
                (u64vector-set!
                 _to144436_
                 _j144453_
                 (u64vector-ref _from144440_ _i144451_))
                (_lp144448_ (fx+ _i144451_ '1) (fx+ _j144453_ '1)))
              '#!void)))))
  (define std/srfi/160/u64#u64vector-reverse-copy__%
    (lambda (_vec144408_ _start144410_ _end144412_)
      (let ((_v144415_ (make-u64vector (fx- _end144412_ _start144410_))))
        (std/srfi/160/u64#u64vector-reverse-copy!
         _v144415_
         '0
         _vec144408_
         _start144410_
         _end144412_)
        _v144415_)))
  (define std/srfi/160/u64#u64vector-reverse-copy__0
    (lambda (_vec144421_)
      (let* ((_start144423_ '0) (_end144425_ (u64vector-length _vec144421_)))
        (std/srfi/160/u64#u64vector-reverse-copy__%
         _vec144421_
         _start144423_
         _end144425_))))
  (define std/srfi/160/u64#u64vector-reverse-copy__1
    (lambda (_vec144427_ _start144428_)
      (let ((_end144430_ (u64vector-length _vec144427_)))
        (std/srfi/160/u64#u64vector-reverse-copy__%
         _vec144427_
         _start144428_
         _end144430_))))
  (define std/srfi/160/u64#u64vector-reverse-copy
    (lambda _g299255_
      (let ((_g299254_ (let () (declare (not safe)) (##length _g299255_))))
        (cond ((let () (declare (not safe)) (##fx= _g299254_ 1))
               (apply std/srfi/160/u64#u64vector-reverse-copy__0 _g299255_))
              ((let () (declare (not safe)) (##fx= _g299254_ 2))
               (apply std/srfi/160/u64#u64vector-reverse-copy__1 _g299255_))
              ((let () (declare (not safe)) (##fx= _g299254_ 3))
               (apply std/srfi/160/u64#u64vector-reverse-copy__% _g299255_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-reverse-copy
                _g299255_))))))
  (define std/srfi/160/u64#u64vector-reverse-copy!
    (lambda (_to144387_ _at144389_ _from144391_ _start144393_ _end144395_)
      (declare (not safe))
      (begin
        (if (u64vector? _to144387_) '#!void (error '"Bad argument" _to144387_))
        (if (u64vector? _from144391_)
            '#!void
            (error '"Bad argument" _from144391_))
        (if (and (fixnum? _at144389_)
                 (fx<= '0 _at144389_ (fx- (u64vector-length _at144389_) '1)))
            '#!void
            (error '"Index out of range" _to144387_ _at144389_))
        (if (and (fixnum? _start144393_)
                 (fx<= '0
                       _start144393_
                       (fx- (u64vector-length _from144391_) '1)))
            '#!void
            (error '"Index out of range" _from144391_ _start144393_))
        (if (and (fixnum? _end144395_)
                 (fx<= _start144393_
                       _end144395_
                       (u64vector-length _from144391_)))
            '#!void
            (error '"Index out of range" _from144391_ _end144395_))
        (if (fx<= (fx- _end144395_ _start144393_)
                  (fx- (u64vector-length _to144387_) _at144389_))
            '#!void
            (error '"Destination area too small"
                   _to144387_
                   _at144389_
                   _from144391_
                   _start144393_
                   _end144395_))
        (let _lp144399_ ((_i144402_ (fx- _end144395_ '1))
                         (_j144404_ _at144389_))
          (if (fx>= _i144402_ _start144393_)
              (begin
                (u64vector-set!
                 _to144387_
                 _j144404_
                 (u64vector-ref _from144391_ _i144402_))
                (_lp144399_ (fx- _i144402_ '1) (fx+ _j144404_ '1)))
              '#!void)))))
  (define std/srfi/160/u64#u64vector-append
    (lambda _args144384_
      (std/srfi/160/u64#u64vector-concatenate _args144384_)))
  (define std/srfi/160/u64#u64vector-concatenate
    (lambda (_lst144324_)
      (let* ((_len144332_
              (foldl1 (lambda (_v144327_ _r144329_)
                        (fx+ (u64vector-length _v144327_) _r144329_))
                      '0
                      _lst144324_))
             (_v144335_ (make-u64vector _len144332_)))
        (declare (not safe))
        (let _lp144339_ ((_rest144342_ _lst144324_) (_at144344_ '0))
          (let* ((_rest144346144354_ _rest144342_)
                 (_else144348144362_ (lambda () _v144335_))
                 (_K144350144372_
                  (lambda (_rest144365_ _u144366_)
                    (let ((_ulen144369_ (u64vector-length _u144366_)))
                      (std/srfi/160/u64#u64vector-copy!
                       _v144335_
                       _at144344_
                       _u144366_
                       '0
                       _ulen144369_)
                      (_lp144339_
                       _rest144365_
                       (fx+ _at144344_ _ulen144369_))))))
            (if (##pair? _rest144346144354_)
                (let ((_hd144351144375_ (##car _rest144346144354_))
                      (_tl144352144377_ (##cdr _rest144346144354_)))
                  (let* ((_u144380_ _hd144351144375_)
                         (_rest144382_ _tl144352144377_))
                    (_K144350144372_ _rest144382_ _u144380_)))
                (_else144348144362_)))))))
  (define std/srfi/160/u64#u64vector-append-subvectors
    (lambda _args144196_
      (let* ((_len144257_
              (let _lp144199_ ((_rest144202_ _args144196_) (_r144204_ '0))
                (let* ((_rest144206144218_ _rest144202_)
                       (_else144208144226_ (lambda () _r144204_))
                       (_K144210144235_
                        (lambda (_rest144229_ _end144230_ _start144232_)
                          (_lp144199_
                           _rest144229_
                           (fx+ _r144204_ (fx- _end144230_ _start144232_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest144206144218_))
                      (let ((_tl144212144238_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest144206144218_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl144212144238_))
                            (let ((_hd144213144241_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl144212144238_)))
                                  (_tl144214144243_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl144212144238_))))
                              (let ((_start144246_ _hd144213144241_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl144214144243_))
                                    (let ((_hd144215144248_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl144214144243_)))
                                          (_tl144216144250_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl144214144243_))))
                                      (let* ((_end144253_ _hd144215144248_)
                                             (_rest144255_ _tl144216144250_))
                                        (_K144210144235_
                                         _rest144255_
                                         _end144253_
                                         _start144246_)))
                                    (_else144208144226_))))
                            (_else144208144226_)))
                      (_else144208144226_)))))
             (_v144260_ (make-u64vector _len144257_)))
        (let _lp144264_ ((_rest144266_ _args144196_) (_at144267_ '0))
          (let* ((_rest144269144281_ _rest144266_)
                 (_else144271144289_ (lambda () _v144260_))
                 (_K144273144298_
                  (lambda (_rest144292_ _end144293_ _start144294_ _u144295_)
                    (std/srfi/160/u64#u64vector-copy!
                     _v144260_
                     _at144267_
                     _u144295_
                     _start144294_
                     _end144293_)
                    (_lp144264_
                     _rest144292_
                     (fx+ _at144267_ (fx- _end144293_ _start144294_))))))
            (if (let () (declare (not safe)) (##pair? _rest144269144281_))
                (let ((_hd144274144301_
                       (let ()
                         (declare (not safe))
                         (##car _rest144269144281_)))
                      (_tl144275144303_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest144269144281_))))
                  (let ((_u144306_ _hd144274144301_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl144275144303_))
                        (let ((_hd144276144308_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl144275144303_)))
                              (_tl144277144310_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl144275144303_))))
                          (let ((_start144313_ _hd144276144308_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl144277144310_))
                                (let ((_hd144278144315_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl144277144310_)))
                                      (_tl144279144317_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl144277144310_))))
                                  (let* ((_end144320_ _hd144278144315_)
                                         (_rest144322_ _tl144279144317_))
                                    (_K144273144298_
                                     _rest144322_
                                     _end144320_
                                     _start144313_
                                     _u144306_)))
                                (_else144271144289_))))
                        (_else144271144289_))))
                (_else144271144289_)))))))
  (define std/srfi/160/u64#u64vector-empty?
    (lambda (_v144193_) (fxzero? (u64vector-length _v144193_))))
  (define std/srfi/160/u64#u64vector=
    (lambda (_v144135_ . _args144137_)
      (declare (not safe))
      (begin
        (if (u64vector? _v144135_) '#!void (error '"Bad argument" _v144135_))
        (let ((_vlen144141_ (u64vector-length _v144135_)))
          (let _lp144144_ ((_rest144147_ _args144137_))
            (let* ((_rest144149144157_ _rest144147_)
                   (_else144151144165_ (lambda () '#t))
                   (_K144153144181_
                    (lambda (_rest144168_ _u144169_)
                      (if (u64vector? _u144169_)
                          '#!void
                          (error '"Bad argument" _u144169_))
                      (let ((_ulen144172_ (u64vector-length _u144169_)))
                        (if (fx= _vlen144141_ _ulen144172_)
                            (let _cmp144175_ ((_i144178_ '0))
                              (if (fx< _i144178_ _vlen144141_)
                                  (if (= (u64vector-ref _v144135_ _i144178_)
                                         (u64vector-ref _u144169_ _i144178_))
                                      (_cmp144175_ (fx+ _i144178_ '1))
                                      '#f)
                                  (_lp144144_ _rest144168_)))
                            '#f)))))
              (if (##pair? _rest144149144157_)
                  (let ((_hd144154144184_ (##car _rest144149144157_))
                        (_tl144155144186_ (##cdr _rest144149144157_)))
                    (let* ((_u144189_ _hd144154144184_)
                           (_rest144191_ _tl144155144186_))
                      (_K144153144181_ _rest144191_ _u144189_)))
                  (_else144151144165_))))))))
  (define std/srfi/160/u64#u64vector-take
    (lambda (_v144127_ _n144129_)
      (let ((_u144132_ (make-u64vector _n144129_)))
        (std/srfi/160/u64#u64vector-copy! _u144132_ '0 _v144127_ '0 _n144129_)
        _u144132_)))
  (define std/srfi/160/u64#u64vector-take-right
    (lambda (_v144112_ _n144114_)
      (let* ((_vlen144117_ (u64vector-length _v144112_))
             (_ulen144120_ (fx- _vlen144117_ _n144114_))
             (_u144123_ (make-u64vector _ulen144120_)))
        (std/srfi/160/u64#u64vector-copy!
         _u144123_
         '0
         _v144112_
         _n144114_
         _vlen144117_)
        _u144123_)))
  (define std/srfi/160/u64#u64vector-drop
    (lambda (_v144097_ _n144099_)
      (let* ((_vlen144102_ (u64vector-length _v144097_))
             (_ulen144105_ (fx- _vlen144102_ _n144099_))
             (_u144108_ (make-u64vector _ulen144105_)))
        (std/srfi/160/u64#u64vector-copy!
         _u144108_
         '0
         _v144097_
         _n144099_
         _vlen144102_)
        _u144108_)))
  (define std/srfi/160/u64#u64vector-drop-right
    (lambda (_v144082_ _n144084_)
      (let* ((_vlen144087_ (u64vector-length _v144082_))
             (_ulen144090_ (fx- _vlen144087_ _n144084_))
             (_u144093_ (make-u64vector _ulen144090_)))
        (std/srfi/160/u64#u64vector-copy!
         _u144093_
         '0
         _v144082_
         '0
         _ulen144090_)
        _u144093_)))
  (define std/srfi/160/u64#u64vector-segment
    (lambda (_v144064_ _n144066_)
      (let _lp144069_ ((_i144072_ '0)
                       (_rest144074_ (u64vector-length _v144064_))
                       (_r144076_ '()))
        (if (fx> _r144076_ '0)
            (let ((_size144079_ (fxmin _n144066_ _rest144074_)))
              (_lp144069_
               (fx+ _i144072_ _size144079_)
               (fx- _rest144074_ _size144079_)
               (cons (std/srfi/160/u64#u64vector-copy__%
                      _v144064_
                      _i144072_
                      (fx+ _i144072_ _size144079_))
                     _r144076_)))
            (reverse _r144076_)))))
  (define std/srfi/160/u64#u64vector-fold__0
    (lambda (_kons144024_ _knil144026_ _v144028_)
      (if (procedure? _kons144024_)
          '#!void
          (error '"Bad argument; expected procedure" _kons144024_))
      (let ((_end144031_ (u64vector-length _v144028_)))
        (declare (not safe))
        (let _lp144035_ ((_i144038_ '0) (_r144040_ _knil144026_))
          (if (fx< _i144038_ _end144031_)
              (_lp144035_
               (fx+ _i144038_ '1)
               (_kons144024_ _r144040_ (u64vector-ref _v144028_ _i144038_)))
              _r144040_)))))
  (define std/srfi/160/u64#u64vector-fold__1
    (lambda (_kons144043_ _knil144044_ _v144045_ . _vs144046_)
      (if (procedure? _kons144043_)
          '#!void
          (error '"Bad argument; expected procedure" _kons144043_))
      (let* ((_vs144049_ (cons _v144045_ _vs144046_))
             (_end144051_ (apply fxmin (map u64vector-length _vs144049_))))
        (declare (not safe))
        (let _lp144055_ ((_i144057_ '0) (_r144058_ _knil144044_))
          (if (fx< _i144057_ _end144051_)
              (_lp144055_
               (fx+ _i144057_ '1)
               (apply _kons144043_
                      _r144058_
                      (map (lambda (_g144059144061_)
                             (u64vector-ref _g144059144061_ _i144057_))
                           _vs144049_)))
              _r144058_)))))
  (define std/srfi/160/u64#u64vector-fold
    (lambda _g299257_
      (let ((_g299256_ (let () (declare (not safe)) (##length _g299257_))))
        (cond ((let () (declare (not safe)) (##fx= _g299256_ 3))
               (apply std/srfi/160/u64#u64vector-fold__0 _g299257_))
              ((let () (declare (not safe)) (##fx>= _g299256_ 3))
               (apply std/srfi/160/u64#u64vector-fold__1 _g299257_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-fold
                _g299257_))))))
  (define std/srfi/160/u64#u64vector-fold-right__0
    (lambda (_kons143984_ _knil143986_ _v143988_)
      (if (procedure? _kons143984_)
          '#!void
          (error '"Bad argument; expected procedure" _kons143984_))
      (let ((_last143991_ (fx- (u64vector-length _v143988_) '1)))
        (declare (not safe))
        (let _lp143995_ ((_i143998_ _last143991_) (_r144000_ _knil143986_))
          (if (fx>= _i143998_ '0)
              (_lp143995_
               (fx- _i143998_ '1)
               (_kons143984_ _r144000_ (u64vector-ref _v143988_ _i143998_)))
              _r144000_)))))
  (define std/srfi/160/u64#u64vector-fold-right__1
    (lambda (_kons144003_ _knil144004_ _v144005_ . _vs144006_)
      (if (procedure? _kons144003_)
          '#!void
          (error '"Bad argument; expected procedure" _kons144003_))
      (let* ((_vs144009_ (cons _v144005_ _vs144006_))
             (_last144011_
              (fx- (apply min (map u64vector-length _vs144009_)) '1)))
        (declare (not safe))
        (let _lp144015_ ((_i144017_ _last144011_) (_r144018_ _knil144004_))
          (if (fx>= _i144017_ '0)
              (_lp144015_
               (fx- _i144017_ '1)
               (apply _kons144003_
                      _r144018_
                      (map (lambda (_g144019144021_)
                             (u64vector-ref _g144019144021_ _i144017_))
                           _vs144009_)))
              _r144018_)))))
  (define std/srfi/160/u64#u64vector-fold-right
    (lambda _g299259_
      (let ((_g299258_ (let () (declare (not safe)) (##length _g299259_))))
        (cond ((let () (declare (not safe)) (##fx= _g299258_ 3))
               (apply std/srfi/160/u64#u64vector-fold-right__0 _g299259_))
              ((let () (declare (not safe)) (##fx>= _g299258_ 3))
               (apply std/srfi/160/u64#u64vector-fold-right__1 _g299259_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-fold-right
                _g299259_))))))
  (define std/srfi/160/u64#u64vector-map__0
    (lambda (_f143944_ _v143946_)
      (if (procedure? _f143944_)
          '#!void
          (error '"Bad argument; expected procedure" _f143944_))
      (let* ((_len143949_ (u64vector-length _v143946_))
             (_u143952_ (make-u64vector _len143949_)))
        (declare (not safe))
        (let _lp143957_ ((_i143960_ '0))
          (if (fx< _i143960_ _len143949_)
              (begin
                (u64vector-set!
                 _u143952_
                 _i143960_
                 (u64vector-ref _v143946_ _i143960_))
                (_lp143957_ (fx+ _i143960_ '1)))
              _u143952_)))))
  (define std/srfi/160/u64#u64vector-map__1
    (lambda (_f143963_ _v143964_ . _vs143965_)
      (if (procedure? _f143963_)
          '#!void
          (error '"Bad argument; expected procedure" _f143963_))
      (let* ((_vs143968_ (cons _v143964_ _vs143965_))
             (_len143970_ (apply fxmin (map u64vector-length _vs143968_)))
             (_u143972_ (make-u64vector _len143970_)))
        (declare (not safe))
        (let _lp143976_ ((_i143978_ '0))
          (if (fx< _i143978_ _len143970_)
              (begin
                (u64vector-set!
                 _u143972_
                 _i143978_
                 (apply _f143963_
                        (map (lambda (_g143979143981_)
                               (u64vector-ref _g143979143981_ _i143978_))
                             _vs143968_)))
                (_lp143976_ (fx+ _i143978_ '1)))
              _u143972_)))))
  (define std/srfi/160/u64#u64vector-map
    (lambda _g299261_
      (let ((_g299260_ (let () (declare (not safe)) (##length _g299261_))))
        (cond ((let () (declare (not safe)) (##fx= _g299260_ 2))
               (apply std/srfi/160/u64#u64vector-map__0 _g299261_))
              ((let () (declare (not safe)) (##fx>= _g299260_ 2))
               (apply std/srfi/160/u64#u64vector-map__1 _g299261_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-map
                _g299261_))))))
  (define std/srfi/160/u64#u64vector-map!__0
    (lambda (_f143910_ _v143912_)
      (if (procedure? _f143910_)
          '#!void
          (error '"Bad argument; expected procedure" _f143910_))
      (let ((_len143915_ (u64vector-length _v143912_)))
        (declare (not safe))
        (let _lp143919_ ((_i143922_ '0))
          (if (fx< _i143922_ _len143915_)
              (begin
                (u64vector-set!
                 _v143912_
                 _i143922_
                 (_f143910_ (u64vector-ref _v143912_ _i143922_)))
                (_lp143919_ (fx+ _i143922_ '1)))
              _v143912_)))))
  (define std/srfi/160/u64#u64vector-map!__1
    (lambda (_f143925_ _v143926_ . _vs143927_)
      (if (procedure? _f143925_)
          '#!void
          (error '"Bad argument; expected procedure" _f143925_))
      (let* ((_vs143930_ (cons _v143926_ _vs143927_))
             (_len143932_ (apply fxmin (map u64vector-length _vs143930_))))
        (declare (not safe))
        (let _lp143936_ ((_i143938_ '0))
          (if (fx< _i143938_ _len143932_)
              (begin
                (u64vector-set!
                 _v143926_
                 _i143938_
                 (apply _f143925_
                        (map (lambda (_g143939143941_)
                               (u64vector-ref _g143939143941_ _i143938_))
                             _vs143930_)))
                (_lp143936_ (fx+ _i143938_ '1)))
              _v143926_)))))
  (define std/srfi/160/u64#u64vector-map!
    (lambda _g299263_
      (let ((_g299262_ (let () (declare (not safe)) (##length _g299263_))))
        (cond ((let () (declare (not safe)) (##fx= _g299262_ 2))
               (apply std/srfi/160/u64#u64vector-map!__0 _g299263_))
              ((let () (declare (not safe)) (##fx>= _g299262_ 2))
               (apply std/srfi/160/u64#u64vector-map!__1 _g299263_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-map!
                _g299263_))))))
  (define std/srfi/160/u64#u64vector-for-each__0
    (lambda (_f143876_ _v143878_)
      (if (procedure? _f143876_)
          '#!void
          (error '"Bad argument; expected procedure" _f143876_))
      (let ((_len143881_ (u64vector-length _v143878_)))
        (declare (not safe))
        (let _lp143885_ ((_i143888_ '0))
          (if (fx< _i143888_ _len143881_)
              (begin
                (_f143876_ (u64vector-ref _v143878_ _i143888_))
                (_lp143885_ (fx+ _i143888_ '1)))
              '#!void)))))
  (define std/srfi/160/u64#u64vector-for-each__1
    (lambda (_f143891_ _v143892_ . _vs143893_)
      (let* ((_vs143896_ (cons _v143892_ _vs143893_))
             (_len143898_ (apply fxmin (map u64vector-length _vs143896_))))
        (declare (not safe))
        (let _lp143902_ ((_i143904_ '0))
          (if (fx< _i143904_ _len143898_)
              (begin
                (apply _f143891_
                       (map (lambda (_g143905143907_)
                              (u64vector-ref _g143905143907_ _i143904_))
                            _vs143896_))
                (_lp143902_ (fx+ _i143904_ '1)))
              '#!void)))))
  (define std/srfi/160/u64#u64vector-for-each
    (lambda _g299265_
      (let ((_g299264_ (let () (declare (not safe)) (##length _g299265_))))
        (cond ((let () (declare (not safe)) (##fx= _g299264_ 2))
               (apply std/srfi/160/u64#u64vector-for-each__0 _g299265_))
              ((let () (declare (not safe)) (##fx>= _g299264_ 2))
               (apply std/srfi/160/u64#u64vector-for-each__1 _g299265_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-for-each
                _g299265_))))))
  (define std/srfi/160/u64#u64vector-count__0
    (lambda (_pred143839_ _v143841_)
      (if (procedure? _pred143839_)
          '#!void
          (error '"Bad argument; expected procedure" _pred143839_))
      (let ((_end143844_ (u64vector-length _v143841_)))
        (declare (not safe))
        (let _lp143848_ ((_i143851_ '0) (_r143853_ '0))
          (if (fx< _i143851_ _end143844_)
              (if (_pred143839_ (u64vector-ref _v143841_ _i143851_))
                  (_lp143848_ (fx+ _i143851_ '1) (fx+ _r143853_ '1))
                  (_lp143848_ (fx+ _i143851_ '1) _r143853_))
              _r143853_)))))
  (define std/srfi/160/u64#u64vector-count__1
    (lambda (_pred143856_ _v143857_ . _vs143858_)
      (if (procedure? _pred143856_)
          '#!void
          (error '"Bad argument; expected procedure" _pred143856_))
      (let* ((_vs143861_ (cons _v143857_ _vs143858_))
             (_end143863_ (apply fxmin (map u64vector-length _vs143861_))))
        (declare (not safe))
        (let _lp143867_ ((_i143869_ '0) (_r143870_ '0))
          (if (fx< _i143869_ _end143863_)
              (if (apply _pred143856_
                         (map (lambda (_g143871143873_)
                                (u64vector-ref _g143871143873_ _i143869_))
                              _vs143861_))
                  (_lp143867_ (fx+ _i143869_ '1) (fx+ _r143870_ '1))
                  (_lp143867_ (fx+ _i143869_ '1) _r143870_))
              _r143870_)))))
  (define std/srfi/160/u64#u64vector-count
    (lambda _g299267_
      (let ((_g299266_ (let () (declare (not safe)) (##length _g299267_))))
        (cond ((let () (declare (not safe)) (##fx= _g299266_ 2))
               (apply std/srfi/160/u64#u64vector-count__0 _g299267_))
              ((let () (declare (not safe)) (##fx>= _g299266_ 2))
               (apply std/srfi/160/u64#u64vector-count__1 _g299267_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-count
                _g299267_))))))
  (define std/srfi/160/u64#u64vector-cumulate
    (lambda (_f143814_ _knil143816_ _v143818_)
      (if (procedure? _f143814_)
          '#!void
          (error '"Bad argument; expected procedure" _f143814_))
      (let* ((_len143821_ (u64vector-length _v143818_))
             (_r143824_ (make-u64vector _len143821_)))
        (declare (not safe))
        (let _lp143829_ ((_i143832_ '0) (_r143834_ _knil143816_))
          (if (fx< _i143832_ _len143821_)
              (let ((_next143836_
                     (_f143814_
                      _r143834_
                      (u64vector-ref _v143818_ _i143832_))))
                (u64vector-set! _v143818_ _i143832_ _next143836_)
                (_lp143829_ (fx+ _i143832_ '1) _next143836_))
              _v143818_)))))
  (define std/srfi/160/u64#u64vector-take-while
    (lambda (_pred143797_ _v143799_)
      (let* ((_len143802_ (u64vector-length _v143799_))
             (_idx143805_
              (std/srfi/160/u64#u64vector-skip__0 _pred143797_ _v143799_))
             (_idx143811_
              (let ((_$e143808_ _idx143805_))
                (if _$e143808_ _$e143808_ _len143802_))))
        (std/srfi/160/u64#u64vector-copy__% _v143799_ '0 _idx143811_))))
  (define std/srfi/160/u64#u64vector-take-while-right
    (lambda (_pred143783_ _v143785_)
      (let* ((_len143788_ (u64vector-length _v143785_))
             (_idx143791_
              (std/srfi/160/u64#u64vector-skip-right__0
               _pred143783_
               _v143785_))
             (_idx143794_ (if _idx143791_ (fx+ _idx143791_ '1) '0)))
        (std/srfi/160/u64#u64vector-copy__%
         _v143785_
         _idx143794_
         _len143788_))))
  (define std/srfi/160/u64#u64vector-drop-while
    (lambda (_pred143766_ _v143768_)
      (let* ((_len143771_ (u64vector-length _v143768_))
             (_idx143774_
              (std/srfi/160/u64#u64vector-skip__0 _pred143766_ _v143768_))
             (_idx143780_
              (let ((_$e143777_ _idx143774_))
                (if _$e143777_ _$e143777_ _len143771_))))
        (std/srfi/160/u64#u64vector-copy__%
         _v143768_
         _idx143780_
         _len143771_))))
  (define std/srfi/160/u64#u64vector-drop-while-right
    (lambda (_pred143752_ _v143754_)
      (let* ((_len143757_ (u64vector-length _v143754_))
             (_idx143760_
              (std/srfi/160/u64#u64vector-skip-right__0
               _pred143752_
               _v143754_))
             (_idx143763_ (if _idx143760_ (fx+ _idx143760_ '1) '0)))
        (std/srfi/160/u64#u64vector-copy__% _v143754_ '0 _idx143763_))))
  (define std/srfi/160/u64#u64vector-index__0
    (lambda (_pred143718_ _v143720_)
      (if (procedure? _pred143718_)
          '#!void
          (error '"Bad argument; expected procedure" _pred143718_))
      (let ((_end143723_ (u64vector-length _v143720_)))
        (declare (not safe))
        (let _lp143727_ ((_i143730_ '0))
          (if (fx< _i143730_ _end143723_)
              (if (_pred143718_ (u64vector-ref _v143720_ _i143730_))
                  _i143730_
                  (_lp143727_ (fx+ _i143730_ '1)))
              '#f)))))
  (define std/srfi/160/u64#u64vector-index__1
    (lambda (_pred143733_ _v143734_ . _vs143735_)
      (if (procedure? _pred143733_)
          '#!void
          (error '"Bad argument; expected procedure" _pred143733_))
      (let* ((_vs143738_ (cons _v143734_ _vs143735_))
             (_end143740_ (apply fxmin (map u64vector-length _vs143738_))))
        (declare (not safe))
        (let _lp143744_ ((_i143746_ '0))
          (if (fx< _i143746_ _end143740_)
              (if (apply _pred143733_
                         (map (lambda (_g143747143749_)
                                (u64vector-ref _g143747143749_ _i143746_))
                              _vs143738_))
                  _i143746_
                  (_lp143744_ (fx+ _i143746_ '1)))
              '#f)))))
  (define std/srfi/160/u64#u64vector-index
    (lambda _g299269_
      (let ((_g299268_ (let () (declare (not safe)) (##length _g299269_))))
        (cond ((let () (declare (not safe)) (##fx= _g299268_ 2))
               (apply std/srfi/160/u64#u64vector-index__0 _g299269_))
              ((let () (declare (not safe)) (##fx>= _g299268_ 2))
               (apply std/srfi/160/u64#u64vector-index__1 _g299269_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-index
                _g299269_))))))
  (define std/srfi/160/u64#u64vector-index-right__0
    (lambda (_pred143684_ _v143686_)
      (if (procedure? _pred143684_)
          '#!void
          (error '"Bad argument; expected procedure" _pred143684_))
      (let ((_start143689_ (fx- (u64vector-length _v143686_) '1)))
        (declare (not safe))
        (let _lp143693_ ((_i143696_ _start143689_))
          (if (fx>= _i143696_ '0)
              (if (_pred143684_ (u64vector-ref _v143686_ _i143696_))
                  _i143696_
                  (_lp143693_ (fx- _i143696_ '1)))
              '#f)))))
  (define std/srfi/160/u64#u64vector-index-right__1
    (lambda (_pred143699_ _v143700_ . _vs143701_)
      (if (procedure? _pred143699_)
          '#!void
          (error '"Bad argument; expected procedure" _pred143699_))
      (let* ((_vs143704_ (cons _v143700_ _vs143701_))
             (_start143706_
              (fx- (apply fxmin (map u64vector-length _vs143704_)) '1)))
        (declare (not safe))
        (let _lp143710_ ((_i143712_ _start143706_))
          (if (fx>= _i143712_ '0)
              (if (apply _pred143699_
                         (map (lambda (_g143713143715_)
                                (u64vector-ref _g143713143715_ _i143712_))
                              _vs143704_))
                  _i143712_
                  (_lp143710_ (fx- _i143712_ '1)))
              '#f)))))
  (define std/srfi/160/u64#u64vector-index-right
    (lambda _g299271_
      (let ((_g299270_ (let () (declare (not safe)) (##length _g299271_))))
        (cond ((let () (declare (not safe)) (##fx= _g299270_ 2))
               (apply std/srfi/160/u64#u64vector-index-right__0 _g299271_))
              ((let () (declare (not safe)) (##fx>= _g299270_ 2))
               (apply std/srfi/160/u64#u64vector-index-right__1 _g299271_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-index-right
                _g299271_))))))
  (define std/srfi/160/u64#u64vector-skip__0
    (lambda (_pred143668_ _v143670_)
      (std/srfi/160/u64#u64vector-index__0
       (lambda (_$obj143673_) (not (_pred143668_ _$obj143673_)))
       _v143670_)))
  (define std/srfi/160/u64#u64vector-skip__1
    (lambda (_pred143676_ _v143677_ . _vs143678_)
      (apply std/srfi/160/u64#u64vector-index
             (lambda (_$obj143681_) (not (_pred143676_ _$obj143681_)))
             _v143677_
             _vs143678_)))
  (define std/srfi/160/u64#u64vector-skip
    (lambda _g299273_
      (let ((_g299272_ (let () (declare (not safe)) (##length _g299273_))))
        (cond ((let () (declare (not safe)) (##fx= _g299272_ 2))
               (apply std/srfi/160/u64#u64vector-skip__0 _g299273_))
              ((let () (declare (not safe)) (##fx>= _g299272_ 2))
               (apply std/srfi/160/u64#u64vector-skip__1 _g299273_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-skip
                _g299273_))))))
  (define std/srfi/160/u64#u64vector-skip-right__0
    (lambda (_pred143652_ _v143654_)
      (std/srfi/160/u64#u64vector-index-right__0
       (lambda (_$obj143657_) (not (_pred143652_ _$obj143657_)))
       _v143654_)))
  (define std/srfi/160/u64#u64vector-skip-right__1
    (lambda (_pred143660_ _v143661_ . _vs143662_)
      (apply std/srfi/160/u64#u64vector-index-right
             (lambda (_$obj143665_) (not (_pred143660_ _$obj143665_)))
             _v143661_
             _vs143662_)))
  (define std/srfi/160/u64#u64vector-skip-right
    (lambda _g299275_
      (let ((_g299274_ (let () (declare (not safe)) (##length _g299275_))))
        (cond ((let () (declare (not safe)) (##fx= _g299274_ 2))
               (apply std/srfi/160/u64#u64vector-skip-right__0 _g299275_))
              ((let () (declare (not safe)) (##fx>= _g299274_ 2))
               (apply std/srfi/160/u64#u64vector-skip-right__1 _g299275_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-skip-right
                _g299275_))))))
  (define std/srfi/160/u64#u64vector-any__0
    (lambda (_pred143612_ _v143614_)
      (if (procedure? _pred143612_)
          '#!void
          (error '"Bad argument; expected procedure" _pred143612_))
      (let ((_end143617_ (u64vector-length _v143614_)))
        (declare (not safe))
        (let _lp143621_ ((_i143624_ '0))
          (if (fx< _i143624_ _end143617_)
              (let ((_$e143627_
                     (_pred143612_ (u64vector-ref _v143614_ _i143624_))))
                (if _$e143627_
                    (values _$e143627_)
                    (_lp143621_ (fx+ _i143624_ '1))))
              '#f)))))
  (define std/srfi/160/u64#u64vector-any__1
    (lambda (_pred143630_ _v143631_ . _vs143632_)
      (if (procedure? _pred143630_)
          '#!void
          (error '"Bad argument; expected procedure" _pred143630_))
      (let* ((_v143635_ (cons _v143631_ _vs143632_))
             (_end143637_ (apply fxmin (map u64vector-length _vs143632_))))
        (declare (not safe))
        (let _lp143641_ ((_i143643_ '0))
          (if (fx< _i143643_ _end143637_)
              (let ((_$e143649_
                     (apply _pred143630_
                            (map (lambda (_g143644143646_)
                                   (u64vector-ref _g143644143646_ _i143643_))
                                 _vs143632_))))
                (if _$e143649_
                    (values _$e143649_)
                    (_lp143641_ (fx+ _i143643_ '1))))
              '#f)))))
  (define std/srfi/160/u64#u64vector-any
    (lambda _g299277_
      (let ((_g299276_ (let () (declare (not safe)) (##length _g299277_))))
        (cond ((let () (declare (not safe)) (##fx= _g299276_ 2))
               (apply std/srfi/160/u64#u64vector-any__0 _g299277_))
              ((let () (declare (not safe)) (##fx>= _g299276_ 2))
               (apply std/srfi/160/u64#u64vector-any__1 _g299277_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-any
                _g299277_))))))
  (define std/srfi/160/u64#u64vector-every__0
    (lambda (_pred143561_ _v143563_)
      (if (procedure? _pred143561_)
          '#!void
          (error '"Bad argument; expected procedure" _pred143561_))
      (let ((_end143566_ (u64vector-length _v143563_)))
        (declare (not safe))
        (let _lp143570_ ((_i143573_ '0) (_r143575_ '#t))
          (if (fx< _i143573_ _end143566_)
              (let ((_$e143578_
                     (_pred143561_ (u64vector-ref _v143563_ _i143573_))))
                (if _$e143578_
                    ((lambda (_g143580143582_)
                       (_lp143570_ (fx+ _i143573_ '1) _g143580143582_))
                     _$e143578_)
                    '#f))
              _r143575_)))))
  (define std/srfi/160/u64#u64vector-every__1
    (lambda (_pred143585_ _v143586_ . _vs143587_)
      (if (procedure? _pred143585_)
          '#!void
          (error '"Bad argument; expected procedure" _pred143585_))
      (let* ((_v143590_ (cons _v143586_ _vs143587_))
             (_end143592_ (apply fxmin (map u64vector-length _vs143587_))))
        (declare (not safe))
        (let _lp143596_ ((_i143598_ '0) (_r143599_ '#t))
          (if (fx< _i143598_ _end143592_)
              (let ((_$e143605_
                     (apply _pred143585_
                            (map (lambda (_g143600143602_)
                                   (u64vector-ref _g143600143602_ _i143598_))
                                 _vs143587_))))
                (if _$e143605_
                    ((lambda (_g143607143609_)
                       (_lp143596_ (fx+ _i143598_ '1) _g143607143609_))
                     _$e143605_)
                    '#f))
              _r143599_)))))
  (define std/srfi/160/u64#u64vector-every
    (lambda _g299279_
      (let ((_g299278_ (let () (declare (not safe)) (##length _g299279_))))
        (cond ((let () (declare (not safe)) (##fx= _g299278_ 2))
               (apply std/srfi/160/u64#u64vector-every__0 _g299279_))
              ((let () (declare (not safe)) (##fx>= _g299278_ 2))
               (apply std/srfi/160/u64#u64vector-every__1 _g299279_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-every
                _g299279_))))))
  (define std/srfi/160/u64#u64vector-partition
    (lambda (_pred143532_ _v143534_)
      (let* ((_count143537_
              (std/srfi/160/u64#u64vector-count__0 _pred143532_ _v143534_))
             (_len143540_ (u64vector-length _v143534_))
             (_u143543_ (make-u64vector _len143540_)))
        (declare (not safe))
        (let _lp143548_ ((_i143551_ '0)
                         (_left143553_ '0)
                         (_right143555_ _count143537_))
          (if (fx< _i143551_ _len143540_)
              (let ((_x143558_ (u64vector-ref _v143534_ _i143551_)))
                (if (_pred143532_ _x143558_)
                    (begin
                      (u64vector-set! _u143543_ _left143553_ _x143558_)
                      (_lp143548_
                       (fx+ _i143551_ '1)
                       (fx+ _left143553_ '1)
                       _right143555_))
                    (begin
                      (u64vector-set! _u143543_ _right143555_ _x143558_)
                      (_lp143548_
                       (fx+ _i143551_ '1)
                       _left143553_
                       (fx+ _right143555_ '1)))))
              _u143543_)))))
  (define std/srfi/160/u64#u64vector-filter
    (lambda (_pred143505_ _v143507_)
      (let* ((_count143510_
              (std/srfi/160/u64#u64vector-count__0 _pred143505_ _v143507_))
             (_u143513_ (make-u64vector _count143510_))
             (_end143516_ (u64vector-length _v143507_)))
        (declare (not safe))
        (let _lp143521_ ((_i143524_ '0) (_j143526_ '0))
          (if (fx< _i143524_ _end143516_)
              (let ((_x143529_ (u64vector-ref _v143507_ _i143524_)))
                (if (_pred143505_ _x143529_)
                    (begin
                      (u64vector-set! _u143513_ _j143526_ _x143529_)
                      (_lp143521_ (fx+ _i143524_ '1) (fx+ _j143526_ '1)))
                    (_lp143521_ (fx+ _i143524_ '1) _j143526_)))
              _u143513_)))))
  (define std/srfi/160/u64#u64vector-remove
    (lambda (_pred143497_ _v143499_)
      (std/srfi/160/u64#u64vector-filter
       (lambda (_$obj143502_) (not (_pred143497_ _$obj143502_)))
       _v143499_)))
  (define std/srfi/160/u64#u64vector-swap
    (lambda (_v143484_ _i143486_ _j143488_)
      (let ((_iv143491_ (u64vector-ref _v143484_ _i143486_))
            (_jv143493_ (u64vector-ref _v143484_ _j143488_)))
        (declare (not safe))
        (begin
          (u64vector-set! _v143484_ _i143486_ _jv143493_)
          (u64vector-set! _v143484_ _j143488_ _iv143491_)))))
  (define std/srfi/160/u64#u64vector-fill!__%
    (lambda (_v143447_ _fill143449_ _start143451_ _end143453_)
      (declare (not safe))
      (begin
        (if (u64vector? _v143447_) '#!void (error '"Bad argument" _v143447_))
        (if (std/srfi/160/base#u64? _fill143449_)
            '#!void
            (error '"Bad argument" _fill143449_))
        (if (and (fixnum? _start143451_)
                 (fx<= '0 _start143451_ (fx- (u64vector-length _v143447_) '1)))
            '#!void
            (error '"Index out of range" _start143451_))
        (if (and (fixnum? _end143453_)
                 (fx<= _start143451_ _end143453_ (u64vector-length _v143447_)))
            '#!void
            (error '"Index out of range" _end143453_))
        (let _lp143457_ ((_i143460_ _start143451_))
          (if (fx< _i143460_ _end143453_)
              (begin
                (u64vector-set! _v143447_ _i143460_ _fill143449_)
                (_lp143457_ (fx+ _i143460_ '1)))
              '#!void)))))
  (define std/srfi/160/u64#u64vector-fill!__0
    (lambda (_v143466_ _fill143467_)
      (let* ((_start143469_ '0) (_end143471_ (u64vector-length _v143466_)))
        (std/srfi/160/u64#u64vector-fill!__%
         _v143466_
         _fill143467_
         _start143469_
         _end143471_))))
  (define std/srfi/160/u64#u64vector-fill!__1
    (lambda (_v143473_ _fill143474_ _start143475_)
      (let ((_end143477_ (u64vector-length _v143473_)))
        (std/srfi/160/u64#u64vector-fill!__%
         _v143473_
         _fill143474_
         _start143475_
         _end143477_))))
  (define std/srfi/160/u64#u64vector-fill!
    (lambda _g299281_
      (let ((_g299280_ (let () (declare (not safe)) (##length _g299281_))))
        (cond ((let () (declare (not safe)) (##fx= _g299280_ 2))
               (apply std/srfi/160/u64#u64vector-fill!__0 _g299281_))
              ((let () (declare (not safe)) (##fx= _g299280_ 3))
               (apply std/srfi/160/u64#u64vector-fill!__1 _g299281_))
              ((let () (declare (not safe)) (##fx= _g299280_ 4))
               (apply std/srfi/160/u64#u64vector-fill!__% _g299281_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-fill!
                _g299281_))))))
  (define std/srfi/160/u64#u64vector-reverse!__%
    (lambda (_v143407_ _start143409_ _end143411_)
      (declare (not safe))
      (begin
        (if (u64vector? _v143407_) '#!void (error '"Bad argument" _v143407_))
        (if (and (fixnum? _start143409_)
                 (fx<= '0 _start143409_ (fx- (u64vector-length _v143407_) '1)))
            '#!void
            (error '"Index out of range" _start143409_))
        (if (and (fixnum? _end143411_)
                 (fx<= _start143409_ _end143411_ (u64vector-length _v143407_)))
            '#!void
            (error '"Index out of range" _end143411_))
        (let _lp143415_ ((_i143418_ _start143409_)
                         (_j143420_ (fx- _end143411_ '1)))
          (if (fx< _i143418_ _j143420_)
              (let ((_iv143423_ (u64vector-ref _v143407_ _i143418_))
                    (_jv143425_ (u64vector-ref _v143407_ _j143420_)))
                (u64vector-set! _v143407_ _i143418_ _jv143425_)
                (u64vector-set! _v143407_ _j143420_ _iv143423_)
                (_lp143415_ (fx+ _i143418_ '1) (fx- _j143420_ '1)))
              '#!void)))))
  (define std/srfi/160/u64#u64vector-reverse!__0
    (lambda (_v143431_)
      (let* ((_start143433_ '0) (_end143435_ (u64vector-length _v143431_)))
        (std/srfi/160/u64#u64vector-reverse!__%
         _v143431_
         _start143433_
         _end143435_))))
  (define std/srfi/160/u64#u64vector-reverse!__1
    (lambda (_v143437_ _start143438_)
      (let ((_end143440_ (u64vector-length _v143437_)))
        (std/srfi/160/u64#u64vector-reverse!__%
         _v143437_
         _start143438_
         _end143440_))))
  (define std/srfi/160/u64#u64vector-reverse!
    (lambda _g299283_
      (let ((_g299282_ (let () (declare (not safe)) (##length _g299283_))))
        (cond ((let () (declare (not safe)) (##fx= _g299282_ 1))
               (apply std/srfi/160/u64#u64vector-reverse!__0 _g299283_))
              ((let () (declare (not safe)) (##fx= _g299282_ 2))
               (apply std/srfi/160/u64#u64vector-reverse!__1 _g299283_))
              ((let () (declare (not safe)) (##fx= _g299282_ 3))
               (apply std/srfi/160/u64#u64vector-reverse!__% _g299283_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector-reverse!
                _g299283_))))))
  (define std/srfi/160/u64#u64vector-unfold!
    (lambda (_f143382_ _v143384_ _start143386_ _end143388_ _seed143390_)
      (declare (not safe))
      (begin
        (if (procedure? _f143382_)
            '#!void
            (error '"Bad argument; expected procedure" _f143382_))
        (if (u64vector? _v143384_) '#!void (error '"Bad argument" _v143384_))
        (if (and (fixnum? _start143386_)
                 (fx<= '0 _start143386_ (fx- (u64vector-length _v143384_) '1)))
            '#!void
            (error '"Index out of range" _start143386_))
        (if (and (fixnum? _end143388_)
                 (fx<= _start143386_ _end143388_ (u64vector-length _v143384_)))
            '#!void
            (error '"Index out of range" _end143388_))
        (let _lp143394_ ((_i143397_ _start143386_)
                         (_state143399_ _seed143390_))
          (if (fx< _i143397_ _end143388_)
              (let ((_g299284_ (_f143382_ _state143399_)))
                (begin
                  (let ((_g299285_
                         (if (##values? _g299284_)
                             (##vector-length _g299284_)
                             1)))
                    (if (not (##fx= _g299285_ 2))
                        (error "Context expects 2 values" _g299285_)))
                  (let ((_x143402_ (##vector-ref _g299284_ 0))
                        (_state143404_ (##vector-ref _g299284_ 1)))
                    (begin
                      (u64vector-set! _v143384_ _i143397_ _x143402_)
                      (_lp143394_ (fx+ _i143397_ '1) _state143404_)))))
              '#!void)))))
  (define std/srfi/160/u64#u64vector-unfold-right!
    (lambda (_f143358_ _v143360_ _start143362_ _end143364_ _seed143366_)
      (declare (not safe))
      (begin
        (if (procedure? _f143358_)
            '#!void
            (error '"Bad argument; expected procedure" _f143358_))
        (if (u64vector? _v143360_) '#!void (error '"Bad argument" _v143360_))
        (if (and (fixnum? _start143362_)
                 (fx<= '0 _start143362_ (fx- (u64vector-length _v143360_) '1)))
            '#!void
            (error '"Index out of range" _start143362_))
        (if (and (fixnum? _end143364_)
                 (fx<= _start143362_ _end143364_ (u64vector-length _v143360_)))
            '#!void
            (error '"Index out of range" _end143364_))
        (let _lp143370_ ((_i143373_ (fx- _end143364_ '1))
                         (_state143375_ _seed143366_))
          (if (fx>= _i143373_ _start143362_)
              (let ((_g299286_ (_f143358_ _state143375_)))
                (begin
                  (let ((_g299287_
                         (if (##values? _g299286_)
                             (##vector-length _g299286_)
                             1)))
                    (if (not (##fx= _g299287_ 2))
                        (error "Context expects 2 values" _g299287_)))
                  (let ((_x143378_ (##vector-ref _g299286_ 0))
                        (_state143380_ (##vector-ref _g299286_ 1)))
                    (begin
                      (u64vector-set! _v143360_ _i143373_ _x143378_)
                      (_lp143370_ (fx- _i143373_ '1) _state143380_)))))
              '#!void)))))
  (define std/srfi/160/u64#reverse-u64vector->list__%
    (lambda (_v143324_ _start143326_ _end143328_)
      (declare (not safe))
      (begin
        (if (u64vector? _v143324_) '#!void (error '"Bad argument" _v143324_))
        (if (and (fixnum? _start143326_)
                 (fx<= '0 _start143326_ (fx- (u64vector-length _v143324_) '1)))
            '#!void
            (error '"Index out of range" _start143326_))
        (if (and (fixnum? _end143328_)
                 (fx<= _start143326_ _end143328_ (u64vector-length _v143324_)))
            '#!void
            (error '"Index out of range" _end143328_))
        (let _lp143332_ ((_i143335_ _start143326_) (_r143337_ '()))
          (if (fx< _i143335_ _end143328_)
              (_lp143332_
               (fx+ _i143335_ '1)
               (cons (u64vector-ref _v143324_ _i143335_) _r143337_))
              _r143337_)))))
  (define std/srfi/160/u64#reverse-u64vector->list__0
    (lambda (_v143343_)
      (let* ((_start143345_ '0) (_end143347_ (u64vector-length _v143343_)))
        (std/srfi/160/u64#reverse-u64vector->list__%
         _v143343_
         _start143345_
         _end143347_))))
  (define std/srfi/160/u64#reverse-u64vector->list__1
    (lambda (_v143349_ _start143350_)
      (let ((_end143352_ (u64vector-length _v143349_)))
        (std/srfi/160/u64#reverse-u64vector->list__%
         _v143349_
         _start143350_
         _end143352_))))
  (define std/srfi/160/u64#reverse-u64vector->list
    (lambda _g299289_
      (let ((_g299288_ (let () (declare (not safe)) (##length _g299289_))))
        (cond ((let () (declare (not safe)) (##fx= _g299288_ 1))
               (apply std/srfi/160/u64#reverse-u64vector->list__0 _g299289_))
              ((let () (declare (not safe)) (##fx= _g299288_ 2))
               (apply std/srfi/160/u64#reverse-u64vector->list__1 _g299289_))
              ((let () (declare (not safe)) (##fx= _g299288_ 3))
               (apply std/srfi/160/u64#reverse-u64vector->list__% _g299289_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#reverse-u64vector->list
                _g299289_))))))
  (define std/srfi/160/u64#reverse-list->u64vector
    (lambda (_lst143270_)
      (let* ((_len143273_ (length _lst143270_))
             (_v143276_ (make-u64vector _len143273_)))
        (declare (not safe))
        (let _lp143281_ ((_rest143284_ _lst143270_) (_i143286_ '0))
          (let* ((_rest143288143296_ _rest143284_)
                 (_else143290143304_ (lambda () _v143276_))
                 (_K143292143311_
                  (lambda (_rest143307_ _x143308_)
                    (if (std/srfi/160/base#u64? _x143308_)
                        '#!void
                        (error '"Bad element" _x143308_))
                    (u64vector-set! _v143276_ _i143286_ _x143308_)
                    (_lp143281_ _rest143307_ (fx+ _i143286_ '1)))))
            (if (##pair? _rest143288143296_)
                (let ((_hd143293143314_ (##car _rest143288143296_))
                      (_tl143294143316_ (##cdr _rest143288143296_)))
                  (let* ((_x143319_ _hd143293143314_)
                         (_rest143321_ _tl143294143316_))
                    (_K143292143311_ _rest143321_ _x143319_)))
                (_else143290143304_)))))))
  (define std/srfi/160/u64#u64vector->vector__%
    (lambda (_v143231_ _start143233_ _end143235_)
      (declare (not safe))
      (begin
        (if (u64vector? _v143231_) '#!void (error '"Bad argument" _v143231_))
        (if (and (fixnum? _start143233_)
                 (fx<= '0 _start143233_ (fx- (u64vector-length _v143231_) '1)))
            '#!void
            (error '"Index out of range" _start143233_))
        (if (and (fixnum? _end143235_)
                 (fx<= _start143233_ _end143235_ (u64vector-length _v143231_)))
            '#!void
            (error '"Index out of range" _end143235_))
        (let* ((_len143239_ (u64vector-length _v143231_))
               (_u143242_ (make-vector _len143239_)))
          (let _lp143246_ ((_i143249_ '0))
            (if (fx< _i143249_ _len143239_)
                (begin
                  (vector-set!
                   _u143242_
                   _i143249_
                   (u64vector-ref _v143231_ _i143249_))
                  (_lp143246_ (fx+ _i143249_ '1)))
                _u143242_))))))
  (define std/srfi/160/u64#u64vector->vector__0
    (lambda (_v143255_)
      (let* ((_start143257_ '0) (_end143259_ (u64vector-length _v143255_)))
        (std/srfi/160/u64#u64vector->vector__%
         _v143255_
         _start143257_
         _end143259_))))
  (define std/srfi/160/u64#u64vector->vector__1
    (lambda (_v143261_ _start143262_)
      (let ((_end143264_ (u64vector-length _v143261_)))
        (std/srfi/160/u64#u64vector->vector__%
         _v143261_
         _start143262_
         _end143264_))))
  (define std/srfi/160/u64#u64vector->vector
    (lambda _g299291_
      (let ((_g299290_ (let () (declare (not safe)) (##length _g299291_))))
        (cond ((let () (declare (not safe)) (##fx= _g299290_ 1))
               (apply std/srfi/160/u64#u64vector->vector__0 _g299291_))
              ((let () (declare (not safe)) (##fx= _g299290_ 2))
               (apply std/srfi/160/u64#u64vector->vector__1 _g299291_))
              ((let () (declare (not safe)) (##fx= _g299290_ 3))
               (apply std/srfi/160/u64#u64vector->vector__% _g299291_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#u64vector->vector
                _g299291_))))))
  (define std/srfi/160/u64#vector->u64vector__%
    (lambda (_v143191_ _start143193_ _end143195_)
      (declare (not safe))
      (begin
        (if (vector? _v143191_)
            '#!void
            (error '"Bad argument; expected vector" _v143191_))
        (if (and (fixnum? _start143193_)
                 (fx<= '0 _start143193_ (fx- (vector-length _v143191_) '1)))
            '#!void
            (error '"Index out of range" _start143193_))
        (if (and (fixnum? _end143195_)
                 (fx<= _start143193_ _end143195_ (vector-length _v143191_)))
            '#!void
            (error '"Index out of range" _end143195_))
        (let* ((_len143199_ (vector-length _v143191_))
               (_u143202_ (make-u64vector _len143199_)))
          (let _lp143206_ ((_i143209_ '0))
            (if (fx< _i143209_ _len143199_)
                (begin
                  (u64vector-set!
                   _u143202_
                   _i143209_
                   (vector-ref _v143191_ _i143209_))
                  (_lp143206_ (fx+ _i143209_ '1)))
                _u143202_))))))
  (define std/srfi/160/u64#vector->u64vector__0
    (lambda (_v143215_)
      (let* ((_start143217_ '0) (_end143219_ (vector-length _v143215_)))
        (std/srfi/160/u64#vector->u64vector__%
         _v143215_
         _start143217_
         _end143219_))))
  (define std/srfi/160/u64#vector->u64vector__1
    (lambda (_v143221_ _start143222_)
      (let ((_end143224_ (vector-length _v143221_)))
        (std/srfi/160/u64#vector->u64vector__%
         _v143221_
         _start143222_
         _end143224_))))
  (define std/srfi/160/u64#vector->u64vector
    (lambda _g299293_
      (let ((_g299292_ (let () (declare (not safe)) (##length _g299293_))))
        (cond ((let () (declare (not safe)) (##fx= _g299292_ 1))
               (apply std/srfi/160/u64#vector->u64vector__0 _g299293_))
              ((let () (declare (not safe)) (##fx= _g299292_ 2))
               (apply std/srfi/160/u64#vector->u64vector__1 _g299293_))
              ((let () (declare (not safe)) (##fx= _g299292_ 3))
               (apply std/srfi/160/u64#vector->u64vector__% _g299293_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#vector->u64vector
                _g299293_))))))
  (define std/srfi/160/u64#make-u64vector-generator__%
    (lambda (_v143157_ _start143159_ _end143161_)
      (declare (not safe))
      (begin
        (if (u64vector? _v143157_) '#!void (error '"Bad argument" _v143157_))
        (if (and (fixnum? _start143159_)
                 (fx<= '0 _start143159_ (fx- (u64vector-length _v143157_) '1)))
            '#!void
            (error '"Index out of range" _start143159_))
        (if (and (fixnum? _end143161_)
                 (fx<= _start143159_ _end143161_ (u64vector-length _v143157_)))
            '#!void
            (error '"Index out of range" _end143161_))
        (let ((_i143165_ _start143159_))
          (lambda ()
            (if (fx< _i143165_ _end143161_)
                (let ((_next143169_ (u64vector-ref _v143157_ _i143165_)))
                  (set! _i143165_ (fx+ _i143165_ '1))
                  _next143169_)
                '#!eof))))))
  (define std/srfi/160/u64#make-u64vector-generator__0
    (lambda (_v143175_)
      (let* ((_start143177_ '0) (_end143179_ (u64vector-length _v143175_)))
        (std/srfi/160/u64#make-u64vector-generator__%
         _v143175_
         _start143177_
         _end143179_))))
  (define std/srfi/160/u64#make-u64vector-generator__1
    (lambda (_v143181_ _start143182_)
      (let ((_end143184_ (u64vector-length _v143181_)))
        (std/srfi/160/u64#make-u64vector-generator__%
         _v143181_
         _start143182_
         _end143184_))))
  (define std/srfi/160/u64#make-u64vector-generator
    (lambda _g299295_
      (let ((_g299294_ (let () (declare (not safe)) (##length _g299295_))))
        (cond ((let () (declare (not safe)) (##fx= _g299294_ 1))
               (apply std/srfi/160/u64#make-u64vector-generator__0 _g299295_))
              ((let () (declare (not safe)) (##fx= _g299294_ 2))
               (apply std/srfi/160/u64#make-u64vector-generator__1 _g299295_))
              ((let () (declare (not safe)) (##fx= _g299294_ 3))
               (apply std/srfi/160/u64#make-u64vector-generator__% _g299295_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#make-u64vector-generator
                _g299295_))))))
  (define std/srfi/160/u64#u64vector-comparator
    (let ()
      (letrec ((_<?143128_
                (lambda (_a143131_ _b143133_)
                  (let ((_len-a143136_ (u64vector-length _a143131_))
                        (_len-b143138_ (u64vector-length _b143133_)))
                    (declare (not safe))
                    (if (fx< _len-a143136_ _len-b143138_)
                        '#t
                        (if (fx> _len-a143136_ _len-b143138_)
                            '#f
                            (let ((_end143142_ _len-a143136_))
                              (let _lp143145_ ((_i143148_ '0))
                                (if (fx< _i143148_ _end143142_)
                                    (let ((_x143151_
                                           (u64vector-ref _a143131_ _i143148_))
                                          (_y143153_
                                           (u64vector-ref
                                            _b143133_
                                            _i143148_)))
                                      (if (< _x143151_ _y143153_)
                                          '#t
                                          (if (> _x143151_ _y143153_)
                                              '#f
                                              (_lp143145_
                                               (fx+ _i143148_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           u64vector?
           std/srfi/160/u64#u64vector=
           _<?143128_
           equal?-hash)))))
  (define std/srfi/160/u64#write-u64vector__%
    (lambda (_v143105_ _port143107_)
      (let ((_$e143110_ (find-method _v143105_ ':write)))
        (if _$e143110_
            ((lambda (_g143112143114_)
               (_g143112143114_ _v143105_ _port143107_))
             _$e143110_)
            (write _v143105_ (current-output-port))))))
  (define std/srfi/160/u64#write-u64vector__0
    (lambda (_v143120_)
      (let ((_port143122_ (current-output-port)))
        (std/srfi/160/u64#write-u64vector__% _v143120_ _port143122_))))
  (define std/srfi/160/u64#write-u64vector
    (lambda _g299297_
      (let ((_g299296_ (let () (declare (not safe)) (##length _g299297_))))
        (cond ((let () (declare (not safe)) (##fx= _g299296_ 1))
               (apply std/srfi/160/u64#write-u64vector__0 _g299297_))
              ((let () (declare (not safe)) (##fx= _g299296_ 2))
               (apply std/srfi/160/u64#write-u64vector__% _g299297_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u64#write-u64vector
                _g299297_)))))))
