(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/text/hex#hexes '"0123456789abcdef")
  (define std/text/hex#hex-encode__%
    (lambda (_bytes164605_ _start164606_ _end164607_)
      (let* ((_end164612_
              (let ((_$e164609_ _end164607_))
                (if _$e164609_ _$e164609_ (u8vector-length _bytes164605_))))
             (_len164614_ (fx- _end164612_ _start164606_))
             (_str164616_
              (make-string
               (let () (declare (not safe)) (##fx* '2 _len164614_)))))
        (let _lp164619_ ((_n164621_ '0))
          (if (let () (declare (not safe)) (##fx< _n164621_ _len164614_))
              (let* ((_ix164623_
                      (let ()
                        (declare (not safe))
                        (##fx+ _n164621_ _start164606_)))
                     (_b164625_
                      (let ()
                        (declare (not safe))
                        (##u8vector-ref _bytes164605_ _ix164623_)))
                     (_off164627_
                      (let ()
                        (declare (not safe))
                        (##fxarithmetic-shift _n164621_ '1))))
                (let ((__tmp290270
                       (let ((__tmp290271
                              (let ()
                                (declare (not safe))
                                (##fxarithmetic-shift _b164625_ '-4))))
                         (declare (not safe))
                         (##string-ref std/text/hex#hexes __tmp290271))))
                  (declare (not safe))
                  (##string-set! _str164616_ _off164627_ __tmp290270))
                (let ((__tmp290274
                       (let () (declare (not safe)) (##fx+ _off164627_ '1)))
                      (__tmp290272
                       (let ((__tmp290273
                              (let ()
                                (declare (not safe))
                                (##fxand _b164625_ '15))))
                         (declare (not safe))
                         (##string-ref std/text/hex#hexes __tmp290273))))
                  (declare (not safe))
                  (##string-set! _str164616_ __tmp290274 __tmp290272))
                (_lp164619_
                 (let () (declare (not safe)) (##fx+ _n164621_ '1))))
              _str164616_)))))
  (define std/text/hex#hex-encode__0
    (lambda (_bytes164633_)
      (let* ((_start164635_ '0) (_end164637_ '#f))
        (std/text/hex#hex-encode__% _bytes164633_ _start164635_ _end164637_))))
  (define std/text/hex#hex-encode__1
    (lambda (_bytes164639_ _start164640_)
      (let ((_end164642_ '#f))
        (std/text/hex#hex-encode__% _bytes164639_ _start164640_ _end164642_))))
  (define std/text/hex#hex-encode
    (lambda _g290276_
      (let ((_g290275_ (let () (declare (not safe)) (##length _g290276_))))
        (cond ((let () (declare (not safe)) (##fx= _g290275_ 1))
               (apply std/text/hex#hex-encode__0 _g290276_))
              ((let () (declare (not safe)) (##fx= _g290275_ 2))
               (apply std/text/hex#hex-encode__1 _g290276_))
              ((let () (declare (not safe)) (##fx= _g290275_ 3))
               (apply std/text/hex#hex-encode__% _g290276_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/hex#hex-encode
                _g290276_))))))
  (define std/text/hex#hex
    (lambda (_u4164602_)
      (let ()
        (declare (not safe))
        (##string-ref std/text/hex#hexes _u4164602_))))
  (define std/text/hex#unhexes-len (char->integer '#\g))
  (define std/text/hex#unhexes (make-u8vector std/text/hex#unhexes-len '255))
  (let _loop164596_ ((_i164598_ '0))
    (if (<= _i164598_ '15)
        (begin
          (let ((_c164600_ (std/text/hex#hex _i164598_)))
            (let ((__tmp290277 (char->integer _c164600_)))
              (declare (not safe))
              (##u8vector-set! std/text/hex#unhexes __tmp290277 _i164598_))
            (let ((__tmp290278 (char->integer (char-upcase _c164600_))))
              (declare (not safe))
              (##u8vector-set! std/text/hex#unhexes __tmp290278 _i164598_)))
          (_loop164596_ (+ _i164598_ '1)))
        '#!void))
  (define std/text/hex#unhex*
    (lambda (_char164590_)
      (letrec* ((_i164592_ (char->integer _char164590_)))
        (if (let ()
              (declare (not safe))
              (##fx< '-1 _i164592_ std/text/hex#unhexes-len))
            (let ((_d164594_
                   (let ()
                     (declare (not safe))
                     (##u8vector-ref std/text/hex#unhexes _i164592_))))
              (if (let () (declare (not safe)) (##fx< _d164594_ '16))
                  _d164594_
                  '#f))
            '#f))))
  (define std/text/hex#unhex
    (lambda (_char164585_)
      (let ((_$e164587_ (std/text/hex#unhex* _char164585_)))
        (if _$e164587_ _$e164587_ (error '"invalid hex char" _char164585_)))))
  (define std/text/hex#hex-decode-nibble
    (lambda (_string164582_ _pos164583_)
      (std/text/hex#unhex
       (let ()
         (declare (not safe))
         (##string-ref _string164582_ _pos164583_)))))
  (define std/text/hex#hex-decode-byte
    (lambda (_string164579_ _pos164580_)
      (let ((__tmp290280
             (let ((__tmp290281
                    (std/text/hex#hex-decode-nibble
                     _string164579_
                     _pos164580_)))
               (declare (not safe))
               (##fxarithmetic-shift __tmp290281 '4)))
            (__tmp290279
             (std/text/hex#hex-decode-nibble
              _string164579_
              (let () (declare (not safe)) (##fx+ _pos164580_ '1)))))
        (declare (not safe))
        (##fx+ __tmp290280 __tmp290279))))
  (define std/text/hex#hex-decode__%
    (lambda (_str164543_ _start164544_ _end164545_)
      (letrec* ((_len164547_
                 (- (let ((_$e164558_ _end164545_))
                      (if _$e164558_ _$e164558_ (string-length _str164543_)))
                    _start164544_))
                (_blen164548_
                 (let ((__tmp290282
                        (let () (declare (not safe)) (##fx+ _len164547_ '1))))
                   (declare (not safe))
                   (##fxquotient __tmp290282 '2)))
                (_bytes164549_ (make-u8vector _blen164548_))
                (_hexes-start164550_
                 (let ((__tmp290283
                        (let ()
                          (declare (not safe))
                          (##fxand _len164547_ '1))))
                   (declare (not safe))
                   (##fx- _start164544_ __tmp290283))))
        (let _lp164552_ ((_n164554_ '0))
          (if (let () (declare (not safe)) (##fx< _n164554_ _blen164548_))
              (let ((_off164556_
                     (let ((__tmp290284
                            (let ()
                              (declare (not safe))
                              (##fxarithmetic-shift _n164554_ '1))))
                       (declare (not safe))
                       (##fx+ _hexes-start164550_ __tmp290284))))
                (let ((__tmp290285
                       (if (let ()
                             (declare (not safe))
                             (##fx< _off164556_ _start164544_))
                           (std/text/hex#hex-decode-nibble
                            _str164543_
                            (let ()
                              (declare (not safe))
                              (##fx+ _off164556_ '1)))
                           (std/text/hex#hex-decode-byte
                            _str164543_
                            _off164556_))))
                  (declare (not safe))
                  (##u8vector-set! _bytes164549_ _n164554_ __tmp290285))
                (_lp164552_
                 (let () (declare (not safe)) (##fx+ _n164554_ '1))))
              '#!void))
        _bytes164549_)))
  (define std/text/hex#hex-decode__0
    (lambda (_str164564_)
      (let* ((_start164566_ '0) (_end164568_ '#f))
        (std/text/hex#hex-decode__% _str164564_ _start164566_ _end164568_))))
  (define std/text/hex#hex-decode__1
    (lambda (_str164570_ _start164571_)
      (let ((_end164573_ '#f))
        (std/text/hex#hex-decode__% _str164570_ _start164571_ _end164573_))))
  (define std/text/hex#hex-decode
    (lambda _g290287_
      (let ((_g290286_ (let () (declare (not safe)) (##length _g290287_))))
        (cond ((let () (declare (not safe)) (##fx= _g290286_ 1))
               (apply std/text/hex#hex-decode__0 _g290287_))
              ((let () (declare (not safe)) (##fx= _g290286_ 2))
               (apply std/text/hex#hex-decode__1 _g290287_))
              ((let () (declare (not safe)) (##fx= _g290286_ 3))
               (apply std/text/hex#hex-decode__% _g290287_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/hex#hex-decode
                _g290287_)))))))
