(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/text/json#read-json__%
    (lambda (_port169871_)
      (std/text/json#read-json-object__% _port169871_ '#f)))
  (define std/text/json#read-json__0
    (lambda ()
      (let ((_port169877_ (current-input-port)))
        (std/text/json#read-json__% _port169877_))))
  (define std/text/json#read-json
    (lambda _g290327_
      (let ((_g290326_ (##length _g290327_)))
        (cond ((##fx= _g290326_ 0)
               (apply std/text/json#read-json__0 _g290327_))
              ((##fx= _g290326_ 1)
               (apply std/text/json#read-json__% _g290327_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#read-json
                _g290327_))))))
  (define std/text/json#string->json-object
    (lambda (_str169868_)
      (std/text/json#read-json-object__% (open-input-string _str169868_) '#f)))
  (define std/text/json#write-json__%
    (lambda (_obj169855_ _port169856_)
      (std/text/json#write-json-object _obj169855_ _port169856_)))
  (define std/text/json#write-json__0
    (lambda (_obj169861_)
      (let ((_port169863_ (current-output-port)))
        (std/text/json#write-json-object _obj169861_ _port169863_))))
  (define std/text/json#write-json
    (lambda _g290329_
      (let ((_g290328_ (##length _g290329_)))
        (cond ((##fx= _g290328_ 1)
               (apply std/text/json#write-json__0 _g290329_))
              ((##fx= _g290328_ 2)
               (apply std/text/json#write-json-object _g290329_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#write-json
                _g290329_))))))
  (define std/text/json#json-object->string
    (lambda (_obj169850_)
      (let ((_port169852_ (open-output-string)))
        (std/text/json#write-json-object _obj169850_ _port169852_)
        (get-output-string _port169852_))))
  (define std/text/json#json-symbolic-keys (make-parameter '#t))
  (define std/text/json#json-list-wrapper (make-parameter identity))
  (define std/text/json#json-sort-keys (make-parameter '#t))
  (define std/text/json#raise-invalid-token
    (lambda (_port169847_ _char169848_)
      (if (eof-object? _char169848_)
          (std/error#raise-io-error
           'read-json
           '"Incomplete JSON object; EOF reached"
           _port169847_)
          (std/error#raise-io-error
           'read-json
           '"Invalid JSON token"
           _port169847_
           _char169848_))))
  (define std/text/json#read-json-object__%
    (lambda (_port169815_ _raise-eof?169816_)
      (std/text/json#skip-whitespace _port169815_)
      (let ((_char169818_ (peek-char _port169815_)))
        (if (eof-object? _char169818_)
            (if _raise-eof?169816_
                (std/error#raise-io-error
                 'read-json
                 '"EOF reached"
                 _port169815_)
                '#!eof)
            (let ((_$e169820_ _char169818_))
              (let ((_default169822169826_
                     (lambda ()
                       (std/text/json#raise-invalid-token
                        _port169815_
                        _char169818_)))
                    (_table169823169828_
                     '#(#f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        2
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        6
                        #f
                        #f
                        6
                        6
                        6
                        6
                        6
                        6
                        6
                        6
                        6
                        6
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        1
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        4
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        5
                        #f
                        #f
                        #f
                        #f
                        #f
                        3
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        0)))
                (if (char? _$e169820_)
                    (let ((_ix169831_ (##char->integer _$e169820_)))
                      (if (##fx< _ix169831_ '124)
                          (let ((_x169834_
                                 (##vector-ref
                                  _table169823169828_
                                  _ix169831_)))
                            (if _x169834_
                                (if (##fx< _x169834_ '3)
                                    (if (##fx= _x169834_ '0)
                                        (std/text/json#read-json-hash
                                         _port169815_)
                                        (if (##fx= _x169834_ '1)
                                            (std/text/json#read-json-list
                                             _port169815_)
                                            (std/text/json#read-json-string
                                             _port169815_)))
                                    (if (##fx< _x169834_ '5)
                                        (if (##fx= _x169834_ '3)
                                            (std/text/json#read-json-true
                                             _port169815_)
                                            (std/text/json#read-json-false
                                             _port169815_))
                                        (if (##fx= _x169834_ '5)
                                            (std/text/json#read-json-null
                                             _port169815_)
                                            (std/text/json#read-json-number
                                             _port169815_))))
                                (_default169822169826_)))
                          (_default169822169826_)))
                    (_default169822169826_))))))))
  (define std/text/json#read-json-object__0
    (lambda (_port169840_)
      (let ((_raise-eof?169842_ '#t))
        (std/text/json#read-json-object__% _port169840_ _raise-eof?169842_))))
  (define std/text/json#read-json-object
    (lambda _g290331_
      (let ((_g290330_ (##length _g290331_)))
        (cond ((##fx= _g290330_ 1)
               (apply std/text/json#read-json-object__0 _g290331_))
              ((##fx= _g290330_ 2)
               (apply std/text/json#read-json-object__% _g290331_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#read-json-object
                _g290331_))))))
  (define std/text/json#skip-whitespace
    (lambda (_port169810_)
      (let ((_char169812_ (peek-char _port169810_)))
        (if (eof-object? _char169812_)
            '#!void
            (if (char-whitespace? _char169812_)
                (begin
                  (read-char _port169810_)
                  (std/text/json#skip-whitespace _port169810_))
                '#!void)))))
  (define std/text/json#skip-chars
    (lambda (_chars169768_ _port169769_)
      (let _lp169771_ ((_rest169773_ _chars169768_))
        (let* ((_rest169774169782_ _rest169773_)
               (_else169776169790_ (lambda () '#!void))
               (_K169778169798_
                (lambda (_rest169793_ _char169794_)
                  (let ((_next169796_ (read-char _port169769_)))
                    (if (eq? _next169796_ _char169794_)
                        (_lp169771_ _rest169793_)
                        (std/text/json#raise-invalid-token
                         _port169769_
                         _next169796_))))))
          (if (##pair? _rest169774169782_)
              (let ((_hd169779169801_ (##car _rest169774169782_))
                    (_tl169780169803_ (##cdr _rest169774169782_)))
                (let* ((_char169806_ _hd169779169801_)
                       (_rest169808_ _tl169780169803_))
                  (_K169778169798_ _rest169808_ _char169806_)))
              '#!void)))))
  (define std/text/json#read-json-hash
    (lambda (_port169752_)
      (read-char _port169752_)
      (let ((_obj169754_
             (if (std/text/json#json-symbolic-keys)
                 (make-table 'test: eq?)
                 (make-table))))
        (let _lp169756_ ()
          (let ((_key169759_ (std/text/json#read-json-hash-key _port169752_)))
            (if _key169759_
                (if (hash-key? _obj169754_ _key169759_)
                    (error '"Duplicate hash key in JSON input" _key169759_)
                    (let ((_val169761_
                           (std/text/json#read-json-object__0 _port169752_)))
                      (table-set! _obj169754_ _key169759_ _val169761_)
                      (std/text/json#skip-whitespace _port169752_)
                      (let* ((_char169763_ (peek-char _port169752_))
                             (_$e169765_ _char169763_))
                        (if (eq? '#\, _$e169765_)
                            (begin (read-char _port169752_) (_lp169756_))
                            (if (eq? '#\} _$e169765_)
                                (begin (read-char _port169752_) _obj169754_)
                                (std/text/json#raise-invalid-token
                                 _port169752_
                                 _char169763_))))))
                _obj169754_))))))
  (define std/text/json#read-json-hash-key
    (lambda (_port169738_)
      (std/text/json#skip-whitespace _port169738_)
      (let* ((_char169740_ (peek-char _port169738_)) (_$e169742_ _char169740_))
        (if (eq? '#\" _$e169742_)
            (let ((_key169745_ (std/text/json#read-json-string _port169738_)))
              (std/text/json#skip-whitespace _port169738_)
              (let* ((_char169747_ (peek-char _port169738_))
                     (_$e169749_ _char169747_))
                (if (eq? '#\: _$e169749_)
                    (begin
                      (read-char _port169738_)
                      (if (std/text/json#json-symbolic-keys)
                          (string->symbol _key169745_)
                          _key169745_))
                    (std/text/json#raise-invalid-token
                     _port169738_
                     _char169747_))))
            (if (eq? '#\} _$e169742_)
                (begin (read-char _port169738_) '#f)
                (std/text/json#raise-invalid-token
                 _port169738_
                 _char169740_))))))
  (define std/text/json#read-json-list
    (lambda (_port169726_)
      (read-char _port169726_)
      (let ((_root169728_ (cons '#f '())))
        (let _lp169730_ ((_tl169732_ _root169728_))
          (let ((_next169734_
                 (std/text/json#read-json-list-next _port169726_)))
            (if (eof-object? _next169734_)
                ((std/text/json#json-list-wrapper) (cdr _root169728_))
                (let ((_tl*169736_ (cons _next169734_ '())))
                  (set-cdr! _tl169732_ _tl*169736_)
                  (_lp169730_ _tl*169736_))))))))
  (define std/text/json#read-json-list-next
    (lambda (_port169712_)
      (std/text/json#skip-whitespace _port169712_)
      (let* ((_char169714_ (peek-char _port169712_)) (_$e169716_ _char169714_))
        (if (eq? '#\] _$e169716_)
            (begin (read-char _port169712_) '#!eof)
            (let ((_obj169719_
                   (std/text/json#read-json-object__0 _port169712_)))
              (std/text/json#skip-whitespace _port169712_)
              (let* ((_char169721_ (peek-char _port169712_))
                     (_$e169723_ _char169721_))
                (if (eq? '#\, _$e169723_)
                    (begin (read-char _port169712_) _obj169719_)
                    (if (eq? '#\] _$e169723_)
                        _obj169719_
                        (std/text/json#raise-invalid-token
                         _port169712_
                         _char169721_)))))))))
  (define std/text/json#read-json-string
    (lambda (_port169611_)
      (letrec ((_read-escape-char169613_
                (lambda (_port169691_)
                  (let* ((_char169693_ (read-char _port169691_))
                         (_$e169695_ _char169693_))
                    (let ((_default169697169701_
                           (lambda ()
                             (std/text/json#raise-invalid-token
                              _port169691_
                              _char169693_)))
                          (_table169698169703_
                           '#(#f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              0
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              0
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              0
                              #f
                              #f
                              #f
                              #f
                              #f
                              1
                              #f
                              #f
                              #f
                              3
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              2
                              #f
                              #f
                              #f
                              4
                              #f
                              5
                              6)))
                      (if (char? _$e169695_)
                          (let ((_ix169706_ (##char->integer _$e169695_)))
                            (if (##fx< _ix169706_ '118)
                                (let ((_x169709_
                                       (##vector-ref
                                        _table169698169703_
                                        _ix169706_)))
                                  (if _x169709_
                                      (if (##fx< _x169709_ '3)
                                          (if (##fx= _x169709_ '0)
                                              _char169693_
                                              (if (##fx= _x169709_ '1)
                                                  '#\backspace
                                                  '#\newline))
                                          (if (##fx< _x169709_ '5)
                                              (if (##fx= _x169709_ '3)
                                                  '#\page
                                                  '#\return)
                                              (if (##fx= _x169709_ '5)
                                                  '#\tab
                                                  (_read-escape-unicode169614_
                                                   _port169691_))))
                                      (_default169697169701_)))
                                (_default169697169701_)))
                          (_default169697169701_))))))
               (_read-escape-unicode169614_
                (lambda (_port169640_)
                  (let _lp169642_ ((_n169644_ '0) (_chars169645_ '()))
                    (if (##fx< _n169644_ '4)
                        (_lp169642_
                         (##fx+ _n169644_ '1)
                         (cons (read-char _port169640_) _chars169645_))
                        (let _lp169647_ ((_rest169649_ _chars169645_)
                                         (_val169650_ '0)
                                         (_shift169651_ '0))
                          (let* ((_rest169652169660_ _rest169649_)
                                 (_else169654169671_
                                  (lambda ()
                                    (if (and (##fx< _val169650_ ##max-char)
                                             (or (##fx< _val169650_ '55296)
                                                 (##fx< '57343 _val169650_)))
                                        (##integer->char _val169650_)
                                        '#\�)))
                                 (_K169656169679_
                                  (lambda (_rest169674_ _char169675_)
                                    (let ((_n169677_
                                           (##fxarithmetic-shift
                                            (_hex-value169615_ _char169675_)
                                            _shift169651_)))
                                      (_lp169647_
                                       _rest169674_
                                       (bitwise-ior _n169677_ _val169650_)
                                       (##fx+ _shift169651_ '4))))))
                            (if (##pair? _rest169652169660_)
                                (let ((_hd169657169682_
                                       (##car _rest169652169660_))
                                      (_tl169658169684_
                                       (##cdr _rest169652169660_)))
                                  (let* ((_char169687_ _hd169657169682_)
                                         (_rest169689_ _tl169658169684_))
                                    (_K169656169679_
                                     _rest169689_
                                     _char169687_)))
                                (_else169654169671_))))))))
               (_hex-value169615_
                (lambda (_char169635_)
                  (let ((_$e169637_ (std/text/hex#unhex* _char169635_)))
                    (if _$e169637_
                        _$e169637_
                        (std/text/json#raise-invalid-token
                         _port169611_
                         _char169635_))))))
        (read-char _port169611_)
        (let ((_root169617_ (cons '#f '())))
          (let _lp169619_ ((_tl169621_ _root169617_))
            (let* ((_char169623_ (read-char _port169611_))
                   (_$e169625_ _char169623_))
              (if (eq? '#\" _$e169625_)
                  (list->string (cdr _root169617_))
                  (if (eq? '#\\ _$e169625_)
                      (let* ((_char169628_
                              (_read-escape-char169613_ _port169611_))
                             (_tl*169630_ (cons _char169628_ '())))
                        (set-cdr! _tl169621_ _tl*169630_)
                        (_lp169619_ _tl*169630_))
                      (if (eof-object? _char169623_)
                          (std/text/json#raise-invalid-token
                           _port169611_
                           _char169623_)
                          (let ((_tl*169633_ (cons _char169623_ '())))
                            (set-cdr! _tl169621_ _tl*169633_)
                            (_lp169619_ _tl*169633_)))))))))))
  (define std/text/json#read-json-number
    (lambda (_port169584_)
      (letrec ((_parse169586_
                (lambda (_chars169604_)
                  (let* ((_str169606_ (list->string _chars169604_))
                         (_$e169608_ (string->number _str169606_)))
                    (if _$e169608_
                        _$e169608_
                        (std/text/json#raise-invalid-token
                         _port169584_
                         _str169606_))))))
        (let ((_chars169588_ (cons (read-char _port169584_) '())))
          (let _lp169590_ ((_tl169592_ _chars169588_))
            (let ((_char169594_ (peek-char _port169584_)))
              (if (or (eof-object? _char169594_)
                      (memq _char169594_ '(#\] #\} #\,))
                      (char-whitespace? _char169594_))
                  (_parse169586_ _chars169588_)
                  (let ((_tl*169602_ (cons (read-char _port169584_) '())))
                    (set-cdr! _tl169592_ _tl*169602_)
                    (_lp169590_ _tl*169602_)))))))))
  (define std/text/json#read-json-true
    (lambda (_port169582_)
      (std/text/json#skip-chars '(#\t #\r #\u #\e) _port169582_)
      '#t))
  (define std/text/json#read-json-false
    (lambda (_port169580_)
      (std/text/json#skip-chars '(#\f #\a #\l #\s #\e) _port169580_)
      '#f))
  (define std/text/json#read-json-null
    (lambda (_port169578_)
      (std/text/json#skip-chars '(#\n #\u #\l #\l) _port169578_)
      '#!void))
  (define std/text/json#write-json-object
    (lambda (_obj169568_ _port169569_)
      (if (number? _obj169568_)
          (if (exact-integer? _obj169568_)
              (gerbil/gambit/ports#write-string__%
               (number->string _obj169568_)
               _port169569_)
              (if (inexact? _obj169568_)
                  (std/text/json#write-json-inexact _obj169568_ _port169569_)
                  (if (rational? _obj169568_)
                      (std/text/json#write-json-inexact
                       (exact->inexact _obj169568_)
                       _port169569_)
                      (error '"Bad JSON object" _obj169568_))))
          (if (string? _obj169568_)
              (std/text/json#write-json-string _obj169568_ _port169569_)
              (if (symbol? _obj169568_)
                  (std/text/json#write-json-string
                   (symbol->string _obj169568_)
                   _port169569_)
                  (if (keyword? _obj169568_)
                      (std/text/json#write-json-string
                       (keyword->string _obj169568_)
                       _port169569_)
                      (if (list? _obj169568_)
                          (std/text/json#write-json-list
                           _obj169568_
                           _port169569_)
                          (if (vector? _obj169568_)
                              (std/text/json#write-json-vector
                               _obj169568_
                               _port169569_)
                              (if (table? _obj169568_)
                                  (std/text/json#write-json-hash
                                   _obj169568_
                                   _port169569_)
                                  (if (eq? '#t _obj169568_)
                                      (gerbil/gambit/ports#write-string__%
                                       '"true"
                                       _port169569_)
                                      (if (eq? '#f _obj169568_)
                                          (gerbil/gambit/ports#write-string__%
                                           '"false"
                                           _port169569_)
                                          (if (eq? _obj169568_ '#!void)
                                              (gerbil/gambit/ports#write-string__%
                                               '"null"
                                               _port169569_)
                                              (let ((_$e169571_
                                                     (method-ref
                                                      _obj169568_
                                                      ':write-json)))
                                                (if _$e169571_
                                                    ((lambda (_g169573169575_)
                                                       (_g169573169575_
                                                        _obj169568_
                                                        _port169569_))
                                                     _$e169571_)
                                                    (std/text/json#write-json-object
                                                     (let ((__method290325
                                                            (method-ref
                                                             _obj169568_
                                                             ':json)))
                                                       (if __method290325
                                                           (__method290325
                                                            _obj169568_)
                                                           (error '"Missing method"
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _obj169568_
                          ':json)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     _port169569_)))))))))))))))
  (define std/text/json#write-json-inexact
    (lambda (_obj169560_ _port169561_)
      (let* ((_mag169563_ (abs _obj169560_))
             (_str169565_ (number->string _mag169563_)))
        (if (flnegative? _obj169560_) (write-char '#\- _port169561_) '#!void)
        (if (eq? (string-ref _str169565_ '0) '#\.)
            (write-char '#\0 _port169561_)
            '#!void)
        (gerbil/gambit/ports#write-string__% _str169565_ _port169561_)
        (if (eq? (string-ref
                  _str169565_
                  (##fx- (string-length _str169565_) '1))
                 '#\.)
            (write-char '#\0 _port169561_)
            '#!void))))
  (define std/text/json#write-json-list
    (lambda (_obj169495_ _port169496_)
      (write-char '#\[ _port169496_)
      (let _lp169498_ ((_rest169500_ _obj169495_))
        (let* ((_rest169501169514_ _rest169500_)
               (_E169505169518_
                (lambda () (error '"No clause matching" _rest169501169514_))))
          (let ((_K169510169550_
                 (lambda (_val169548_)
                   (std/text/json#write-json-object _val169548_ _port169496_)
                   (write-char '#\] _port169496_)))
                (_K169507169533_
                 (lambda (_rest169530_ _val169531_)
                   (std/text/json#write-json-object _val169531_ _port169496_)
                   (write-char '#\, _port169496_)
                   (_lp169498_ _rest169530_)))
                (_K169506169523_ (lambda () (write-char '#\] _port169496_))))
            (let ((_try-match169504169526_
                   (lambda ()
                     (if (##null? _rest169501169514_)
                         (_K169506169523_)
                         (_E169505169518_)))))
              (if (##pair? _rest169501169514_)
                  (let ((_tl169512169555_ (##cdr _rest169501169514_))
                        (_hd169511169553_ (##car _rest169501169514_)))
                    (if (##null? _tl169512169555_)
                        (let ((_val169558_ _hd169511169553_))
                          (_K169510169550_ _val169558_))
                        (let ((_val169541_ _hd169511169553_)
                              (_rest169543_ _tl169512169555_))
                          (_K169507169533_ _rest169543_ _val169541_))))
                  (_try-match169504169526_))))))))
  (define std/text/json#write-json-vector
    (lambda (_obj169484_ _port169485_)
      (let ((_len169487_ (vector-length _obj169484_)))
        (if (##fxpositive? _len169487_)
            (let ((_last169489_ (##fx- _len169487_ '1)))
              (write-char '#\[ _port169485_)
              (let _lp169491_ ((_n169493_ '0))
                (if (##fx= _n169493_ _last169489_)
                    (begin
                      (std/text/json#write-json-object
                       (##vector-ref _obj169484_ _n169493_)
                       _port169485_)
                      (write-char '#\] _port169485_))
                    (begin
                      (std/text/json#write-json-object
                       (##vector-ref _obj169484_ _n169493_)
                       _port169485_)
                      (write-char '#\, _port169485_)
                      (_lp169491_ (##fx+ _n169493_ '1))))))
            (gerbil/gambit/ports#write-string__% '"[]" _port169485_)))))
  (define std/text/json#json-key-string__%
    (lambda (_key169471_ _obj169472_)
      (if (string? _key169471_)
          _key169471_
          (if (symbol? _key169471_)
              (symbol->string _key169471_)
              (if (keyword? _key169471_)
                  (keyword->string _key169471_)
                  (error '"Illegal hash key; must be symbol, keyword or string"
                         _obj169472_
                         _key169471_))))))
  (define std/text/json#json-key-string__0
    (lambda (_key169477_)
      (let ((_obj169479_ '#f))
        (std/text/json#json-key-string__% _key169477_ _obj169479_))))
  (define std/text/json#json-key-string
    (lambda _g290333_
      (let ((_g290332_ (##length _g290333_)))
        (cond ((##fx= _g290332_ 1)
               (apply std/text/json#json-key-string__0 _g290333_))
              ((##fx= _g290332_ 2)
               (apply std/text/json#json-key-string__% _g290333_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#json-key-string
                _g290333_))))))
  (define std/text/json#write-json-alist__%
    (lambda (_alist169399_ _port169400_ _obj169401_)
      (write-char '#\{ _port169400_)
      (let _lp169403_ ((_previous-key169405_ '#f) (_rest169406_ _alist169399_))
        (let* ((_rest169407169418_ _rest169406_)
               (_E169410169422_
                (lambda () (error '"No clause matching" _rest169407169418_))))
          (let ((_K169412169439_
                 (lambda (_rest169433_ _val169434_ _key-obj169435_)
                   (let ((_key169437_
                          (std/text/json#json-key-string__%
                           _key-obj169435_
                           _obj169401_)))
                     (if (equal? _key169437_ _previous-key169405_)
                         (error '"Duplicate key in JSON object" _key169437_)
                         '#!void)
                     (write _key169437_ _port169400_)
                     (write-char '#\: _port169400_)
                     (std/text/json#write-json-object _val169434_ _port169400_)
                     (if (null? _rest169433_)
                         '#!void
                         (write-char '#\, _port169400_))
                     (_lp169403_ _key169437_ _rest169433_))))
                (_K169411169427_ (lambda () (write-char '#\} _port169400_))))
            (let ((_try-match169409169430_
                   (lambda ()
                     (if (##null? _rest169407169418_)
                         (_K169411169427_)
                         (_E169410169422_)))))
              (if (##pair? _rest169407169418_)
                  (let ((_tl169414169444_ (##cdr _rest169407169418_))
                        (_hd169413169442_ (##car _rest169407169418_)))
                    (if (##pair? _hd169413169442_)
                        (let ((_tl169416169449_ (##cdr _hd169413169442_))
                              (_hd169415169447_ (##car _hd169413169442_)))
                          (let ((_key-obj169452_ _hd169415169447_)
                                (_val169454_ _tl169416169449_)
                                (_rest169456_ _tl169414169444_))
                            (_K169412169439_
                             _rest169456_
                             _val169454_
                             _key-obj169452_)))
                        (_E169410169422_)))
                  (_try-match169409169430_))))))))
  (define std/text/json#write-json-alist__0
    (lambda (_alist169461_ _port169462_)
      (let ((_obj169464_ _alist169461_))
        (std/text/json#write-json-alist__%
         _alist169461_
         _port169462_
         _obj169464_))))
  (define std/text/json#write-json-alist
    (lambda _g290335_
      (let ((_g290334_ (##length _g290335_)))
        (cond ((##fx= _g290334_ 2)
               (apply std/text/json#write-json-alist__0 _g290335_))
              ((##fx= _g290334_ 3)
               (apply std/text/json#write-json-alist__% _g290335_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#write-json-alist
                _g290335_))))))
  (define std/text/json#json-sort-alist__%
    (lambda (_alist169382_ _obj169383_)
      (std/sort#sort
       _alist169382_
       (lambda (_kv1169385_ _kv2169386_)
         (string<?
          (std/text/json#json-key-string__% (car _kv1169385_) _obj169383_)
          (std/text/json#json-key-string__% (car _kv2169386_) _obj169383_))))))
  (define std/text/json#json-sort-alist__0
    (lambda (_alist169391_)
      (let ((_obj169393_ _alist169391_))
        (std/text/json#json-sort-alist__% _alist169391_ _obj169393_))))
  (define std/text/json#json-sort-alist
    (lambda _g290337_
      (let ((_g290336_ (##length _g290337_)))
        (cond ((##fx= _g290336_ 1)
               (apply std/text/json#json-sort-alist__0 _g290337_))
              ((##fx= _g290336_ 2)
               (apply std/text/json#json-sort-alist__% _g290337_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#json-sort-alist
                _g290337_))))))
  (define std/text/json#write-json-alist/sort__%
    (lambda (_alist169365_ _port169366_ _obj169367_)
      (std/text/json#write-json-alist__%
       (std/text/json#json-sort-alist__% _alist169365_ _obj169367_)
       _port169366_
       _obj169367_)))
  (define std/text/json#write-json-alist/sort__0
    (lambda (_alist169372_ _port169373_)
      (let ((_obj169375_ _alist169372_))
        (std/text/json#write-json-alist/sort__%
         _alist169372_
         _port169373_
         _obj169375_))))
  (define std/text/json#write-json-alist/sort
    (lambda _g290339_
      (let ((_g290338_ (##length _g290339_)))
        (cond ((##fx= _g290338_ 2)
               (apply std/text/json#write-json-alist/sort__0 _g290339_))
              ((##fx= _g290338_ 3)
               (apply std/text/json#write-json-alist/sort__% _g290339_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#write-json-alist/sort
                _g290339_))))))
  (define std/text/json#write-json-hash
    (lambda (_obj169359_ _port169360_)
      (letrec* ((_lst169362_ (table->list _obj169359_)))
        (if (std/text/json#json-sort-keys)
            (std/text/json#write-json-alist/sort__%
             _lst169362_
             _port169360_
             _obj169359_)
            (std/text/json#write-json-alist__%
             _lst169362_
             _port169360_
             _obj169359_)))))
  (define std/text/json#write-json-string
    (lambda (_obj169318_ _port169319_)
      (letrec* ((_escape169321_
                 '((#\" . #\")
                   (#\\ . #\\)
                   (#\backspace . #\b)
                   (#\newline . #\n)
                   (#\page . #\f)
                   (#\return . #\r)
                   (#\tab . #\t)))
                (_printable-char?169322_
                 (lambda (_char169355_)
                   (let ((_n169357_ (char->integer _char169355_)))
                     (if (##fx< _n169357_ '32)
                         '#f
                         (if (##fx= _n169357_ '127) '#f '#t)))))
                (_write-uchar169323_
                 (lambda (_char169342_ _port169343_)
                   (let ((_int169345_ (char->integer _char169342_)))
                     (gerbil/gambit/ports#write-string__% '"\\u" _port169343_)
                     (let _lp169347_ ((_n169349_ '0)
                                      (_mask169350_ '61440)
                                      (_shift169351_ '-12))
                       (if (##fx< _n169349_ '4)
                           (let ((_char169353_
                                  (std/text/hex#hex
                                   (arithmetic-shift
                                    (bitwise-and _int169345_ _mask169350_)
                                    _shift169351_))))
                             (write-char _char169353_ _port169343_)
                             (_lp169347_
                              (##fx+ _n169349_ '1)
                              (arithmetic-shift _mask169350_ '-4)
                              (##fx+ _shift169351_ '4)))
                           '#!void)))))
                (_write-str169324_
                 (lambda (_obj169326_ _port169327_)
                   (let ((_len169329_ (string-length _obj169326_)))
                     (let _lp169331_ ((_n169333_ '0))
                       (if (##fx< _n169333_ _len169329_)
                           (let ((_char169335_
                                  (string-ref _obj169326_ _n169333_)))
                             (let ((_$e169337_
                                    (assq _char169335_ _escape169321_)))
                               (if _$e169337_
                                   ((lambda (_esc169340_)
                                      (write-char '#\\ _port169327_)
                                      (write-char
                                       (cdr _esc169340_)
                                       _port169327_))
                                    _$e169337_)
                                   (if (_printable-char?169322_ _char169335_)
                                       (write-char _char169335_ _port169327_)
                                       (_write-uchar169323_
                                        _char169335_
                                        _port169327_))))
                             (_lp169331_ (##fx+ _n169333_ '1)))
                           '#!void))))))
        (write-char '#\" _port169319_)
        (_write-str169324_ _obj169318_ _port169319_)
        (write-char '#\" _port169319_)))))
