(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/xml/sxpath#string-null? string-empty?)
  (define std/xml/sxpath#nl (string '#\newline))
  (define std/xml/sxpath#cout
    (lambda _args227715_
      (for-each
       (lambda (_x227717_)
         (if (procedure? _x227717_) (_x227717_) (display _x227717_)))
       _args227715_)))
  (define std/xml/sxpath#cerr
    (lambda _args227711_
      (for-each
       (lambda (_x227713_)
         (if (procedure? _x227713_)
             (_x227713_ (current-error-port))
             (display _x227713_ (current-error-port))))
       _args227711_)))
  (define std/xml/sxpath#nodeset?
    (lambda (_x227706_)
      (let ((_$e227708_
             (if (pair? _x227706_) (not (symbol? (car _x227706_))) '#f)))
        (if _$e227708_ _$e227708_ (null? _x227706_)))))
  (define std/xml/sxpath#node-typeof?
    (lambda (_crit227699_)
      (lambda (_node227701_)
        (let ((_$e227703_ _crit227699_))
          (if (eq? '* _$e227703_)
              (if (pair? _node227701_)
                  (not (memq (car _node227701_) '(@ *PI*)))
                  '#f)
              (if (eq? '*any* _$e227703_)
                  '#t
                  (if (eq? '*text* _$e227703_)
                      (string? _node227701_)
                      (if (pair? _node227701_)
                          (eq? _crit227699_ (car _node227701_))
                          '#f))))))))
  (define std/xml/sxpath#node-eq?
    (lambda (_other227695_)
      (lambda (_node227697_) (eq? _other227695_ _node227697_))))
  (define std/xml/sxpath#node-equal?
    (lambda (_other227691_)
      (lambda (_node227693_) (equal? _other227691_ _node227693_))))
  (define std/xml/sxpath#node-pos
    (lambda (_n224696_)
      (lambda (_nodeset224698_)
        (if (not (std/xml/sxpath#nodeset? _nodeset224698_))
            '()
            (if (null? _nodeset224698_)
                _nodeset224698_
                (if (eqv? _n224696_ '1)
                    (list (car _nodeset224698_))
                    (if (negative? _n224696_)
                        ((std/xml/sxpath#node-pos
                          (+ _n224696_ '1 (length _nodeset224698_)))
                         _nodeset224698_)
                        (begin
                          (let ((_$e226066_ (positive? _n224696_)))
                            (if _$e226066_
                                _$e226066_
                                (begin
                                  (std/xml/sxpath#cerr
                                   '"failed assertion: "
                                   '(positive? n)
                                   std/xml/sxpath#nl
                                   '"bindings"
                                   '#\newline
                                   'n
                                   '": "
                                   _n224696_
                                   std/xml/sxpath#nl)
                                  (error '"assertion failure"))))
                          ((std/xml/sxpath#node-pos (- _n224696_ '1))
                           (cdr _nodeset224698_))))))))))
  (define std/xml/sxpath#filter
    (lambda (_pred?224685_)
      (lambda (_lst224687_)
        (let _loop224689_ ((_lst224691_
                            (if (std/xml/sxpath#nodeset? _lst224687_)
                                _lst224687_
                                (list _lst224687_)))
                           (_res224692_ '()))
          (if (null? _lst224691_)
              (reverse _res224692_)
              (let ((_pred-result224694_ (_pred?224685_ (car _lst224691_))))
                (_loop224689_
                 (cdr _lst224691_)
                 (if (and _pred-result224694_
                          (not (null? _pred-result224694_)))
                     (cons (car _lst224691_) _res224692_)
                     _res224692_))))))))
  (define std/xml/sxpath#take-until
    (lambda (_pred?224675_)
      (lambda (_lst224677_)
        (let _loop224679_ ((_lst224681_
                            (if (std/xml/sxpath#nodeset? _lst224677_)
                                _lst224677_
                                (list _lst224677_))))
          (if (null? _lst224681_)
              _lst224681_
              (let ((_pred-result224683_ (_pred?224675_ (car _lst224681_))))
                (if (and _pred-result224683_ (not (null? _pred-result224683_)))
                    '()
                    (cons (car _lst224681_)
                          (_loop224679_ (cdr _lst224681_))))))))))
  (define std/xml/sxpath#take-after
    (lambda (_pred?224665_)
      (lambda (_lst224667_)
        (let _loop224669_ ((_lst224671_
                            (if (std/xml/sxpath#nodeset? _lst224667_)
                                _lst224667_
                                (list _lst224667_))))
          (if (null? _lst224671_)
              _lst224671_
              (let ((_pred-result224673_ (_pred?224665_ (car _lst224671_))))
                (if (and _pred-result224673_ (not (null? _pred-result224673_)))
                    (cdr _lst224671_)
                    (_loop224669_ (cdr _lst224671_)))))))))
  (define std/xml/sxpath#map-union
    (lambda (_proc224660_ _lst224661_)
      (if (null? _lst224661_)
          _lst224661_
          (let ((_proc-res224663_ (_proc224660_ (car _lst224661_))))
            ((if (std/xml/sxpath#nodeset? _proc-res224663_) append cons)
             _proc-res224663_
             (std/xml/sxpath#map-union _proc224660_ (cdr _lst224661_)))))))
  (define std/xml/sxpath#node-reverse
    (lambda (_node-or-nodeset224658_)
      (if (not (std/xml/sxpath#nodeset? _node-or-nodeset224658_))
          (list _node-or-nodeset224658_)
          (reverse _node-or-nodeset224658_))))
  (define std/xml/sxpath#node-trace
    (lambda (_title224654_)
      (lambda (_node-or-nodeset224656_)
        (std/xml/sxpath#cout std/xml/sxpath#nl '"-->")
        (display _title224654_)
        (display '" :")
        (pretty-print _node-or-nodeset224656_)
        _node-or-nodeset224656_)))
  (define std/xml/sxpath#select-kids
    (lambda (_test-pred?224650_)
      (lambda (_node224652_)
        (if (null? _node224652_)
            _node224652_
            (if (not (pair? _node224652_))
                '()
                (if (symbol? (car _node224652_))
                    ((std/xml/sxpath#filter _test-pred?224650_)
                     (cdr _node224652_))
                    (std/xml/sxpath#map-union
                     (std/xml/sxpath#select-kids _test-pred?224650_)
                     _node224652_)))))))
  (define std/xml/sxpath#node-self std/xml/sxpath#filter)
  (define std/xml/sxpath#node-join
    (lambda _selectors224641_
      (lambda (_nodeset224643_)
        (let _loop224645_ ((_nodeset224647_ _nodeset224643_)
                           (_selectors224648_ _selectors224641_))
          (if (null? _selectors224648_)
              _nodeset224647_
              (_loop224645_
               (if (std/xml/sxpath#nodeset? _nodeset224647_)
                   (std/xml/sxpath#map-union
                    (car _selectors224648_)
                    _nodeset224647_)
                   ((car _selectors224648_) _nodeset224647_))
               (cdr _selectors224648_)))))))
  (define std/xml/sxpath#node-reduce
    (lambda _converters224632_
      (lambda (_nodeset224634_)
        (let _loop224636_ ((_nodeset224638_ _nodeset224634_)
                           (_converters224639_ _converters224632_))
          (if (null? _converters224639_)
              _nodeset224638_
              (_loop224636_
               ((car _converters224639_) _nodeset224638_)
               (cdr _converters224639_)))))))
  (define std/xml/sxpath#node-or
    (lambda _converters224620_
      (lambda (_node-or-nodeset224622_)
        (let _loop224624_ ((_result224626_ '())
                           (_converters224627_ _converters224620_))
          (if (null? _converters224627_)
              _result224626_
              (_loop224624_
               (append _result224626_
                       (let ((_$e224629_
                              ((car _converters224627_)
                               _node-or-nodeset224622_)))
                         (if _$e224629_ _$e224629_ '())))
               (cdr _converters224627_)))))))
  (define std/xml/sxpath#node-closure
    (lambda (_test-pred?224611_)
      (lambda (_node224613_)
        (let _loop224615_ ((_parent224617_ _node224613_) (_result224618_ '()))
          (if (null? _parent224617_)
              _result224618_
              (_loop224615_
               ((std/xml/sxpath#select-kids (std/xml/sxpath#node-typeof? '*))
                _parent224617_)
               (append _result224618_
                       ((std/xml/sxpath#select-kids _test-pred?224611_)
                        _parent224617_))))))))
  (define std/xml/sxpath#node-parent
    (lambda (_rootnode224605_)
      (lambda (_node224607_)
        (if (std/xml/sxpath#nodeset? _node224607_)
            (std/xml/sxpath#map-union
             (std/xml/sxpath#node-parent _rootnode224605_)
             _node224607_)
            (let ((_pred224609_
                   (std/xml/sxpath#node-or
                    (std/xml/sxpath#node-reduce
                     (std/xml/sxpath#node-self
                      (std/xml/sxpath#node-typeof? '*))
                     (std/xml/sxpath#select-kids
                      (std/xml/sxpath#node-eq? _node224607_)))
                    (std/xml/sxpath#node-join
                     (std/xml/sxpath#select-kids
                      (std/xml/sxpath#node-typeof? '@))
                     (std/xml/sxpath#select-kids
                      (std/xml/sxpath#node-eq? _node224607_))))))
              ((std/xml/sxpath#node-or
                (std/xml/sxpath#node-self _pred224609_)
                (std/xml/sxpath#node-closure _pred224609_))
               _rootnode224605_))))))
  (define std/xml/sxpath#sxpath
    (lambda (_path224591_)
      (lambda (_nodeset224593_)
        (let _loop224595_ ((_nodeset224597_ _nodeset224593_)
                           (_path224598_ _path224591_))
          (if (null? _path224598_)
              _nodeset224597_
              (if (std/xml/sxpath#nodeset? _nodeset224597_)
                  (std/xml/sxpath#map-union
                   (std/xml/sxpath#sxpath _path224598_)
                   _nodeset224597_)
                  (if (procedure? (car _path224598_))
                      (_loop224595_
                       ((car _path224598_) _nodeset224597_)
                       (cdr _path224598_))
                      (if (eq? '// (car _path224598_))
                          (_loop224595_
                           ((if (std/xml/sxpath#nodeset? _nodeset224597_)
                                append
                                cons)
                            _nodeset224597_
                            ((std/xml/sxpath#node-closure
                              (std/xml/sxpath#node-typeof? '*any*))
                             _nodeset224597_))
                           (cdr _path224598_))
                          (if (symbol? (car _path224598_))
                              (_loop224595_
                               ((std/xml/sxpath#select-kids
                                 (std/xml/sxpath#node-typeof?
                                  (car _path224598_)))
                                _nodeset224597_)
                               (cdr _path224598_))
                              (if (and (pair? (car _path224598_))
                                       (eq? 'equal? (caar _path224598_)))
                                  (_loop224595_
                                   ((std/xml/sxpath#select-kids
                                     (apply std/xml/sxpath#node-equal?
                                            (cdar _path224598_)))
                                    _nodeset224597_)
                                   (cdr _path224598_))
                                  (if (and (pair? (car _path224598_))
                                           (eq? 'eq? (caar _path224598_)))
                                      (_loop224595_
                                       ((std/xml/sxpath#select-kids
                                         (apply std/xml/sxpath#node-eq?
                                                (cdar _path224598_)))
                                        _nodeset224597_)
                                       (cdr _path224598_))
                                      (if (pair? (car _path224598_))
                                          (let _reducer224600_ ((_nodeset224602_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (if (symbol? (caar _path224598_))
                             ((std/xml/sxpath#select-kids
                               (std/xml/sxpath#node-typeof?
                                (caar _path224598_)))
                              _nodeset224597_)
                             (_loop224595_
                              _nodeset224597_
                              (caar _path224598_))))
                        (_reducing-path224603_ (cdar _path224598_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                            (if (null? _reducing-path224603_)
                                                (_loop224595_
                                                 _nodeset224602_
                                                 (cdr _path224598_))
                                                (if (number? (car _reducing-path224603_))
                                                    (_reducer224600_
                                                     ((std/xml/sxpath#node-pos
                                                       (car _reducing-path224603_))
                                                      _nodeset224602_)
                                                     (cdr _reducing-path224603_))
                                                    (_reducer224600_
                                                     ((std/xml/sxpath#filter
                                                       (std/xml/sxpath#sxpath
                                                        (car _reducing-path224603_)))
                                                      _nodeset224602_)
                                                     (cdr _reducing-path224603_)))))
                                          (error '"Invalid path step: "
                                                 (car _path224598_)))))))))))))))
