(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define gerbil/gambit/ports#write-string__%
    (lambda (_str65781_ _port65782_)
      (write-substring _str65781_ '0 (string-length _str65781_) _port65782_)))
  (define gerbil/gambit/ports#write-string__0
    (lambda (_str65787_)
      (let ((_port65789_ (current-output-port)))
        (gerbil/gambit/ports#write-string__% _str65787_ _port65789_))))
  (define gerbil/gambit/ports#write-string
    (lambda _g65794_
      (let ((_g65793_ (length _g65794_)))
        (cond ((##fx= _g65793_ 1)
               (apply gerbil/gambit/ports#write-string__0 _g65794_))
              ((##fx= _g65793_ 2)
               (apply gerbil/gambit/ports#write-string__% _g65794_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/gambit/ports#write-string
                _g65794_))))))
  (define gerbil/gambit/ports#read-string__%
    (lambda (_obj65762_ _port65763_)
      (if (fixnum? _obj65762_)
          (begin
            (if (##fx>= _obj65762_ '0)
                '#!void
                (error '"Bad argument; expected non-negative fixnum"
                       _obj65762_))
            (let* ((_str65765_ (make-string _obj65762_))
                   (_rd65767_
                    (read-substring _str65765_ '0 _obj65762_ _port65763_)))
              (if (##fxzero? _obj65762_)
                  _str65765_
                  (if (##fxzero? _rd65767_)
                      (eof-object)
                      (if (##fx< _rd65767_ _obj65762_)
                          (begin
                            (string-shrink! _str65765_ _rd65767_)
                            _str65765_)
                          _str65765_)))))
          (if (string? _obj65762_)
              (read-substring
               _obj65762_
               '0
               (##string-length _obj65762_)
               _port65763_)
              (error '"Bad argument; expected string or non-negative fixnum"
                     _obj65762_)))))
  (define gerbil/gambit/ports#read-string__0
    (lambda (_obj65773_)
      (let ((_port65775_ (current-input-port)))
        (gerbil/gambit/ports#read-string__% _obj65773_ _port65775_))))
  (define gerbil/gambit/ports#read-string
    (lambda _g65796_
      (let ((_g65795_ (length _g65796_)))
        (cond ((##fx= _g65795_ 1)
               (apply gerbil/gambit/ports#read-string__0 _g65796_))
              ((##fx= _g65795_ 2)
               (apply gerbil/gambit/ports#read-string__% _g65796_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/gambit/ports#read-string
                _g65796_))))))
  (define gerbil/gambit/ports#write-u8vector__%
    (lambda (_bytes65748_ _port65749_)
      (write-subu8vector
       _bytes65748_
       '0
       (u8vector-length _bytes65748_)
       _port65749_)))
  (define gerbil/gambit/ports#write-u8vector__0
    (lambda (_bytes65754_)
      (let ((_port65756_ (current-output-port)))
        (gerbil/gambit/ports#write-u8vector__% _bytes65754_ _port65756_))))
  (define gerbil/gambit/ports#write-u8vector
    (lambda _g65798_
      (let ((_g65797_ (length _g65798_)))
        (cond ((##fx= _g65797_ 1)
               (apply gerbil/gambit/ports#write-u8vector__0 _g65798_))
              ((##fx= _g65797_ 2)
               (apply gerbil/gambit/ports#write-u8vector__% _g65798_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/gambit/ports#write-u8vector
                _g65798_))))))
  (define gerbil/gambit/ports#read-u8vector__%
    (lambda (_obj65729_ _port65730_)
      (if (fixnum? _obj65729_)
          (begin
            (if (##fx>= _obj65729_ '0)
                '#!void
                (error '"Bad argument; expected non-negative fixnum"
                       _obj65729_))
            (let* ((_bytes65732_ (make-u8vector _obj65729_))
                   (_rd65734_
                    (read-subu8vector _bytes65732_ '0 _obj65729_ _port65730_)))
              (if (##fxzero? _obj65729_)
                  _bytes65732_
                  (if (##fxzero? _rd65734_)
                      (eof-object)
                      (if (##fx< _rd65734_ _obj65729_)
                          (begin
                            (u8vector-shrink! _bytes65732_ _rd65734_)
                            _bytes65732_)
                          _bytes65732_)))))
          (if (u8vector? _obj65729_)
              (read-subu8vector
               _obj65729_
               '0
               (##u8vector-length _obj65729_)
               _port65730_)
              (error '"Bad argument; expected u8vector or non-negative fixnum"
                     _obj65729_)))))
  (define gerbil/gambit/ports#read-u8vector__0
    (lambda (_obj65740_)
      (let ((_port65742_ (current-input-port)))
        (gerbil/gambit/ports#read-u8vector__% _obj65740_ _port65742_))))
  (define gerbil/gambit/ports#read-u8vector
    (lambda _g65800_
      (let ((_g65799_ (length _g65800_)))
        (cond ((##fx= _g65799_ 1)
               (apply gerbil/gambit/ports#read-u8vector__0 _g65800_))
              ((##fx= _g65799_ 2)
               (apply gerbil/gambit/ports#read-u8vector__% _g65800_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/gambit/ports#read-u8vector
                _g65800_)))))))
