(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/actor/message#actor-error::t
    (make-struct-type
     'std/actor/message#actor-error::t
     error::t
     '0
     'actor-error
     '()
     ':init!
     '()))
  (define std/actor/message#actor-error?
    (make-struct-predicate std/actor/message#actor-error::t))
  (define std/actor/message#make-actor-error
    (lambda _$args177860_
      (apply make-struct-instance
             std/actor/message#actor-error::t
             _$args177860_)))
  (define std/actor/message#actor-error:::init!
    (lambda (_self177855_ _where177856_ _what177857_ . _irritants177858_)
      (if (let ((__tmp306382
                 (let () (declare (not safe)) (##vector-length _self177855_))))
            (declare (not safe))
            (##fx< '3 __tmp306382))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self177855_ '1 _what177857_))
            (let ()
              (declare (not safe))
              (##vector-set! _self177855_ '2 _irritants177858_))
            (let ()
              (declare (not safe))
              (##vector-set! _self177855_ '3 _where177856_)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self177855_))))
  (bind-method!
   std/actor/message#actor-error::t
   ':init!
   std/actor/message#actor-error:::init!
   '#f)
  (define std/actor/message#message::t
    (make-struct-type
     'std/actor/message#message::t
     '#f
     '4
     'message
     '((final: . #t))
     '#f
     '(e source dest options)))
  (define std/actor/message#message?
    (make-struct-predicate std/actor/message#message::t))
  (define std/actor/message#make-message
    (lambda _$args177730_
      (apply make-struct-instance std/actor/message#message::t _$args177730_)))
  (define std/actor/message#message-e
    (make-struct-field-accessor std/actor/message#message::t '0))
  (define std/actor/message#message-source
    (make-struct-field-accessor std/actor/message#message::t '1))
  (define std/actor/message#message-dest
    (make-struct-field-accessor std/actor/message#message::t '2))
  (define std/actor/message#message-options
    (make-struct-field-accessor std/actor/message#message::t '3))
  (define std/actor/message#message-e-set!
    (make-struct-field-mutator std/actor/message#message::t '0))
  (define std/actor/message#message-source-set!
    (make-struct-field-mutator std/actor/message#message::t '1))
  (define std/actor/message#message-dest-set!
    (make-struct-field-mutator std/actor/message#message::t '2))
  (define std/actor/message#message-options-set!
    (make-struct-field-mutator std/actor/message#message::t '3))
  (define std/actor/message#proxy::t
    (make-struct-type
     'std/actor/message#proxy::t
     '#f
     '1
     'proxy
     '()
     '#f
     '(handler)))
  (define std/actor/message#proxy?
    (make-struct-predicate std/actor/message#proxy::t))
  (define std/actor/message#make-proxy
    (lambda _$args177727_
      (apply make-struct-instance std/actor/message#proxy::t _$args177727_)))
  (define std/actor/message#proxy-handler
    (make-struct-field-accessor std/actor/message#proxy::t '0))
  (define std/actor/message#proxy-handler-set!
    (make-struct-field-mutator std/actor/message#proxy::t '0))
  (define std/actor/message#send__%
    (lambda (_dest177704_ _msg177705_ _raise-dead?177706_)
      (let _lp177708_ ((_dest177710_ _dest177704_))
        (if (thread? _dest177710_)
            (let ((_$e177712_
                   (std/actor/message#thread-send/check
                    _dest177710_
                    _msg177705_)))
              (if _$e177712_
                  _$e177712_
                  (if (not _raise-dead?177706_)
                      '#f
                      (raise (make-struct-instance
                              std/actor/message#actor-error::t
                              'send
                              '"Cannot send message; dead thread"
                              _dest177710_
                              _msg177705_)))))
            (if (let ()
                  (declare (not safe))
                  (##structure-instance-of?
                   _dest177710_
                   'std/actor/message#proxy::t))
                (_lp177708_
                 (##structure-ref
                  _dest177710_
                  '1
                  std/actor/message#proxy::t
                  '#f))
                (_lp177708_
                 (let* ((__self306380 ':actor)
                        (__method306381
                         (method-ref __self306380 _dest177710_)))
                   (if __method306381
                       (__method306381 __self306380)
                       (error '"Missing method"
                              __self306380
                              _dest177710_)))))))))
  (define std/actor/message#send__0
    (lambda (_dest177718_ _msg177719_)
      (let ((_raise-dead?177721_ '#f))
        (std/actor/message#send__%
         _dest177718_
         _msg177719_
         _raise-dead?177721_))))
  (define std/actor/message#send
    (lambda _g306384_
      (let ((_g306383_ (let () (declare (not safe)) (##length _g306384_))))
        (cond ((let () (declare (not safe)) (##fx= _g306383_ 2))
               (apply std/actor/message#send__0 _g306384_))
              ((let () (declare (not safe)) (##fx= _g306383_ 3))
               (apply std/actor/message#send__% _g306384_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/message#send
                _g306384_))))))
  (define std/actor/message#send-message__%
    (lambda (_dest177677_ _value177678_ _options177679_ _check-dead?177680_)
      (std/actor/message#send__%
       _dest177677_
       (let ((__tmp306385 (current-thread)))
         (declare (not safe))
         (##structure
          std/actor/message#message::t
          _value177678_
          __tmp306385
          _dest177677_
          _options177679_))
       _check-dead?177680_)))
  (define std/actor/message#send-message__0
    (lambda (_dest177685_ _value177686_)
      (let* ((_options177688_ '#f)
             (_check-dead?177690_
              (let ()
                (declare (not safe))
                (##structure-instance-of?
                 _dest177685_
                 'std/actor/message#proxy::t))))
        (std/actor/message#send-message__%
         _dest177685_
         _value177686_
         _options177688_
         _check-dead?177690_))))
  (define std/actor/message#send-message__1
    (lambda (_dest177692_ _value177693_ _options177694_)
      (let ((_check-dead?177696_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _dest177692_
                'std/actor/message#proxy::t))))
        (std/actor/message#send-message__%
         _dest177692_
         _value177693_
         _options177694_
         _check-dead?177696_))))
  (define std/actor/message#send-message
    (lambda _g306387_
      (let ((_g306386_ (let () (declare (not safe)) (##length _g306387_))))
        (cond ((let () (declare (not safe)) (##fx= _g306386_ 2))
               (apply std/actor/message#send-message__0 _g306387_))
              ((let () (declare (not safe)) (##fx= _g306386_ 3))
               (apply std/actor/message#send-message__1 _g306387_))
              ((let () (declare (not safe)) (##fx= _g306386_ 4))
               (apply std/actor/message#send-message__% _g306387_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/message#send-message
                _g306387_))))))
  (define std/actor/message#send-message/timeout__%
    (lambda (_dest177657_ _value177658_ _timeo177659_ _check-dead?177660_)
      (std/actor/message#send__%
       _dest177657_
       (let ((__tmp306389 (current-thread))
             (__tmp306388 (cons 'timeout: (cons _timeo177659_ '()))))
         (declare (not safe))
         (##structure
          std/actor/message#message::t
          _value177658_
          __tmp306389
          _dest177657_
          __tmp306388))
       _check-dead?177660_)))
  (define std/actor/message#send-message/timeout__0
    (lambda (_dest177665_ _value177666_ _timeo177667_)
      (let ((_check-dead?177669_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _dest177665_
                'std/actor/message#proxy::t))))
        (std/actor/message#send-message/timeout__%
         _dest177665_
         _value177666_
         _timeo177667_
         _check-dead?177669_))))
  (define std/actor/message#send-message/timeout
    (lambda _g306391_
      (let ((_g306390_ (let () (declare (not safe)) (##length _g306391_))))
        (cond ((let () (declare (not safe)) (##fx= _g306390_ 3))
               (apply std/actor/message#send-message/timeout__0 _g306391_))
              ((let () (declare (not safe)) (##fx= _g306390_ 4))
               (apply std/actor/message#send-message/timeout__% _g306391_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/message#send-message/timeout
                _g306391_))))))
  (namespace ("std/actor/message#" send thread-send/check))
  (define (thread-send/check thread msg)
    (declare (not interrupts-enabled))
    (macro-check-initialized-thread
     thread
     (send thread msg)
     (if (macro-thread-end-condvar thread) (##thread-send thread msg) #f)))
  (define std/actor/message#receive-timeout
    (lambda _args177592_
      (letrec* ((_now177594_ '#f))
        (let _lp177596_ ((_rest177598_ _args177592_)
                         (_timeo177599_ absent-obj)
                         (_deadline177600_ '#f)
                         (_K177601_ void))
          (let* ((_rest177602177612_ _rest177598_)
                 (_else177604177620_
                  (lambda () (values _timeo177599_ _K177601_)))
                 (_K177606177637_
                  (lambda (_rest177623_ _k177624_ _evt177625_)
                    (if (not _evt177625_)
                        (_lp177596_
                         _rest177623_
                         _timeo177599_
                         _deadline177600_
                         _K177601_)
                        (if (time? _evt177625_)
                            (let ((_evt-deadline177627_
                                   (time->seconds _evt177625_)))
                              (if (or (not _deadline177600_)
                                      (< _evt-deadline177627_
                                         _deadline177600_))
                                  (_lp177596_
                                   _rest177623_
                                   _evt177625_
                                   _evt-deadline177627_
                                   _k177624_)
                                  (_lp177596_
                                   _rest177623_
                                   _timeo177599_
                                   _deadline177600_
                                   _K177601_)))
                            (if (real? _evt177625_)
                                (begin
                                  (if _now177594_
                                      '#!void
                                      (set! _now177594_
                                            (let ()
                                              (declare (not safe))
                                              (##current-time-point))))
                                  (let ((_evt-deadline177632_
                                         (+ _now177594_ _evt177625_)))
                                    (if (or (not _deadline177600_)
                                            (< _evt-deadline177632_
                                               _deadline177600_))
                                        (_lp177596_
                                         _rest177623_
                                         (seconds->time _evt-deadline177632_)
                                         _evt-deadline177632_
                                         _k177624_)
                                        (_lp177596_
                                         _rest177623_
                                         _timeo177599_
                                         _deadline177600_
                                         _K177601_))))
                                (error '"Illegal event; expected time, real, or #f"
                                       _evt177625_)))))))
            (if (let () (declare (not safe)) (##pair? _rest177602177612_))
                (let ((_hd177607177640_
                       (let ()
                         (declare (not safe))
                         (##car _rest177602177612_)))
                      (_tl177608177642_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest177602177612_))))
                  (let ((_evt177645_ _hd177607177640_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl177608177642_))
                        (let ((_hd177609177647_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl177608177642_)))
                              (_tl177610177649_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl177608177642_))))
                          (let* ((_k177652_ _hd177609177647_)
                                 (_rest177654_ _tl177610177649_))
                            (_K177606177637_
                             _rest177654_
                             _k177652_
                             _evt177645_)))
                        (_else177604177620_))))
                (_else177604177620_)))))))
  (define std/actor/message#mailbox-timeout '#(timeout))
  (namespace ("std/actor/message#" mailbox-empty mailbox-next))
  (define mailbox-empty '#(empty))
  (define (mailbox-next)
    (declare (not interrupts-enabled))
    (let* ((mb (##thread-mailbox-get! (macro-current-thread)))
           (cursor (macro-mailbox-cursor mb))
           (next (if cursor (macro-fifo-next cursor) (macro-mailbox-fifo mb)))
           (next2 (macro-fifo-next next)))
      (if (##pair? next2)
          (let ((result (macro-fifo-elem next2)))
            (macro-mailbox-cursor-set! mb next)
            result)
          mailbox-empty))))
