(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/actor/rpc/base#!rpc-protocol::t
    (make-struct-type
     'std/actor/rpc/base#!rpc-protocol::t
     '#f
     '2
     '!rpc-protocol
     '()
     '#f
     '(connect accept)))
  (define std/actor/rpc/base#!rpc-protocol?
    (make-struct-predicate std/actor/rpc/base#!rpc-protocol::t))
  (define std/actor/rpc/base#make-!rpc-protocol
    (lambda _$args253916_
      (apply make-struct-instance
             std/actor/rpc/base#!rpc-protocol::t
             _$args253916_)))
  (define std/actor/rpc/base#!rpc-protocol-connect
    (make-struct-field-accessor std/actor/rpc/base#!rpc-protocol::t '0))
  (define std/actor/rpc/base#!rpc-protocol-accept
    (make-struct-field-accessor std/actor/rpc/base#!rpc-protocol::t '1))
  (define std/actor/rpc/base#!rpc-protocol-connect-set!
    (make-struct-field-mutator std/actor/rpc/base#!rpc-protocol::t '0))
  (define std/actor/rpc/base#!rpc-protocol-accept-set!
    (make-struct-field-mutator std/actor/rpc/base#!rpc-protocol::t '1))
  (define std/actor/rpc/base#xdr-read-uuid
    (lambda (_buffer253912_)
      (let ((_bytes253914_ (make-u8vector std/misc/uuid#uuid-length)))
        (std/net/bio/input#bio-read-bytes _bytes253914_ _buffer253912_)
        (let ()
          (declare (not safe))
          (##structure std/misc/uuid#uuid::t _bytes253914_ '#f)))))
  (define std/actor/rpc/base#xdr-write-uuid
    (lambda (_obj253909_ _buffer253910_)
      (std/net/bio/output#bio-write-subu8vector
       (##direct-structure-ref _obj253909_ '1 std/misc/uuid#uuid::t '#f)
       '0
       std/misc/uuid#uuid-length
       _buffer253910_)))
  (table-set!
   std/actor/xdr#+xdr-default-type-registry+
   (let () (declare (not safe)) (##type-id std/misc/uuid#uuid::t))
   (let ()
     (declare (not safe))
     (##structure
      std/actor/xdr#XDR::t
      std/actor/rpc/base#xdr-read-uuid
      std/actor/rpc/base#xdr-write-uuid)))
  (table-set!
   std/actor/xdr#+xdr-default-type-registry+
   (let () (declare (not safe)) (##type-id std/actor/message#actor-error::t))
   (let ((__tmp310476
          (lambda (_buffer253906_)
            (std/actor/xdr#xdr-read-struct
             std/actor/message#actor-error::t
             _buffer253906_))))
     (declare (not safe))
     (##structure
      std/actor/xdr#XDR::t
      __tmp310476
      std/actor/xdr#xdr-write-struct)))
  (table-set!
   std/actor/xdr#+xdr-default-type-registry+
   (let () (declare (not safe)) (##type-id std/actor/proto#remote-error::t))
   (let ((__tmp310477
          (lambda (_buffer253903_)
            (std/actor/xdr#xdr-read-struct
             std/actor/proto#remote-error::t
             _buffer253903_))))
     (declare (not safe))
     (##structure
      std/actor/xdr#XDR::t
      __tmp310477
      std/actor/xdr#xdr-write-struct)))
  (table-set!
   std/actor/xdr#+xdr-default-type-registry+
   (let () (declare (not safe)) (##type-id std/actor/proto#rpc-error::t))
   (let ((__tmp310478
          (lambda (_buffer253900_)
            (std/actor/xdr#xdr-read-struct
             std/actor/proto#rpc-error::t
             _buffer253900_))))
     (declare (not safe))
     (##structure
      std/actor/xdr#XDR::t
      __tmp310478
      std/actor/xdr#xdr-write-struct)))
  (define std/actor/rpc/base#rpc::proto
    (let ((__tmp310479 (hash-copy std/actor/xdr#+xdr-default-type-registry+)))
      (declare (not safe))
      (##structure
       std/actor/proto#!protocol::t
       'std/actor#rpc
       '()
       __tmp310479)))
  (define std/actor/rpc/base#rpc.connect::t
    (make-struct-type
     'std/actor#rpc.connect::t
     '#f
     '3
     'rpc.connect
     '((final: . #t))
     '#f
     '(id address proto)))
  (define std/actor/rpc/base#rpc.connect?
    (make-struct-predicate std/actor/rpc/base#rpc.connect::t))
  (define std/actor/rpc/base#make-rpc.connect
    (lambda _$args253897_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.connect::t
             _$args253897_)))
  (define std/actor/rpc/base#rpc.connect-id
    (make-struct-field-accessor std/actor/rpc/base#rpc.connect::t '0))
  (define std/actor/rpc/base#rpc.connect-address
    (make-struct-field-accessor std/actor/rpc/base#rpc.connect::t '1))
  (define std/actor/rpc/base#rpc.connect-proto
    (make-struct-field-accessor std/actor/rpc/base#rpc.connect::t '2))
  (define std/actor/rpc/base#rpc.connect-id-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.connect::t '0))
  (define std/actor/rpc/base#rpc.connect-address-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.connect::t '1))
  (define std/actor/rpc/base#rpc.connect-proto-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.connect::t '2))
  (define std/actor/rpc/base#xdr-rpc.connect-read
    (lambda (_buffer253895_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.connect::t
       _buffer253895_)))
  (define std/actor/rpc/base#xdr-rpc.connect-write
    (lambda (_obj253892_ _buffer253893_)
      (std/actor/xdr#xdr-write-struct _obj253892_ _buffer253893_)))
  (define std/actor/rpc/base#rpc.connect::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.connect-read
       std/actor/rpc/base#xdr-rpc.connect-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.connect::t
   std/actor/rpc/base#rpc.connect::xdr)
  (define std/actor/rpc/base#rpc.register::t
    (make-struct-type
     'std/actor#rpc.register::t
     '#f
     '2
     'rpc.register
     '((final: . #t))
     '#f
     '(id proto)))
  (define std/actor/rpc/base#rpc.register?
    (make-struct-predicate std/actor/rpc/base#rpc.register::t))
  (define std/actor/rpc/base#make-rpc.register
    (lambda _$args253889_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.register::t
             _$args253889_)))
  (define std/actor/rpc/base#rpc.register-id
    (make-struct-field-accessor std/actor/rpc/base#rpc.register::t '0))
  (define std/actor/rpc/base#rpc.register-proto
    (make-struct-field-accessor std/actor/rpc/base#rpc.register::t '1))
  (define std/actor/rpc/base#rpc.register-id-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.register::t '0))
  (define std/actor/rpc/base#rpc.register-proto-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.register::t '1))
  (define std/actor/rpc/base#xdr-rpc.register-read
    (lambda (_buffer253887_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.register::t
       _buffer253887_)))
  (define std/actor/rpc/base#xdr-rpc.register-write
    (lambda (_obj253884_ _buffer253885_)
      (std/actor/xdr#xdr-write-struct _obj253884_ _buffer253885_)))
  (define std/actor/rpc/base#rpc.register::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.register-read
       std/actor/rpc/base#xdr-rpc.register-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.register::t
   std/actor/rpc/base#rpc.register::xdr)
  (define std/actor/rpc/base#rpc.unregister::t
    (make-struct-type
     'std/actor#rpc.unregister::t
     '#f
     '1
     'rpc.unregister
     '((final: . #t))
     '#f
     '(id)))
  (define std/actor/rpc/base#rpc.unregister?
    (make-struct-predicate std/actor/rpc/base#rpc.unregister::t))
  (define std/actor/rpc/base#make-rpc.unregister
    (lambda _$args253881_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.unregister::t
             _$args253881_)))
  (define std/actor/rpc/base#rpc.unregister-id
    (make-struct-field-accessor std/actor/rpc/base#rpc.unregister::t '0))
  (define std/actor/rpc/base#rpc.unregister-id-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.unregister::t '0))
  (define std/actor/rpc/base#xdr-rpc.unregister-read
    (lambda (_buffer253879_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.unregister::t
       _buffer253879_)))
  (define std/actor/rpc/base#xdr-rpc.unregister-write
    (lambda (_obj253876_ _buffer253877_)
      (std/actor/xdr#xdr-write-struct _obj253876_ _buffer253877_)))
  (define std/actor/rpc/base#rpc.unregister::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.unregister-read
       std/actor/rpc/base#xdr-rpc.unregister-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.unregister::t
   std/actor/rpc/base#rpc.unregister::xdr)
  (define std/actor/rpc/base#rpc.resolve::t
    (make-struct-type
     'std/actor#rpc.resolve::t
     '#f
     '1
     'rpc.resolve
     '((final: . #t))
     '#f
     '(id)))
  (define std/actor/rpc/base#rpc.resolve?
    (make-struct-predicate std/actor/rpc/base#rpc.resolve::t))
  (define std/actor/rpc/base#make-rpc.resolve
    (lambda _$args253873_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.resolve::t
             _$args253873_)))
  (define std/actor/rpc/base#rpc.resolve-id
    (make-struct-field-accessor std/actor/rpc/base#rpc.resolve::t '0))
  (define std/actor/rpc/base#rpc.resolve-id-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.resolve::t '0))
  (define std/actor/rpc/base#xdr-rpc.resolve-read
    (lambda (_buffer253871_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.resolve::t
       _buffer253871_)))
  (define std/actor/rpc/base#xdr-rpc.resolve-write
    (lambda (_obj253868_ _buffer253869_)
      (std/actor/xdr#xdr-write-struct _obj253868_ _buffer253869_)))
  (define std/actor/rpc/base#rpc.resolve::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.resolve-read
       std/actor/rpc/base#xdr-rpc.resolve-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.resolve::t
   std/actor/rpc/base#rpc.resolve::xdr)
  (define std/actor/rpc/base#rpc.server-address::t
    (make-struct-type
     'std/actor#rpc.server-address::t
     '#f
     '0
     'rpc.server-address
     '((final: . #t))
     '#f
     '()))
  (define std/actor/rpc/base#rpc.server-address?
    (make-struct-predicate std/actor/rpc/base#rpc.server-address::t))
  (define std/actor/rpc/base#make-rpc.server-address
    (lambda _$args253865_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.server-address::t
             _$args253865_)))
  (define std/actor/rpc/base#xdr-rpc.server-address-read
    (lambda (_buffer253863_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.server-address::t
       _buffer253863_)))
  (define std/actor/rpc/base#xdr-rpc.server-address-write
    (lambda (_obj253860_ _buffer253861_)
      (std/actor/xdr#xdr-write-struct _obj253860_ _buffer253861_)))
  (define std/actor/rpc/base#rpc.server-address::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.server-address-read
       std/actor/rpc/base#xdr-rpc.server-address-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.server-address::t
   std/actor/rpc/base#rpc.server-address::xdr)
  (define std/actor/rpc/base#rpc.connection-accept::t
    (make-struct-type
     'std/actor#rpc.connection-accept::t
     '#f
     '2
     'rpc.connection-accept
     '((final: . #t))
     '#f
     '(sock sa)))
  (define std/actor/rpc/base#rpc.connection-accept?
    (make-struct-predicate std/actor/rpc/base#rpc.connection-accept::t))
  (define std/actor/rpc/base#make-rpc.connection-accept
    (lambda _$args253857_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.connection-accept::t
             _$args253857_)))
  (define std/actor/rpc/base#rpc.connection-accept-sock
    (make-struct-field-accessor
     std/actor/rpc/base#rpc.connection-accept::t
     '0))
  (define std/actor/rpc/base#rpc.connection-accept-sa
    (make-struct-field-accessor
     std/actor/rpc/base#rpc.connection-accept::t
     '1))
  (define std/actor/rpc/base#rpc.connection-accept-sock-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.connection-accept::t '0))
  (define std/actor/rpc/base#rpc.connection-accept-sa-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.connection-accept::t '1))
  (define std/actor/rpc/base#xdr-rpc.connection-accept-read
    (lambda (_buffer253855_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.connection-accept::t
       _buffer253855_)))
  (define std/actor/rpc/base#xdr-rpc.connection-accept-write
    (lambda (_obj253852_ _buffer253853_)
      (std/actor/xdr#xdr-write-struct _obj253852_ _buffer253853_)))
  (define std/actor/rpc/base#rpc.connection-accept::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.connection-accept-read
       std/actor/rpc/base#xdr-rpc.connection-accept-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.connection-accept::t
   std/actor/rpc/base#rpc.connection-accept::xdr)
  (define std/actor/rpc/base#rpc.connection-shutdown::t
    (make-struct-type
     'std/actor#rpc.connection-shutdown::t
     '#f
     '0
     'rpc.connection-shutdown
     '((final: . #t))
     '#f
     '()))
  (define std/actor/rpc/base#rpc.connection-shutdown?
    (make-struct-predicate std/actor/rpc/base#rpc.connection-shutdown::t))
  (define std/actor/rpc/base#make-rpc.connection-shutdown
    (lambda _$args253849_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.connection-shutdown::t
             _$args253849_)))
  (define std/actor/rpc/base#xdr-rpc.connection-shutdown-read
    (lambda (_buffer253847_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.connection-shutdown::t
       _buffer253847_)))
  (define std/actor/rpc/base#xdr-rpc.connection-shutdown-write
    (lambda (_obj253844_ _buffer253845_)
      (std/actor/xdr#xdr-write-struct _obj253844_ _buffer253845_)))
  (define std/actor/rpc/base#rpc.connection-shutdown::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.connection-shutdown-read
       std/actor/rpc/base#xdr-rpc.connection-shutdown-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.connection-shutdown::t
   std/actor/rpc/base#rpc.connection-shutdown::xdr)
  (define std/actor/rpc/base#rpc.connection-close::t
    (make-struct-type
     'std/actor#rpc.connection-close::t
     '#f
     '0
     'rpc.connection-close
     '((final: . #t))
     '#f
     '()))
  (define std/actor/rpc/base#rpc.connection-close?
    (make-struct-predicate std/actor/rpc/base#rpc.connection-close::t))
  (define std/actor/rpc/base#make-rpc.connection-close
    (lambda _$args253841_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.connection-close::t
             _$args253841_)))
  (define std/actor/rpc/base#xdr-rpc.connection-close-read
    (lambda (_buffer253839_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.connection-close::t
       _buffer253839_)))
  (define std/actor/rpc/base#xdr-rpc.connection-close-write
    (lambda (_obj253836_ _buffer253837_)
      (std/actor/xdr#xdr-write-struct _obj253836_ _buffer253837_)))
  (define std/actor/rpc/base#rpc.connection-close::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.connection-close-read
       std/actor/rpc/base#xdr-rpc.connection-close-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.connection-close::t
   std/actor/rpc/base#rpc.connection-close::xdr)
  (define std/actor/rpc/base#rpc.monitor::t
    (make-struct-type
     'std/actor#rpc.monitor::t
     '#f
     '1
     'rpc.monitor
     '((final: . #t))
     '#f
     '(remote)))
  (define std/actor/rpc/base#rpc.monitor?
    (make-struct-predicate std/actor/rpc/base#rpc.monitor::t))
  (define std/actor/rpc/base#make-rpc.monitor
    (lambda _$args253833_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.monitor::t
             _$args253833_)))
  (define std/actor/rpc/base#rpc.monitor-remote
    (make-struct-field-accessor std/actor/rpc/base#rpc.monitor::t '0))
  (define std/actor/rpc/base#rpc.monitor-remote-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.monitor::t '0))
  (define std/actor/rpc/base#xdr-rpc.monitor-read
    (lambda (_buffer253831_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.monitor::t
       _buffer253831_)))
  (define std/actor/rpc/base#xdr-rpc.monitor-write
    (lambda (_obj253828_ _buffer253829_)
      (std/actor/xdr#xdr-write-struct _obj253828_ _buffer253829_)))
  (define std/actor/rpc/base#rpc.monitor::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.monitor-read
       std/actor/rpc/base#xdr-rpc.monitor-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.monitor::t
   std/actor/rpc/base#rpc.monitor::xdr)
  (define std/actor/rpc/base#rpc.unmonitor::t
    (make-struct-type
     'std/actor#rpc.unmonitor::t
     '#f
     '1
     'rpc.unmonitor
     '((final: . #t))
     '#f
     '(remote)))
  (define std/actor/rpc/base#rpc.unmonitor?
    (make-struct-predicate std/actor/rpc/base#rpc.unmonitor::t))
  (define std/actor/rpc/base#make-rpc.unmonitor
    (lambda _$args253825_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.unmonitor::t
             _$args253825_)))
  (define std/actor/rpc/base#rpc.unmonitor-remote
    (make-struct-field-accessor std/actor/rpc/base#rpc.unmonitor::t '0))
  (define std/actor/rpc/base#rpc.unmonitor-remote-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.unmonitor::t '0))
  (define std/actor/rpc/base#xdr-rpc.unmonitor-read
    (lambda (_buffer253823_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.unmonitor::t
       _buffer253823_)))
  (define std/actor/rpc/base#xdr-rpc.unmonitor-write
    (lambda (_obj253820_ _buffer253821_)
      (std/actor/xdr#xdr-write-struct _obj253820_ _buffer253821_)))
  (define std/actor/rpc/base#rpc.unmonitor::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.unmonitor-read
       std/actor/rpc/base#xdr-rpc.unmonitor-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.unmonitor::t
   std/actor/rpc/base#rpc.unmonitor::xdr)
  (define std/actor/rpc/base#rpc.disconnect::t
    (make-struct-type
     'std/actor#rpc.disconnect::t
     '#f
     '1
     'rpc.disconnect
     '((final: . #t))
     '#f
     '(remote)))
  (define std/actor/rpc/base#rpc.disconnect?
    (make-struct-predicate std/actor/rpc/base#rpc.disconnect::t))
  (define std/actor/rpc/base#make-rpc.disconnect
    (lambda _$args253817_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.disconnect::t
             _$args253817_)))
  (define std/actor/rpc/base#rpc.disconnect-remote
    (make-struct-field-accessor std/actor/rpc/base#rpc.disconnect::t '0))
  (define std/actor/rpc/base#rpc.disconnect-remote-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.disconnect::t '0))
  (define std/actor/rpc/base#xdr-rpc.disconnect-read
    (lambda (_buffer253815_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.disconnect::t
       _buffer253815_)))
  (define std/actor/rpc/base#xdr-rpc.disconnect-write
    (lambda (_obj253812_ _buffer253813_)
      (std/actor/xdr#xdr-write-struct _obj253812_ _buffer253813_)))
  (define std/actor/rpc/base#rpc.disconnect::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.disconnect-read
       std/actor/rpc/base#xdr-rpc.disconnect-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.disconnect::t
   std/actor/rpc/base#rpc.disconnect::xdr)
  (define std/actor/rpc/base#rpc.shutdown::t
    (make-struct-type
     'std/actor#rpc.shutdown::t
     '#f
     '0
     'rpc.shutdown
     '((final: . #t))
     '#f
     '()))
  (define std/actor/rpc/base#rpc.shutdown?
    (make-struct-predicate std/actor/rpc/base#rpc.shutdown::t))
  (define std/actor/rpc/base#make-rpc.shutdown
    (lambda _$args253809_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.shutdown::t
             _$args253809_)))
  (define std/actor/rpc/base#xdr-rpc.shutdown-read
    (lambda (_buffer253807_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.shutdown::t
       _buffer253807_)))
  (define std/actor/rpc/base#xdr-rpc.shutdown-write
    (lambda (_obj253802_ _buffer253804_)
      (std/actor/xdr#xdr-write-struct _obj253802_ _buffer253804_)))
  (define std/actor/rpc/base#rpc.shutdown::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.shutdown-read
       std/actor/rpc/base#xdr-rpc.shutdown-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.shutdown::t
   std/actor/rpc/base#rpc.shutdown::xdr)
  (define std/actor/rpc/base#null-uuid
    (std/misc/uuid#u8vector->uuid (make-u8vector std/misc/uuid#uuid-length)))
  (define std/actor/rpc/base#rpc-monitor__%
    (lambda (_thread253782_ _msg253783_)
      (letrec ((_thread-monitor253785_
                (lambda (_server253787_ _thread253788_ _msg253789_)
                  (with-exception-catcher
                   values
                   (lambda () (thread-join! _thread253788_)))
                  (thread-send _server253787_ _msg253789_))))
        (gerbil/gambit/threads#spawn/name
         'rpc-monitor
         _thread-monitor253785_
         (current-thread)
         _thread253782_
         _msg253783_))))
  (define std/actor/rpc/base#rpc-monitor__0
    (lambda (_thread253795_)
      (let ((_msg253797_ _thread253795_))
        (std/actor/rpc/base#rpc-monitor__% _thread253795_ _msg253797_))))
  (define std/actor/rpc/base#rpc-monitor
    (lambda _g310481_
      (let ((_g310480_ (let () (declare (not safe)) (##length _g310481_))))
        (cond ((let () (declare (not safe)) (##fx= _g310480_ 1))
               (apply std/actor/rpc/base#rpc-monitor__0 _g310481_))
              ((let () (declare (not safe)) (##fx= _g310480_ 2))
               (apply std/actor/rpc/base#rpc-monitor__% _g310481_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/base#rpc-monitor
                _g310481_))))))
  (define std/actor/rpc/base#make-uuid-table
    (lambda ()
      (make-table 'test: std/misc/uuid#uuid=? 'hash: std/misc/uuid#uuid-hash)))
  (define std/actor/rpc/base#+protocols+ (std/actor/rpc/base#make-uuid-table))
  (define std/actor/rpc/base#bind-protocol!
    (lambda (_id253777_ _proto253778_)
      (if (let ()
            (declare (not safe))
            (##structure-direct-instance-of?
             _proto253778_
             'std/actor/proto#!protocol::t))
          '#!void
          (error '"Bad protocol" _proto253778_))
      (table-set!
       std/actor/rpc/base#+protocols+
       (std/misc/uuid#UUID _id253777_)
       _proto253778_)))
  (define std/actor/rpc/base#lookup-protocol
    (lambda (_uuid253775_)
      (table-ref std/actor/rpc/base#+protocols+ _uuid253775_ '#f)))
  (define std/actor/rpc/base#make-actor-table
    (lambda ()
      (let ((__obj310475 (make-object std/misc/sync#sync-hash::t '2)))
        (std/misc/sync#sync-hash:::init!
         __obj310475
         (std/actor/rpc/base#make-uuid-table))
        __obj310475)))
  (define std/actor/rpc/base#actor-table-put!
    (lambda (_at253769_ _uuid253770_ _actor253771_ _proto253772_)
      (std/misc/sync#sync-hash-put!
       _at253769_
       _uuid253770_
       (values _actor253771_ _proto253772_)))))
