(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/coroutine#current-coroutine (make-parameter '#f))
  (define std/coroutine#cort::t
    (make-struct-type
     'std/coroutine#cort::t
     '#f
     '3
     'cort
     '((final: . #t))
     '#f
     '(k end? res)))
  (define std/coroutine#cort? (make-struct-predicate std/coroutine#cort::t))
  (define std/coroutine#make-cort
    (lambda _$args20094_
      (apply make-struct-instance std/coroutine#cort::t _$args20094_)))
  (define std/coroutine#cort-k
    (make-struct-field-accessor std/coroutine#cort::t '0))
  (define std/coroutine#cort-end?
    (make-struct-field-accessor std/coroutine#cort::t '1))
  (define std/coroutine#cort-res
    (make-struct-field-accessor std/coroutine#cort::t '2))
  (define std/coroutine#cort-k-set!
    (make-struct-field-mutator std/coroutine#cort::t '0))
  (define std/coroutine#cort-end?-set!
    (make-struct-field-mutator std/coroutine#cort::t '1))
  (define std/coroutine#cort-res-set!
    (make-struct-field-mutator std/coroutine#cort::t '2))
  (define std/coroutine#cothr::t
    (make-struct-type
     'std/coroutine#cothr::t
     '#f
     '4
     'cothr
     '((final: . #t))
     '#f
     '(mx cv state val)))
  (define std/coroutine#cothr? (make-struct-predicate std/coroutine#cothr::t))
  (define std/coroutine#make-cothr
    (lambda _$args20091_
      (apply make-struct-instance std/coroutine#cothr::t _$args20091_)))
  (define std/coroutine#cothr-mx
    (make-struct-field-accessor std/coroutine#cothr::t '0))
  (define std/coroutine#cothr-cv
    (make-struct-field-accessor std/coroutine#cothr::t '1))
  (define std/coroutine#cothr-state
    (make-struct-field-accessor std/coroutine#cothr::t '2))
  (define std/coroutine#cothr-val
    (make-struct-field-accessor std/coroutine#cothr::t '3))
  (define std/coroutine#cothr-mx-set!
    (make-struct-field-mutator std/coroutine#cothr::t '0))
  (define std/coroutine#cothr-cv-set!
    (make-struct-field-mutator std/coroutine#cothr::t '1))
  (define std/coroutine#cothr-state-set!
    (make-struct-field-mutator std/coroutine#cothr::t '2))
  (define std/coroutine#cothr-val-set!
    (make-struct-field-mutator std/coroutine#cothr::t '3))
  (define std/coroutine#coroutine
    (lambda (_proc20085_ . _args20086_)
      (call-with-current-continuation
       (lambda (_k20088_)
         (std/coroutine#coroutine-start!
          _k20088_
          (if (null? _args20086_)
              _proc20085_
              (lambda () (apply _proc20085_ _args20086_))))))))
  (define std/coroutine#cothread
    (lambda (_proc20076_ . _args20077_)
      (let* ((_cothr20079_
              (let ((__tmp283167 (make-mutex 'coroutine))
                    (__tmp283166 (make-condition-variable 'coroutine)))
                (declare (not safe))
                (##structure
                 std/coroutine#cothr::t
                 __tmp283167
                 __tmp283166
                 'run
                 '#f)))
             (_thread20082_
              (make-thread
               (lambda ()
                 (std/coroutine#cothread-start!
                  _cothr20079_
                  _proc20076_
                  _args20077_))
               'cothread)))
        (thread-specific-set! _thread20082_ _cothr20079_)
        (thread-start! _thread20082_))))
  (define std/coroutine#cothread?
    (lambda (_thread20074_)
      (if (thread? _thread20074_)
          (let ((__tmp283168 (thread-specific _thread20074_)))
            (declare (not safe))
            (##structure-direct-instance-of?
             __tmp283168
             'std/coroutine#cothr::t))
          '#f)))
  (define std/coroutine#continue
    (lambda (_c20071_ . _args20072_)
      (if (let ()
            (declare (not safe))
            (##structure-direct-instance-of? _c20071_ 'std/coroutine#cort::t))
          (std/coroutine#coroutine-continue! _c20071_ _args20072_)
          (if (std/coroutine#cothread? _c20071_)
              (std/coroutine#cothread-continue!
               (thread-specific _c20071_)
               _args20072_)
              (error '"Illegal argument; not continuable" _c20071_)))))
  (define std/coroutine#yield
    (lambda _args20062_
      (let ((_$e20064_ (std/coroutine#current-coroutine)))
        (if _$e20064_
            ((lambda (_g2006620068_)
               (std/coroutine#coroutine-yield! _g2006620068_ _args20062_))
             _$e20064_)
            (if (let ((__tmp283169 (thread-specific (current-thread))))
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   __tmp283169
                   'std/coroutine#cothr::t))
                (std/coroutine#cothread-yield!
                 (thread-specific (current-thread))
                 _args20062_)
                (error '"Not in a coroutine continuation"))))))
  (define std/coroutine#coroutine-start!
    (lambda (_k20050_ _thunk20051_)
      (let ((_c20053_
             (let ()
               (declare (not safe))
               (##structure std/coroutine#cort::t '#f '#f '#f))))
        (call-with-parameters
         (lambda ()
           (call-with-current-continuation
            (lambda (_kk20056_)
              (##direct-structure-set!
               _c20053_
               _kk20056_
               '1
               std/coroutine#cort::t
               '#f)
              (_k20050_ _c20053_)))
           (call-with-values
            _thunk20051_
            (lambda _res20058_
              (let ((_k20060_
                     (##direct-structure-ref
                      _c20053_
                      '1
                      std/coroutine#cort::t
                      '#f)))
                (##direct-structure-set!
                 _c20053_
                 '#t
                 '2
                 std/coroutine#cort::t
                 '#f)
                (##direct-structure-set!
                 _c20053_
                 _res20058_
                 '3
                 std/coroutine#cort::t
                 '#f)
                (##direct-structure-set!
                 _c20053_
                 '#f
                 '1
                 std/coroutine#cort::t
                 '#f)
                (apply _k20060_ _res20058_)))))
         std/coroutine#current-coroutine
         _c20053_))))
  (define std/coroutine#coroutine-continue!
    (lambda (_c20009_ _args20010_)
      (let* ((_c2001120019_ _c20009_)
             (_E2001320023_
              (lambda () (error '"No clause matching" _c2001120019_)))
             (_K2001420032_
              (lambda (_res20026_ _end?20027_ _k20028_)
                (if _end?20027_
                    (apply values _res20026_)
                    (call-with-current-continuation
                     (lambda (_kk20030_)
                       (##direct-structure-set!
                        _c20009_
                        _kk20030_
                        '1
                        std/coroutine#cort::t
                        '#f)
                       (apply _k20028_ _args20010_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c2001120019_
               'std/coroutine#cort::t))
            (let* ((_e2001520035_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c2001120019_ '1)))
                   (_k20038_ _e2001520035_)
                   (_e2001620040_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c2001120019_ '2)))
                   (_end?20043_ _e2001620040_)
                   (_e2001720045_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c2001120019_ '3)))
                   (_res20048_ _e2001720045_))
              (_K2001420032_ _res20048_ _end?20043_ _k20038_))
            (_E2001320023_)))))
  (define std/coroutine#coroutine-yield!
    (lambda (_c19982_ _args19983_)
      (let* ((_c1998419990_ _c19982_)
             (_E1998619994_
              (lambda () (error '"No clause matching" _c1998419990_)))
             (_K1998720001_
              (lambda (_k19997_)
                (call-with-current-continuation
                 (lambda (_kk19999_)
                   (##direct-structure-set!
                    _c19982_
                    _kk19999_
                    '1
                    std/coroutine#cort::t
                    '#f)
                   (apply _k19997_ _args19983_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c1998419990_
               'std/coroutine#cort::t))
            (let* ((_e1998820004_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1998419990_ '1)))
                   (_k20007_ _e1998820004_))
              (_K1998720001_ _k20007_))
            (_E1998619994_)))))
  (define std/coroutine#cothread-start!
    (lambda (_c19968_ _proc19969_ _args19970_)
      (call-with-parameters
       (lambda ()
         (with-exception-catcher
          (lambda (_g1997219974_)
            (if '#t
                (let ((_e19977_ _g1997219974_))
                  (std/coroutine#cothread-signal! _c19968_ 'error _e19977_))
                (raise _g1997219974_)))
          (lambda ()
            (std/coroutine#cothread-wait! _c19968_)
            (let ((_val19980_ (apply _proc19969_ _args19970_)))
              (std/coroutine#cothread-signal! _c19968_ 'end _val19980_)))))
       std/coroutine#current-coroutine
       '#f)))
  (define std/coroutine#cothread-stop!__%
    (lambda (_thread19953_ _val19954_)
      (if (thread? _thread19953_)
          (let ((_spec19956_ (thread-specific _thread19953_)))
            (if (let ()
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   _spec19956_
                   'std/coroutine#cothr::t))
                (std/coroutine#cothread-signal! _spec19956_ 'end _val19954_)
                (error '"Not a coroutine thread" _thread19953_ _spec19956_)))
          (error '"Expected coroutine thread" _thread19953_))))
  (define std/coroutine#cothread-stop!__0
    (lambda (_thread19961_)
      (let ((_val19963_ '#!void))
        (std/coroutine#cothread-stop!__% _thread19961_ _val19963_))))
  (define std/coroutine#cothread-stop!
    (lambda _g283171_
      (let ((_g283170_ (let () (declare (not safe)) (##length _g283171_))))
        (cond ((let () (declare (not safe)) (##fx= _g283170_ 1))
               (apply std/coroutine#cothread-stop!__0 _g283171_))
              ((let () (declare (not safe)) (##fx= _g283170_ 2))
               (apply std/coroutine#cothread-stop!__% _g283171_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/coroutine#cothread-stop!
                _g283171_))))))
  (define std/coroutine#cothread-continue!
    (lambda (_c19894_ _val19895_)
      (let* ((_c1989619905_ _c19894_)
             (_E1989819909_
              (lambda () (error '"No clause matching" _c1989619905_)))
             (_K1989919929_
              (lambda (_kont19912_ _state19913_ _cv19914_ _mx19915_)
                (mutex-lock! _mx19915_)
                (let ((_$e19917_ _state19913_))
                  (if (eq? 'run _$e19917_)
                      (begin
                        (##direct-structure-set!
                         _c19894_
                         _val19895_
                         '4
                         std/coroutine#cothr::t
                         '#f)
                        (##direct-structure-set!
                         _c19894_
                         'continue
                         '3
                         std/coroutine#cothr::t
                         '#f)
                        (condition-variable-signal! _cv19914_)
                        (mutex-unlock! _mx19915_ _cv19914_)
                        (let _lp19920_ ()
                          (mutex-lock! _mx19915_)
                          (let ((_state19923_
                                 (##direct-structure-ref
                                  _c19894_
                                  '3
                                  std/coroutine#cothr::t
                                  '#f))
                                (_kont19924_
                                 (##direct-structure-ref
                                  _c19894_
                                  '4
                                  std/coroutine#cothr::t
                                  '#f)))
                            (let ((_$e19926_ _state19923_))
                              (if (eq? 'continue _$e19926_)
                                  (begin
                                    (mutex-unlock! _mx19915_ _cv19914_)
                                    (_lp19920_))
                                  (if (eq? 'yield _$e19926_)
                                      (begin
                                        (##direct-structure-set!
                                         _c19894_
                                         'run
                                         '3
                                         std/coroutine#cothr::t
                                         '#f)
                                        (mutex-unlock! _mx19915_)
                                        _kont19924_)
                                      (if (eq? 'end _$e19926_)
                                          (begin
                                            (mutex-unlock! _mx19915_)
                                            _kont19924_)
                                          (if (eq? 'error _$e19926_)
                                              (begin
                                                (mutex-unlock! _mx19915_)
                                                (raise _kont19924_))
                                              (begin
                                                (mutex-unlock! _mx19915_)
                                                (error '"Illegal cothread state"
                                                       _state19923_))))))))))
                      (if (eq? 'end _$e19917_)
                          (begin (mutex-unlock! _mx19915_) _kont19912_)
                          (if (eq? 'error _$e19917_)
                              (begin
                                (mutex-unlock! _mx19915_)
                                (raise _kont19912_))
                              (error '"Illegal cothread state"
                                     _state19913_))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c1989619905_
               'std/coroutine#cothr::t))
            (let* ((_e1990019932_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1989619905_ '1)))
                   (_mx19935_ _e1990019932_)
                   (_e1990119937_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1989619905_ '2)))
                   (_cv19940_ _e1990119937_)
                   (_e1990219942_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1989619905_ '3)))
                   (_state19945_ _e1990219942_)
                   (_e1990319947_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1989619905_ '4)))
                   (_kont19950_ _e1990319947_))
              (_K1989919929_ _kont19950_ _state19945_ _cv19940_ _mx19935_))
            (_E1989819909_)))))
  (define std/coroutine#cothread-yield!
    (lambda (_c19889_ _args19890_)
      (let ((_kont19892_
             (std/coroutine#cothread-yield-values!
              _c19889_
              (apply values _args19890_))))
        (std/coroutine#cothread-wait! _c19889_)
        _kont19892_)))
  (define std/coroutine#cothread-yield-values!
    (lambda (_c19840_ _val19841_)
      (let* ((_c1984219851_ _c19840_)
             (_E1984419855_
              (lambda () (error '"No clause matching" _c1984219851_)))
             (_K1984519866_
              (lambda (_kont19858_ _state19859_ _cv19860_ _mx19861_)
                (mutex-lock! _mx19861_)
                (let ((_$e19863_ _state19859_))
                  (if (eq? 'continue _$e19863_)
                      (begin
                        (##direct-structure-set!
                         _c19840_
                         _val19841_
                         '4
                         std/coroutine#cothr::t
                         '#f)
                        (##direct-structure-set!
                         _c19840_
                         'yield
                         '3
                         std/coroutine#cothr::t
                         '#f)
                        (condition-variable-signal! _cv19860_)
                        (mutex-unlock! _mx19861_)
                        _kont19858_)
                      (begin
                        (mutex-unlock! _mx19861_)
                        (error '"Illegal cothread state" _state19859_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c1984219851_
               'std/coroutine#cothr::t))
            (let* ((_e1984619869_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1984219851_ '1)))
                   (_mx19872_ _e1984619869_)
                   (_e1984719874_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1984219851_ '2)))
                   (_cv19877_ _e1984719874_)
                   (_e1984819879_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1984219851_ '3)))
                   (_state19882_ _e1984819879_)
                   (_e1984919884_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1984219851_ '4)))
                   (_kont19887_ _e1984919884_))
              (_K1984519866_ _kont19887_ _state19882_ _cv19877_ _mx19872_))
            (_E1984419855_)))))
  (define std/coroutine#cothread-signal!
    (lambda (_c19807_ _state19808_ _val19809_)
      (let* ((_c1981019817_ _c19807_)
             (_E1981219821_
              (lambda () (error '"No clause matching" _c1981019817_)))
             (_K1981319827_
              (lambda (_cv19824_ _mx19825_)
                (mutex-lock! _mx19825_)
                (if (memq (##direct-structure-ref
                           _c19807_
                           '3
                           std/coroutine#cothr::t
                           '#f)
                          '(end error))
                    '#!void
                    (begin
                      (##direct-structure-set!
                       _c19807_
                       _val19809_
                       '4
                       std/coroutine#cothr::t
                       '#f)
                      (##direct-structure-set!
                       _c19807_
                       _state19808_
                       '3
                       std/coroutine#cothr::t
                       '#f)
                      (condition-variable-signal! _cv19824_)))
                (mutex-unlock! _mx19825_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c1981019817_
               'std/coroutine#cothr::t))
            (let* ((_e1981419830_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1981019817_ '1)))
                   (_mx19833_ _e1981419830_)
                   (_e1981519835_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1981019817_ '2)))
                   (_cv19838_ _e1981519835_))
              (_K1981319827_ _cv19838_ _mx19833_))
            (_E1981219821_)))))
  (define std/coroutine#cothread-wait!
    (lambda (_c19765_)
      (let* ((_c1976619773_ _c19765_)
             (_E1976819777_
              (lambda () (error '"No clause matching" _c1976619773_)))
             (_K1976919794_
              (lambda (_cv19780_ _mx19781_)
                (let _lp19783_ ()
                  (mutex-lock! _mx19781_)
                  (let* ((_state19786_
                          (##direct-structure-ref
                           _c19765_
                           '3
                           std/coroutine#cothr::t
                           '#f))
                         (_$e19788_ _state19786_))
                    (if (or (eq? 'run _$e19788_) (eq? 'yield _$e19788_))
                        (begin (mutex-unlock! _mx19781_ _cv19780_) (_lp19783_))
                        (if (eq? 'continue _$e19788_)
                            (mutex-unlock! _mx19781_)
                            (begin
                              (mutex-unlock! _mx19781_)
                              (error '"Illegal cothread state"
                                     _state19786_)))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c1976619773_
               'std/coroutine#cothr::t))
            (let* ((_e1977019797_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1976619773_ '1)))
                   (_mx19800_ _e1977019797_)
                   (_e1977119802_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1976619773_ '2)))
                   (_cv19805_ _e1977119802_))
              (_K1976919794_ _cv19805_ _mx19800_))
            (_E1976819777_))))))
