(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/conpool#errorf
    (lambda (_fmt260009_ . _args260010_)
      (std/logger#log-message 'connpool '0 _fmt260009_ _args260010_)))
  (define std/db/conpool#warnf
    (lambda (_fmt260006_ . _args260007_)
      (std/logger#log-message 'connpool '1 _fmt260006_ _args260007_)))
  (define std/db/conpool#infof
    (lambda (_fmt260003_ . _args260004_)
      (std/logger#log-message 'connpool '2 _fmt260003_ _args260004_)))
  (define std/db/conpool#debugf
    (lambda (_fmt260000_ . _args260001_)
      (std/logger#log-message 'connpool '3 _fmt260000_ _args260001_)))
  (define std/db/conpool#verbosef
    (lambda (_fmt259995_ . _args259997_)
      (std/logger#log-message 'connpool '4 _fmt259995_ _args259997_)))
  (define std/db/conpool#conpool::t
    (make-struct-type
     'std/db/conpool#conpool::t
     '#f
     '6
     'conpool
     '((final: . #t))
     ':init!
     '(e mx cv conns out max)))
  (define std/db/conpool#conpool?
    (make-struct-predicate std/db/conpool#conpool::t))
  (define std/db/conpool#make-conpool
    (lambda _$args259992_
      (apply make-struct-instance std/db/conpool#conpool::t _$args259992_)))
  (define std/db/conpool#conpool-e
    (make-struct-field-accessor std/db/conpool#conpool::t '0))
  (define std/db/conpool#conpool-mx
    (make-struct-field-accessor std/db/conpool#conpool::t '1))
  (define std/db/conpool#conpool-cv
    (make-struct-field-accessor std/db/conpool#conpool::t '2))
  (define std/db/conpool#conpool-conns
    (make-struct-field-accessor std/db/conpool#conpool::t '3))
  (define std/db/conpool#conpool-out
    (make-struct-field-accessor std/db/conpool#conpool::t '4))
  (define std/db/conpool#conpool-max
    (make-struct-field-accessor std/db/conpool#conpool::t '5))
  (define std/db/conpool#conpool-e-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '0))
  (define std/db/conpool#conpool-mx-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '1))
  (define std/db/conpool#conpool-cv-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '2))
  (define std/db/conpool#conpool-conns-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '3))
  (define std/db/conpool#conpool-out-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '4))
  (define std/db/conpool#conpool-max-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '5))
  (define std/db/conpool#conpool:::init!__%
    (lambda (_self259976_ _connect259977_ _max259978_)
      (if (let ((__tmp311204
                 (let () (declare (not safe)) (##vector-length _self259976_))))
            (declare (not safe))
            (##fx< '6 __tmp311204))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self259976_ '1 _connect259977_))
            (let ((__tmp311205 (make-mutex)))
              (declare (not safe))
              (##vector-set! _self259976_ '2 __tmp311205))
            (let ((__tmp311206 (make-condition-variable)))
              (declare (not safe))
              (##vector-set! _self259976_ '3 __tmp311206))
            (let () (declare (not safe)) (##vector-set! _self259976_ '4 '()))
            (let () (declare (not safe)) (##vector-set! _self259976_ '5 '()))
            (let ()
              (declare (not safe))
              (##vector-set! _self259976_ '6 _max259978_)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self259976_))))
  (define std/db/conpool#conpool:::init!__0
    (lambda (_self259983_ _connect259984_)
      (let ((_max259986_ '#f))
        (std/db/conpool#conpool:::init!__%
         _self259983_
         _connect259984_
         _max259986_))))
  (define std/db/conpool#conpool:::init!
    (lambda _g311208_
      (let ((_g311207_ (let () (declare (not safe)) (##length _g311208_))))
        (cond ((let () (declare (not safe)) (##fx= _g311207_ 2))
               (apply std/db/conpool#conpool:::init!__0 _g311208_))
              ((let () (declare (not safe)) (##fx= _g311207_ 3))
               (apply std/db/conpool#conpool:::init!__% _g311208_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/conpool#conpool:::init!
                _g311208_))))))
  (bind-method!
   std/db/conpool#conpool::t
   ':init!
   std/db/conpool#conpool:::init!
   '#f)
  (define std/db/conpool#conpool-get__%
    (lambda (_cp259735_ _timeo259736_)
      (let* ((_cp259737259748_ _cp259735_)
             (_E259739259752_
              (lambda () (error '"No clause matching" _cp259737259748_)))
             (_K259740259811_
              (lambda (_max259755_
                       _out259756_
                       _cv259757_
                       _mx259758_
                       _connect259759_)
                (let _lp259761_ ()
                  (mutex-lock! _mx259758_)
                  (let* ((_g259763259771_
                          (##direct-structure-ref
                           _cp259735_
                           '4
                           std/db/conpool#conpool::t
                           '#f))
                         (_else259765259793_
                          (lambda ()
                            (if (or (not _max259755_)
                                    (fx< (length _out259756_) _max259755_))
                                (let ((_conn259789_
                                       (with-exception-catcher
                                        (lambda (_g259781259783_)
                                          (if '#t
                                              (let ((_e259786_
                                                     _g259781259783_))
                                                (mutex-unlock! _mx259758_)
                                                (raise _e259786_))
                                              (raise _g259781259783_)))
                                        (lambda () (_connect259759_)))))
                                  (##direct-structure-set!
                                   _cp259735_
                                   (cons _conn259789_ _out259756_)
                                   '5
                                   std/db/conpool#conpool::t
                                   '#f)
                                  (mutex-unlock! _mx259758_)
                                  _conn259789_)
                                (let ((_res259791_
                                       (mutex-unlock!
                                        _mx259758_
                                        _cv259757_
                                        _timeo259736_)))
                                  (if _res259791_
                                      (_lp259761_)
                                      (std/error#raise-timeout
                                       'conpool-get
                                       '"Error getting connection; timeout"))))))
                         (_K259767259799_
                          (lambda (_rest259796_ _conn259797_)
                            (##direct-structure-set!
                             _cp259735_
                             _rest259796_
                             '4
                             std/db/conpool#conpool::t
                             '#f)
                            (##direct-structure-set!
                             _cp259735_
                             (cons _conn259797_ _out259756_)
                             '5
                             std/db/conpool#conpool::t
                             '#f)
                            (mutex-unlock! _mx259758_)
                            _conn259797_)))
                    (if (let () (declare (not safe)) (##pair? _g259763259771_))
                        (let ((_hd259768259802_
                               (let ()
                                 (declare (not safe))
                                 (##car _g259763259771_)))
                              (_tl259769259804_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _g259763259771_))))
                          (let* ((_conn259807_ _hd259768259802_)
                                 (_rest259809_ _tl259769259804_))
                            (_K259767259799_ _rest259809_ _conn259807_)))
                        (_else259765259793_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cp259737259748_
               'std/db/conpool#conpool::t))
            (let* ((_e259741259814_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259737259748_ '1)))
                   (_connect259817_ _e259741259814_)
                   (_e259742259819_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259737259748_ '2)))
                   (_mx259822_ _e259742259819_)
                   (_e259743259824_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259737259748_ '3)))
                   (_cv259827_ _e259743259824_)
                   (_e259744259829_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259737259748_ '4)))
                   (_e259745259832_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259737259748_ '5)))
                   (_out259835_ _e259745259832_)
                   (_e259746259837_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259737259748_ '6)))
                   (_max259840_ _e259746259837_))
              (_K259740259811_
               _max259840_
               _out259835_
               _cv259827_
               _mx259822_
               _connect259817_))
            (_E259739259752_)))))
  (define std/db/conpool#conpool-get__0
    (lambda (_cp259845_)
      (let ((_timeo259847_ absent-obj))
        (std/db/conpool#conpool-get__% _cp259845_ _timeo259847_))))
  (define std/db/conpool#conpool-get
    (lambda _g311210_
      (let ((_g311209_ (let () (declare (not safe)) (##length _g311210_))))
        (cond ((let () (declare (not safe)) (##fx= _g311209_ 1))
               (apply std/db/conpool#conpool-get__0 _g311210_))
              ((let () (declare (not safe)) (##fx= _g311209_ 2))
               (apply std/db/conpool#conpool-get__% _g311210_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/conpool#conpool-get
                _g311210_))))))
  (define std/db/conpool#conpool-put
    (lambda (_cp259684_ _conn259685_)
      (let* ((_cp259686259696_ _cp259684_)
             (_E259688259700_
              (lambda () (error '"No clause matching" _cp259686259696_)))
             (_K259689259708_
              (lambda (_out259703_ _conns259704_ _cv259705_ _mx259706_)
                (mutex-lock! _mx259706_)
                (##direct-structure-set!
                 _cp259684_
                 (cons _conn259685_ _conns259704_)
                 '4
                 std/db/conpool#conpool::t
                 '#f)
                (##direct-structure-set!
                 _cp259684_
                 (remq _conn259685_ _out259703_)
                 '5
                 std/db/conpool#conpool::t
                 '#f)
                (condition-variable-signal! _cv259705_)
                (mutex-unlock! _mx259706_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cp259686259696_
               'std/db/conpool#conpool::t))
            (let* ((_e259690259711_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259686259696_ '1)))
                   (_e259691259714_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259686259696_ '2)))
                   (_mx259717_ _e259691259714_)
                   (_e259692259719_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259686259696_ '3)))
                   (_cv259722_ _e259692259719_)
                   (_e259693259724_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259686259696_ '4)))
                   (_conns259727_ _e259693259724_)
                   (_e259694259729_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259686259696_ '5)))
                   (_out259732_ _e259694259729_))
              (_K259689259708_
               _out259732_
               _conns259727_
               _cv259722_
               _mx259717_))
            (_E259688259700_)))))
  (define std/db/conpool#conpool-release
    (lambda (_cp259634_ _conn259635_)
      (let* ((_cp259636259646_ _cp259634_)
             (_E259638259650_
              (lambda () (error '"No clause matching" _cp259636259646_)))
             (_K259639259658_
              (lambda (_out259653_ _conns259654_ _cv259655_ _mx259656_)
                (mutex-lock! _mx259656_)
                (##direct-structure-set!
                 _cp259634_
                 (remq _conn259635_ _out259653_)
                 '5
                 std/db/conpool#conpool::t
                 '#f)
                (mutex-unlock! _mx259656_)
                (let ((__method311202 (method-ref _conn259635_ 'destroy)))
                  (if __method311202
                      (__method311202 _conn259635_)
                      (error '"Missing method" _conn259635_ 'destroy))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cp259636259646_
               'std/db/conpool#conpool::t))
            (let* ((_e259640259661_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259636259646_ '1)))
                   (_e259641259664_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259636259646_ '2)))
                   (_mx259667_ _e259641259664_)
                   (_e259642259669_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259636259646_ '3)))
                   (_cv259672_ _e259642259669_)
                   (_e259643259674_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259636259646_ '4)))
                   (_conns259677_ _e259643259674_)
                   (_e259644259679_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259636259646_ '5)))
                   (_out259682_ _e259644259679_))
              (_K259639259658_
               _out259682_
               _conns259677_
               _cv259672_
               _mx259667_))
            (_E259638259650_)))))
  (define std/db/conpool#conpool-close
    (lambda (_cp259573_)
      (letrec ((_close259575_
                (lambda (_conn259625_)
                  (with-exception-catcher
                   (lambda (_g259626259628_)
                     (if '#t
                         (let ((_e259631_ _g259626259628_))
                           (std/db/conpool#errorf
                            '"error closing connection: ~a"
                            _e259631_))
                         (raise _g259626259628_)))
                   (lambda ()
                     (let ((__method311203 (method-ref _conn259625_ 'destroy)))
                       (if __method311203
                           (__method311203 _conn259625_)
                           (error '"Missing method"
                                  _conn259625_
                                  'destroy))))))))
        (let* ((_cp259576259586_ _cp259573_)
               (_E259578259590_
                (lambda () (error '"No clause matching" _cp259576259586_)))
               (_K259579259599_
                (lambda (_out259593_ _conns259594_ _cv259595_ _mx259596_)
                  (mutex-lock! _mx259596_)
                  (for-each _close259575_ _conns259594_)
                  (for-each _close259575_ _out259593_)
                  (##direct-structure-set!
                   _cp259573_
                   (lambda () (error '"Connection pool is closed"))
                   '1
                   std/db/conpool#conpool::t
                   '#f)
                  (##direct-structure-set!
                   _cp259573_
                   '()
                   '4
                   std/db/conpool#conpool::t
                   '#f)
                  (##direct-structure-set!
                   _cp259573_
                   '()
                   '5
                   std/db/conpool#conpool::t
                   '#f)
                  (mutex-unlock! _mx259596_))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _cp259576259586_
                 'std/db/conpool#conpool::t))
              (let* ((_e259580259602_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cp259576259586_ '1)))
                     (_e259581259605_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cp259576259586_ '2)))
                     (_mx259608_ _e259581259605_)
                     (_e259582259610_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cp259576259586_ '3)))
                     (_cv259613_ _e259582259610_)
                     (_e259583259615_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cp259576259586_ '4)))
                     (_conns259618_ _e259583259615_)
                     (_e259584259620_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cp259576259586_ '5)))
                     (_out259623_ _e259584259620_))
                (_K259579259599_
                 _out259623_
                 _conns259618_
                 _cv259613_
                 _mx259608_))
              (_E259578259590_)))))))
