(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/leveldb#leveldb-error::t
    (make-struct-type
     'std/db/leveldb#leveldb-error::t
     error::t
     '0
     'leveldb-error
     '()
     '#f
     '()))
  (define std/db/leveldb#leveldb-error?
    (make-struct-predicate std/db/leveldb#leveldb-error::t))
  (define std/db/leveldb#make-leveldb-error
    (lambda _$args277518_
      (apply make-struct-instance
             std/db/leveldb#leveldb-error::t
             _$args277518_)))
  (define std/db/leveldb#raise-leveldb-error
    (lambda (_where277515_ _what277516_)
      (raise (make-struct-instance
              std/db/leveldb#leveldb-error::t
              _what277516_
              '()
              _where277515_))))
  (define std/db/leveldb#raise-leveldb-error/errptr
    (lambda (_where277512_ _errptr277513_)
      (raise (make-struct-instance
              std/db/leveldb#leveldb-error::t
              (std/db/_leveldb#errptr_str _errptr277513_)
              '()
              _where277512_))))
  (define std/db/leveldb#fixnum-positive?
    (lambda (_obj277510_)
      (if (fixnum? _obj277510_)
          (let () (declare (not safe)) (##fxpositive? _obj277510_))
          '#f)))
  (define std/db/leveldb#value-bytes
    (lambda (_key277508_)
      (if (u8vector? _key277508_)
          _key277508_
          (if (string? _key277508_)
              (std/text/utf8#string->utf8__0 _key277508_)
              (error '"Bad argument: expected u8vector or string"
                     _key277508_)))))
  (define std/db/leveldb#leveldb::t
    (make-struct-type
     'std/db/leveldb#leveldb::t
     '#f
     '2
     'leveldb
     '((final: . #t))
     '#f
     '(db opt)))
  (define std/db/leveldb#leveldb?
    (make-struct-predicate std/db/leveldb#leveldb::t))
  (define std/db/leveldb#make-leveldb
    (lambda _$args277505_
      (apply make-struct-instance std/db/leveldb#leveldb::t _$args277505_)))
  (define std/db/leveldb#leveldb-db
    (make-struct-field-accessor std/db/leveldb#leveldb::t '0))
  (define std/db/leveldb#leveldb-opt
    (make-struct-field-accessor std/db/leveldb#leveldb::t '1))
  (define std/db/leveldb#leveldb-db-set!
    (make-struct-field-mutator std/db/leveldb#leveldb::t '0))
  (define std/db/leveldb#leveldb-opt-set!
    (make-struct-field-mutator std/db/leveldb#leveldb::t '1))
  (define std/db/leveldb#leveldb-opts::t
    (make-struct-type
     'std/db/leveldb#leveldb-opts::t
     '#f
     '3
     'leveldb-opts
     '((final: . #t))
     '#f
     '(e cache filter)))
  (define std/db/leveldb#leveldb-opts?
    (make-struct-predicate std/db/leveldb#leveldb-opts::t))
  (define std/db/leveldb#make-leveldb-opts
    (lambda _$args277502_
      (apply make-struct-instance
             std/db/leveldb#leveldb-opts::t
             _$args277502_)))
  (define std/db/leveldb#leveldb-opts-e
    (make-struct-field-accessor std/db/leveldb#leveldb-opts::t '0))
  (define std/db/leveldb#leveldb-opts-cache
    (make-struct-field-accessor std/db/leveldb#leveldb-opts::t '1))
  (define std/db/leveldb#leveldb-opts-filter
    (make-struct-field-accessor std/db/leveldb#leveldb-opts::t '2))
  (define std/db/leveldb#leveldb-opts-e-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-opts::t '0))
  (define std/db/leveldb#leveldb-opts-cache-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-opts::t '1))
  (define std/db/leveldb#leveldb-opts-filter-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-opts::t '2))
  (define std/db/leveldb#leveldb-itor::t
    (make-struct-type
     'std/db/leveldb#leveldb-itor::t
     '#f
     '1
     'leveldb-itor
     '((final: . #t))
     '#f
     '(e)))
  (define std/db/leveldb#leveldb-itor?
    (make-struct-predicate std/db/leveldb#leveldb-itor::t))
  (define std/db/leveldb#make-leveldb-itor
    (lambda _$args277499_
      (apply make-struct-instance
             std/db/leveldb#leveldb-itor::t
             _$args277499_)))
  (define std/db/leveldb#leveldb-itor-e
    (make-struct-field-accessor std/db/leveldb#leveldb-itor::t '0))
  (define std/db/leveldb#leveldb-itor-e-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-itor::t '0))
  (define std/db/leveldb#leveldb-open__%
    (lambda (_name277481_ _opts277482_)
      (let* ((_errptr277484_ (std/db/leveldb#get-errptr))
             (_ptr277486_
              (std/db/_leveldb#leveldb_open
               (##direct-structure-ref
                _opts277482_
                '1
                std/db/leveldb#leveldb-opts::t
                '#f)
               _name277481_
               _errptr277484_)))
        (if _ptr277486_
            (let ()
              (declare (not safe))
              (##structure std/db/leveldb#leveldb::t _ptr277486_ _opts277482_))
            (std/db/leveldb#raise-leveldb-error/errptr
             'leveldb-open
             _errptr277484_)))))
  (define std/db/leveldb#leveldb-open__0
    (lambda (_name277492_)
      (let ((_opts277494_ (std/db/leveldb#leveldb-default-options)))
        (std/db/leveldb#leveldb-open__% _name277492_ _opts277494_))))
  (define std/db/leveldb#leveldb-open
    (lambda _g312774_
      (let ((_g312773_ (let () (declare (not safe)) (##length _g312774_))))
        (cond ((let () (declare (not safe)) (##fx= _g312773_ 1))
               (apply std/db/leveldb#leveldb-open__0 _g312774_))
              ((let () (declare (not safe)) (##fx= _g312773_ 2))
               (apply std/db/leveldb#leveldb-open__% _g312774_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-open
                _g312774_))))))
  (define std/db/leveldb#leveldb-close
    (lambda (_ldb277456_)
      (let* ((_ldb277457277463_ _ldb277456_)
             (_E277459277467_
              (lambda () (error '"No clause matching" _ldb277457277463_)))
             (_K277460277472_
              (lambda (_db277470_)
                (if _db277470_
                    (begin
                      (std/db/_leveldb#leveldb_close _db277470_)
                      (##direct-structure-set!
                       _ldb277456_
                       '#f
                       '1
                       std/db/leveldb#leveldb::t
                       '#f))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277457277463_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277461277475_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277457277463_ '1)))
                   (_db277478_ _e277461277475_))
              (_K277460277472_ _db277478_))
            (_E277459277467_)))))
  (define std/db/leveldb#leveldb::destroy std/db/leveldb#leveldb-close)
  (bind-method!
   std/db/leveldb#leveldb::t
   'destroy
   std/db/leveldb#leveldb::destroy
   '#f)
  (define std/db/leveldb#leveldb-put__%
    (lambda (_ldb277282_ _key277283_ _val277284_ _opts277285_)
      (let* ((_ldb277286277292_ _ldb277282_)
             (_E277288277296_
              (lambda () (error '"No clause matching" _ldb277286277292_)))
             (_K277289277312_
              (lambda (_db277299_)
                (if _db277299_
                    (let ((_keyx277301_
                           (std/db/leveldb#value-bytes _key277283_))
                          (_valx277302_
                           (std/db/leveldb#value-bytes _val277284_))
                          (_errptr277303_ (std/db/leveldb#get-errptr)))
                      (std/db/_leveldb#leveldb_put
                       _db277299_
                       _opts277285_
                       _keyx277301_
                       _valx277302_
                       _errptr277303_)
                      (let ((_$e277305_
                             (std/db/_leveldb#errptr_str _errptr277303_)))
                        (if _$e277305_
                            ((lambda (_g277307277309_)
                               (std/db/leveldb#raise-leveldb-error
                                'leveldb-put
                                _g277307277309_))
                             _$e277305_)
                            '#!void)))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277286277292_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277290277315_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277286277292_ '1)))
                   (_db277318_ _e277290277315_))
              (_K277289277312_ _db277318_))
            (_E277288277296_)))))
  (define std/db/leveldb#leveldb-put__0
    (lambda (_ldb277323_ _key277324_ _val277325_)
      (let ((_opts277327_ (std/db/leveldb#leveldb-default-write-options)))
        (std/db/leveldb#leveldb-put__%
         _ldb277323_
         _key277324_
         _val277325_
         _opts277327_))))
  (define std/db/leveldb#leveldb-put
    (lambda _g312776_
      (let ((_g312775_ (let () (declare (not safe)) (##length _g312776_))))
        (cond ((let () (declare (not safe)) (##fx= _g312775_ 3))
               (apply std/db/leveldb#leveldb-put__0 _g312776_))
              ((let () (declare (not safe)) (##fx= _g312775_ 4))
               (apply std/db/leveldb#leveldb-put__% _g312776_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-put
                _g312776_))))))
  (define std/db/leveldb#leveldb-get__%
    (lambda (_ldb277229_ _key277230_ _opts277231_)
      (let* ((_ldb277232277238_ _ldb277229_)
             (_E277234277242_
              (lambda () (error '"No clause matching" _ldb277232277238_)))
             (_K277235277261_
              (lambda (_db277245_)
                (if _db277245_
                    (let* ((_keyx277247_
                            (std/db/leveldb#value-bytes _key277230_))
                           (_errptr277249_ (std/db/leveldb#get-errptr))
                           (_slice277251_
                            (std/db/_leveldb#leveldb_get
                             _db277245_
                             _opts277231_
                             _keyx277247_
                             _errptr277249_)))
                      (if _slice277251_
                          (std/db/leveldb#slice->bytes _slice277251_)
                          (let ((_$e277254_
                                 (std/db/_leveldb#errptr_str _errptr277249_)))
                            (if _$e277254_
                                ((lambda (_g277256277258_)
                                   (std/db/leveldb#raise-leveldb-error
                                    'leveldb-get
                                    _g277256277258_))
                                 _$e277254_)
                                '#f))))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277232277238_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277236277264_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277232277238_ '1)))
                   (_db277267_ _e277236277264_))
              (_K277235277261_ _db277267_))
            (_E277234277242_)))))
  (define std/db/leveldb#leveldb-get__0
    (lambda (_ldb277272_ _key277273_)
      (let ((_opts277275_ (std/db/leveldb#leveldb-default-read-options)))
        (std/db/leveldb#leveldb-get__% _ldb277272_ _key277273_ _opts277275_))))
  (define std/db/leveldb#leveldb-get
    (lambda _g312778_
      (let ((_g312777_ (let () (declare (not safe)) (##length _g312778_))))
        (cond ((let () (declare (not safe)) (##fx= _g312777_ 2))
               (apply std/db/leveldb#leveldb-get__0 _g312778_))
              ((let () (declare (not safe)) (##fx= _g312777_ 3))
               (apply std/db/leveldb#leveldb-get__% _g312778_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-get
                _g312778_))))))
  (define std/db/leveldb#leveldb-delete__%
    (lambda (_ldb277180_ _key277181_ _opts277182_)
      (let* ((_ldb277183277189_ _ldb277180_)
             (_E277185277193_
              (lambda () (error '"No clause matching" _ldb277183277189_)))
             (_K277186277208_
              (lambda (_db277196_)
                (if _db277196_
                    (let ((_keyx277198_
                           (std/db/leveldb#value-bytes _key277181_))
                          (_errptr277199_ (std/db/leveldb#get-errptr)))
                      (std/db/_leveldb#leveldb_delete
                       _db277196_
                       _opts277182_
                       _keyx277198_
                       _errptr277199_)
                      (let ((_$e277201_
                             (std/db/_leveldb#errptr_str _errptr277199_)))
                        (if _$e277201_
                            ((lambda (_g277203277205_)
                               (std/db/leveldb#raise-leveldb-error
                                'leveldb-delete
                                _g277203277205_))
                             _$e277201_)
                            '#!void)))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277183277189_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277187277211_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277183277189_ '1)))
                   (_db277214_ _e277187277211_))
              (_K277186277208_ _db277214_))
            (_E277185277193_)))))
  (define std/db/leveldb#leveldb-delete__0
    (lambda (_ldb277219_ _key277220_)
      (let ((_opts277222_ (std/db/leveldb#leveldb-default-write-options)))
        (std/db/leveldb#leveldb-delete__%
         _ldb277219_
         _key277220_
         _opts277222_))))
  (define std/db/leveldb#leveldb-delete
    (lambda _g312780_
      (let ((_g312779_ (let () (declare (not safe)) (##length _g312780_))))
        (cond ((let () (declare (not safe)) (##fx= _g312779_ 2))
               (apply std/db/leveldb#leveldb-delete__0 _g312780_))
              ((let () (declare (not safe)) (##fx= _g312779_ 3))
               (apply std/db/leveldb#leveldb-delete__% _g312780_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-delete
                _g312780_))))))
  (define std/db/leveldb#leveldb-write__%
    (lambda (_ldb277132_ _batch277133_ _opts277134_)
      (let* ((_ldb277135277141_ _ldb277132_)
             (_E277137277145_
              (lambda () (error '"No clause matching" _ldb277135277141_)))
             (_K277138277159_
              (lambda (_db277148_)
                (if _db277148_
                    (let ((_errptr277150_ (std/db/leveldb#get-errptr)))
                      (std/db/_leveldb#leveldb_write
                       _db277148_
                       _opts277134_
                       _batch277133_
                       _errptr277150_)
                      (let ((_$e277152_
                             (std/db/_leveldb#errptr_str _errptr277150_)))
                        (if _$e277152_
                            ((lambda (_g277154277156_)
                               (std/db/leveldb#raise-leveldb-error
                                'leveldb-write
                                _g277154277156_))
                             _$e277152_)
                            '#!void)))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277135277141_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277139277162_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277135277141_ '1)))
                   (_db277165_ _e277139277162_))
              (_K277138277159_ _db277165_))
            (_E277137277145_)))))
  (define std/db/leveldb#leveldb-write__0
    (lambda (_ldb277170_ _batch277171_)
      (let ((_opts277173_ (std/db/leveldb#leveldb-default-write-options)))
        (std/db/leveldb#leveldb-write__%
         _ldb277170_
         _batch277171_
         _opts277173_))))
  (define std/db/leveldb#leveldb-write
    (lambda _g312782_
      (let ((_g312781_ (let () (declare (not safe)) (##length _g312782_))))
        (cond ((let () (declare (not safe)) (##fx= _g312781_ 2))
               (apply std/db/leveldb#leveldb-write__0 _g312782_))
              ((let () (declare (not safe)) (##fx= _g312781_ 3))
               (apply std/db/leveldb#leveldb-write__% _g312782_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-write
                _g312782_))))))
  (define std/db/leveldb#leveldb-key?__%
    (lambda (_ldb277079_ _key277080_ _opts277081_)
      (let* ((_ldb277082277088_ _ldb277079_)
             (_E277084277092_
              (lambda () (error '"No clause matching" _ldb277082277088_)))
             (_K277085277111_
              (lambda (_db277095_)
                (if _db277095_
                    (let* ((_keyx277097_
                            (std/db/leveldb#value-bytes _key277080_))
                           (_errptr277099_ (std/db/leveldb#get-errptr))
                           (_slice277101_
                            (std/db/_leveldb#leveldb_get
                             _db277095_
                             _opts277081_
                             _keyx277097_
                             _errptr277099_)))
                      (if _slice277101_
                          '#t
                          (let ((_$e277104_
                                 (std/db/_leveldb#errptr_str _errptr277099_)))
                            (if _$e277104_
                                ((lambda (_g277106277108_)
                                   (std/db/leveldb#raise-leveldb-error
                                    'leveldb-key?
                                    _g277106277108_))
                                 _$e277104_)
                                '#f))))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277082277088_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277086277114_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277082277088_ '1)))
                   (_db277117_ _e277086277114_))
              (_K277085277111_ _db277117_))
            (_E277084277092_)))))
  (define std/db/leveldb#leveldb-key?__0
    (lambda (_ldb277122_ _key277123_)
      (let ((_opts277125_ (std/db/leveldb#leveldb-default-read-options)))
        (std/db/leveldb#leveldb-key?__%
         _ldb277122_
         _key277123_
         _opts277125_))))
  (define std/db/leveldb#leveldb-key?
    (lambda _g312784_
      (let ((_g312783_ (let () (declare (not safe)) (##length _g312784_))))
        (cond ((let () (declare (not safe)) (##fx= _g312783_ 2))
               (apply std/db/leveldb#leveldb-key?__0 _g312784_))
              ((let () (declare (not safe)) (##fx= _g312783_ 3))
               (apply std/db/leveldb#leveldb-key?__% _g312784_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-key?
                _g312784_))))))
  (define std/db/leveldb#slice->bytes
    (lambda (_slice277071_)
      (let* ((_len277073_ (std/db/_leveldb#slice_len _slice277071_))
             (_bytes277075_ (make-u8vector _len277073_)))
        (std/db/_leveldb#slice_bytes _slice277071_ _bytes277075_)
        _bytes277075_)))
  (define std/db/leveldb#errptr-key 'std/db/leveldb#errptr)
  (define std/db/leveldb#get-errptr
    (lambda ()
      (let ((_$e277061_
             (gerbil/gambit/threads#thread-local-get
              std/db/leveldb#errptr-key)))
        (if _$e277061_
            ((lambda (_errptr277064_)
               (std/db/_leveldb#errptr_clear _errptr277064_)
               _errptr277064_)
             _$e277061_)
            (let ((_errptr277069_
                   (let ((_ptr277066_ (std/db/_leveldb#make_errptr)))
                     (if _ptr277066_
                         _ptr277066_
                         (std/db/leveldb#raise-leveldb-error
                          'get-errptr
                          '"Error allocating pointer")))))
              (gerbil/gambit/threads#thread-local-set!
               std/db/leveldb#errptr-key
               _errptr277069_)
              _errptr277069_)))))
  (define std/db/leveldb#leveldb-writebatch
    (lambda ()
      (let ((_ptr277057_ (std/db/_leveldb#leveldb_writebatch_create)))
        (if _ptr277057_
            _ptr277057_
            (std/db/leveldb#raise-leveldb-error
             'leveldb_writebatch_create
             '"Error allocating pointer")))))
  (define std/db/leveldb#leveldb-writebatch-clear
    (lambda (_batch277054_)
      (std/db/_leveldb#leveldb_writebatch_clear _batch277054_)))
  (define std/db/leveldb#leveldb-writebatch-put
    (lambda (_batch277047_ _key277048_ _val277049_)
      (let ((_keyx277051_ (std/db/leveldb#value-bytes _key277048_))
            (_valx277052_ (std/db/leveldb#value-bytes _val277049_)))
        (std/db/_leveldb#leveldb_writebatch_put
         _batch277047_
         _keyx277051_
         _valx277052_))))
  (define std/db/leveldb#leveldb-writebatch-delete
    (lambda (_batch277042_ _key277043_)
      (let ((_keyx277045_ (std/db/leveldb#value-bytes _key277043_)))
        (std/db/_leveldb#leveldb_writebatch_delete
         _batch277042_
         _keyx277045_))))
  (define std/db/leveldb#leveldb-iterator__%
    (lambda (_ldb277002_ _opts277003_)
      (let* ((_ldb277004277010_ _ldb277002_)
             (_E277006277014_
              (lambda () (error '"No clause matching" _ldb277004277010_)))
             (_K277007277024_
              (lambda (_db277017_)
                (if _db277017_
                    (let ((_lit277022_
                           (let ((__tmp312785
                                  (let ((_ptr277019_
                                         (std/db/_leveldb#leveldb_create_iterator
                                          _db277017_
                                          _opts277003_)))
                                    (if _ptr277019_
                                        _ptr277019_
                                        (std/db/leveldb#raise-leveldb-error
                                         'leveldb_create_iterator
                                         '"Error allocating pointer")))))
                             (declare (not safe))
                             (##structure
                              std/db/leveldb#leveldb-itor::t
                              __tmp312785))))
                      (make-will
                       _lit277022_
                       std/db/leveldb#leveldb-iterator-close)
                      _lit277022_)
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277004277010_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277008277027_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277004277010_ '1)))
                   (_db277030_ _e277008277027_))
              (_K277007277024_ _db277030_))
            (_E277006277014_)))))
  (define std/db/leveldb#leveldb-iterator__0
    (lambda (_ldb277035_)
      (let ((_opts277037_ (std/db/leveldb#leveldb-default-read-options)))
        (std/db/leveldb#leveldb-iterator__% _ldb277035_ _opts277037_))))
  (define std/db/leveldb#leveldb-iterator
    (lambda _g312787_
      (let ((_g312786_ (let () (declare (not safe)) (##length _g312787_))))
        (cond ((let () (declare (not safe)) (##fx= _g312786_ 1))
               (apply std/db/leveldb#leveldb-iterator__0 _g312787_))
              ((let () (declare (not safe)) (##fx= _g312786_ 2))
               (apply std/db/leveldb#leveldb-iterator__% _g312787_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-iterator
                _g312787_))))))
  (define std/db/leveldb#leveldb-iterator-close
    (lambda (_lit276977_)
      (let* ((_lit276978276984_ _lit276977_)
             (_E276980276988_
              (lambda () (error '"No clause matching" _lit276978276984_)))
             (_K276981276993_
              (lambda (_itor276991_)
                (if _itor276991_
                    (begin
                      (std/db/_leveldb#leveldb_iter_destroy _itor276991_)
                      (##direct-structure-set!
                       _lit276977_
                       '#f
                       '1
                       std/db/leveldb#leveldb-itor::t
                       '#f))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276978276984_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276982276996_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276978276984_ '1)))
                   (_itor276999_ _e276982276996_))
              (_K276981276993_ _itor276999_))
            (_E276980276988_)))))
  (define std/db/leveldb#leveldb-itor::destroy
    std/db/leveldb#leveldb-iterator-close)
  (bind-method!
   std/db/leveldb#leveldb-itor::t
   'destroy
   std/db/leveldb#leveldb-itor::destroy
   '#f)
  (define std/db/leveldb#leveldb-iterator-valid?
    (lambda (_lit276831_)
      (let* ((_lit276832276838_ _lit276831_)
             (_E276834276842_
              (lambda () (error '"No clause matching" _lit276832276838_)))
             (_K276835276847_
              (lambda (_itor276845_)
                (if _itor276845_
                    (eq? (std/db/_leveldb#leveldb_iter_valid _itor276845_) '1)
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276832276838_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276836276850_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276832276838_ '1)))
                   (_itor276853_ _e276836276850_))
              (_K276835276847_ _itor276853_))
            (_E276834276842_)))))
  (define std/db/leveldb#leveldb-iterator-seek-first
    (lambda (_lit276807_)
      (let* ((_lit276808276814_ _lit276807_)
             (_E276810276818_
              (lambda () (error '"No clause matching" _lit276808276814_)))
             (_K276811276823_
              (lambda (_itor276821_)
                (if _itor276821_
                    (std/db/_leveldb#leveldb_iter_seek_to_first _itor276821_)
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276808276814_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276812276826_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276808276814_ '1)))
                   (_itor276829_ _e276812276826_))
              (_K276811276823_ _itor276829_))
            (_E276810276818_)))))
  (define std/db/leveldb#leveldb-iterator-seek-last
    (lambda (_lit276783_)
      (let* ((_lit276784276790_ _lit276783_)
             (_E276786276794_
              (lambda () (error '"No clause matching" _lit276784276790_)))
             (_K276787276799_
              (lambda (_itor276797_)
                (if _itor276797_
                    (std/db/_leveldb#leveldb_iter_seek_to_last _itor276797_)
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276784276790_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276788276802_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276784276790_ '1)))
                   (_itor276805_ _e276788276802_))
              (_K276787276799_ _itor276805_))
            (_E276786276794_)))))
  (define std/db/leveldb#leveldb-iterator-seek
    (lambda (_lit276756_ _key276757_)
      (let* ((_lit276758276764_ _lit276756_)
             (_E276760276768_
              (lambda () (error '"No clause matching" _lit276758276764_)))
             (_K276761276775_
              (lambda (_itor276771_)
                (if _itor276771_
                    (let ((_keyx276773_
                           (std/db/leveldb#value-bytes _key276757_)))
                      (std/db/_leveldb#leveldb_iter_seek
                       _itor276771_
                       _keyx276773_))
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276758276764_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276762276778_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276758276764_ '1)))
                   (_itor276781_ _e276762276778_))
              (_K276761276775_ _itor276781_))
            (_E276760276768_)))))
  (define std/db/leveldb#leveldb-iterator-next
    (lambda (_lit276732_)
      (let* ((_lit276733276739_ _lit276732_)
             (_E276735276743_
              (lambda () (error '"No clause matching" _lit276733276739_)))
             (_K276736276748_
              (lambda (_itor276746_)
                (if _itor276746_
                    (std/db/_leveldb#leveldb_iter_next _itor276746_)
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276733276739_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276737276751_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276733276739_ '1)))
                   (_itor276754_ _e276737276751_))
              (_K276736276748_ _itor276754_))
            (_E276735276743_)))))
  (define std/db/leveldb#leveldb-iterator-prev
    (lambda (_lit276708_)
      (let* ((_lit276709276715_ _lit276708_)
             (_E276711276719_
              (lambda () (error '"No clause matching" _lit276709276715_)))
             (_K276712276724_
              (lambda (_itor276722_)
                (if _itor276722_
                    (std/db/_leveldb#leveldb_iter_prev _itor276722_)
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276709276715_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276713276727_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276709276715_ '1)))
                   (_itor276730_ _e276713276727_))
              (_K276712276724_ _itor276730_))
            (_E276711276719_)))))
  (define std/db/leveldb#leveldb-iterator-key
    (lambda (_lit276678_)
      (let* ((_lit276679276685_ _lit276678_)
             (_E276681276689_
              (lambda () (error '"No clause matching" _lit276679276685_)))
             (_K276682276700_
              (lambda (_itor276692_)
                (if _itor276692_
                    (let ((_slice276693276695_
                           (std/db/_leveldb#leveldb_iter_key _itor276692_)))
                      (if _slice276693276695_
                          (let ((_slice276698_ _slice276693276695_))
                            (std/db/leveldb#slice->bytes _slice276698_))
                          '#f))
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276679276685_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276683276703_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276679276685_ '1)))
                   (_itor276706_ _e276683276703_))
              (_K276682276700_ _itor276706_))
            (_E276681276689_)))))
  (define std/db/leveldb#leveldb-iterator-value
    (lambda (_lit276648_)
      (let* ((_lit276649276655_ _lit276648_)
             (_E276651276659_
              (lambda () (error '"No clause matching" _lit276649276655_)))
             (_K276652276670_
              (lambda (_itor276662_)
                (if _itor276662_
                    (let ((_slice276663276665_
                           (std/db/_leveldb#leveldb_iter_value _itor276662_)))
                      (if _slice276663276665_
                          (let ((_slice276668_ _slice276663276665_))
                            (std/db/leveldb#slice->bytes _slice276668_))
                          '#f))
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276649276655_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276653276673_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276649276655_ '1)))
                   (_itor276676_ _e276653276673_))
              (_K276652276670_ _itor276676_))
            (_E276651276659_)))))
  (define std/db/leveldb#leveldb-iterator-error__%
    (lambda (_lit276604_ _raise?276605_)
      (let* ((_lit276606276612_ _lit276604_)
             (_E276608276616_
              (lambda () (error '"No clause matching" _lit276606276612_)))
             (_K276609276630_
              (lambda (_itor276619_)
                (if _itor276619_
                    (let ((_errptr276621_ (std/db/leveldb#get-errptr)))
                      (std/db/_leveldb#leveldb_iter_get_error
                       _itor276619_
                       _errptr276621_)
                      (if (not _raise?276605_)
                          (std/db/_leveldb#errptr_str _errptr276621_)
                          (let ((_$e276623_
                                 (std/db/_leveldb#errptr_str _errptr276621_)))
                            (if _$e276623_
                                ((lambda (_g276625276627_)
                                   (std/db/leveldb#raise-leveldb-error
                                    'leveldb-iterator-error
                                    _g276625276627_))
                                 _$e276623_)
                                '#f))))
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276606276612_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276610276633_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276606276612_ '1)))
                   (_itor276636_ _e276610276633_))
              (_K276609276630_ _itor276636_))
            (_E276608276616_)))))
  (define std/db/leveldb#leveldb-iterator-error__0
    (lambda (_lit276641_)
      (let ((_raise?276643_ '#t))
        (std/db/leveldb#leveldb-iterator-error__%
         _lit276641_
         _raise?276643_))))
  (define std/db/leveldb#leveldb-iterator-error
    (lambda _g312789_
      (let ((_g312788_ (let () (declare (not safe)) (##length _g312789_))))
        (cond ((let () (declare (not safe)) (##fx= _g312788_ 1))
               (apply std/db/leveldb#leveldb-iterator-error__0 _g312789_))
              ((let () (declare (not safe)) (##fx= _g312788_ 2))
               (apply std/db/leveldb#leveldb-iterator-error__% _g312789_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-iterator-error
                _g312789_))))))
  (define std/db/leveldb#leveldb-iter-state::t
    (make-struct-type
     'std/db/leveldb#leveldb-iter-state::t
     '#f
     '4
     'leveldb-iter-state
     '((final: . #t))
     '#f
     '(itor value start limit)))
  (define std/db/leveldb#leveldb-iter-state?
    (make-struct-predicate std/db/leveldb#leveldb-iter-state::t))
  (define std/db/leveldb#make-leveldb-iter-state
    (lambda _$args276600_
      (apply make-struct-instance
             std/db/leveldb#leveldb-iter-state::t
             _$args276600_)))
  (define std/db/leveldb#leveldb-iter-state-itor
    (make-struct-field-accessor std/db/leveldb#leveldb-iter-state::t '0))
  (define std/db/leveldb#leveldb-iter-state-value
    (make-struct-field-accessor std/db/leveldb#leveldb-iter-state::t '1))
  (define std/db/leveldb#leveldb-iter-state-start
    (make-struct-field-accessor std/db/leveldb#leveldb-iter-state::t '2))
  (define std/db/leveldb#leveldb-iter-state-limit
    (make-struct-field-accessor std/db/leveldb#leveldb-iter-state::t '3))
  (define std/db/leveldb#leveldb-iter-state-itor-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-iter-state::t '0))
  (define std/db/leveldb#leveldb-iter-state-value-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-iter-state::t '1))
  (define std/db/leveldb#leveldb-iter-state-start-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-iter-state::t '2))
  (define std/db/leveldb#leveldb-iter-state-limit-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-iter-state::t '3))
  (define std/db/leveldb#in-leveldb__%
    (lambda (_db276578_ _start276579_ _limit276580_)
      (std/db/leveldb#iter-leveldb
       (let ((__tmp312792 (std/db/leveldb#leveldb-iterator__0 _db276578_))
             (__tmp312791
              (if _start276579_
                  (std/db/leveldb#value-bytes _start276579_)
                  '#f))
             (__tmp312790
              (if _limit276580_
                  (std/db/leveldb#value-bytes _limit276580_)
                  '#f)))
         (declare (not safe))
         (##structure
          std/db/leveldb#leveldb-iter-state::t
          __tmp312792
          std/db/leveldb#iter-nil
          __tmp312791
          __tmp312790))
       std/db/leveldb#leveldb-iter-key-value)))
  (define std/db/leveldb#in-leveldb__0
    (lambda (_db276585_)
      (let* ((_start276587_ '#f) (_limit276589_ '#f))
        (std/db/leveldb#in-leveldb__%
         _db276585_
         _start276587_
         _limit276589_))))
  (define std/db/leveldb#in-leveldb__1
    (lambda (_db276591_ _start276592_)
      (let ((_limit276594_ '#f))
        (std/db/leveldb#in-leveldb__%
         _db276591_
         _start276592_
         _limit276594_))))
  (define std/db/leveldb#in-leveldb
    (lambda _g312794_
      (let ((_g312793_ (let () (declare (not safe)) (##length _g312794_))))
        (cond ((let () (declare (not safe)) (##fx= _g312793_ 1))
               (apply std/db/leveldb#in-leveldb__0 _g312794_))
              ((let () (declare (not safe)) (##fx= _g312793_ 2))
               (apply std/db/leveldb#in-leveldb__1 _g312794_))
              ((let () (declare (not safe)) (##fx= _g312793_ 3))
               (apply std/db/leveldb#in-leveldb__% _g312794_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#in-leveldb
                _g312794_))))))
  (define std/db/leveldb#in-leveldb-keys__%
    (lambda (_db276555_ _start276556_ _limit276557_)
      (std/db/leveldb#iter-leveldb
       (let ((__tmp312797 (std/db/leveldb#leveldb-iterator__0 _db276555_))
             (__tmp312796
              (if _start276556_
                  (std/db/leveldb#value-bytes _start276556_)
                  '#f))
             (__tmp312795
              (if _limit276557_
                  (std/db/leveldb#value-bytes _limit276557_)
                  '#f)))
         (declare (not safe))
         (##structure
          std/db/leveldb#leveldb-iter-state::t
          __tmp312797
          std/db/leveldb#iter-nil
          __tmp312796
          __tmp312795))
       std/db/leveldb#leveldb-iter-key)))
  (define std/db/leveldb#in-leveldb-keys__0
    (lambda (_db276562_)
      (let* ((_start276564_ '#f) (_limit276566_ '#f))
        (std/db/leveldb#in-leveldb-keys__%
         _db276562_
         _start276564_
         _limit276566_))))
  (define std/db/leveldb#in-leveldb-keys__1
    (lambda (_db276568_ _start276569_)
      (let ((_limit276571_ '#f))
        (std/db/leveldb#in-leveldb-keys__%
         _db276568_
         _start276569_
         _limit276571_))))
  (define std/db/leveldb#in-leveldb-keys
    (lambda _g312799_
      (let ((_g312798_ (let () (declare (not safe)) (##length _g312799_))))
        (cond ((let () (declare (not safe)) (##fx= _g312798_ 1))
               (apply std/db/leveldb#in-leveldb-keys__0 _g312799_))
              ((let () (declare (not safe)) (##fx= _g312798_ 2))
               (apply std/db/leveldb#in-leveldb-keys__1 _g312799_))
              ((let () (declare (not safe)) (##fx= _g312798_ 3))
               (apply std/db/leveldb#in-leveldb-keys__% _g312799_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#in-leveldb-keys
                _g312799_))))))
  (define std/db/leveldb#iter-leveldb
    (lambda (_state276496_ _value-e276497_)
      (letrec ((_next276499_
                (lambda (_it276528_)
                  (let* ((_it276529276535_ _it276528_)
                         (_E276531276539_
                          (lambda ()
                            (error '"No clause matching" _it276529276535_)))
                         (_K276532276546_
                          (lambda (_state276542_)
                            (let ((_r276544_ (_value-e276497_ _state276542_)))
                              (if (std/iter#iter-end? _r276544_)
                                  '#!void
                                  (std/db/leveldb#leveldb-iter-next
                                   _state276542_))
                              _r276544_))))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _it276529276535_
                           'std/iter#iterator::t))
                        (let* ((_e276533276549_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _it276529276535_ '1)))
                               (_state276552_ _e276533276549_))
                          (_K276532276546_ _state276552_))
                        (_E276531276539_)))))
               (_fini276500_
                (lambda (_it276504_)
                  (let* ((_it276505276511_ _it276504_)
                         (_E276507276515_
                          (lambda ()
                            (error '"No clause matching" _it276505276511_)))
                         (_K276508276520_
                          (lambda (_state276518_)
                            (if _state276518_
                                (begin
                                  (std/db/leveldb#leveldb-iter-fini
                                   _state276518_)
                                  (##direct-structure-set!
                                   _it276504_
                                   '#f
                                   '1
                                   std/iter#iterator::t
                                   '#f))
                                '#!void))))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _it276505276511_
                           'std/iter#iterator::t))
                        (let* ((_e276509276523_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _it276505276511_ '1)))
                               (_state276526_ _e276509276523_))
                          (_K276508276520_ _state276526_))
                        (_E276507276515_))))))
        (let ((_it276502_
               (let ((__obj312772 (make-object std/iter#iterator::t '3)))
                 (if (let ((__tmp312800
                            (let ()
                              (declare (not safe))
                              (##vector-length __obj312772))))
                       (declare (not safe))
                       (##fx< '3 __tmp312800))
                     (begin
                       (let ()
                         (declare (not safe))
                         (##vector-set! __obj312772 '1 _state276496_))
                       (let ()
                         (declare (not safe))
                         (##vector-set! __obj312772 '2 _next276499_))
                       (let ()
                         (declare (not safe))
                         (##vector-set! __obj312772 '3 _fini276500_)))
                     (error '"struct-instance-init!: too many arguments for struct"
                            __obj312772))
                 __obj312772)))
          (make-will _it276502_ _fini276500_)
          (std/db/leveldb#leveldb-iter-start _state276496_)
          _it276502_))))
  (define std/db/leveldb#leveldb-iter-start
    (lambda (_state276451_)
      (let* ((_state276452276461_ _state276451_)
             (_E276454276465_
              (lambda () (error '"No clause matching" _state276452276461_)))
             (_K276455276473_
              (lambda (_limit276468_ _start276469_ _nil276470_ _itor276471_)
                (if _start276469_
                    (std/db/leveldb#leveldb-iterator-seek
                     _itor276471_
                     _start276469_)
                    (std/db/leveldb#leveldb-iterator-seek-first _itor276471_))
                (##direct-structure-set!
                 _state276451_
                 (if (std/db/leveldb#leveldb-iterator-valid? _itor276471_)
                     (if (and _start276469_
                              (equal? _start276469_ _limit276468_))
                         std/iter#iter-end
                         std/db/leveldb#iter-nil)
                     std/iter#iter-end)
                 '2
                 std/db/leveldb#leveldb-iter-state::t
                 '#f))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _state276452276461_
               'std/db/leveldb#leveldb-iter-state::t))
            (let* ((_e276456276476_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276452276461_ '1)))
                   (_itor276479_ _e276456276476_)
                   (_e276457276481_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276452276461_ '2)))
                   (_nil276484_ _e276457276481_)
                   (_e276458276486_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276452276461_ '3)))
                   (_start276489_ _e276458276486_)
                   (_e276459276491_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276452276461_ '4)))
                   (_limit276494_ _e276459276491_))
              (_K276455276473_
               _limit276494_
               _start276489_
               _nil276484_
               _itor276479_))
            (_E276454276465_)))))
  (define std/db/leveldb#leveldb-iter-key-value
    (lambda (_state276413_)
      (let* ((_state276414276421_ _state276413_)
             (_E276416276425_
              (lambda () (error '"No clause matching" _state276414276421_)))
             (_K276417276438_
              (lambda (_value276428_ _itor276429_)
                (if (std/db/leveldb#iter-nil? _value276428_)
                    (let* ((_key276431_
                            (std/db/leveldb#leveldb-iterator-key _itor276429_))
                           (_val276433_
                            (std/db/leveldb#leveldb-iterator-value
                             _itor276429_))
                           (_value276435_ (values _key276431_ _val276433_)))
                      (##direct-structure-set!
                       _state276413_
                       _value276435_
                       '2
                       std/db/leveldb#leveldb-iter-state::t
                       '#f)
                      _value276435_)
                    _value276428_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _state276414276421_
               'std/db/leveldb#leveldb-iter-state::t))
            (let* ((_e276418276441_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276414276421_ '1)))
                   (_itor276444_ _e276418276441_)
                   (_e276419276446_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276414276421_ '2)))
                   (_value276449_ _e276419276446_))
              (_K276417276438_ _value276449_ _itor276444_))
            (_E276416276425_)))))
  (define std/db/leveldb#leveldb-iter-key
    (lambda (_state276380_)
      (let* ((_state276381276388_ _state276380_)
             (_E276383276392_
              (lambda () (error '"No clause matching" _state276381276388_)))
             (_K276384276400_
              (lambda (_value276395_ _itor276396_)
                (if (std/db/leveldb#iter-nil? _value276395_)
                    (let ((_value276398_
                           (std/db/leveldb#leveldb-iterator-key _itor276396_)))
                      (##direct-structure-set!
                       _state276380_
                       _value276398_
                       '2
                       std/db/leveldb#leveldb-iter-state::t
                       '#f)
                      _value276398_)
                    _value276395_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _state276381276388_
               'std/db/leveldb#leveldb-iter-state::t))
            (let* ((_e276385276403_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276381276388_ '1)))
                   (_itor276406_ _e276385276403_)
                   (_e276386276408_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276381276388_ '2)))
                   (_value276411_ _e276386276408_))
              (_K276384276400_ _value276411_ _itor276406_))
            (_E276383276392_)))))
  (define std/db/leveldb#leveldb-iter-next
    (lambda (_state276338_)
      (let* ((_state276339276348_ _state276338_)
             (_E276341276352_
              (lambda () (error '"No clause matching" _state276339276348_)))
             (_K276342276359_
              (lambda (_limit276355_ _start276356_ _itor276357_)
                (std/db/leveldb#leveldb-iterator-next _itor276357_)
                (##direct-structure-set!
                 _state276338_
                 (if (std/db/leveldb#leveldb-iterator-valid? _itor276357_)
                     (if (and _limit276355_
                              (equal? (std/db/leveldb#leveldb-iterator-key
                                       _itor276357_)
                                      _limit276355_))
                         std/iter#iter-end
                         std/db/leveldb#iter-nil)
                     std/iter#iter-end)
                 '2
                 std/db/leveldb#leveldb-iter-state::t
                 '#f))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _state276339276348_
               'std/db/leveldb#leveldb-iter-state::t))
            (let* ((_e276343276362_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276339276348_ '1)))
                   (_itor276365_ _e276343276362_)
                   (_e276344276367_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276339276348_ '2)))
                   (_e276345276370_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276339276348_ '3)))
                   (_start276373_ _e276345276370_)
                   (_e276346276375_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276339276348_ '4)))
                   (_limit276378_ _e276346276375_))
              (_K276342276359_ _limit276378_ _start276373_ _itor276365_))
            (_E276341276352_)))))
  (define std/db/leveldb#leveldb-iter-fini
    (lambda (_state276314_)
      (let* ((_state276315276321_ _state276314_)
             (_E276317276325_
              (lambda () (error '"No clause matching" _state276315276321_)))
             (_K276318276330_
              (lambda (_itor276328_)
                (std/db/leveldb#leveldb-iterator-close _itor276328_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _state276315276321_
               'std/db/leveldb#leveldb-iter-state::t))
            (let* ((_e276319276333_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276315276321_ '1)))
                   (_itor276336_ _e276319276333_))
              (std/db/leveldb#leveldb-iterator-close _itor276336_))
            (_E276317276325_)))))
  (define std/db/leveldb#iter-nil '#&nil)
  (define std/db/leveldb#iter-nil?
    (lambda (_o276312_) (eq? std/db/leveldb#iter-nil _o276312_)))
  (define std/db/leveldb#leveldb-compact-range
    (lambda (_ldb276283_ _start-key276284_ _end-key276285_)
      (let* ((_ldb276286276292_ _ldb276283_)
             (_E276288276296_
              (lambda () (error '"No clause matching" _ldb276286276292_)))
             (_K276289276304_
              (lambda (_db276299_)
                (if _db276299_
                    (let ((_startx276301_
                           (std/db/leveldb#value-bytes _start-key276284_))
                          (_endx276302_
                           (std/db/leveldb#value-bytes _end-key276285_)))
                      (std/db/_leveldb#leveldb_compact_range
                       _db276299_
                       _startx276301_
                       _endx276302_))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb276286276292_
               'std/db/leveldb#leveldb::t))
            (let* ((_e276290276307_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb276286276292_ '1)))
                   (_db276310_ _e276290276307_))
              (_K276289276304_ _db276310_))
            (_E276288276296_)))))
  (define std/db/leveldb#leveldb-destroy-db__%
    (lambda (_name276261_ _opts276262_)
      (let ((_errptr276264_ (std/db/leveldb#get-errptr)))
        (std/db/_leveldb#leveldb_destroy_db
         (##direct-structure-ref
          _opts276262_
          '1
          std/db/leveldb#leveldb-opts::t
          '#f)
         _name276261_
         _errptr276264_)
        (let ((_$e276266_ (std/db/_leveldb#errptr_str _errptr276264_)))
          (if _$e276266_
              ((lambda (_g276268276270_)
                 (std/db/leveldb#raise-leveldb-error
                  'leveldb-destroy-db
                  _g276268276270_))
               _$e276266_)
              '#!void)))))
  (define std/db/leveldb#leveldb-destroy-db__0
    (lambda (_name276276_)
      (let ((_opts276278_ (std/db/leveldb#leveldb-default-options)))
        (std/db/leveldb#leveldb-destroy-db__% _name276276_ _opts276278_))))
  (define std/db/leveldb#leveldb-destroy-db
    (lambda _g312802_
      (let ((_g312801_ (let () (declare (not safe)) (##length _g312802_))))
        (cond ((let () (declare (not safe)) (##fx= _g312801_ 1))
               (apply std/db/leveldb#leveldb-destroy-db__0 _g312802_))
              ((let () (declare (not safe)) (##fx= _g312801_ 2))
               (apply std/db/leveldb#leveldb-destroy-db__% _g312802_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-destroy-db
                _g312802_))))))
  (define std/db/leveldb#leveldb-repair-db__%
    (lambda (_name276238_ _opts276239_)
      (let ((_errptr276241_ (std/db/leveldb#get-errptr)))
        (std/db/_leveldb#leveldb_repair_db
         (##direct-structure-ref
          _opts276239_
          '1
          std/db/leveldb#leveldb-opts::t
          '#f)
         _name276238_
         _errptr276241_)
        (let ((_$e276243_ (std/db/_leveldb#errptr_str _errptr276241_)))
          (if _$e276243_
              ((lambda (_g276245276247_)
                 (std/db/leveldb#raise-leveldb-error
                  'leveldb-repair-db
                  _g276245276247_))
               _$e276243_)
              '#!void)))))
  (define std/db/leveldb#leveldb-repair-db__0
    (lambda (_name276253_)
      (let ((_opts276255_ (std/db/leveldb#leveldb-default-options)))
        (std/db/leveldb#leveldb-repair-db__% _name276253_ _opts276255_))))
  (define std/db/leveldb#leveldb-repair-db
    (lambda _g312804_
      (let ((_g312803_ (let () (declare (not safe)) (##length _g312804_))))
        (cond ((let () (declare (not safe)) (##fx= _g312803_ 1))
               (apply std/db/leveldb#leveldb-repair-db__0 _g312804_))
              ((let () (declare (not safe)) (##fx= _g312803_ 2))
               (apply std/db/leveldb#leveldb-repair-db__% _g312804_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-repair-db
                _g312804_))))))
  (define std/db/leveldb#leveldb-options__%
    (lambda (_g312805_
             _create-if-missing276152276164_
             _error-if-exists276153276166_
             _paranoid-checks276154276168_
             _compression276155276170_
             _write-buffer-size276156276172_
             _max-open-files276157276174_
             _block-size276158276176_
             _block-restart-interval276159276178_
             _lru-cache-capacity276160276180_
             _bloom-filter-bits276161276182_)
      (let* ((_create-if-missing276185_
              (if (eq? _create-if-missing276152276164_ absent-value)
                  '#t
                  _create-if-missing276152276164_))
             (_error-if-exists276187_
              (if (eq? _error-if-exists276153276166_ absent-value)
                  '#f
                  _error-if-exists276153276166_))
             (_paranoid-checks276189_
              (if (eq? _paranoid-checks276154276168_ absent-value)
                  '#f
                  _paranoid-checks276154276168_))
             (_compression276191_
              (if (eq? _compression276155276170_ absent-value)
                  '#t
                  _compression276155276170_))
             (_write-buffer-size276193_
              (if (eq? _write-buffer-size276156276172_ absent-value)
                  '#f
                  _write-buffer-size276156276172_))
             (_max-open-files276195_
              (if (eq? _max-open-files276157276174_ absent-value)
                  '#f
                  _max-open-files276157276174_))
             (_block-size276197_
              (if (eq? _block-size276158276176_ absent-value)
                  '#f
                  _block-size276158276176_))
             (_block-restart-interval276199_
              (if (eq? _block-restart-interval276159276178_ absent-value)
                  '#f
                  _block-restart-interval276159276178_))
             (_lru-cache-capacity276201_
              (if (eq? _lru-cache-capacity276160276180_ absent-value)
                  '#f
                  _lru-cache-capacity276160276180_))
             (_bloom-filter-bits276203_
              (if (eq? _bloom-filter-bits276161276182_ absent-value)
                  '#f
                  _bloom-filter-bits276161276182_))
             (_opts276208_
              (let ((_ptr276205_ (std/db/_leveldb#leveldb_options_create)))
                (if _ptr276205_
                    _ptr276205_
                    (std/db/leveldb#raise-leveldb-error
                     'leveldb_options_create
                     '"Error allocating pointer")))))
        (if _create-if-missing276185_
            (std/db/_leveldb#leveldb_options_set_create_if_missing
             _opts276208_
             '1)
            '#!void)
        (if _error-if-exists276187_
            (std/db/_leveldb#leveldb_options_set_error_if_exists
             _opts276208_
             '1)
            '#!void)
        (if _paranoid-checks276189_
            (std/db/_leveldb#leveldb_options_set_paranoid_checks
             _opts276208_
             '1)
            '#!void)
        (std/db/_leveldb#leveldb_options_set_compression
         _opts276208_
         (if _compression276191_ '1 '0))
        (if _write-buffer-size276193_
            (if (std/db/leveldb#fixnum-positive? _write-buffer-size276193_)
                (std/db/_leveldb#leveldb_options_set_write_buffer_size
                 _opts276208_
                 _write-buffer-size276193_)
                (error '"Bad write buffer size; expected positive fixnum"
                       _write-buffer-size276193_))
            '#!void)
        (if _max-open-files276195_
            (if (fixnum? _max-open-files276195_)
                (std/db/_leveldb#leveldb_options_set_max_open_files
                 _opts276208_
                 _max-open-files276195_)
                (error '"Bad max open files; expected fixnum"))
            '#!void)
        (if _block-size276197_
            (if (std/db/leveldb#fixnum-positive? _block-size276197_)
                (std/db/_leveldb#leveldb_options_set_block_size
                 _opts276208_
                 _block-size276197_)
                (error '"Bad block size; expected positive fixnum"))
            '#!void)
        (if _block-restart-interval276199_
            (if (fixnum? _block-restart-interval276199_)
                (std/db/_leveldb#leveldb_options_set_block_restart_interval
                 _opts276208_
                 _block-restart-interval276199_)
                (error '"Bad block restart interval; expected fixnum"))
            '#!void)
        (letrec* ((_cache276210_
                   (if _lru-cache-capacity276201_
                       (if (std/db/leveldb#fixnum-positive?
                            _lru-cache-capacity276201_)
                           (let ((_ptr276221_
                                  (let ((_ptr276218_
                                         (std/db/_leveldb#leveldb_cache_create_lru
                                          _lru-cache-capacity276201_)))
                                    (if _ptr276218_
                                        _ptr276218_
                                        (std/db/leveldb#raise-leveldb-error
                                         'leveldb_cache_create_lru
                                         '"Error allocating pointer")))))
                             (std/db/_leveldb#leveldb_options_set_cache
                              _opts276208_
                              _ptr276221_)
                             _ptr276221_)
                           (error '"Bad lru cache size; expected positive fixnum"))
                       '#!void))
                  (_bloom-filter276211_
                   (if _bloom-filter-bits276203_
                       (if (std/db/leveldb#fixnum-positive?
                            _bloom-filter-bits276203_)
                           (let ((_ptr276216_
                                  (let ((_ptr276213_
                                         (std/db/_leveldb#leveldb_filterpolicy_create_bloom
                                          _bloom-filter-bits276203_)))
                                    (if _ptr276213_
                                        _ptr276213_
                                        (std/db/leveldb#raise-leveldb-error
                                         'leveldb_filterpolicy_create_bloom
                                         '"Error allocating pointer")))))
                             (std/db/_leveldb#leveldb_options_set_filter_policy
                              _opts276208_
                              _ptr276216_)
                             _ptr276216_)
                           (error '"Bad bloom filter bits; expected positive fixnum"))
                       '#!void)))
          (let ()
            (declare (not safe))
            (##structure
             std/db/leveldb#leveldb-opts::t
             _opts276208_
             _cache276210_
             _bloom-filter276211_))))))
  (define std/db/leveldb#leveldb-options__@
    (lambda (_keys276151276226_ . _args276228_)
      (apply std/db/leveldb#leveldb-options__%
             _keys276151276226_
             (table-ref _keys276151276226_ 'create-if-missing: absent-value)
             (table-ref _keys276151276226_ 'error-if-exists: absent-value)
             (table-ref _keys276151276226_ 'paranoid-checks: absent-value)
             (table-ref _keys276151276226_ 'compression: absent-value)
             (table-ref _keys276151276226_ 'write-buffer-size: absent-value)
             (table-ref _keys276151276226_ 'max-open-files: absent-value)
             (table-ref _keys276151276226_ 'block-size: absent-value)
             (table-ref
              _keys276151276226_
              'block-restart-interval:
              absent-value)
             (table-ref _keys276151276226_ 'lru-cache-capacity: absent-value)
             (table-ref _keys276151276226_ 'bloom-filter-bits: absent-value)
             _args276228_)))
  (define std/db/leveldb#leveldb-options
    (lambda _args276162276234_
      (apply keyword-dispatch
             '#(#f
                #f
                bloom-filter-bits:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                error-if-exists:
                #f
                #f
                block-restart-interval:
                #f
                #f
                write-buffer-size:
                #f
                #f
                #f
                #f
                lru-cache-capacity:
                max-open-files:
                #f
                #f
                compression:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                paranoid-checks:
                block-size:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                create-if-missing:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f)
             std/db/leveldb#leveldb-options__@
             _args276162276234_)))
  (define std/db/leveldb#leveldb-default-options
    (lambda () (force std/db/leveldb#default-options)))
  (define std/db/leveldb#default-options
    (make-promise
     (lambda ()
       (std/db/leveldb#leveldb-options__%
        '#f
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value))))
  (define std/db/leveldb#leveldb-read-options__%
    (lambda (_g312806_ _verify-checksums276116276120_ _fill-cache276117276122_)
      (let* ((_verify-checksums276125_
              (if (eq? _verify-checksums276116276120_ absent-value)
                  '#f
                  _verify-checksums276116276120_))
             (_fill-cache276127_
              (if (eq? _fill-cache276117276122_ absent-value)
                  '#f
                  _fill-cache276117276122_))
             (_opts276132_
              (let ((_ptr276129_ (std/db/_leveldb#leveldb_readoptions_create)))
                (if _ptr276129_
                    _ptr276129_
                    (std/db/leveldb#raise-leveldb-error
                     'leveldb_readoptions_create
                     '"Error allocating pointer")))))
        (if _verify-checksums276125_
            (std/db/_leveldb#leveldb_readoptions_set_verify_checksums
             _opts276132_
             '1)
            '#!void)
        (if _fill-cache276127_
            (std/db/_leveldb#leveldb_readoptions_set_fill_cache
             _opts276132_
             '1)
            '#!void)
        _opts276132_)))
  (define std/db/leveldb#leveldb-read-options__@
    (lambda (_keys276115276137_ . _args276139_)
      (apply std/db/leveldb#leveldb-read-options__%
             _keys276115276137_
             (table-ref _keys276115276137_ 'verify-checksums: absent-value)
             (table-ref _keys276115276137_ 'fill-cache: absent-value)
             _args276139_)))
  (define std/db/leveldb#leveldb-read-options
    (lambda _args276118276145_
      (apply keyword-dispatch
             '#(#f verify-checksums: #f fill-cache:)
             std/db/leveldb#leveldb-read-options__@
             _args276118276145_)))
  (define std/db/leveldb#leveldb-default-read-options
    (lambda () (force std/db/leveldb#default-read-options)))
  (define std/db/leveldb#default-read-options
    (make-promise
     (lambda ()
       (std/db/leveldb#leveldb-read-options__%
        '#f
        absent-value
        absent-value))))
  (define std/db/leveldb#leveldb-write-options__%
    (lambda (_g312807_ _sync276085276088_)
      (let* ((_sync276091_
              (if (eq? _sync276085276088_ absent-value)
                  '#f
                  _sync276085276088_))
             (_opts276096_
              (let ((_ptr276093_
                     (std/db/_leveldb#leveldb_writeoptions_create)))
                (if _ptr276093_
                    _ptr276093_
                    (std/db/leveldb#raise-leveldb-error
                     'leveldb_writeoptions_create
                     '"Error allocating pointer")))))
        (if _sync276091_
            (std/db/_leveldb#leveldb_writeoptions_set_sync _opts276096_ '1)
            '#!void)
        _opts276096_)))
  (define std/db/leveldb#leveldb-write-options__@
    (lambda (_keys276084276101_ . _args276103_)
      (apply std/db/leveldb#leveldb-write-options__%
             _keys276084276101_
             (table-ref _keys276084276101_ 'sync: absent-value)
             _args276103_)))
  (define std/db/leveldb#leveldb-write-options
    (lambda _args276086276109_
      (apply keyword-dispatch
             '#(sync:)
             std/db/leveldb#leveldb-write-options__@
             _args276086276109_)))
  (define std/db/leveldb#leveldb-default-write-options
    (lambda () (force std/db/leveldb#default-write-options)))
  (define std/db/leveldb#default-write-options
    (make-promise
     (lambda () (std/db/leveldb#leveldb-write-options__% '#f absent-value)))))
