(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/generic/dispatch#type-of
    (lambda (_obj5363_)
      (declare (not interrupts-enabled))
      (let ((_t5366_ (##type _obj5363_)))
        (if (##fx= _t5366_ (macro-type-mem1))
            (let ((_st5368_ (##subtype _obj5363_)))
              (if (##fx= _st5368_ (macro-subtype-structure))
                  (##type-id (##structure-type _obj5363_))
                  (if (##fx= _st5368_ (macro-subtype-boxvalues))
                      (if (##fx= (##vector-length _obj5363_) '1) 'box 'values)
                      (##vector-ref
                       std/generic/dispatch#+subtype-id+
                       _st5368_))))
            (if (##fx= _t5366_ (macro-type-mem2))
                'pair
                (if (##fx= _t5366_ (macro-type-fixnum))
                    'fixnum
                    (if (##char? _obj5363_)
                        'char
                        (if (##eq? _obj5363_ '())
                            'null
                            (if (##eq? _obj5363_ '#f)
                                'boolean
                                (if (##eq? _obj5363_ '#t)
                                    'boolean
                                    (if (##eq? _obj5363_ '#!void)
                                        'void
                                        (if (##eq? _obj5363_ '#!eof)
                                            'eof
                                            'unknown))))))))))))
  (define std/generic/dispatch#linear-type-of
    (lambda (_obj5355_)
      (let ((_t5357_ (##type _obj5355_)))
        (if (##fx= _t5357_ (macro-type-mem1))
            (let ((_st5359_ (##subtype _obj5355_)))
              (if (##fx= _st5359_ (macro-subtype-structure))
                  (let ((_klass5361_ (##structure-type _obj5355_)))
                    (std/generic/dispatch#type-linearize-class _klass5361_))
                  (if (##fx= _st5359_ (macro-subtype-boxvalues))
                      (if (##fx= (##vector-length _obj5355_) '1)
                          '(box t)
                          '(values t))
                      (##vector-ref
                       std/generic/dispatch#+subtype-linear+
                       _st5359_))))
            (if (##fx= _t5357_ (macro-type-mem2))
                '(pair t)
                (if (##fx= _t5357_ (macro-type-fixnum))
                    '(fixnum integer real number t)
                    (if (##char? _obj5355_)
                        '(char t)
                        (if (##eq? _obj5355_ '())
                            '(null t)
                            (if (##eq? _obj5355_ '#f)
                                '(boolean t)
                                (if (##eq? _obj5355_ '#t)
                                    '(boolean t)
                                    (if (##eq? _obj5355_ '#!void)
                                        '(void t)
                                        (if (##eq? _obj5355_ '#!eof)
                                            '(eof t)
                                            '(unknown)))))))))))))
  (define std/generic/dispatch#type-linearize-class
    (lambda (_klass5353_)
      (if (type-descriptor? _klass5353_)
          (if (type-descriptor-mixin _klass5353_)
              (std/generic/dispatch#type-linearize-class-type _klass5353_)
              (std/generic/dispatch#type-linearize-struct-type _klass5353_))
          (std/generic/dispatch#type-linearize-record-type__0 _klass5353_))))
  (define std/generic/dispatch#type-linearize-class-type
    (lambda (_klass5313_)
      (let _lp5315_ ((_rest5317_ (type-descriptor-mixin _klass5313_))
                     (_r5318_ (cons (##type-id _klass5313_) '())))
        (let* ((_rest53195327_ _rest5317_)
               (_else53215335_ (lambda () (foldl1 cons '(object t) _r5318_)))
               (_K53235341_
                (lambda (_rest5338_ _klass5339_)
                  (_lp5315_
                   _rest5338_
                   (cons (##type-id _klass5339_) _r5318_)))))
          (if (##pair? _rest53195327_)
              (let ((_hd53245344_ (##car _rest53195327_))
                    (_tl53255346_ (##cdr _rest53195327_)))
                (let* ((_klass5349_ _hd53245344_) (_rest5351_ _tl53255346_))
                  (_K53235341_ _rest5351_ _klass5349_)))
              (_else53215335_))))))
  (define std/generic/dispatch#type-linearize-struct-type
    (lambda (_klass5311_)
      (std/generic/dispatch#type-linearize-record-type__%
       _klass5311_
       '(object t))))
  (define std/generic/dispatch#type-linearize-record-type__%
    (lambda (_klass5293_ _base5294_)
      (let _lp5296_ ((_klass5298_ _klass5293_) (_r5299_ '()))
        (if (##type? _klass5298_)
            (_lp5296_
             (##type-super _klass5298_)
             (cons (##type-id _klass5298_) _r5299_))
            (foldl1 cons _base5294_ _r5299_)))))
  (define std/generic/dispatch#type-linearize-record-type__0
    (lambda (_klass5304_)
      (let ((_base5306_ '(t)))
        (std/generic/dispatch#type-linearize-record-type__%
         _klass5304_
         _base5306_))))
  (define std/generic/dispatch#type-linearize-record-type
    (lambda _g283135_
      (let ((_g283134_ (##length _g283135_)))
        (cond ((##fx= _g283134_ 1)
               (apply std/generic/dispatch#type-linearize-record-type__0
                      _g283135_))
              ((##fx= _g283134_ 2)
               (apply std/generic/dispatch#type-linearize-record-type__%
                      _g283135_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/generic/dispatch#type-linearize-record-type
                _g283135_))))))
  (define std/generic/dispatch#+subtype-id+ (make-vector '32 'unknown))
  (define std/generic/dispatch#+subtype-linear+ (make-vector '32 '(unknown)))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-vector)
   'vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-vector)
   '(vector t))
  (vector-set! std/generic/dispatch#+subtype-id+ (macro-subtype-pair) 'pair)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-pair)
   '(pair t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-ratnum)
   'ratnum)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-ratnum)
   '(ratnum real number t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-cpxnum)
   'cpxnum)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-cpxnum)
   '(cpxnum number t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-symbol)
   'symbol)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-symbol)
   '(symbol t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-keyword)
   'keyword)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-keyword)
   '(keyword t))
  (vector-set! std/generic/dispatch#+subtype-id+ (macro-subtype-frame) 'frame)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-frame)
   '(frame t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-continuation)
   'continuation)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-continuation)
   '(continuation t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-promise)
   'promise)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-promise)
   '(promise t))
  (vector-set! std/generic/dispatch#+subtype-id+ (macro-subtype-weak) 'weak)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-weak)
   '(weak t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-procedure)
   'procedure)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-procedure)
   '(procedure t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-foreign)
   'foreign)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-foreign)
   '(foreign t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-string)
   'string)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-string)
   '(string t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-s8vector)
   's8vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-s8vector)
   '(s8vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-u8vector)
   'u8vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-u8vector)
   '(u8vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-s16vector)
   's16vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-s16vector)
   '(s16vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-u16vector)
   'u16vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-u16vector)
   '(u16vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-s32vector)
   's32vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-s32vector)
   '(s32vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-u32vector)
   'u32vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-u32vector)
   '(u32vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-f32vector)
   'f32vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-f32vector)
   '(f32vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-s64vector)
   's64vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-s64vector)
   '(s64vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-u64vector)
   'u64vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-u64vector)
   '(u64vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-f64vector)
   'f64vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-f64vector)
   '(f64vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-flonum)
   'flonum)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-flonum)
   '(flonum real number t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-bignum)
   'bignum)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-bignum)
   '(bignum integer real number t))
  (define std/generic/dispatch#generic::t
    (make-struct-type
     'std/generic/dispatch#generic::t
     '#f
     '4
     'generic
     '((final: . #t))
     ':init!
     '(id tabs default mx)))
  (define std/generic/dispatch#generic?
    (make-struct-predicate std/generic/dispatch#generic::t))
  (define std/generic/dispatch#make-generic
    (lambda _$args5289_
      (apply make-struct-instance
             std/generic/dispatch#generic::t
             _$args5289_)))
  (define std/generic/dispatch#generic-id
    (make-struct-field-accessor std/generic/dispatch#generic::t '0))
  (define std/generic/dispatch#generic-tabs
    (make-struct-field-accessor std/generic/dispatch#generic::t '1))
  (define std/generic/dispatch#generic-default
    (make-struct-field-accessor std/generic/dispatch#generic::t '2))
  (define std/generic/dispatch#generic-mx
    (make-struct-field-accessor std/generic/dispatch#generic::t '3))
  (define std/generic/dispatch#generic-id-set!
    (make-struct-field-mutator std/generic/dispatch#generic::t '0))
  (define std/generic/dispatch#generic-tabs-set!
    (make-struct-field-mutator std/generic/dispatch#generic::t '1))
  (define std/generic/dispatch#generic-default-set!
    (make-struct-field-mutator std/generic/dispatch#generic::t '2))
  (define std/generic/dispatch#generic-mx-set!
    (make-struct-field-mutator std/generic/dispatch#generic::t '3))
  (define std/generic/dispatch#&generic-id
    (make-struct-field-unchecked-accessor std/generic/dispatch#generic::t '0))
  (define std/generic/dispatch#&generic-tabs
    (make-struct-field-unchecked-accessor std/generic/dispatch#generic::t '1))
  (define std/generic/dispatch#&generic-default
    (make-struct-field-unchecked-accessor std/generic/dispatch#generic::t '2))
  (define std/generic/dispatch#&generic-mx
    (make-struct-field-unchecked-accessor std/generic/dispatch#generic::t '3))
  (define std/generic/dispatch#&generic-id-set!
    (make-struct-field-unchecked-mutator std/generic/dispatch#generic::t '0))
  (define std/generic/dispatch#&generic-tabs-set!
    (make-struct-field-unchecked-mutator std/generic/dispatch#generic::t '1))
  (define std/generic/dispatch#&generic-default-set!
    (make-struct-field-unchecked-mutator std/generic/dispatch#generic::t '2))
  (define std/generic/dispatch#&generic-mx-set!
    (make-struct-field-unchecked-mutator std/generic/dispatch#generic::t '3))
  (define std/generic/dispatch#generic:::init!__%
    (lambda (_self5270_ _id5271_ _default5272_)
      (if (or (not _default5272_) (procedure? _default5272_))
          '#!void
          (error '"Bad default method; expected procedure or #f"
                 _id5271_
                 _default5272_))
      (if (##fx< '4 (##vector-length _self5270_))
          (begin
            (##vector-set! _self5270_ '1 _id5271_)
            (##vector-set! _self5270_ '2 (vector))
            (##vector-set! _self5270_ '3 _default5272_)
            (##vector-set! _self5270_ '4 (make-mutex 'generic)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self5270_))))
  (define std/generic/dispatch#generic:::init!__0
    (lambda (_self5280_ _id5281_)
      (let ((_default5283_ '#f))
        (std/generic/dispatch#generic:::init!__%
         _self5280_
         _id5281_
         _default5283_))))
  (define std/generic/dispatch#generic:::init!
    (lambda _g283137_
      (let ((_g283136_ (##length _g283137_)))
        (cond ((##fx= _g283136_ 2)
               (apply std/generic/dispatch#generic:::init!__0 _g283137_))
              ((##fx= _g283136_ 3)
               (apply std/generic/dispatch#generic:::init!__% _g283137_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/generic/dispatch#generic:::init!
                _g283137_))))))
  (bind-method!
   std/generic/dispatch#generic::t
   ':init!
   std/generic/dispatch#generic:::init!
   '#f)
  (define std/generic/dispatch#generic-table::t
    (make-struct-type
     'std/generic/dispatch#generic-table::t
     '#f
     '3
     'generic-table
     '((final: . #t))
     ':init!
     '(methods cache mx)))
  (define std/generic/dispatch#generic-table?
    (make-struct-predicate std/generic/dispatch#generic-table::t))
  (define std/generic/dispatch#make-generic-table
    (lambda _$args5144_
      (apply make-struct-instance
             std/generic/dispatch#generic-table::t
             _$args5144_)))
  (define std/generic/dispatch#generic-table-methods
    (make-struct-field-accessor std/generic/dispatch#generic-table::t '0))
  (define std/generic/dispatch#generic-table-cache
    (make-struct-field-accessor std/generic/dispatch#generic-table::t '1))
  (define std/generic/dispatch#generic-table-mx
    (make-struct-field-accessor std/generic/dispatch#generic-table::t '2))
  (define std/generic/dispatch#generic-table-methods-set!
    (make-struct-field-mutator std/generic/dispatch#generic-table::t '0))
  (define std/generic/dispatch#generic-table-cache-set!
    (make-struct-field-mutator std/generic/dispatch#generic-table::t '1))
  (define std/generic/dispatch#generic-table-mx-set!
    (make-struct-field-mutator std/generic/dispatch#generic-table::t '2))
  (define std/generic/dispatch#&generic-table-methods
    (make-struct-field-unchecked-accessor
     std/generic/dispatch#generic-table::t
     '0))
  (define std/generic/dispatch#&generic-table-cache
    (make-struct-field-unchecked-accessor
     std/generic/dispatch#generic-table::t
     '1))
  (define std/generic/dispatch#&generic-table-mx
    (make-struct-field-unchecked-accessor
     std/generic/dispatch#generic-table::t
     '2))
  (define std/generic/dispatch#&generic-table-methods-set!
    (make-struct-field-unchecked-mutator
     std/generic/dispatch#generic-table::t
     '0))
  (define std/generic/dispatch#&generic-table-cache-set!
    (make-struct-field-unchecked-mutator
     std/generic/dispatch#generic-table::t
     '1))
  (define std/generic/dispatch#&generic-table-mx-set!
    (make-struct-field-unchecked-mutator
     std/generic/dispatch#generic-table::t
     '2))
  (define std/generic/dispatch#generic-table:::init!
    (lambda (_self5142_)
      (if (##fx< '3 (##vector-length _self5142_))
          (begin
            (##vector-set! _self5142_ '1 '())
            (##vector-set! _self5142_ '2 (make-vector '10 '#f))
            (##vector-set! _self5142_ '3 (make-mutex 'generic-table)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self5142_))))
  (bind-method!
   std/generic/dispatch#generic-table::t
   ':init!
   std/generic/dispatch#generic-table:::init!
   '#f)
  (define std/generic/dispatch#generic-bind!
    (lambda (_gen5001_ _signature5002_ _method5003_)
      (if (procedure? _method5003_)
          '#!void
          (error '"Bad method; expected procedure" _method5003_))
      (let ((_arity5005_ (length _signature5002_))
            (_mx5006_
             (##unchecked-structure-ref
              _gen5001_
              '4
              std/generic/dispatch#generic::t
              '#f)))
        (mutex-lock! _mx5006_)
        (let ((_tabs5008_
               (##unchecked-structure-ref
                _gen5001_
                '2
                std/generic/dispatch#generic::t
                '#f)))
          (if (##fx< _arity5005_ (##vector-length _tabs5008_))
              (let ((_$e5010_ (##vector-ref _tabs5008_ _arity5005_)))
                (if _$e5010_
                    ((lambda (_gtab5013_)
                       (std/generic/dispatch#generic-bind-method!
                        _gtab5013_
                        _signature5002_
                        _method5003_))
                     _$e5010_)
                    (let ((_gtab5015_
                           (let ((__obj283132
                                  (make-object
                                   std/generic/dispatch#generic-table::t
                                   '3)))
                             (std/generic/dispatch#generic-table:::init!
                              __obj283132)
                             __obj283132)))
                      (##vector-set! _tabs5008_ _arity5005_ _gtab5015_)
                      (std/generic/dispatch#generic-bind-method!
                       _gtab5015_
                       _signature5002_
                       _method5003_))))
              (let ((_new-tabs5017_ (make-vector (##fx+ _arity5005_ '1) '#f))
                    (_gtab5018_
                     (let ((__obj283133
                            (make-object
                             std/generic/dispatch#generic-table::t
                             '3)))
                       (std/generic/dispatch#generic-table:::init! __obj283133)
                       __obj283133)))
                (##subvector-move!
                 _tabs5008_
                 '0
                 (##vector-length _tabs5008_)
                 _new-tabs5017_
                 '0)
                (##vector-set! _new-tabs5017_ _arity5005_ _gtab5018_)
                (##unchecked-structure-set!
                 _gen5001_
                 _new-tabs5017_
                 '2
                 std/generic/dispatch#generic::t
                 '#f)
                (std/generic/dispatch#generic-bind-method!
                 _gtab5018_
                 _signature5002_
                 _method5003_))))
        (mutex-unlock! _mx5006_))))
  (define std/generic/dispatch#generic-bind-method!
    (lambda (_gtab4974_ _signature4975_ _method4976_)
      (letrec ((_invalidate?4978_
                (lambda (_cache4990_)
                  (let ((_cache-len4992_ (##vector-length _cache4990_)))
                    (let _lp4994_ ((_i4996_ '0))
                      (if (##fx< _i4996_ _cache-len4992_)
                          (let ((_$e4998_ (##vector-ref _cache4990_ _i4996_)))
                            (if _$e4998_
                                _$e4998_
                                (_lp4994_ (##fx+ _i4996_ '1))))
                          '#f))))))
        (let _again4980_ ()
          (let* ((_old-methods4983_
                  (##unchecked-structure-ref
                   _gtab4974_
                   '1
                   std/generic/dispatch#generic-table::t
                   '#f))
                 (_new-methods4985_
                  (std/generic/dispatch#generic-add-method
                   _old-methods4983_
                   _signature4975_
                   _method4976_)))
            (let ((_mx4988_
                   (##unchecked-structure-ref
                    _gtab4974_
                    '3
                    std/generic/dispatch#generic-table::t
                    '#f)))
              (mutex-lock! _mx4988_)
              (if (eq? _old-methods4983_
                       (##unchecked-structure-ref
                        _gtab4974_
                        '1
                        std/generic/dispatch#generic-table::t
                        '#f))
                  (begin
                    (##unchecked-structure-set!
                     _gtab4974_
                     _new-methods4985_
                     '1
                     std/generic/dispatch#generic-table::t
                     '#f)
                    (if (_invalidate?4978_
                         (##unchecked-structure-ref
                          _gtab4974_
                          '2
                          std/generic/dispatch#generic-table::t
                          '#f))
                        (##unchecked-structure-set!
                         _gtab4974_
                         (make-vector
                          (##vector-length
                           (##unchecked-structure-ref
                            _gtab4974_
                            '2
                            std/generic/dispatch#generic-table::t
                            '#f))
                          '#f)
                         '2
                         std/generic/dispatch#generic-table::t
                         '#f)
                        '#!void)
                    (mutex-unlock! _mx4988_))
                  (begin (mutex-unlock! _mx4988_) (_again4980_)))))))))
  (define std/generic/dispatch#generic-add-method
    (lambda (_methods4905_ _signature4906_ _method4907_)
      (let _recur4909_ ((_rest4911_ _methods4905_))
        (let* ((_rest49124920_ _rest4911_)
               (_else49144928_
                (lambda () (cons (cons _signature4906_ _method4907_) '())))
               (_K49164962_
                (lambda (_rest4931_ _hd4932_)
                  (let* ((_hd49334940_ _hd4932_)
                         (_E49354944_
                          (lambda ()
                            (error '"No clause matching" _hd49334940_)))
                         (_K49364950_
                          (lambda (_hd-method4947_ _hd-signature4948_)
                            (if (std/generic/dispatch#generic-dispatch-before?
                                 _signature4906_
                                 _hd-signature4948_)
                                (cons (cons _signature4906_ _method4907_)
                                      (cons _hd4932_ _rest4931_))
                                (if (equal? _signature4906_ _hd-signature4948_)
                                    (cons (cons _signature4906_ _method4907_)
                                          _rest4931_)
                                    (cons _hd4932_
                                          (_recur4909_ _rest4931_)))))))
                    (if (##pair? _hd49334940_)
                        (let ((_hd49374953_ (##car _hd49334940_))
                              (_tl49384955_ (##cdr _hd49334940_)))
                          (let* ((_hd-signature4958_ _hd49374953_)
                                 (_hd-method4960_ _tl49384955_))
                            (_K49364950_ _hd-method4960_ _hd-signature4958_)))
                        (_E49354944_))))))
          (if (##pair? _rest49124920_)
              (let ((_hd49174965_ (##car _rest49124920_))
                    (_tl49184967_ (##cdr _rest49124920_)))
                (let* ((_hd4970_ _hd49174965_) (_rest4972_ _tl49184967_))
                  (_K49164962_ _rest4972_ _hd4970_)))
              (_else49144928_))))))
  (define std/generic/dispatch#generic-dispatch-before?
    (lambda (_sig-a4833_ _sig-b4834_)
      (let _lp4836_ ((_rest-a4838_ _sig-a4833_) (_rest-b4839_ _sig-b4834_))
        (let* ((_rest-a48404848_ _rest-a4838_)
               (_else48424856_ (lambda () '#f))
               (_K48444893_
                (lambda (_rest-a4859_ _type-a4860_)
                  (let* ((_rest-b48614868_ _rest-b4839_)
                         (_E48634872_
                          (lambda ()
                            (error '"No clause matching" _rest-b48614868_)))
                         (_K48644881_
                          (lambda (_rest-b4875_ _type-b4876_)
                            (if (not (std/generic/dispatch#generic-dispatch-type<?
                                      _type-b4876_
                                      _type-a4860_))
                                (let ((_$e4878_
                                       (std/generic/dispatch#generic-dispatch-type<?
                                        _type-a4860_
                                        _type-b4876_)))
                                  (if _$e4878_
                                      _$e4878_
                                      (_lp4836_ _rest-a4859_ _rest-b4875_)))
                                '#f))))
                    (if (##pair? _rest-b48614868_)
                        (let ((_hd48654884_ (##car _rest-b48614868_))
                              (_tl48664886_ (##cdr _rest-b48614868_)))
                          (let* ((_type-b4889_ _hd48654884_)
                                 (_rest-b4891_ _tl48664886_))
                            (_K48644881_ _rest-b4891_ _type-b4889_)))
                        (_E48634872_))))))
          (if (##pair? _rest-a48404848_)
              (let ((_hd48454896_ (##car _rest-a48404848_))
                    (_tl48464898_ (##cdr _rest-a48404848_)))
                (let* ((_type-a4901_ _hd48454896_) (_rest-a4903_ _tl48464898_))
                  (_K48444893_ _rest-a4903_ _type-a4901_)))
              (_else48424856_))))))
  (define std/generic/dispatch#generic-dispatch-type<?
    (lambda (_type-a4830_ _type-b4831_)
      (memq (car _type-b4831_) _type-a4830_)))
  (define std/generic/dispatch#generic-dispatch
    (lambda (_gen4809_ . _args4810_)
      (let ((_arity4812_ (##length _args4810_))
            (_tabs4813_
             (##unchecked-structure-ref
              _gen4809_
              '2
              std/generic/dispatch#generic::t
              '#f)))
        (let ((_$e4815_
               (if (##fx< _arity4812_ (##vector-length _tabs4813_))
                   (##vector-ref _tabs4813_ _arity4812_)
                   '#f)))
          (if _$e4815_
              ((lambda (_gtab4818_)
                 (let ((_$e4820_
                        (std/generic/dispatch#generic-dispatch-method
                         _gtab4818_
                         _args4810_
                         (##unchecked-structure-ref
                          _gen4809_
                          '3
                          std/generic/dispatch#generic::t
                          '#f))))
                   (if _$e4820_
                       ((lambda (_method4823_) (apply _method4823_ _args4810_))
                        _$e4820_)
                       (error '"No method matching arguments"
                              (##direct-structure-ref
                               _gen4809_
                               '1
                               std/generic/dispatch#generic::t
                               '#f)
                              _args4810_))))
               _$e4815_)
              (let ((_$e4825_
                     (##unchecked-structure-ref
                      _gen4809_
                      '3
                      std/generic/dispatch#generic::t
                      '#f)))
                (if _$e4825_
                    ((lambda (_method4828_) (apply _method4828_ _args4810_))
                     _$e4825_)
                    (error '"No method matching arguments"
                           (##direct-structure-ref
                            _gen4809_
                            '1
                            std/generic/dispatch#generic::t
                            '#f)
                           _args4810_))))))))
  (define std/generic/dispatch#generic-dispatch-method
    (lambda (_gtab4802_ _args4803_ _default4804_)
      (let ((_$e4806_
             (std/generic/dispatch#generic-dispatch-cache-lookup
              (##unchecked-structure-ref
               _gtab4802_
               '2
               std/generic/dispatch#generic-table::t
               '#f)
              _args4803_)))
        (if _$e4806_
            _$e4806_
            (std/generic/dispatch#generic-dispatch-method-ref
             _gtab4802_
             _args4803_
             _default4804_)))))
  (define std/generic/dispatch#generic-dispatch-method-ref
    (lambda (_gtab4788_ _args4789_ _default4790_)
      (let* ((_methods4792_
              (##unchecked-structure-ref
               _gtab4788_
               '1
               std/generic/dispatch#generic-table::t
               '#f))
             (_method4797_
              (let ((_$e4794_
                     (std/generic/dispatch#generic-dispatch-find-method
                      _methods4792_
                      _args4789_)))
                (if _$e4794_ _$e4794_ _default4790_))))
        (if _method4797_
            (let ((_mx4800_
                   (##unchecked-structure-ref
                    _gtab4788_
                    '3
                    std/generic/dispatch#generic-table::t
                    '#f)))
              (mutex-lock! _mx4800_)
              (if (eq? _methods4792_
                       (##unchecked-structure-ref
                        _gtab4788_
                        '1
                        std/generic/dispatch#generic-table::t
                        '#f))
                  (if (std/generic/dispatch#generic-dispatch-cache-lookup
                       (##unchecked-structure-ref
                        _gtab4788_
                        '2
                        std/generic/dispatch#generic-table::t
                        '#f)
                       _args4789_)
                      '#!void
                      (std/generic/dispatch#generic-dispatch-cache!
                       _gtab4788_
                       _args4789_
                       _method4797_))
                  '#!void)
              (mutex-unlock! _mx4800_))
            '#!void)
        _method4797_)))
  (define std/generic/dispatch#generic-dispatch1
    (lambda (_gen4765_ _arg14767_)
      (let* ((_tabs4769_
              (##unchecked-structure-ref
               _gen4765_
               '2
               std/generic/dispatch#generic::t
               '#f))
             (_$e4772_
              (if (##fx< '1 (##vector-length _tabs4769_))
                  (##vector-ref _tabs4769_ '1)
                  '#f)))
        (if _$e4772_
            ((lambda (_gtab4775_)
               (let ((_$e4777_
                      (std/generic/dispatch#generic-dispatch-method1
                       _gtab4775_
                       (##unchecked-structure-ref
                        _gen4765_
                        '3
                        std/generic/dispatch#generic::t
                        '#f)
                       _arg14767_)))
                 (if _$e4777_
                     ((lambda (_method4780_) (_method4780_ _arg14767_))
                      _$e4777_)
                     (error '"No method matching arguments"
                            (##direct-structure-ref
                             _gen4765_
                             '1
                             std/generic/dispatch#generic::t
                             '#f)
                            (cons _arg14767_ '())))))
             _$e4772_)
            (let ((_$e4783_
                   (##unchecked-structure-ref
                    _gen4765_
                    '3
                    std/generic/dispatch#generic::t
                    '#f)))
              (if _$e4783_
                  ((lambda (_method4786_) (_method4786_ _arg14767_)) _$e4783_)
                  (error '"No method matching arguments"
                         (##direct-structure-ref
                          _gen4765_
                          '1
                          std/generic/dispatch#generic::t
                          '#f)
                         (cons _arg14767_ '()))))))))
  (define std/generic/dispatch#generic-dispatch-method1
    (lambda (_gtab4756_ _default4758_ _arg14760_)
      (let ((_$e4762_
             (std/generic/dispatch#generic-dispatch-cache-lookup1
              (##unchecked-structure-ref
               _gtab4756_
               '2
               std/generic/dispatch#generic-table::t
               '#f)
              _arg14760_)))
        (if _$e4762_
            _$e4762_
            (std/generic/dispatch#generic-dispatch-method-ref
             _gtab4756_
             (cons _arg14760_ '())
             _default4758_)))))
  (define std/generic/dispatch#generic-dispatch2
    (lambda (_gen4732_ _arg14734_ _arg24735_)
      (let* ((_tabs4737_
              (##unchecked-structure-ref
               _gen4732_
               '2
               std/generic/dispatch#generic::t
               '#f))
             (_$e4740_
              (if (##fx< '2 (##vector-length _tabs4737_))
                  (##vector-ref _tabs4737_ '2)
                  '#f)))
        (if _$e4740_
            ((lambda (_gtab4743_)
               (let ((_$e4745_
                      (std/generic/dispatch#generic-dispatch-method2
                       _gtab4743_
                       (##unchecked-structure-ref
                        _gen4732_
                        '3
                        std/generic/dispatch#generic::t
                        '#f)
                       _arg14734_
                       _arg24735_)))
                 (if _$e4745_
                     ((lambda (_method4748_)
                        (_method4748_ _arg14734_ _arg24735_))
                      _$e4745_)
                     (error '"No method matching arguments"
                            (##direct-structure-ref
                             _gen4732_
                             '1
                             std/generic/dispatch#generic::t
                             '#f)
                            (cons _arg14734_ (cons _arg24735_ '()))))))
             _$e4740_)
            (let ((_$e4751_
                   (##unchecked-structure-ref
                    _gen4732_
                    '3
                    std/generic/dispatch#generic::t
                    '#f)))
              (if _$e4751_
                  ((lambda (_method4754_) (_method4754_ _arg14734_ _arg24735_))
                   _$e4751_)
                  (error '"No method matching arguments"
                         (##direct-structure-ref
                          _gen4732_
                          '1
                          std/generic/dispatch#generic::t
                          '#f)
                         (cons _arg14734_ (cons _arg24735_ '())))))))))
  (define std/generic/dispatch#generic-dispatch-method2
    (lambda (_gtab4722_ _default4724_ _arg14726_ _arg24727_)
      (let ((_$e4729_
             (std/generic/dispatch#generic-dispatch-cache-lookup2
              (##unchecked-structure-ref
               _gtab4722_
               '2
               std/generic/dispatch#generic-table::t
               '#f)
              _arg14726_
              _arg24727_)))
        (if _$e4729_
            _$e4729_
            (std/generic/dispatch#generic-dispatch-method-ref
             _gtab4722_
             (cons _arg14726_ (cons _arg24727_ '()))
             _default4724_)))))
  (define std/generic/dispatch#generic-dispatch3
    (lambda (_gen4697_ _arg14699_ _arg24700_ _arg34701_)
      (let* ((_tabs4703_
              (##unchecked-structure-ref
               _gen4697_
               '2
               std/generic/dispatch#generic::t
               '#f))
             (_$e4706_
              (if (##fx< '3 (##vector-length _tabs4703_))
                  (##vector-ref _tabs4703_ '3)
                  '#f)))
        (if _$e4706_
            ((lambda (_gtab4709_)
               (let ((_$e4711_
                      (std/generic/dispatch#generic-dispatch-method3
                       _gtab4709_
                       (##unchecked-structure-ref
                        _gen4697_
                        '3
                        std/generic/dispatch#generic::t
                        '#f)
                       _arg14699_
                       _arg24700_
                       _arg34701_)))
                 (if _$e4711_
                     ((lambda (_method4714_)
                        (_method4714_ _arg14699_ _arg24700_ _arg34701_))
                      _$e4711_)
                     (error '"No method matching arguments"
                            (##direct-structure-ref
                             _gen4697_
                             '1
                             std/generic/dispatch#generic::t
                             '#f)
                            (cons _arg14699_
                                  (cons _arg24700_ (cons _arg34701_ '())))))))
             _$e4706_)
            (let ((_$e4717_
                   (##unchecked-structure-ref
                    _gen4697_
                    '3
                    std/generic/dispatch#generic::t
                    '#f)))
              (if _$e4717_
                  ((lambda (_method4720_)
                     (_method4720_ _arg14699_ _arg24700_ _arg34701_))
                   _$e4717_)
                  (error '"No method matching arguments"
                         (##direct-structure-ref
                          _gen4697_
                          '1
                          std/generic/dispatch#generic::t
                          '#f)
                         (cons _arg14699_
                               (cons _arg24700_ (cons _arg34701_ '()))))))))))
  (define std/generic/dispatch#generic-dispatch-method3
    (lambda (_gtab4686_ _default4688_ _arg14690_ _arg24691_ _arg34692_)
      (let ((_$e4694_
             (std/generic/dispatch#generic-dispatch-cache-lookup3
              (##unchecked-structure-ref
               _gtab4686_
               '2
               std/generic/dispatch#generic-table::t
               '#f)
              _arg14690_
              _arg24691_
              _arg34692_)))
        (if _$e4694_
            _$e4694_
            (std/generic/dispatch#generic-dispatch-method-ref
             _gtab4686_
             (cons _arg14690_ (cons _arg24691_ (cons _arg34692_ '())))
             _default4688_)))))
  (define std/generic/dispatch#generic-dispatch4
    (lambda (_gen4660_ _arg14662_ _arg24663_ _arg34664_ _arg44665_)
      (let* ((_tabs4667_
              (##unchecked-structure-ref
               _gen4660_
               '2
               std/generic/dispatch#generic::t
               '#f))
             (_$e4670_
              (if (##fx< '4 (##vector-length _tabs4667_))
                  (##vector-ref _tabs4667_ '4)
                  '#f)))
        (if _$e4670_
            ((lambda (_gtab4673_)
               (let ((_$e4675_
                      (std/generic/dispatch#generic-dispatch-method4
                       _gtab4673_
                       (##unchecked-structure-ref
                        _gen4660_
                        '3
                        std/generic/dispatch#generic::t
                        '#f)
                       _arg14662_
                       _arg24663_
                       _arg34664_
                       _arg44665_)))
                 (if _$e4675_
                     ((lambda (_method4678_)
                        (_method4678_
                         _arg14662_
                         _arg24663_
                         _arg34664_
                         _arg44665_))
                      _$e4675_)
                     (error '"No method matching arguments"
                            (##direct-structure-ref
                             _gen4660_
                             '1
                             std/generic/dispatch#generic::t
                             '#f)
                            (cons _arg14662_
                                  (cons _arg24663_
                                        (cons _arg34664_
                                              (cons _arg44665_ '()))))))))
             _$e4670_)
            (let ((_$e4681_
                   (##unchecked-structure-ref
                    _gen4660_
                    '3
                    std/generic/dispatch#generic::t
                    '#f)))
              (if _$e4681_
                  ((lambda (_method4684_)
                     (_method4684_
                      _arg14662_
                      _arg24663_
                      _arg34664_
                      _arg44665_))
                   _$e4681_)
                  (error '"No method matching arguments"
                         (##direct-structure-ref
                          _gen4660_
                          '1
                          std/generic/dispatch#generic::t
                          '#f)
                         (cons _arg14662_
                               (cons _arg24663_
                                     (cons _arg34664_
                                           (cons _arg44665_ '())))))))))))
  (define std/generic/dispatch#generic-dispatch-method4
    (lambda (_gtab4648_
             _default4650_
             _arg14652_
             _arg24653_
             _arg34654_
             _arg44655_)
      (let ((_$e4657_
             (std/generic/dispatch#generic-dispatch-cache-lookup4
              (##unchecked-structure-ref
               _gtab4648_
               '2
               std/generic/dispatch#generic-table::t
               '#f)
              _arg14652_
              _arg24653_
              _arg34654_
              _arg44655_)))
        (if _$e4657_
            _$e4657_
            (std/generic/dispatch#generic-dispatch-method-ref
             _gtab4648_
             (cons _arg14652_
                   (cons _arg24653_ (cons _arg34654_ (cons _arg44655_ '()))))
             _default4650_)))))
  (define std/generic/dispatch#generic-dispatch-find-method
    (lambda (_methods4578_ _args4579_)
      (let ((_arg-types4581_
             (map std/generic/dispatch#linear-type-of _args4579_)))
        (let _lp4583_ ((_rest4585_ _methods4578_))
          (let* ((_rest45864594_ _rest4585_)
                 (_else45884602_ (lambda () '#f))
                 (_K45904636_
                  (lambda (_rest4605_ _hd4606_)
                    (let* ((_hd46074614_ _hd4606_)
                           (_E46094618_
                            (lambda ()
                              (error '"No clause matching" _hd46074614_)))
                           (_K46104624_
                            (lambda (_method4621_ _signature4622_)
                              (if (std/generic/dispatch#generic-dispatch-match?
                                   _arg-types4581_
                                   _signature4622_)
                                  _method4621_
                                  (_lp4583_ _rest4605_)))))
                      (if (##pair? _hd46074614_)
                          (let ((_hd46114627_ (##car _hd46074614_))
                                (_tl46124629_ (##cdr _hd46074614_)))
                            (let* ((_signature4632_ _hd46114627_)
                                   (_method4634_ _tl46124629_))
                              (_K46104624_ _method4634_ _signature4632_)))
                          (_E46094618_))))))
            (if (##pair? _rest45864594_)
                (let ((_hd45914639_ (##car _rest45864594_))
                      (_tl45924641_ (##cdr _rest45864594_)))
                  (let* ((_hd4644_ _hd45914639_) (_rest4646_ _tl45924641_))
                    (_K45904636_ _rest4646_ _hd4644_)))
                (_else45884602_)))))))
  (define std/generic/dispatch#generic-dispatch-match?
    (lambda (_arg-types4509_ _signature4510_)
      (let _lp4512_ ((_rest-args4514_ _arg-types4509_)
                     (_rest-sign4515_ _signature4510_))
        (let* ((_rest-args45164524_ _rest-args4514_)
               (_else45184532_ (lambda () '#t))
               (_K45204566_
                (lambda (_rest-args4535_ _arg-tids4536_)
                  (let* ((_rest-sign45374544_ _rest-sign4515_)
                         (_E45394548_
                          (lambda ()
                            (error '"No clause matching" _rest-sign45374544_)))
                         (_K45404554_
                          (lambda (_rest-sign4551_ _sign-tids4552_)
                            (if (memq (car _sign-tids4552_) _arg-tids4536_)
                                (_lp4512_ _rest-args4535_ _rest-sign4551_)
                                '#f))))
                    (if (##pair? _rest-sign45374544_)
                        (let ((_hd45414557_ (##car _rest-sign45374544_))
                              (_tl45424559_ (##cdr _rest-sign45374544_)))
                          (let* ((_sign-tids4562_ _hd45414557_)
                                 (_rest-sign4564_ _tl45424559_))
                            (_K45404554_ _rest-sign4564_ _sign-tids4562_)))
                        (_E45394548_))))))
          (if (##pair? _rest-args45164524_)
              (let ((_hd45214569_ (##car _rest-args45164524_))
                    (_tl45224571_ (##cdr _rest-args45164524_)))
                (let* ((_arg-tids4574_ _hd45214569_)
                       (_rest-args4576_ _tl45224571_))
                  (_K45204566_ _rest-args4576_ _arg-tids4574_)))
              (_else45184532_))))))
  (define std/generic/dispatch#generic-dispatch-next
    (lambda (_gen4433_ _method4434_ . _args4435_)
      (letrec ((_drop4437_
                (lambda (_method4459_ _methods4460_)
                  (let _lp4462_ ((_rest4464_ _methods4460_))
                    (let* ((_rest44654475_ _rest4464_)
                           (_else44674483_ (lambda () '()))
                           (_K44694490_
                            (lambda (_rest4486_ _proc4487_ _signature4488_)
                              (if (eq? _method4459_ _proc4487_)
                                  _rest4486_
                                  (_lp4462_ _rest4486_)))))
                      (if (##pair? _rest44654475_)
                          (let ((_hd44704493_ (##car _rest44654475_))
                                (_tl44714495_ (##cdr _rest44654475_)))
                            (if (##pair? _hd44704493_)
                                (let ((_hd44724498_ (##car _hd44704493_))
                                      (_tl44734500_ (##cdr _hd44704493_)))
                                  (let* ((_signature4503_ _hd44724498_)
                                         (_proc4505_ _tl44734500_)
                                         (_rest4507_ _tl44714495_))
                                    (_K44694490_
                                     _rest4507_
                                     _proc4505_
                                     _signature4503_)))
                                (_else44674483_)))
                          (_else44674483_)))))))
        (let ((_arity4439_ (##length _args4435_))
              (_tabs4440_
               (##unchecked-structure-ref
                _gen4433_
                '2
                std/generic/dispatch#generic::t
                '#f)))
          (let ((_$e4442_
                 (if (##fx< _arity4439_ (##vector-length _tabs4440_))
                     (##vector-ref _tabs4440_ _arity4439_)
                     '#f)))
            (if _$e4442_
                ((lambda (_gtab4445_)
                   (let* ((_methods4447_
                           (_drop4437_
                            _method4434_
                            (##unchecked-structure-ref
                             _gtab4445_
                             '1
                             std/generic/dispatch#generic-table::t
                             '#f)))
                          (_$e4449_
                           (std/generic/dispatch#generic-dispatch-find-method
                            _methods4447_
                            _args4435_)))
                     (if _$e4449_
                         ((lambda (_method4452_)
                            (apply _method4452_ _args4435_))
                          _$e4449_)
                         (let ((_$e4454_
                                (##unchecked-structure-ref
                                 _gen4433_
                                 '3
                                 std/generic/dispatch#generic::t
                                 '#f)))
                           (if _$e4454_
                               ((lambda (_method4457_)
                                  (apply _method4457_ _args4435_))
                                _$e4454_)
                               (error '"No next method matching arguments"
                                      (##direct-structure-ref
                                       _gen4433_
                                       '1
                                       std/generic/dispatch#generic::t
                                       '#f)
                                      _args4435_))))))
                 _$e4442_)
                (error '"Cannot dispatch next method; no dispatch table"
                       (##direct-structure-ref
                        _gen4433_
                        '1
                        std/generic/dispatch#generic::t
                        '#f)
                       _args4435_)))))))
  (define std/generic/dispatch#generic-dispatch-cache-lookup
    (lambda (_cache4346_ _args4347_)
      (declare (not interrupts-enabled))
      (letrec ((_lookup4349_
                (lambda (_hash4353_ _shift4354_ _rest4355_)
                  (let* ((_rest43564364_ _rest4355_)
                         (_else43584377_
                          (lambda ()
                            (let* ((_len4372_ (##vector-length _cache4346_))
                                   (_ix4374_
                                    (##fxmodulo _hash4353_ _len4372_)))
                              (##vector-ref _cache4346_ _ix4374_))))
                         (_K43604421_
                          (lambda (_rest4380_ _arg4381_)
                            (let* ((_tid4383_
                                    (std/generic/dispatch#type-of _arg4381_))
                                   (_hash4385_
                                    (##fxxor _hash4353_
                                             (##fxarithmetic-shift
                                              (##symbol-hash _tid4383_)
                                              _shift4354_))))
                              (let* ((_g43874395_
                                      (_lookup4349_
                                       _hash4385_
                                       (##fx+ _shift4354_ '1)
                                       _rest4380_))
                                     (_else43894403_ (lambda () '#f))
                                     (_K43914409_
                                      (lambda (_xrest4406_ _xtid4407_)
                                        (if (##eq? _tid4383_ _xtid4407_)
                                            _xrest4406_
                                            '#f))))
                                (if (##pair? _g43874395_)
                                    (let ((_hd43924412_ (##car _g43874395_))
                                          (_tl43934414_ (##cdr _g43874395_)))
                                      (let* ((_xtid4417_ _hd43924412_)
                                             (_xrest4419_ _tl43934414_))
                                        (_K43914409_ _xrest4419_ _xtid4417_)))
                                    (_else43894403_)))))))
                    (if (##pair? _rest43564364_)
                        (let ((_hd43614424_ (##car _rest43564364_))
                              (_tl43624426_ (##cdr _rest43564364_)))
                          (let* ((_arg4429_ _hd43614424_)
                                 (_rest4431_ _tl43624426_))
                            (_K43604421_ _rest4431_ _arg4429_)))
                        (_else43584377_))))))
        (let ((_proc4351_ (_lookup4349_ '0 '0 _args4347_)))
          (if (##procedure? _proc4351_) _proc4351_ '#f)))))
  (define std/generic/dispatch#cache-hash1
    (lambda (_cache4294_ _mix4295_ _shift4296_ _arg4297_)
      (declare (not interrupts-enabled))
      (let* ((_tid4300_ (std/generic/dispatch#type-of _arg4297_))
             (_hash4302_
              (##fxxor _mix4295_
                       (##fxarithmetic-shift
                        (##symbol-hash _tid4300_)
                        _shift4296_)))
             (_len4304_ (##vector-length _cache4294_))
             (_ix4306_ (##fxmodulo _hash4302_ _len4304_))
             (_obj4308_ (##vector-ref _cache4294_ _ix4306_)))
        (let* ((_obj43104318_ _obj4308_)
               (_else43124326_ (lambda () '#f))
               (_K43144334_
                (lambda (_rest4329_ _xtid4331_)
                  (if (eq? _tid4300_ _xtid4331_) _rest4329_ '#f))))
          (if (##pair? _obj43104318_)
              (let ((_hd43154337_ (##car _obj43104318_))
                    (_tl43164339_ (##cdr _obj43104318_)))
                (let* ((_xtid4342_ _hd43154337_) (_rest4344_ _tl43164339_))
                  (_K43144334_ _rest4344_ _xtid4342_)))
              (_else43124326_))))))
  (define std/generic/dispatch#cache-hash2
    (lambda (_cache4239_ _mix4241_ _shift4243_ _arg14245_ _arg24246_)
      (declare (not interrupts-enabled))
      (let* ((_tid4249_ (std/generic/dispatch#type-of _arg14245_))
             (_hash4252_
              (##fxxor _mix4241_
                       (##fxarithmetic-shift
                        (##symbol-hash _tid4249_)
                        _shift4243_)))
             (_obj4255_
              (std/generic/dispatch#cache-hash1
               _cache4239_
               _hash4252_
               (fx+ _shift4243_ '1)
               _arg24246_)))
        (let* ((_obj42584266_ _obj4255_)
               (_else42604274_ (lambda () '#f))
               (_K42624282_
                (lambda (_rest4277_ _xtid4279_)
                  (if (eq? _tid4249_ _xtid4279_) _rest4277_ '#f))))
          (if (##pair? _obj42584266_)
              (let ((_hd42634285_ (##car _obj42584266_))
                    (_tl42644287_ (##cdr _obj42584266_)))
                (let* ((_xtid4290_ _hd42634285_) (_rest4292_ _tl42644287_))
                  (_K42624282_ _rest4292_ _xtid4290_)))
              (_else42604274_))))))
  (define std/generic/dispatch#cache-hash3
    (lambda (_cache4183_
             _mix4185_
             _shift4187_
             _arg14189_
             _arg24190_
             _arg34191_)
      (declare (not interrupts-enabled))
      (let* ((_tid4194_ (std/generic/dispatch#type-of _arg14189_))
             (_hash4197_
              (##fxxor _mix4185_
                       (##fxarithmetic-shift
                        (##symbol-hash _tid4194_)
                        _shift4187_)))
             (_obj4200_
              (std/generic/dispatch#cache-hash2
               _cache4183_
               _hash4197_
               (fx+ _shift4187_ '1)
               _arg24190_
               _arg34191_)))
        (let* ((_obj42034211_ _obj4200_)
               (_else42054219_ (lambda () '#f))
               (_K42074227_
                (lambda (_rest4222_ _xtid4224_)
                  (if (eq? _tid4194_ _xtid4224_) _rest4222_ '#f))))
          (if (##pair? _obj42034211_)
              (let ((_hd42084230_ (##car _obj42034211_))
                    (_tl42094232_ (##cdr _obj42034211_)))
                (let* ((_xtid4235_ _hd42084230_) (_rest4237_ _tl42094232_))
                  (_K42074227_ _rest4237_ _xtid4235_)))
              (_else42054219_))))))
  (define std/generic/dispatch#cache-hash4
    (lambda (_cache4126_
             _mix4128_
             _shift4130_
             _arg14132_
             _arg24133_
             _arg34134_
             _arg44135_)
      (declare (not interrupts-enabled))
      (let* ((_tid4138_ (std/generic/dispatch#type-of _arg14132_))
             (_hash4141_
              (##fxxor _mix4128_
                       (##fxarithmetic-shift
                        (##symbol-hash _tid4138_)
                        _shift4130_)))
             (_obj4144_
              (std/generic/dispatch#cache-hash3
               _cache4126_
               _hash4141_
               (fx+ _shift4130_ '1)
               _arg24133_
               _arg34134_
               _arg44135_)))
        (let* ((_obj41474155_ _obj4144_)
               (_else41494163_ (lambda () '#f))
               (_K41514171_
                (lambda (_rest4166_ _xtid4168_)
                  (if (eq? _tid4138_ _xtid4168_) _rest4166_ '#f))))
          (if (##pair? _obj41474155_)
              (let ((_hd41524174_ (##car _obj41474155_))
                    (_tl41534176_ (##cdr _obj41474155_)))
                (let* ((_xtid4179_ _hd41524174_) (_rest4181_ _tl41534176_))
                  (_K41514171_ _rest4181_ _xtid4179_)))
              (_else41494163_))))))
  (define std/generic/dispatch#generic-dispatch-cache-lookup1
    (lambda (_cache4118_ _arg14120_)
      (declare (not interrupts-enabled))
      (let ((_method4123_
             (std/generic/dispatch#cache-hash1 _cache4118_ '0 '0 _arg14120_)))
        (if (##procedure? _method4123_) _method4123_ '#f))))
  (define std/generic/dispatch#generic-dispatch-cache-lookup2
    (lambda (_cache4109_ _arg14111_ _arg24112_)
      (declare (not interrupts-enabled))
      (let ((_method4115_
             (std/generic/dispatch#cache-hash2
              _cache4109_
              '0
              '0
              _arg14111_
              _arg24112_)))
        (if (##procedure? _method4115_) _method4115_ '#f))))
  (define std/generic/dispatch#generic-dispatch-cache-lookup3
    (lambda (_cache4099_ _arg14101_ _arg24102_ _arg34103_)
      (declare (not interrupts-enabled))
      (let ((_method4106_
             (std/generic/dispatch#cache-hash3
              _cache4099_
              '0
              '0
              _arg14101_
              _arg24102_
              _arg34103_)))
        (if (##procedure? _method4106_) _method4106_ '#f))))
  (define std/generic/dispatch#generic-dispatch-cache-lookup4
    (lambda (_cache4088_ _arg14090_ _arg24091_ _arg34092_ _arg44093_)
      (declare (not interrupts-enabled))
      (let ((_method4096_
             (std/generic/dispatch#cache-hash4
              _cache4088_
              '0
              '0
              _arg14090_
              _arg24091_
              _arg34092_
              _arg44093_)))
        (if (##procedure? _method4096_) _method4096_ '#f))))
  (define std/generic/dispatch#generic-dispatch-cache!
    (lambda (_gtab4061_ _args4062_ _method4063_)
      (let* ((_arg-types4065_ (map std/generic/dispatch#type-of _args4062_))
             (_entry4067_ (foldl1 cons _method4063_ _arg-types4065_))
             (_hash4073_
              (foldl2 (lambda (_tid4069_ _shift4070_ _r4071_)
                        (##fxxor _r4071_
                                 (##fxarithmetic-shift
                                  (##symbol-hash _tid4069_)
                                  _shift4070_)))
                      '0
                      _arg-types4065_
                      (iota (length _args4062_)))))
        (let _lp4076_ ((_cache4078_
                        (##unchecked-structure-ref
                         _gtab4061_
                         '2
                         std/generic/dispatch#generic-table::t
                         '#f)))
          (let* ((_len4080_ (##vector-length _cache4078_))
                 (_ix4082_ (##fxmodulo _hash4073_ _len4080_)))
            (if (##vector-ref _cache4078_ _ix4082_)
                (let ((_$e4085_
                       (std/generic/dispatch#generic-dispatch-cache-rehash
                        _cache4078_)))
                  (if _$e4085_ (_lp4076_ _$e4085_) '#!void))
                (begin
                  (##vector-set! _cache4078_ _ix4082_ _entry4067_)
                  (##unchecked-structure-set!
                   _gtab4061_
                   _cache4078_
                   '2
                   std/generic/dispatch#generic-table::t
                   '#f))))))))
  (define std/generic/dispatch#generic-dispatch-cache-rehash
    (lambda (_cache3989_)
      (letrec* ((_cache-len3991_ (##vector-length _cache3989_))
                (_hash-entry3992_
                 (lambda (_entry4016_)
                   (let _lp4018_ ((_rest4020_ _entry4016_)
                                  (_count4021_ '0)
                                  (_r4022_ '()))
                     (let* ((_rest40234031_ _rest4020_)
                            (_else40254043_
                             (lambda ()
                               (foldl2 (lambda (_tid4039_ _shift4040_ _r4041_)
                                         (##fxxor _r4041_
                                                  (##fxarithmetic-shift
                                                   (##symbol-hash _tid4039_)
                                                   _shift4040_)))
                                       '0
                                       _r4022_
                                       (iota _count4021_))))
                            (_K40274049_
                             (lambda (_rest4046_ _tid4047_)
                               (_lp4018_
                                _rest4046_
                                (##fx+ _count4021_ '1)
                                (cons _tid4047_ _r4022_)))))
                       (if (##pair? _rest40234031_)
                           (let ((_hd40284052_ (##car _rest40234031_))
                                 (_tl40294054_ (##cdr _rest40234031_)))
                             (let* ((_tid4057_ _hd40284052_)
                                    (_rest4059_ _tl40294054_))
                               (_K40274049_ _rest4059_ _tid4057_)))
                           (_else40254043_))))))
                (_rehash!3993_
                 (lambda (_new-cache4001_)
                   (letrec* ((_new-cache-len4003_
                              (##vector-length _new-cache4001_)))
                     (let _lp4005_ ((_i4007_ '0))
                       (if (##fx< _i4007_ _cache-len3991_)
                           (let ((_entry4009_
                                  (##vector-ref _cache3989_ _i4007_)))
                             (if _entry4009_
                                 (let* ((_hash4011_
                                         (_hash-entry3992_ _entry4009_))
                                        (_ix4013_
                                         (##fxmodulo
                                          _hash4011_
                                          _new-cache-len4003_)))
                                   (if (##vector-ref _new-cache4001_ _ix4013_)
                                       '#f
                                       (begin
                                         (##vector-set!
                                          _new-cache4001_
                                          _ix4013_
                                          _entry4009_)
                                         (_lp4005_ (##fx+ _i4007_ '1)))))
                                 (_lp4005_ (##fx+ _i4007_ '1))))
                           '#t))))))
        (let _retry3995_ ((_new-cache-len3997_
                           (##fxquotient (##fx* '3 _cache-len3991_) '2)))
          (if (##fx< _new-cache-len3997_ std/generic/dispatch#+max-cache-size+)
              (let ((_new-cache3999_ (make-vector _new-cache-len3997_ '#f)))
                (if (_rehash!3993_ _new-cache3999_)
                    _new-cache3999_
                    (_retry3995_
                     (##fxquotient (##fx* '3 _new-cache-len3997_) '2))))
              (begin
                (display '"*** Warning: cannot rehash generic cache; maximum cache size exceeded\n"
                         ##stderr-port)
                '#f))))))
  (define std/generic/dispatch#+max-cache-size+ (expt '2 '16)))
