(declare (block) (standard-bindings) (extended-bindings))
(begin
  (bind-method! (macro-type-port) 'destroy close-port)
  (define std/misc/ports#copy-port
    (lambda (_in231087_ _out231088_)
      (if (not (input-port? _in231087_))
          (error '"Expected input port" _in231087_)
          (if (not (output-port? _out231088_))
              (error '"Expected output port" _out231088_)
              (if (macro-byte-port? _in231087_)
                  (if (macro-byte-port? _out231088_)
                      (std/misc/ports#try-copy-byte-port
                       _in231087_
                       _out231088_)
                      (if (macro-character-port? _out231088_)
                          (std/misc/ports#copy-character-port
                           _in231087_
                           _out231088_)
                          (std/misc/ports#copy-object-port
                           _in231087_
                           _out231088_)))
                  (if (macro-character-port? _in231087_)
                      (if (macro-character-port? _out231088_)
                          (std/misc/ports#copy-character-port
                           _in231087_
                           _out231088_)
                          (std/misc/ports#copy-object-port
                           _in231087_
                           _out231088_))
                      (std/misc/ports#copy-object-port
                       _in231087_
                       _out231088_)))))))
  (define std/misc/ports#try-copy-byte-port
    (lambda (_in231081_ _out231082_)
      (macro-port-mutex-lock! _in231081_)
      (if (or (let ((__tmp303082 (macro-character-port-rlo _in231081_))
                    (__tmp303081 (macro-character-port-rhi _in231081_)))
                (declare (not safe))
                (##fx< __tmp303082 __tmp303081))
              (macro-character-port-peek-eof? _in231081_))
          (std/misc/ports#copy-character-port/lock _in231081_ _out231082_)
          (std/misc/ports#copy-byte-port/lock _in231081_ _out231082_))))
  (define std/misc/ports#copy-character-port
    (lambda (_in231078_ _out231079_)
      (macro-port-mutex-lock! _in231078_)
      (std/misc/ports#copy-character-port/lock _in231078_ _out231079_)))
  (define std/misc/ports#copy-byte-port/lock
    (lambda (_in231053_ _out231054_)
      (letrec ((_loop231056_
                (lambda ()
                  (let ((_rlo231066_ (macro-byte-port-rlo _in231053_))
                        (_rhi231067_ (macro-byte-port-rhi _in231053_)))
                    (if (let ()
                          (declare (not safe))
                          (##fx< _rlo231066_ _rhi231067_))
                        (let ((_rbuf231069_ (macro-byte-port-rbuf _in231053_)))
                          (with-exception-catcher
                           (lambda (_g231070231072_)
                             (if '#t
                                 (let ((_e231075_ _g231070231072_))
                                   (if (eq? _in231053_ _out231054_)
                                       '#!void
                                       (macro-port-mutex-unlock! _in231053_))
                                   (raise _e231075_))
                                 (raise _g231070231072_)))
                           (lambda ()
                             (if (eq? _in231053_ _out231054_)
                                 (macro-port-mutex-unlock! _in231053_)
                                 '#!void)
                             (write-subu8vector
                              _rbuf231069_
                              _rlo231066_
                              _rhi231067_
                              _out231054_)
                             (if (eq? _in231053_ _out231054_)
                                 (macro-port-mutex-lock! _in231053_)
                                 '#!void)))
                          (macro-byte-port-rlo-set! _in231053_ _rhi231067_)
                          (_rbuf-fill231057_))
                        (_rbuf-fill231057_)))))
               (_rbuf-fill231057_
                (lambda ()
                  (let* ((_rbuf231060_ (macro-byte-port-rbuf _in231053_))
                         (_res231062_
                          ((macro-byte-port-rbuf-fill _in231053_)
                           _in231053_
                           (let ()
                             (declare (not safe))
                             (##u8vector-length _rbuf231060_))
                           '#t)))
                    (if (eq? _res231062_ ##err-code-EAGAIN)
                        (macro-port-mutex-unlock! _in231053_)
                        (if (fixnum? _res231062_)
                            (begin
                              (macro-port-mutex-unlock! _in231053_)
                              (let ()
                                (declare (not safe))
                                (##raise-os-io-exception
                                 _in231053_
                                 '#f
                                 _res231062_
                                 std/misc/ports#copy-port
                                 _in231053_
                                 _out231054_)))
                            (if _res231062_
                                (_loop231056_)
                                (macro-port-mutex-unlock! _in231053_))))))))
        (_loop231056_))))
  (define std/misc/ports#copy-character-port/lock
    (lambda (_in231028_ _out231029_)
      (letrec ((_loop231031_
                (lambda ()
                  (let ((_rlo231041_ (macro-character-port-rlo _in231028_))
                        (_rhi231042_ (macro-character-port-rhi _in231028_)))
                    (if (let ()
                          (declare (not safe))
                          (##fx< _rlo231041_ _rhi231042_))
                        (let ((_rbuf231044_
                               (macro-character-port-rbuf _in231028_)))
                          (with-exception-catcher
                           (lambda (_g231045231047_)
                             (if '#t
                                 (let ((_e231050_ _g231045231047_))
                                   (if (eq? _in231028_ _out231029_)
                                       '#!void
                                       (macro-port-mutex-unlock! _in231028_))
                                   (raise _e231050_))
                                 (raise _g231045231047_)))
                           (lambda ()
                             (if (eq? _in231028_ _out231029_)
                                 (macro-port-mutex-unlock! _in231028_)
                                 '#!void)
                             (write-substring
                              _rbuf231044_
                              _rlo231041_
                              _rhi231042_
                              _out231029_)
                             (if (eq? _in231028_ _out231029_)
                                 (macro-port-mutex-lock! _in231028_)
                                 '#!void)))
                          (macro-character-port-rlo-set!
                           _in231028_
                           _rhi231042_)
                          (_rbuf-fill231032_))
                        (if (macro-character-port-peek-eof? _in231028_)
                            (begin
                              (macro-character-port-peek-eof?-set!
                               _in231028_
                               '#f)
                              (macro-port-mutex-unlock! _in231028_))
                            (_rbuf-fill231032_))))))
               (_rbuf-fill231032_
                (lambda ()
                  (let* ((_rbuf231035_ (macro-character-port-rbuf _in231028_))
                         (_res231037_
                          ((macro-character-port-rbuf-fill _in231028_)
                           _in231028_
                           (let ()
                             (declare (not safe))
                             (##string-length _rbuf231035_))
                           '#t)))
                    (if (eq? _res231037_ ##err-code-EAGAIN)
                        (macro-port-mutex-unlock! _in231028_)
                        (if (fixnum? _res231037_)
                            (begin
                              (macro-port-mutex-unlock! _in231028_)
                              (let ()
                                (declare (not safe))
                                (##raise-os-io-exception
                                 _in231028_
                                 '#f
                                 _res231037_
                                 std/misc/ports#copy-port
                                 _in231028_
                                 _out231029_)))
                            (if _res231037_
                                (_loop231031_)
                                (macro-port-mutex-unlock! _in231028_))))))))
        (_loop231031_))))
  (define std/misc/ports#copy-object-port
    (lambda (_in231021_ _out231022_)
      (let _lp231024_ ((_next231026_ (read _in231021_)))
        (if (eof-object? _next231026_)
            '#!void
            (begin
              (write _next231026_ _out231022_)
              (_lp231024_ (read _in231021_)))))))
  (define std/misc/ports#read-all-as-string
    (lambda (_port231017_)
      (let ((_string231019_ (read-line _port231017_ '#f)))
        (if (string? _string231019_) _string231019_ '""))))
  (define std/misc/ports#read-file-string__%
    (lambda (_g303083_ _settings230994230997_ _file230999_)
      (let ((_settings231001_
             (if (eq? _settings230994230997_ absent-value)
                 '()
                 _settings230994230997_)))
        (call-with-input-file
         (cons 'path: (cons _file230999_ _settings231001_))
         std/misc/ports#read-all-as-string))))
  (define std/misc/ports#read-file-string__@
    (lambda (_keys230993231006_ . _args231008_)
      (apply std/misc/ports#read-file-string__%
             _keys230993231006_
             (table-ref _keys230993231006_ 'settings: absent-value)
             _args231008_)))
  (define std/misc/ports#read-file-string
    (lambda _args230995231014_
      (apply keyword-dispatch
             '#(settings:)
             std/misc/ports#read-file-string__@
             _args230995231014_)))
  (define std/misc/ports#read-all-as-lines__%
    (lambda (_g303084_
             _separator230788230792_
             _include-separator?230789230794_
             _port230796_)
      (let* ((_separator230798_
              (if (eq? _separator230788230792_ absent-value)
                  '#\newline
                  _separator230788230792_))
             (_include-separator?230800_
              (if (eq? _include-separator?230789230794_ absent-value)
                  '#f
                  _include-separator?230789230794_))
             (_head230802_ (cons '#f '()))
             (_tail230805_ _head230802_))
        (let _loop230970_ ()
          (let ((_line230973_
                 (read-line
                  _port230796_
                  _separator230798_
                  _include-separator?230800_)))
            (if (string? _line230973_)
                (begin
                  (let ((_new-tail230975_ (cons _line230973_ '())))
                    (let ()
                      (declare (not safe))
                      (##set-cdr! _tail230805_ _new-tail230975_))
                    (set! _tail230805_ _new-tail230975_))
                  (_loop230970_))
                '#!void)))
        (let () (declare (not safe)) (##cdr _head230802_)))))
  (define std/misc/ports#read-all-as-lines__@
    (lambda (_keys230787230981_ . _args230983_)
      (apply std/misc/ports#read-all-as-lines__%
             _keys230787230981_
             (table-ref _keys230787230981_ 'separator: absent-value)
             (table-ref _keys230787230981_ 'include-separator?: absent-value)
             _args230983_)))
  (define std/misc/ports#read-all-as-lines
    (lambda _args230790230989_
      (apply keyword-dispatch
             '#(separator: #f include-separator?: #f)
             std/misc/ports#read-all-as-lines__@
             _args230790230989_)))
  (define std/misc/ports#read-file-lines__%
    (lambda (_g303085_ _settings230763230766_ _file230768_)
      (let ((_settings230770_
             (if (eq? _settings230763230766_ absent-value)
                 '()
                 _settings230763230766_)))
        (call-with-input-file
         (cons 'path: (cons _file230768_ _settings230770_))
         std/misc/ports#read-all-as-lines))))
  (define std/misc/ports#read-file-lines__@
    (lambda (_keys230762230775_ . _args230777_)
      (apply std/misc/ports#read-file-lines__%
             _keys230762230775_
             (table-ref _keys230762230775_ 'settings: absent-value)
             _args230777_)))
  (define std/misc/ports#read-file-lines
    (lambda _args230764230783_
      (apply keyword-dispatch
             '#(settings:)
             std/misc/ports#read-file-lines__@
             _args230764230783_)))
  (define std/misc/ports#read-all-as-u8vector__%
    (lambda (_port230741_ _bufsize230742_)
      (let _lp230744_ ((_buf230746_ (make-u8vector _bufsize230742_))
                       (_u8s230747_ '()))
        (let ((_len230749_
               (read-subu8vector _buf230746_ '0 _bufsize230742_ _port230741_)))
          (if (= _len230749_ _bufsize230742_)
              (_lp230744_
               (make-u8vector _bufsize230742_)
               (cons _buf230746_ _u8s230747_))
              (begin
                (u8vector-shrink! _buf230746_ _len230749_)
                (u8vector-concatenate
                 (reverse (cons _buf230746_ _u8s230747_)))))))))
  (define std/misc/ports#read-all-as-u8vector__0
    (lambda (_port230754_)
      (let ((_bufsize230756_ '8192))
        (std/misc/ports#read-all-as-u8vector__%
         _port230754_
         _bufsize230756_))))
  (define std/misc/ports#read-all-as-u8vector
    (lambda _g303087_
      (let ((_g303086_ (let () (declare (not safe)) (##length _g303087_))))
        (cond ((let () (declare (not safe)) (##fx= _g303086_ 1))
               (apply std/misc/ports#read-all-as-u8vector__0 _g303087_))
              ((let () (declare (not safe)) (##fx= _g303086_ 2))
               (apply std/misc/ports#read-all-as-u8vector__% _g303087_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/ports#read-all-as-u8vector
                _g303087_))))))
  (define std/misc/ports#read-file-u8vector__%
    (lambda (_g303088_
             _settings230708230712_
             _bufsize230709230714_
             _file230716_)
      (let* ((_settings230718_
              (if (eq? _settings230708230712_ absent-value)
                  '()
                  _settings230708230712_))
             (_bufsize230720_
              (if (eq? _bufsize230709230714_ absent-value)
                  '8192
                  _bufsize230709230714_)))
        (call-with-input-file
         (cons 'path: (cons _file230716_ _settings230718_))
         (lambda (_g230721230723_)
           (std/misc/ports#read-all-as-u8vector__%
            _g230721230723_
            _bufsize230720_))))))
  (define std/misc/ports#read-file-u8vector__@
    (lambda (_keys230707230729_ . _args230731_)
      (apply std/misc/ports#read-file-u8vector__%
             _keys230707230729_
             (table-ref _keys230707230729_ 'settings: absent-value)
             (table-ref _keys230707230729_ 'bufsize: absent-value)
             _args230731_)))
  (define std/misc/ports#read-file-u8vector
    (lambda _args230710230737_
      (apply keyword-dispatch
             '#(settings: bufsize:)
             std/misc/ports#read-file-u8vector__@
             _args230710230737_)))
  (define std/misc/ports#write-file-string__%
    (lambda (_g303089_
             _settings230675230679_
             _newline-ending230676230681_
             _file230683_
             _string230684_)
      (let* ((_settings230686_
              (if (eq? _settings230675230679_ absent-value)
                  '()
                  _settings230675230679_))
             (_newline-ending230688_
              (if (eq? _newline-ending230676230681_ absent-value)
                  '#t
                  _newline-ending230676230681_)))
        (call-with-output-file
         (cons 'path: (cons _file230683_ _settings230686_))
         (lambda (_port230690_)
           (display _string230684_ _port230690_)
           (if (and _newline-ending230688_
                    (not (string-empty? _string230684_))
                    (not (std/srfi/13#string-suffix?__0 '"\n" _string230684_)))
               (newline _port230690_)
               '#!void))))))
  (define std/misc/ports#write-file-string__@
    (lambda (_keys230674230695_ . _args230697_)
      (apply std/misc/ports#write-file-string__%
             _keys230674230695_
             (table-ref _keys230674230695_ 'settings: absent-value)
             (table-ref _keys230674230695_ 'newline-ending: absent-value)
             _args230697_)))
  (define std/misc/ports#write-file-string
    (lambda _args230677230703_
      (apply keyword-dispatch
             '#(settings: newline-ending:)
             std/misc/ports#write-file-string__@
             _args230677230703_)))
  (define std/misc/ports#write-file-lines__%
    (lambda (_g303090_
             _settings230642230646_
             _newline-ending230643230648_
             _file230650_
             _list230651_)
      (let* ((_settings230653_
              (if (eq? _settings230642230646_ absent-value)
                  '()
                  _settings230642230646_))
             (_newline-ending230655_
              (if (eq? _newline-ending230643230648_ absent-value)
                  '#t
                  _newline-ending230643230648_)))
        (letrec* ((_string230657_ (string-join _list230651_ '"\n")))
          (std/misc/ports#write-file-string__%
           '#f
           _settings230653_
           _newline-ending230655_
           _file230650_
           _string230657_)))))
  (define std/misc/ports#write-file-lines__@
    (lambda (_keys230641230662_ . _args230664_)
      (apply std/misc/ports#write-file-lines__%
             _keys230641230662_
             (table-ref _keys230641230662_ 'settings: absent-value)
             (table-ref _keys230641230662_ 'newline-ending: absent-value)
             _args230664_)))
  (define std/misc/ports#write-file-lines
    (lambda _args230644230670_
      (apply keyword-dispatch
             '#(settings: newline-ending:)
             std/misc/ports#write-file-lines__@
             _args230644230670_))))
