(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/httpd/handler#errorf
    (lambda (_fmt206483_ . _args206484_)
      (std/logger#log-message 'httpd '0 _fmt206483_ _args206484_)))
  (define std/net/httpd/handler#warnf
    (lambda (_fmt206480_ . _args206481_)
      (std/logger#log-message 'httpd '1 _fmt206480_ _args206481_)))
  (define std/net/httpd/handler#infof
    (lambda (_fmt206477_ . _args206478_)
      (std/logger#log-message 'httpd '2 _fmt206477_ _args206478_)))
  (define std/net/httpd/handler#debugf
    (lambda (_fmt206474_ . _args206475_)
      (std/logger#log-message 'httpd '3 _fmt206474_ _args206475_)))
  (define std/net/httpd/handler#verbosef
    (lambda (_fmt206469_ . _args206471_)
      (std/logger#log-message 'httpd '4 _fmt206469_ _args206471_)))
  (define std/net/httpd/handler#http-request::t
    (make-struct-type
     'std/net/httpd/handler#http-request::t
     '#f
     '9
     'http-request
     '((final: . #t))
     '#f
     '(buf client method url path params proto headers data)))
  (define std/net/httpd/handler#http-request?
    (make-struct-predicate std/net/httpd/handler#http-request::t))
  (define std/net/httpd/handler#make-http-request
    (lambda _$args206466_
      (apply make-struct-instance
             std/net/httpd/handler#http-request::t
             _$args206466_)))
  (define std/net/httpd/handler#http-request-buf
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '0))
  (define std/net/httpd/handler#http-request-client
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '1))
  (define std/net/httpd/handler#http-request-method
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '2))
  (define std/net/httpd/handler#http-request-url
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '3))
  (define std/net/httpd/handler#http-request-path
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '4))
  (define std/net/httpd/handler#http-request-params
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '5))
  (define std/net/httpd/handler#http-request-proto
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '6))
  (define std/net/httpd/handler#http-request-headers
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '7))
  (define std/net/httpd/handler#http-request-data
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '8))
  (define std/net/httpd/handler#http-request-buf-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '0))
  (define std/net/httpd/handler#http-request-client-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '1))
  (define std/net/httpd/handler#http-request-method-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '2))
  (define std/net/httpd/handler#http-request-url-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '3))
  (define std/net/httpd/handler#http-request-path-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '4))
  (define std/net/httpd/handler#http-request-params-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '5))
  (define std/net/httpd/handler#http-request-proto-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '6))
  (define std/net/httpd/handler#http-request-headers-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '7))
  (define std/net/httpd/handler#http-request-data-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '8))
  (define std/net/httpd/handler#&http-request-buf
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '0))
  (define std/net/httpd/handler#&http-request-client
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '1))
  (define std/net/httpd/handler#&http-request-method
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '2))
  (define std/net/httpd/handler#&http-request-url
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '3))
  (define std/net/httpd/handler#&http-request-path
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '4))
  (define std/net/httpd/handler#&http-request-params
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '5))
  (define std/net/httpd/handler#&http-request-proto
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '6))
  (define std/net/httpd/handler#&http-request-headers
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '7))
  (define std/net/httpd/handler#&http-request-data
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '8))
  (define std/net/httpd/handler#&http-request-buf-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '0))
  (define std/net/httpd/handler#&http-request-client-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '1))
  (define std/net/httpd/handler#&http-request-method-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '2))
  (define std/net/httpd/handler#&http-request-url-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '3))
  (define std/net/httpd/handler#&http-request-path-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '4))
  (define std/net/httpd/handler#&http-request-params-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '5))
  (define std/net/httpd/handler#&http-request-proto-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '6))
  (define std/net/httpd/handler#&http-request-headers-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '7))
  (define std/net/httpd/handler#&http-request-data-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '8))
  (define std/net/httpd/handler#http-response::t
    (make-struct-type
     'std/net/httpd/handler#http-response::t
     '#f
     '3
     'http-response
     '((final: . #t))
     '#f
     '(buf output close?)))
  (define std/net/httpd/handler#http-response?
    (make-struct-predicate std/net/httpd/handler#http-response::t))
  (define std/net/httpd/handler#make-http-response
    (lambda _$args206463_
      (apply make-struct-instance
             std/net/httpd/handler#http-response::t
             _$args206463_)))
  (define std/net/httpd/handler#http-response-buf
    (make-struct-field-accessor std/net/httpd/handler#http-response::t '0))
  (define std/net/httpd/handler#http-response-output
    (make-struct-field-accessor std/net/httpd/handler#http-response::t '1))
  (define std/net/httpd/handler#http-response-close?
    (make-struct-field-accessor std/net/httpd/handler#http-response::t '2))
  (define std/net/httpd/handler#http-response-buf-set!
    (make-struct-field-mutator std/net/httpd/handler#http-response::t '0))
  (define std/net/httpd/handler#http-response-output-set!
    (make-struct-field-mutator std/net/httpd/handler#http-response::t '1))
  (define std/net/httpd/handler#http-response-close?-set!
    (make-struct-field-mutator std/net/httpd/handler#http-response::t '2))
  (define std/net/httpd/handler#&http-response-buf
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-response::t
     '0))
  (define std/net/httpd/handler#&http-response-output
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-response::t
     '1))
  (define std/net/httpd/handler#&http-response-close?
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-response::t
     '2))
  (define std/net/httpd/handler#&http-response-buf-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-response::t
     '0))
  (define std/net/httpd/handler#&http-response-output-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-response::t
     '1))
  (define std/net/httpd/handler#&http-response-close?-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-response::t
     '2))
  (define std/net/httpd/handler#http-request-handler
    (lambda (_get-handler206394_ _sock206395_ _addr206396_)
      (letrec* ((_ibuf206398_
                 (std/net/httpd/handler#get-input-buffer _sock206395_))
                (_obuf206399_
                 (std/net/httpd/handler#get-output-buffer _sock206395_))
                (_loop206400_
                 (lambda ()
                   (let ((_req206412_
                          (##structure
                           std/net/httpd/handler#http-request::t
                           _ibuf206398_
                           _addr206396_
                           '#f
                           '#f
                           '#f
                           '#f
                           '#f
                           '#f
                           '#!void))
                         (_res206413_
                          (##structure
                           std/net/httpd/handler#http-response::t
                           _obuf206399_
                           '#f
                           '#f)))
                     (std/net/socket/buffer#ssocket-input-buffer-timeout-set!
                      _ibuf206398_
                      std/net/httpd/handler#request-timeout)
                     (std/net/socket/buffer#ssocket-output-buffer-timeout-set!
                      _obuf206399_
                      std/net/httpd/handler#response-timeout)
                     (with-exception-catcher
                      (lambda (_g206414206416_)
                        (if ((lambda (_$obj206419_)
                               (##structure-instance-of?
                                _$obj206419_
                                'std/error#timeout-error::t))
                             _g206414206416_)
                            (let ((_e206422_ _g206414206416_))
                              (std/net/httpd/handler#errorf
                               '"request error: ~a"
                               _e206422_)
                              (##unchecked-structure-set!
                               _res206413_
                               '#t
                               '3
                               std/net/httpd/handler#http-response::t
                               '#f)
                              (std/net/httpd/handler#http-response-write
                               _res206413_
                               '408
                               '()
                               '#f)
                              (raise 'abort))
                            (if ((lambda (_$obj206424_)
                                   (##structure-instance-of?
                                    _$obj206424_
                                    'std/error#io-error::t))
                                 _g206414206416_)
                                (let ((_e206427_ _g206414206416_))
                                  (std/net/httpd/handler#errorf
                                   '"request error: ~a"
                                   _e206427_)
                                  (##unchecked-structure-set!
                                   _res206413_
                                   '#t
                                   '3
                                   std/net/httpd/handler#http-response::t
                                   '#f)
                                  (std/net/httpd/handler#http-response-write
                                   _res206413_
                                   '400
                                   '()
                                   '#f)
                                  (raise 'abort))
                                (raise _g206414206416_))))
                      (lambda ()
                        (std/net/httpd/handler#read-request! _req206412_)))
                     (let* ((_method206430_
                             (##unchecked-structure-ref
                              _req206412_
                              '3
                              std/net/httpd/handler#http-request::t
                              '#f))
                            (_path206432_
                             (##unchecked-structure-ref
                              _req206412_
                              '5
                              std/net/httpd/handler#http-request::t
                              '#f))
                            (_proto206434_
                             (##unchecked-structure-ref
                              _req206412_
                              '7
                              std/net/httpd/handler#http-request::t
                              '#f))
                            (_headers206436_
                             (##unchecked-structure-ref
                              _req206412_
                              '8
                              std/net/httpd/handler#http-request::t
                              '#f))
                            (_host206438_
                             (std/net/httpd/handler#header-e
                              '"Host"
                              _headers206436_))
                            (_close?206443_
                             (let ((_$e206440_ _proto206434_))
                               (if (equal? '"HTTP/1.1" _$e206440_)
                                   (equal? (std/net/httpd/handler#header-e
                                            '"Connection"
                                            _headers206436_)
                                           '"close")
                                   (if (equal? '"HTTP/1.0" _$e206440_)
                                       (not (equal? (std/net/httpd/handler#header-e
                                                     '"Connection"
                                                     _headers206436_)
                                                    '"Keep-Alive"))
                                       '#t)))))
                       (if _close?206443_
                           (##unchecked-structure-set!
                            _res206413_
                            '#t
                            '3
                            std/net/httpd/handler#http-response::t
                            '#f)
                           '#!void)
                       (if (not (member _proto206434_
                                        '("HTTP/1.1" "HTTP/1.0")))
                           (std/net/httpd/handler#http-response-write
                            _res206413_
                            '505
                            '()
                            '#f)
                           (if (not (symbol? _method206430_))
                               (std/net/httpd/handler#http-response-write
                                _res206413_
                                '501
                                '()
                                '#f)
                               (if (and (eq? _method206430_ 'OPTIONS)
                                        (equal? _path206432_ '"*"))
                                   (std/net/httpd/handler#http-response-write
                                    _res206413_
                                    '200
                                    '()
                                    '#f)
                                   (if (eq? _method206430_ 'TRACE)
                                       (std/net/httpd/handler#http-response-trace
                                        _res206413_
                                        _req206412_)
                                       (let ((_$e206446_
                                              (_get-handler206394_
                                               _host206438_
                                               _path206432_)))
                                         (if _$e206446_
                                             ((lambda (_handler206449_)
                                                (if (procedure?
                                                     _handler206449_)
                                                    (with-exception-catcher
                                                     (lambda (_g206450206452_)
                                                       (if ((lambda (_$obj206455_)
                                                              (##structure-instance-of?
                                                               _$obj206455_
                                                               'std/error#io-error::t))
                                                            _g206450206452_)
                                                           (let ((_e206458_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _g206450206452_))
                     (std/net/httpd/handler#errorf
                      '"request i/o error: ~a"
                      _e206458_)
                     (if (##unchecked-structure-ref
                          _res206413_
                          '2
                          std/net/httpd/handler#http-response::t
                          '#f)
                         '#!void
                         (begin
                           (##unchecked-structure-set!
                            _res206413_
                            '#t
                            '3
                            std/net/httpd/handler#http-response::t
                            '#f)
                           (std/net/httpd/handler#http-response-write
                            _res206413_
                            '500
                            '()
                            '#f)))
                     (raise 'abort))
                   (if '#t
                       (let ((_e206460_ _g206450206452_))
                         (std/net/httpd/handler#errorf
                          '"request handler error: ~a"
                          _e206460_)
                         (if (##unchecked-structure-ref
                              _res206413_
                              '2
                              std/net/httpd/handler#http-response::t
                              '#f)
                             (raise 'abort)
                             (std/net/httpd/handler#http-response-write
                              _res206413_
                              '500
                              '()
                              '#f)))
                       (raise _g206450206452_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (lambda ()
                                                       (_handler206449_
                                                        _req206412_
                                                        _res206413_)))
                                                    (begin
                                                      (std/net/httpd/handler#warnf
                                                       '"request handler is not a procedure: ~a ~a ~a"
                                                       _host206438_
                                                       _path206432_
                                                       _handler206449_)
                                                      (std/net/httpd/handler#http-response-write
                                                       _res206413_
                                                       '500
                                                       '()
                                                       '#f))))
                                              _$e206446_)
                                             (std/net/httpd/handler#http-response-write
                                              _res206413_
                                              '404
                                              '()
                                              '#f)))))))
                       (if _close?206443_
                           '#!void
                           (begin
                             (std/net/httpd/handler#http-request-skip-body
                              _req206412_)
                             (_loop206400_))))))))
        (with-unwind-protect
         (lambda ()
           (with-exception-catcher
            (lambda (_g206401206404_)
              (if '#t
                  (let ((_e206407_ _g206401206404_))
                    (if (memq _e206407_ '(abort eof))
                        '#!void
                        (begin
                          (std/net/httpd/handler#errorf
                           '"unhandled exception: ~a"
                           _e206407_)
                          (raise _e206407_)))
                    _e206407_)
                  (raise _g206401206404_)))
            (lambda () (_loop206400_))))
         (lambda ()
           (std/net/socket/api#ssocket-close _sock206395_)
           (std/net/httpd/handler#put-input-buffer! _ibuf206398_)
           (std/net/httpd/handler#put-output-buffer! _obuf206399_))))))
  (define std/net/httpd/handler#http-request-body
    (lambda (_req206321_)
      (let* ((_req206322206336_ _req206321_)
             (_E206324206340_
              (lambda () (error '"No clause matching" _req206322206336_)))
             (_K206325206356_
              (lambda (_data206343_
                       _headers206344_
                       _method206345_
                       _ibuf206346_)
                (if (eq? _data206343_ '#!void)
                    (let ((_$e206348_ _method206345_))
                      (if (or (eq? 'POST _$e206348_) (eq? 'PUT _$e206348_))
                          (let ((_data206354_
                                 (std/net/httpd/handler#read-request-body
                                  _ibuf206346_
                                  _headers206344_)))
                            (##unchecked-structure-set!
                             _req206321_
                             _data206354_
                             '9
                             std/net/httpd/handler#http-request::t
                             '#f)
                            _data206354_)
                          (begin
                            (std/net/httpd/handler#http-request-skip-body
                             _req206321_)
                            '#f)))
                    _data206343_))))
        (if (##structure-direct-instance-of?
             _req206322206336_
             'std/net/httpd/handler#http-request::t)
            (let* ((_e206326206359_ (##vector-ref _req206322206336_ '1))
                   (_ibuf206362_ _e206326206359_)
                   (_e206327206364_ (##vector-ref _req206322206336_ '2))
                   (_e206328206367_ (##vector-ref _req206322206336_ '3))
                   (_method206370_ _e206328206367_)
                   (_e206329206372_ (##vector-ref _req206322206336_ '4))
                   (_e206330206375_ (##vector-ref _req206322206336_ '5))
                   (_e206331206378_ (##vector-ref _req206322206336_ '6))
                   (_e206332206381_ (##vector-ref _req206322206336_ '7))
                   (_e206333206384_ (##vector-ref _req206322206336_ '8))
                   (_headers206387_ _e206333206384_)
                   (_e206334206389_ (##vector-ref _req206322206336_ '9))
                   (_data206392_ _e206334206389_))
              (_K206325206356_
               _data206392_
               _headers206387_
               _method206370_
               _ibuf206362_))
            (_E206324206340_)))))
  (define std/net/httpd/handler#http-request-timeout-set!
    (lambda (_req206296_ _timeo206297_)
      (let* ((_req206298206304_ _req206296_)
             (_E206300206308_
              (lambda () (error '"No clause matching" _req206298206304_)))
             (_K206301206313_
              (lambda (_ibuf206311_)
                (std/net/socket/buffer#ssocket-input-buffer-timeout-set!
                 _ibuf206311_
                 _timeo206297_))))
        (if (##structure-direct-instance-of?
             _req206298206304_
             'std/net/httpd/handler#http-request::t)
            (let* ((_e206302206316_ (##vector-ref _req206298206304_ '1))
                   (_ibuf206319_ _e206302206316_))
              (_K206301206313_ _ibuf206319_))
            (_E206300206308_)))))
  (define std/net/httpd/handler#http-response-write
    (lambda (_res206246_ _status206247_ _headers206248_ _body206249_)
      (let* ((_res206250206258_ _res206246_)
             (_E206252206262_
              (lambda () (error '"No clause matching" _res206250206258_)))
             (_K206253206278_
              (lambda (_close?206265_ _output206266_ _obuf206267_)
                (if _output206266_
                    (error '"duplicate response" _res206246_)
                    '#!void)
                (##unchecked-structure-set!
                 _res206246_
                 'END
                 '2
                 std/net/httpd/handler#http-response::t
                 '#f)
                (let* ((_len206269_
                        (if (u8vector? _body206249_)
                            (u8vector-length _body206249_)
                            (if (string? _body206249_)
                                (std/text/utf8#string-utf8-length__0
                                 _body206249_)
                                (if (not _body206249_)
                                    '0
                                    (error '"Bad response body; expected string, u8vector, or #f"
                                           _body206249_)))))
                       (_headers206271_
                        (cons (cons '"Content-Length"
                                    (number->string _len206269_))
                              _headers206248_))
                       (_headers206273_
                        (if _close?206265_
                            (cons '("Connection" . "close") _headers206271_)
                            _headers206271_))
                       (_headers206275_
                        (cons (cons '"Date" (std/net/httpd/handler#http-date))
                              _headers206273_)))
                  (std/net/httpd/handler#write-response-line
                   _obuf206267_
                   _status206247_)
                  (std/net/httpd/handler#write-response-headers
                   _obuf206267_
                   _headers206275_)
                  (std/net/httpd/handler#write-crlf _obuf206267_)
                  (if (u8vector? _body206249_)
                      (std/net/bio/output#bio-write-bytes
                       _body206249_
                       _obuf206267_)
                      (if (string? _body206249_)
                          (std/net/bio/output#bio-write-string
                           _body206249_
                           _obuf206267_)
                          '#!void))
                  (std/net/bio/output#bio-force-output _obuf206267_)))))
        (if (##structure-direct-instance-of?
             _res206250206258_
             'std/net/httpd/handler#http-response::t)
            (let* ((_e206254206281_ (##vector-ref _res206250206258_ '1))
                   (_obuf206284_ _e206254206281_)
                   (_e206255206286_ (##vector-ref _res206250206258_ '2))
                   (_output206289_ _e206255206286_)
                   (_e206256206291_ (##vector-ref _res206250206258_ '3))
                   (_close?206294_ _e206256206291_))
              (_K206253206278_ _close?206294_ _output206289_ _obuf206284_))
            (_E206252206262_)))))
  (define std/net/httpd/handler#http-response-begin
    (lambda (_res206199_ _status206200_ _headers206201_)
      (let* ((_res206202206210_ _res206199_)
             (_E206204206214_
              (lambda () (error '"No clause matching" _res206202206210_)))
             (_K206205206228_
              (lambda (_close?206217_ _output206218_ _obuf206219_)
                (if _output206218_
                    (error '"duplicate response" _res206199_)
                    '#!void)
                (##unchecked-structure-set!
                 _res206199_
                 'CHUNK
                 '2
                 std/net/httpd/handler#http-response::t
                 '#f)
                (let* ((_headers206221_
                        (cons '("Transfer-Encoding" . "chunked")
                              _headers206201_))
                       (_headers206223_
                        (if _close?206217_
                            (cons '("Connection" . "close") _headers206221_)
                            _headers206221_))
                       (_headers206225_
                        (cons (cons '"Date" (std/net/httpd/handler#http-date))
                              _headers206223_)))
                  (std/net/httpd/handler#write-response-line
                   _obuf206219_
                   _status206200_)
                  (std/net/httpd/handler#write-response-headers
                   _obuf206219_
                   _headers206225_)
                  (std/net/httpd/handler#write-crlf _obuf206219_)))))
        (if (##structure-direct-instance-of?
             _res206202206210_
             'std/net/httpd/handler#http-response::t)
            (let* ((_e206206206231_ (##vector-ref _res206202206210_ '1))
                   (_obuf206234_ _e206206206231_)
                   (_e206207206236_ (##vector-ref _res206202206210_ '2))
                   (_output206239_ _e206207206236_)
                   (_e206208206241_ (##vector-ref _res206202206210_ '3))
                   (_close?206244_ _e206208206241_))
              (_K206205206228_ _close?206244_ _output206239_ _obuf206234_))
            (_E206204206214_)))))
  (define std/net/httpd/handler#http-response-chunk__%
    (lambda (_res206144_ _chunk206145_ _start206146_ _end206147_)
      (let* ((_res206148206155_ _res206144_)
             (_E206150206159_
              (lambda () (error '"No clause matching" _res206148206155_)))
             (_K206151206165_
              (lambda (_output206162_ _obuf206163_)
                (if (eq? _output206162_ 'CHUNK)
                    '#!void
                    (error '"illegal response; not writing chunks"
                           _res206144_
                           _output206162_))
                (std/net/httpd/handler#write-chunk
                 _obuf206163_
                 _chunk206145_
                 _start206146_
                 _end206147_))))
        (if (##structure-direct-instance-of?
             _res206148206155_
             'std/net/httpd/handler#http-response::t)
            (let* ((_e206152206168_ (##vector-ref _res206148206155_ '1))
                   (_obuf206171_ _e206152206168_)
                   (_e206153206173_ (##vector-ref _res206148206155_ '2))
                   (_output206176_ _e206153206173_))
              (_K206151206165_ _output206176_ _obuf206171_))
            (_E206150206159_)))))
  (define std/net/httpd/handler#http-response-chunk__0
    (lambda (_res206181_ _chunk206182_)
      (let* ((_start206184_ '0) (_end206186_ '#f))
        (std/net/httpd/handler#http-response-chunk__%
         _res206181_
         _chunk206182_
         _start206184_
         _end206186_))))
  (define std/net/httpd/handler#http-response-chunk__1
    (lambda (_res206188_ _chunk206189_ _start206190_)
      (let ((_end206192_ '#f))
        (std/net/httpd/handler#http-response-chunk__%
         _res206188_
         _chunk206189_
         _start206190_
         _end206192_))))
  (define std/net/httpd/handler#http-response-chunk
    (lambda _g309564_
      (let ((_g309563_ (##length _g309564_)))
        (cond ((##fx= _g309563_ 2)
               (apply std/net/httpd/handler#http-response-chunk__0 _g309564_))
              ((##fx= _g309563_ 3)
               (apply std/net/httpd/handler#http-response-chunk__1 _g309564_))
              ((##fx= _g309563_ 4)
               (apply std/net/httpd/handler#http-response-chunk__% _g309564_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/httpd/handler#http-response-chunk
                _g309564_))))))
  (define std/net/httpd/handler#http-response-end
    (lambda (_res206112_)
      (let* ((_res206113206120_ _res206112_)
             (_E206115206124_
              (lambda () (error '"No clause matching" _res206113206120_)))
             (_K206116206130_
              (lambda (_output206127_ _obuf206128_)
                (if (eq? _output206127_ 'CHUNK)
                    '#!void
                    (error '"illegal response; not writing chunks"
                           _res206112_
                           _output206127_))
                (##unchecked-structure-set!
                 _res206112_
                 'END
                 '2
                 std/net/httpd/handler#http-response::t
                 '#f)
                (std/net/httpd/handler#write-last-chunk _obuf206128_)
                (std/net/bio/output#bio-force-output _obuf206128_))))
        (if (##structure-direct-instance-of?
             _res206113206120_
             'std/net/httpd/handler#http-response::t)
            (let* ((_e206117206133_ (##vector-ref _res206113206120_ '1))
                   (_obuf206136_ _e206117206133_)
                   (_e206118206138_ (##vector-ref _res206113206120_ '2))
                   (_output206141_ _e206118206138_))
              (_K206116206130_ _output206141_ _obuf206136_))
            (_E206115206124_)))))
  (define std/net/httpd/handler#http-response-force-output
    (lambda (_res206110_)
      (std/net/bio/output#bio-force-output
       (##direct-structure-ref
        _res206110_
        '1
        std/net/httpd/handler#http-response::t
        '#f))))
  (define std/net/httpd/handler#http-response-timeout-set!
    (lambda (_res206085_ _timeo206086_)
      (let* ((_res206087206093_ _res206085_)
             (_E206089206097_
              (lambda () (error '"No clause matching" _res206087206093_)))
             (_K206090206102_
              (lambda (_obuf206100_)
                (std/net/socket/buffer#ssocket-output-buffer-timeout-set!
                 _obuf206100_
                 _timeo206086_))))
        (if (##structure-direct-instance-of?
             _res206087206093_
             'std/net/httpd/handler#http-response::t)
            (let* ((_e206091206105_ (##vector-ref _res206087206093_ '1))
                   (_obuf206108_ _e206091206105_))
              (_K206090206102_ _obuf206108_))
            (_E206089206097_)))))
  (define std/net/httpd/handler#header-e
    (lambda (_key206045_ _lst206046_)
      (let _lp206048_ ((_rest206050_ _lst206046_))
        (let* ((_rest206051206059_ _rest206050_)
               (_else206053206067_ (lambda () '#f))
               (_K206055206073_
                (lambda (_rest206070_ _hd206071_)
                  (if (##string-equal? _key206045_ (car _hd206071_))
                      (cdr _hd206071_)
                      (_lp206048_ _rest206070_)))))
          (if (##pair? _rest206051206059_)
              (let ((_hd206056206076_ (##car _rest206051206059_))
                    (_tl206057206078_ (##cdr _rest206051206059_)))
                (let* ((_hd206081_ _hd206056206076_)
                       (_rest206083_ _tl206057206078_))
                  (_K206055206073_ _rest206083_ _hd206081_)))
              (_else206053206067_))))))
  (define std/net/httpd/handler#http-request-skip-body
    (lambda (_req206043_)
      (if (eq? (##unchecked-structure-ref
                _req206043_
                '9
                std/net/httpd/handler#http-request::t
                '#f)
               '#!void)
          (begin
            (##unchecked-structure-set!
             _req206043_
             '#f
             '9
             std/net/httpd/handler#http-request::t
             '#f)
            (std/net/httpd/handler#skip-request-body
             (##unchecked-structure-ref
              _req206043_
              '1
              std/net/httpd/handler#http-request::t
              '#f)
             (##unchecked-structure-ref
              _req206043_
              '8
              std/net/httpd/handler#http-request::t
              '#f)))
          '#!void)))
  (define std/net/httpd/handler#http-response-trace
    (lambda (_res205973_ _req205974_)
      (let* ((_req205975205988_ _req205974_)
             (_E205977205992_
              (lambda () (error '"No clause matching" _req205975205988_)))
             (_K205978206008_
              (lambda (_headers205995_
                       _proto205996_
                       _url205997_
                       _method205998_)
                (let ((_xbuf206000_
                       (std/net/bio/buffer#open-chunked-output-buffer__0)))
                  (std/net/bio/output#bio-write-string
                   (symbol->string _method205998_)
                   _xbuf206000_)
                  (std/net/bio/output#bio-write-u8
                   std/net/httpd/handler#SPC
                   _xbuf206000_)
                  (std/net/bio/output#bio-write-string
                   _url205997_
                   _xbuf206000_)
                  (std/net/bio/output#bio-write-u8
                   std/net/httpd/handler#SPC
                   _xbuf206000_)
                  (std/net/bio/output#bio-write-string
                   _proto205996_
                   _xbuf206000_)
                  (std/net/httpd/handler#write-crlf _xbuf206000_)
                  (std/net/httpd/handler#write-response-headers
                   _xbuf206000_
                   _headers205995_)
                  (std/net/httpd/handler#write-crlf _xbuf206000_)
                  (let ((_chunks206002_
                         (std/net/bio/buffer#chunked-output-chunks
                          _xbuf206000_)))
                    (std/net/httpd/handler#http-response-begin
                     _res205973_
                     '200
                     '(("Content-Type" . "message/http")))
                    (for-each
                     (lambda (_g206003206005_)
                       (std/net/httpd/handler#http-response-chunk__0
                        _res205973_
                        _g206003206005_))
                     _chunks206002_)
                    (std/net/httpd/handler#http-response-end _res205973_))))))
        (if (##structure-direct-instance-of?
             _req205975205988_
             'std/net/httpd/handler#http-request::t)
            (let* ((_e205979206011_ (##vector-ref _req205975205988_ '1))
                   (_e205980206014_ (##vector-ref _req205975205988_ '2))
                   (_e205981206017_ (##vector-ref _req205975205988_ '3))
                   (_method206020_ _e205981206017_)
                   (_e205982206022_ (##vector-ref _req205975205988_ '4))
                   (_url206025_ _e205982206022_)
                   (_e205983206027_ (##vector-ref _req205975205988_ '5))
                   (_e205984206030_ (##vector-ref _req205975205988_ '6))
                   (_e205985206033_ (##vector-ref _req205975205988_ '7))
                   (_proto206036_ _e205985206033_)
                   (_e205986206038_ (##vector-ref _req205975205988_ '8))
                   (_headers206041_ _e205986206038_))
              (_K205978206008_
               _headers206041_
               _proto206036_
               _url206025_
               _method206020_))
            (_E205977205992_)))))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace ("std/net/httpd/handler#" http-date))
  (c-declare
   "#include <time.h>\n#include <string.h>\n__thread char buf[64];\nstatic char *ffi_httpd_date () {\n struct tm tm;\n time_t t = time(NULL);\n asctime_r (gmtime_r (&t, &tm), buf);\n // clobber newline\n buf[strlen(buf)-1] = 0;\n return buf;\n}")
  (define-c-lambda http-date () char-string "ffi_httpd_date")
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif")
  (define std/net/httpd/handler#request-timeout '60)
  (define std/net/httpd/handler#response-timeout '120)
  (define std/net/httpd/handler#max-request-headers '256)
  (define std/net/httpd/handler#max-token-length '1024)
  (define std/net/httpd/handler#max-request-body-length (expt '2 '20))
  (define std/net/httpd/handler#input-buffer-size '4096)
  (define std/net/httpd/handler#output-buffer-size '4096)
  (define std/net/httpd/handler#set-httpd-request-timeout!
    (lambda (_val205964_)
      (if (or (not _val205964_) (real? _val205964_) (time? _val205964_))
          (set! std/net/httpd/handler#request-timeout _val205964_)
          (error '"Cannot set httpd parameter; Bad argument" _val205964_))))
  (define std/net/httpd/handler#set-httpd-response-timeout!
    (lambda (_val205955_)
      (if (or (not _val205955_) (real? _val205955_) (time? _val205955_))
          (set! std/net/httpd/handler#response-timeout _val205955_)
          (error '"Cannot set httpd parameter; Bad argument" _val205955_))))
  (define std/net/httpd/handler#set-httpd-max-request-headers!
    (lambda (_val205952_)
      (if (and (fixnum? _val205952_) (fxpositive? _val205952_))
          (set! std/net/httpd/handler#max-request-headers _val205952_)
          (error '"Cannot set httpd parameter; Bad argument" _val205952_))))
  (define std/net/httpd/handler#set-httpd-max-token-length!
    (lambda (_val205949_)
      (if (and (fixnum? _val205949_) (fxpositive? _val205949_))
          (set! std/net/httpd/handler#max-token-length _val205949_)
          (error '"Cannot set httpd parameter; Bad argument" _val205949_))))
  (define std/net/httpd/handler#set-httpd-max-request-body-length!
    (lambda (_val205946_)
      (if (and (fixnum? _val205946_) (fxpositive? _val205946_))
          (set! std/net/httpd/handler#max-request-body-length _val205946_)
          (error '"Cannot set httpd parameter; Bad argument" _val205946_))))
  (define std/net/httpd/handler#set-httpd-input-buffer-size!
    (lambda (_val205943_)
      (if (and (fixnum? _val205943_) (fxpositive? _val205943_))
          (set! std/net/httpd/handler#input-buffer-size _val205943_)
          (error '"Cannot set httpd parameter; Bad argument" _val205943_))))
  (define std/net/httpd/handler#set-httpd-output-buffer-size!
    (lambda (_val205940_)
      (if (and (fixnum? _val205940_) (fxpositive? _val205940_))
          (set! std/net/httpd/handler#output-buffer-size _val205940_)
          (error '"Cannot set httpd parameter; Bad argument" _val205940_))))
  (define std/net/httpd/handler#read-request!
    (lambda (_req205926_)
      (let* ((_ibuf205928_
              (##unchecked-structure-ref
               _req205926_
               '1
               std/net/httpd/handler#http-request::t
               '#f))
             (_g309565_
              (std/net/httpd/handler#read-request-line _ibuf205928_)))
        (begin
          (let ((_g309566_
                 (if (##values? _g309565_) (##vector-length _g309565_) 1)))
            (if (not (##fx= _g309566_ 3))
                (error "Context expects 3 values" _g309566_)))
          (let ((_method205930_ (##vector-ref _g309565_ 0))
                (_url205931_ (##vector-ref _g309565_ 1))
                (_proto205932_ (##vector-ref _g309565_ 2)))
            (let ((_g309567_
                   (std/net/httpd/handler#split-request-url _url205931_)))
              (begin
                (let ((_g309568_
                       (if (##values? _g309567_)
                           (##vector-length _g309567_)
                           1)))
                  (if (not (##fx= _g309568_ 2))
                      (error "Context expects 2 values" _g309568_)))
                (let ((_path205934_ (##vector-ref _g309567_ 0))
                      (_params205935_ (##vector-ref _g309567_ 1)))
                  (let ((_headers205937_
                         (std/net/httpd/handler#read-request-headers
                          _ibuf205928_)))
                    (##unchecked-structure-set!
                     _req205926_
                     _method205930_
                     '3
                     std/net/httpd/handler#http-request::t
                     '#f)
                    (##unchecked-structure-set!
                     _req205926_
                     _url205931_
                     '4
                     std/net/httpd/handler#http-request::t
                     '#f)
                    (##unchecked-structure-set!
                     _req205926_
                     _path205934_
                     '5
                     std/net/httpd/handler#http-request::t
                     '#f)
                    (##unchecked-structure-set!
                     _req205926_
                     _params205935_
                     '6
                     std/net/httpd/handler#http-request::t
                     '#f)
                    (##unchecked-structure-set!
                     _req205926_
                     _proto205932_
                     '7
                     std/net/httpd/handler#http-request::t
                     '#f)
                    (##unchecked-structure-set!
                     _req205926_
                     _headers205937_
                     '8
                     std/net/httpd/handler#http-request::t
                     '#f))))))))))
  (define std/net/httpd/handler#split-request-url-rx
    (std/pregexp#pregexp '"^[^/]+://[^/]*(/.*)$"))
  (define std/net/httpd/handler#split-request-url
    (lambda (_url205879_)
      (let ((_$e205881_ (string-index _url205879_ '#\:)))
        (if _$e205881_
            ((lambda (_ix205884_)
               (let* ((_g205885205895_
                       (std/pregexp#pregexp-match
                        std/net/httpd/handler#split-request-url-rx
                        _url205879_))
                      (_else205887205903_
                       (lambda ()
                         (std/error#raise-io-error
                          'http-read-request
                          '"invalid url"
                          _url205879_)))
                      (_K205889205908_
                       (lambda (_base205906_)
                         (std/net/httpd/handler#split-request-url
                          _base205906_))))
                 (if (##pair? _g205885205895_)
                     (let ((_tl205891205911_ (##cdr _g205885205895_)))
                       (if (##pair? _tl205891205911_)
                           (let ((_hd205892205914_ (##car _tl205891205911_))
                                 (_tl205893205916_ (##cdr _tl205891205911_)))
                             (let ((_base205919_ _hd205892205914_))
                               (if (##null? _tl205893205916_)
                                   (std/net/httpd/handler#split-request-url
                                    _base205919_)
                                   (_else205887205903_))))
                           (_else205887205903_)))
                     (_else205887205903_))))
             _$e205881_)
            (let ((_$e205921_ (string-index _url205879_ '#\?)))
              (if _$e205921_
                  ((lambda (_ix205924_)
                     (values (substring _url205879_ '0 _ix205924_)
                             (substring
                              _url205879_
                              (fx+ _ix205924_ '1)
                              (string-length _url205879_))))
                   _$e205921_)
                  (values _url205879_ '#f)))))))
  (define std/net/httpd/handler#read-request-line
    (lambda (_ibuf205863_)
      (let* ((_g309569_
              (std/net/httpd/handler#read-skip*__1
               _ibuf205863_
               std/net/httpd/handler#CR
               std/net/httpd/handler#LF))
             (_method205866_
              (std/net/httpd/handler#read-token
               _ibuf205863_
               std/net/httpd/handler#SPC))
             (_url205868_
              (std/net/httpd/handler#read-token
               _ibuf205863_
               std/net/httpd/handler#SPC))
             (_proto205870_
              (std/net/httpd/handler#read-token
               _ibuf205863_
               std/net/httpd/handler#CR))
             (_g309570_
              (std/net/httpd/handler#read-skip__0
               _ibuf205863_
               std/net/httpd/handler#LF))
             (_method205876_
              (let ((_$e205873_
                     (table-ref
                      std/net/httpd/handler#+http-request-methods+
                      _method205866_
                      '#f)))
                (if _$e205873_ _$e205873_ _method205866_))))
        (values _method205876_ _url205868_ _proto205870_))))
  (define std/net/httpd/handler#read-request-headers
    (lambda (_ibuf205847_)
      (let ((_root205849_ (cons '#f '())))
        (let _lp205851_ ((_tl205853_ _root205849_) (_count205854_ '0))
          (let ((_next205856_ (std/net/bio/input#bio-peek-u8 _ibuf205847_)))
            (if (eof-object? _next205856_)
                (raise 'eof)
                (if (eq? _next205856_ std/net/httpd/handler#CR)
                    (begin
                      (std/net/httpd/handler#read-skip__1
                       _ibuf205847_
                       std/net/httpd/handler#CR
                       std/net/httpd/handler#LF)
                      (cdr _root205849_))
                    (if (fx< _count205854_
                             std/net/httpd/handler#max-request-headers)
                        (let* ((_hdr205858_
                                (std/net/httpd/handler#read-header
                                 _ibuf205847_))
                               (_tl*205860_ (cons _hdr205858_ '())))
                          (set-cdr! _tl205853_ _tl*205860_)
                          (_lp205851_ _tl*205860_ (fx+ _count205854_ '1)))
                        (std/error#raise-io-error
                         'http-read-request
                         '"too many headers"
                         _count205854_)))))))))
  (define std/net/httpd/handler#read-header
    (lambda (_ibuf205837_)
      (let* ((_key205839_
              (std/net/httpd/handler#read-token
               _ibuf205837_
               std/net/httpd/handler#COL))
             (_g309571_ (std/net/httpd/handler#header-titlecase! _key205839_))
             (_g309572_
              (std/net/httpd/handler#read-skip*__0
               _ibuf205837_
               std/net/httpd/handler#SPC))
             (_val205843_
              (std/net/httpd/handler#read-token
               _ibuf205837_
               std/net/httpd/handler#CR))
             (_g309573_
              (std/net/httpd/handler#read-skip__0
               _ibuf205837_
               std/net/httpd/handler#LF)))
        (cons _key205839_ _val205843_))))
  (define std/net/httpd/handler#header-titlecase!
    (lambda (_str205819_)
      (let ((_len205821_ (string-length _str205819_)))
        (let _lp205823_ ((_i205825_ '0) (_upcase?205826_ '#t))
          (if (fx< _i205825_ _len205821_)
              (let* ((_char205828_ (string-ref _str205819_ _i205825_))
                     (_int205830_ (char->integer _char205828_)))
                (if (fx<= '97 _int205830_ '122)
                    (begin
                      (if _upcase?205826_
                          (let ((_char205833_
                                 (integer->char (fx- _int205830_ '32))))
                            (string-set! _str205819_ _i205825_ _char205833_))
                          '#!void)
                      (_lp205823_ (fx+ _i205825_ '1) '#f))
                    (if (fx<= '65 _int205830_ '90)
                        (begin
                          (if _upcase?205826_
                              '#!void
                              (let ((_char205835_
                                     (integer->char (fx+ _int205830_ '32))))
                                (string-set!
                                 _str205819_
                                 _i205825_
                                 _char205835_)))
                          (_lp205823_ (fx+ _i205825_ '1) '#f))
                        (_lp205823_ (fx+ _i205825_ '1) '#t))))
              _str205819_)))))
  (define std/net/httpd/handler#read-token
    (lambda (_ibuf205804_ _sep205805_)
      (letrec* ((_tbuf205807_ (std/net/httpd/handler#get-token-buffer)))
        (let _lp205809_ ((_count205811_ '0))
          (let ((_next205813_ (std/net/bio/input#bio-read-u8 _ibuf205804_)))
            (if (eof-object? _next205813_)
                (begin
                  (std/net/httpd/handler#put-token-buffer! _tbuf205807_)
                  (raise 'eof))
                (if (eq? _next205813_ _sep205805_)
                    (let ((_token205815_
                           (##substring _tbuf205807_ '0 _count205811_)))
                      (std/net/httpd/handler#put-token-buffer! _tbuf205807_)
                      _token205815_)
                    (if (fx< _count205811_
                             std/net/httpd/handler#max-token-length)
                        (let ((_char205817_ (integer->char _next205813_)))
                          (string-set! _tbuf205807_ _count205811_ _char205817_)
                          (_lp205809_ (fx+ _count205811_ '1)))
                        (begin
                          (std/net/httpd/handler#put-token-buffer!
                           _tbuf205807_)
                          (std/error#raise-io-error
                           'http-read-request
                           '"Maximum token length exceeded"
                           _count205811_))))))))))
  (define std/net/httpd/handler#read-skip__0
    (lambda (_ibuf205795_ _c205796_)
      (let ((_next205798_ (std/net/bio/input#bio-read-u8 _ibuf205795_)))
        (if (eq? _c205796_ _next205798_)
            '#!void
            (std/error#raise-io-error
             'http-read-request
             '"Unexpected character"
             _next205798_)))))
  (define std/net/httpd/handler#read-skip__1
    (lambda (_ibuf205800_ _c1205801_ _c2205802_)
      (std/net/httpd/handler#read-skip__0 _ibuf205800_ _c1205801_)
      (std/net/httpd/handler#read-skip__0 _ibuf205800_ _c2205802_)))
  (define std/net/httpd/handler#read-skip
    (lambda _g309575_
      (let ((_g309574_ (##length _g309575_)))
        (cond ((##fx= _g309574_ 2)
               (apply std/net/httpd/handler#read-skip__0 _g309575_))
              ((##fx= _g309574_ 3)
               (apply std/net/httpd/handler#read-skip__1 _g309575_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/httpd/handler#read-skip
                _g309575_))))))
  (define std/net/httpd/handler#read-skip*__0
    (lambda (_ibuf205778_ _c205779_)
      (let _lp205781_ ()
        (let ((_next205784_ (std/net/bio/input#bio-peek-u8 _ibuf205778_)))
          (if (eq? _next205784_ _c205779_)
              (begin (std/net/bio/input#bio-read-u8 _ibuf205778_) (_lp205781_))
              '#!void)))))
  (define std/net/httpd/handler#read-skip*__1
    (lambda (_ibuf205786_ _c1205787_ _c2205788_)
      (let _lp205790_ ()
        (let ((_next205793_ (std/net/bio/input#bio-peek-u8 _ibuf205786_)))
          (if (eq? _next205793_ _c1205787_)
              (begin
                (std/net/bio/input#bio-read-u8 _ibuf205786_)
                (std/net/httpd/handler#read-skip__0 _ibuf205786_ _c2205788_)
                (_lp205790_))
              '#!void)))))
  (define std/net/httpd/handler#read-skip*
    (lambda _g309577_
      (let ((_g309576_ (##length _g309577_)))
        (cond ((##fx= _g309576_ 2)
               (apply std/net/httpd/handler#read-skip*__0 _g309577_))
              ((##fx= _g309576_ 3)
               (apply std/net/httpd/handler#read-skip*__1 _g309577_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/httpd/handler#read-skip*
                _g309577_))))))
  (define std/net/httpd/handler#read-request-body
    (lambda (_ibuf205756_ _headers205757_)
      (letrec ((_read-simple-body205759_
                (lambda ()
                  (let ((_$e205767_
                         (std/net/httpd/handler#header-e
                          '"Content-Length"
                          _headers205757_)))
                    (if _$e205767_
                        ((lambda (_len205770_)
                           (let* ((_len205772_ (string->number _len205770_))
                                  (_g309578_
                                   (if (fx<= _len205772_
                                             std/net/httpd/handler#max-request-body-length)
                                       '#!void
                                       (std/error#raise-io-error
                                        'http-request-body
                                        '"Maximum body length exceeded"
                                        _len205772_)))
                                  (_bytes205775_ (make-u8vector _len205772_)))
                             (std/net/bio/input#bio-read-bytes
                              _bytes205775_
                              _ibuf205756_)
                             _bytes205775_))
                         _$e205767_)
                        '#f)))))
        (let ((_$e205761_
               (std/net/httpd/handler#header-e
                '"Transfer-Encoding"
                _headers205757_)))
          (if _$e205761_
              ((lambda (_tenc205764_)
                 (if (not (equal? '"identity" _tenc205764_))
                     (std/net/httpd/handler#read-request-chunks _ibuf205756_)
                     (_read-simple-body205759_)))
               _$e205761_)
              (_read-simple-body205759_))))))
  (define std/net/httpd/handler#read-request-chunks
    (lambda (_ibuf205735_)
      (let ((_root205737_ (cons '#f '())))
        (let _lp205739_ ((_tl205741_ _root205737_) (_count205742_ '0))
          (let* ((_next205744_
                  (std/net/httpd/handler#read-token
                   _ibuf205735_
                   std/net/httpd/handler#CR))
                 (_g309579_
                  (std/net/httpd/handler#read-skip__0
                   _ibuf205735_
                   std/net/httpd/handler#LF))
                 (_len205747_ (string->number _next205744_ '16)))
            (if (fx> _len205747_ '0)
                (let ((_count205750_ (fx+ _count205742_ _len205747_)))
                  (if (fx<= _count205750_
                            std/net/httpd/handler#max-request-body-length)
                      (let ((_chunk205752_ (make-u8vector _len205747_)))
                        (std/net/bio/input#bio-read-bytes
                         _chunk205752_
                         _ibuf205735_)
                        (std/net/httpd/handler#read-skip__1
                         _ibuf205735_
                         std/net/httpd/handler#CR
                         std/net/httpd/handler#LF)
                        (let ((_tl*205754_ (cons _chunk205752_ '())))
                          (set-cdr! _tl205741_ _tl*205754_)
                          (_lp205739_ _tl*205754_ _count205750_)))
                      (std/error#raise-io-error
                       'http-request-body
                       '"Maximum body length exceeded"
                       _count205750_
                       _len205747_)))
                (u8vector-concatenate (cdr _root205737_))))))))
  (define std/net/httpd/handler#skip-request-body
    (lambda (_ibuf205716_ _headers205717_)
      (letrec ((_skip-simple-body205719_
                (lambda ()
                  (let ((_clen205726205728_
                         (std/net/httpd/handler#header-e
                          '"Content-Length"
                          _headers205717_)))
                    (if _clen205726205728_
                        (let* ((_clen205731_ _clen205726205728_)
                               (_len205733_ (string->number _clen205731_)))
                          (if (fixnum? _len205733_)
                              (std/net/bio/input#bio-input-skip
                               _len205733_
                               _ibuf205716_)
                              (std/error#raise-io-error
                               'http-request-skip-body
                               '"Illegal body length"
                               _clen205731_)))
                        '#f)))))
        (let ((_$e205721_
               (std/net/httpd/handler#header-e
                '"Transfer-Encoding"
                _headers205717_)))
          (if _$e205721_
              ((lambda (_tenc205724_)
                 (if (not (equal? '"identity" _tenc205724_))
                     (std/net/httpd/handler#skip-request-chunks _ibuf205716_)
                     (_skip-simple-body205719_)))
               _$e205721_)
              (_skip-simple-body205719_))))))
  (define std/net/httpd/handler#skip-request-chunks
    (lambda (_ibuf205708_)
      (let* ((_next205710_
              (std/net/httpd/handler#read-token
               _ibuf205708_
               std/net/httpd/handler#CR))
             (_g309580_
              (std/net/httpd/handler#read-skip__0
               _ibuf205708_
               std/net/httpd/handler#LF))
             (_len205713_ (string->number _next205710_ '16)))
        (if (fx> _len205713_ '0)
            (begin
              (std/net/bio/input#bio-input-skip _len205713_ _ibuf205708_)
              (std/net/httpd/handler#read-skip__1
               _ibuf205708_
               std/net/httpd/handler#CR
               std/net/httpd/handler#LF)
              (std/net/httpd/handler#skip-request-chunks _ibuf205708_))
            '#!void))))
  (define std/net/httpd/handler#write-response-line
    (lambda (_obuf205700_ _status205701_)
      (let ((_text205706_
             (let ((_$e205703_
                    (table-ref
                     std/net/httpd/handler#+http-response-codes+
                     _status205701_
                     '#f)))
               (if _$e205703_ (values _$e205703_) '"Gremlins!"))))
        (std/net/bio/output#bio-write-string '"HTTP/1.1" _obuf205700_)
        (std/net/bio/output#bio-write-u8
         std/net/httpd/handler#SPC
         _obuf205700_)
        (std/net/bio/output#bio-write-string
         (number->string _status205701_)
         _obuf205700_)
        (std/net/bio/output#bio-write-u8
         std/net/httpd/handler#SPC
         _obuf205700_)
        (std/net/bio/output#bio-write-string _text205706_ _obuf205700_)
        (std/net/httpd/handler#write-crlf _obuf205700_))))
  (define std/net/httpd/handler#write-response-headers
    (lambda (_obuf205665_ _headers205666_)
      (letrec ((_write-header205668_
                (lambda (_hdr205670_)
                  (let* ((_hdr205671205678_ _hdr205670_)
                         (_E205673205682_
                          (lambda ()
                            (error '"No clause matching" _hdr205671205678_)))
                         (_K205674205688_
                          (lambda (_val205685_ _key205686_)
                            (if (string? _key205686_)
                                (if (string? _val205685_)
                                    (begin
                                      (std/net/bio/output#bio-write-string
                                       _key205686_
                                       _obuf205665_)
                                      (std/net/bio/output#bio-write-u8
                                       std/net/httpd/handler#COL
                                       _obuf205665_)
                                      (std/net/bio/output#bio-write-u8
                                       std/net/httpd/handler#SPC
                                       _obuf205665_)
                                      (std/net/bio/output#bio-write-string
                                       _val205685_
                                       _obuf205665_)
                                      (std/net/httpd/handler#write-crlf
                                       _obuf205665_))
                                    (error '"Bad header value; expected string"
                                           _hdr205670_
                                           _val205685_))
                                (error '"Bad header key; expected string"
                                       _hdr205670_
                                       _key205686_)))))
                    (if (##pair? _hdr205671205678_)
                        (let ((_hd205675205691_ (##car _hdr205671205678_))
                              (_tl205676205693_ (##cdr _hdr205671205678_)))
                          (let* ((_key205696_ _hd205675205691_)
                                 (_val205698_ _tl205676205693_))
                            (_K205674205688_ _val205698_ _key205696_)))
                        (_E205673205682_))))))
        (for-each _write-header205668_ _headers205666_))))
  (define std/net/httpd/handler#write-crlf
    (lambda (_obuf205663_)
      (std/net/bio/output#bio-write-u8 std/net/httpd/handler#CR _obuf205663_)
      (std/net/bio/output#bio-write-u8 std/net/httpd/handler#LF _obuf205663_)))
  (define std/net/httpd/handler#write-chunk
    (lambda (_obuf205653_ _chunk205654_ _start205655_ _end205656_)
      (let* ((_end205658_
              (if _end205656_
                  _end205656_
                  (if (u8vector? _chunk205654_)
                      (u8vector-length _chunk205654_)
                      (if (string? _chunk205654_)
                          (string-length _chunk205654_)
                          (if (not _chunk205654_)
                              '0
                              (error '"Bad chunk; expected u8vector or string"
                                     _chunk205654_))))))
             (_len205660_
              (if (u8vector? _chunk205654_)
                  (fx- _end205658_ _start205655_)
                  (if (string? _chunk205654_)
                      (std/text/utf8#string-utf8-length__%
                       _chunk205654_
                       _start205655_
                       _end205658_)
                      '0))))
        (if (fx> _len205660_ '0)
            (begin
              (std/net/bio/output#bio-write-string
               (number->string _len205660_ '16)
               _obuf205653_)
              (std/net/httpd/handler#write-crlf _obuf205653_)
              (if (u8vector? _chunk205654_)
                  (std/net/bio/output#bio-write-subu8vector
                   _chunk205654_
                   _start205655_
                   _end205658_
                   _obuf205653_)
                  (if (string? _chunk205654_)
                      (std/net/bio/output#bio-write-substring
                       _chunk205654_
                       _start205655_
                       _end205658_
                       _obuf205653_)
                      '#!void))
              (std/net/httpd/handler#write-crlf _obuf205653_))
            '#!void))))
  (define std/net/httpd/handler#write-last-chunk
    (lambda (_obuf205651_)
      (std/net/bio/output#bio-write-u8 std/net/httpd/handler#C0 _obuf205651_)
      (std/net/httpd/handler#write-crlf _obuf205651_)
      (std/net/httpd/handler#write-crlf _obuf205651_)))
  (define std/net/httpd/handler#C0 (char->integer '#\0))
  (define std/net/httpd/handler#CR (char->integer '#\return))
  (define std/net/httpd/handler#LF (char->integer '#\newline))
  (define std/net/httpd/handler#COL (char->integer '#\:))
  (define std/net/httpd/handler#SPC (char->integer '#\space))
  (define std/net/httpd/handler#QMARK (char->integer '#\?))
  (define std/net/httpd/handler#+http-request-methods+
    (let ((_ht205648_ (make-table 'size: '7)))
      (table-set! _ht205648_ '"GET" 'GET)
      (table-set! _ht205648_ '"HEAD" 'HEAD)
      (table-set! _ht205648_ '"POST" 'POST)
      (table-set! _ht205648_ '"PUT" 'PUT)
      (table-set! _ht205648_ '"DELETE" 'DELETE)
      (table-set! _ht205648_ '"TRACE" 'TRACE)
      (table-set! _ht205648_ '"OPTIONS" 'OPTIONS)
      _ht205648_))
  (define std/net/httpd/handler#+http-response-codes+
    (let ((_ht205645_ (make-table 'test: eq? 'size: '40)))
      (table-set! _ht205645_ '100 '"Continue")
      (table-set! _ht205645_ '101 '"Switching Protocols")
      (table-set! _ht205645_ '200 '"OK")
      (table-set! _ht205645_ '201 '"Created")
      (table-set! _ht205645_ '202 '"Accepted")
      (table-set! _ht205645_ '203 '"Non-Authoritative Information")
      (table-set! _ht205645_ '204 '"No Content")
      (table-set! _ht205645_ '205 '"Reset Content")
      (table-set! _ht205645_ '206 '"Partial Content")
      (table-set! _ht205645_ '300 '"Multiple Choices")
      (table-set! _ht205645_ '301 '"Moved Permanently")
      (table-set! _ht205645_ '302 '"Found")
      (table-set! _ht205645_ '303 '"See Other")
      (table-set! _ht205645_ '304 '"Not Modified")
      (table-set! _ht205645_ '305 '"Use Proxy")
      (table-set! _ht205645_ '307 '"Temporary Redirect")
      (table-set! _ht205645_ '400 '"Bad Request")
      (table-set! _ht205645_ '401 '"Unauthorized")
      (table-set! _ht205645_ '402 '"Payment Required")
      (table-set! _ht205645_ '403 '"Forbidden")
      (table-set! _ht205645_ '404 '"Not Found")
      (table-set! _ht205645_ '405 '"Method Not Allowed")
      (table-set! _ht205645_ '406 '"Not Acceptable")
      (table-set! _ht205645_ '407 '"Proxy Authentication Required")
      (table-set! _ht205645_ '408 '"Request Timeout")
      (table-set! _ht205645_ '409 '"Conflict")
      (table-set! _ht205645_ '410 '"Gone")
      (table-set! _ht205645_ '411 '"Length Required")
      (table-set! _ht205645_ '412 '"Precondition Failed")
      (table-set! _ht205645_ '413 '"Request Entity Too Large")
      (table-set! _ht205645_ '414 '"Request-URI Too Long")
      (table-set! _ht205645_ '415 '"Unsupported Media Type")
      (table-set! _ht205645_ '416 '"Requested Range Not Satisfiable")
      (table-set! _ht205645_ '417 '"Expectation Failed")
      (table-set! _ht205645_ '500 '"Internal Server Error")
      (table-set! _ht205645_ '501 '"Not Implemented")
      (table-set! _ht205645_ '502 '"Bad Gateway")
      (table-set! _ht205645_ '503 '"Service Unavailable")
      (table-set! _ht205645_ '504 '"Gateway Timeout")
      (table-set! _ht205645_ '505 '"HTTP Version Not Supported")
      _ht205645_))
  (define std/net/httpd/handler#+input-buffers+ '())
  (define std/net/httpd/handler#+output-buffers+ '())
  (define std/net/httpd/handler#+token-buffers+ '())
  (define std/net/httpd/handler#get-input-buffer
    (lambda (_sock205609_)
      (declare (not interrupts-enabled))
      (let* ((_+input-buffers+205611205619_
              std/net/httpd/handler#+input-buffers+)
             (_else205613205627_
              (lambda ()
                (std/net/socket/buffer#open-ssocket-input-buffer__%
                 _sock205609_
                 std/net/httpd/handler#input-buffer-size)))
             (_K205615205633_
              (lambda (_rest205630_ _buf205631_)
                (set! std/net/httpd/handler#+input-buffers+ _rest205630_)
                (std/net/socket/buffer#ssocket-input-buffer-reset!
                 _buf205631_
                 _sock205609_)
                _buf205631_)))
        (if (##pair? _+input-buffers+205611205619_)
            (let ((_hd205616205636_ (##car _+input-buffers+205611205619_))
                  (_tl205617205638_ (##cdr _+input-buffers+205611205619_)))
              (let* ((_buf205641_ _hd205616205636_)
                     (_rest205643_ _tl205617205638_))
                (_K205615205633_ _rest205643_ _buf205641_)))
            (_else205613205627_)))))
  (define std/net/httpd/handler#put-input-buffer!
    (lambda (_buf205606_)
      (declare (not interrupts-enabled))
      (begin
        (std/net/socket/buffer#ssocket-input-buffer-release! _buf205606_)
        (set! std/net/httpd/handler#+input-buffers+
              (cons _buf205606_ std/net/httpd/handler#+input-buffers+)))))
  (define std/net/httpd/handler#get-output-buffer
    (lambda (_sock205570_)
      (declare (not interrupts-enabled))
      (let* ((_+output-buffers+205572205580_
              std/net/httpd/handler#+output-buffers+)
             (_else205574205588_
              (lambda ()
                (std/net/socket/buffer#open-ssocket-output-buffer__%
                 _sock205570_
                 std/net/httpd/handler#output-buffer-size)))
             (_K205576205594_
              (lambda (_rest205591_ _buf205592_)
                (set! std/net/httpd/handler#+output-buffers+ _rest205591_)
                (std/net/socket/buffer#ssocket-output-buffer-reset!
                 _buf205592_
                 _sock205570_)
                _buf205592_)))
        (if (##pair? _+output-buffers+205572205580_)
            (let ((_hd205577205597_ (##car _+output-buffers+205572205580_))
                  (_tl205578205599_ (##cdr _+output-buffers+205572205580_)))
              (let* ((_buf205602_ _hd205577205597_)
                     (_rest205604_ _tl205578205599_))
                (_K205576205594_ _rest205604_ _buf205602_)))
            (_else205574205588_)))))
  (define std/net/httpd/handler#put-output-buffer!
    (lambda (_buf205567_)
      (declare (not interrupts-enabled))
      (begin
        (std/net/socket/buffer#ssocket-output-buffer-release! _buf205567_)
        (set! std/net/httpd/handler#+output-buffers+
              (cons _buf205567_ std/net/httpd/handler#+output-buffers+)))))
  (define std/net/httpd/handler#get-token-buffer
    (lambda ()
      (declare (not interrupts-enabled))
      (let* ((_+token-buffers+205533205541_
              std/net/httpd/handler#+token-buffers+)
             (_else205535205549_
              (lambda () (make-string std/net/httpd/handler#max-token-length)))
             (_K205537205555_
              (lambda (_rest205552_ _buf205553_)
                (set! std/net/httpd/handler#+token-buffers+ _rest205552_)
                _buf205553_)))
        (if (##pair? _+token-buffers+205533205541_)
            (let ((_hd205538205558_ (##car _+token-buffers+205533205541_))
                  (_tl205539205560_ (##cdr _+token-buffers+205533205541_)))
              (let* ((_buf205563_ _hd205538205558_)
                     (_rest205565_ _tl205539205560_))
                (_K205537205555_ _rest205565_ _buf205563_)))
            (_else205535205549_)))))
  (define std/net/httpd/handler#put-token-buffer!
    (lambda (_buf205529_)
      (declare (not interrupts-enabled))
      (set! std/net/httpd/handler#+token-buffers+
            (cons _buf205529_ std/net/httpd/handler#+token-buffers+)))))
