(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/socket/server#start-socket-server!__%
    (lambda (_impl203384_)
      (let ((_$e203386_ (std/net/socket/base#current-socket-server)))
        (if _$e203386_
            (values _$e203386_)
            (begin
              (std/logger#start-logger!__0)
              (let ((_srv203389_
                     (gerbil/gambit/threads#spawn/group
                      'socket-server
                      _impl203384_)))
                (std/net/socket/base#current-socket-server _srv203389_)
                _srv203389_))))))
  (define std/net/socket/server#start-socket-server!__0
    (lambda ()
      (let ((_impl203395_ (std/net/socket/server#default-server-impl)))
        (std/net/socket/server#start-socket-server!__% _impl203395_))))
  (define std/net/socket/server#start-socket-server!
    (lambda _g309559_
      (let ((_g309558_ (let () (declare (not safe)) (##length _g309559_))))
        (cond ((let () (declare (not safe)) (##fx= _g309558_ 0))
               (apply std/net/socket/server#start-socket-server!__0 _g309559_))
              ((let () (declare (not safe)) (##fx= _g309558_ 1))
               (apply std/net/socket/server#start-socket-server!__% _g309559_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/server#start-socket-server!
                _g309559_))))))
  (define std/net/socket/server#stop-socket-server!__%
    (lambda (_srv203373_)
      (std/net/socket/server#server-shutdown! _srv203373_)))
  (define std/net/socket/server#stop-socket-server!__0
    (lambda ()
      (let ((_srv203379_ (std/net/socket/base#current-socket-server)))
        (std/net/socket/server#server-shutdown! _srv203379_))))
  (define std/net/socket/server#stop-socket-server!
    (lambda _g309561_
      (let ((_g309560_ (let () (declare (not safe)) (##length _g309561_))))
        (cond ((let () (declare (not safe)) (##fx= _g309560_ 0))
               (apply std/net/socket/server#stop-socket-server!__0 _g309561_))
              ((let () (declare (not safe)) (##fx= _g309560_ 1))
               (apply std/net/socket/server#server-shutdown! _g309561_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/server#stop-socket-server!
                _g309561_))))))
  (define std/net/socket/server#server-shutdown!
    (lambda (_srv203361_)
      (let ((_tgroup203363_ (thread-thread-group _srv203361_)))
        (with-unwind-protect
         (lambda ()
           (let ((_token203366_
                  (let ()
                    (declare (not safe))
                    (##structure std/actor/proto#!token::t)))
                 (_dest203368_ _srv203361_))
             (std/actor/message#send-message__%
              _dest203368_
              (let ((__tmp309562
                     (let ()
                       (declare (not safe))
                       (##structure
                        std/net/socket/base#socket-server.shutdown!::t))))
                (declare (not safe))
                (##structure
                 std/actor/proto#!call::t
                 __tmp309562
                 _token203366_))
              '#f
              '#t)
             (std/actor/proto#!!call-recv _token203366_ _dest203368_))
           (thread-join! _srv203361_))
         (lambda () (std/misc/threads#thread-group-kill! _tgroup203363_))))))
  (define std/net/socket/server#default-server-impl
    (lambda () std/net/socket/kqueue-server#kqueue-socket-server)))
