(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/kqueue#kqueue
    (lambda ()
      (let* ((_fd199536_
              (let ((_r199533_ (std/os/kqueue#_kqueue)))
                (if (not (let ()
                           (declare (not safe))
                           (##fxnegative? _r199533_)))
                    _r199533_
                    (std/os/error#raise-os-error
                     (let () (declare (not safe)) (##fx- _r199533_))
                     std/os/kqueue#kqueue))))
             (_raw199538_ (std/os/fd#fdopen _fd199536_ 'in 'kqueue)))
        (std/os/fcntl#fd-set-closeonexec _raw199538_)
        _raw199538_)))
  (define std/os/kqueue#kqueue-close
    (lambda (_kq199530_) (close-port _kq199530_)))
  (define std/os/kqueue#make-kevents
    (lambda (_size199525_)
      (let ((_r199527_ (std/os/kqueue#make_kevents _size199525_)))
        (if _r199527_
            _r199527_
            (error '"Error allocating memory" 'make_kevents)))))
  (define std/os/kqueue#kevent-set!__%
    (lambda (_g301120_
             _ident199476199484_
             _filter199477199486_
             _flags199478199488_
             _filter-flags199479199490_
             _data199480199492_
             _user-data199481199494_
             _kevts199496_
             _ix199497_)
      (let* ((_ident199499_
              (if (eq? _ident199476199484_ absent-value)
                  (error '"Missing required keyword argument" 'ident:)
                  _ident199476199484_))
             (_filter199501_
              (if (eq? _filter199477199486_ absent-value)
                  (error '"Missing required keyword argument" 'filter:)
                  _filter199477199486_))
             (_flags199503_
              (if (eq? _flags199478199488_ absent-value)
                  '0
                  _flags199478199488_))
             (_filter-flags199505_
              (if (eq? _filter-flags199479199490_ absent-value)
                  '0
                  _filter-flags199479199490_))
             (_data199507_
              (if (eq? _data199480199492_ absent-value) '0 _data199480199492_))
             (_user-data199509_
              (if (eq? _user-data199481199494_ absent-value)
                  '#f
                  _user-data199481199494_)))
        (std/os/kqueue#ev_set
         _kevts199496_
         _ix199497_
         _ident199499_
         _filter199501_
         _flags199503_
         _filter-flags199505_
         _data199507_
         _user-data199509_))))
  (define std/os/kqueue#kevent-set!__@
    (lambda (_keys199475199514_ . _args199516_)
      (apply std/os/kqueue#kevent-set!__%
             _keys199475199514_
             (table-ref _keys199475199514_ 'ident: absent-value)
             (table-ref _keys199475199514_ 'filter: absent-value)
             (table-ref _keys199475199514_ 'flags: absent-value)
             (table-ref _keys199475199514_ 'filter-flags: absent-value)
             (table-ref _keys199475199514_ 'data: absent-value)
             (table-ref _keys199475199514_ 'user-data: absent-value)
             _args199516_)))
  (define std/os/kqueue#kevent-set!
    (lambda _args199482199522_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                filter:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                data:
                #f
                filter-flags:
                #f
                #f
                flags:
                #f
                #f
                ident:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                user-data:
                #f
                #f
                #f
                #f
                #f
                #f)
             std/os/kqueue#kevent-set!__@
             _args199482199522_)))
  (define std/os/kqueue#kevent
    (lambda (_kqueue199458_
             _change-list199459_
             _nchanges199460_
             _event-list199461_
             _nevents199462_)
      (let _lp199464_ ()
        (let ((_r199468_
               (std/os/kqueue#_kevent
                (std/os/fd#fd-e _kqueue199458_)
                _change-list199459_
                _nchanges199460_
                _event-list199461_
                _nevents199462_
                std/os/kqueue#timespec-zero)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r199468_)))
              _r199468_
              (let ((_errno199471_
                     (let () (declare (not safe)) (##fx- _r199468_))))
                (if '#f
                    '#f
                    (if (eq? _errno199471_ std/os/error#EINTR)
                        (_lp199464_)
                        (std/os/error#raise-os-error
                         _errno199471_
                         std/os/kqueue#kevent
                         _kqueue199458_
                         _change-list199459_
                         _nchanges199460_
                         _event-list199461_
                         _nevents199462_)))))))))
  (define std/os/kqueue#kqueue-poll
    (lambda (_kqueue199454_ _events199455_ _nevents199456_)
      (std/os/kqueue#kevent
       _kqueue199454_
       '#f
       '0
       _events199455_
       _nevents199456_)))
  (define std/os/kqueue#kqueue-kevent-add__%
    (lambda (_kqueue199408_
             _dev199409_
             _filter199410_
             _additional-flags199411_
             _filter-flags199412_
             _data199413_)
      (let ((_kevt199415_ (std/os/kqueue#get-kevent-ptr)))
        (std/os/kqueue#kevent-set!__%
         '#f
         (if (std/os/fd#fd? _dev199409_)
             (std/os/fd#fd-e _dev199409_)
             _dev199409_)
         _filter199410_
         (let ()
           (declare (not safe))
           (##fxior std/os/kqueue#EV_ADD _additional-flags199411_))
         _filter-flags199412_
         _data199413_
         absent-value
         _kevt199415_
         '0)
        (std/os/kqueue#kevent _kqueue199408_ _kevt199415_ '1 '#f '0))))
  (define std/os/kqueue#kqueue-kevent-add__0
    (lambda (_kqueue199420_ _dev199421_ _filter199422_)
      (let* ((_additional-flags199424_ '0)
             (_filter-flags199426_ '0)
             (_data199428_ '0))
        (std/os/kqueue#kqueue-kevent-add__%
         _kqueue199420_
         _dev199421_
         _filter199422_
         _additional-flags199424_
         _filter-flags199426_
         _data199428_))))
  (define std/os/kqueue#kqueue-kevent-add__1
    (lambda (_kqueue199430_
             _dev199431_
             _filter199432_
             _additional-flags199433_)
      (let* ((_filter-flags199435_ '0) (_data199437_ '0))
        (std/os/kqueue#kqueue-kevent-add__%
         _kqueue199430_
         _dev199431_
         _filter199432_
         _additional-flags199433_
         _filter-flags199435_
         _data199437_))))
  (define std/os/kqueue#kqueue-kevent-add__2
    (lambda (_kqueue199439_
             _dev199440_
             _filter199441_
             _additional-flags199442_
             _filter-flags199443_)
      (let ((_data199445_ '0))
        (std/os/kqueue#kqueue-kevent-add__%
         _kqueue199439_
         _dev199440_
         _filter199441_
         _additional-flags199442_
         _filter-flags199443_
         _data199445_))))
  (define std/os/kqueue#kqueue-kevent-add
    (lambda _g301122_
      (let ((_g301121_ (let () (declare (not safe)) (##length _g301122_))))
        (cond ((let () (declare (not safe)) (##fx= _g301121_ 3))
               (apply std/os/kqueue#kqueue-kevent-add__0 _g301122_))
              ((let () (declare (not safe)) (##fx= _g301121_ 4))
               (apply std/os/kqueue#kqueue-kevent-add__1 _g301122_))
              ((let () (declare (not safe)) (##fx= _g301121_ 5))
               (apply std/os/kqueue#kqueue-kevent-add__2 _g301122_))
              ((let () (declare (not safe)) (##fx= _g301121_ 6))
               (apply std/os/kqueue#kqueue-kevent-add__% _g301122_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/kqueue#kqueue-kevent-add
                _g301122_))))))
  (define std/os/kqueue#kqueue-kevent-del
    (lambda (_kqueue199401_ _dev199402_ _filter199403_)
      (let ((_kevt199405_ (std/os/kqueue#get-kevent-ptr)))
        (std/os/kqueue#kevent-set!__%
         '#f
         (if (std/os/fd#fd? _dev199402_)
             (std/os/fd#fd-e _dev199402_)
             _dev199402_)
         _filter199403_
         std/os/kqueue#EV_DELETE
         absent-value
         absent-value
         absent-value
         _kevt199405_
         '0)
        (std/os/kqueue#kevent _kqueue199401_ _kevt199405_ '1 '#f '0))))
  (define std/os/kqueue#kqueue-kevent-disable
    (lambda (_kqueue199395_ _dev199396_ _filter199397_)
      (let ((_kevt199399_ (std/os/kqueue#get-kevent-ptr)))
        (std/os/kqueue#kevent-set!__%
         '#f
         (if (std/os/fd#fd? _dev199396_)
             (std/os/fd#fd-e _dev199396_)
             _dev199396_)
         _filter199397_
         std/os/kqueue#EV_DISABLE
         absent-value
         absent-value
         absent-value
         _kevt199399_
         '0)
        (std/os/kqueue#kevent _kqueue199395_ _kevt199399_ '1 '#f '0))))
  (define std/os/kqueue#kevent-ptr-key 'std/os/kqueue#kevent-ptr)
  (define std/os/kqueue#get-kevent-ptr
    (lambda ()
      (let ((_$e199387_
             (gerbil/gambit/threads#thread-local-get
              std/os/kqueue#kevent-ptr-key)))
        (if _$e199387_
            (values _$e199387_)
            (let ((_kevent-ptr199393_
                   (let ((_r199390_ (std/os/kqueue#make_kevents '1)))
                     (if _r199390_
                         _r199390_
                         (error '"Error allocating memory" 'make_kevents)))))
              (gerbil/gambit/threads#thread-local-set!
               std/os/kqueue#kevent-ptr-key
               _kevent-ptr199393_)
              _kevent-ptr199393_)))))
  (define std/os/kqueue#timespec-zero (std/os/kqueue#make-timespec '0 '0))
  (define std/os/kqueue#make-timespec
    (lambda (_seconds199378_ _nanoseconds199379_)
      (let ((_timespec199384_
             (let ((_r199381_ (std/os/kqueue#make_timespec)))
               (if _r199381_
                   _r199381_
                   (error '"Error allocating memory" 'make_timespec)))))
        (std/os/kqueue#timespec_seconds_set _timespec199384_ _seconds199378_)
        (std/os/kqueue#timespec_nanoseconds_set
         _timespec199384_
         _nanoseconds199379_)
        _timespec199384_)))
  (define std/os/kqueue#kevent-ident std/os/kqueue#kevent_ident)
  (define std/os/kqueue#kevent-filter std/os/kqueue#kevent_filter)
  (define std/os/kqueue#kevent-flags std/os/kqueue#kevent_flags)
  (define std/os/kqueue#kevent-fflags std/os/kqueue#kevent_fflags)
  (define std/os/kqueue#kevent-data std/os/kqueue#kevent_data)
  (define std/os/kqueue#kevent-udata std/os/kqueue#kevent_udata)
  (define std/os/kqueue#set-kevent-ident! std/os/kqueue#kevent_ident_set)
  (define std/os/kqueue#set-kevent-filter! std/os/kqueue#kevent_filter_set)
  (define std/os/kqueue#set-kevent-flags! std/os/kqueue#kevent_flags_set)
  (define std/os/kqueue#set-kevent-fflags! std/os/kqueue#kevent_fflags_set)
  (define std/os/kqueue#set-kevent-data! std/os/kqueue#kevent_data_set)
  (define std/os/kqueue#set-kevent-udata! std/os/kqueue#kevent_udata_set)
  (define-cond-expand-feature darwin)
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace
   ("std/os/kqueue#"
    ev_set
    kevent_udata_set
    kevent_udata
    kevent_data_set
    kevent_data
    kevent_fflags_set
    kevent_fflags
    kevent_flags_set
    kevent_flags
    kevent_filter_set
    kevent_filter
    kevent_ident_set
    kevent_ident
    make_kevents
    __kevent
    __kqueue
    _kevent
    _kqueue
    timespec_nanoseconds_set
    timespec_seconds_set
    make_timespec
    timespec*
    timespec
    kevent*
    NOTE_WRITE
    NOTE_USECONDS
    NOTE_TRUNCATE
    NOTE_TRACKERR
    NOTE_TRACK
    NOTE_SIGNAL
    NOTE_SECONDS
    NOTE_REVOKE
    NOTE_RENAME
    NOTE_REAP
    NOTE_READ
    NOTE_OPEN
    NOTE_OOB
    NOTE_NSECONDS
    NOTE_MSECONDS
    NOTE_MACHTIME
    NOTE_LOWAT
    NOTE_LINK
    NOTE_LEEWAY
    NOTE_FUNLOCK
    NOTE_FORK
    NOTE_FFOR
    NOTE_FFNOP
    NOTE_FFLAGSMASK
    NOTE_FFCTRLMASK
    NOTE_FFCOPY
    NOTE_FFAND
    NOTE_EXTEND
    NOTE_EXITSTATUS
    NOTE_EXIT
    NOTE_EXEC
    NOTE_DELETE
    NOTE_CRITICAL
    NOTE_CLOSE_WRITE
    NOTE_CLOSE
    NOTE_CHANGE
    NOTE_BACKGROUND
    NOTE_ATTRIB
    NOTE_ABSOLUTE
    EV_RECEIPT
    EV_OOBAND
    EV_ONESHOT
    EV_ERROR
    EV_EOF
    EV_ENABLE
    EV_DISPATCH
    EV_DISABLE
    EV_DELETE
    EV_CLEAR
    EV_ADD
    EVFILT_WRITE
    EVFILT_VNODE
    EVFILT_USER
    EVFILT_TIMER
    EVFILT_SIGNAL
    EVFILT_READ
    EVFILT_PROCDESC
    EVFILT_PROC
    EVFILT_MACHPORT
    EVFILT_FS
    EVFILT_EXCEPT
    EVFILT_DEVICE
    EVFILT_AIO))
  (c-declare "#include <sys/types.h>")
  (c-declare "#include <sys/event.h>")
  (c-declare "#include <sys/time.h>")
  (namespace ("std/os/kqueue#" kevent))
  (define-const EV_ADD)
  (define-const EV_ENABLE)
  (define-const EV_DISABLE)
  (define-const EV_DELETE)
  (define-const EV_ONESHOT)
  (define-const EV_CLEAR)
  (define-const EV_EOF)
  (define-const EV_ERROR)
  (cond-expand
   ((or openbsd freebsd) (define-const EV_RECEIPT) (define-const EV_DISPATCH))
   (netbsd)
   (darwin (define-const EV_RECEIPT) (define-const EV_OOBAND)))
  (define-const EVFILT_READ)
  (define-const EVFILT_WRITE)
  (define-const EVFILT_VNODE)
  (define-const EVFILT_PROC)
  (define-const EVFILT_SIGNAL)
  (define-const EVFILT_TIMER)
  (cond-expand
   (openbsd (define-const EVFILT_DEVICE))
   (netbsd (define-const EVFILT_AIO))
   (freebsd (define-const EVFILT_AIO)
            (define-const EVFILT_PROCDESC)
            (define-const EVFILT_USER))
   (darwin (define-const EVFILT_AIO) (define-const EVFILT_MACHPORT)))
  (define-const NOTE_WRITE)
  (define-const NOTE_DELETE)
  (define-const NOTE_EXTEND)
  (define-const NOTE_ATTRIB)
  (define-const NOTE_LINK)
  (define-const NOTE_RENAME)
  (define-const NOTE_REVOKE)
  (define-const NOTE_EXIT)
  (define-const NOTE_FORK)
  (define-const NOTE_EXEC)
  (define-const NOTE_LOWAT)
  (cond-expand
   (openbsd (define-const NOTE_TRUNCATE)
            (define-const NOTE_TRACK)
            (define-const NOTE_TRACKERR)
            (define-const NOTE_CHANGE))
   (netbsd (define-const NOTE_TRACK) (define-const NOTE_TRACKERR))
   (freebsd (define-const NOTE_CLOSE)
            (define-const NOTE_CLOSE_WRITE)
            (define-const NOTE_OPEN)
            (define-const NOTE_READ)
            (define-const NOTE_TRACK)
            (define-const NOTE_SECONDS)
            (define-const NOTE_MSECONDS)
            (define-const NOTE_USECONDS)
            (define-const NOTE_NSECONDS)
            (define-const NOTE_FFNOP)
            (define-const NOTE_FFAND)
            (define-const NOTE_FFOR)
            (define-const NOTE_FFCOPY)
            (define-const NOTE_FFCTRLMASK)
            (define-const NOTE_FFLAGSMASK))
   (darwin (define-const NOTE_EXITSTATUS)
           (define-const NOTE_SIGNAL)
           (define-const NOTE_REAP)
           (define-const NOTE_SECONDS)
           (define-const NOTE_USECONDS)
           (define-const NOTE_NSECONDS)
           (define-const NOTE_ABSOLUTE)
           (define-const NOTE_CRITICAL)
           (define-const NOTE_BACKGROUND)
           (define-const NOTE_LEEWAY)))
  (c-define-type kevent (struct "kevent"))
  (c-define-type kevent* (pointer kevent (kevent*) "ffi_free"))
  (define-guard ffi-have-timespec (c-define-type timespec (struct "timespec")))
  (define-guard
   ffi-have-timespec*
   (c-define-type timespec* (pointer timespec (timespec*) "ffi_free")))
  (define-c-lambda
   make_timespec
   ()
   timespec*
   "___return ((struct timespec*)malloc(sizeof(struct timespec)));")
  (define-c-lambda
   timespec_seconds_set
   (timespec* int)
   void
   "___arg1->tv_sec = ___arg2; ___return ;")
  (define-c-lambda
   timespec_nanoseconds_set
   (timespec* int)
   void
   "___arg1->tv_nsec = ___arg2; ___return ;")
  (define-c-lambda __kqueue () int "kqueue")
  (define-c-lambda
   __kevent
   (int kevent* int kevent* int timespec*)
   int
   "kevent")
  (define-with-errno _kqueue __kqueue ())
  (define-with-errno _kevent __kevent (kqfd chgs nchgs evts nevts timeo))
  (define-c-lambda
   make_kevents
   (int)
   kevent*
   "___return ((struct kevent*)malloc (___arg1 * sizeof (struct kevent)));")
  (define-c-lambda
   kevent_ident
   (kevent* int)
   unsigned-int
   "___return (___arg1[___arg2].ident);")
  (define-c-lambda
   kevent_ident_set
   (kevent* int unsigned-int)
   void
   "___arg1[___arg2].ident = ___arg3; ___return;")
  (define-c-lambda
   kevent_filter
   (kevent* int)
   short
   "___return (___arg1[___arg2].filter);")
  (define-c-lambda
   kevent_filter_set
   (kevent* int short)
   void
   "___arg1[___arg2].filter = ___arg3; ___return;")
  (define-c-lambda
   kevent_flags
   (kevent* int)
   unsigned-short
   "___return (___arg1[___arg2].flags);")
  (define-c-lambda
   kevent_flags_set
   (kevent* int unsigned-short)
   void
   "___arg1[___arg2].flags = ___arg3; ___return;")
  (define-c-lambda
   kevent_fflags
   (kevent* int)
   unsigned-int
   "___return (___arg1[___arg2].fflags);")
  (define-c-lambda
   kevent_fflags_set
   (kevent* int unsigned-int)
   void
   "___arg1[___arg2].fflags = ___arg3; ___return;")
  (define-c-lambda
   kevent_data
   (kevent* int)
   int64
   "___return (___arg1[___arg2].data);")
  (define-c-lambda
   kevent_data_set
   (kevent* int int64)
   void
   "___arg1[___arg2].data = ___arg3; ___return;")
  (define-c-lambda
   kevent_udata
   (kevent* int)
   (pointer void)
   "___return (___arg1[___arg2].udata);")
  (define-c-lambda
   kevent_udata_set
   (kevent* int (pointer void))
   void
   "___arg1[___arg2].udata = ___arg3; ___return;")
  (define-c-lambda
   ev_set
   (kevent* int
            unsigned-int
            short
            unsigned-short
            unsigned-int
            int64
            (pointer void))
   void
   "EV_SET(&___arg1[___arg2], ___arg3, ___arg4, ___arg5, ___arg6, ___arg7, ___arg8); ___return;")
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif"))
