(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/signal-handler#errorf
    (lambda (_fmt199947_ . _args199948_)
      (std/logger#log-message 'signal '0 _fmt199947_ _args199948_)))
  (define std/os/signal-handler#warnf
    (lambda (_fmt199944_ . _args199945_)
      (std/logger#log-message 'signal '1 _fmt199944_ _args199945_)))
  (define std/os/signal-handler#infof
    (lambda (_fmt199941_ . _args199942_)
      (std/logger#log-message 'signal '2 _fmt199941_ _args199942_)))
  (define std/os/signal-handler#debugf
    (lambda (_fmt199938_ . _args199939_)
      (std/logger#log-message 'signal '3 _fmt199938_ _args199939_)))
  (define std/os/signal-handler#verbosef
    (lambda (_fmt199933_ . _args199935_)
      (std/logger#log-message 'signal '4 _fmt199933_ _args199935_)))
  (define std/os/signal-handler#system-signal-handler
    (make-promise
     (lambda ()
       (let ((__obj301123
              (make-object std/os/signal-handler#signal-handler::t '4)))
         (std/os/signal-handler#signal-handler:::init! __obj301123)
         __obj301123))))
  (define std/os/signal-handler#add-signal-handler!
    (lambda (_signo199927_ _thunk199928_)
      (if (and (fx> _signo199927_ '0) (fx< _signo199927_ std/os/signal#SIGMAX))
          '#!void
          (error '"Invalid signal" _signo199927_))
      (let ((_handler199930_
             (force std/os/signal-handler#system-signal-handler)))
        (std/os/signal-handler#signal-handler-add!
         _handler199930_
         _signo199927_
         _thunk199928_))))
  (define std/os/signal-handler#remove-signal-handler!
    (lambda (_signo199923_)
      (if (and (fx> _signo199923_ '0) (fx< _signo199923_ std/os/signal#SIGMAX))
          '#!void
          (error '"Invalid signal" _signo199923_))
      (let ((_handler199925_
             (force std/os/signal-handler#system-signal-handler)))
        (std/os/signal-handler#signal-handler-remove!
         _handler199925_
         _signo199923_))))
  (define std/os/signal-handler#signal-handler::t
    (make-struct-type
     'std/os/signal-handler#signal-handler::t
     '#f
     '4
     'signal-handler
     '((final: . #t))
     ':init!
     '(handlers default-handlers kq mx)))
  (define std/os/signal-handler#signal-handler?
    (make-struct-predicate std/os/signal-handler#signal-handler::t))
  (define std/os/signal-handler#make-signal-handler
    (lambda _$args199920_
      (apply make-struct-instance
             std/os/signal-handler#signal-handler::t
             _$args199920_)))
  (define std/os/signal-handler#signal-handler-handlers
    (make-struct-field-accessor std/os/signal-handler#signal-handler::t '0))
  (define std/os/signal-handler#signal-handler-default-handlers
    (make-struct-field-accessor std/os/signal-handler#signal-handler::t '1))
  (define std/os/signal-handler#signal-handler-kq
    (make-struct-field-accessor std/os/signal-handler#signal-handler::t '2))
  (define std/os/signal-handler#signal-handler-mx
    (make-struct-field-accessor std/os/signal-handler#signal-handler::t '3))
  (define std/os/signal-handler#signal-handler-handlers-set!
    (make-struct-field-mutator std/os/signal-handler#signal-handler::t '0))
  (define std/os/signal-handler#signal-handler-default-handlers-set!
    (make-struct-field-mutator std/os/signal-handler#signal-handler::t '1))
  (define std/os/signal-handler#signal-handler-kq-set!
    (make-struct-field-mutator std/os/signal-handler#signal-handler::t '2))
  (define std/os/signal-handler#signal-handler-mx-set!
    (make-struct-field-mutator std/os/signal-handler#signal-handler::t '3))
  (define std/os/signal-handler#signal-handler:::init!
    (lambda (_self199909_)
      (let* ((_handlers199911_ (make-vector std/os/signal#SIGMAX '#f))
             (_default-handlers199913_ (make-vector std/os/signal#SIGMAX '#f))
             (_kq199915_ (std/os/kqueue#kqueue))
             (_mx199917_ (make-mutex 'signal-handler)))
        (if (let ((__tmp301124
                   (let ()
                     (declare (not safe))
                     (##vector-length _self199909_))))
              (declare (not safe))
              (##fx< '4 __tmp301124))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self199909_ '1 _handlers199911_))
              (let ()
                (declare (not safe))
                (##vector-set! _self199909_ '2 _default-handlers199913_))
              (let ()
                (declare (not safe))
                (##vector-set! _self199909_ '3 _kq199915_))
              (let ()
                (declare (not safe))
                (##vector-set! _self199909_ '4 _mx199917_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self199909_))
        (std/logger#start-logger!__0)
        (gerbil/gambit/threads#spawn/name
         'signal-handler
         std/os/signal-handler#signal-handler-wait
         _self199909_))))
  (bind-method!
   std/os/signal-handler#signal-handler::t
   ':init!
   std/os/signal-handler#signal-handler:::init!
   '#f)
  (define std/os/signal-handler#signal-handler-wait
    (lambda (_sh199679_)
      (with-exception-catcher
       (lambda (_g199680199682_)
         (if '#t
             (let ((_e199685_ _g199680199682_))
               (std/os/signal-handler#errorf
                '"Error handling signals ~a"
                _e199685_)
               (raise _e199685_))
             (raise _g199680199682_)))
       (lambda ()
         (letrec* ((_events199730_ (std/os/kqueue#make-kevents '4)))
           (let* ((_sh199731199740_ _sh199679_)
                  (_E199733199744_
                   (lambda () (error '"No clause matching" _sh199731199740_)))
                  (_K199734199764_
                   (lambda (_mx199747_
                            _kq199748_
                            _default-handlers199749_
                            _handlers199750_)
                     (let _wait-loop199752_ ()
                       (let ((__tmp301125 (std/os/fd#fd-io-in _kq199748_)))
                         (declare (not safe))
                         (##wait-for-io! __tmp301125 '#t))
                       (let ((_n199755_
                              (std/os/kqueue#kqueue-poll
                               _kq199748_
                               _events199730_
                               '4)))
                         (if (let ()
                               (declare (not safe))
                               (##fxpositive? _n199755_))
                             (let _event-loop199757_ ((_i199759_ '0))
                               (if (fx< _i199759_ _n199755_)
                                   (begin
                                     (if (let ((__tmp301126
                                                (let ((__tmp301127
                                                       (std/os/kqueue#kevent-flags
                                                        _events199730_
                                                        _i199759_)))
                                                  (declare (not safe))
                                                  (##fxand __tmp301127
                                                           std/os/kqueue#EV_ERROR))))
                                           (declare (not safe))
                                           (##fxzero? __tmp301126))
                                         (if (fx= (std/os/kqueue#kevent-filter
                                                   _events199730_
                                                   _i199759_)
                                                  std/os/kqueue#EVFILT_SIGNAL)
                                             (let ((_event-handler199762_
                                                    (gerbil/gambit/threads#with-lock
                                                     _mx199747_
                                                     (lambda ()
                                                       (vector-ref
                                                        _handlers199750_
                                                        (std/os/kqueue#kevent-ident
                                                         _events199730_
                                                         _i199759_))))))
                                               (if _event-handler199762_
                                                   (std/os/signal-handler#signal-handler-dispatch
                                                    _event-handler199762_)
                                                   '#!void))
                                             '#!void)
                                         (std/os/error#raise-os-error
                                          (std/os/kqueue#kevent-data
                                           _events199730_
                                           _i199759_)
                                          std/os/signal-handler#signal-handler-wait))
                                     (_event-loop199757_ (fx+ _i199759_ '1)))
                                   '#!void))
                             '#!void))
                       (_wait-loop199752_)))))
             (if (let ()
                   (declare (not safe))
                   (##structure-direct-instance-of?
                    _sh199731199740_
                    'std/os/signal-handler#signal-handler::t))
                 (let* ((_e199735199767_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _sh199731199740_ '1)))
                        (_handlers199770_ _e199735199767_)
                        (_e199736199772_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _sh199731199740_ '2)))
                        (_default-handlers199775_ _e199736199772_)
                        (_e199737199777_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _sh199731199740_ '3)))
                        (_kq199780_ _e199737199777_)
                        (_e199738199782_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _sh199731199740_ '4)))
                        (_mx199785_ _e199738199782_))
                   (_K199734199764_
                    _mx199785_
                    _kq199780_
                    _default-handlers199775_
                    _handlers199770_))
                 (_E199733199744_))))))))
  (define std/os/signal-handler#signal-handler-add!
    (lambda (_sh199629_ _signo199630_ _thunk199631_)
      (let* ((_sh199632199641_ _sh199629_)
             (_E199634199645_
              (lambda () (error '"No clause matching" _sh199632199641_)))
             (_K199635199656_
              (lambda (_mx199648_
                       _kq199649_
                       _default-handlers199650_
                       _handlers199651_)
                (gerbil/gambit/threads#with-lock
                 _mx199648_
                 (lambda ()
                   (let ((_ev199654_ (std/os/kqueue#make-kevents '1)))
                     (vector-set! _handlers199651_ _signo199630_ _thunk199631_)
                     (std/os/kqueue#kqueue-kevent-add__0
                      _kq199649_
                      _signo199630_
                      std/os/kqueue#EVFILT_SIGNAL)
                     (std/os/signal-handler#ignore-signal!
                      _sh199629_
                      _signo199630_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _sh199632199641_
               'std/os/signal-handler#signal-handler::t))
            (let* ((_e199636199659_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199632199641_ '1)))
                   (_handlers199662_ _e199636199659_)
                   (_e199637199664_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199632199641_ '2)))
                   (_default-handlers199667_ _e199637199664_)
                   (_e199638199669_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199632199641_ '3)))
                   (_kq199672_ _e199638199669_)
                   (_e199639199674_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199632199641_ '4)))
                   (_mx199677_ _e199639199674_))
              (_K199635199656_
               _mx199677_
               _kq199672_
               _default-handlers199667_
               _handlers199662_))
            (_E199634199645_)))))
  (define std/os/signal-handler#signal-handler-remove!
    (lambda (_sh199580_ _signo199581_)
      (let* ((_sh199582199591_ _sh199580_)
             (_E199584199595_
              (lambda () (error '"No clause matching" _sh199582199591_)))
             (_K199585199606_
              (lambda (_mx199598_
                       _kq199599_
                       _default-handlers199600_
                       _handlers199601_)
                (gerbil/gambit/threads#with-lock
                 _mx199598_
                 (lambda ()
                   (let ((_ev199604_ (std/os/kqueue#make-kevents '1)))
                     (std/os/signal-handler#restore-signal!
                      _sh199580_
                      _signo199581_)
                     (std/os/kqueue#kqueue-kevent-del
                      _kq199599_
                      _signo199581_
                      std/os/kqueue#EVFILT_SIGNAL)
                     (vector-set! _handlers199601_ _signo199581_ '#f)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _sh199582199591_
               'std/os/signal-handler#signal-handler::t))
            (let* ((_e199586199609_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199582199591_ '1)))
                   (_handlers199612_ _e199586199609_)
                   (_e199587199614_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199582199591_ '2)))
                   (_default-handlers199617_ _e199587199614_)
                   (_e199588199619_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199582199591_ '3)))
                   (_kq199622_ _e199588199619_)
                   (_e199589199624_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199582199591_ '4)))
                   (_mx199627_ _e199589199624_))
              (_K199585199606_
               _mx199627_
               _kq199622_
               _default-handlers199617_
               _handlers199612_))
            (_E199584199595_)))))
  (define std/os/signal-handler#ignore-signal!
    (lambda (_sh199572_ _signo199573_)
      (let* ((_default-handlers199575_
              (##direct-structure-ref
               _sh199572_
               '2
               std/os/signal-handler#signal-handler::t
               '#f))
             (_default-handler199577_
              (std/os/signal-handler#set-signal!
               _signo199573_
               std/os/signal-handler#SIG_IGN)))
        (if (vector-ref _default-handlers199575_ _signo199573_)
            '#!void
            (vector-set!
             _default-handlers199575_
             _signo199573_
             _default-handler199577_)))))
  (define std/os/signal-handler#restore-signal!
    (lambda (_sh199564_ _signo199565_)
      (let* ((_default-handlers199567_
              (##direct-structure-ref
               _sh199564_
               '2
               std/os/signal-handler#signal-handler::t
               '#f))
             (_default-handler199569_
              (vector-ref _default-handlers199567_ _signo199565_)))
        (if (vector-ref _default-handlers199567_ _signo199565_)
            (std/os/signal-handler#set-signal!
             _signo199565_
             _default-handler199569_)
            '#!void))))
  (c-declare "#include <signal.h>")
  (namespace ("std/os/signal-handler#" SIG_IGN set-signal!))
  (define SIG_IGN
    ((c-lambda () (pointer "void") "___return((void *)SIG_IGN);")))
  (define set-signal!
    (c-lambda
     (int (pointer "void"))
     (pointer "void")
     "___return((void*)signal(___arg1, (void (*)(int))(___arg2)));"))
  (define std/os/signal-handler#signal-handler-dispatch
    (lambda (_handler199555_)
      (with-exception-catcher
       (lambda (_g199556199558_)
         (if '#t
             (let ((_e199561_ _g199556199558_))
               (std/os/signal-handler#errorf
                '"error dispatching signal handler: ~a"
                _e199561_))
             (raise _g199556199558_)))
       (lambda () (_handler199555_))))))
