(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/113#sob
    (make-struct-type
     'std/srfi/113#sob
     '#f
     '3
     'sob
     '((fields: hash-table comparator multi?))
     '#f))
  (define std/srfi/113#sob? (make-struct-predicate std/srfi/113#sob))
  (define std/srfi/113#sob-hash-table
    (make-struct-field-accessor std/srfi/113#sob '0))
  (define std/srfi/113#sob-comparator
    (make-struct-field-accessor std/srfi/113#sob '1))
  (define std/srfi/113#sob-multi?
    (make-struct-field-accessor std/srfi/113#sob '2))
  (define std/srfi/113#raw-make-sob
    (lambda (_hash-table94613_ _comparator94614_ _multi?94615_)
      (make-struct-instance
       std/srfi/113#sob
       _hash-table94613_
       _comparator94614_
       _multi?94615_)))
  (define std/srfi/113#set?
    (lambda (_obj94611_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj94611_ 'std/srfi/113#sob))
          (not (##structure-ref _obj94611_ '3 std/srfi/113#sob '#f))
          '#f)))
  (define std/srfi/113#bag?
    (lambda (_obj94609_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj94609_ 'std/srfi/113#sob))
          (##structure-ref _obj94609_ '3 std/srfi/113#sob '#f)
          '#f)))
  (define std/srfi/113#check-set
    (lambda (_obj94607_)
      (if (not (std/srfi/113#set? _obj94607_))
          (error '"not a set" _obj94607_)
          '#!void)))
  (define std/srfi/113#check-bag
    (lambda (_obj94605_)
      (if (not (std/srfi/113#bag? _obj94605_))
          (error '"not a bag" _obj94605_)
          '#!void)))
  (define std/srfi/113#check-all-sets
    (lambda (_list94601_)
      (for-each
       (lambda (_obj94603_) (std/srfi/113#check-set _obj94603_))
       _list94601_)
      (std/srfi/113#sob-check-comparators _list94601_)))
  (define std/srfi/113#check-all-bags
    (lambda (_list94597_)
      (for-each
       (lambda (_obj94599_) (std/srfi/113#check-bag _obj94599_))
       _list94597_)
      (std/srfi/113#sob-check-comparators _list94597_)))
  (define std/srfi/113#sob-check-comparators
    (lambda (_list94593_)
      (if (not (null? _list94593_))
          (for-each
           (lambda (_sob94595_)
             (std/srfi/113#check-same-comparator (car _list94593_) _sob94595_))
           (cdr _list94593_))
          '#!void)))
  (define std/srfi/113#check-same-comparator
    (lambda (_a94590_ _b94591_)
      (if (not (eq? (##structure-ref _a94590_ '2 std/srfi/113#sob '#f)
                    (##structure-ref _b94591_ '2 std/srfi/113#sob '#f)))
          (error '"different comparators" _a94590_ _b94591_)
          '#!void)))
  (define std/srfi/113#check-element
    (lambda (_sob94587_ _element94588_)
      (std/srfi/128#comparator-check-type
       (##structure-ref _sob94587_ '2 std/srfi/113#sob '#f)
       _element94588_)))
  (define std/srfi/113#make-sob
    (lambda (_comparator94584_ _multi?94585_)
      (let ((__tmp295165
             (std/srfi/125#srfi-make-hash-table _comparator94584_)))
        (declare (not safe))
        (##structure
         std/srfi/113#sob
         __tmp295165
         _comparator94584_
         _multi?94585_))))
  (define std/srfi/113#sob-copy
    (lambda (_sob94582_)
      (let ((__tmp295168
             (std/srfi/125#hash-table-copy__0
              (##structure-ref _sob94582_ '1 std/srfi/113#sob '#f)))
            (__tmp295167 (##structure-ref _sob94582_ '2 std/srfi/113#sob '#f))
            (__tmp295166 (##structure-ref _sob94582_ '3 std/srfi/113#sob '#f)))
        (declare (not safe))
        (##structure std/srfi/113#sob __tmp295168 __tmp295167 __tmp295166))))
  (define std/srfi/113#set-copy
    (lambda (_set94580_)
      (std/srfi/113#check-set _set94580_)
      (std/srfi/113#sob-copy _set94580_)))
  (define std/srfi/113#bag-copy
    (lambda (_bag94578_)
      (std/srfi/113#check-bag _bag94578_)
      (std/srfi/113#sob-copy _bag94578_)))
  (define std/srfi/113#sob-empty-copy
    (lambda (_sob94576_)
      (std/srfi/113#make-sob
       (##structure-ref _sob94576_ '2 std/srfi/113#sob '#f)
       (##structure-ref _sob94576_ '3 std/srfi/113#sob '#f))))
  (define std/srfi/113#set
    (lambda (_comparator94569_ . _elements94570_)
      (let ((_result94572_ (std/srfi/113#make-sob _comparator94569_ '#f)))
        (for-each
         (lambda (_x94574_)
           (std/srfi/113#sob-increment! _result94572_ _x94574_ '1))
         _elements94570_)
        _result94572_)))
  (define std/srfi/113#bag
    (lambda (_comparator94562_ . _elements94563_)
      (let ((_result94565_ (std/srfi/113#make-sob _comparator94562_ '#t)))
        (for-each
         (lambda (_x94567_)
           (std/srfi/113#sob-increment! _result94565_ _x94567_ '1))
         _elements94563_)
        _result94565_)))
  (define std/srfi/113#sob-unfold
    (lambda (_stop?94549_
             _mapper94550_
             _successor94551_
             _seed94552_
             _comparator94553_
             _multi?94554_)
      (let ((_result94556_
             (std/srfi/113#make-sob _comparator94553_ _multi?94554_)))
        (let _loop94558_ ((_seed94560_ _seed94552_))
          (if (_stop?94549_ _seed94560_)
              _result94556_
              (begin
                (std/srfi/113#sob-increment!
                 _result94556_
                 (_mapper94550_ _seed94560_)
                 '1)
                (_loop94558_ (_successor94551_ _seed94560_))))))))
  (define std/srfi/113#set-unfold
    (lambda (_continue?94543_
             _mapper94544_
             _successor94545_
             _seed94546_
             _comparator94547_)
      (std/srfi/113#sob-unfold
       _continue?94543_
       _mapper94544_
       _successor94545_
       _seed94546_
       _comparator94547_
       '#f)))
  (define std/srfi/113#bag-unfold
    (lambda (_continue?94537_
             _mapper94538_
             _successor94539_
             _seed94540_
             _comparator94541_)
      (std/srfi/113#sob-unfold
       _continue?94537_
       _mapper94538_
       _successor94539_
       _seed94540_
       _comparator94541_
       '#t)))
  (define std/srfi/113#sob-contains?
    (lambda (_sob94534_ _member94535_)
      (hash-key?
       (##structure-ref _sob94534_ '1 std/srfi/113#sob '#f)
       _member94535_)))
  (define std/srfi/113#set-contains?
    (lambda (_set94531_ _member94532_)
      (std/srfi/113#check-set _set94531_)
      (std/srfi/113#sob-contains? _set94531_ _member94532_)))
  (define std/srfi/113#bag-contains?
    (lambda (_bag94528_ _member94529_)
      (std/srfi/113#check-bag _bag94528_)
      (std/srfi/113#sob-contains? _bag94528_ _member94529_)))
  (define std/srfi/113#sob-empty?
    (lambda (_sob94526_)
      (= '0
         (table-length (##structure-ref _sob94526_ '1 std/srfi/113#sob '#f)))))
  (define std/srfi/113#set-empty?
    (lambda (_set94524_)
      (std/srfi/113#check-set _set94524_)
      (std/srfi/113#sob-empty? _set94524_)))
  (define std/srfi/113#bag-empty?
    (lambda (_bag94522_)
      (std/srfi/113#check-bag _bag94522_)
      (std/srfi/113#sob-empty? _bag94522_)))
  (define std/srfi/113#sob-half-disjoint?
    (lambda (_a94511_ _b94512_)
      (let ((_ha94514_ (##structure-ref _a94511_ '1 std/srfi/113#sob '#f))
            (_hb94515_ (##structure-ref _b94512_ '1 std/srfi/113#sob '#f)))
        (call-with-current-continuation
         (lambda (_return94517_)
           (table-for-each
            (lambda (_key94519_ _val94520_)
              (if (hash-key? _hb94515_ _key94519_)
                  (_return94517_ '#f)
                  '#!void))
            _ha94514_)
           '#t)))))
  (define std/srfi/113#set-disjoint?
    (lambda (_a94508_ _b94509_)
      (std/srfi/113#check-set _a94508_)
      (std/srfi/113#check-set _b94509_)
      (std/srfi/113#check-same-comparator _a94508_ _b94509_)
      (if (std/srfi/113#sob-half-disjoint? _a94508_ _b94509_)
          (std/srfi/113#sob-half-disjoint? _b94509_ _a94508_)
          '#f)))
  (define std/srfi/113#bag-disjoint?
    (lambda (_a94505_ _b94506_)
      (std/srfi/113#check-bag _a94505_)
      (std/srfi/113#check-bag _b94506_)
      (std/srfi/113#check-same-comparator _a94505_ _b94506_)
      (if (std/srfi/113#sob-half-disjoint? _a94505_ _b94506_)
          (std/srfi/113#sob-half-disjoint? _b94506_ _a94505_)
          '#f)))
  (define std/srfi/113#sob-member
    (lambda (_sob94491_ _element94492_ _default94493_)
      (letrec ((_same?94495_
                (lambda (_a94502_ _b94503_)
                  (std/srfi/128#=?
                   (##structure-ref _sob94491_ '2 std/srfi/113#sob '#f)
                   _a94502_
                   _b94503_))))
        (call-with-current-continuation
         (lambda (_return94497_)
           (table-for-each
            (lambda (_key94499_ _val94500_)
              (if (_same?94495_ _key94499_ _element94492_)
                  (_return94497_ _key94499_)
                  '#!void))
            (##structure-ref _sob94491_ '1 std/srfi/113#sob '#f))
           _default94493_)))))
  (define std/srfi/113#set-member
    (lambda (_set94487_ _element94488_ _default94489_)
      (std/srfi/113#check-set _set94487_)
      (std/srfi/113#sob-member _set94487_ _element94488_ _default94489_)))
  (define std/srfi/113#bag-member
    (lambda (_bag94483_ _element94484_ _default94485_)
      (std/srfi/113#check-bag _bag94483_)
      (std/srfi/113#sob-member _bag94483_ _element94484_ _default94485_)))
  (define std/srfi/113#set-element-comparator
    (lambda (_set94481_)
      (std/srfi/113#check-set _set94481_)
      (##structure-ref _set94481_ '2 std/srfi/113#sob '#f)))
  (define std/srfi/113#bag-element-comparator
    (lambda (_bag94479_)
      (std/srfi/113#check-bag _bag94479_)
      (##structure-ref _bag94479_ '2 std/srfi/113#sob '#f)))
  (define std/srfi/113#sob-increment!
    (lambda (_sob94471_ _element94472_ _count94473_)
      (std/srfi/113#check-element _sob94471_ _element94472_)
      (std/srfi/125#hash-table-update!/default
       (##structure-ref _sob94471_ '1 std/srfi/113#sob '#f)
       _element94472_
       (if (##structure-ref _sob94471_ '3 std/srfi/113#sob '#f)
           (lambda (_value94475_) (+ _value94475_ _count94473_))
           (lambda (_value94477_) '1))
       '0)))
  (define std/srfi/113#sob-decrement!
    (lambda (_sob94465_ _element94466_ _count94467_)
      (std/srfi/125#hash-table-update!/default
       (##structure-ref _sob94465_ '1 std/srfi/113#sob '#f)
       _element94466_
       (lambda (_value94469_) (- _value94469_ _count94467_))
       '0)))
  (define std/srfi/113#sob-cleanup!
    (lambda (_sob94459_)
      (let ((_ht94461_ (##structure-ref _sob94459_ '1 std/srfi/113#sob '#f)))
        (for-each
         (lambda (_key94463_) (table-set! _ht94461_ _key94463_))
         (std/srfi/113#nonpositive-keys _ht94461_))
        _sob94459_)))
  (define std/srfi/113#nonpositive-keys
    (lambda (_ht94452_)
      (let ((_result94454_ '()))
        (table-for-each
         (lambda (_key94456_ _value94457_)
           (if (<= _value94457_ '0)
               (set! _result94454_ (cons _key94456_ _result94454_))
               '#!void))
         _ht94452_)
        _result94454_)))
  (define std/srfi/113#bag-increment!
    (lambda (_bag94448_ _element94449_ _count94450_)
      (std/srfi/113#check-bag _bag94448_)
      (std/srfi/113#sob-increment! _bag94448_ _element94449_ _count94450_)
      _bag94448_))
  (define std/srfi/113#bag-decrement!
    (lambda (_bag94444_ _element94445_ _count94446_)
      (std/srfi/113#check-bag _bag94444_)
      (std/srfi/113#sob-decrement! _bag94444_ _element94445_ _count94446_)
      (std/srfi/113#sob-cleanup! _bag94444_)
      _bag94444_))
  (define std/srfi/113#sob-adjoin-all!
    (lambda (_sob94439_ _elements94440_)
      (for-each
       (lambda (_elem94442_)
         (std/srfi/113#sob-increment! _sob94439_ _elem94442_ '1))
       _elements94440_)))
  (define std/srfi/113#set-adjoin!
    (lambda (_set94436_ . _elements94437_)
      (std/srfi/113#check-set _set94436_)
      (std/srfi/113#sob-adjoin-all! _set94436_ _elements94437_)
      _set94436_))
  (define std/srfi/113#bag-adjoin!
    (lambda (_bag94433_ . _elements94434_)
      (std/srfi/113#check-bag _bag94433_)
      (std/srfi/113#sob-adjoin-all! _bag94433_ _elements94434_)
      _bag94433_))
  (define std/srfi/113#set-adjoin
    (lambda (_set94428_ . _elements94429_)
      (std/srfi/113#check-set _set94428_)
      (let ((_result94431_ (std/srfi/113#sob-copy _set94428_)))
        (std/srfi/113#sob-adjoin-all! _result94431_ _elements94429_)
        _result94431_)))
  (define std/srfi/113#bag-adjoin
    (lambda (_bag94423_ . _elements94424_)
      (std/srfi/113#check-bag _bag94423_)
      (let ((_result94426_ (std/srfi/113#sob-copy _bag94423_)))
        (std/srfi/113#sob-adjoin-all! _result94426_ _elements94424_)
        _result94426_)))
  (define std/srfi/113#sob-replace!
    (lambda (_sob94408_ _element94409_)
      (let* ((_comparator94411_
              (##structure-ref _sob94408_ '2 std/srfi/113#sob '#f))
             (_=94413_
              (##direct-structure-ref
               _comparator94411_
               '2
               std/srfi/128#comparator::t
               '#f))
             (_ht94415_ (##structure-ref _sob94408_ '1 std/srfi/113#sob '#f)))
        (std/srfi/128#comparator-check-type _comparator94411_ _element94409_)
        (call-with-current-continuation
         (lambda (_return94418_)
           (table-for-each
            (lambda (_key94420_ _value94421_)
              (if (_=94413_ _key94420_ _element94409_)
                  (begin
                    (table-set! _ht94415_ _key94420_)
                    (table-set! _ht94415_ _element94409_ _value94421_)
                    (_return94418_ _sob94408_))
                  '#!void))
            _ht94415_)
           _sob94408_)))))
  (define std/srfi/113#set-replace!
    (lambda (_set94405_ _element94406_)
      (std/srfi/113#check-set _set94405_)
      (std/srfi/113#sob-replace! _set94405_ _element94406_)
      _set94405_))
  (define std/srfi/113#bag-replace!
    (lambda (_bag94402_ _element94403_)
      (std/srfi/113#check-bag _bag94402_)
      (std/srfi/113#sob-replace! _bag94402_ _element94403_)
      _bag94402_))
  (define std/srfi/113#set-replace
    (lambda (_set94397_ _element94398_)
      (std/srfi/113#check-set _set94397_)
      (let ((_result94400_ (std/srfi/113#sob-copy _set94397_)))
        (std/srfi/113#sob-replace! _result94400_ _element94398_)
        _result94400_)))
  (define std/srfi/113#bag-replace
    (lambda (_bag94392_ _element94393_)
      (std/srfi/113#check-bag _bag94392_)
      (let ((_result94395_ (std/srfi/113#sob-copy _bag94392_)))
        (std/srfi/113#sob-replace! _result94395_ _element94393_)
        _result94395_)))
  (define std/srfi/113#sob-delete-all!
    (lambda (_sob94387_ _elements94388_)
      (for-each
       (lambda (_element94390_)
         (std/srfi/113#sob-decrement! _sob94387_ _element94390_ '1))
       _elements94388_)
      (std/srfi/113#sob-cleanup! _sob94387_)
      _sob94387_))
  (define std/srfi/113#set-delete!
    (lambda (_set94384_ . _elements94385_)
      (std/srfi/113#check-set _set94384_)
      (std/srfi/113#sob-delete-all! _set94384_ _elements94385_)))
  (define std/srfi/113#bag-delete!
    (lambda (_bag94381_ . _elements94382_)
      (std/srfi/113#check-bag _bag94381_)
      (std/srfi/113#sob-delete-all! _bag94381_ _elements94382_)))
  (define std/srfi/113#set-delete-all!
    (lambda (_set94378_ _elements94379_)
      (std/srfi/113#check-set _set94378_)
      (std/srfi/113#sob-delete-all! _set94378_ _elements94379_)))
  (define std/srfi/113#bag-delete-all!
    (lambda (_bag94375_ _elements94376_)
      (std/srfi/113#check-bag _bag94375_)
      (std/srfi/113#sob-delete-all! _bag94375_ _elements94376_)))
  (define std/srfi/113#set-delete
    (lambda (_set94372_ . _elements94373_)
      (std/srfi/113#check-set _set94372_)
      (std/srfi/113#sob-delete-all!
       (std/srfi/113#sob-copy _set94372_)
       _elements94373_)))
  (define std/srfi/113#bag-delete
    (lambda (_bag94369_ . _elements94370_)
      (std/srfi/113#check-bag _bag94369_)
      (std/srfi/113#sob-delete-all!
       (std/srfi/113#sob-copy _bag94369_)
       _elements94370_)))
  (define std/srfi/113#set-delete-all
    (lambda (_set94366_ _elements94367_)
      (std/srfi/113#check-set _set94366_)
      (std/srfi/113#sob-delete-all!
       (std/srfi/113#sob-copy _set94366_)
       _elements94367_)))
  (define std/srfi/113#bag-delete-all
    (lambda (_bag94363_ _elements94364_)
      (std/srfi/113#check-bag _bag94363_)
      (std/srfi/113#sob-delete-all!
       (std/srfi/113#sob-copy _bag94363_)
       _elements94364_)))
  (define std/srfi/113#missing (string-copy '"missing"))
  (define std/srfi/113#sob-search!
    (lambda (_sob94342_ _element94343_ _failure94344_ _success94345_)
      (letrec ((_insert94347_
                (lambda (_obj94361_)
                  (std/srfi/113#sob-increment! _sob94342_ _element94343_ '1)
                  (values _sob94342_ _obj94361_)))
               (_ignore94348_
                (lambda (_obj94359_) (values _sob94342_ _obj94359_)))
               (_update94349_
                (lambda (_new-elem94356_ _obj94357_)
                  (std/srfi/113#sob-decrement! _sob94342_ _element94343_ '1)
                  (std/srfi/113#sob-increment! _sob94342_ _new-elem94356_ '1)
                  (values (std/srfi/113#sob-cleanup! _sob94342_) _obj94357_)))
               (_remove94350_
                (lambda (_obj94354_)
                  (std/srfi/113#sob-decrement! _sob94342_ _element94343_ '1)
                  (values (std/srfi/113#sob-cleanup! _sob94342_) _obj94354_))))
        (let ((_true-element94352_
               (std/srfi/113#sob-member
                _sob94342_
                _element94343_
                std/srfi/113#missing)))
          (if (eq? _true-element94352_ std/srfi/113#missing)
              (_failure94344_ _insert94347_ _ignore94348_)
              (_success94345_
               _true-element94352_
               _update94349_
               _remove94350_))))))
  (define std/srfi/113#set-search!
    (lambda (_set94337_ _element94338_ _failure94339_ _success94340_)
      (std/srfi/113#check-set _set94337_)
      (std/srfi/113#sob-search!
       _set94337_
       _element94338_
       _failure94339_
       _success94340_)))
  (define std/srfi/113#bag-search!
    (lambda (_bag94332_ _element94333_ _failure94334_ _success94335_)
      (std/srfi/113#check-bag _bag94332_)
      (std/srfi/113#sob-search!
       _bag94332_
       _element94333_
       _failure94334_
       _success94335_)))
  (define std/srfi/113#sob-size
    (lambda (_sob94325_)
      (if (##structure-ref _sob94325_ '3 std/srfi/113#sob '#f)
          (let ((_result94327_ '0))
            (table-for-each
             (lambda (_elem94329_ _count94330_)
               (set! _result94327_ (+ _count94330_ _result94327_)))
             (##structure-ref _sob94325_ '1 std/srfi/113#sob '#f))
            _result94327_)
          (table-length
           (##structure-ref _sob94325_ '1 std/srfi/113#sob '#f)))))
  (define std/srfi/113#set-size
    (lambda (_set94323_)
      (std/srfi/113#check-set _set94323_)
      (std/srfi/113#sob-size _set94323_)))
  (define std/srfi/113#bag-size
    (lambda (_bag94321_)
      (std/srfi/113#check-bag _bag94321_)
      (std/srfi/113#sob-size _bag94321_)))
  (define std/srfi/113#sob-find
    (lambda (_pred94312_ _sob94313_ _failure94314_)
      (call-with-current-continuation
       (lambda (_return94316_)
         (table-for-each
          (lambda (_key94318_ _value94319_)
            (if (_pred94312_ _key94318_) (_return94316_ _key94318_) '#!void))
          (##structure-ref _sob94313_ '1 std/srfi/113#sob '#f))
         (_failure94314_)))))
  (define std/srfi/113#set-find
    (lambda (_pred94308_ _set94309_ _failure94310_)
      (std/srfi/113#check-set _set94309_)
      (std/srfi/113#sob-find _pred94308_ _set94309_ _failure94310_)))
  (define std/srfi/113#bag-find
    (lambda (_pred94304_ _bag94305_ _failure94306_)
      (std/srfi/113#check-bag _bag94305_)
      (std/srfi/113#sob-find _pred94304_ _bag94305_ _failure94306_)))
  (define std/srfi/113#sob-count
    (lambda (_pred94298_ _sob94299_)
      (std/srfi/113#sob-fold
       (lambda (_elem94301_ _total94302_)
         (if (_pred94298_ _elem94301_) (+ _total94302_ '1) _total94302_))
       '0
       _sob94299_)))
  (define std/srfi/113#set-count
    (lambda (_pred94295_ _set94296_)
      (std/srfi/113#check-set _set94296_)
      (std/srfi/113#sob-count _pred94295_ _set94296_)))
  (define std/srfi/113#bag-count
    (lambda (_pred94292_ _bag94293_)
      (std/srfi/113#check-bag _bag94293_)
      (std/srfi/113#sob-count _pred94292_ _bag94293_)))
  (define std/srfi/113#sob-any?
    (lambda (_pred94284_ _sob94285_)
      (call-with-current-continuation
       (lambda (_return94287_)
         (table-for-each
          (lambda (_elem94289_ _value94290_)
            (if (_pred94284_ _elem94289_) (_return94287_ '#t) '#!void))
          (##structure-ref _sob94285_ '1 std/srfi/113#sob '#f))
         '#f))))
  (define std/srfi/113#set-any?
    (lambda (_pred94281_ _set94282_)
      (std/srfi/113#check-set _set94282_)
      (std/srfi/113#sob-any? _pred94281_ _set94282_)))
  (define std/srfi/113#bag-any?
    (lambda (_pred94278_ _bag94279_)
      (std/srfi/113#check-bag _bag94279_)
      (std/srfi/113#sob-any? _pred94278_ _bag94279_)))
  (define std/srfi/113#sob-every?
    (lambda (_pred94270_ _sob94271_)
      (call-with-current-continuation
       (lambda (_return94273_)
         (table-for-each
          (lambda (_elem94275_ _value94276_)
            (if (not (_pred94270_ _elem94275_)) (_return94273_ '#f) '#!void))
          (##structure-ref _sob94271_ '1 std/srfi/113#sob '#f))
         '#t))))
  (define std/srfi/113#set-every?
    (lambda (_pred94267_ _set94268_)
      (std/srfi/113#check-set _set94268_)
      (std/srfi/113#sob-every? _pred94267_ _set94268_)))
  (define std/srfi/113#bag-every?
    (lambda (_pred94264_ _bag94265_)
      (std/srfi/113#check-bag _bag94265_)
      (std/srfi/113#sob-every? _pred94264_ _bag94265_)))
  (define std/srfi/113#do-n-times
    (lambda (_cmd94257_ _n94258_)
      (let _loop94260_ ((_n94262_ _n94258_))
        (if (> _n94262_ '0)
            (begin (_cmd94257_) (_loop94260_ (- _n94262_ '1)))
            '#!void))))
  (define std/srfi/113#sob-for-each
    (lambda (_proc94250_ _sob94251_)
      (table-for-each
       (lambda (_key94253_ _value94254_)
         (std/srfi/113#do-n-times
          (lambda () (_proc94250_ _key94253_))
          _value94254_))
       (##structure-ref _sob94251_ '1 std/srfi/113#sob '#f))))
  (define std/srfi/113#set-for-each
    (lambda (_proc94247_ _set94248_)
      (std/srfi/113#check-set _set94248_)
      (std/srfi/113#sob-for-each _proc94247_ _set94248_)))
  (define std/srfi/113#bag-for-each
    (lambda (_proc94244_ _bag94245_)
      (std/srfi/113#check-bag _bag94245_)
      (std/srfi/113#sob-for-each _proc94244_ _bag94245_)))
  (define std/srfi/113#sob-map
    (lambda (_comparator94235_ _proc94236_ _sob94237_)
      (let ((_result94239_
             (std/srfi/113#make-sob
              _comparator94235_
              (##structure-ref _sob94237_ '3 std/srfi/113#sob '#f))))
        (table-for-each
         (lambda (_key94241_ _value94242_)
           (std/srfi/113#sob-increment!
            _result94239_
            (_proc94236_ _key94241_)
            _value94242_))
         (##structure-ref _sob94237_ '1 std/srfi/113#sob '#f))
        _result94239_)))
  (define std/srfi/113#set-map
    (lambda (_comparator94231_ _proc94232_ _set94233_)
      (std/srfi/113#check-set _set94233_)
      (std/srfi/113#sob-map _comparator94231_ _proc94232_ _set94233_)))
  (define std/srfi/113#bag-map
    (lambda (_comparator94227_ _proc94228_ _bag94229_)
      (std/srfi/113#check-bag _bag94229_)
      (std/srfi/113#sob-map _comparator94227_ _proc94228_ _bag94229_)))
  (define std/srfi/113#sob-fold
    (lambda (_proc94219_ _nil94220_ _sob94221_)
      (let ((_result94223_ _nil94220_))
        (std/srfi/113#sob-for-each
         (lambda (_elem94225_)
           (set! _result94223_ (_proc94219_ _elem94225_ _result94223_)))
         _sob94221_)
        _result94223_)))
  (define std/srfi/113#set-fold
    (lambda (_proc94215_ _nil94216_ _set94217_)
      (std/srfi/113#check-set _set94217_)
      (std/srfi/113#sob-fold _proc94215_ _nil94216_ _set94217_)))
  (define std/srfi/113#bag-fold
    (lambda (_proc94211_ _nil94212_ _bag94213_)
      (std/srfi/113#check-bag _bag94213_)
      (std/srfi/113#sob-fold _proc94211_ _nil94212_ _bag94213_)))
  (define std/srfi/113#sob-filter
    (lambda (_pred94203_ _sob94204_)
      (let ((_result94206_ (std/srfi/113#sob-empty-copy _sob94204_)))
        (table-for-each
         (lambda (_key94208_ _value94209_)
           (if (_pred94203_ _key94208_)
               (std/srfi/113#sob-increment!
                _result94206_
                _key94208_
                _value94209_)
               '#!void))
         (##structure-ref _sob94204_ '1 std/srfi/113#sob '#f))
        _result94206_)))
  (define std/srfi/113#set-filter
    (lambda (_pred94200_ _set94201_)
      (std/srfi/113#check-set _set94201_)
      (std/srfi/113#sob-filter _pred94200_ _set94201_)))
  (define std/srfi/113#bag-filter
    (lambda (_pred94197_ _bag94198_)
      (std/srfi/113#check-bag _bag94198_)
      (std/srfi/113#sob-filter _pred94197_ _bag94198_)))
  (define std/srfi/113#set-remove
    (lambda (_pred94192_ _set94193_)
      (std/srfi/113#check-set _set94193_)
      (std/srfi/113#sob-filter
       (lambda (_x94195_) (not (_pred94192_ _x94195_)))
       _set94193_)))
  (define std/srfi/113#bag-remove
    (lambda (_pred94187_ _bag94188_)
      (std/srfi/113#check-bag _bag94188_)
      (std/srfi/113#sob-filter
       (lambda (_x94190_) (not (_pred94187_ _x94190_)))
       _bag94188_)))
  (define std/srfi/113#sob-filter!
    (lambda (_pred94181_ _sob94182_)
      (table-for-each
       (lambda (_key94184_ _value94185_)
         (if (not (_pred94181_ _key94184_))
             (std/srfi/113#sob-decrement! _sob94182_ _key94184_ _value94185_)
             '#!void))
       (##structure-ref _sob94182_ '1 std/srfi/113#sob '#f))
      (std/srfi/113#sob-cleanup! _sob94182_)))
  (define std/srfi/113#set-filter!
    (lambda (_pred94178_ _set94179_)
      (std/srfi/113#check-set _set94179_)
      (std/srfi/113#sob-filter! _pred94178_ _set94179_)))
  (define std/srfi/113#bag-filter!
    (lambda (_pred94175_ _bag94176_)
      (std/srfi/113#check-bag _bag94176_)
      (std/srfi/113#sob-filter! _pred94175_ _bag94176_)))
  (define std/srfi/113#set-remove!
    (lambda (_pred94170_ _set94171_)
      (std/srfi/113#check-set _set94171_)
      (std/srfi/113#sob-filter!
       (lambda (_x94173_) (not (_pred94170_ _x94173_)))
       _set94171_)))
  (define std/srfi/113#bag-remove!
    (lambda (_pred94165_ _bag94166_)
      (std/srfi/113#check-bag _bag94166_)
      (std/srfi/113#sob-filter!
       (lambda (_x94168_) (not (_pred94165_ _x94168_)))
       _bag94166_)))
  (define std/srfi/113#sob-partition
    (lambda (_pred94156_ _sob94157_)
      (let ((_res194159_ (std/srfi/113#sob-empty-copy _sob94157_))
            (_res294160_ (std/srfi/113#sob-empty-copy _sob94157_)))
        (table-for-each
         (lambda (_key94162_ _value94163_)
           (if (_pred94156_ _key94162_)
               (std/srfi/113#sob-increment!
                _res194159_
                _key94162_
                _value94163_)
               (std/srfi/113#sob-increment!
                _res294160_
                _key94162_
                _value94163_)))
         (##structure-ref _sob94157_ '1 std/srfi/113#sob '#f))
        (values _res194159_ _res294160_))))
  (define std/srfi/113#set-partition
    (lambda (_pred94153_ _set94154_)
      (std/srfi/113#check-set _set94154_)
      (std/srfi/113#sob-partition _pred94153_ _set94154_)))
  (define std/srfi/113#bag-partition
    (lambda (_pred94150_ _bag94151_)
      (std/srfi/113#check-bag _bag94151_)
      (std/srfi/113#sob-partition _pred94150_ _bag94151_)))
  (define std/srfi/113#sob-partition!
    (lambda (_pred94142_ _sob94143_)
      (let ((_result94145_ (std/srfi/113#sob-empty-copy _sob94143_)))
        (table-for-each
         (lambda (_key94147_ _value94148_)
           (if (not (_pred94142_ _key94147_))
               (begin
                 (std/srfi/113#sob-decrement!
                  _sob94143_
                  _key94147_
                  _value94148_)
                 (std/srfi/113#sob-increment!
                  _result94145_
                  _key94147_
                  _value94148_))
               '#!void))
         (##structure-ref _sob94143_ '1 std/srfi/113#sob '#f))
        (values (std/srfi/113#sob-cleanup! _sob94143_) _result94145_))))
  (define std/srfi/113#set-partition!
    (lambda (_pred94139_ _set94140_)
      (std/srfi/113#check-set _set94140_)
      (std/srfi/113#sob-partition! _pred94139_ _set94140_)))
  (define std/srfi/113#bag-partition!
    (lambda (_pred94136_ _bag94137_)
      (std/srfi/113#check-bag _bag94137_)
      (std/srfi/113#sob-partition! _pred94136_ _bag94137_)))
  (define std/srfi/113#sob->list
    (lambda (_sob94131_)
      (std/srfi/113#sob-fold
       (lambda (_elem94133_ _list94134_) (cons _elem94133_ _list94134_))
       '()
       _sob94131_)))
  (define std/srfi/113#set->list
    (lambda (_set94129_)
      (std/srfi/113#check-set _set94129_)
      (std/srfi/113#sob->list _set94129_)))
  (define std/srfi/113#bag->list
    (lambda (_bag94127_)
      (std/srfi/113#check-bag _bag94127_)
      (std/srfi/113#sob->list _bag94127_)))
  (define std/srfi/113#list->sob!
    (lambda (_sob94122_ _list94123_)
      (for-each
       (lambda (_elem94125_)
         (std/srfi/113#sob-increment! _sob94122_ _elem94125_ '1))
       _list94123_)
      _sob94122_))
  (define std/srfi/113#list->set
    (lambda (_comparator94119_ _list94120_)
      (std/srfi/113#list->sob!
       (std/srfi/113#make-sob _comparator94119_ '#f)
       _list94120_)))
  (define std/srfi/113#list->bag
    (lambda (_comparator94116_ _list94117_)
      (std/srfi/113#list->sob!
       (std/srfi/113#make-sob _comparator94116_ '#t)
       _list94117_)))
  (define std/srfi/113#list->set!
    (lambda (_set94113_ _list94114_)
      (std/srfi/113#check-set _set94113_)
      (std/srfi/113#list->sob! _set94113_ _list94114_)))
  (define std/srfi/113#list->bag!
    (lambda (_bag94110_ _list94111_)
      (std/srfi/113#check-bag _bag94110_)
      (std/srfi/113#list->sob! _bag94110_ _list94111_)))
  (define std/srfi/113#sob=?__0 (lambda (_sob94101_) '#t))
  (define std/srfi/113#sob=?__2
    (lambda (_sob194106_ _sob294107_ . _sobs94108_)
      (if (std/srfi/113#dyadic-sob=? _sob194106_ _sob294107_)
          (apply std/srfi/113#sob=? _sob294107_ _sobs94108_)
          '#f)))
  (define std/srfi/113#sob=?
    (lambda _g295170_
      (let ((_g295169_ (let () (declare (not safe)) (##length _g295170_))))
        (cond ((let () (declare (not safe)) (##fx= _g295169_ 1))
               (apply std/srfi/113#sob=?__0 _g295170_))
              ((let () (declare (not safe)) (##fx= _g295169_ 2))
               (apply std/srfi/113#dyadic-sob=? _g295170_))
              ((let () (declare (not safe)) (##fx>= _g295169_ 2))
               (apply std/srfi/113#sob=?__2 _g295170_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/113#sob=?
                _g295170_))))))
  (define std/srfi/113#set=?
    (lambda _sets94099_
      (std/srfi/113#check-all-sets _sets94099_)
      (apply std/srfi/113#sob=? _sets94099_)))
  (define std/srfi/113#bag=?
    (lambda _bags94097_
      (std/srfi/113#check-all-bags _bags94097_)
      (apply std/srfi/113#sob=? _bags94097_)))
  (define std/srfi/113#dyadic-sob=?
    (lambda (_sob194086_ _sob294087_)
      (call-with-current-continuation
       (lambda (_return94089_)
         (let ((_ht194091_
                (##structure-ref _sob194086_ '1 std/srfi/113#sob '#f))
               (_ht294092_
                (##structure-ref _sob294087_ '1 std/srfi/113#sob '#f)))
           (if (not (= (table-length _ht194091_) (table-length _ht294092_)))
               (_return94089_ '#f)
               '#!void)
           (table-for-each
            (lambda (_key94094_ _value94095_)
              (if (not (= _value94095_ (table-ref _ht294092_ _key94094_ '0)))
                  (_return94089_ '#f)
                  '#!void))
            _ht194091_))
         '#t))))
  (define std/srfi/113#sob<=?__0 (lambda (_sob94077_) '#t))
  (define std/srfi/113#sob<=?__2
    (lambda (_sob194082_ _sob294083_ . _sobs94084_)
      (if (std/srfi/113#dyadic-sob<=? _sob194082_ _sob294083_)
          (apply std/srfi/113#sob<=? _sob294083_ _sobs94084_)
          '#f)))
  (define std/srfi/113#sob<=?
    (lambda _g295172_
      (let ((_g295171_ (let () (declare (not safe)) (##length _g295172_))))
        (cond ((let () (declare (not safe)) (##fx= _g295171_ 1))
               (apply std/srfi/113#sob<=?__0 _g295172_))
              ((let () (declare (not safe)) (##fx= _g295171_ 2))
               (apply std/srfi/113#dyadic-sob<=? _g295172_))
              ((let () (declare (not safe)) (##fx>= _g295171_ 2))
               (apply std/srfi/113#sob<=?__2 _g295172_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/113#sob<=?
                _g295172_))))))
  (define std/srfi/113#set<=?
    (lambda _sets94075_
      (std/srfi/113#check-all-sets _sets94075_)
      (apply std/srfi/113#sob<=? _sets94075_)))
  (define std/srfi/113#bag<=?
    (lambda _bags94073_
      (std/srfi/113#check-all-bags _bags94073_)
      (apply std/srfi/113#sob<=? _bags94073_)))
  (define std/srfi/113#dyadic-sob<=?
    (lambda (_sob194062_ _sob294063_)
      (call-with-current-continuation
       (lambda (_return94065_)
         (let ((_ht194067_
                (##structure-ref _sob194062_ '1 std/srfi/113#sob '#f))
               (_ht294068_
                (##structure-ref _sob294063_ '1 std/srfi/113#sob '#f)))
           (if (not (<= (table-length _ht194067_) (table-length _ht294068_)))
               (_return94065_ '#f)
               '#!void)
           (table-for-each
            (lambda (_key94070_ _value94071_)
              (if (not (<= _value94071_ (table-ref _ht294068_ _key94070_ '0)))
                  (_return94065_ '#f)
                  '#!void))
            _ht194067_))
         '#t))))
  (define std/srfi/113#sob<?__0 (lambda (_sob94053_) '#t))
  (define std/srfi/113#sob<?__2
    (lambda (_sob194058_ _sob294059_ . _sobs94060_)
      (if (std/srfi/113#dyadic-sob<? _sob194058_ _sob294059_)
          (apply std/srfi/113#sob<? _sob294059_ _sobs94060_)
          '#f)))
  (define std/srfi/113#sob<?
    (lambda _g295174_
      (let ((_g295173_ (let () (declare (not safe)) (##length _g295174_))))
        (cond ((let () (declare (not safe)) (##fx= _g295173_ 1))
               (apply std/srfi/113#sob<?__0 _g295174_))
              ((let () (declare (not safe)) (##fx= _g295173_ 2))
               (apply std/srfi/113#dyadic-sob<? _g295174_))
              ((let () (declare (not safe)) (##fx>= _g295173_ 2))
               (apply std/srfi/113#sob<?__2 _g295174_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/113#sob<?
                _g295174_))))))
  (define std/srfi/113#set<?
    (lambda _sets94051_
      (std/srfi/113#check-all-sets _sets94051_)
      (apply std/srfi/113#sob<? _sets94051_)))
  (define std/srfi/113#bag<?
    (lambda _bags94049_
      (std/srfi/113#check-all-bags _bags94049_)
      (apply std/srfi/113#sob<? _bags94049_)))
  (define std/srfi/113#dyadic-sob<?
    (lambda (_sob194034_ _sob294035_)
      (call-with-current-continuation
       (lambda (_return94037_)
         (let ((_ht194039_
                (##structure-ref _sob194034_ '1 std/srfi/113#sob '#f))
               (_ht294040_
                (##structure-ref _sob294035_ '1 std/srfi/113#sob '#f)))
           (let ((_smaller-count94042_
                  (if (< (table-length _ht194039_) (table-length _ht294040_))
                      '1
                      (if (= (table-length _ht194039_)
                             (table-length _ht294040_))
                          '0
                          (_return94037_ '#f)))))
             (table-for-each
              (lambda (_key94044_ _value94045_)
                (let ((_value294047_ (table-ref _ht294040_ _key94044_ '0)))
                  (if (not (<= _value94045_ _value294047_))
                      (_return94037_ '#f)
                      (if (< _value94045_ _value294047_)
                          (set! _smaller-count94042_
                                (+ _smaller-count94042_ '1))
                          '#!void))))
              _ht194039_)
             (positive? _smaller-count94042_)))))))
  (define std/srfi/113#sob>?__0 (lambda (_sob94025_) '#t))
  (define std/srfi/113#sob>?__2
    (lambda (_sob194030_ _sob294031_ . _sobs94032_)
      (if (std/srfi/113#dyadic-sob>? _sob194030_ _sob294031_)
          (apply std/srfi/113#sob>? _sob294031_ _sobs94032_)
          '#f)))
  (define std/srfi/113#sob>?
    (lambda _g295176_
      (let ((_g295175_ (let () (declare (not safe)) (##length _g295176_))))
        (cond ((let () (declare (not safe)) (##fx= _g295175_ 1))
               (apply std/srfi/113#sob>?__0 _g295176_))
              ((let () (declare (not safe)) (##fx= _g295175_ 2))
               (apply std/srfi/113#dyadic-sob>? _g295176_))
              ((let () (declare (not safe)) (##fx>= _g295175_ 2))
               (apply std/srfi/113#sob>?__2 _g295176_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/113#sob>?
                _g295176_))))))
  (define std/srfi/113#set>?
    (lambda _sets94023_
      (std/srfi/113#check-all-sets _sets94023_)
      (apply std/srfi/113#sob>? _sets94023_)))
  (define std/srfi/113#bag>?
    (lambda _bags94021_
      (std/srfi/113#check-all-bags _bags94021_)
      (apply std/srfi/113#sob>? _bags94021_)))
  (define std/srfi/113#dyadic-sob>?
    (lambda (_sob194018_ _sob294019_)
      (std/srfi/113#dyadic-sob<? _sob294019_ _sob194018_)))
  (define std/srfi/113#sob>=?__0 (lambda (_sob94009_) '#t))
  (define std/srfi/113#sob>=?__2
    (lambda (_sob194014_ _sob294015_ . _sobs94016_)
      (if (std/srfi/113#dyadic-sob>=? _sob194014_ _sob294015_)
          (apply std/srfi/113#sob>=? _sob294015_ _sobs94016_)
          '#f)))
  (define std/srfi/113#sob>=?
    (lambda _g295178_
      (let ((_g295177_ (let () (declare (not safe)) (##length _g295178_))))
        (cond ((let () (declare (not safe)) (##fx= _g295177_ 1))
               (apply std/srfi/113#sob>=?__0 _g295178_))
              ((let () (declare (not safe)) (##fx= _g295177_ 2))
               (apply std/srfi/113#dyadic-sob>=? _g295178_))
              ((let () (declare (not safe)) (##fx>= _g295177_ 2))
               (apply std/srfi/113#sob>=?__2 _g295178_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/113#sob>=?
                _g295178_))))))
  (define std/srfi/113#set>=?
    (lambda _sets94007_
      (std/srfi/113#check-all-sets _sets94007_)
      (apply std/srfi/113#sob>=? _sets94007_)))
  (define std/srfi/113#bag>=?
    (lambda _bags94005_
      (std/srfi/113#check-all-bags _bags94005_)
      (apply std/srfi/113#sob>=? _bags94005_)))
  (define std/srfi/113#dyadic-sob>=?
    (lambda (_sob194002_ _sob294003_)
      (std/srfi/113#dyadic-sob<=? _sob294003_ _sob194002_)))
  (define std/srfi/113#max-one
    (lambda (_n93999_ _multi?94000_)
      (if _multi?94000_ _n93999_ (if (> _n93999_ '1) '1 _n93999_))))
  (define std/srfi/113#sob-union
    (lambda (_sob193992_ . _sobs93993_)
      (if (null? _sobs93993_)
          _sob193992_
          (let ((_result93995_ (std/srfi/113#sob-empty-copy _sob193992_)))
            (std/srfi/113#dyadic-sob-union!
             _result93995_
             _sob193992_
             (car _sobs93993_))
            (for-each
             (lambda (_sob93997_)
               (std/srfi/113#dyadic-sob-union!
                _result93995_
                _result93995_
                _sob93997_))
             (cdr _sobs93993_))
            _result93995_))))
  (define std/srfi/113#dyadic-sob-union!
    (lambda (_result93974_ _sob193975_ _sob293976_)
      (let ((_sob1-ht93978_
             (##structure-ref _sob193975_ '1 std/srfi/113#sob '#f))
            (_sob2-ht93979_
             (##structure-ref _sob293976_ '1 std/srfi/113#sob '#f))
            (_result-ht93980_
             (##structure-ref _result93974_ '1 std/srfi/113#sob '#f)))
        (table-for-each
         (lambda (_key93982_ _value193983_)
           (let ((_value293985_ (table-ref _sob2-ht93979_ _key93982_ '0)))
             (table-set!
              _result-ht93980_
              _key93982_
              (max _value193983_ _value293985_))))
         _sob1-ht93978_)
        (table-for-each
         (lambda (_key93987_ _value293988_)
           (let ((_value193990_ (table-ref _sob1-ht93978_ _key93987_ '0)))
             (if (= _value193990_ '0)
                 (table-set! _result-ht93980_ _key93987_ _value293988_)
                 '#!void)))
         _sob2-ht93979_))))
  (define std/srfi/113#set-union
    (lambda _sets93972_
      (std/srfi/113#check-all-sets _sets93972_)
      (apply std/srfi/113#sob-union _sets93972_)))
  (define std/srfi/113#bag-union
    (lambda _bags93970_
      (std/srfi/113#check-all-bags _bags93970_)
      (apply std/srfi/113#sob-union _bags93970_)))
  (define std/srfi/113#sob-union!
    (lambda (_sob193965_ . _sobs93966_)
      (for-each
       (lambda (_sob93968_)
         (std/srfi/113#dyadic-sob-union! _sob193965_ _sob193965_ _sob93968_))
       _sobs93966_)
      _sob193965_))
  (define std/srfi/113#set-union!
    (lambda _sets93963_
      (std/srfi/113#check-all-sets _sets93963_)
      (apply std/srfi/113#sob-union! _sets93963_)))
  (define std/srfi/113#bag-union!
    (lambda _bags93961_
      (std/srfi/113#check-all-bags _bags93961_)
      (apply std/srfi/113#sob-union! _bags93961_)))
  (define std/srfi/113#sob-intersection
    (lambda (_sob193954_ . _sobs93955_)
      (if (null? _sobs93955_)
          _sob193954_
          (let ((_result93957_ (std/srfi/113#sob-empty-copy _sob193954_)))
            (std/srfi/113#dyadic-sob-intersection!
             _result93957_
             _sob193954_
             (car _sobs93955_))
            (for-each
             (lambda (_sob93959_)
               (std/srfi/113#dyadic-sob-intersection!
                _result93957_
                _result93957_
                _sob93959_))
             (cdr _sobs93955_))
            (std/srfi/113#sob-cleanup! _result93957_)))))
  (define std/srfi/113#dyadic-sob-intersection!
    (lambda (_result93941_ _sob193942_ _sob293943_)
      (let ((_sob1-ht93945_
             (##structure-ref _sob193942_ '1 std/srfi/113#sob '#f))
            (_sob2-ht93946_
             (##structure-ref _sob293943_ '1 std/srfi/113#sob '#f))
            (_result-ht93947_
             (##structure-ref _result93941_ '1 std/srfi/113#sob '#f)))
        (table-for-each
         (lambda (_key93949_ _value193950_)
           (let ((_value293952_ (table-ref _sob2-ht93946_ _key93949_ '0)))
             (table-set!
              _result-ht93947_
              _key93949_
              (min _value193950_ _value293952_))))
         _sob1-ht93945_))))
  (define std/srfi/113#set-intersection
    (lambda _sets93939_
      (std/srfi/113#check-all-sets _sets93939_)
      (apply std/srfi/113#sob-intersection _sets93939_)))
  (define std/srfi/113#bag-intersection
    (lambda _bags93937_
      (std/srfi/113#check-all-bags _bags93937_)
      (apply std/srfi/113#sob-intersection _bags93937_)))
  (define std/srfi/113#sob-intersection!
    (lambda (_sob193932_ . _sobs93933_)
      (for-each
       (lambda (_sob93935_)
         (std/srfi/113#dyadic-sob-intersection!
          _sob193932_
          _sob193932_
          _sob93935_))
       _sobs93933_)
      (std/srfi/113#sob-cleanup! _sob193932_)))
  (define std/srfi/113#set-intersection!
    (lambda _sets93930_
      (std/srfi/113#check-all-sets _sets93930_)
      (apply std/srfi/113#sob-intersection! _sets93930_)))
  (define std/srfi/113#bag-intersection!
    (lambda _bags93928_
      (std/srfi/113#check-all-bags _bags93928_)
      (apply std/srfi/113#sob-intersection! _bags93928_)))
  (define std/srfi/113#sob-difference
    (lambda (_sob193921_ . _sobs93922_)
      (if (null? _sobs93922_)
          _sob193921_
          (let ((_result93924_ (std/srfi/113#sob-empty-copy _sob193921_)))
            (std/srfi/113#dyadic-sob-difference!
             _result93924_
             _sob193921_
             (car _sobs93922_))
            (for-each
             (lambda (_sob93926_)
               (std/srfi/113#dyadic-sob-difference!
                _result93924_
                _result93924_
                _sob93926_))
             (cdr _sobs93922_))
            (std/srfi/113#sob-cleanup! _result93924_)))))
  (define std/srfi/113#dyadic-sob-difference!
    (lambda (_result93908_ _sob193909_ _sob293910_)
      (let ((_sob1-ht93912_
             (##structure-ref _sob193909_ '1 std/srfi/113#sob '#f))
            (_sob2-ht93913_
             (##structure-ref _sob293910_ '1 std/srfi/113#sob '#f))
            (_result-ht93914_
             (##structure-ref _result93908_ '1 std/srfi/113#sob '#f)))
        (table-for-each
         (lambda (_key93916_ _value193917_)
           (let ((_value293919_ (table-ref _sob2-ht93913_ _key93916_ '0)))
             (table-set!
              _result-ht93914_
              _key93916_
              (- _value193917_ _value293919_))))
         _sob1-ht93912_))))
  (define std/srfi/113#set-difference
    (lambda _sets93906_
      (std/srfi/113#check-all-sets _sets93906_)
      (apply std/srfi/113#sob-difference _sets93906_)))
  (define std/srfi/113#bag-difference
    (lambda _bags93904_
      (std/srfi/113#check-all-bags _bags93904_)
      (apply std/srfi/113#sob-difference _bags93904_)))
  (define std/srfi/113#sob-difference!
    (lambda (_sob193899_ . _sobs93900_)
      (for-each
       (lambda (_sob93902_)
         (std/srfi/113#dyadic-sob-difference!
          _sob193899_
          _sob193899_
          _sob93902_))
       _sobs93900_)
      (std/srfi/113#sob-cleanup! _sob193899_)))
  (define std/srfi/113#set-difference!
    (lambda _sets93897_
      (std/srfi/113#check-all-sets _sets93897_)
      (apply std/srfi/113#sob-difference! _sets93897_)))
  (define std/srfi/113#bag-difference!
    (lambda _bags93895_
      (std/srfi/113#check-all-bags _bags93895_)
      (apply std/srfi/113#sob-difference! _bags93895_)))
  (define std/srfi/113#sob-sum
    (lambda (_sob193888_ . _sobs93889_)
      (if (null? _sobs93889_)
          _sob193888_
          (let ((_result93891_ (std/srfi/113#sob-empty-copy _sob193888_)))
            (std/srfi/113#dyadic-sob-sum!
             _result93891_
             _sob193888_
             (car _sobs93889_))
            (for-each
             (lambda (_sob93893_)
               (std/srfi/113#dyadic-sob-sum!
                _result93891_
                _result93891_
                _sob93893_))
             (cdr _sobs93889_))
            _result93891_))))
  (define std/srfi/113#dyadic-sob-sum!
    (lambda (_result93870_ _sob193871_ _sob293872_)
      (let ((_sob1-ht93874_
             (##structure-ref _sob193871_ '1 std/srfi/113#sob '#f))
            (_sob2-ht93875_
             (##structure-ref _sob293872_ '1 std/srfi/113#sob '#f))
            (_result-ht93876_
             (##structure-ref _result93870_ '1 std/srfi/113#sob '#f)))
        (table-for-each
         (lambda (_key93878_ _value193879_)
           (let ((_value293881_ (table-ref _sob2-ht93875_ _key93878_ '0)))
             (table-set!
              _result-ht93876_
              _key93878_
              (+ _value193879_ _value293881_))))
         _sob1-ht93874_)
        (table-for-each
         (lambda (_key93883_ _value293884_)
           (let ((_value193886_ (table-ref _sob1-ht93874_ _key93883_ '0)))
             (if (= _value193886_ '0)
                 (table-set! _result-ht93876_ _key93883_ _value293884_)
                 '#!void)))
         _sob2-ht93875_))))
  (define std/srfi/113#bag-sum
    (lambda _bags93868_
      (std/srfi/113#check-all-bags _bags93868_)
      (apply std/srfi/113#sob-sum _bags93868_)))
  (define std/srfi/113#sob-sum!
    (lambda (_sob193863_ . _sobs93864_)
      (for-each
       (lambda (_sob93866_)
         (std/srfi/113#dyadic-sob-sum! _sob193863_ _sob193863_ _sob93866_))
       _sobs93864_)
      _sob193863_))
  (define std/srfi/113#bag-sum!
    (lambda _bags93861_
      (std/srfi/113#check-all-bags _bags93861_)
      (apply std/srfi/113#sob-sum! _bags93861_)))
  (define std/srfi/113#sob-xor!
    (lambda (_result93843_ _sob193844_ _sob293845_)
      (let ((_sob1-ht93847_
             (##structure-ref _sob193844_ '1 std/srfi/113#sob '#f))
            (_sob2-ht93848_
             (##structure-ref _sob293845_ '1 std/srfi/113#sob '#f))
            (_result-ht93849_
             (##structure-ref _result93843_ '1 std/srfi/113#sob '#f)))
        (table-for-each
         (lambda (_key93851_ _value293852_)
           (let ((_value193854_ (table-ref _sob1-ht93847_ _key93851_ '0)))
             (if (= _value193854_ '0)
                 (table-set! _result-ht93849_ _key93851_ _value293852_)
                 '#!void)))
         _sob2-ht93848_)
        (table-for-each
         (lambda (_key93856_ _value193857_)
           (let ((_value293859_ (table-ref _sob2-ht93848_ _key93856_ '0)))
             (table-set!
              _result-ht93849_
              _key93856_
              (abs (- _value193857_ _value293859_)))))
         _sob1-ht93847_)
        (std/srfi/113#sob-cleanup! _result93843_))))
  (define std/srfi/113#set-xor
    (lambda (_set193840_ _set293841_)
      (std/srfi/113#check-set _set193840_)
      (std/srfi/113#check-set _set293841_)
      (std/srfi/113#check-same-comparator _set193840_ _set293841_)
      (std/srfi/113#sob-xor!
       (std/srfi/113#sob-empty-copy _set193840_)
       _set193840_
       _set293841_)))
  (define std/srfi/113#bag-xor
    (lambda (_bag193837_ _bag293838_)
      (std/srfi/113#check-bag _bag193837_)
      (std/srfi/113#check-bag _bag293838_)
      (std/srfi/113#check-same-comparator _bag193837_ _bag293838_)
      (std/srfi/113#sob-xor!
       (std/srfi/113#sob-empty-copy _bag193837_)
       _bag193837_
       _bag293838_)))
  (define std/srfi/113#set-xor!
    (lambda (_set193834_ _set293835_)
      (std/srfi/113#check-set _set193834_)
      (std/srfi/113#check-set _set293835_)
      (std/srfi/113#check-same-comparator _set193834_ _set293835_)
      (std/srfi/113#sob-xor! _set193834_ _set193834_ _set293835_)))
  (define std/srfi/113#bag-xor!
    (lambda (_bag193831_ _bag293832_)
      (std/srfi/113#check-bag _bag193831_)
      (std/srfi/113#check-bag _bag293832_)
      (std/srfi/113#check-same-comparator _bag193831_ _bag293832_)
      (std/srfi/113#sob-xor! _bag193831_ _bag193831_ _bag293832_)))
  (define std/srfi/113#sob-product!
    (lambda (_n93822_ _result93823_ _sob93824_)
      (let ((_rht93826_
             (##structure-ref _result93823_ '1 std/srfi/113#sob '#f)))
        (table-for-each
         (lambda (_elem93828_ _count93829_)
           (table-set! _rht93826_ _elem93828_ (* _count93829_ _n93822_)))
         (##structure-ref _sob93824_ '1 std/srfi/113#sob '#f))
        _result93823_)))
  (define std/srfi/113#valid-n
    (lambda (_n93820_)
      (if (integer? _n93820_)
          (if (exact? _n93820_) (positive? _n93820_) '#f)
          '#f)))
  (define std/srfi/113#bag-product
    (lambda (_n93817_ _bag93818_)
      (std/srfi/113#check-bag _bag93818_)
      (std/srfi/113#valid-n _n93817_)
      (std/srfi/113#sob-product!
       _n93817_
       (std/srfi/113#sob-empty-copy _bag93818_)
       _bag93818_)))
  (define std/srfi/113#bag-product!
    (lambda (_n93814_ _bag93815_)
      (std/srfi/113#check-bag _bag93815_)
      (std/srfi/113#valid-n _n93814_)
      (std/srfi/113#sob-product! _n93814_ _bag93815_ _bag93815_)))
  (define std/srfi/113#bag-unique-size
    (lambda (_bag93812_)
      (std/srfi/113#check-bag _bag93812_)
      (table-length (##structure-ref _bag93812_ '1 std/srfi/113#sob '#f))))
  (define std/srfi/113#bag-element-count
    (lambda (_bag93809_ _elem93810_)
      (std/srfi/113#check-bag _bag93809_)
      (table-ref
       (##structure-ref _bag93809_ '1 std/srfi/113#sob '#f)
       _elem93810_
       '0)))
  (define std/srfi/113#bag-for-each-unique
    (lambda (_proc93803_ _bag93804_)
      (std/srfi/113#check-bag _bag93804_)
      (table-for-each
       (lambda (_key93806_ _value93807_) (_proc93803_ _key93806_ _value93807_))
       (##structure-ref _bag93804_ '1 std/srfi/113#sob '#f))))
  (define std/srfi/113#bag-fold-unique
    (lambda (_proc93794_ _nil93795_ _bag93796_)
      (std/srfi/113#check-bag _bag93796_)
      (let ((_result93798_ _nil93795_))
        (table-for-each
         (lambda (_elem93800_ _count93801_)
           (set! _result93798_
                 (_proc93794_ _elem93800_ _count93801_ _result93798_)))
         (##structure-ref _bag93796_ '1 std/srfi/113#sob '#f))
        _result93798_)))
  (define std/srfi/113#bag->set
    (lambda (_bag93787_)
      (std/srfi/113#check-bag _bag93787_)
      (let ((_result93789_
             (std/srfi/113#make-sob
              (##structure-ref _bag93787_ '2 std/srfi/113#sob '#f)
              '#f)))
        (table-for-each
         (lambda (_key93791_ _value93792_)
           (std/srfi/113#sob-increment! _result93789_ _key93791_ _value93792_))
         (##structure-ref _bag93787_ '1 std/srfi/113#sob '#f))
        _result93789_)))
  (define std/srfi/113#set->bag
    (lambda (_set93780_)
      (std/srfi/113#check-set _set93780_)
      (let ((_result93782_
             (std/srfi/113#make-sob
              (##structure-ref _set93780_ '2 std/srfi/113#sob '#f)
              '#t)))
        (table-for-each
         (lambda (_key93784_ _value93785_)
           (std/srfi/113#sob-increment! _result93782_ _key93784_ _value93785_))
         (##structure-ref _set93780_ '1 std/srfi/113#sob '#f))
        _result93782_)))
  (define std/srfi/113#set->bag!
    (lambda (_bag93774_ _set93775_)
      (std/srfi/113#check-bag _bag93774_)
      (std/srfi/113#check-set _set93775_)
      (std/srfi/113#check-same-comparator _set93775_ _bag93774_)
      (table-for-each
       (lambda (_key93777_ _value93778_)
         (std/srfi/113#sob-increment! _bag93774_ _key93777_ _value93778_))
       (##structure-ref _set93775_ '1 std/srfi/113#sob '#f))
      _bag93774_))
  (define std/srfi/113#bag->alist
    (lambda (_bag93768_)
      (std/srfi/113#check-bag _bag93768_)
      (std/srfi/113#bag-fold-unique
       (lambda (_elem93770_ _count93771_ _list93772_)
         (cons (cons _elem93770_ _count93771_) _list93772_))
       '()
       _bag93768_)))
  (define std/srfi/113#alist->bag
    (lambda (_comparator93756_ _alist93757_)
      (let* ((_result93759_ (std/srfi/113#bag _comparator93756_))
             (_ht93761_
              (##structure-ref _result93759_ '1 std/srfi/113#sob '#f)))
        (for-each
         (lambda (_assoc93764_)
           (let ((_element93766_ (car _assoc93764_)))
             (if (not (hash-key? _ht93761_ _element93766_))
                 (std/srfi/113#sob-increment!
                  _result93759_
                  _element93766_
                  (cdr _assoc93764_))
                 '#!void)))
         _alist93757_)
        _result93759_)))
  (define std/srfi/113#sob-hash
    (lambda (_sob93746_)
      (let* ((_ht93748_ (##structure-ref _sob93746_ '1 std/srfi/113#sob '#f))
             (_hash93750_
              (std/srfi/128#comparator-hash-function
               (##structure-ref _sob93746_ '2 std/srfi/113#sob '#f))))
        (std/srfi/113#sob-fold
         (lambda (_element93753_ _result93754_)
           (+ (_hash93750_ _element93753_) _result93754_))
         '5381
         _sob93746_))))
  (define std/srfi/113#set-comparator
    (let ()
      (declare (not safe))
      (##structure
       std/srfi/128#comparator::t
       std/srfi/113#set?
       std/srfi/113#set=?
       '#f
       std/srfi/113#sob-hash)))
  (define std/srfi/113#bag-comparator
    (let ()
      (declare (not safe))
      (##structure
       std/srfi/128#comparator::t
       std/srfi/113#bag?
       std/srfi/113#bag=?
       '#f
       std/srfi/113#sob-hash)))
  (std/srfi/128#comparator-register-default! std/srfi/113#set-comparator)
  (std/srfi/128#comparator-register-default! std/srfi/113#bag-comparator)
  (define std/srfi/113#sob-print
    (lambda (_sob93741_ _port93742_)
      (display (if (##structure-ref _sob93741_ '3 std/srfi/113#sob '#f)
                   '"&bag["
                   '"&set[")
               _port93742_)
      (std/srfi/113#sob-for-each
       (lambda (_elem93744_)
         (display '" " _port93742_)
         (write _elem93744_ _port93742_))
       _sob93741_)
      (display '" ]" _port93742_))))
