(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/132#r7rs-vector-copy
    (lambda (_v98745_ _start98746_ _end98747_)
      (subvector _v98745_ _start98746_ _end98747_)))
  (define std/srfi/132#r7rs-vector-copy!__%
    (lambda (_v98715_ _start98716_ _v298717_ _start298718_ _end298719_)
      (subvector-move!
       _v98715_
       _start98716_
       _v298717_
       _start298718_
       _end298719_)))
  (define std/srfi/132#r7rs-vector-copy!__0
    (lambda (_v98724_ _start98725_ _v298726_)
      (let* ((_start298728_ '0) (_end298730_ (vector-length _v298726_)))
        (subvector-move!
         _v98724_
         _start98725_
         _v298726_
         _start298728_
         _end298730_))))
  (define std/srfi/132#r7rs-vector-copy!__1
    (lambda (_v98732_ _start98733_ _v298734_ _start298735_)
      (let ((_end298737_ (vector-length _v298734_)))
        (subvector-move!
         _v98732_
         _start98733_
         _v298734_
         _start298735_
         _end298737_))))
  (define std/srfi/132#r7rs-vector-copy!
    (lambda _g289504_
      (let ((_g289503_ (let () (declare (not safe)) (##length _g289504_))))
        (cond ((let () (declare (not safe)) (##fx= _g289503_ 3))
               (apply std/srfi/132#r7rs-vector-copy!__0 _g289504_))
              ((let () (declare (not safe)) (##fx= _g289503_ 4))
               (apply std/srfi/132#r7rs-vector-copy!__1 _g289504_))
              ((let () (declare (not safe)) (##fx= _g289503_ 5))
               (apply subvector-move! _g289504_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/132#r7rs-vector-copy!
                _g289504_))))))
  (define std/srfi/132#r7rs-vector-fill!
    (lambda (_v98703_ _val98704_ _start98705_ _end98706_)
      (let ((_len98708_ (vector-length _v98703_)))
        (let _lp98710_ ((_i98712_ _start98705_))
          (if (fx< _i98712_ _end98706_)
              (begin
                (vector-set! _v98703_ _i98712_ _val98704_)
                (_lp98710_ (fx+ _i98712_ '1)))
              '#!void)))))
  (define std/srfi/132#list-delete-neighbor-dups
    (lambda (_=98683_ _lis98684_)
      (if (pair? _lis98684_)
          (let* ((_x098686_ (car _lis98684_))
                 (_xs98688_ (cdr _lis98684_))
                 (_ans98700_
                  (let _recur98690_ ((_x098692_ _x098686_)
                                     (_xs98693_ _xs98688_))
                    (if (pair? _xs98693_)
                        (let ((_x198695_ (car _xs98693_))
                              (_x2+98696_ (cdr _xs98693_)))
                          (if (_=98683_ _x098692_ _x198695_)
                              (_recur98690_ _x098692_ _x2+98696_)
                              (let ((_ans-tail98698_
                                     (_recur98690_ _x198695_ _x2+98696_)))
                                (if (eq? _ans-tail98698_ _x2+98696_)
                                    _xs98693_
                                    (cons _x198695_ _ans-tail98698_)))))
                        _xs98693_))))
            (if (eq? _ans98700_ _xs98688_)
                _lis98684_
                (cons _x098686_ _ans98700_)))
          _lis98684_)))
  (define std/srfi/132#list-delete-neighbor-dups!
    (lambda (_=98664_ _lis98665_)
      (if (pair? _lis98665_)
          (let _lp198667_ ((_prev98669_ _lis98665_)
                           (_prev-elt98670_ (car _lis98665_))
                           (_lis98671_ (cdr _lis98665_)))
            (if (pair? _lis98671_)
                (let ((_lis-elt98673_ (car _lis98671_))
                      (_next98674_ (cdr _lis98671_)))
                  (if (_=98664_ _prev-elt98670_ _lis-elt98673_)
                      (let _lp298676_ ((_lis98678_ _next98674_))
                        (if (pair? _lis98678_)
                            (let ((_lis-elt98680_ (car _lis98678_))
                                  (_next98681_ (cdr _lis98678_)))
                              (if (_=98664_ _prev-elt98670_ _lis-elt98680_)
                                  (_lp298676_ _next98681_)
                                  (begin
                                    (set-cdr! _prev98669_ _lis98678_)
                                    (_lp198667_
                                     _lis98678_
                                     _lis-elt98680_
                                     _next98681_))))
                            (set-cdr! _prev98669_ _lis98678_)))
                      (_lp198667_ _lis98671_ _lis-elt98673_ _next98674_)))
                '#!void))
          '#!void)
      _lis98665_))
  (define std/srfi/132#vector-delete-neighbor-dups
    (lambda (_elt=98640_ _v98641_ . _maybe-start+end98642_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98641_ _maybe-start+end98642_))
       (lambda (_start98645_ _end98646_)
         (if (< _start98645_ _end98646_)
             (let* ((_x98648_ (vector-ref _v98641_ _start98645_))
                    (_ans98661_
                     (let _recur98650_ ((_x98652_ _x98648_)
                                        (_i98653_ _start98645_)
                                        (_j98654_ '1))
                       (if (< _i98653_ _end98646_)
                           (let ((_y98656_ (vector-ref _v98641_ _i98653_))
                                 (_nexti98657_ (+ _i98653_ '1)))
                             (if (_elt=98640_ _x98652_ _y98656_)
                                 (_recur98650_ _x98652_ _nexti98657_ _j98654_)
                                 (let ((_ansvec98659_
                                        (_recur98650_
                                         _y98656_
                                         _nexti98657_
                                         (+ _j98654_ '1))))
                                   (vector-set!
                                    _ansvec98659_
                                    _j98654_
                                    _y98656_)
                                   _ansvec98659_)))
                           (make-vector _j98654_)))))
               (vector-set! _ans98661_ '0 _x98648_)
               _ans98661_)
             '#())))))
  (define std/srfi/132#vector-delete-neighbor-dups!
    (lambda (_elt=98608_ _v98609_ . _maybe-start+end98610_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98609_ _maybe-start+end98610_))
       (lambda (_start98613_ _end98614_)
         (if (>= _start98613_ _end98614_)
             _end98614_
             (let _skip98616_ ((_j98618_ _start98613_)
                               (_vj98619_ (vector-ref _v98609_ _start98613_)))
               (let ((_j+198621_ (+ _j98618_ '1)))
                 (if (>= _j+198621_ _end98614_)
                     _end98614_
                     (let ((_vj+198623_ (vector-ref _v98609_ _j+198621_)))
                       (if (not (_elt=98608_ _vj98619_ _vj+198623_))
                           (_skip98616_ _j+198621_ _vj+198623_)
                           (let _lp298625_ ((_j98627_ _j98618_)
                                            (_vj98628_ _vj98619_)
                                            (_k98629_ (+ _j98618_ '2)))
                             (let _lp398631_ ((_k98633_ _k98629_))
                               (if (>= _k98633_ _end98614_)
                                   (+ _j98627_ '1)
                                   (let ((_vk98635_
                                          (vector-ref _v98609_ _k98633_))
                                         (_k+198636_ (+ _k98633_ '1)))
                                     (if (_elt=98608_ _vj98628_ _vk98635_)
                                         (_lp398631_ _k+198636_)
                                         (let ((_j+198638_ (+ _j98627_ '1)))
                                           (vector-set!
                                            _v98609_
                                            _j+198638_
                                            _vk98635_)
                                           (_lp298625_
                                            _j+198638_
                                            _vk98635_
                                            _k+198636_)))))))))))))))))
  (define std/srfi/132#list-merge-sort
    (lambda (_elt<98525_ _lis98526_)
      (letrec ((_getrun98528_
                (lambda (_lis98597_)
                  (let _lp98599_ ((_ans98601_ '())
                                  (_i98602_ '1)
                                  (_prev98603_ (car _lis98597_))
                                  (_xs98604_ (cdr _lis98597_)))
                    (if (pair? _xs98604_)
                        (let ((_x98606_ (car _xs98604_)))
                          (if (_elt<98525_ _x98606_ _prev98603_)
                              (values (_append-reverse98529_
                                       _ans98601_
                                       (cons _prev98603_ '()))
                                      _i98602_
                                      _xs98604_)
                              (_lp98599_
                               (cons _prev98603_ _ans98601_)
                               (+ _i98602_ '1)
                               _x98606_
                               (cdr _xs98604_))))
                        (values (_append-reverse98529_
                                 _ans98601_
                                 (cons _prev98603_ '()))
                                _i98602_
                                _xs98604_)))))
               (_append-reverse98529_
                (lambda (_rev-head98589_ _tail98590_)
                  (let _lp98592_ ((_rev-head98594_ _rev-head98589_)
                                  (_tail98595_ _tail98590_))
                    (if (_null-list?98530_ _rev-head98594_)
                        _tail98595_
                        (_lp98592_
                         (cdr _rev-head98594_)
                         (cons (car _rev-head98594_) _tail98595_))))))
               (_null-list?98530_
                (lambda (_l98587_)
                  (if (pair? _l98587_)
                      '#f
                      (if (null? _l98587_)
                          '#t
                          (error '"argument out of domain" _l98587_)))))
               (_merge98531_
                (lambda (_a98573_ _b98574_)
                  (let _recur98576_ ((_x98578_ (car _a98573_))
                                     (_a98579_ _a98573_)
                                     (_y98580_ (car _b98574_))
                                     (_b98581_ _b98574_))
                    (if (_elt<98525_ _y98580_ _x98578_)
                        (cons _y98580_
                              (let ((_b98583_ (cdr _b98581_)))
                                (if (pair? _b98583_)
                                    (_recur98576_
                                     _x98578_
                                     _a98579_
                                     (car _b98583_)
                                     _b98583_)
                                    _a98579_)))
                        (cons _x98578_
                              (let ((_a98585_ (cdr _a98579_)))
                                (if (pair? _a98585_)
                                    (_recur98576_
                                     (car _a98585_)
                                     _a98585_
                                     _y98580_
                                     _b98581_)
                                    _b98581_)))))))
               (_grow98532_
                (lambda (_s98546_ _ls98547_ _ls298548_ _u98549_ _lw98550_)
                  (if (or (<= _lw98550_ _ls98547_) (not (pair? _u98549_)))
                      (values _s98546_ _ls98547_ _u98549_)
                      (let ((_ls298561_
                             (let _lp98555_ ((_ls298557_ _ls298548_))
                               (let ((_ls2*298559_ (+ _ls298557_ _ls298557_)))
                                 (if (<= _ls2*298559_ _ls98547_)
                                     (_lp98555_ _ls2*298559_)
                                     _ls298557_)))))
                        (call-with-values
                         (lambda () (_getrun98528_ _u98549_))
                         (lambda (_r98564_ _lr98565_ _u298566_)
                           (call-with-values
                            (lambda ()
                              (_grow98532_
                               _r98564_
                               _lr98565_
                               '1
                               _u298566_
                               _ls298561_))
                            (lambda (_t98569_ _lt98570_ _u398571_)
                              (_grow98532_
                               (_merge98531_ _s98546_ _t98569_)
                               (+ _ls98547_ _lt98570_)
                               (+ _ls298561_ _ls298561_)
                               _u398571_
                               _lw98550_))))))))))
        (if (pair? _lis98526_)
            (call-with-values
             (lambda () (_getrun98528_ _lis98526_))
             (lambda (_r98535_ _lr98536_ _tail98537_)
               (let ((_infinity98539_ '16777216))
                 (call-with-values
                  (lambda ()
                    (_grow98532_
                     _r98535_
                     _lr98536_
                     '1
                     _tail98537_
                     _infinity98539_))
                  (lambda (_a98542_ _la98543_ _v98544_) _a98542_)))))
            '()))))
  (define std/srfi/132#list-merge-sort!
    (lambda (_elt<98425_ _lis98426_)
      (letrec ((_getrun98428_
                (lambda (_lis98514_)
                  (let _lp98516_ ((_lis98518_ _lis98514_)
                                  (_x98519_ (car _lis98514_))
                                  (_i98520_ '1)
                                  (_next98521_ (cdr _lis98514_)))
                    (if (pair? _next98521_)
                        (let ((_y98523_ (car _next98521_)))
                          (if (_elt<98425_ _y98523_ _x98519_)
                              (values _i98520_ _lis98518_ _next98521_)
                              (_lp98516_
                               _next98521_
                               _y98523_
                               (+ _i98520_ '1)
                               (cdr _next98521_))))
                        (values _i98520_ _lis98518_ _next98521_)))))
               (_merge!98429_
                (lambda (_a98475_ _enda98476_ _b98477_ _endb98478_)
                  (letrec ((_scan-a98480_
                            (lambda (_prev98484_
                                     _x98485_
                                     _a98486_
                                     _y98487_
                                     _b98488_)
                              (if (_elt<98425_ _y98487_ _x98485_)
                                  (begin
                                    (set-cdr! _prev98484_ _b98488_)
                                    (let ((_next-b98490_ (cdr _b98488_)))
                                      (if (eq? _b98488_ _endb98478_)
                                          (begin
                                            (set-cdr! _b98488_ _a98486_)
                                            _enda98476_)
                                          (_scan-b98481_
                                           _b98488_
                                           _x98485_
                                           _a98486_
                                           (car _next-b98490_)
                                           _next-b98490_))))
                                  (if (eq? _a98486_ _enda98476_)
                                      (begin
                                        (_maybe-set-cdr!98482_
                                         _a98486_
                                         _b98488_)
                                        _endb98478_)
                                      (let ((_next-a98492_ (cdr _a98486_)))
                                        (_scan-a98480_
                                         _a98486_
                                         (car _next-a98492_)
                                         _next-a98492_
                                         _y98487_
                                         _b98488_))))))
                           (_scan-b98481_
                            (lambda (_prev98494_
                                     _x98495_
                                     _a98496_
                                     _y98497_
                                     _b98498_)
                              (if (_elt<98425_ _y98497_ _x98495_)
                                  (if (eq? _b98498_ _endb98478_)
                                      (begin
                                        (set-cdr! _b98498_ _a98496_)
                                        _enda98476_)
                                      (let ((_next-b98500_ (cdr _b98498_)))
                                        (_scan-b98481_
                                         _b98498_
                                         _x98495_
                                         _a98496_
                                         (car _next-b98500_)
                                         _next-b98500_)))
                                  (begin
                                    (set-cdr! _prev98494_ _a98496_)
                                    (if (eq? _a98496_ _enda98476_)
                                        (begin
                                          (_maybe-set-cdr!98482_
                                           _a98496_
                                           _b98498_)
                                          _endb98478_)
                                        (let ((_next-a98502_ (cdr _a98496_)))
                                          (_scan-a98480_
                                           _a98496_
                                           (car _next-a98502_)
                                           _next-a98502_
                                           _y98497_
                                           _b98498_)))))))
                           (_maybe-set-cdr!98482_
                            (lambda (_pair98504_ _val98505_)
                              (if (not (eq? (cdr _pair98504_) _val98505_))
                                  (set-cdr! _pair98504_ _val98505_)
                                  '#!void))))
                    (let ((_x98507_ (car _a98475_)) (_y98508_ (car _b98477_)))
                      (if (_elt<98425_ _y98508_ _x98507_)
                          (values _b98477_
                                  (if (eq? _b98477_ _endb98478_)
                                      (begin
                                        (set-cdr! _b98477_ _a98475_)
                                        _enda98476_)
                                      (let ((_next-b98510_ (cdr _b98477_)))
                                        (_scan-b98481_
                                         _b98477_
                                         _x98507_
                                         _a98475_
                                         (car _next-b98510_)
                                         _next-b98510_))))
                          (values _a98475_
                                  (if (eq? _a98475_ _enda98476_)
                                      (begin
                                        (_maybe-set-cdr!98482_
                                         _a98475_
                                         _b98477_)
                                        _endb98478_)
                                      (let ((_next-a98512_ (cdr _a98475_)))
                                        (_scan-a98480_
                                         _a98475_
                                         (car _next-a98512_)
                                         _next-a98512_
                                         _y98508_
                                         _b98477_)))))))))
               (_grow98430_
                (lambda (_s98445_
                         _ends98446_
                         _ls98447_
                         _ls298448_
                         _u98449_
                         _lw98450_)
                  (if (and (pair? _u98449_) (< _ls98447_ _lw98450_))
                      (let ((_ls298458_
                             (let _lp98452_ ((_ls298454_ _ls298448_))
                               (let ((_ls2*298456_ (+ _ls298454_ _ls298454_)))
                                 (if (<= _ls2*298456_ _ls98447_)
                                     (_lp98452_ _ls2*298456_)
                                     _ls298454_)))))
                        (call-with-values
                         (lambda () (_getrun98428_ _u98449_))
                         (lambda (_lr98461_ _endr98462_ _u298463_)
                           (call-with-values
                            (lambda ()
                              (_grow98430_
                               _u98449_
                               _endr98462_
                               _lr98461_
                               '1
                               _u298463_
                               _ls298458_))
                            (lambda (_t98466_ _endt98467_ _lt98468_ _u398469_)
                              (call-with-values
                               (lambda ()
                                 (_merge!98429_
                                  _s98445_
                                  _ends98446_
                                  _t98466_
                                  _endt98467_))
                               (lambda (_st98472_ _end-st98473_)
                                 (_grow98430_
                                  _st98472_
                                  _end-st98473_
                                  (+ _ls98447_ _lt98468_)
                                  (+ _ls298458_ _ls298458_)
                                  _u398469_
                                  _lw98450_))))))))
                      (values _s98445_ _ends98446_ _ls98447_ _u98449_)))))
        (if (pair? _lis98426_)
            (call-with-values
             (lambda () (_getrun98428_ _lis98426_))
             (lambda (_lr98433_ _endr98434_ _rest98435_)
               (let ((_infinity98437_ '16777216))
                 (call-with-values
                  (lambda ()
                    (_grow98430_
                     _lis98426_
                     _endr98434_
                     _lr98433_
                     '1
                     _rest98435_
                     _infinity98437_))
                  (lambda (_a98440_ _enda98441_ _la98442_ _v98443_)
                    (set-cdr! _enda98441_ '())
                    _a98440_)))))
            '()))))
  (define std/srfi/132#list-merge
    (lambda (_<98410_ _a98411_ _b98412_)
      (if (not (pair? _a98411_))
          _b98412_
          (if (not (pair? _b98412_))
              _a98411_
              (let _recur98414_ ((_x98416_ (car _a98411_))
                                 (_a98417_ _a98411_)
                                 (_y98418_ (car _b98412_))
                                 (_b98419_ _b98412_))
                (if (_<98410_ _y98418_ _x98416_)
                    (let ((_b98421_ (cdr _b98419_)))
                      (if (pair? _b98421_)
                          (cons _y98418_
                                (_recur98414_
                                 _x98416_
                                 _a98417_
                                 (car _b98421_)
                                 _b98421_))
                          (cons _y98418_ _a98417_)))
                    (let ((_a98423_ (cdr _a98417_)))
                      (if (pair? _a98423_)
                          (cons _x98416_
                                (_recur98414_
                                 (car _a98423_)
                                 _a98423_
                                 _y98418_
                                 _b98419_))
                          (cons _x98416_ _b98419_)))))))))
  (define std/srfi/132#list-merge!
    (lambda (_<98379_ _a98380_ _b98381_)
      (letrec ((_scan-a98383_
                (lambda (_prev98386_ _a98387_ _x98388_ _b98389_ _y98390_)
                  (if (_<98379_ _y98390_ _x98388_)
                      (let ((_next-b98392_ (cdr _b98389_)))
                        (set-cdr! _prev98386_ _b98389_)
                        (if (pair? _next-b98392_)
                            (_scan-b98384_
                             _b98389_
                             _a98387_
                             _x98388_
                             _next-b98392_
                             (car _next-b98392_))
                            (set-cdr! _b98389_ _a98387_)))
                      (let ((_next-a98394_ (cdr _a98387_)))
                        (if (pair? _next-a98394_)
                            (_scan-a98383_
                             _a98387_
                             _next-a98394_
                             (car _next-a98394_)
                             _b98389_
                             _y98390_)
                            (set-cdr! _a98387_ _b98389_))))))
               (_scan-b98384_
                (lambda (_prev98396_ _a98397_ _x98398_ _b98399_ _y98400_)
                  (if (_<98379_ _y98400_ _x98398_)
                      (let ((_next-b98402_ (cdr _b98399_)))
                        (if (pair? _next-b98402_)
                            (_scan-b98384_
                             _b98399_
                             _a98397_
                             _x98398_
                             _next-b98402_
                             (car _next-b98402_))
                            (set-cdr! _b98399_ _a98397_)))
                      (let ((_next-a98404_ (cdr _a98397_)))
                        (set-cdr! _prev98396_ _a98397_)
                        (if (pair? _next-a98404_)
                            (_scan-a98383_
                             _a98397_
                             _next-a98404_
                             (car _next-a98404_)
                             _b98399_
                             _y98400_)
                            (set-cdr! _a98397_ _b98399_)))))))
        (if (not (pair? _a98380_))
            _b98381_
            (if (not (pair? _b98381_))
                _a98380_
                (if (_<98379_ (car _b98381_) (car _a98380_))
                    (begin
                      (let ((_next-b98406_ (cdr _b98381_)))
                        (if (null? _next-b98406_)
                            (set-cdr! _b98381_ _a98380_)
                            (_scan-b98384_
                             _b98381_
                             _a98380_
                             (car _a98380_)
                             _next-b98406_
                             (car _next-b98406_))))
                      _b98381_)
                    (begin
                      (let ((_next-a98408_ (cdr _a98380_)))
                        (if (null? _next-a98408_)
                            (set-cdr! _a98380_ _b98381_)
                            (_scan-a98383_
                             _a98380_
                             _next-a98408_
                             (car _next-a98408_)
                             _b98381_
                             (car _b98381_))))
                      _a98380_)))))))
  (define std/srfi/132#list-sorted?
    (lambda (_<98363_ _list98364_)
      (let ((_$e98366_ (not (pair? _list98364_))))
        (if _$e98366_
            _$e98366_
            (let _lp98369_ ((_prev98371_ (car _list98364_))
                            (_tail98372_ (cdr _list98364_)))
              (let ((_$e98374_ (not (pair? _tail98372_))))
                (if _$e98374_
                    _$e98374_
                    (let ((_next98377_ (car _tail98372_)))
                      (if (not (_<98363_ _next98377_ _prev98371_))
                          (_lp98369_ _next98377_ (cdr _tail98372_))
                          '#f)))))))))
  (define std/srfi/132#vector-sorted?
    (lambda (_elt<98342_ _v98343_ . _maybe-start+end98344_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98343_ _maybe-start+end98344_))
       (lambda (_start98347_ _end98348_)
         (let ((_$e98350_ (>= _start98347_ _end98348_)))
           (if _$e98350_
               _$e98350_
               (let _lp98353_ ((_i98355_ (+ _start98347_ '1))
                               (_vi-198356_
                                (vector-ref _v98343_ _start98347_)))
                 (let ((_$e98358_ (>= _i98355_ _end98348_)))
                   (if _$e98358_
                       _$e98358_
                       (let ((_vi98361_ (vector-ref _v98343_ _i98355_)))
                         (if (not (_elt<98342_ _vi98361_ _vi-198356_))
                             (_lp98353_ (+ _i98355_ '1) _vi98361_)
                             '#f)))))))))))
  (define std/srfi/132#vector-portion-copy
    (lambda (_vec98325_ _start98326_ _end98327_)
      (let* ((_len98329_ (vector-length _vec98325_))
             (_new-len98331_ (- _end98327_ _start98326_))
             (_new98333_ (make-vector _new-len98331_)))
        (let _$loop98336_ ((_i98339_ _start98326_) (_j98340_ '0))
          (if (= _i98339_ _end98327_)
              _new98333_
              (begin
                (vector-set!
                 _new98333_
                 _j98340_
                 (vector-ref _vec98325_ _i98339_))
                (_$loop98336_ (+ _i98339_ '1) (+ _j98340_ '1))))))))
  (define std/srfi/132#vector-copy
    (lambda (_vec98323_)
      (std/srfi/132#vector-portion-copy
       _vec98323_
       '0
       (vector-length _vec98323_))))
  (define std/srfi/132#vector-portion-copy!
    (lambda (_target98310_ _src98311_ _start98312_ _end98313_)
      (let ((_len98315_ (- _end98313_ _start98312_)))
        (let _$loop98317_ ((_i98320_ (- _len98315_ '1))
                           (_j98321_ (- _end98313_ '1)))
          (if (< _i98320_ '0)
              '#!void
              (begin
                (vector-set!
                 _target98310_
                 _i98320_
                 (vector-ref _src98311_ _j98321_))
                (_$loop98317_ (- _i98320_ '1) (- _j98321_ '1))))))))
  (define std/srfi/132#has-element
    (lambda (_list98307_ _index98308_)
      (if (zero? _index98308_)
          (if (pair? _list98307_)
              (values '#t (car _list98307_))
              (values '#f '#f))
          (if (null? _list98307_)
              (values '#f '#f)
              (std/srfi/132#has-element
               (cdr _list98307_)
               (- _index98308_ '1))))))
  (define std/srfi/132#list-ref-or-default
    (lambda (_list98299_ _index98300_ _default98301_)
      (call-with-values
       (lambda () (std/srfi/132#has-element _list98299_ _index98300_))
       (lambda (_has?98304_ _maybe98305_)
         (if _has?98304_ _maybe98305_ _default98301_)))))
  (define std/srfi/132#vector-start+end
    (lambda (_vector98293_ _maybe-start+end98294_)
      (let ((_start98296_
             (std/srfi/132#list-ref-or-default _maybe-start+end98294_ '0 '0))
            (_end98297_
             (std/srfi/132#list-ref-or-default
              _maybe-start+end98294_
              '1
              (vector-length _vector98293_))))
        (values _start98296_ _end98297_))))
  (define std/srfi/132#vectors-start+end-2
    (lambda (_vector-198284_ _vector-298285_ _maybe-start+end98286_)
      (let ((_start-198288_
             (std/srfi/132#list-ref-or-default _maybe-start+end98286_ '0 '0))
            (_end-198289_
             (std/srfi/132#list-ref-or-default
              _maybe-start+end98286_
              '1
              (vector-length _vector-198284_)))
            (_start-298290_
             (std/srfi/132#list-ref-or-default _maybe-start+end98286_ '2 '0))
            (_end-298291_
             (std/srfi/132#list-ref-or-default
              _maybe-start+end98286_
              '3
              (vector-length _vector-298285_))))
        (values _start-198288_ _end-198289_ _start-298290_ _end-298291_))))
  (define std/srfi/132#really-vector-heap-sort!
    (lambda (_elt<98234_ _v98235_ _start98236_ _end98237_)
      (letrec ((_restore-heap!98239_
                (lambda (_end98255_ _i98256_)
                  (let* ((_vi98258_ (vector-ref _v98235_ _i98256_))
                         (_first-leaf98260_
                          (quotient (+ _start98236_ _end98255_) '2))
                         (_final-k98281_
                          (let _lp98262_ ((_k98264_ _i98256_))
                            (if (>= _k98264_ _first-leaf98260_)
                                _k98264_
                                (let* ((_k*2-start98266_
                                        (+ _k98264_ (- _k98264_ _start98236_)))
                                       (_child198268_ (+ '1 _k*2-start98266_))
                                       (_child298270_ (+ '2 _k*2-start98266_))
                                       (_child1-val98272_
                                        (vector-ref _v98235_ _child198268_)))
                                  (call-with-values
                                   (lambda ()
                                     (if (< _child298270_ _end98255_)
                                         (let ((_child2-val98276_
                                                (vector-ref
                                                 _v98235_
                                                 _child298270_)))
                                           (if (_elt<98234_
                                                _child2-val98276_
                                                _child1-val98272_)
                                               (values _child198268_
                                                       _child1-val98272_)
                                               (values _child298270_
                                                       _child2-val98276_)))
                                         (values _child198268_
                                                 _child1-val98272_)))
                                   (lambda (_max-child98278_
                                            _max-child-val98279_)
                                     (if (_elt<98234_
                                          _vi98258_
                                          _max-child-val98279_)
                                         (begin
                                           (vector-set!
                                            _v98235_
                                            _k98264_
                                            _max-child-val98279_)
                                           (_lp98262_ _max-child98278_))
                                         _k98264_))))))))
                    (vector-set! _v98235_ _final-k98281_ _vi98258_)))))
        (let ((_first-leaf98241_ (quotient (+ _start98236_ _end98237_) '2)))
          (let _$loop98243_ ((_i98246_ (- _first-leaf98241_ '1)))
            (if (< _i98246_ _start98236_)
                '#!void
                (begin
                  (_restore-heap!98239_ _end98237_ _i98246_)
                  (_$loop98243_ (- _i98246_ '1))))))
        (let _$loop98248_ ((_i98251_ (- _end98237_ '1)))
          (if (<= _i98251_ _start98236_)
              '#!void
              (begin
                (let ((_top98253_ (vector-ref _v98235_ _start98236_)))
                  (vector-set!
                   _v98235_
                   _start98236_
                   (vector-ref _v98235_ _i98251_))
                  (vector-set! _v98235_ _i98251_ _top98253_)
                  (_restore-heap!98239_ _i98251_ _start98236_))
                (_$loop98248_ (- _i98251_ '1))))))))
  (define std/srfi/132#vector-heap-sort!
    (lambda (_elt<98226_ _v98227_ . _maybe-start+end98228_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98227_ _maybe-start+end98228_))
       (lambda (_start98231_ _end98232_)
         (std/srfi/132#really-vector-heap-sort!
          _elt<98226_
          _v98227_
          _start98231_
          _end98232_)))))
  (define std/srfi/132#vector-heap-sort
    (lambda (_elt<98216_ _v98217_ . _maybe-start+end98218_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98217_ _maybe-start+end98218_))
       (lambda (_start98221_ _end98222_)
         (let ((_ans98224_
                (std/srfi/132#vector-portion-copy
                 _v98217_
                 _start98221_
                 _end98222_)))
           (std/srfi/132#really-vector-heap-sort!
            _elt<98216_
            _ans98224_
            '0
            (- _end98222_ _start98221_))
           _ans98224_)))))
  (define std/srfi/132#vector-insert-sort
    (lambda (_elt<98206_ _v98207_ . _maybe-start+end98208_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98207_ _maybe-start+end98208_))
       (lambda (_start98211_ _end98212_)
         (let ((_ans98214_
                (std/srfi/132#vector-portion-copy
                 _v98207_
                 _start98211_
                 _end98212_)))
           (std/srfi/132#%vector-insert-sort!
            _elt<98206_
            _ans98214_
            '0
            (- _end98212_ _start98211_))
           _ans98214_)))))
  (define std/srfi/132#vector-insert-sort!
    (lambda (_<98198_ _v98199_ . _maybe-start+end98200_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98199_ _maybe-start+end98200_))
       (lambda (_start98203_ _end98204_)
         (std/srfi/132#%vector-insert-sort!
          _<98198_
          _v98199_
          _start98203_
          _end98204_)))))
  (define std/srfi/132#%vector-insert-sort!
    (lambda (_elt<98177_ _v98178_ _start98179_ _end98180_)
      (let _$loop98182_ ((_i98185_ (+ '1 _start98179_)))
        (if (>= _i98185_ _end98180_)
            '#!void
            (begin
              (let ((_val98187_ (vector-ref _v98178_ _i98185_)))
                (vector-set!
                 _v98178_
                 (let _lp98189_ ((_j98191_ _i98185_))
                   (if (<= _j98191_ _start98179_)
                       _start98179_
                       (let* ((_j-198193_ (- _j98191_ '1))
                              (_vj-198195_ (vector-ref _v98178_ _j-198193_)))
                         (if (_elt<98177_ _val98187_ _vj-198195_)
                             (begin
                               (vector-set! _v98178_ _j98191_ _vj-198195_)
                               (_lp98189_ _j-198193_))
                             _j98191_))))
                 _val98187_))
              (_$loop98182_ (+ _i98185_ '1)))))))
  (define std/srfi/132#vector-merge
    (lambda (_<98164_ _v198165_ _v298166_ . _maybe-starts+ends98167_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vectors-start+end-2
          _v198165_
          _v298166_
          _maybe-starts+ends98167_))
       (lambda (_start198170_ _end198171_ _start298172_ _end298173_)
         (let ((_ans98175_
                (make-vector
                 (+ (- _end198171_ _start198170_)
                    (- _end298173_ _start298172_)))))
           (std/srfi/132#%vector-merge!
            _<98164_
            _ans98175_
            _v198165_
            _v298166_
            '0
            _start198170_
            _end198171_
            _start298172_
            _end298173_)
           _ans98175_)))))
  (define std/srfi/132#vector-merge!
    (lambda (_<98148_ _v98149_ _v198150_ _v298151_ . _maybe-starts+ends98152_)
      (call-with-values
       (lambda ()
         (if (pair? _maybe-starts+ends98152_)
             (values (car _maybe-starts+ends98152_)
                     (cdr _maybe-starts+ends98152_))
             (values '0 '())))
       (lambda (_start98155_ _rest98156_)
         (call-with-values
          (lambda ()
            (std/srfi/132#vectors-start+end-2 _v198150_ _v298151_ _rest98156_))
          (lambda (_start198159_ _end198160_ _start298161_ _end298162_)
            (std/srfi/132#%vector-merge!
             _<98148_
             _v98149_
             _v198150_
             _v298151_
             _start98155_
             _start198159_
             _end198160_
             _start298161_
             _end298162_)))))))
  (define std/srfi/132#%vector-merge!
    (lambda (_elt<98110_
             _v98111_
             _v198112_
             _v298113_
             _start98114_
             _start198115_
             _end198116_
             _start298117_
             _end298118_)
      (letrec ((_vblit98120_
                (lambda (_fromv98122_ _j98123_ _i98124_ _end98125_)
                  (let _lp98127_ ((_j98129_ _j98123_) (_i98130_ _i98124_))
                    (vector-set!
                     _v98111_
                     _i98130_
                     (vector-ref _fromv98122_ _j98129_))
                    (let ((_j98132_ (+ _j98129_ '1)))
                      (if (< _j98132_ _end98125_)
                          (_lp98127_ _j98132_ (+ _i98130_ '1))
                          '#!void))))))
        (if (<= _end198116_ _start198115_)
            (if (< _start298117_ _end298118_)
                (_vblit98120_ _v298113_ _start298117_ _start98114_ _end298118_)
                '#!void)
            (if (<= _end298118_ _start298117_)
                (_vblit98120_ _v198112_ _start198115_ _start98114_ _end198116_)
                (let _lp98134_ ((_i98136_ _start98114_)
                                (_j98137_ _start198115_)
                                (_x98138_ (vector-ref _v198112_ _start198115_))
                                (_k98139_ _start298117_)
                                (_y98140_
                                 (vector-ref _v298113_ _start298117_)))
                  (let ((_i198142_ (+ _i98136_ '1)))
                    (if (_elt<98110_ _y98140_ _x98138_)
                        (let ((_k98144_ (+ _k98139_ '1)))
                          (vector-set! _v98111_ _i98136_ _y98140_)
                          (if (< _k98144_ _end298118_)
                              (_lp98134_
                               _i198142_
                               _j98137_
                               _x98138_
                               _k98144_
                               (vector-ref _v298113_ _k98144_))
                              (_vblit98120_
                               _v198112_
                               _j98137_
                               _i198142_
                               _end198116_)))
                        (let ((_j98146_ (+ _j98137_ '1)))
                          (vector-set! _v98111_ _i98136_ _x98138_)
                          (if (< _j98146_ _end198116_)
                              (_lp98134_
                               _i198142_
                               _j98146_
                               (vector-ref _v198112_ _j98146_)
                               _k98139_
                               _y98140_)
                              (_vblit98120_
                               _v298113_
                               _k98139_
                               _i198142_
                               _end298118_)))))))))))
  (define std/srfi/132#vector-merge-sort!
    (lambda (_<98100_ _v98101_ . _maybe-args98102_)
      (call-with-values
       (lambda () (std/srfi/132#vector-start+end _v98101_ _maybe-args98102_))
       (lambda (_start98105_ _end98106_)
         (let ((_temp98108_
                (if (and (pair? _maybe-args98102_)
                         (pair? (cdr _maybe-args98102_))
                         (pair? (cddr _maybe-args98102_)))
                    (caddr _maybe-args98102_)
                    (std/srfi/132#vector-copy _v98101_))))
           (std/srfi/132#%vector-merge-sort!
            _<98100_
            _v98101_
            _start98105_
            _end98106_
            _temp98108_))))))
  (define std/srfi/132#vector-merge-sort
    (lambda (_<98090_ _v98091_ . _maybe-args98092_)
      (call-with-values
       (lambda () (std/srfi/132#vector-start+end _v98091_ _maybe-args98092_))
       (lambda (_start98095_ _end98096_)
         (let ((_ans98098_ (subvector _v98091_ _start98095_ _end98096_)))
           (std/srfi/132#vector-merge-sort! _<98090_ _ans98098_)
           _ans98098_)))))
  (define std/srfi/132#%vector-merge-sort!
    (lambda (_elt<97988_ _v097989_ _l97990_ _r97991_ _temp097992_)
      (letrec ((_xor97994_
                (lambda (_a98087_ _b98088_) (not (eq? _a98087_ _b98088_))))
               (_merge97995_
                (lambda (_target98046_
                         _v198047_
                         _v298048_
                         _l98049_
                         _len198050_
                         _len298051_
                         _v2=target?98052_)
                  (letrec ((_vblit98054_
                            (lambda (_fromv98056_ _j98057_ _i98058_ _end98059_)
                              (let _lp98061_ ((_j98063_ _j98057_)
                                              (_i98064_ _i98058_))
                                (vector-set!
                                 _target98046_
                                 _i98064_
                                 (vector-ref _fromv98056_ _j98063_))
                                (let ((_j98066_ (+ _j98063_ '1)))
                                  (if (< _j98066_ _end98059_)
                                      (_lp98061_ _j98066_ (+ _i98064_ '1))
                                      '#!void))))))
                    (let* ((_r198068_ (+ _l98049_ _len198050_))
                           (_r298070_ (+ _r198068_ _len298051_)))
                      (let _lp98073_ ((_n98075_ _l98049_)
                                      (_j98076_ _l98049_)
                                      (_x98077_
                                       (vector-ref _v198047_ _l98049_))
                                      (_k98078_ _r198068_)
                                      (_y98079_
                                       (vector-ref _v298048_ _r198068_)))
                        (let ((_n+198081_ (+ _n98075_ '1)))
                          (if (_elt<97988_ _y98079_ _x98077_)
                              (let ((_k98083_ (+ _k98078_ '1)))
                                (vector-set! _target98046_ _n98075_ _y98079_)
                                (if (< _k98083_ _r298070_)
                                    (_lp98073_
                                     _n+198081_
                                     _j98076_
                                     _x98077_
                                     _k98083_
                                     (vector-ref _v298048_ _k98083_))
                                    (_vblit98054_
                                     _v198047_
                                     _j98076_
                                     _n+198081_
                                     _r198068_)))
                              (let ((_j98085_ (+ _j98076_ '1)))
                                (vector-set! _target98046_ _n98075_ _x98077_)
                                (if (< _j98085_ _r198068_)
                                    (_lp98073_
                                     _n+198081_
                                     _j98085_
                                     (vector-ref _v198047_ _j98085_)
                                     _k98078_
                                     _y98079_)
                                    (if (not _v2=target?98052_)
                                        (_vblit98054_
                                         _v298048_
                                         _k98078_
                                         _n+198081_
                                         _r298070_)
                                        '#!void))))))))))
               (_getrun97996_
                (lambda (_v98035_ _l98036_ _r98037_)
                  (let _lp98039_ ((_i98041_ (+ _l98036_ '1))
                                  (_x98042_ (vector-ref _v98035_ _l98036_)))
                    (if (>= _i98041_ _r98037_)
                        (- _i98041_ _l98036_)
                        (let ((_y98044_ (vector-ref _v98035_ _i98041_)))
                          (if (_elt<97988_ _y98044_ _x98042_)
                              (- _i98041_ _l98036_)
                              (_lp98039_ (+ _i98041_ '1) _y98044_))))))))
        (if (< _l97990_ _r97991_)
            (call-with-values
             (lambda ()
               (let _recur97999_ ((_l98001_ _l97990_)
                                  (_want98002_ (- _r97991_ _l97990_)))
                 (let ((_len98004_ (- _r97991_ _l98001_)))
                   (let _lp98006_ ((_pfxlen98008_
                                    (_getrun97996_
                                     _v097989_
                                     _l98001_
                                     _r97991_))
                                   (_pfxlen298009_ '1)
                                   (_v98010_ _v097989_)
                                   (_temp98011_ _temp097992_)
                                   (_v=v0?98012_ '#t))
                     (if (or (>= _pfxlen98008_ _want98002_)
                             (= _pfxlen98008_ _len98004_))
                         (values _pfxlen98008_ _v98010_ _v=v0?98012_)
                         (let ((_pfxlen298023_
                                (let _lp98017_ ((_j98019_ _pfxlen298009_))
                                  (let ((_j*298021_ (+ _j98019_ _j98019_)))
                                    (if (<= _j98019_ _pfxlen98008_)
                                        (_lp98017_ _j*298021_)
                                        _j98019_))))
                               (_tail-len98024_ (- _len98004_ _pfxlen98008_)))
                           (call-with-values
                            (lambda ()
                              (_recur97999_
                               (+ _pfxlen98008_ _l98001_)
                               _pfxlen298023_))
                            (lambda (_nr-len98027_
                                     _nr-vec98028_
                                     _nrvec=v0?98029_)
                              (_merge97995_
                               _temp98011_
                               _v98010_
                               _nr-vec98028_
                               _l98001_
                               _pfxlen98008_
                               _nr-len98027_
                               (_xor97994_ _nrvec=v0?98029_ _v=v0?98012_))
                              (_lp98006_
                               (+ _pfxlen98008_ _nr-len98027_)
                               (+ _pfxlen298023_ _pfxlen298023_)
                               _temp98011_
                               _v98010_
                               (not _v=v0?98012_))))))))))
             (lambda (_ignored-len98031_
                      _ignored-ansvec98032_
                      _ansvec=v0?98033_)
               (if (not _ansvec=v0?98033_)
                   (subvector-move!
                    _v097989_
                    _l97990_
                    _temp097992_
                    _l97990_
                    _r97991_)
                   '#!void)))
            '#!void))))
  (define std/srfi/132#vector-quick-sort!
    (lambda (_<97980_ _v97981_ . _maybe-start+end97982_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v97981_ _maybe-start+end97982_))
       (lambda (_start97985_ _end97986_)
         (std/srfi/132#%quick-sort!
          _<97980_
          _v97981_
          _start97985_
          _end97986_)))))
  (define std/srfi/132#vector-quick-sort
    (lambda (_<97970_ _v97971_ . _maybe-start+end97972_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v97971_ _maybe-start+end97972_))
       (lambda (_start97975_ _end97976_)
         (let ((_ans97978_ (make-vector (- _end97976_ _start97975_))))
           (std/srfi/132#vector-portion-copy!
            _ans97978_
            _v97971_
            _start97975_
            _end97976_)
           (std/srfi/132#%quick-sort!
            _<97970_
            _ans97978_
            '0
            (- _end97976_ _start97975_))
           _ans97978_)))))
  (define std/srfi/132#%quick-sort!
    (lambda (_elt<97900_ _v97901_ _start97902_ _end97903_)
      (letrec ((_swap97905_
                (lambda (_l97963_ _r97964_ _n97965_)
                  (if (> _n97965_ '0)
                      (let ((_x97967_ (vector-ref _v97901_ _l97963_))
                            (_r-197968_ (- _r97964_ '1)))
                        (vector-set!
                         _v97901_
                         _l97963_
                         (vector-ref _v97901_ _r-197968_))
                        (vector-set! _v97901_ _r-197968_ _x97967_)
                        (_swap97905_
                         (+ _l97963_ '1)
                         _r-197968_
                         (- _n97965_ '1)))
                      '#!void)))
               (_median97906_
                (lambda (_v197955_ _v297956_ _v397957_)
                  (call-with-values
                   (lambda ()
                     (if (_elt<97900_ _v197955_ _v297956_)
                         (values _v197955_ _v297956_)
                         (values _v297956_ _v197955_)))
                   (lambda (_little97960_ _big97961_)
                     (if (_elt<97900_ _big97961_ _v397957_)
                         _big97961_
                         (if (_elt<97900_ _little97960_ _v397957_)
                             _v397957_
                             _little97960_)))))))
        (let _recur97908_ ((_l97910_ _start97902_) (_r97911_ _end97903_))
          (if (< '10 (- _r97911_ _l97910_))
              (let ((_pivot97913_
                     (_median97906_
                      (vector-ref _v97901_ _l97910_)
                      (vector-ref _v97901_ (quotient (+ _l97910_ _r97911_) '2))
                      (vector-ref _v97901_ (- _r97911_ '1)))))
                (letrec ((_lscan97915_
                          (lambda (_i97919_ _j97920_ _k97921_ _m97922_)
                            (let _lp97924_ ((_i97926_ _i97919_)
                                            (_j97927_ _j97920_))
                              (if (> _j97927_ _k97921_)
                                  (_done97917_ _i97926_ _j97927_ _m97922_)
                                  (let ((_x97929_
                                         (vector-ref _v97901_ _j97927_)))
                                    (if (_elt<97900_ _x97929_ _pivot97913_)
                                        (_lp97924_ _i97926_ (+ _j97927_ '1))
                                        (if (_elt<97900_ _pivot97913_ _x97929_)
                                            (_rscan97916_
                                             _i97926_
                                             _j97927_
                                             _k97921_
                                             _m97922_)
                                            (begin
                                              (if (< _i97926_ _j97927_)
                                                  (begin
                                                    (vector-set!
                                                     _v97901_
                                                     _j97927_
                                                     (vector-ref
                                                      _v97901_
                                                      _i97926_))
                                                    (vector-set!
                                                     _v97901_
                                                     _i97926_
                                                     _x97929_))
                                                  '#!void)
                                              (_lp97924_
                                               (+ _i97926_ '1)
                                               (+ _j97927_ '1))))))))))
                         (_rscan97916_
                          (lambda (_i97931_ _j97932_ _k97933_ _m97934_)
                            (let _lp97936_ ((_k97938_ _k97933_)
                                            (_m97939_ _m97934_))
                              (if (<= _k97938_ _j97932_)
                                  (_done97917_ _i97931_ _j97932_ _m97939_)
                                  (let ((_x97941_
                                         (vector-ref _v97901_ _k97938_)))
                                    (if (_elt<97900_ _pivot97913_ _x97941_)
                                        (_lp97936_ (- _k97938_ '1) _m97939_)
                                        (if (_elt<97900_ _x97941_ _pivot97913_)
                                            (begin
                                              (vector-set!
                                               _v97901_
                                               _k97938_
                                               (vector-ref _v97901_ _j97932_))
                                              (vector-set!
                                               _v97901_
                                               _j97932_
                                               _x97941_)
                                              (_lscan97915_
                                               _i97931_
                                               (+ _j97932_ '1)
                                               (- _k97938_ '1)
                                               _m97939_))
                                            (begin
                                              (if (< _k97938_ _m97939_)
                                                  (begin
                                                    (vector-set!
                                                     _v97901_
                                                     _k97938_
                                                     (vector-ref
                                                      _v97901_
                                                      _m97939_))
                                                    (vector-set!
                                                     _v97901_
                                                     _m97939_
                                                     _x97941_))
                                                  '#!void)
                                              (_lp97936_
                                               (- _k97938_ '1)
                                               (- _m97939_ '1))))))))))
                         (_done97917_
                          (lambda (_i97944_ _j97945_ _m97946_)
                            (let ((_num<97948_ (- _j97945_ _i97944_))
                                  (_num>97949_ (+ '1 (- _m97946_ _j97945_)))
                                  (_num=l97950_ (- _i97944_ _l97910_))
                                  (_num=r97951_ (- (- _r97911_ _m97946_) '1)))
                              (_swap97905_
                               _l97910_
                               _j97945_
                               (min _num<97948_ _num=l97950_))
                              (_swap97905_
                               _j97945_
                               _r97911_
                               (min _num>97949_ _num=r97951_))
                              (if (<= _num<97948_ _num>97949_)
                                  (begin
                                    (_recur97908_
                                     _l97910_
                                     (+ _l97910_ _num<97948_))
                                    (_recur97908_
                                     (- _r97911_ _num>97949_)
                                     _r97911_))
                                  (begin
                                    (_recur97908_
                                     (- _r97911_ _num>97949_)
                                     _r97911_)
                                    (_recur97908_
                                     _l97910_
                                     (+ _l97910_ _num<97948_))))))))
                  (let ((_r-197953_ (- _r97911_ '1)))
                    (_lscan97915_ _l97910_ _l97910_ _r-197953_ _r-197953_))))
              (std/srfi/132#%vector-insert-sort!
               _elt<97900_
               _v97901_
               _l97910_
               _r97911_))))))
  (define std/srfi/132#vector-quick-sort3!
    (lambda (_c97892_ _v97893_ . _maybe-start+end97894_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v97893_ _maybe-start+end97894_))
       (lambda (_start97897_ _end97898_)
         (std/srfi/132#%quick-sort3!
          _c97892_
          _v97893_
          _start97897_
          _end97898_)))))
  (define std/srfi/132#vector-quick-sort3
    (lambda (_c97882_ _v97883_ . _maybe-start+end97884_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v97883_ _maybe-start+end97884_))
       (lambda (_start97887_ _end97888_)
         (let ((_ans97890_ (make-vector (- _end97888_ _start97887_))))
           (std/srfi/132#vector-portion-copy!
            _ans97890_
            _v97883_
            _start97887_
            _end97888_)
           (std/srfi/132#%quick-sort3!
            _c97882_
            _ans97890_
            '0
            (- _end97888_ _start97887_))
           _ans97890_)))))
  (define std/srfi/132#%quick-sort3!
    (lambda (_c97791_ _v97792_ _start97793_ _end97794_)
      (letrec ((_swap97796_
                (lambda (_l97875_ _r97876_ _n97877_)
                  (if (> _n97877_ '0)
                      (let ((_x97879_ (vector-ref _v97792_ _l97875_))
                            (_r-197880_ (- _r97876_ '1)))
                        (vector-set!
                         _v97792_
                         _l97875_
                         (vector-ref _v97792_ _r-197880_))
                        (vector-set! _v97792_ _r-197880_ _x97879_)
                        (_swap97796_
                         (+ _l97875_ '1)
                         _r-197880_
                         (- _n97877_ '1)))
                      '#!void)))
               (_sort397797_
                (lambda (_v197867_ _v297868_ _v397869_)
                  (call-with-values
                   (lambda ()
                     (if (< (_c97791_ _v197867_ _v297868_) '0)
                         (values _v197867_ _v297868_)
                         (values _v297868_ _v197867_)))
                   (lambda (_little97872_ _big97873_)
                     (if (< (_c97791_ _big97873_ _v397869_) '0)
                         (values _little97872_ _big97873_ _v397869_)
                         (if (< (_c97791_ _little97872_ _v397869_) '0)
                             (values _little97872_ _v397869_ _big97873_)
                             (values _v397869_ _little97872_ _big97873_)))))))
               (_elt<97798_
                (lambda (_v197864_ _v297865_)
                  (negative? (_c97791_ _v197864_ _v297865_)))))
        (let _recur97800_ ((_l97802_ _start97793_) (_r97803_ _end97794_))
          (if (< '10 (- _r97803_ _l97802_))
              (let* ((_r-197805_ (- _r97803_ '1))
                     (_mid97807_ (quotient (+ _l97802_ _r97803_) '2))
                     (_l+197809_ (+ _l97802_ '1))
                     (_pivot97818_
                      (call-with-values
                       (lambda ()
                         (_sort397797_
                          (vector-ref _v97792_ _l97802_)
                          (vector-ref _v97792_ _mid97807_)
                          (vector-ref _v97792_ _r-197805_)))
                       (lambda (_lo97812_ _piv97813_ _hi97814_)
                         (let ((_tmp97816_ (vector-ref _v97792_ _l+197809_)))
                           (vector-set! _v97792_ _l97802_ _piv97813_)
                           (vector-set! _v97792_ _r-197805_ _hi97814_)
                           (vector-set! _v97792_ _l+197809_ _lo97812_)
                           (vector-set! _v97792_ _mid97807_ _tmp97816_)
                           _piv97813_)))))
                (letrec ((_lscan97821_
                          (lambda (_i97825_ _j97826_ _k97827_ _m97828_)
                            (let _lp97830_ ((_i97832_ _i97825_)
                                            (_j97833_ _j97826_))
                              (if (> _j97833_ _k97827_)
                                  (_done97823_ _i97832_ _j97833_ _m97828_)
                                  (let* ((_x97835_
                                          (vector-ref _v97792_ _j97833_))
                                         (_sign97837_
                                          (_c97791_ _x97835_ _pivot97818_)))
                                    (if (< _sign97837_ '0)
                                        (_lp97830_ _i97832_ (+ _j97833_ '1))
                                        (if (= _sign97837_ '0)
                                            (begin
                                              (if (< _i97832_ _j97833_)
                                                  (begin
                                                    (vector-set!
                                                     _v97792_
                                                     _j97833_
                                                     (vector-ref
                                                      _v97792_
                                                      _i97832_))
                                                    (vector-set!
                                                     _v97792_
                                                     _i97832_
                                                     _x97835_))
                                                  '#!void)
                                              (_lp97830_
                                               (+ _i97832_ '1)
                                               (+ _j97833_ '1)))
                                            (if (> _sign97837_ '0)
                                                (_rscan97822_
                                                 _i97832_
                                                 _j97833_
                                                 _k97827_
                                                 _m97828_)
                                                '#!void))))))))
                         (_rscan97822_
                          (lambda (_i97840_ _j97841_ _k97842_ _m97843_)
                            (let _lp97845_ ((_k97847_ _k97842_)
                                            (_m97848_ _m97843_))
                              (if (<= _k97847_ _j97841_)
                                  (_done97823_ _i97840_ _j97841_ _m97848_)
                                  (let* ((_x97850_
                                          (vector-ref _v97792_ _k97847_))
                                         (_sign97852_
                                          (_c97791_ _x97850_ _pivot97818_)))
                                    (if (> _sign97852_ '0)
                                        (_lp97845_ (- _k97847_ '1) _m97848_)
                                        (if (= _sign97852_ '0)
                                            (begin
                                              (if (< _k97847_ _m97848_)
                                                  (begin
                                                    (vector-set!
                                                     _v97792_
                                                     _k97847_
                                                     (vector-ref
                                                      _v97792_
                                                      _m97848_))
                                                    (vector-set!
                                                     _v97792_
                                                     _m97848_
                                                     _x97850_))
                                                  '#!void)
                                              (_lp97845_
                                               (- _k97847_ '1)
                                               (- _m97848_ '1)))
                                            (if (< _sign97852_ '0)
                                                (begin
                                                  (vector-set!
                                                   _v97792_
                                                   _k97847_
                                                   (vector-ref
                                                    _v97792_
                                                    _j97841_))
                                                  (vector-set!
                                                   _v97792_
                                                   _j97841_
                                                   _x97850_)
                                                  (_lscan97821_
                                                   _i97840_
                                                   (+ _j97841_ '1)
                                                   (- _k97847_ '1)
                                                   _m97848_))
                                                '#!void))))))))
                         (_done97823_
                          (lambda (_i97855_ _j97856_ _m97857_)
                            (let ((_num<97859_ (- _j97856_ _i97855_))
                                  (_num>97860_ (+ '1 (- _m97857_ _j97856_)))
                                  (_num=l97861_ (- _i97855_ _l97802_))
                                  (_num=r97862_ (- (- _r97803_ _m97857_) '1)))
                              (_swap97796_
                               _l97802_
                               _j97856_
                               (min _num<97859_ _num=l97861_))
                              (_swap97796_
                               _j97856_
                               _r97803_
                               (min _num>97860_ _num=r97862_))
                              (if (<= _num<97859_ _num>97860_)
                                  (begin
                                    (_recur97800_
                                     _l97802_
                                     (+ _l97802_ _num<97859_))
                                    (_recur97800_
                                     (- _r97803_ _num>97860_)
                                     _r97803_))
                                  (begin
                                    (_recur97800_
                                     (- _r97803_ _num>97860_)
                                     _r97803_)
                                    (_recur97800_
                                     _l97802_
                                     (+ _l97802_ _num<97859_))))))))
                  (_lscan97821_
                   _l+197809_
                   (+ _l97802_ '2)
                   (- _r97803_ '2)
                   _r-197805_)))
              (std/srfi/132#%vector-insert-sort!
               _elt<97798_
               _v97792_
               _l97802_
               _r97803_))))))
  (define std/srfi/132#list-sort
    (lambda (_<97786_ _l97787_)
      (let ((_v97789_ (list->vector _l97787_)))
        (std/srfi/132#vector-heap-sort! _<97786_ _v97789_)
        (vector->list _v97789_))))
  (define std/srfi/132#list-sort! std/srfi/132#list-merge-sort!)
  (define std/srfi/132#list-stable-sort std/srfi/132#list-merge-sort)
  (define std/srfi/132#list-stable-sort! std/srfi/132#list-merge-sort!)
  (define std/srfi/132#vector-sort std/srfi/132#vector-quick-sort)
  (define std/srfi/132#vector-sort! std/srfi/132#vector-quick-sort!)
  (define std/srfi/132#vector-stable-sort std/srfi/132#vector-merge-sort)
  (define std/srfi/132#vector-stable-sort! std/srfi/132#vector-merge-sort!)
  (define std/srfi/132#vector-find-median
    (lambda (_<97769_ _v97770_ _knil97771_ . _rest97772_)
      (let* ((_mean97777_
              (if (null? _rest97772_)
                  (lambda (_a97774_ _b97775_) (/ (+ _a97774_ _b97775_) '2))
                  (car _rest97772_)))
             (_n97779_ (vector-length _v97770_)))
        (if (zero? _n97779_)
            _knil97771_
            (if (odd? _n97779_)
                (std/srfi/132#%vector-select
                 _<97769_
                 _v97770_
                 (quotient _n97779_ '2)
                 '0
                 _n97779_)
                (call-with-values
                 (lambda ()
                   (std/srfi/132#%vector-select2
                    _<97769_
                    _v97770_
                    (- (quotient _n97779_ '2) '1)
                    '0
                    _n97779_))
                 (lambda (_a97783_ _b97784_)
                   (_mean97777_ _a97783_ _b97784_))))))))
  (define std/srfi/132#vector-find-median!
    (lambda (_<97756_ _v97757_ _knil97758_ . _rest97759_)
      (let* ((_mean97764_
              (if (null? _rest97759_)
                  (lambda (_a97761_ _b97762_) (/ (+ _a97761_ _b97762_) '2))
                  (car _rest97759_)))
             (_n97766_ (vector-length _v97757_)))
        (std/srfi/132#vector-sort! _<97756_ _v97757_)
        (if (zero? _n97766_)
            _knil97758_
            (if (odd? _n97766_)
                (vector-ref _v97757_ (quotient _n97766_ '2))
                (_mean97764_
                 (vector-ref _v97757_ (- (quotient _n97766_ '2) '1))
                 (vector-ref _v97757_ (quotient _n97766_ '2))))))))
  (define std/srfi/132#vector-select
    (lambda (_<97746_ _v97747_ _k97748_ . _rest97749_)
      (let* ((_start97751_ (if (null? _rest97749_) '0 (car _rest97749_)))
             (_end97753_
              (if (and (pair? _rest97749_) (pair? (cdr _rest97749_)))
                  (car (cdr _rest97749_))
                  (vector-length _v97747_))))
        (std/srfi/132#%vector-select
         _<97746_
         _v97747_
         _k97748_
         _start97751_
         _end97753_))))
  (define std/srfi/132#vector-select! std/srfi/132#vector-select)
  (define std/srfi/132#vector-separate!
    (lambda (_<97725_ _v97726_ _k97727_ . _rest97728_)
      (let* ((_start97730_ (if (null? _rest97728_) '0 (car _rest97728_)))
             (_end97732_
              (if (and (pair? _rest97728_) (pair? (cdr _rest97728_)))
                  (car (cdr _rest97728_))
                  (vector-length _v97726_))))
        (if (and (> _k97727_ '0) (> _end97732_ _start97730_))
            (let ((_pivot97735_
                   (std/srfi/132#vector-select
                    _<97725_
                    _v97726_
                    (- _k97727_ '1)
                    _start97730_
                    _end97732_)))
              (call-with-values
               (lambda ()
                 (std/srfi/132#count-smaller
                  _<97725_
                  _pivot97735_
                  _v97726_
                  _start97730_
                  _end97732_
                  '0
                  '0))
               (lambda (_count97738_ _count297739_)
                 (let* ((_v297741_ (make-vector _count97738_))
                        (_v397743_
                         (make-vector
                          (- _end97732_
                             _start97730_
                             _count97738_
                             _count297739_))))
                   (std/srfi/132#copy-smaller!
                    _<97725_
                    _pivot97735_
                    _v297741_
                    '0
                    _v97726_
                    _start97730_
                    _end97732_)
                   (std/srfi/132#copy-bigger!
                    _<97725_
                    _pivot97735_
                    _v397743_
                    '0
                    _v97726_
                    _start97730_
                    _end97732_)
                   (std/srfi/132#r7rs-vector-copy!__0
                    _v97726_
                    _start97730_
                    _v297741_)
                   (std/srfi/132#r7rs-vector-fill!
                    _v97726_
                    _pivot97735_
                    (+ _start97730_ _count97738_)
                    (+ _start97730_ _count97738_ _count297739_))
                   (std/srfi/132#r7rs-vector-copy!__0
                    _v97726_
                    (+ _start97730_ _count97738_ _count297739_)
                    _v397743_)))))
            '#!void))))
  (define std/srfi/132#just-sort-it-threshold '50)
  (define std/srfi/132#%vector-select
    (lambda (_<?97719_ _v97720_ _k97721_ _start97722_ _end97723_)
      (if (and 'vector-select
               (procedure? _<?97719_)
               (vector? _v97720_)
               (exact-integer? _k97721_)
               (exact-integer? _start97722_)
               (exact-integer? _end97723_)
               (<= '0 _k97721_ (- _end97723_ _start97722_ '1))
               (<= '0 _start97722_ _end97723_ (vector-length _v97720_)))
          '#!void
          (error '"assertion failure"))
      (std/srfi/132#%%vector-select
       _<?97719_
       _v97720_
       _k97721_
       _start97722_
       _end97723_)))
  (define std/srfi/132#%vector-select2
    (lambda (_<?97713_ _v97714_ _k97715_ _start97716_ _end97717_)
      (if (and 'vector-select
               (procedure? _<?97713_)
               (vector? _v97714_)
               (exact-integer? _k97715_)
               (exact-integer? _start97716_)
               (exact-integer? _end97717_)
               (<= '0 _k97715_ (- _end97717_ _start97716_ '1 '1))
               (<= '0 _start97716_ _end97717_ (vector-length _v97714_)))
          '#!void
          (error '"assertion failure"))
      (std/srfi/132#%%vector-select2
       _<?97713_
       _v97714_
       _k97715_
       _start97716_
       _end97717_)))
  (define std/srfi/132#%%vector-select
    (lambda (_<?97684_ _v97685_ _k97686_ _start97687_ _end97688_)
      (let ((_size97690_ (- _end97688_ _start97687_)))
        (if (= '1 _size97690_)
            (vector-ref _v97685_ (+ _k97686_ _start97687_))
            (if (= '2 _size97690_)
                (if (_<?97684_
                     (vector-ref _v97685_ _start97687_)
                     (vector-ref _v97685_ (+ _start97687_ '1)))
                    (vector-ref _v97685_ (+ _k97686_ _start97687_))
                    (vector-ref _v97685_ (+ (- '1 _k97686_) _start97687_)))
                (if (< _size97690_ std/srfi/132#just-sort-it-threshold)
                    (vector-ref
                     (std/srfi/132#vector-sort
                      _<?97684_
                      (subvector _v97685_ _start97687_ _end97688_))
                     _k97686_)
                    (let* ((_ip97692_ (random-integer _size97690_))
                           (_pivot97694_
                            (vector-ref _v97685_ (+ _start97687_ _ip97692_))))
                      (call-with-values
                       (lambda ()
                         (std/srfi/132#count-smaller
                          _<?97684_
                          _pivot97694_
                          _v97685_
                          _start97687_
                          _end97688_
                          '0
                          '0))
                       (lambda (_count97698_ _count297699_)
                         (if (< _k97686_ _count97698_)
                             (let* ((_n97701_ _count97698_)
                                    (_v297703_ (make-vector _n97701_)))
                               (std/srfi/132#copy-smaller!
                                _<?97684_
                                _pivot97694_
                                _v297703_
                                '0
                                _v97685_
                                _start97687_
                                _end97688_)
                               (std/srfi/132#%%vector-select
                                _<?97684_
                                _v297703_
                                _k97686_
                                '0
                                _n97701_))
                             (if (< _k97686_ (+ _count97698_ _count297699_))
                                 _pivot97694_
                                 (let* ((_n97706_
                                         (- _size97690_
                                            _count97698_
                                            _count297699_))
                                        (_v297708_ (make-vector _n97706_))
                                        (_k297710_
                                         (- _k97686_
                                            _count97698_
                                            _count297699_)))
                                   (std/srfi/132#copy-bigger!
                                    _<?97684_
                                    _pivot97694_
                                    _v297708_
                                    '0
                                    _v97685_
                                    _start97687_
                                    _end97688_)
                                   (std/srfi/132#%%vector-select
                                    _<?97684_
                                    _v297708_
                                    _k297710_
                                    '0
                                    _n97706_)))))))))))))
  (define std/srfi/132#%%vector-select2
    (lambda (_<?97650_ _v97651_ _k97652_ _start97653_ _end97654_)
      (let ((_size97656_ (- _end97654_ _start97653_)))
        (if (= '2 _size97656_)
            (let ((_a97658_ (vector-ref _v97651_ _start97653_))
                  (_b97659_ (vector-ref _v97651_ (+ _start97653_ '1))))
              (if (_<?97650_ _a97658_ _b97659_)
                  (values _a97658_ _b97659_)
                  (values _b97659_ _a97658_)))
            (if (< _size97656_ std/srfi/132#just-sort-it-threshold)
                (let ((_v297661_
                       (std/srfi/132#vector-sort
                        _<?97650_
                        (subvector _v97651_ _start97653_ _end97654_))))
                  (values (vector-ref _v297661_ _k97652_)
                          (vector-ref _v297661_ (+ _k97652_ '1))))
                (let* ((_ip97663_ (random-integer _size97656_))
                       (_pivot97665_
                        (vector-ref _v97651_ (+ _start97653_ _ip97663_))))
                  (call-with-values
                   (lambda ()
                     (std/srfi/132#count-smaller
                      _<?97650_
                      _pivot97665_
                      _v97651_
                      _start97653_
                      _end97654_
                      '0
                      '0))
                   (lambda (_count97669_ _count297670_)
                     (if (= (+ _k97652_ '1) _count97669_)
                         (values (std/srfi/132#%%vector-select
                                  _<?97650_
                                  _v97651_
                                  _k97652_
                                  _start97653_
                                  _end97654_)
                                 _pivot97665_)
                         (if (< _k97652_ _count97669_)
                             (let* ((_n97672_ _count97669_)
                                    (_v297674_ (make-vector _n97672_)))
                               (std/srfi/132#copy-smaller!
                                _<?97650_
                                _pivot97665_
                                _v297674_
                                '0
                                _v97651_
                                _start97653_
                                _end97654_)
                               (std/srfi/132#%%vector-select2
                                _<?97650_
                                _v297674_
                                _k97652_
                                '0
                                _n97672_))
                             (if (< _k97652_ (+ _count97669_ _count297670_))
                                 (values _pivot97665_
                                         (if (< (+ _k97652_ '1)
                                                (+ _count97669_ _count297670_))
                                             _pivot97665_
                                             (std/srfi/132#%%vector-select
                                              _<?97650_
                                              _v97651_
                                              (+ _k97652_ '1)
                                              _start97653_
                                              _end97654_)))
                                 (let* ((_n97677_
                                         (- _size97656_
                                            _count97669_
                                            _count297670_))
                                        (_v297679_ (make-vector _n97677_))
                                        (_k297681_
                                         (- _k97652_
                                            _count97669_
                                            _count297670_)))
                                   (std/srfi/132#copy-bigger!
                                    _<?97650_
                                    _pivot97665_
                                    _v297679_
                                    '0
                                    _v97651_
                                    _start97653_
                                    _end97654_)
                                   (std/srfi/132#%%vector-select2
                                    _<?97650_
                                    _v297679_
                                    _k297681_
                                    '0
                                    _n97677_)))))))))))))
  (define std/srfi/132#count-smaller
    (lambda (_<?97642_
             _pivot97643_
             _v97644_
             _i97645_
             _end97646_
             _count97647_
             _count297648_)
      (if (= _i97645_ _end97646_)
          (values _count97647_ _count297648_)
          (if (_<?97642_ (vector-ref _v97644_ _i97645_) _pivot97643_)
              (std/srfi/132#count-smaller
               _<?97642_
               _pivot97643_
               _v97644_
               (+ _i97645_ '1)
               _end97646_
               (+ _count97647_ '1)
               _count297648_)
              (if (_<?97642_ _pivot97643_ (vector-ref _v97644_ _i97645_))
                  (std/srfi/132#count-smaller
                   _<?97642_
                   _pivot97643_
                   _v97644_
                   (+ _i97645_ '1)
                   _end97646_
                   _count97647_
                   _count297648_)
                  (std/srfi/132#count-smaller
                   _<?97642_
                   _pivot97643_
                   _v97644_
                   (+ _i97645_ '1)
                   _end97646_
                   _count97647_
                   (+ _count297648_ '1)))))))
  (define std/srfi/132#copy-smaller!
    (lambda (_<?97634_
             _pivot97635_
             _dst97636_
             _at97637_
             _src97638_
             _start97639_
             _end97640_)
      (if (= _start97639_ _end97640_)
          _dst97636_
          (if (_<?97634_ (vector-ref _src97638_ _start97639_) _pivot97635_)
              (begin
                (vector-set!
                 _dst97636_
                 _at97637_
                 (vector-ref _src97638_ _start97639_))
                (std/srfi/132#copy-smaller!
                 _<?97634_
                 _pivot97635_
                 _dst97636_
                 (+ _at97637_ '1)
                 _src97638_
                 (+ _start97639_ '1)
                 _end97640_))
              (std/srfi/132#copy-smaller!
               _<?97634_
               _pivot97635_
               _dst97636_
               _at97637_
               _src97638_
               (+ _start97639_ '1)
               _end97640_)))))
  (define std/srfi/132#copy-bigger!
    (lambda (_<?97626_
             _pivot97627_
             _dst97628_
             _at97629_
             _src97630_
             _start97631_
             _end97632_)
      (if (= _start97631_ _end97632_)
          _dst97628_
          (if (_<?97626_ _pivot97627_ (vector-ref _src97630_ _start97631_))
              (begin
                (vector-set!
                 _dst97628_
                 _at97629_
                 (vector-ref _src97630_ _start97631_))
                (std/srfi/132#copy-bigger!
                 _<?97626_
                 _pivot97627_
                 _dst97628_
                 (+ _at97629_ '1)
                 _src97630_
                 (+ _start97631_ '1)
                 _end97632_))
              (std/srfi/132#copy-bigger!
               _<?97626_
               _pivot97627_
               _dst97628_
               _at97629_
               _src97630_
               (+ _start97631_ '1)
               _end97632_))))))
