(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/146/hash#tree-search
    (lambda (_comparator113033_
             _tree113034_
             _obj113035_
             _failure113036_
             _success113037_)
      (let ((_entry113039_
             (std/srfi/146/hamt-map#phm/get__0 _tree113034_ _obj113035_)))
        (if _entry113039_
            (_success113037_
             (car _entry113039_)
             (cdr _entry113039_)
             (lambda (_new-key113041_ _new-datum113042_ _ret113043_)
               (let ((_tree113045_
                      (std/srfi/146/hamt-map#phm/remove
                       _tree113034_
                       _obj113035_)))
                 (values (std/srfi/146/hamt-map#phm/put
                          _tree113045_
                          _new-key113041_
                          (cons _new-key113041_ _new-datum113042_))
                         _ret113043_)))
             (lambda (_ret113047_)
               (values (std/srfi/146/hamt-map#phm/remove
                        _tree113034_
                        _obj113035_)
                       _ret113047_)))
            (_failure113036_
             (lambda (_new-key113049_ _new-datum113050_ _ret113051_)
               (values (std/srfi/146/hamt-map#phm/put
                        _tree113034_
                        _new-key113049_
                        (cons _new-key113049_ _new-datum113050_))
                       _ret113051_))
             (lambda (_ret113053_) (values _tree113034_ _ret113053_)))))))
  (define std/srfi/146/hash#tree-fold
    (lambda (_proc113026_ _seed113027_ _tree113028_)
      (std/srfi/146/hamt-map#phm/for-each
       (lambda (_key113030_ _entry113031_)
         (set! _seed113027_
               (_proc113026_
                (car _entry113031_)
                (cdr _entry113031_)
                _seed113027_)))
       _tree113028_)
      _seed113027_))
  (define std/srfi/146/hash#tree-for-each
    (lambda (_proc113020_ _tree113021_)
      (std/srfi/146/hamt-map#phm/for-each
       (lambda (_key113023_ _entry113024_)
         (_proc113020_ (car _entry113024_) (cdr _entry113024_)))
       _tree113021_)))
  (define std/srfi/146/hash#tree-generator
    (lambda (_tree113014_)
      (std/srfi/121#make-coroutine-generator
       (lambda (_yield113016_)
         (std/srfi/146/hash#tree-for-each
          (lambda _item113018_ (_yield113016_ _item113018_))
          _tree113014_)))))
  (define std/srfi/146/hash#<hashmap>
    (make-struct-type
     'std/srfi/146/hash#<hashmap>
     '#f
     '2
     '<hashmap>
     '((fields: comparator tree))
     '#f))
  (define std/srfi/146/hash#hashmap?
    (make-struct-predicate std/srfi/146/hash#<hashmap>))
  (define std/srfi/146/hash#hashmap-key-comparator
    (make-struct-field-accessor std/srfi/146/hash#<hashmap> '0))
  (define std/srfi/146/hash#hashmap-tree
    (make-struct-field-accessor std/srfi/146/hash#<hashmap> '1))
  (define std/srfi/146/hash#%make-hashmap
    (lambda (_comparator113011_ _tree113012_)
      (make-struct-instance
       std/srfi/146/hash#<hashmap>
       _comparator113011_
       _tree113012_)))
  (define std/srfi/146/hash#make-empty-hashmap
    (lambda (_comparator113006_)
      (let ((_val113008_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator113006_
                'std/srfi/128#comparator::t))))
        (if _val113008_ _val113008_ (error)))
      (let ((__tmp295551
             (std/srfi/146/hamt-map#make-phm__0
              (std/srfi/128#comparator-hash-function _comparator113006_)
              (##direct-structure-ref
               _comparator113006_
               '2
               std/srfi/128#comparator::t
               '#f))))
        (declare (not safe))
        (##structure
         std/srfi/146/hash#<hashmap>
         _comparator113006_
         __tmp295551))))
  (define std/srfi/146/hash#hashmap
    (lambda (_comparator112998_ . _args112999_)
      (let ((_val113001_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112998_
                'std/srfi/128#comparator::t))))
        (if _val113001_ _val113001_ (error)))
      (std/srfi/146/hash#hashmap-unfold
       null?
       (lambda (_args113004_) (values (car _args113004_) (cadr _args113004_)))
       cddr
       _args112999_
       _comparator112998_)))
  (define std/srfi/146/hash#hashmap-unfold
    (lambda (_stop?112972_
             _mapper112973_
             _successor112974_
             _seed112975_
             _comparator112976_)
      (let ((_val112978_ (procedure? _stop?112972_)))
        (if _val112978_ _val112978_ (error)))
      (let ((_val112981_ (procedure? _mapper112973_)))
        (if _val112981_ _val112981_ (error)))
      (let ((_val112984_ (procedure? _successor112974_)))
        (if _val112984_ _val112984_ (error)))
      (let ((_val112987_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112976_
                'std/srfi/128#comparator::t))))
        (if _val112987_ _val112987_ (error)))
      (let _loop112990_ ((_hashmap112992_
                          (std/srfi/146/hash#make-empty-hashmap
                           _comparator112976_))
                         (_seed112993_ _seed112975_))
        (if (_stop?112972_ _seed112993_)
            _hashmap112992_
            (let ((_g295552_ (_mapper112973_ _seed112993_)))
              (begin
                (let ((_g295553_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g295552_)
                             (##vector-length _g295552_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g295553_ 2)))
                      (error "Context expects 2 values" _g295553_)))
                (let ((_key112995_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g295552_ 0)))
                      (_value112996_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g295552_ 1))))
                  (_loop112990_
                   (std/srfi/146/hash#hashmap-adjoin
                    _hashmap112992_
                    _key112995_
                    _value112996_)
                   (_successor112974_ _seed112993_)))))))))
  (define std/srfi/146/hash#hashmap-empty?
    (lambda (_hashmap112964_)
      (let ((_val112966_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112964_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112966_ _val112966_ (error)))
      (not (std/srfi/146/hash#hashmap-any?
            (lambda (_key112969_ _value112970_) '#t)
            _hashmap112964_))))
  (define std/srfi/146/hash#hashmap-contains?
    (lambda (_hashmap112948_ _key112949_)
      (let ((_val112951_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112948_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112951_ _val112951_ (error)))
      (call-with-current-continuation
       (lambda (_return112954_)
         (std/srfi/146/hash#hashmap-search
          _hashmap112948_
          _key112949_
          (lambda (_insert112956_ _ignore112957_) (_return112954_ '#f))
          (lambda (_key112959_ _value112960_ _update112961_ _remove112962_)
            (_return112954_ '#t)))))))
  (define std/srfi/146/hash#hashmap-disjoint?
    (lambda (_hashmap1112934_ _hashmap2112935_)
      (let ((_val112937_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112934_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112937_ _val112937_ (error)))
      (let ((_val112940_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112935_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112940_ _val112940_ (error)))
      (call-with-current-continuation
       (lambda (_return112943_)
         (std/srfi/146/hash#hashmap-for-each
          (lambda (_key112945_ _value112946_)
            (if (std/srfi/146/hash#hashmap-contains?
                 _hashmap2112935_
                 _key112945_)
                (_return112943_ '#f)
                '#!void))
          _hashmap1112934_)
         '#t))))
  (define std/srfi/146/hash#hashmap-ref__0
    (lambda (_hashmap112890_ _key112891_)
      (let ((_val112893_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112890_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112893_ _val112893_ (error)))
      (std/srfi/146/hash#hashmap-ref__1
       _hashmap112890_
       _key112891_
       (lambda () (error '"hashmap-ref: key not in hashmap" _key112891_)))))
  (define std/srfi/146/hash#hashmap-ref__1
    (lambda (_hashmap112897_ _key112898_ _failure112899_)
      (let ((_val112901_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112897_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112901_ _val112901_ (error)))
      (let ((_val112904_ (procedure? _failure112899_)))
        (if _val112904_ _val112904_ (error)))
      (std/srfi/146/hash#hashmap-ref__2
       _hashmap112897_
       _key112898_
       _failure112899_
       (lambda (_value112907_) _value112907_))))
  (define std/srfi/146/hash#hashmap-ref__2
    (lambda (_hashmap112909_ _key112910_ _failure112911_ _success112912_)
      (let ((_val112914_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112909_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112914_ _val112914_ (error)))
      (let ((_val112917_ (procedure? _failure112911_)))
        (if _val112917_ _val112917_ (error)))
      (let ((_val112920_ (procedure? _success112912_)))
        (if _val112920_ _val112920_ (error)))
      ((call-with-current-continuation
        (lambda (_return-thunk112923_)
          (std/srfi/146/hash#hashmap-search
           _hashmap112909_
           _key112910_
           (lambda (_insert112925_ _ignore112926_)
             (_return-thunk112923_ _failure112911_))
           (lambda (_key112928_ _value112929_ _update112930_ _remove112931_)
             (_return-thunk112923_
              (lambda () (_success112912_ _value112929_))))))))))
  (define std/srfi/146/hash#hashmap-ref
    (lambda _g295555_
      (let ((_g295554_ (let () (declare (not safe)) (##length _g295555_))))
        (cond ((let () (declare (not safe)) (##fx= _g295554_ 2))
               (apply std/srfi/146/hash#hashmap-ref__0 _g295555_))
              ((let () (declare (not safe)) (##fx= _g295554_ 3))
               (apply std/srfi/146/hash#hashmap-ref__1 _g295555_))
              ((let () (declare (not safe)) (##fx= _g295554_ 4))
               (apply std/srfi/146/hash#hashmap-ref__2 _g295555_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap-ref
                _g295555_))))))
  (define std/srfi/146/hash#hashmap-ref/default
    (lambda (_hashmap112882_ _key112883_ _default112884_)
      (let ((_val112886_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112882_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112886_ _val112886_ (error)))
      (std/srfi/146/hash#hashmap-ref__1
       _hashmap112882_
       _key112883_
       (lambda () _default112884_))))
  (define std/srfi/146/hash#hashmap-adjoin
    (lambda (_hashmap112867_ . _args112868_)
      (let ((_val112870_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112867_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112870_ _val112870_ (error)))
      (let _loop112873_ ((_args112875_ _args112868_)
                         (_hashmap112876_ _hashmap112867_))
        (if (null? _args112875_)
            _hashmap112876_
            (let ((_g295556_
                   (std/srfi/146/hash#hashmap-intern
                    _hashmap112876_
                    (car _args112875_)
                    (lambda () (cadr _args112875_)))))
              (begin
                (let ((_g295557_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g295556_)
                             (##vector-length _g295556_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g295557_ 2)))
                      (error "Context expects 2 values" _g295557_)))
                (let ((_hashmap112879_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g295556_ 0)))
                      (_value112880_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g295556_ 1))))
                  (_loop112873_ (cddr _args112875_) _hashmap112879_))))))))
  (define std/srfi/146/hash#hashmap-adjoin! std/srfi/146/hash#hashmap-adjoin)
  (define std/srfi/146/hash#hashmap-set
    (lambda (_hashmap112851_ . _args112852_)
      (let ((_val112854_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112851_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112854_ _val112854_ (error)))
      (let _loop112857_ ((_args112859_ _args112852_)
                         (_hashmap112860_ _hashmap112851_))
        (if (null? _args112859_)
            _hashmap112860_
            (let ((_hashmap112865_
                   (std/srfi/146/hash#hashmap-update__1
                    _hashmap112860_
                    (car _args112859_)
                    (lambda (_value112862_) (cadr _args112859_))
                    (lambda () '#f))))
              (_loop112857_ (cddr _args112859_) _hashmap112865_))))))
  (define std/srfi/146/hash#hashmap-set! std/srfi/146/hash#hashmap-set)
  (define std/srfi/146/hash#hashmap-replace
    (lambda (_hashmap112833_ _key112834_ _value112835_)
      (let ((_val112837_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112833_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112837_ _val112837_ (error)))
      (let ((_g295558_
             (std/srfi/146/hash#hashmap-search
              _hashmap112833_
              _key112834_
              (lambda (_insert112840_ _ignore112841_) (_ignore112841_ '#f))
              (lambda (_old-key112843_
                       _old-value112844_
                       _update112845_
                       _remove112846_)
                (_update112845_ _key112834_ _value112835_ '#f)))))
        (begin
          (let ((_g295559_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g295558_) (##vector-length _g295558_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g295559_ 2)))
                (error "Context expects 2 values" _g295559_)))
          (let ((_hashmap112848_
                 (let () (declare (not safe)) (##vector-ref _g295558_ 0)))
                (_obj112849_
                 (let () (declare (not safe)) (##vector-ref _g295558_ 1))))
            _hashmap112848_)))))
  (define std/srfi/146/hash#hashmap-replace! std/srfi/146/hash#hashmap-replace)
  (define std/srfi/146/hash#hashmap-delete
    (lambda (_hashmap112827_ . _keys112828_)
      (let ((_val112830_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112827_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112830_ _val112830_ (error)))
      (std/srfi/146/hash#hashmap-delete-all _hashmap112827_ _keys112828_)))
  (define std/srfi/146/hash#hashmap-delete! std/srfi/146/hash#hashmap-delete)
  (define std/srfi/146/hash#hashmap-delete-all
    (lambda (_hashmap112804_ _keys112805_)
      (let ((_val112807_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112804_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112807_ _val112807_ (error)))
      (let ((_val112810_ (list? _keys112805_)))
        (if _val112810_ _val112810_ (error)))
      (foldl1 (lambda (_key112813_ _hashmap112814_)
                (let ((_g295560_
                       (std/srfi/146/hash#hashmap-search
                        _hashmap112814_
                        _key112813_
                        (lambda (_insert112816_ _ignore112817_)
                          (_ignore112817_ '#f))
                        (lambda (_old-key112819_
                                 _old-value112820_
                                 _update112821_
                                 _remove112822_)
                          (_remove112822_ '#f)))))
                  (begin
                    (let ((_g295561_
                           (let ()
                             (declare (not safe))
                             (if (##values? _g295560_)
                                 (##vector-length _g295560_)
                                 1))))
                      (if (not (let ()
                                 (declare (not safe))
                                 (##fx= _g295561_ 2)))
                          (error "Context expects 2 values" _g295561_)))
                    (let ((_hashmap112824_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g295560_ 0)))
                          (_obj112825_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g295560_ 1))))
                      _hashmap112824_))))
              _hashmap112804_
              _keys112805_)))
  (define std/srfi/146/hash#hashmap-delete-all!
    std/srfi/146/hash#hashmap-delete-all)
  (define std/srfi/146/hash#hashmap-intern
    (lambda (_hashmap112782_ _key112783_ _failure112784_)
      (let ((_val112786_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112782_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112786_ _val112786_ (error)))
      (let ((_val112789_ (procedure? _failure112784_)))
        (if _val112789_ _val112789_ (error)))
      (call-with-current-continuation
       (lambda (_return112792_)
         (std/srfi/146/hash#hashmap-search
          _hashmap112782_
          _key112783_
          (lambda (_insert112794_ _ignore112795_)
            (let ((_value112797_ (_failure112784_)))
              (_insert112794_ _value112797_ _value112797_)))
          (lambda (_old-key112799_
                   _old-value112800_
                   _update112801_
                   _remove112802_)
            (_return112792_ _hashmap112782_ _old-value112800_)))))))
  (define std/srfi/146/hash#hashmap-intern! std/srfi/146/hash#hashmap-intern)
  (define std/srfi/146/hash#hashmap-update__0
    (lambda (_hashmap112741_ _key112742_ _updater112743_)
      (std/srfi/146/hash#hashmap-update__1
       _hashmap112741_
       _key112742_
       _updater112743_
       (lambda ()
         (error '"hashmap-update: key not found in hashmap" _key112742_)))))
  (define std/srfi/146/hash#hashmap-update__1
    (lambda (_hashmap112746_ _key112747_ _updater112748_ _failure112749_)
      (std/srfi/146/hash#hashmap-update__2
       _hashmap112746_
       _key112747_
       _updater112748_
       _failure112749_
       (lambda (_value112751_) _value112751_))))
  (define std/srfi/146/hash#hashmap-update__2
    (lambda (_hashmap112753_
             _key112754_
             _updater112755_
             _failure112756_
             _success112757_)
      (let ((_val112759_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112753_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112759_ _val112759_ (error)))
      (let ((_val112762_ (procedure? _updater112755_)))
        (if _val112762_ _val112762_ (error)))
      (let ((_val112765_ (procedure? _failure112756_)))
        (if _val112765_ _val112765_ (error)))
      (let ((_val112768_ (procedure? _success112757_)))
        (if _val112768_ _val112768_ (error)))
      (let ((_g295562_
             (std/srfi/146/hash#hashmap-search
              _hashmap112753_
              _key112754_
              (lambda (_insert112771_ _ignore112772_)
                (_insert112771_ (_updater112755_ (_failure112756_)) '#f))
              (lambda (_old-key112774_
                       _old-value112775_
                       _update112776_
                       _remove112777_)
                (_update112776_
                 _key112754_
                 (_updater112755_ (_success112757_ _old-value112775_))
                 '#f)))))
        (begin
          (let ((_g295563_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g295562_) (##vector-length _g295562_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g295563_ 2)))
                (error "Context expects 2 values" _g295563_)))
          (let ((_hashmap112779_
                 (let () (declare (not safe)) (##vector-ref _g295562_ 0)))
                (_obj112780_
                 (let () (declare (not safe)) (##vector-ref _g295562_ 1))))
            _hashmap112779_)))))
  (define std/srfi/146/hash#hashmap-update
    (lambda _g295565_
      (let ((_g295564_ (let () (declare (not safe)) (##length _g295565_))))
        (cond ((let () (declare (not safe)) (##fx= _g295564_ 3))
               (apply std/srfi/146/hash#hashmap-update__0 _g295565_))
              ((let () (declare (not safe)) (##fx= _g295564_ 4))
               (apply std/srfi/146/hash#hashmap-update__1 _g295565_))
              ((let () (declare (not safe)) (##fx= _g295564_ 5))
               (apply std/srfi/146/hash#hashmap-update__2 _g295565_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap-update
                _g295565_))))))
  (define std/srfi/146/hash#hashmap-update! std/srfi/146/hash#hashmap-update)
  (define std/srfi/146/hash#hashmap-update/default
    (lambda (_hashmap112735_ _key112736_ _updater112737_ _default112738_)
      (std/srfi/146/hash#hashmap-update__1
       _hashmap112735_
       _key112736_
       _updater112737_
       (lambda () _default112738_))))
  (define std/srfi/146/hash#hashmap-update!/default
    std/srfi/146/hash#hashmap-update/default)
  (define std/srfi/146/hash#hashmap-pop__0
    (lambda (_hashmap112713_)
      (std/srfi/146/hash#hashmap-pop__1
       _hashmap112713_
       (lambda () (error '"hashmap-pop: hashmap has no association")))))
  (define std/srfi/146/hash#hashmap-pop__1
    (lambda (_hashmap112716_ _failure112717_)
      (let ((_val112719_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112716_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112719_ _val112719_ (error)))
      (let ((_val112722_ (procedure? _failure112717_)))
        (if _val112722_ _val112722_ (error)))
      ((call-with-current-continuation
        (lambda (_return-thunk112725_)
          (let ((_g295566_
                 (std/srfi/146/hash#hashmap-find
                  (lambda (_key112727_ _value112728_) '#t)
                  _hashmap112716_
                  (lambda () (_return-thunk112725_ _failure112717_)))))
            (begin
              (let ((_g295567_
                     (let ()
                       (declare (not safe))
                       (if (##values? _g295566_)
                           (##vector-length _g295566_)
                           1))))
                (if (not (let () (declare (not safe)) (##fx= _g295567_ 2)))
                    (error "Context expects 2 values" _g295567_)))
              (let ((_key112731_
                     (let () (declare (not safe)) (##vector-ref _g295566_ 0)))
                    (_value112732_
                     (let () (declare (not safe)) (##vector-ref _g295566_ 1))))
                (lambda ()
                  (values (std/srfi/146/hash#hashmap-delete
                           _hashmap112716_
                           _key112731_)
                          _key112731_
                          _value112732_))))))))))
  (define std/srfi/146/hash#hashmap-pop
    (lambda _g295569_
      (let ((_g295568_ (let () (declare (not safe)) (##length _g295569_))))
        (cond ((let () (declare (not safe)) (##fx= _g295568_ 1))
               (apply std/srfi/146/hash#hashmap-pop__0 _g295569_))
              ((let () (declare (not safe)) (##fx= _g295568_ 2))
               (apply std/srfi/146/hash#hashmap-pop__1 _g295569_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap-pop
                _g295569_))))))
  (define std/srfi/146/hash#hashmap-pop! std/srfi/146/hash#hashmap-pop)
  (define std/srfi/146/hash#hashmap-search
    (lambda (_hashmap112683_ _key112684_ _failure112685_ _success112686_)
      (let ((_val112688_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112683_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112688_ _val112688_ (error)))
      (let ((_val112691_ (procedure? _failure112685_)))
        (if _val112691_ _val112691_ (error)))
      (let ((_val112694_ (procedure? _success112686_)))
        (if _val112694_ _val112694_ (error)))
      (call-with-current-continuation
       (lambda (_return112697_)
         (let* ((_comparator112699_
                 (##structure-ref
                  _hashmap112683_
                  '1
                  std/srfi/146/hash#<hashmap>
                  '#f))
                (_g295570_
                 (std/srfi/146/hash#tree-search
                  _comparator112699_
                  (##structure-ref
                   _hashmap112683_
                   '2
                   std/srfi/146/hash#<hashmap>
                   '#f)
                  _key112684_
                  (lambda (_insert112701_ _ignore112702_)
                    (_failure112685_
                     (lambda (_value112704_ _obj112705_)
                       (_insert112701_ _key112684_ _value112704_ _obj112705_))
                     (lambda (_obj112707_)
                       (_return112697_ _hashmap112683_ _obj112707_))))
                  _success112686_)))
           (begin
             (let ((_g295571_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g295570_)
                          (##vector-length _g295570_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g295571_ 2)))
                   (error "Context expects 2 values" _g295571_)))
             (let ((_tree112709_
                    (let () (declare (not safe)) (##vector-ref _g295570_ 0)))
                   (_obj112710_
                    (let () (declare (not safe)) (##vector-ref _g295570_ 1))))
               (let ()
                 (values (let ()
                           (declare (not safe))
                           (##structure
                            std/srfi/146/hash#<hashmap>
                            _comparator112699_
                            _tree112709_))
                         _obj112710_)))))))))
  (define std/srfi/146/hash#hashmap-search! std/srfi/146/hash#hashmap-search)
  (define std/srfi/146/hash#hashmap-size
    (lambda (_hashmap112675_)
      (let ((_val112677_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112675_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112677_ _val112677_ (error)))
      (std/srfi/146/hash#hashmap-count
       (lambda (_key112680_ _value112681_) '#t)
       _hashmap112675_)))
  (define std/srfi/146/hash#hashmap-find
    (lambda (_predicate112657_ _hashmap112658_ _failure112659_)
      (let ((_val112661_ (procedure? _predicate112657_)))
        (if _val112661_ _val112661_ (error)))
      (let ((_val112664_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112658_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112664_ _val112664_ (error)))
      (let ((_val112667_ (procedure? _failure112659_)))
        (if _val112667_ _val112667_ (error)))
      (call-with-current-continuation
       (lambda (_return112670_)
         (std/srfi/146/hash#hashmap-for-each
          (lambda (_key112672_ _value112673_)
            (if (_predicate112657_ _key112672_ _value112673_)
                (_return112670_ _key112672_ _value112673_)
                '#!void))
          _hashmap112658_)
         (_failure112659_)))))
  (define std/srfi/146/hash#hashmap-count
    (lambda (_predicate112644_ _hashmap112645_)
      (let ((_val112647_ (procedure? _predicate112644_)))
        (if _val112647_ _val112647_ (error)))
      (let ((_val112650_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112645_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112650_ _val112650_ (error)))
      (std/srfi/146/hash#hashmap-fold
       (lambda (_key112653_ _value112654_ _count112655_)
         (if (_predicate112644_ _key112653_ _value112654_)
             (+ '1 _count112655_)
             _count112655_))
       '0
       _hashmap112645_)))
  (define std/srfi/146/hash#hashmap-any?
    (lambda (_predicate112630_ _hashmap112631_)
      (let ((_val112633_ (procedure? _predicate112630_)))
        (if _val112633_ _val112633_ (error)))
      (let ((_val112636_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112631_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112636_ _val112636_ (error)))
      (call-with-current-continuation
       (lambda (_return112639_)
         (std/srfi/146/hash#hashmap-for-each
          (lambda (_key112641_ _value112642_)
            (if (_predicate112630_ _key112641_ _value112642_)
                (_return112639_ '#t)
                '#!void))
          _hashmap112631_)
         '#f))))
  (define std/srfi/146/hash#hashmap-every?
    (lambda (_predicate112618_ _hashmap112619_)
      (let ((_val112621_ (procedure? _predicate112618_)))
        (if _val112621_ _val112621_ (error)))
      (let ((_val112624_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112619_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112624_ _val112624_ (error)))
      (not (std/srfi/146/hash#hashmap-any?
            (lambda (_key112627_ _value112628_)
              (not (_predicate112618_ _key112627_ _value112628_)))
            _hashmap112619_))))
  (define std/srfi/146/hash#hashmap-keys
    (lambda (_hashmap112609_)
      (let ((_val112611_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112609_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112611_ _val112611_ (error)))
      (std/srfi/146/hash#hashmap-fold
       (lambda (_key112614_ _value112615_ _keys112616_)
         (cons _key112614_ _keys112616_))
       '()
       _hashmap112609_)))
  (define std/srfi/146/hash#hashmap-values
    (lambda (_hashmap112600_)
      (let ((_val112602_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112600_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112602_ _val112602_ (error)))
      (std/srfi/146/hash#hashmap-fold
       (lambda (_key112605_ _value112606_ _values112607_)
         (cons _value112606_ _values112607_))
       '()
       _hashmap112600_)))
  (define std/srfi/146/hash#hashmap-entries
    (lambda (_hashmap112595_)
      (let ((_val112597_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112595_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112597_ _val112597_ (error)))
      (values (std/srfi/146/hash#hashmap-keys _hashmap112595_)
              (std/srfi/146/hash#hashmap-values _hashmap112595_))))
  (define std/srfi/146/hash#hashmap-map
    (lambda (_proc112575_ _comparator112576_ _hashmap112577_)
      (let ((_val112579_ (procedure? _proc112575_)))
        (if _val112579_ _val112579_ (error)))
      (let ((_val112582_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112576_
                'std/srfi/128#comparator::t))))
        (if _val112582_ _val112582_ (error)))
      (let ((_val112585_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112577_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112585_ _val112585_ (error)))
      (std/srfi/146/hash#hashmap-fold
       (lambda (_key112588_ _value112589_ _hashmap112590_)
         (let ((_g295572_ (_proc112575_ _key112588_ _value112589_)))
           (begin
             (let ((_g295573_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g295572_)
                          (##vector-length _g295572_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g295573_ 2)))
                   (error "Context expects 2 values" _g295573_)))
             (let ((_key112592_
                    (let () (declare (not safe)) (##vector-ref _g295572_ 0)))
                   (_value112593_
                    (let () (declare (not safe)) (##vector-ref _g295572_ 1))))
               (std/srfi/146/hash#hashmap-set
                _hashmap112590_
                _key112592_
                _value112593_)))))
       (std/srfi/146/hash#make-empty-hashmap _comparator112576_)
       _hashmap112577_)))
  (define std/srfi/146/hash#hashmap-for-each
    (lambda (_proc112566_ _hashmap112567_)
      (let ((_val112569_ (procedure? _proc112566_)))
        (if _val112569_ _val112569_ (error)))
      (let ((_val112572_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112567_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112572_ _val112572_ (error)))
      (std/srfi/146/hash#tree-for-each
       _proc112566_
       (##structure-ref _hashmap112567_ '2 std/srfi/146/hash#<hashmap> '#f))))
  (define std/srfi/146/hash#hashmap-fold
    (lambda (_proc112556_ _acc112557_ _hashmap112558_)
      (let ((_val112560_ (procedure? _proc112556_)))
        (if _val112560_ _val112560_ (error)))
      (let ((_val112563_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112558_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112563_ _val112563_ (error)))
      (std/srfi/146/hash#tree-fold
       _proc112556_
       _acc112557_
       (##structure-ref _hashmap112558_ '2 std/srfi/146/hash#<hashmap> '#f))))
  (define std/srfi/146/hash#hashmap-map->list
    (lambda (_proc112543_ _hashmap112544_)
      (let ((_val112546_ (procedure? _proc112543_)))
        (if _val112546_ _val112546_ (error)))
      (let ((_val112549_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112544_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112549_ _val112549_ (error)))
      (std/srfi/146/hash#hashmap-fold
       (lambda (_key112552_ _value112553_ _lst112554_)
         (cons (_proc112543_ _key112552_ _value112553_) _lst112554_))
       '()
       _hashmap112544_)))
  (define std/srfi/146/hash#hashmap-filter
    (lambda (_predicate112530_ _hashmap112531_)
      (let ((_val112533_ (procedure? _predicate112530_)))
        (if _val112533_ _val112533_ (error)))
      (let ((_val112536_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112531_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112536_ _val112536_ (error)))
      (std/srfi/146/hash#hashmap-fold
       (lambda (_key112539_ _value112540_ _hashmap112541_)
         (if (_predicate112530_ _key112539_ _value112540_)
             (std/srfi/146/hash#hashmap-set
              _hashmap112541_
              _key112539_
              _value112540_)
             _hashmap112541_))
       (std/srfi/146/hash#make-empty-hashmap
        (##structure-ref _hashmap112531_ '1 std/srfi/146/hash#<hashmap> '#f))
       _hashmap112531_)))
  (define std/srfi/146/hash#hashmap-filter! std/srfi/146/hash#hashmap-filter)
  (define std/srfi/146/hash#hashmap-remove
    (lambda (_predicate112518_ _hashmap112519_)
      (let ((_val112521_ (procedure? _predicate112518_)))
        (if _val112521_ _val112521_ (error)))
      (let ((_val112524_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112519_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112524_ _val112524_ (error)))
      (std/srfi/146/hash#hashmap-filter
       (lambda (_key112527_ _value112528_)
         (not (_predicate112518_ _key112527_ _value112528_)))
       _hashmap112519_)))
  (define std/srfi/146/hash#hashmap-remove! std/srfi/146/hash#hashmap-remove)
  (define std/srfi/146/hash#hashmap-partition
    (lambda (_predicate112509_ _hashmap112510_)
      (let ((_val112512_ (procedure? _predicate112509_)))
        (if _val112512_ _val112512_ (error)))
      (let ((_val112515_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112510_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112515_ _val112515_ (error)))
      (values (std/srfi/146/hash#hashmap-filter
               _predicate112509_
               _hashmap112510_)
              (std/srfi/146/hash#hashmap-remove
               _predicate112509_
               _hashmap112510_))))
  (define std/srfi/146/hash#hashmap-partition!
    std/srfi/146/hash#hashmap-partition)
  (define std/srfi/146/hash#hashmap-copy
    (lambda (_hashmap112504_)
      (let ((_val112506_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112504_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112506_ _val112506_ (error)))
      _hashmap112504_))
  (define std/srfi/146/hash#hashmap->alist
    (lambda (_hashmap112495_)
      (let ((_val112497_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112495_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112497_ _val112497_ (error)))
      (std/srfi/146/hash#hashmap-fold
       (lambda (_key112500_ _value112501_ _alist112502_)
         (cons (cons _key112500_ _value112501_) _alist112502_))
       '()
       _hashmap112495_)))
  (define std/srfi/146/hash#alist->hashmap
    (lambda (_comparator112481_ _alist112482_)
      (let ((_val112484_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112481_
                'std/srfi/128#comparator::t))))
        (if _val112484_ _val112484_ (error)))
      (let ((_val112487_ (list? _alist112482_)))
        (if _val112487_ _val112487_ (error)))
      (std/srfi/146/hash#hashmap-unfold
       null?
       (lambda (_alist112490_)
         (let ((_key112492_ (caar _alist112490_))
               (_value112493_ (cdar _alist112490_)))
           (values _key112492_ _value112493_)))
       cdr
       _alist112482_
       _comparator112481_)))
  (define std/srfi/146/hash#alist->hashmap!
    (lambda (_hashmap112466_ _alist112467_)
      (let ((_val112469_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112466_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112469_ _val112469_ (error)))
      (let ((_val112472_ (list? _alist112467_)))
        (if _val112472_ _val112472_ (error)))
      (foldl1 (lambda (_association112475_ _hashmap112476_)
                (let ((_key112478_ (car _association112475_))
                      (_value112479_ (cdr _association112475_)))
                  (std/srfi/146/hash#hashmap-set
                   _hashmap112476_
                   _key112478_
                   _value112479_)))
              _hashmap112466_
              _alist112467_)))
  (define std/srfi/146/hash#hashmap=?__0
    (lambda (_comparator112451_ _hashmap112452_)
      (let ((_val112454_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112452_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112454_ _val112454_ (error)))
      '#t))
  (define std/srfi/146/hash#hashmap=?__2
    (lambda (_comparator112461_
             _hashmap1112462_
             _hashmap2112463_
             .
             _hashmaps112464_)
      (if (std/srfi/146/hash#%hashmap=?
           _comparator112461_
           _hashmap1112462_
           _hashmap2112463_)
          (apply std/srfi/146/hash#hashmap=?
                 _comparator112461_
                 _hashmap2112463_
                 _hashmaps112464_)
          '#f)))
  (define std/srfi/146/hash#hashmap=?
    (lambda _g295575_
      (let ((_g295574_ (let () (declare (not safe)) (##length _g295575_))))
        (cond ((let () (declare (not safe)) (##fx= _g295574_ 2))
               (apply std/srfi/146/hash#hashmap=?__0 _g295575_))
              ((let () (declare (not safe)) (##fx= _g295574_ 3))
               (apply std/srfi/146/hash#%hashmap=? _g295575_))
              ((let () (declare (not safe)) (##fx>= _g295574_ 3))
               (apply std/srfi/146/hash#hashmap=?__2 _g295575_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap=?
                _g295575_))))))
  (define std/srfi/146/hash#%hashmap=?
    (lambda (_comparator112447_ _hashmap1112448_ _hashmap2112449_)
      (if (eq? (##structure-ref
                _hashmap1112448_
                '1
                std/srfi/146/hash#<hashmap>
                '#f)
               (##structure-ref
                _hashmap2112449_
                '1
                std/srfi/146/hash#<hashmap>
                '#f))
          (if (std/srfi/146/hash#%hashmap<=?
               _comparator112447_
               _hashmap1112448_
               _hashmap2112449_)
              (std/srfi/146/hash#%hashmap<=?
               _comparator112447_
               _hashmap2112449_
               _hashmap1112448_)
              '#f)
          '#f)))
  (define std/srfi/146/hash#hashmap<=?__0
    (lambda (_comparator112414_ _hashmap112415_)
      (let ((_val112417_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112415_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112417_ _val112417_ (error)))
      '#t))
  (define std/srfi/146/hash#hashmap<=?__1
    (lambda (_comparator112420_ _hashmap1112421_ _hashmap2112422_)
      (let ((_val112424_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112420_
                'std/srfi/128#comparator::t))))
        (if _val112424_ _val112424_ (error)))
      (let ((_val112427_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112421_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112427_ _val112427_ (error)))
      (let ((_val112430_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112422_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112430_ _val112430_ (error)))
      (std/srfi/146/hash#%hashmap<=?
       _comparator112420_
       _hashmap1112421_
       _hashmap2112422_)))
  (define std/srfi/146/hash#hashmap<=?__2
    (lambda (_comparator112433_
             _hashmap1112434_
             _hashmap2112435_
             .
             _hashmaps112436_)
      (let ((_val112438_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112433_
                'std/srfi/128#comparator::t))))
        (if _val112438_ _val112438_ (error)))
      (let ((_val112441_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112434_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112441_ _val112441_ (error)))
      (let ((_val112444_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112435_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112444_ _val112444_ (error)))
      (if (std/srfi/146/hash#%hashmap<=?
           _comparator112433_
           _hashmap1112434_
           _hashmap2112435_)
          (apply std/srfi/146/hash#hashmap<=?
                 _comparator112433_
                 _hashmap2112435_
                 _hashmaps112436_)
          '#f)))
  (define std/srfi/146/hash#hashmap<=?
    (lambda _g295577_
      (let ((_g295576_ (let () (declare (not safe)) (##length _g295577_))))
        (cond ((let () (declare (not safe)) (##fx= _g295576_ 2))
               (apply std/srfi/146/hash#hashmap<=?__0 _g295577_))
              ((let () (declare (not safe)) (##fx= _g295576_ 3))
               (apply std/srfi/146/hash#hashmap<=?__1 _g295577_))
              ((let () (declare (not safe)) (##fx>= _g295576_ 3))
               (apply std/srfi/146/hash#hashmap<=?__2 _g295577_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap<=?
                _g295577_))))))
  (define std/srfi/146/hash#%hashmap<=?
    (lambda (_comparator112395_ _hashmap1112396_ _hashmap2112397_)
      (let ((_val112399_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112395_
                'std/srfi/128#comparator::t))))
        (if _val112399_ _val112399_ (error)))
      (let ((_val112402_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112396_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112402_ _val112402_ (error)))
      (let ((_val112405_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112397_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112405_ _val112405_ (error)))
      (std/srfi/146/hash#hashmap-every?
       (lambda (_key112408_ _value112409_)
         (std/srfi/146/hash#hashmap-ref__2
          _hashmap2112397_
          _key112408_
          (lambda () '#f)
          (lambda (_stored-value112412_)
            (std/srfi/128#=?
             _comparator112395_
             _value112409_
             _stored-value112412_))))
       _hashmap1112396_)))
  (define std/srfi/146/hash#hashmap>?__0
    (lambda (_comparator112362_ _hashmap112363_)
      (let ((_val112365_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112363_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112365_ _val112365_ (error)))
      '#t))
  (define std/srfi/146/hash#hashmap>?__1
    (lambda (_comparator112368_ _hashmap1112369_ _hashmap2112370_)
      (let ((_val112372_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112368_
                'std/srfi/128#comparator::t))))
        (if _val112372_ _val112372_ (error)))
      (let ((_val112375_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112369_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112375_ _val112375_ (error)))
      (let ((_val112378_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112370_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112378_ _val112378_ (error)))
      (std/srfi/146/hash#%hashmap>?
       _comparator112368_
       _hashmap1112369_
       _hashmap2112370_)))
  (define std/srfi/146/hash#hashmap>?__2
    (lambda (_comparator112381_
             _hashmap1112382_
             _hashmap2112383_
             .
             _hashmaps112384_)
      (let ((_val112386_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112381_
                'std/srfi/128#comparator::t))))
        (if _val112386_ _val112386_ (error)))
      (let ((_val112389_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112382_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112389_ _val112389_ (error)))
      (let ((_val112392_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112383_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112392_ _val112392_ (error)))
      (if (std/srfi/146/hash#%hashmap>?
           _comparator112381_
           _hashmap1112382_
           _hashmap2112383_)
          (apply std/srfi/146/hash#hashmap>?
                 _comparator112381_
                 _hashmap2112383_
                 _hashmaps112384_)
          '#f)))
  (define std/srfi/146/hash#hashmap>?
    (lambda _g295579_
      (let ((_g295578_ (let () (declare (not safe)) (##length _g295579_))))
        (cond ((let () (declare (not safe)) (##fx= _g295578_ 2))
               (apply std/srfi/146/hash#hashmap>?__0 _g295579_))
              ((let () (declare (not safe)) (##fx= _g295578_ 3))
               (apply std/srfi/146/hash#hashmap>?__1 _g295579_))
              ((let () (declare (not safe)) (##fx>= _g295578_ 3))
               (apply std/srfi/146/hash#hashmap>?__2 _g295579_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap>?
                _g295579_))))))
  (define std/srfi/146/hash#%hashmap>?
    (lambda (_comparator112349_ _hashmap1112350_ _hashmap2112351_)
      (let ((_val112353_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112349_
                'std/srfi/128#comparator::t))))
        (if _val112353_ _val112353_ (error)))
      (let ((_val112356_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112350_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112356_ _val112356_ (error)))
      (let ((_val112359_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112351_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112359_ _val112359_ (error)))
      (not (std/srfi/146/hash#%hashmap<=?
            _comparator112349_
            _hashmap1112350_
            _hashmap2112351_))))
  (define std/srfi/146/hash#hashmap<?__0
    (lambda (_comparator112316_ _hashmap112317_)
      (let ((_val112319_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112317_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112319_ _val112319_ (error)))
      '#t))
  (define std/srfi/146/hash#hashmap<?__1
    (lambda (_comparator112322_ _hashmap1112323_ _hashmap2112324_)
      (let ((_val112326_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112322_
                'std/srfi/128#comparator::t))))
        (if _val112326_ _val112326_ (error)))
      (let ((_val112329_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112323_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112329_ _val112329_ (error)))
      (let ((_val112332_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112324_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112332_ _val112332_ (error)))
      (std/srfi/146/hash#%hashmap<?
       _comparator112322_
       _hashmap1112323_
       _hashmap2112324_)))
  (define std/srfi/146/hash#hashmap<?__2
    (lambda (_comparator112335_
             _hashmap1112336_
             _hashmap2112337_
             .
             _hashmaps112338_)
      (let ((_val112340_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112335_
                'std/srfi/128#comparator::t))))
        (if _val112340_ _val112340_ (error)))
      (let ((_val112343_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112336_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112343_ _val112343_ (error)))
      (let ((_val112346_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112337_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112346_ _val112346_ (error)))
      (if (std/srfi/146/hash#%hashmap<?
           _comparator112335_
           _hashmap1112336_
           _hashmap2112337_)
          (apply std/srfi/146/hash#hashmap<?
                 _comparator112335_
                 _hashmap2112337_
                 _hashmaps112338_)
          '#f)))
  (define std/srfi/146/hash#hashmap<?
    (lambda _g295581_
      (let ((_g295580_ (let () (declare (not safe)) (##length _g295581_))))
        (cond ((let () (declare (not safe)) (##fx= _g295580_ 2))
               (apply std/srfi/146/hash#hashmap<?__0 _g295581_))
              ((let () (declare (not safe)) (##fx= _g295580_ 3))
               (apply std/srfi/146/hash#hashmap<?__1 _g295581_))
              ((let () (declare (not safe)) (##fx>= _g295580_ 3))
               (apply std/srfi/146/hash#hashmap<?__2 _g295581_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap<?
                _g295581_))))))
  (define std/srfi/146/hash#%hashmap<?
    (lambda (_comparator112303_ _hashmap1112304_ _hashmap2112305_)
      (let ((_val112307_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112303_
                'std/srfi/128#comparator::t))))
        (if _val112307_ _val112307_ (error)))
      (let ((_val112310_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112304_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112310_ _val112310_ (error)))
      (let ((_val112313_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112305_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112313_ _val112313_ (error)))
      (std/srfi/146/hash#%hashmap>?
       _comparator112303_
       _hashmap2112305_
       _hashmap1112304_)))
  (define std/srfi/146/hash#hashmap>=?__0
    (lambda (_comparator112270_ _hashmap112271_)
      (let ((_val112273_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112271_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112273_ _val112273_ (error)))
      '#t))
  (define std/srfi/146/hash#hashmap>=?__1
    (lambda (_comparator112276_ _hashmap1112277_ _hashmap2112278_)
      (let ((_val112280_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112276_
                'std/srfi/128#comparator::t))))
        (if _val112280_ _val112280_ (error)))
      (let ((_val112283_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112277_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112283_ _val112283_ (error)))
      (let ((_val112286_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112278_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112286_ _val112286_ (error)))
      (std/srfi/146/hash#%hashmap>=?
       _comparator112276_
       _hashmap1112277_
       _hashmap2112278_)))
  (define std/srfi/146/hash#hashmap>=?__2
    (lambda (_comparator112289_
             _hashmap1112290_
             _hashmap2112291_
             .
             _hashmaps112292_)
      (let ((_val112294_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112289_
                'std/srfi/128#comparator::t))))
        (if _val112294_ _val112294_ (error)))
      (let ((_val112297_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112290_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112297_ _val112297_ (error)))
      (let ((_val112300_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112291_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112300_ _val112300_ (error)))
      (if (std/srfi/146/hash#%hashmap>=?
           _comparator112289_
           _hashmap1112290_
           _hashmap2112291_)
          (apply std/srfi/146/hash#hashmap>=?
                 _comparator112289_
                 _hashmap2112291_
                 _hashmaps112292_)
          '#f)))
  (define std/srfi/146/hash#hashmap>=?
    (lambda _g295583_
      (let ((_g295582_ (let () (declare (not safe)) (##length _g295583_))))
        (cond ((let () (declare (not safe)) (##fx= _g295582_ 2))
               (apply std/srfi/146/hash#hashmap>=?__0 _g295583_))
              ((let () (declare (not safe)) (##fx= _g295582_ 3))
               (apply std/srfi/146/hash#hashmap>=?__1 _g295583_))
              ((let () (declare (not safe)) (##fx>= _g295582_ 3))
               (apply std/srfi/146/hash#hashmap>=?__2 _g295583_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap>=?
                _g295583_))))))
  (define std/srfi/146/hash#%hashmap>=?
    (lambda (_comparator112257_ _hashmap1112258_ _hashmap2112259_)
      (let ((_val112261_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112257_
                'std/srfi/128#comparator::t))))
        (if _val112261_ _val112261_ (error)))
      (let ((_val112264_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112258_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112264_ _val112264_ (error)))
      (let ((_val112267_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112259_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112267_ _val112267_ (error)))
      (not (std/srfi/146/hash#%hashmap<?
            _comparator112257_
            _hashmap1112258_
            _hashmap2112259_))))
  (define std/srfi/146/hash#%hashmap-union
    (lambda (_hashmap1112239_ _hashmap2112240_)
      (std/srfi/146/hash#hashmap-fold
       (lambda (_key2112242_ _value2112243_ _hashmap112244_)
         (let ((_g295584_
                (std/srfi/146/hash#hashmap-search
                 _hashmap112244_
                 _key2112242_
                 (lambda (_insert112246_ _ignore112247_)
                   (_insert112246_ _value2112243_ '#f))
                 (lambda (_key1112249_
                          _value1112250_
                          _update112251_
                          _remove112252_)
                   (_update112251_ _key1112249_ _value1112250_ '#f)))))
           (begin
             (let ((_g295585_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g295584_)
                          (##vector-length _g295584_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g295585_ 2)))
                   (error "Context expects 2 values" _g295585_)))
             (let ((_hashmap112254_
                    (let () (declare (not safe)) (##vector-ref _g295584_ 0)))
                   (_obj112255_
                    (let () (declare (not safe)) (##vector-ref _g295584_ 1))))
               _hashmap112254_))))
       _hashmap1112239_
       _hashmap2112240_)))
  (define std/srfi/146/hash#%hashmap-intersection
    (lambda (_hashmap1112233_ _hashmap2112234_)
      (std/srfi/146/hash#hashmap-filter
       (lambda (_key1112236_ _value1112237_)
         (std/srfi/146/hash#hashmap-contains? _hashmap2112234_ _key1112236_))
       _hashmap1112233_)))
  (define std/srfi/146/hash#%hashmap-difference
    (lambda (_hashmap1112215_ _hashmap2112216_)
      (std/srfi/146/hash#hashmap-fold
       (lambda (_key2112218_ _value2112219_ _hashmap112220_)
         (let ((_g295586_
                (std/srfi/146/hash#hashmap-search
                 _hashmap112220_
                 _key2112218_
                 (lambda (_insert112222_ _ignore112223_) (_ignore112223_ '#f))
                 (lambda (_key1112225_
                          _value1112226_
                          _update112227_
                          _remove112228_)
                   (_remove112228_ '#f)))))
           (begin
             (let ((_g295587_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g295586_)
                          (##vector-length _g295586_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g295587_ 2)))
                   (error "Context expects 2 values" _g295587_)))
             (let ((_hashmap112230_
                    (let () (declare (not safe)) (##vector-ref _g295586_ 0)))
                   (_obj112231_
                    (let () (declare (not safe)) (##vector-ref _g295586_ 1))))
               _hashmap112230_))))
       _hashmap1112215_
       _hashmap2112216_)))
  (define std/srfi/146/hash#%hashmap-xor
    (lambda (_hashmap1112197_ _hashmap2112198_)
      (std/srfi/146/hash#hashmap-fold
       (lambda (_key2112200_ _value2112201_ _hashmap112202_)
         (let ((_g295588_
                (std/srfi/146/hash#hashmap-search
                 _hashmap112202_
                 _key2112200_
                 (lambda (_insert112204_ _ignore112205_)
                   (_insert112204_ _value2112201_ '#f))
                 (lambda (_key1112207_
                          _value1112208_
                          _update112209_
                          _remove112210_)
                   (_remove112210_ '#f)))))
           (begin
             (let ((_g295589_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g295588_)
                          (##vector-length _g295588_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g295589_ 2)))
                   (error "Context expects 2 values" _g295589_)))
             (let ((_hashmap112212_
                    (let () (declare (not safe)) (##vector-ref _g295588_ 0)))
                   (_obj112213_
                    (let () (declare (not safe)) (##vector-ref _g295588_ 1))))
               _hashmap112212_))))
       _hashmap1112197_
       _hashmap2112198_)))
  (define std/srfi/146/hash#hashmap-union__0
    (lambda (_hashmap112173_)
      (let ((_val112175_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112173_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112175_ _val112175_ (error)))
      _hashmap112173_))
  (define std/srfi/146/hash#hashmap-union__1
    (lambda (_hashmap1112178_ _hashmap2112179_)
      (let ((_val112181_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112178_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112181_ _val112181_ (error)))
      (let ((_val112184_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112179_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112184_ _val112184_ (error)))
      (std/srfi/146/hash#%hashmap-union _hashmap1112178_ _hashmap2112179_)))
  (define std/srfi/146/hash#hashmap-union__2
    (lambda (_hashmap1112187_ _hashmap2112188_ . _hashmaps112189_)
      (let ((_val112191_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112187_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112191_ _val112191_ (error)))
      (let ((_val112194_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112188_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112194_ _val112194_ (error)))
      (apply std/srfi/146/hash#hashmap-union
             (std/srfi/146/hash#%hashmap-union
              _hashmap1112187_
              _hashmap2112188_)
             _hashmaps112189_)))
  (define std/srfi/146/hash#hashmap-union
    (lambda _g295591_
      (let ((_g295590_ (let () (declare (not safe)) (##length _g295591_))))
        (cond ((let () (declare (not safe)) (##fx= _g295590_ 1))
               (apply std/srfi/146/hash#hashmap-union__0 _g295591_))
              ((let () (declare (not safe)) (##fx= _g295590_ 2))
               (apply std/srfi/146/hash#hashmap-union__1 _g295591_))
              ((let () (declare (not safe)) (##fx>= _g295590_ 2))
               (apply std/srfi/146/hash#hashmap-union__2 _g295591_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap-union
                _g295591_))))))
  (define std/srfi/146/hash#hashmap-union! std/srfi/146/hash#hashmap-union)
  (define std/srfi/146/hash#hashmap-intersection__0
    (lambda (_hashmap112149_)
      (let ((_val112151_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112149_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112151_ _val112151_ (error)))
      _hashmap112149_))
  (define std/srfi/146/hash#hashmap-intersection__1
    (lambda (_hashmap1112154_ _hashmap2112155_)
      (let ((_val112157_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112154_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112157_ _val112157_ (error)))
      (let ((_val112160_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112155_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112160_ _val112160_ (error)))
      (std/srfi/146/hash#%hashmap-intersection
       _hashmap1112154_
       _hashmap2112155_)))
  (define std/srfi/146/hash#hashmap-intersection__2
    (lambda (_hashmap1112163_ _hashmap2112164_ . _hashmaps112165_)
      (let ((_val112167_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112163_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112167_ _val112167_ (error)))
      (let ((_val112170_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112164_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112170_ _val112170_ (error)))
      (apply std/srfi/146/hash#hashmap-intersection
             (std/srfi/146/hash#%hashmap-intersection
              _hashmap1112163_
              _hashmap2112164_)
             _hashmaps112165_)))
  (define std/srfi/146/hash#hashmap-intersection
    (lambda _g295593_
      (let ((_g295592_ (let () (declare (not safe)) (##length _g295593_))))
        (cond ((let () (declare (not safe)) (##fx= _g295592_ 1))
               (apply std/srfi/146/hash#hashmap-intersection__0 _g295593_))
              ((let () (declare (not safe)) (##fx= _g295592_ 2))
               (apply std/srfi/146/hash#hashmap-intersection__1 _g295593_))
              ((let () (declare (not safe)) (##fx>= _g295592_ 2))
               (apply std/srfi/146/hash#hashmap-intersection__2 _g295593_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap-intersection
                _g295593_))))))
  (define std/srfi/146/hash#hashmap-intersection!
    std/srfi/146/hash#hashmap-intersection)
  (define std/srfi/146/hash#hashmap-difference__0
    (lambda (_hashmap112125_)
      (let ((_val112127_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112125_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112127_ _val112127_ (error)))
      _hashmap112125_))
  (define std/srfi/146/hash#hashmap-difference__1
    (lambda (_hashmap1112130_ _hashmap2112131_)
      (let ((_val112133_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112130_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112133_ _val112133_ (error)))
      (let ((_val112136_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112131_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112136_ _val112136_ (error)))
      (std/srfi/146/hash#%hashmap-difference
       _hashmap1112130_
       _hashmap2112131_)))
  (define std/srfi/146/hash#hashmap-difference__2
    (lambda (_hashmap1112139_ _hashmap2112140_ . _hashmaps112141_)
      (let ((_val112143_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112139_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112143_ _val112143_ (error)))
      (let ((_val112146_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112140_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112146_ _val112146_ (error)))
      (apply std/srfi/146/hash#hashmap-difference
             (std/srfi/146/hash#%hashmap-difference
              _hashmap1112139_
              _hashmap2112140_)
             _hashmaps112141_)))
  (define std/srfi/146/hash#hashmap-difference
    (lambda _g295595_
      (let ((_g295594_ (let () (declare (not safe)) (##length _g295595_))))
        (cond ((let () (declare (not safe)) (##fx= _g295594_ 1))
               (apply std/srfi/146/hash#hashmap-difference__0 _g295595_))
              ((let () (declare (not safe)) (##fx= _g295594_ 2))
               (apply std/srfi/146/hash#hashmap-difference__1 _g295595_))
              ((let () (declare (not safe)) (##fx>= _g295594_ 2))
               (apply std/srfi/146/hash#hashmap-difference__2 _g295595_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap-difference
                _g295595_))))))
  (define std/srfi/146/hash#hashmap-difference!
    std/srfi/146/hash#hashmap-difference)
  (define std/srfi/146/hash#hashmap-xor__0
    (lambda (_hashmap112101_)
      (let ((_val112103_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap112101_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112103_ _val112103_ (error)))
      _hashmap112101_))
  (define std/srfi/146/hash#hashmap-xor__1
    (lambda (_hashmap1112106_ _hashmap2112107_)
      (let ((_val112109_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112106_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112109_ _val112109_ (error)))
      (let ((_val112112_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112107_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112112_ _val112112_ (error)))
      (std/srfi/146/hash#%hashmap-xor _hashmap1112106_ _hashmap2112107_)))
  (define std/srfi/146/hash#hashmap-xor__2
    (lambda (_hashmap1112115_ _hashmap2112116_ . _hashmaps112117_)
      (let ((_val112119_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap1112115_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112119_ _val112119_ (error)))
      (let ((_val112122_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _hashmap2112116_
                'std/srfi/146/hash#<hashmap>))))
        (if _val112122_ _val112122_ (error)))
      (apply std/srfi/146/hash#hashmap-xor
             (std/srfi/146/hash#%hashmap-xor _hashmap1112115_ _hashmap2112116_)
             _hashmaps112117_)))
  (define std/srfi/146/hash#hashmap-xor
    (lambda _g295597_
      (let ((_g295596_ (let () (declare (not safe)) (##length _g295597_))))
        (cond ((let () (declare (not safe)) (##fx= _g295596_ 1))
               (apply std/srfi/146/hash#hashmap-xor__0 _g295597_))
              ((let () (declare (not safe)) (##fx= _g295596_ 2))
               (apply std/srfi/146/hash#hashmap-xor__1 _g295597_))
              ((let () (declare (not safe)) (##fx>= _g295596_ 2))
               (apply std/srfi/146/hash#hashmap-xor__2 _g295597_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hash#hashmap-xor
                _g295597_))))))
  (define std/srfi/146/hash#hashmap-xor! std/srfi/146/hash#hashmap-xor)
  (define std/srfi/146/hash#hashmap-equality
    (lambda (_comparator112093_)
      (let ((_val112095_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112093_
                'std/srfi/128#comparator::t))))
        (if _val112095_ _val112095_ (error)))
      (lambda (_hashmap1112098_ _hashmap2112099_)
        (std/srfi/146/hash#%hashmap=?
         _comparator112093_
         _hashmap1112098_
         _hashmap2112099_))))
  (define std/srfi/146/hash#hashmap-hash-function
    (lambda (_comparator112086_)
      (let ((_val112088_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator112086_
                'std/srfi/128#comparator::t))))
        (if _val112088_ _val112088_ (error)))
      (lambda (_hashmap112091_) '0)))
  (define std/srfi/146/hash#make-hashmap-comparator
    (lambda (_comparator112084_)
      (let ((__tmp295599
             (std/srfi/146/hash#hashmap-equality _comparator112084_))
            (__tmp295598
             (std/srfi/146/hash#hashmap-hash-function _comparator112084_)))
        (declare (not safe))
        (##structure
         std/srfi/128#comparator::t
         std/srfi/146/hash#hashmap?
         __tmp295599
         '#f
         __tmp295598))))
  (define std/srfi/146/hash#hashmap-comparator
    (std/srfi/146/hash#make-hashmap-comparator
     (std/srfi/128#make-default-comparator)))
  (std/srfi/128#comparator-register-default!
   std/srfi/146/hash#hashmap-comparator))
