(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/159/show#nl (std/srfi/159/base#displayed '"\n"))
  (define std/srfi/159/show#fl
    (lambda (_st126058_)
      (let ((_col126061_
             (##structure-ref _st126058_ '3 std/srfi/159/base#Show-Env '#f)))
        ((let ()
           (std/srfi/159/base#displayed
            (if (zero? _col126061_)
                std/srfi/159/base#nothing
                std/srfi/159/show#nl)))
         _st126058_))))
  (define std/srfi/159/show#tab-to
    (lambda _o126044_
      (lambda (_st126046_)
        (let ((_col126049_
               (##structure-ref _st126046_ '3 std/srfi/159/base#Show-Env '#f))
              (_pad-char126050_
               (##structure-ref _st126046_ '7 std/srfi/159/base#Show-Env '#f)))
          ((let ()
             (std/srfi/159/base#displayed
              (let* ((_tab-width126053_
                      (if (pair? _o126044_) (car _o126044_) '8))
                     (_rem126055_ (modulo _col126049_ _tab-width126053_)))
                (if (positive? _rem126055_)
                    (std/srfi/159/base#displayed
                     (make-string
                      (- _tab-width126053_ _rem126055_)
                      _pad-char126050_))
                    std/srfi/159/base#nothing))))
           _st126046_)))))
  (define std/srfi/159/show#space-to
    (lambda (_where126035_)
      (lambda (_st126037_)
        (let ((_col126040_
               (##structure-ref _st126037_ '3 std/srfi/159/base#Show-Env '#f))
              (_pad-char126041_
               (##structure-ref _st126037_ '7 std/srfi/159/base#Show-Env '#f)))
          ((let ()
             (std/srfi/159/base#displayed
              (std/srfi/159/base#displayed
               (make-string
                (max '0 (- _where126035_ _col126040_))
                _pad-char126041_))))
           _st126037_)))))
  (define std/srfi/159/show#with-string-transformer
    (lambda (_proc126008_ . _ls126009_)
      (lambda (_st126011_)
        (let ((_output126014_
               (std/srfi/159/base#%ask119432 _st126011_ 'output)))
          ((let ()
             (std/srfi/159/base#displayed
              (let ((_output*126024_
                     (lambda (_str126017_)
                       (lambda (_st126019_)
                         (let ()
                           ((let ()
                              (std/srfi/159/base#displayed
                               (_output126014_ (_proc126008_ _str126017_))))
                            _st126019_))))))
                (lambda (_st126026_)
                  (let ((_tmp126029_
                         (std/srfi/159/base#%ask119432 _st126026_ 'output)))
                    (dynamic-wind
                     (lambda ()
                       (std/srfi/159/base#%tell120772
                        _st126026_
                        'output
                        _output*126024_))
                     (lambda ()
                       ((std/srfi/159/base#each
                         (std/srfi/159/base#each-in-list _ls126009_))
                        _st126026_))
                     (lambda ()
                       (std/srfi/159/base#%tell120772
                        _st126026_
                        'output
                        _tmp126029_))))))))
           _st126011_)))))
  (define std/srfi/159/show#upcased
    (lambda _ls126006_
      (apply std/srfi/159/show#with-string-transformer
             std/srfi/13#string-upcase
             _ls126006_)))
  (define std/srfi/159/show#downcased
    (lambda _ls126004_
      (apply std/srfi/159/show#with-string-transformer
             std/srfi/13#string-downcase
             _ls126004_)))
  (define std/srfi/159/show#padded/both
    (lambda (_width125983_ . _ls125984_)
      (std/srfi/159/base#call-with-output
       (std/srfi/159/base#each-in-list _ls125984_)
       (lambda (_str125986_)
         (lambda (_st125988_)
           (let ((_string-width125991_
                  (##structure-ref
                   _st125988_
                   '10
                   std/srfi/159/base#Show-Env
                   '#f))
                 (_pad-char125992_
                  (##structure-ref
                   _st125988_
                   '7
                   std/srfi/159/base#Show-Env
                   '#f)))
             ((let ()
                (std/srfi/159/base#displayed
                 (let ((_diff125995_
                        (- _width125983_ (_string-width125991_ _str125986_))))
                   (if (positive? _diff125995_)
                       (let* ((_diff/2125997_ (quotient _diff125995_ '2))
                              (_left125999_
                               (make-string _diff/2125997_ _pad-char125992_))
                              (_right126001_
                               (if (even? _diff125995_)
                                   _left125999_
                                   (make-string
                                    (+ '1 _diff/2125997_)
                                    _pad-char125992_))))
                         (std/srfi/159/base#each
                          _left125999_
                          _str125986_
                          _right126001_))
                       (std/srfi/159/base#displayed _str125986_)))))
              _st125988_)))))))
  (define std/srfi/159/show#padded/right
    (lambda (_width125967_ . _ls125968_)
      (lambda (_st125970_)
        (let ((_col1125973_
               (##structure-ref _st125970_ '3 std/srfi/159/base#Show-Env '#f)))
          ((let ()
             (std/srfi/159/base#displayed
              (std/srfi/159/base#each
               (std/srfi/159/base#each-in-list _ls125968_)
               (lambda (_st125976_)
                 (let ((_col2125979_
                        (##structure-ref
                         _st125976_
                         '3
                         std/srfi/159/base#Show-Env
                         '#f))
                       (_pad-char125980_
                        (##structure-ref
                         _st125976_
                         '7
                         std/srfi/159/base#Show-Env
                         '#f)))
                   ((let ()
                      (std/srfi/159/base#displayed
                       (std/srfi/159/base#displayed
                        (make-string
                         (max '0
                              (- _width125967_ (- _col2125979_ _col1125973_)))
                         _pad-char125980_))))
                    _st125976_))))))
           _st125970_)))))
  (define std/srfi/159/show#padded/left
    (lambda (_width125953_ . _ls125954_)
      (std/srfi/159/base#call-with-output
       (std/srfi/159/base#each-in-list _ls125954_)
       (lambda (_str125956_)
         (lambda (_st125958_)
           (let ((_string-width125961_
                  (##structure-ref
                   _st125958_
                   '10
                   std/srfi/159/base#Show-Env
                   '#f))
                 (_pad-char125962_
                  (##structure-ref
                   _st125958_
                   '7
                   std/srfi/159/base#Show-Env
                   '#f)))
             ((let ()
                (std/srfi/159/base#displayed
                 (let ((_diff125965_
                        (- _width125953_ (_string-width125961_ _str125956_))))
                   (std/srfi/159/base#each
                    (make-string (max '0 _diff125965_) _pad-char125962_)
                    _str125956_))))
              _st125958_)))))))
  (define std/srfi/159/show#padded std/srfi/159/show#padded/left)
  (define std/srfi/159/show#trimmed/buffered
    (lambda (_width125936_ _producer125937_ _proc125938_)
      (std/srfi/159/base#call-with-output
       _producer125937_
       (lambda (_str125940_)
         (lambda (_st125942_)
           (let ((_string-width125945_
                  (##structure-ref
                   _st125942_
                   '10
                   std/srfi/159/base#Show-Env
                   '#f)))
             ((let ()
                (std/srfi/159/base#displayed
                 (let* ((_str-width125948_ (_string-width125945_ _str125940_))
                        (_diff125950_ (- _str-width125948_ _width125936_)))
                   (std/srfi/159/base#displayed
                    (if (positive? _diff125950_)
                        (_proc125938_
                         _str125940_
                         _str-width125948_
                         _diff125950_)
                        _str125940_)))))
              _st125942_)))))))
  (define std/srfi/159/show#trimmed/right
    (lambda (_width125911_ . _ls125912_)
      (std/srfi/159/show#trimmed/buffered
       _width125911_
       (std/srfi/159/base#each-in-list _ls125912_)
       (lambda (_str125914_ _str-width125915_ _diff125916_)
         (lambda (_st125918_)
           (let ((_ellipsis125921_
                  (##structure-ref
                   _st125918_
                   '11
                   std/srfi/159/base#Show-Env
                   '#f))
                 (_string-width125922_
                  (##structure-ref
                   _st125918_
                   '10
                   std/srfi/159/base#Show-Env
                   '#f))
                 (_col125923_
                  (##structure-ref
                   _st125918_
                   '3
                   std/srfi/159/base#Show-Env
                   '#f)))
             ((let ()
                (std/srfi/159/base#displayed
                 (let* ((_ell125929_
                         (if (char? _ellipsis125921_)
                             (string _ellipsis125921_)
                             (let ((_$e125926_ _ellipsis125921_))
                               (if _$e125926_ _$e125926_ '""))))
                        (_ell-len125931_ (_string-width125922_ _ell125929_))
                        (_diff125933_
                         (- (+ _str-width125915_ _ell-len125931_)
                            _width125911_)))
                   (std/srfi/159/base#each
                    (if (negative? _diff125933_)
                        std/srfi/159/base#nothing
                        (substring
                         _str125914_
                         '0
                         (- _width125911_ _ell-len125931_)))
                    _ell125929_))))
              _st125918_)))))))
  (define std/srfi/159/show#trimmed/left
    (lambda (_width125887_ . _ls125888_)
      (std/srfi/159/show#trimmed/buffered
       _width125887_
       (std/srfi/159/base#each-in-list _ls125888_)
       (lambda (_str125890_ _str-width125891_ _diff125892_)
         (lambda (_st125894_)
           (let ((_ellipsis125897_
                  (##structure-ref
                   _st125894_
                   '11
                   std/srfi/159/base#Show-Env
                   '#f))
                 (_string-width125898_
                  (##structure-ref
                   _st125894_
                   '10
                   std/srfi/159/base#Show-Env
                   '#f)))
             ((let ()
                (std/srfi/159/base#displayed
                 (let* ((_ell125904_
                         (if (char? _ellipsis125897_)
                             (string _ellipsis125897_)
                             (let ((_$e125901_ _ellipsis125897_))
                               (if _$e125901_ _$e125901_ '""))))
                        (_ell-len125906_ (_string-width125898_ _ell125904_))
                        (_diff125908_
                         (- (+ _str-width125891_ _ell-len125906_)
                            _width125887_)))
                   (std/srfi/159/base#each
                    _ell125904_
                    (if (negative? _diff125908_)
                        std/srfi/159/base#nothing
                        (std/srfi/159/string#substring*__0
                         _str125890_
                         _diff125908_))))))
              _st125894_)))))))
  (define std/srfi/159/show#trimmed std/srfi/159/show#trimmed/left)
  (define std/srfi/159/show#trimmed/both
    (lambda (_width125859_ . _ls125860_)
      (std/srfi/159/show#trimmed/buffered
       _width125859_
       (std/srfi/159/base#each-in-list _ls125860_)
       (lambda (_str125862_ _str-width125863_ _diff125864_)
         (lambda (_st125866_)
           (let ((_ellipsis125869_
                  (##structure-ref
                   _st125866_
                   '11
                   std/srfi/159/base#Show-Env
                   '#f))
                 (_string-width125870_
                  (##structure-ref
                   _st125866_
                   '10
                   std/srfi/159/base#Show-Env
                   '#f)))
             ((let ()
                (std/srfi/159/base#displayed
                 (let* ((_ell125876_
                         (if (char? _ellipsis125869_)
                             (string _ellipsis125869_)
                             (let ((_$e125873_ _ellipsis125869_))
                               (if _$e125873_ _$e125873_ '""))))
                        (_ell-len125878_ (_string-width125870_ _ell125876_))
                        (_diff125880_
                         (- (+ _str-width125863_
                               _ell-len125878_
                               _ell-len125878_)
                            _width125859_))
                        (_left125882_ (quotient _diff125880_ '2))
                        (_right125884_
                         (- (_string-width125870_ _str125862_)
                            (quotient (+ _diff125880_ '1) '2))))
                   (if (negative? _diff125880_)
                       _ell125876_
                       (std/srfi/159/base#each
                        _ell125876_
                        (substring _str125862_ _left125882_ _right125884_)
                        _ell125876_)))))
              _st125866_)))))))
  (define std/srfi/159/show#trimmed/lazy
    (lambda (_width125813_ . _ls125814_)
      (lambda (_st125816_)
        (let ((_orig-output125819_
               (std/srfi/159/base#%ask119432 _st125816_ 'output))
              (_string-width125820_
               (##structure-ref
                _st125816_
                '10
                std/srfi/159/base#Show-Env
                '#f)))
          ((let ()
             (std/srfi/159/base#displayed
              (call-with-current-continuation
               (lambda (_return125823_)
                 (let ((_chars-written125828_ '0)
                       (_output125829_
                        (let ((_$e125825_ _orig-output125819_))
                          (if _$e125825_
                              _$e125825_
                              std/srfi/159/base#output-default))))
                   (letrec ((_output*125831_
                             (lambda (_str125842_)
                               (let ((_len125844_
                                      (_string-width125820_ _str125842_)))
                                 (set! _chars-written125828_
                                       (+ _chars-written125828_ _len125844_))
                                 (if (> _chars-written125828_ _width125813_)
                                     (let* ((_end125846_
                                             (max '0
                                                  (- _len125844_
                                                     (- _chars-written125828_
                                                        _width125813_))))
                                            (_s125848_
                                             (substring
                                              _str125842_
                                              '0
                                              _end125846_)))
                                       (std/srfi/159/base#each
                                        (_output125829_ _s125848_)
                                        (lambda (_st125851_)
                                          (std/srfi/159/base#%tell120772
                                           _st125851_
                                           'output
                                           _orig-output125819_)
                                          _st125851_)
                                        (lambda (_st125854_)
                                          (let ()
                                            ((let ()
                                               (std/srfi/159/base#displayed
                                                (_return125823_
                                                 std/srfi/159/base#nothing)))
                                             _st125854_)))))
                                     (_output125829_ _str125842_))))))
                     (lambda (_st125833_)
                       (let ((_tmp125836_
                              (std/srfi/159/base#%ask119432
                               _st125833_
                               'output)))
                         (dynamic-wind
                          (lambda ()
                            (std/srfi/159/base#%tell120772
                             _st125833_
                             'output
                             _output*125831_))
                          (lambda ()
                            ((std/srfi/159/base#each
                              (std/srfi/159/base#each-in-list _ls125814_))
                             _st125833_))
                          (lambda ()
                            (std/srfi/159/base#%tell120772
                             _st125833_
                             'output
                             _tmp125836_)))))))))))
           _st125816_)))))
  (define std/srfi/159/show#fitted/right
    (lambda (_width125810_ . _ls125811_)
      (std/srfi/159/show#padded/right
       _width125810_
       (std/srfi/159/show#trimmed/right
        _width125810_
        (std/srfi/159/base#each-in-list _ls125811_)))))
  (define std/srfi/159/show#fitted/left
    (lambda (_width125807_ . _ls125808_)
      (std/srfi/159/show#padded/left
       _width125807_
       (std/srfi/159/show#trimmed/left
        _width125807_
        (std/srfi/159/base#each-in-list _ls125808_)))))
  (define std/srfi/159/show#fitted std/srfi/159/show#fitted/left)
  (define std/srfi/159/show#fitted/both
    (lambda (_width125804_ . _ls125805_)
      (std/srfi/159/show#padded/both
       _width125804_
       (std/srfi/159/show#trimmed/both
        _width125804_
        (std/srfi/159/base#each-in-list _ls125805_)))))
  (define std/srfi/159/show#joined/general
    (lambda (_elt-f125789_
             _last-f125790_
             _dot-f125791_
             _init-ls125792_
             _sep125793_)
      (lambda (_st125795_)
        (let ()
          ((let ()
             (std/srfi/159/base#displayed
              (let _lp125800_ ((_ls125802_ _init-ls125792_))
                (if (pair? _ls125802_)
                    (std/srfi/159/base#each
                     (if (eq? _ls125802_ _init-ls125792_)
                         std/srfi/159/base#nothing
                         _sep125793_)
                     ((if (and _last-f125790_ (null? (cdr _ls125802_)))
                          _last-f125790_
                          _elt-f125789_)
                      (car _ls125802_))
                     (_lp125800_ (cdr _ls125802_)))
                    (if (and _dot-f125791_ (not (null? _ls125802_)))
                        (std/srfi/159/base#each
                         (if (eq? _ls125802_ _init-ls125792_)
                             std/srfi/159/base#nothing
                             _sep125793_)
                         (_dot-f125791_ _ls125802_))
                        std/srfi/159/base#nothing)))))
           _st125795_)))))
  (define std/srfi/159/show#joined
    (lambda (_elt-f125785_ _ls125786_ . _o125787_)
      (std/srfi/159/show#joined/general
       _elt-f125785_
       '#f
       '#f
       _ls125786_
       (if (pair? _o125787_) (car _o125787_) '""))))
  (define std/srfi/159/show#joined/prefix
    (lambda (_elt-f125779_ _ls125780_ . _o125781_)
      (if (null? _ls125780_)
          std/srfi/159/base#nothing
          (let ((_sep125783_ (if (pair? _o125781_) (car _o125781_) '"")))
            (std/srfi/159/base#each
             _sep125783_
             (std/srfi/159/show#joined
              _elt-f125779_
              _ls125780_
              _sep125783_))))))
  (define std/srfi/159/show#joined/suffix
    (lambda (_elt-f125773_ _ls125774_ . _o125775_)
      (if (null? _ls125774_)
          std/srfi/159/base#nothing
          (let ((_sep125777_ (if (pair? _o125775_) (car _o125775_) '"")))
            (std/srfi/159/base#each
             (std/srfi/159/show#joined _elt-f125773_ _ls125774_ _sep125777_)
             _sep125777_)))))
  (define std/srfi/159/show#joined/last
    (lambda (_elt-f125768_ _last-f125769_ _ls125770_ . _o125771_)
      (std/srfi/159/show#joined/general
       _elt-f125768_
       _last-f125769_
       '#f
       _ls125770_
       (if (pair? _o125771_) (car _o125771_) '""))))
  (define std/srfi/159/show#joined/dot
    (lambda (_elt-f125763_ _dot-f125764_ _ls125765_ . _o125766_)
      (std/srfi/159/show#joined/general
       _elt-f125763_
       '#f
       _dot-f125764_
       _ls125765_
       (if (pair? _o125766_) (car _o125766_) '""))))
  (define std/srfi/159/show#joined/range
    (lambda (_elt-f125747_ _start125748_ . _o125749_)
      (let ((_end125751_ (if (pair? _o125749_) (car _o125749_) '#f))
            (_sep125752_
             (if (and (pair? _o125749_) (pair? (cdr _o125749_)))
                 (cadr _o125749_)
                 '"")))
        (let _lp125754_ ((_i125756_ _start125748_))
          (if (and _end125751_ (>= _i125756_ _end125751_))
              std/srfi/159/base#nothing
              (std/srfi/159/base#each
               (if (> _i125756_ _start125748_)
                   _sep125752_
                   std/srfi/159/base#nothing)
               (_elt-f125747_ _i125756_)
               (lambda (_st125758_)
                 (let ()
                   ((let ()
                      (std/srfi/159/base#displayed
                       (_lp125754_ (+ _i125756_ '1))))
                    _st125758_))))))))))
