(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/78#check:write write)
  (define std/srfi/78#check:mode '#f)
  (define std/srfi/78#check-set-mode!
    (lambda (_mode90743_)
      (set! std/srfi/78#check:mode
            (let ((_$e90745_ _mode90743_))
              (if (eq? 'off _$e90745_)
                  '0
                  (if (eq? 'summary _$e90745_)
                      '1
                      (if (eq? 'report-failed _$e90745_)
                          '10
                          (if (eq? 'report _$e90745_)
                              '100
                              (error '"unrecognized mode" _mode90743_)))))))))
  (std/srfi/78#check-set-mode! 'report)
  (define std/srfi/78#check:correct '#f)
  (define std/srfi/78#check:failed '#f)
  (define std/srfi/78#check-reset!
    (lambda ()
      (set! std/srfi/78#check:correct '0)
      (set! std/srfi/78#check:failed '())))
  (define std/srfi/78#check:add-correct!
    (lambda ()
      (set! std/srfi/78#check:correct (+ std/srfi/78#check:correct '1))))
  (define std/srfi/78#check:add-failed!
    (lambda (_expression90737_ _actual-result90738_ _expected-result90739_)
      (set! std/srfi/78#check:failed
            (cons (list _expression90737_
                        _actual-result90738_
                        _expected-result90739_)
                  std/srfi/78#check:failed))))
  (std/srfi/78#check-reset!)
  (define std/srfi/78#check:report-expression
    (lambda (_expression90735_)
      (newline)
      (std/srfi/78#check:write _expression90735_)
      (display '" => ")))
  (define std/srfi/78#check:report-actual-result
    (lambda (_actual-result90733_)
      (std/srfi/78#check:write _actual-result90733_)
      (display '" ; ")))
  (define std/srfi/78#check:report-correct
    (lambda (_cases90731_)
      (display '"correct")
      (if (not (= _cases90731_ '1))
          (begin
            (display '" (")
            (display _cases90731_)
            (display '" cases checked)"))
          '#!void)
      (newline)))
  (define std/srfi/78#check:report-failed
    (lambda (_expected-result90729_)
      (display '"*** failed ***")
      (newline)
      (display '" ; expected result: ")
      (std/srfi/78#check:write _expected-result90729_)
      (newline)))
  (define std/srfi/78#check-report
    (lambda ()
      (if (>= std/srfi/78#check:mode '1)
          (begin
            (newline)
            (display '"; *** checks *** : ")
            (display std/srfi/78#check:correct)
            (display '" correct, ")
            (display (length std/srfi/78#check:failed))
            (display '" failed.")
            (if (or (null? std/srfi/78#check:failed)
                    (<= std/srfi/78#check:mode '1))
                (newline)
                (let* ((_w90720_ (car (reverse std/srfi/78#check:failed)))
                       (_expression90722_ (car _w90720_))
                       (_actual-result90724_ (cadr _w90720_))
                       (_expected-result90726_ (caddr _w90720_)))
                  (display '" First failed example:")
                  (newline)
                  (std/srfi/78#check:report-expression _expression90722_)
                  (std/srfi/78#check:report-actual-result _actual-result90724_)
                  (std/srfi/78#check:report-failed _expected-result90726_))))
          '#!void)))
  (define std/srfi/78#check-passed?
    (lambda (_expected-total-count90714_)
      (if (= (length std/srfi/78#check:failed) '0)
          (= std/srfi/78#check:correct _expected-total-count90714_)
          '#f)))
  (define std/srfi/78#check:proc
    (lambda (_expression90700_
             _thunk90701_
             _equal90702_
             _expected-result90703_)
      (let ((_$e90705_ std/srfi/78#check:mode))
        (if (eq? '0 _$e90705_)
            '#f
            (if (eq? '1 _$e90705_)
                (let ((_actual-result90708_ (_thunk90701_)))
                  (if (_equal90702_
                       _actual-result90708_
                       _expected-result90703_)
                      (std/srfi/78#check:add-correct!)
                      (std/srfi/78#check:add-failed!
                       _expression90700_
                       _actual-result90708_
                       _expected-result90703_)))
                (if (eq? '10 _$e90705_)
                    (let ((_actual-result90710_ (_thunk90701_)))
                      (if (_equal90702_
                           _actual-result90710_
                           _expected-result90703_)
                          (std/srfi/78#check:add-correct!)
                          (begin
                            (std/srfi/78#check:report-expression
                             _expression90700_)
                            (std/srfi/78#check:report-actual-result
                             _actual-result90710_)
                            (std/srfi/78#check:report-failed
                             _expected-result90703_)
                            (std/srfi/78#check:add-failed!
                             _expression90700_
                             _actual-result90710_
                             _expected-result90703_))))
                    (if (eq? '100 _$e90705_)
                        (begin
                          (std/srfi/78#check:report-expression
                           _expression90700_)
                          (let ((_actual-result90712_ (_thunk90701_)))
                            (std/srfi/78#check:report-actual-result
                             _actual-result90712_)
                            (if (_equal90702_
                                 _actual-result90712_
                                 _expected-result90703_)
                                (begin
                                  (std/srfi/78#check:report-correct '1)
                                  (std/srfi/78#check:add-correct!))
                                (begin
                                  (std/srfi/78#check:report-failed
                                   _expected-result90703_)
                                  (std/srfi/78#check:add-failed!
                                   _expression90700_
                                   _actual-result90712_
                                   _expected-result90703_)))))
                        (error '"unrecognized check:mode"
                               std/srfi/78#check:mode))))))
      (if '#f '#f '#!void)))
  (define std/srfi/78#check:proc-ec
    (lambda (_w90692_)
      (let ((_correct?90694_ (car _w90692_))
            (_expression90695_ (cadr _w90692_))
            (_actual-result90696_ (caddr _w90692_))
            (_expected-result90697_ (cadddr _w90692_))
            (_cases90698_ (car (cddddr _w90692_))))
        (if _correct?90694_
            (begin
              (if (>= std/srfi/78#check:mode '100)
                  (begin
                    (std/srfi/78#check:report-expression _expression90695_)
                    (std/srfi/78#check:report-actual-result
                     _actual-result90696_)
                    (std/srfi/78#check:report-correct _cases90698_))
                  '#!void)
              (std/srfi/78#check:add-correct!))
            (begin
              (if (>= std/srfi/78#check:mode '10)
                  (begin
                    (std/srfi/78#check:report-expression _expression90695_)
                    (std/srfi/78#check:report-actual-result
                     _actual-result90696_)
                    (std/srfi/78#check:report-failed _expected-result90697_))
                  '#!void)
              (std/srfi/78#check:add-failed!
               _expression90695_
               _actual-result90696_
               _expected-result90697_)))))))
