(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/srfi-135/etc#string-copy!
    (lambda (_s101177_ _i101178_ _x101179_)
      (substring-move!
       _s101177_
       _i101178_
       _x101179_
       '0
       (string-length _x101179_))))
  (define std/srfi/srfi-135/etc#div-and-mod
    (lambda (_x101164_ _y101165_)
      (if (and (exact-integer? _x101164_) (exact-integer? _y101165_))
          (if (= _y101165_ '0)
              (error '"mod: zero divisor" _x101164_ _y101165_)
              (if (>= _x101164_ '0)
                  (values (quotient _x101164_ _y101165_)
                          (remainder _x101164_ _y101165_))
                  (if (< _y101165_ '0)
                      (let* ((_q101167_ (quotient _x101164_ _y101165_))
                             (_r101169_ (- _x101164_ (* _q101167_ _y101165_))))
                        (if (= _r101169_ '0)
                            (values _q101167_ '0)
                            (values (+ _q101167_ '1) (- _r101169_ _y101165_))))
                      (let* ((_q101172_ (quotient _x101164_ _y101165_))
                             (_r101174_ (- _x101164_ (* _q101172_ _y101165_))))
                        (if (= _r101174_ '0)
                            (values _q101172_ '0)
                            (values (- _q101172_ '1)
                                    (+ _r101174_ _y101165_)))))))
          (error '"div or mod: illegal arguments" _x101164_ _y101165_))))
  (define std/srfi/srfi-135/etc#div
    (lambda (_x101157_ _y101158_)
      (if (and (exact-integer? _x101157_)
               (exact-integer? _y101158_)
               (>= _x101157_ '0))
          (quotient _x101157_ _y101158_)
          (call-with-values
           (lambda () (std/srfi/srfi-135/etc#div-and-mod _x101157_ _y101158_))
           (lambda (_q101161_ _r101162_) _q101161_)))))
  (define std/srfi/srfi-135/etc#mod
    (lambda (_x101150_ _y101151_)
      (if (and (exact-integer? _x101150_)
               (exact-integer? _y101151_)
               (>= _x101150_ '0))
          (remainder _x101150_ _y101151_)
          (call-with-values
           (lambda () (std/srfi/srfi-135/etc#div-and-mod _x101150_ _y101151_))
           (lambda (_q101154_ _r101155_) _r101155_)))))
  (define std/srfi/srfi-135/etc#last-pair
    (lambda (_x101148_)
      (if (and (pair? _x101148_) (pair? (cdr _x101148_)))
          (std/srfi/srfi-135/etc#last-pair (cdr _x101148_))
          _x101148_)))
  (define std/srfi/srfi-135/etc#list-take
    (lambda (_x101139_ _n101140_)
      (let _loop101142_ ((_n101144_ _n101140_)
                         (_x101145_ _x101139_)
                         (_y101146_ '()))
        (if (= _n101144_ '0)
            (reverse _y101146_)
            (_loop101142_
             (- _n101144_ '1)
             (cdr _x101145_)
             (cons (car _x101145_) _y101146_)))))))
