(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/text/base58#alphabet::t
    (make-struct-type
     'std/text/base58#alphabet::t
     '#f
     '2
     'alphabet
     '((final: . #t))
     ':init!
     '(enc dec)))
  (define std/text/base58#alphabet?
    (make-struct-predicate std/text/base58#alphabet::t))
  (define std/text/base58#make-alphabet
    (lambda _$args167489_
      (apply make-struct-instance std/text/base58#alphabet::t _$args167489_)))
  (define std/text/base58#alphabet-enc
    (make-struct-field-accessor std/text/base58#alphabet::t '0))
  (define std/text/base58#alphabet-dec
    (make-struct-field-accessor std/text/base58#alphabet::t '1))
  (define std/text/base58#alphabet-enc-set!
    (make-struct-field-mutator std/text/base58#alphabet::t '0))
  (define std/text/base58#alphabet-dec-set!
    (make-struct-field-mutator std/text/base58#alphabet::t '1))
  (define std/text/base58#&alphabet-enc
    (make-struct-field-unchecked-accessor std/text/base58#alphabet::t '0))
  (define std/text/base58#&alphabet-dec
    (make-struct-field-unchecked-accessor std/text/base58#alphabet::t '1))
  (define std/text/base58#&alphabet-enc-set!
    (make-struct-field-unchecked-mutator std/text/base58#alphabet::t '0))
  (define std/text/base58#&alphabet-dec-set!
    (make-struct-field-unchecked-mutator std/text/base58#alphabet::t '1))
  (define std/text/base58#alphabet:::init!
    (lambda (_self167476_ _str167477_)
      (let* ((_alpha167479_ (string->list _str167477_))
             (_enc167481_ (list->vector _alpha167479_))
             (_dec167483_ (make-vector '128 '#f)))
        (for-each
         (lambda (_i167486_ _a167487_)
           (vector-set! _dec167483_ (char->integer _a167487_) _i167486_))
         (iota (string-length _str167477_))
         _alpha167479_)
        (if (##fx< '2 (##vector-length _self167476_))
            (begin
              (##vector-set! _self167476_ '1 _enc167481_)
              (##vector-set! _self167476_ '2 _dec167483_))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self167476_)))))
  (bind-method!
   std/text/base58#alphabet::t
   ':init!
   std/text/base58#alphabet:::init!
   '#f)
  (define std/text/base58#alphabet-encode
    (lambda (_ab167350_ _i167351_)
      (vector-ref
       (##unchecked-structure-ref
        _ab167350_
        '1
        std/text/base58#alphabet::t
        '#f)
       _i167351_)))
  (define std/text/base58#alphabet-decode
    (lambda (_ab167345_ _char167346_)
      (let ((_i167348_ (char->integer _char167346_)))
        (if (fx< _i167348_ '128)
            (vector-ref
             (##unchecked-structure-ref
              _ab167345_
              '2
              std/text/base58#alphabet::t
              '#f)
             _i167348_)
            '#f))))
  (define std/text/base58#base58-btc-alphabet
    (let ((__obj290288 (make-object std/text/base58#alphabet::t '2)))
      (std/text/base58#alphabet:::init!
       __obj290288
       '"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz")
      __obj290288))
  (define std/text/base58#base58-flickr-alphabet
    (let ((__obj290289 (make-object std/text/base58#alphabet::t '2)))
      (std/text/base58#alphabet:::init!
       __obj290289
       '"123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ")
      __obj290289))
  (define std/text/base58#base58-encode__%
    (lambda (_bytes167309_ _ab167310_)
      (let* ((_idx167312_
              (fx+ (fxquotient (fx* (u8vector-length _bytes167309_) '138) '100)
                   '1))
             (_str167314_ (make-string _idx167312_)))
        (let _lp167317_ ((_bn167319_
                          (std/text/base58#bytes->integer _bytes167309_))
                         (_idx167320_ _idx167312_))
          (if (zero? _bn167319_)
              (let ((_zero167322_
                     (std/text/base58#alphabet-encode _ab167310_ '0)))
                (let _pad167324_ ((_i167326_ '0) (_idx167327_ _idx167320_))
                  (if (and (fx< _i167326_ (u8vector-length _bytes167309_))
                           (fxzero? (u8vector-ref _bytes167309_ _i167326_)))
                      (let ((_idx167329_ (fx- _idx167327_ '1)))
                        (string-set! _str167314_ _idx167329_ _zero167322_)
                        (_pad167324_ (fx+ _i167326_ '1) _idx167329_))
                      (substring
                       _str167314_
                       _idx167327_
                       (string-length _str167314_)))))
              (let ((_bn167331_ (quotient _bn167319_ '58))
                    (_mo167332_ (modulo _bn167319_ '58))
                    (_idx167333_ (fx- _idx167320_ '1)))
                (string-set!
                 _str167314_
                 _idx167333_
                 (std/text/base58#alphabet-encode _ab167310_ _mo167332_))
                (_lp167317_ _bn167331_ _idx167333_)))))))
  (define std/text/base58#base58-encode__0
    (lambda (_bytes167338_)
      (let ((_ab167340_ std/text/base58#base58-btc-alphabet))
        (std/text/base58#base58-encode__% _bytes167338_ _ab167340_))))
  (define std/text/base58#base58-encode
    (lambda _g290291_
      (let ((_g290290_ (##length _g290291_)))
        (cond ((##fx= _g290290_ 1)
               (apply std/text/base58#base58-encode__0 _g290291_))
              ((##fx= _g290290_ 2)
               (apply std/text/base58#base58-encode__% _g290291_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/base58#base58-encode
                _g290291_))))))
  (define std/text/base58#base58-decode__%
    (lambda (_str167274_ _ab167275_)
      (letrec* ((_leading-zeros167277_
                 (let ((_zero167292_
                        (std/text/base58#alphabet-encode _ab167275_ '0)))
                   (let _lp167294_ ((_i167296_ '0))
                     (if (and (fx< _i167296_ (string-length _str167274_))
                              (eq? _zero167292_
                                   (string-ref _str167274_ _i167296_)))
                         (_lp167294_ (fx+ _i167296_ '1))
                         (make-u8vector _i167296_ '0))))))
        (let _lp167279_ ((_i167281_ '0) (_bn167282_ '0))
          (if (fx< _i167281_ (string-length _str167274_))
              (let ((_char167284_ (string-ref _str167274_ _i167281_)))
                (let ((_$e167287_
                       (std/text/base58#alphabet-decode
                        _ab167275_
                        _char167284_)))
                  (if _$e167287_
                      ((lambda (_c167290_)
                         (_lp167279_
                          (fx+ _i167281_ '1)
                          (+ (* _bn167282_ '58) _c167290_)))
                       _$e167287_)
                      (std/error#raise-io-error
                       'base58-decode
                       '"Invalid character"
                       _str167274_
                       _char167284_))))
              (u8vector-append
               _leading-zeros167277_
               (std/text/base58#integer->bytes _bn167282_)))))))
  (define std/text/base58#base58-decode__0
    (lambda (_str167301_)
      (let ((_ab167303_ std/text/base58#base58-btc-alphabet))
        (std/text/base58#base58-decode__% _str167301_ _ab167303_))))
  (define std/text/base58#base58-decode
    (lambda _g290293_
      (let ((_g290292_ (##length _g290293_)))
        (cond ((##fx= _g290292_ 1)
               (apply std/text/base58#base58-decode__0 _g290293_))
              ((##fx= _g290292_ 2)
               (apply std/text/base58#base58-decode__% _g290293_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/base58#base58-decode
                _g290293_))))))
  (define std/text/base58#bytes->integer
    (lambda (_bytes167264_)
      (let _lp167266_ ((_i167268_ '0) (_r167269_ '0))
        (if (fx< _i167268_ (u8vector-length _bytes167264_))
            (let ((_b167271_ (u8vector-ref _bytes167264_ _i167268_)))
              (_lp167266_
               (fx+ _i167268_ '1)
               (bitwise-ior (arithmetic-shift _r167269_ '8) _b167271_)))
            _r167269_))))
  (define std/text/base58#integer->bytes
    (lambda (_x167257_)
      (let _lp167259_ ((_x167261_ _x167257_) (_r167262_ '()))
        (if (positive? _x167261_)
            (_lp167259_
             (arithmetic-shift _x167261_ '-8)
             (cons (bitwise-and _x167261_ '255) _r167262_))
            (list->u8vector _r167262_))))))
