(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/text/utf16#string->utf16__%
    (lambda (_str167103_ _endianness167104_ _BOM?167105_)
      (if (string? _str167103_) '#!void (error '"Expected string" _str167103_))
      (let ((_u16-set!167110_
             (let ((_$e167107_ _endianness167104_))
               (if (eq? 'big _$e167107_)
                   std/text/utf16#u16-set!/be
                   (if (eq? 'little _$e167107_)
                       std/text/utf16#u16-set!/le
                       (if (eq? 'native _$e167107_)
                           std/misc/bytes#&u8vector-u16-set!/native
                           (error '"Bad endianness" _endianness167104_)))))))
        (std/text/utf16#utf16-encode
         _str167103_
         _u16-set!167110_
         _BOM?167105_))))
  (define std/text/utf16#string->utf16__0
    (lambda (_str167115_)
      (let* ((_endianness167117_ std/misc/bytes#big) (_BOM?167119_ '#f))
        (std/text/utf16#string->utf16__%
         _str167115_
         _endianness167117_
         _BOM?167119_))))
  (define std/text/utf16#string->utf16__1
    (lambda (_str167121_ _endianness167122_)
      (let ((_BOM?167124_ '#f))
        (std/text/utf16#string->utf16__%
         _str167121_
         _endianness167122_
         _BOM?167124_))))
  (define std/text/utf16#string->utf16
    (lambda _g304069_
      (let ((_g304068_ (##length _g304069_)))
        (cond ((##fx= _g304068_ 1)
               (apply std/text/utf16#string->utf16__0 _g304069_))
              ((##fx= _g304068_ 2)
               (apply std/text/utf16#string->utf16__1 _g304069_))
              ((##fx= _g304068_ 3)
               (apply std/text/utf16#string->utf16__% _g304069_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/utf16#string->utf16
                _g304069_))))))
  (define std/text/utf16#utf16-encode
    (lambda (_str167094_ _u16-set!167095_ _BOM?167096_)
      (if _BOM?167096_
          (let ((_bytes167098_
                 (make-u8vector
                  (fx+ (fx* '4 (string-length _str167094_)) '2))))
            (_u16-set!167095_ _bytes167098_ '0 '65279)
            (std/text/utf16#utf16-encode!
             _str167094_
             _bytes167098_
             '2
             _u16-set!167095_))
          (let ((_bytes167100_
                 (make-u8vector (fx* '4 (string-length _str167094_)))))
            (std/text/utf16#utf16-encode!
             _str167094_
             _bytes167100_
             '0
             _u16-set!167095_)))))
  (define std/text/utf16#utf16-encode!
    (lambda (_str167067_ _bytes167068_ _j167069_ _u16-set!167070_)
      (letrec* ((_end167072_ (string-length _str167067_)))
        (let _lp167074_ ((_i167076_ '0) (_j167077_ _j167069_))
          (if (fx< _i167076_ _end167072_)
              (let* ((_char167079_ (string-ref _str167067_ _i167076_))
                     (_int167081_ (char->integer _char167079_)))
                (if (and (fixnum? _int167081_)
                         (or (fx<= '0 _int167081_ '55295)
                             (fx<= '57344 _int167081_ '65535)))
                    (begin
                      (_u16-set!167070_ _bytes167068_ _j167077_ _int167081_)
                      (_lp167074_ (fx+ _i167076_ '1) (fx+ _j167077_ '2)))
                    (if (<= '65536 _int167081_ '1114111)
                        (let* ((_U167087_ (- _int167081_ '65536))
                               (_W1167089_
                                (fx+ (arithmetic-shift _U167087_ '-10) '55296))
                               (_W2167091_
                                (fx+ (bitwise-and _U167087_ '1023) '56320)))
                          (_u16-set!167070_ _bytes167068_ _j167077_ _W1167089_)
                          (_u16-set!167070_
                           _bytes167068_
                           (fx+ _j167077_ '2)
                           _W2167091_)
                          (_lp167074_ (fx+ _i167076_ '1) (fx+ _j167077_ '4)))
                        (std/error#raise-io-error
                         'utf16-encode!
                         '"Illegal codepoint"
                         _char167079_
                         _int167081_))))
              (if (fx< _j167077_ (u8vector-length _bytes167068_))
                  (begin
                    (u8vector-shrink! _bytes167068_ _j167077_)
                    _bytes167068_)
                  _bytes167068_))))))
  (define std/text/utf16#utf16->string__%
    (lambda (_bytes167040_ _endianness167041_ _endianness-mandatory?167042_)
      (if (u8vector? _bytes167040_)
          '#!void
          (error '"Expected u8vector" _bytes167040_))
      (let ((_u16-ref167047_
             (let ((_$e167044_ _endianness167041_))
               (if (eq? 'big _$e167044_)
                   std/text/utf16#u16-ref/be
                   (if (eq? 'little _$e167044_)
                       std/text/utf16#u16-ref/le
                       (if (eq? 'native _$e167044_)
                           std/misc/bytes#&u8vector-u16-ref/native
                           (error '"Bad endianness" _endianness167041_)))))))
        (std/text/utf16#utf16-decode
         _bytes167040_
         _u16-ref167047_
         (not _endianness-mandatory?167042_)))))
  (define std/text/utf16#utf16->string__0
    (lambda (_bytes167052_)
      (let* ((_endianness167054_ std/misc/bytes#big)
             (_endianness-mandatory?167056_ '#f))
        (std/text/utf16#utf16->string__%
         _bytes167052_
         _endianness167054_
         _endianness-mandatory?167056_))))
  (define std/text/utf16#utf16->string__1
    (lambda (_bytes167058_ _endianness167059_)
      (let ((_endianness-mandatory?167061_ '#f))
        (std/text/utf16#utf16->string__%
         _bytes167058_
         _endianness167059_
         _endianness-mandatory?167061_))))
  (define std/text/utf16#utf16->string
    (lambda _g304071_
      (let ((_g304070_ (##length _g304071_)))
        (cond ((##fx= _g304070_ 1)
               (apply std/text/utf16#utf16->string__0 _g304071_))
              ((##fx= _g304070_ 2)
               (apply std/text/utf16#utf16->string__1 _g304071_))
              ((##fx= _g304070_ 3)
               (apply std/text/utf16#utf16->string__% _g304071_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/utf16#utf16->string
                _g304071_))))))
  (define std/text/utf16#utf16-decode
    (lambda (_bytes167030_ _u16-ref167031_ _BOM?167032_)
      (letrec* ((_len167034_ (u8vector-length _bytes167030_)))
        (if (fxeven? _len167034_)
            '#!void
            (std/error#raise-io-error
             'utf16-decode
             '"Cannot decode UTF-16; odd length u8vector"
             _bytes167030_))
        (if _BOM?167032_
            (if (fx>= _len167034_ '2)
                (let ((_b0167036_ (u8vector-ref _bytes167030_ '0))
                      (_b1167037_ (u8vector-ref _bytes167030_ '1)))
                  (if (and (fx= _b0167036_ '254) (fx= _b1167037_ '255))
                      (std/text/utf16#utf16-decode!
                       _bytes167030_
                       '2
                       std/text/utf16#u16-ref/be)
                      (if (and (fx= _b0167036_ '255) (fx= _b1167037_ '254))
                          (std/text/utf16#utf16-decode!
                           _bytes167030_
                           '2
                           std/text/utf16#u16-ref/le)
                          (std/text/utf16#utf16-decode!
                           _bytes167030_
                           '0
                           _u16-ref167031_))))
                '"")
            (std/text/utf16#utf16-decode! _bytes167030_ '0 _u16-ref167031_)))))
  (define std/text/utf16#utf16-decode!
    (lambda (_bytes166991_ _i166992_ _u16-ref166993_)
      (letrec* ((_end166995_ (u8vector-length _bytes166991_))
                (_str166996_ (make-string (fx- _end166995_ _i166992_))))
        (let _lp166998_ ((_i167000_ _i166992_) (_j167001_ '0))
          (if (fx< _i167000_ _end166995_)
              (let ((_W167003_ (_u16-ref166993_ _bytes166991_ _i167000_)))
                (if (or (fx<= '0 _W167003_ '55295)
                        (fx<= '57344 _W167003_ '65535))
                    (let ((_char167008_ (integer->char _W167003_)))
                      (string-set! _str166996_ _j167001_ _char167008_)
                      (_lp166998_ (fx+ _i167000_ '2) (fx+ _j167001_ '1)))
                    (let ((_Whi167010_ (fxarithmetic-shift _W167003_ '-10)))
                      (if (fx= _Whi167010_ '54)
                          (let ((_i+2167012_ (fx+ _i167000_ '2)))
                            (if (fx< _i+2167012_ _end166995_)
                                (let* ((_W2167014_
                                        (_u16-ref166993_
                                         _bytes166991_
                                         _i+2167012_))
                                       (_W2hi167016_
                                        (fxarithmetic-shift _W2167014_ '-10)))
                                  (if (fx= _W2hi167016_ '55)
                                      (let* ((_u1167019_
                                              (fxand _W167003_ '1023))
                                             (_u2167021_
                                              (fxand _W2167014_ '1023))
                                             (_u*167023_
                                              (bitwise-ior
                                               (arithmetic-shift
                                                _u1167019_
                                                '10)
                                               _u2167021_))
                                             (_u167025_ (+ _u*167023_ '65536))
                                             (_char167027_
                                              (integer->char _u167025_)))
                                        (string-set!
                                         _str166996_
                                         _j167001_
                                         _char167027_)
                                        (_lp166998_
                                         (fx+ _i167000_ '4)
                                         (fx+ _j167001_ '1)))
                                      (begin
                                        (string-set!
                                         _str166996_
                                         _j167001_
                                         '65533)
                                        (_lp166998_
                                         (fx+ _i167000_ '4)
                                         (fx+ _j167001_ '1)))))
                                (std/error#raise-io-error
                                 'utf16-decode!
                                 '"Incomplete character"
                                 _W167003_)))
                          (begin
                            (string-set! _str166996_ _j167001_ '#\�)
                            (_lp166998_
                             (fx+ _i167000_ '2)
                             (fx+ _j167001_ '1)))))))
              (if (fx< _j167001_ (string-length _str166996_))
                  (begin (string-shrink! _str166996_ _j167001_) _str166996_)
                  _str166996_))))))
  (define std/text/utf16#u16-ref/be
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#big)
        std/misc/bytes#&u8vector-u16-ref/native
        (lambda (_v166988_ _i166989_)
          (std/misc/bytes#&u8vector-uint-ref/be _v166988_ _i166989_ '2))))
  (define std/text/utf16#u16-ref/le
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#little)
        std/misc/bytes#&u8vector-u16-ref/native
        (lambda (_v166985_ _i166986_)
          (std/misc/bytes#&u8vector-uint-ref/le _v166985_ _i166986_ '2))))
  (define std/text/utf16#u16-set!/be
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#big)
        std/misc/bytes#&u8vector-u16-set!/native
        (lambda (_v166981_ _i166982_ _n166983_)
          (std/misc/bytes#&u8vector-uint-set!/be
           _v166981_
           _i166982_
           _n166983_
           '2))))
  (define std/text/utf16#u16-set!/le
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#little)
        std/misc/bytes#&u8vector-u16-set!/native
        (lambda (_v166977_ _i166978_ _n166979_)
          (std/misc/bytes#&u8vector-uint-set!/le
           _v166977_
           _i166978_
           _n166979_
           '2)))))
