(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/text/utf32#string->utf32__%
    (lambda (_str167229_ _endianness167230_ _BOM?167231_)
      (if (string? _str167229_) '#!void (error '"Expected string" _str167229_))
      (let ((_u32-set!167236_
             (let ((_$e167233_ _endianness167230_))
               (if (eq? 'big _$e167233_)
                   std/text/utf32#u32-set!/be
                   (if (eq? 'little _$e167233_)
                       std/text/utf32#u32-set!/le
                       (if (eq? 'native _$e167233_)
                           (std/misc/bytes#&u8vector-u32-set!/native)
                           (error '"Bad endianness" _endianness167230_)))))))
        (std/text/utf32#utf32-encode
         _str167229_
         _u32-set!167236_
         _BOM?167231_))))
  (define std/text/utf32#string->utf32__0
    (lambda (_str167241_)
      (let* ((_endianness167243_ std/misc/bytes#big) (_BOM?167245_ '#f))
        (std/text/utf32#string->utf32__%
         _str167241_
         _endianness167243_
         _BOM?167245_))))
  (define std/text/utf32#string->utf32__1
    (lambda (_str167247_ _endianness167248_)
      (let ((_BOM?167250_ '#f))
        (std/text/utf32#string->utf32__%
         _str167247_
         _endianness167248_
         _BOM?167250_))))
  (define std/text/utf32#string->utf32
    (lambda _g304073_
      (let ((_g304072_ (##length _g304073_)))
        (cond ((##fx= _g304072_ 1)
               (apply std/text/utf32#string->utf32__0 _g304073_))
              ((##fx= _g304072_ 2)
               (apply std/text/utf32#string->utf32__1 _g304073_))
              ((##fx= _g304072_ 3)
               (apply std/text/utf32#string->utf32__% _g304073_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/utf32#string->utf32
                _g304073_))))))
  (define std/text/utf32#utf32-encode
    (lambda (_str167220_ _u32-set!167221_ _BOM?167222_)
      (if _BOM?167222_
          (let ((_bytes167224_
                 (make-u8vector
                  (fx* '4 (fx+ (string-length _str167220_) '1)))))
            (_u32-set!167221_ _bytes167224_ '0 '65279)
            (std/text/utf32#utf32-encode!
             _str167220_
             _bytes167224_
             '4
             _u32-set!167221_))
          (let ((_bytes167226_
                 (make-u8vector (fx* '4 (string-length _str167220_)))))
            (std/text/utf32#utf32-encode!
             _str167220_
             _bytes167226_
             '0
             _u32-set!167221_)))))
  (define std/text/utf32#utf32-encode!
    (lambda (_str167203_ _bytes167204_ _j167205_ _u32-set!167206_)
      (letrec* ((_end167208_ (string-length _str167203_)))
        (let _lp167210_ ((_i167212_ '0) (_j167213_ _j167205_))
          (if (fx< _i167212_ _end167208_)
              (let* ((_char167215_ (string-ref _str167203_ _i167212_))
                     (_int167217_ (char->integer _char167215_)))
                (_u32-set!167206_ _bytes167204_ _j167213_ _int167217_)
                (_lp167210_ (fx+ _i167212_ '1) (fx+ _j167213_ '4)))
              _bytes167204_)))))
  (define std/text/utf32#utf32->string__%
    (lambda (_bytes167176_ _endianness167177_ _endianness-mandatory?167178_)
      (if (u8vector? _bytes167176_)
          '#!void
          (error '"Expected u8vector" _bytes167176_))
      (let ((_u32-ref167183_
             (let ((_$e167180_ _endianness167177_))
               (if (eq? 'big _$e167180_)
                   std/text/utf32#u32-ref/be
                   (if (eq? 'little _$e167180_)
                       std/text/utf32#u32-ref/le
                       (if (eq? 'native _$e167180_)
                           std/misc/bytes#&u8vector-u32-ref/native
                           (error '"Bad endianness" _endianness167177_)))))))
        (std/text/utf32#utf32-decode
         _bytes167176_
         _u32-ref167183_
         (not _endianness-mandatory?167178_)))))
  (define std/text/utf32#utf32->string__0
    (lambda (_bytes167188_)
      (let* ((_endianness167190_ std/misc/bytes#big)
             (_endianness-mandatory?167192_ '#f))
        (std/text/utf32#utf32->string__%
         _bytes167188_
         _endianness167190_
         _endianness-mandatory?167192_))))
  (define std/text/utf32#utf32->string__1
    (lambda (_bytes167194_ _endianness167195_)
      (let ((_endianness-mandatory?167197_ '#f))
        (std/text/utf32#utf32->string__%
         _bytes167194_
         _endianness167195_
         _endianness-mandatory?167197_))))
  (define std/text/utf32#utf32->string
    (lambda _g304075_
      (let ((_g304074_ (##length _g304075_)))
        (cond ((##fx= _g304074_ 1)
               (apply std/text/utf32#utf32->string__0 _g304075_))
              ((##fx= _g304074_ 2)
               (apply std/text/utf32#utf32->string__1 _g304075_))
              ((##fx= _g304074_ 3)
               (apply std/text/utf32#utf32->string__% _g304075_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/utf32#utf32->string
                _g304075_))))))
  (define std/text/utf32#utf32-decode
    (lambda (_bytes167164_ _u32-ref167165_ _BOM?167166_)
      (letrec* ((_len167168_ (u8vector-length _bytes167164_)))
        (if (fx= (fxremainder _len167168_ '4) '0)
            '#!void
            (std/error#raise-io-error
             'utf32-decode
             '"Cannot decode UTF-32; u8vector length is not a multiple of 4"
             _bytes167164_))
        (if _BOM?167166_
            (if (fx>= _len167168_ '4)
                (let ((_b0167170_ (u8vector-ref _bytes167164_ '0))
                      (_b1167171_ (u8vector-ref _bytes167164_ '1))
                      (_b2167172_ (u8vector-ref _bytes167164_ '2))
                      (_b3167173_ (u8vector-ref _bytes167164_ '3)))
                  (if (and (fx= _b0167170_ '0)
                           (fx= _b1167171_ '0)
                           (fx= _b2167172_ '254)
                           (fx= _b3167173_ '255))
                      (std/text/utf32#utf32-decode!
                       _bytes167164_
                       '4
                       std/text/utf32#u32-ref/be)
                      (if (and (fx= _b0167170_ '255)
                               (fx= _b1167171_ '254)
                               (fx= _b2167172_ '0)
                               (fx= _b3167173_ '0))
                          (std/text/utf32#utf32-decode!
                           _bytes167164_
                           '4
                           std/text/utf32#u32-ref/le)
                          (std/text/utf32#utf32-decode!
                           _bytes167164_
                           '0
                           _u32-ref167165_))))
                '"")
            (std/text/utf32#utf32-decode! _bytes167164_ '0 _u32-ref167165_)))))
  (define std/text/utf32#utf32-decode!
    (lambda (_bytes167144_ _i167145_ _u32-ref167146_)
      (letrec* ((_end167148_ (u8vector-length _bytes167144_))
                (_str167149_
                 (make-string (fxquotient (fx- _end167148_ _i167145_) '4))))
        (let _lp167151_ ((_i167153_ _i167145_) (_j167154_ '0))
          (if (fx< _i167153_ _end167148_)
              (let ((_int167156_ (_u32-ref167146_ _bytes167144_ _i167153_)))
                (if (or (and (fixnum? _int167156_)
                             (or (fx<= '0 _int167156_ '55295)
                                 (fx<= '57344 _int167156_ '65535)))
                        (<= '65536 _int167156_ '1114111))
                    (begin
                      (string-set!
                       _str167149_
                       _j167154_
                       (integer->char _int167156_))
                      (_lp167151_ (fx+ _i167153_ '4) (fx+ _j167154_ '1)))
                    (begin
                      (string-set! _str167149_ _j167154_ '#\�)
                      (_lp167151_ (fx+ _i167153_ '4) (fx+ _j167154_ '1)))))
              _str167149_)))))
  (define std/text/utf32#u32-ref/be
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#big)
        std/misc/bytes#&u8vector-u32-ref/native
        (lambda (_v167141_ _i167142_)
          (std/misc/bytes#&u8vector-uint-ref/be _v167141_ _i167142_ '4))))
  (define std/text/utf32#u32-ref/le
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#little)
        std/misc/bytes#&u8vector-u32-ref/native
        (lambda (_v167138_ _i167139_)
          (std/misc/bytes#&u8vector-uint-ref/le _v167138_ _i167139_ '4))))
  (define std/text/utf32#u32-set!/be
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#big)
        std/misc/bytes#&u8vector-u32-set!/native
        (lambda (_v167134_ _i167135_ _n167136_)
          (std/misc/bytes#&u8vector-uint-set!/be
           _v167134_
           _i167135_
           _n167136_
           '4))))
  (define std/text/utf32#u32-set!/le
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#little)
        std/misc/bytes#&u8vector-u32-set!/native
        (lambda (_v167130_ _i167131_ _n167132_)
          (std/misc/bytes#&u8vector-uint-set!/le
           _v167130_
           _i167131_
           _n167132_
           '4)))))
