(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/text/utf8#string->utf8__%
    (lambda (_str101329_ _start101330_ _end101331_)
      (if (string? _str101329_)
          (std/text/utf8#utf8-encode _str101329_ _start101330_ _end101331_)
          (error '"Bad argument; expected string" _str101329_))))
  (define std/text/utf8#string->utf8__0
    (lambda (_str101336_)
      (let* ((_start101338_ '0) (_end101340_ (string-length _str101336_)))
        (std/text/utf8#string->utf8__%
         _str101336_
         _start101338_
         _end101340_))))
  (define std/text/utf8#string->utf8__1
    (lambda (_str101342_ _start101343_)
      (let ((_end101345_ (string-length _str101342_)))
        (std/text/utf8#string->utf8__%
         _str101342_
         _start101343_
         _end101345_))))
  (define std/text/utf8#string->utf8
    (lambda _g290262_
      (let ((_g290261_ (##length _g290262_)))
        (cond ((##fx= _g290261_ 1)
               (apply std/text/utf8#string->utf8__0 _g290262_))
              ((##fx= _g290261_ 2)
               (apply std/text/utf8#string->utf8__1 _g290262_))
              ((##fx= _g290261_ 3)
               (apply std/text/utf8#string->utf8__% _g290262_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/utf8#string->utf8
                _g290262_))))))
  (define std/text/utf8#string-utf8-length__%
    (lambda (_str101306_ _start101307_ _end101308_)
      (if (string? _str101306_)
          (std/text/utf8#utf8-encode-length
           _str101306_
           _start101307_
           _end101308_)
          (error '"Bad argument; expected string" _str101306_))))
  (define std/text/utf8#string-utf8-length__0
    (lambda (_str101313_)
      (let* ((_start101315_ '0) (_end101317_ (string-length _str101313_)))
        (std/text/utf8#string-utf8-length__%
         _str101313_
         _start101315_
         _end101317_))))
  (define std/text/utf8#string-utf8-length__1
    (lambda (_str101319_ _start101320_)
      (let ((_end101322_ (string-length _str101319_)))
        (std/text/utf8#string-utf8-length__%
         _str101319_
         _start101320_
         _end101322_))))
  (define std/text/utf8#string-utf8-length
    (lambda _g290264_
      (let ((_g290263_ (##length _g290264_)))
        (cond ((##fx= _g290263_ 1)
               (apply std/text/utf8#string-utf8-length__0 _g290264_))
              ((##fx= _g290263_ 2)
               (apply std/text/utf8#string-utf8-length__1 _g290264_))
              ((##fx= _g290263_ 3)
               (apply std/text/utf8#string-utf8-length__% _g290264_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/utf8#string-utf8-length
                _g290264_))))))
  (define std/text/utf8#utf8->string__%
    (lambda (_u8v101283_ _start101284_ _end101285_)
      (if (u8vector? _u8v101283_)
          (std/text/utf8#utf8-decode _u8v101283_ _start101284_ _end101285_)
          (error '"Bad argument; expected u8vector" _u8v101283_))))
  (define std/text/utf8#utf8->string__0
    (lambda (_u8v101290_)
      (let* ((_start101292_ '0) (_end101294_ (u8vector-length _u8v101290_)))
        (std/text/utf8#utf8->string__%
         _u8v101290_
         _start101292_
         _end101294_))))
  (define std/text/utf8#utf8->string__1
    (lambda (_u8v101296_ _start101297_)
      (let ((_end101299_ (u8vector-length _u8v101296_)))
        (std/text/utf8#utf8->string__%
         _u8v101296_
         _start101297_
         _end101299_))))
  (define std/text/utf8#utf8->string
    (lambda _g290266_
      (let ((_g290265_ (##length _g290266_)))
        (cond ((##fx= _g290265_ 1)
               (apply std/text/utf8#utf8->string__0 _g290266_))
              ((##fx= _g290265_ 2)
               (apply std/text/utf8#utf8->string__1 _g290266_))
              ((##fx= _g290265_ 3)
               (apply std/text/utf8#utf8->string__% _g290266_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/utf8#utf8->string
                _g290266_))))))
  (define std/text/utf8#utf8-encode
    (lambda (_str101269_ _start101270_ _end101271_)
      (let* ((_slen101273_ (fx- _end101271_ _start101270_))
             (_u8vlen101275_ (##fx* _slen101273_ '4))
             (_u8v101277_ (make-u8vector _u8vlen101275_))
             (_count101279_
              (std/text/utf8#utf8-encode!
               _str101269_
               _u8v101277_
               _start101270_
               _end101271_)))
        (##u8vector-shrink! _u8v101277_ _count101279_)
        _u8v101277_)))
  (define std/text/utf8#utf8-encode-length
    (lambda (_str101255_ _start101256_ _end101257_)
      (let _lp101259_ ((_i101261_ _start101256_) (_r101262_ '0))
        (if (##fx< _i101261_ _end101257_)
            (let* ((_char101264_ (##string-ref _str101255_ _i101261_))
                   (_clen101266_
                    (std/text/utf8#utf8-char-length _char101264_)))
              (_lp101259_ (##fx+ _i101261_ '1) (##fx+ _r101262_ _clen101266_)))
            _r101262_))))
  (define std/text/utf8#utf8-char-length
    (lambda (_char101251_)
      (let ((_c101253_ (##char->integer _char101251_)))
        (if (##fx<= _c101253_ '127)
            '1
            (if (##fx<= _c101253_ '2047)
                '2
                (if (##fx<= _c101253_ '65535) '3 '4))))))
  (define std/text/utf8#utf8-encode!
    (lambda (_str101236_ _u8v101237_ _start101238_ _end101239_)
      (let _lp101241_ ((_i101243_ _start101238_) (_j101244_ '0))
        (if (##fx< _i101243_ _end101239_)
            (let* ((_char101246_ (##string-ref _str101236_ _i101243_))
                   (_c101248_ (##char->integer _char101246_)))
              (if (##fx<= _c101248_ '127)
                  (begin
                    (##u8vector-set! _u8v101237_ _j101244_ _c101248_)
                    (_lp101241_ (##fx+ _i101243_ '1) (##fx+ _j101244_ '1)))
                  (if (##fx<= _c101248_ '2047)
                      (begin
                        (##u8vector-set!
                         _u8v101237_
                         _j101244_
                         (##fxior '192
                                  (##fxarithmetic-shift-right _c101248_ '6)))
                        (##u8vector-set!
                         _u8v101237_
                         (##fx+ _j101244_ '1)
                         (##fxior '128 (##fxand _c101248_ '63)))
                        (_lp101241_ (##fx+ _i101243_ '1) (##fx+ _j101244_ '2)))
                      (if (##fx<= _c101248_ '65535)
                          (begin
                            (##u8vector-set!
                             _u8v101237_
                             _j101244_
                             (##fxior '224
                                      (##fxarithmetic-shift-right
                                       _c101248_
                                       '12)))
                            (##u8vector-set!
                             _u8v101237_
                             (##fx+ _j101244_ '1)
                             (##fxior '128
                                      (##fxand (##fxarithmetic-shift-right
                                                _c101248_
                                                '6)
                                               '63)))
                            (##u8vector-set!
                             _u8v101237_
                             (##fx+ _j101244_ '2)
                             (##fxior '128 (##fxand _c101248_ '63)))
                            (_lp101241_
                             (##fx+ _i101243_ '1)
                             (##fx+ _j101244_ '3)))
                          (begin
                            (##u8vector-set!
                             _u8v101237_
                             _j101244_
                             (##fxior '240
                                      (##fxarithmetic-shift-right
                                       _c101248_
                                       '18)))
                            (##u8vector-set!
                             _u8v101237_
                             (##fx+ _j101244_ '1)
                             (##fxior '128
                                      (##fxand (##fxarithmetic-shift-right
                                                _c101248_
                                                '12)
                                               '63)))
                            (##u8vector-set!
                             _u8v101237_
                             (##fx+ _j101244_ '2)
                             (##fxior '128
                                      (##fxand (##fxarithmetic-shift-right
                                                _c101248_
                                                '6)
                                               '63)))
                            (##u8vector-set!
                             _u8v101237_
                             (##fx+ _j101244_ '3)
                             (##fxior '128 (##fxand _c101248_ '63)))
                            (_lp101241_
                             (##fx+ _i101243_ '1)
                             (##fx+ _j101244_ '4)))))))
            _j101244_))))
  (define std/text/utf8#utf8-decode
    (lambda (_u8v101225_ _start101226_ _end101227_)
      (let* ((_u8vlen101229_ (fx- _end101227_ _start101226_))
             (_str101231_ (make-string _u8vlen101229_))
             (_slen101233_
              (std/text/utf8#utf8-decode!
               _u8v101225_
               _str101231_
               _start101226_
               _end101227_)))
        (##string-shrink! _str101231_ _slen101233_)
        _str101231_)))
  (define std/text/utf8#utf8-decode!
    (lambda (_u8v101181_ _str101182_ _start101183_ _end101184_)
      (let _lp101186_ ((_i101188_ _start101183_) (_j101189_ '0))
        (if (##fx< _i101188_ _end101184_)
            (let ((_byte101191_ (##u8vector-ref _u8v101181_ _i101188_)))
              (if (##fx<= _byte101191_ '127)
                  (let ((_char101193_ (##integer->char _byte101191_)))
                    (##string-set! _str101182_ _j101189_ _char101193_)
                    (_lp101186_ (##fx+ _i101188_ '1) (##fx+ _j101189_ '1)))
                  (if (##fx<= _byte101191_ '223)
                      (let* ((_i+2101195_ (##fx+ _i101188_ '2))
                             (_g290267_
                              (if (##fx<= _i+2101195_ _end101184_)
                                  '#!void
                                  (std/error#raise-io-error
                                   'utf8-decode!
                                   '"incomplete character"
                                   _byte101191_)))
                             (_byte2101198_
                              (##u8vector-ref
                               _u8v101181_
                               (##fx+ _i101188_ '1)))
                             (_char101200_
                              (##integer->char
                               (##fxior (##fxarithmetic-shift-left
                                         (##fxand _byte101191_ '31)
                                         '6)
                                        (##fxand _byte2101198_ '63)))))
                        (##string-set! _str101182_ _j101189_ _char101200_)
                        (_lp101186_ _i+2101195_ (##fx+ _j101189_ '1)))
                      (if (##fx<= _byte101191_ '239)
                          (let* ((_i+3101203_ (##fx+ _i101188_ '3))
                                 (_g290268_
                                  (if (##fx<= _i+3101203_ _end101184_)
                                      '#!void
                                      (std/error#raise-io-error
                                       'utf8-decode!
                                       '"incomplete character"
                                       _byte101191_)))
                                 (_byte2101206_
                                  (##u8vector-ref
                                   _u8v101181_
                                   (##fx+ _i101188_ '1)))
                                 (_byte3101208_
                                  (##u8vector-ref
                                   _u8v101181_
                                   (##fx+ _i101188_ '2)))
                                 (_char101210_
                                  (##integer->char
                                   (##fxior (##fxarithmetic-shift-left
                                             (##fxand _byte101191_ '15)
                                             '12)
                                            (##fxarithmetic-shift-left
                                             (##fxand _byte2101206_ '63)
                                             '6)
                                            (##fxand _byte3101208_ '63)))))
                            (##string-set! _str101182_ _j101189_ _char101210_)
                            (_lp101186_ _i+3101203_ (##fx+ _j101189_ '1)))
                          (if (##fx<= _byte101191_ '244)
                              (let* ((_i+4101213_ (##fx+ _i101188_ '4))
                                     (_g290269_
                                      (if (##fx<= _i+4101213_ _end101184_)
                                          '#!void
                                          (std/error#raise-io-error
                                           'utf8-decode!
                                           '"incomplete character"
                                           _byte101191_)))
                                     (_byte2101216_
                                      (##u8vector-ref
                                       _u8v101181_
                                       (##fx+ _i101188_ '1)))
                                     (_byte3101218_
                                      (##u8vector-ref
                                       _u8v101181_
                                       (##fx+ _i101188_ '2)))
                                     (_byte4101220_
                                      (##u8vector-ref
                                       _u8v101181_
                                       (##fx+ _i101188_ '3)))
                                     (_char101222_
                                      (##integer->char
                                       (##fxior (##fxarithmetic-shift-left
                                                 (##fxand _byte101191_ '7)
                                                 '18)
                                                (##fxarithmetic-shift-left
                                                 (##fxand _byte2101216_ '63)
                                                 '12)
                                                (##fxarithmetic-shift-left
                                                 (##fxand _byte3101218_ '63)
                                                 '6)
                                                (##fxand _byte4101220_ '63)))))
                                (##string-set!
                                 _str101182_
                                 _j101189_
                                 _char101222_)
                                (_lp101186_ _i+4101213_ (##fx+ _j101189_ '1)))
                              (begin
                                (##string-set! _str101182_ _j101189_ '#\�)
                                (_lp101186_
                                 (##fx+ _i101188_ '1)
                                 (##fx+ _j101189_ '1))))))))
            _j101189_)))))
