(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/web/fastcgi#errorf
    (lambda (_fmt258694_ . _args258695_)
      (std/logger#log-message 'fastcgi '0 _fmt258694_ _args258695_)))
  (define std/web/fastcgi#warnf
    (lambda (_fmt258691_ . _args258692_)
      (std/logger#log-message 'fastcgi '1 _fmt258691_ _args258692_)))
  (define std/web/fastcgi#infof
    (lambda (_fmt258688_ . _args258689_)
      (std/logger#log-message 'fastcgi '2 _fmt258688_ _args258689_)))
  (define std/web/fastcgi#debugf
    (lambda (_fmt258685_ . _args258686_)
      (std/logger#log-message 'fastcgi '3 _fmt258685_ _args258686_)))
  (define std/web/fastcgi#verbosef
    (lambda (_fmt258680_ . _args258682_)
      (std/logger#log-message 'fastcgi '4 _fmt258680_ _args258682_)))
  (define std/web/fastcgi#fastcgi-request::t
    (make-struct-type
     'std/web/fastcgi#fastcgi-request::t
     '#f
     '6
     'fastcgi-request
     '()
     '#f
     '(port id keepalive role params stdin)))
  (define std/web/fastcgi#fastcgi-request?
    (make-struct-predicate std/web/fastcgi#fastcgi-request::t))
  (define std/web/fastcgi#make-fastcgi-request
    (lambda _$args258677_
      (apply make-struct-instance
             std/web/fastcgi#fastcgi-request::t
             _$args258677_)))
  (define std/web/fastcgi#fastcgi-request-port
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '0))
  (define std/web/fastcgi#fastcgi-request-id
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '1))
  (define std/web/fastcgi#fastcgi-request-keepalive
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '2))
  (define std/web/fastcgi#fastcgi-request-role
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '3))
  (define std/web/fastcgi#fastcgi-request-params
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '4))
  (define std/web/fastcgi#fastcgi-request-stdin
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '5))
  (define std/web/fastcgi#fastcgi-request-port-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '0))
  (define std/web/fastcgi#fastcgi-request-id-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '1))
  (define std/web/fastcgi#fastcgi-request-keepalive-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '2))
  (define std/web/fastcgi#fastcgi-request-role-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '3))
  (define std/web/fastcgi#fastcgi-request-params-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '4))
  (define std/web/fastcgi#fastcgi-request-stdin-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '5))
  (define std/web/fastcgi#start-fastcgi-server!
    (lambda (_address258674_ _respond258675_)
      (std/logger#start-logger!__0)
      (gerbil/gambit/threads#spawn
       std/web/fastcgi#fastcgi-server
       (open-tcp-server (std/net/address#inet-address->string _address258674_))
       _respond258675_)))
  (define std/web/fastcgi#fastcgi-server
    (lambda (_sock258659_ _respond258660_)
      (let _lp258662_ ()
        (with-exception-catcher
         (lambda (_g258664258666_)
           (if '#t
               (let ((_e258669_ _g258664258666_))
                 (std/web/fastcgi#errorf
                  '"error accepting connection: ~a"
                  _e258669_))
               (raise _g258664258666_)))
         (lambda ()
           (let ((_client258672_ (read _sock258659_)))
             (gerbil/gambit/threads#spawn
              std/web/fastcgi#fastcgi-connection
              _client258672_
              _respond258660_))))
        (_lp258662_))))
  (define std/web/fastcgi#fastcgi-connection
    (lambda (_port258641_ _respond258642_)
      (letrec ((_loop258644_
                (lambda ()
                  (let ((_req258657_
                         (std/web/fastcgi#fastcgi-accept _port258641_)))
                    (if (eof-object? _req258657_)
                        '#!void
                        (if (eq? (##structure-ref
                                  _req258657_
                                  '4
                                  std/web/fastcgi#fastcgi-request::t
                                  '#f)
                                 'FCGI-RESPONDER)
                            (begin
                              (_respond258642_ _req258657_)
                              (std/web/fastcgi#fastcgi-request-end__0
                               _req258657_)
                              (if (##structure-ref
                                   _req258657_
                                   '3
                                   std/web/fastcgi#fastcgi-request::t
                                   '#f)
                                  (_loop258644_)
                                  '#!void))
                            (begin
                              (std/web/fastcgi#fastcgi-request-end__%
                               _req258657_
                               '1
                               std/web/fastcgi#FCGI-UNKNOWN-ROLE)
                              (if (##structure-ref
                                   _req258657_
                                   '3
                                   std/web/fastcgi#fastcgi-request::t
                                   '#f)
                                  (_loop258644_)
                                  '#!void))))))))
        (with-unwind-protect
         (lambda ()
           (with-exception-catcher
            (lambda (_g258645258648_)
              (if '#t
                  (let ((_e258651_ _g258645258648_))
                    (std/web/fastcgi#errorf '"error responding: ~a" _e258651_))
                  (raise _g258645258648_)))
            (lambda () (_loop258644_))))
         (lambda ()
           (with-exception-catcher
            void
            (lambda () (close-port _port258641_))))))))
  (define std/web/fastcgi#fastcgi-accept
    (lambda (_port258397_)
      (letrec ((_begin-request258399_
                (lambda (_port258520_)
                  (let* ((_g258521258531_
                          (std/web/fastcgi#fcgi-read-record _port258520_))
                         (_E258524258535_
                          (lambda ()
                            (error '"No clause matching" _g258521258531_))))
                    (let ((_K258526258623_
                           (lambda (_body258549_ _reqid258550_ _type258551_)
                             (if (eq? _type258551_
                                      std/web/fastcgi#FCGI-BEGIN-REQUEST)
                                 (let ((_g311123_
                                        (std/web/fastcgi#fcgi-begin-request-e
                                         _body258549_)))
                                   (begin
                                     (let ((_g311124_
                                            (let ()
                                              (declare (not safe))
                                              (if (##values? _g311123_)
                                                  (##vector-length _g311123_)
                                                  1))))
                                       (if (not (let ()
                                                  (declare (not safe))
                                                  (##fx= _g311124_ 2)))
                                           (error "Context expects 2 values"
                                                  _g311124_)))
                                     (let ((_role258553_
                                            (let ()
                                              (declare (not safe))
                                              (##vector-ref _g311123_ 0)))
                                           (_flags258554_
                                            (let ()
                                              (declare (not safe))
                                              (##vector-ref _g311123_ 1))))
                                       (let ((_keepalive258556_
                                              (not (zero? (fxand _flags258554_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         std/web/fastcgi#FCGI-KEEP-CONN)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                         (_receive-request-data258400_
                                          _port258520_
                                          _reqid258550_
                                          _keepalive258556_
                                          _role258553_)))))
                                 (if (eq? _type258551_
                                          std/web/fastcgi#FCGI-GET-VALUES)
                                     (let* ((_keys258559_
                                             (std/web/fastcgi#fcgi-get-values-e
                                              _body258549_))
                                            (_resp258618_
                                             (let ((_iterable258586_
                                                    _keys258559_)
                                                   (_iter-do258588_
                                                    (lambda (_val258561_
                                                             _r258563_)
                                                      (let* ((_val258564258569_
                                                              _val258561_)
                                                             (_E258566258573_
                                                              (lambda ()
                                                                (error '"No clause matching"
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                               _val258564258569_)))
                     (_K258567258581_
                      (lambda (_key258576_)
                        (let ((_$e258578_ _key258576_))
                          (if (eq? 'FCGI_MAX_CONNS _$e258578_)
                              (cons (cons _key258576_ '"1") _r258563_)
                              (if (eq? 'FCGI_MAX_REQS _$e258578_)
                                  (cons (cons _key258576_ '"1") _r258563_)
                                  (if (eq? 'FCGI_MPXS_CONNS _$e258578_)
                                      (cons (cons _key258576_ '"0") _r258563_)
                                      _r258563_))))))
                     (_key258584_ _val258564258569_))
                (_K258567258581_ _key258584_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (_r258590_ '()))
                                               (if (pair? _iterable258586_)
                                                   (foldl1 _iter-do258588_
                                                           _r258590_
                                                           _iterable258586_)
                                                   (if (null? _iterable258586_)
                                                       _r258590_
                                                       (let* ((_it258592_
                                                               (std/iter#iter
                                                                _iterable258586_))
                                                              (_next!258595_
                                                               (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (declare (not safe))
                         (##unchecked-structure-ref
                          _it258592_
                          '2
                          std/iter#iterator::t
                          '#f))))
                 (declare (not safe))
                 (let _lp258600_ ((_rval258603_ '()))
                   (let ((_val258606_ (_next!258595_ _it258592_)))
                     (if (eq? std/iter#iter-end _val258606_)
                         (begin
                           (let ((_$e258608_
                                  (##unchecked-structure-ref
                                   _it258592_
                                   '3
                                   std/iter#iterator::t
                                   '#f)))
                             (if _$e258608_
                                 ((lambda (_g258610258612_)
                                    (_g258610258612_ _it258592_))
                                  _$e258608_)
                                 '#!void))
                           _rval258603_)
                         (let ((_xval258615_
                                (_iter-do258588_ _val258606_ _rval258603_)))
                           (_lp258600_ _xval258615_))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                            (_data258620_
                                             (std/web/fastcgi#fcgi-get-values-result-data
                                              _resp258618_)))
                                       (std/web/fastcgi#fcgi-write-record__0
                                        _port258520_
                                        std/web/fastcgi#FCGI-GET-VALUES-RESULT
                                        _reqid258550_
                                        _data258620_)
                                       (_begin-request258399_ _port258520_))
                                     (if (eq? _reqid258550_ '0)
                                         (begin
                                           (std/web/fastcgi#fcgi-write-record__0
                                            _port258520_
                                            std/web/fastcgi#FCGI-UNKNOWN-TYPE
                                            _reqid258550_
                                            (std/web/fastcgi#fcgi-unknown-type-data
                                             _type258551_))
                                           (_begin-request258399_
                                            _port258520_))
                                         (begin
                                           (std/web/fastcgi#warnf
                                            '"fastcgi-accept: unexpected message type ~a"
                                            _type258551_)
                                           (_begin-request258399_
                                            _port258520_)))))))
                          (_K258525258541_ (lambda (_eof258539_) _eof258539_)))
                      (let ((_try-match258523258546_
                             (lambda ()
                               (if (eof-object? _g258521258531_)
                                   (let ((_eof258544_ _g258521258531_))
                                     (_K258525258541_ _eof258544_))
                                   (_E258524258535_)))))
                        (if (let ((__tmp311125
                                   (if (let ()
                                         (declare (not safe))
                                         (##values? _g258521258531_))
                                       (let ()
                                         (declare (not safe))
                                         (##vector-length _g258521258531_))
                                       '1)))
                              (declare (not safe))
                              (##fx= __tmp311125 '3))
                            (let* ((_e258527258626_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g258521258531_ '0)))
                                   (_e258528258631_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g258521258531_ '1)))
                                   (_e258529258636_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g258521258531_ '2))))
                              (let ((_type258629_ _e258527258626_)
                                    (_reqid258634_ _e258528258631_)
                                    (_body258639_ _e258529258636_))
                                (_K258526258623_
                                 _body258639_
                                 _reqid258634_
                                 _type258629_)))
                            (_try-match258523258546_)))))))
               (_receive-request-data258400_
                (lambda (_port258402_
                         _id258403_
                         _keepalive258404_
                         _role258405_)
                  (letrec* ((_params258407_ (make-table 'test: eq?)))
                    (let _lp258409_ ((_end-params258411_ '#f)
                                     (_end-stdin258412_ '#f)
                                     (_stdin258413_ '()))
                      (if (and _end-params258411_ _end-stdin258412_)
                          (let ((__tmp311126
                                 (u8vector-concatenate
                                  (reverse _stdin258413_))))
                            (declare (not safe))
                            (##structure
                             std/web/fastcgi#fastcgi-request::t
                             _port258402_
                             _id258403_
                             _keepalive258404_
                             _role258405_
                             _params258407_
                             __tmp311126))
                          (let* ((_g258414258424_
                                  (std/web/fastcgi#fcgi-read-record
                                   _port258402_))
                                 (_E258417258428_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _g258414258424_))))
                            (let ((_K258419258502_
                                   (lambda (_body258439_
                                            _reqid258440_
                                            _type258441_)
                                     (if (eq? _reqid258440_ _id258403_)
                                         (if (eq? _type258441_
                                                  std/web/fastcgi#FCGI-PARAMS)
                                             (if (zero? (u8vector-length
                                                         _body258439_))
                                                 (_lp258409_
                                                  '#t
                                                  _end-stdin258412_
                                                  _stdin258413_)
                                                 (let ((_alist258443_
                                                        (std/web/fastcgi#fcgi-params-e
                                                         _body258439_)))
                                                   (let ((_iterable258476_
                                                          _alist258443_)
                                                         (_iter-do258478_
                                                          (lambda (_val258445_)
                                                            (let* ((_val258447258454_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _val258445_)
                           (_E258449258458_
                            (lambda ()
                              (error '"No clause matching" _val258447258454_)))
                           (_K258450258464_
                            (lambda (_value258461_ _key258462_)
                              (table-set!
                               _params258407_
                               _key258462_
                               _value258461_))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _val258447258454_))
                          (let ((_hd258451258467_
                                 (let ()
                                   (declare (not safe))
                                   (##car _val258447258454_)))
                                (_tl258452258469_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _val258447258454_))))
                            (let* ((_key258472_ _hd258451258467_)
                                   (_value258474_ _tl258452258469_))
                              (_K258450258464_ _value258474_ _key258472_)))
                          (_E258449258458_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (if (pair? _iterable258476_)
                                                         (for-each
                                                          _iter-do258478_
                                                          _iterable258476_)
                                                         (if (null? _iterable258476_)
                                                             '#!void
                                                             (let* ((_it258481_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (std/iter#iter _iterable258476_))
                            (_next!258484_
                             (let ()
                               (declare (not safe))
                               (##unchecked-structure-ref
                                _it258481_
                                '2
                                std/iter#iterator::t
                                '#f))))
                       (declare (not safe))
                       (begin
                         (let _lp258489_ ()
                           (let ((_val258493_ (_next!258484_ _it258481_)))
                             (if (eq? std/iter#iter-end _val258493_)
                                 '#!void
                                 (begin
                                   (_iter-do258478_ _val258493_)
                                   (_lp258489_)))))
                         (let ((_$e258495_
                                (##unchecked-structure-ref
                                 _it258481_
                                 '3
                                 std/iter#iterator::t
                                 '#f)))
                           (if _$e258495_
                               ((lambda (_g258497258499_)
                                  (_g258497258499_ _it258481_))
                                _$e258495_)
                               '#!void))
                         '#!void)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (_lp258409_
                                                    '#f
                                                    _end-stdin258412_
                                                    _stdin258413_)))
                                             (if (eq? _type258441_
                                                      std/web/fastcgi#FCGI-STDIN)
                                                 (if (zero? (u8vector-length
                                                             _body258439_))
                                                     (_lp258409_
                                                      _end-params258411_
                                                      '#t
                                                      _stdin258413_)
                                                     (_lp258409_
                                                      _end-params258411_
                                                      '#f
                                                      (cons _body258439_
                                                            _stdin258413_)))
                                                 (if (eq? _type258441_
                                                          std/web/fastcgi#FCGI-ABORT-REQUEST)
                                                     (std/error#raise-io-error
                                                      'fastcgi-accept
                                                      '"Connection aborted")
                                                     (begin
                                                       (std/web/fastcgi#warnf
                                                        '"fastcgi-accept: unexpected message type ~a"
                                                        _type258441_)
                                                       (_lp258409_
                                                        _end-params258411_
                                                        _end-stdin258412_
                                                        _stdin258413_)))))
                                         (begin
                                           (std/web/fastcgi#warnf
                                            '"fastcgi-accept: unexpected message request ~a"
                                            _reqid258440_)
                                           (_lp258409_
                                            _end-params258411_
                                            _end-stdin258412_
                                            _stdin258413_)))))
                                  (_K258418258433_
                                   (lambda ()
                                     (std/error#raise-io-error
                                      'fastcgi-accept
                                      '"Premature port end"
                                      _port258402_))))
                              (let ((_try-match258416258436_
                                     (lambda ()
                                       (if (eof-object? _g258414258424_)
                                           (_K258418258433_)
                                           (_E258417258428_)))))
                                (if (let ((__tmp311127
                                           (if (let ()
                                                 (declare (not safe))
                                                 (##values? _g258414258424_))
                                               (let ()
                                                 (declare (not safe))
                                                 (##vector-length
                                                  _g258414258424_))
                                               '1)))
                                      (declare (not safe))
                                      (##fx= __tmp311127 '3))
                                    (let* ((_e258420258505_
                                            (let ()
                                              (declare (not safe))
                                              (##vector-ref
                                               _g258414258424_
                                               '0)))
                                           (_e258421258510_
                                            (let ()
                                              (declare (not safe))
                                              (##vector-ref
                                               _g258414258424_
                                               '1)))
                                           (_e258422258515_
                                            (let ()
                                              (declare (not safe))
                                              (##vector-ref
                                               _g258414258424_
                                               '2))))
                                      (let ((_type258508_ _e258420258505_)
                                            (_reqid258513_ _e258421258510_)
                                            (_body258518_ _e258422258515_))
                                        (_K258419258502_
                                         _body258518_
                                         _reqid258513_
                                         _type258508_)))
                                    (_try-match258416258436_)))))))))))
        (_begin-request258399_ _port258397_))))
  (define std/web/fastcgi#fastcgi-write-stdout
    (lambda (_req258365_ _data258366_)
      (let* ((_req258367258374_ _req258365_)
             (_E258369258378_
              (lambda () (error '"No clause matching" _req258367258374_)))
             (_K258370258384_
              (lambda (_reqid258381_ _port258382_)
                (if _port258382_
                    (std/web/fastcgi#fcgi-write-data
                     _port258382_
                     std/web/fastcgi#FCGI-STDOUT
                     _reqid258381_
                     _data258366_)
                    (error '"request ended; no port" _req258365_)))))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of?
               _req258367258374_
               'std/web/fastcgi#fastcgi-request::t))
            (let* ((_e258371258387_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258367258374_ '1)))
                   (_port258390_ _e258371258387_)
                   (_e258372258392_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258367258374_ '2)))
                   (_reqid258395_ _e258372258392_))
              (_K258370258384_ _reqid258395_ _port258390_))
            (_E258369258378_)))))
  (define std/web/fastcgi#fastcgi-write-stderr
    (lambda (_req258333_ _data258334_)
      (let* ((_req258335258342_ _req258333_)
             (_E258337258346_
              (lambda () (error '"No clause matching" _req258335258342_)))
             (_K258338258352_
              (lambda (_reqid258349_ _port258350_)
                (if _port258350_
                    (std/web/fastcgi#fcgi-write-data
                     _port258350_
                     std/web/fastcgi#FCGI-STDERR
                     _reqid258349_
                     _data258334_)
                    (error '"request ended; no port" _req258333_)))))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of?
               _req258335258342_
               'std/web/fastcgi#fastcgi-request::t))
            (let* ((_e258339258355_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258335258342_ '1)))
                   (_port258358_ _e258339258355_)
                   (_e258340258360_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258335258342_ '2)))
                   (_reqid258363_ _e258340258360_))
              (_K258338258352_ _reqid258363_ _port258358_))
            (_E258337258346_)))))
  (define std/web/fastcgi#fastcgi-request-end__%
    (lambda (_req258282_ _app-status258283_ _proto-status258284_)
      (let* ((_req258285258292_ _req258282_)
             (_E258287258296_
              (lambda () (error '"No clause matching" _req258285258292_)))
             (_K258288258302_
              (lambda (_reqid258299_ _port258300_)
                (if _port258300_
                    (begin
                      (std/web/fastcgi#fcgi-write-record__0
                       _port258300_
                       std/web/fastcgi#FCGI-STDOUT
                       _reqid258299_
                       '#u8())
                      (std/web/fastcgi#fcgi-write-record__0
                       _port258300_
                       std/web/fastcgi#FCGI-STDERR
                       _reqid258299_
                       '#u8())
                      (std/web/fastcgi#fcgi-write-record__0
                       _port258300_
                       std/web/fastcgi#FCGI-END-REQUEST
                       _reqid258299_
                       (std/web/fastcgi#fcgi-end-request-data
                        _app-status258283_
                        _proto-status258284_))
                      (##structure-set!
                       _req258282_
                       '#f
                       '1
                       std/web/fastcgi#fastcgi-request::t
                       '#f))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of?
               _req258285258292_
               'std/web/fastcgi#fastcgi-request::t))
            (let* ((_e258289258305_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258285258292_ '1)))
                   (_port258308_ _e258289258305_)
                   (_e258290258310_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258285258292_ '2)))
                   (_reqid258313_ _e258290258310_))
              (_K258288258302_ _reqid258313_ _port258308_))
            (_E258287258296_)))))
  (define std/web/fastcgi#fastcgi-request-end__0
    (lambda (_req258318_)
      (let* ((_app-status258320_ '0)
             (_proto-status258322_ std/web/fastcgi#FCGI-REQUEST-COMPLETE))
        (std/web/fastcgi#fastcgi-request-end__%
         _req258318_
         _app-status258320_
         _proto-status258322_))))
  (define std/web/fastcgi#fastcgi-request-end__1
    (lambda (_req258324_ _app-status258325_)
      (let ((_proto-status258327_ std/web/fastcgi#FCGI-REQUEST-COMPLETE))
        (std/web/fastcgi#fastcgi-request-end__%
         _req258324_
         _app-status258325_
         _proto-status258327_))))
  (define std/web/fastcgi#fastcgi-request-end
    (lambda _g311129_
      (let ((_g311128_ (let () (declare (not safe)) (##length _g311129_))))
        (cond ((let () (declare (not safe)) (##fx= _g311128_ 1))
               (apply std/web/fastcgi#fastcgi-request-end__0 _g311129_))
              ((let () (declare (not safe)) (##fx= _g311128_ 2))
               (apply std/web/fastcgi#fastcgi-request-end__1 _g311129_))
              ((let () (declare (not safe)) (##fx= _g311128_ 3))
               (apply std/web/fastcgi#fastcgi-request-end__% _g311129_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/web/fastcgi#fastcgi-request-end
                _g311129_))))))
  (define std/web/fastcgi#FCGI-BEGIN-REQUEST '1)
  (define std/web/fastcgi#FCGI-ABORT-REQUEST '2)
  (define std/web/fastcgi#FCGI-END-REQUEST '3)
  (define std/web/fastcgi#FCGI-PARAMS '4)
  (define std/web/fastcgi#FCGI-STDIN '5)
  (define std/web/fastcgi#FCGI-STDOUT '6)
  (define std/web/fastcgi#FCGI-STDERR '7)
  (define std/web/fastcgi#FCGI-DATA '8)
  (define std/web/fastcgi#FCGI-GET-VALUES '9)
  (define std/web/fastcgi#FCGI-GET-VALUES-RESULT '10)
  (define std/web/fastcgi#FCGI-UNKNOWN-TYPE '11)
  (define std/web/fastcgi#FCGI-RESPONDER '1)
  (define std/web/fastcgi#FCGI-AUTHORIZER '2)
  (define std/web/fastcgi#FCGI-FILTER '3)
  (define std/web/fastcgi#FCGI-KEEP-CONN '1)
  (define std/web/fastcgi#FCGI-REQUEST-COMPLETE '0)
  (define std/web/fastcgi#FCGI-CANT-MPX-CONN '1)
  (define std/web/fastcgi#FCGI-OVERLOADED '2)
  (define std/web/fastcgi#FCGI-UNKNOWN-ROLE '3)
  (define std/web/fastcgi#fcgi-read-record
    (lambda (_port258251_)
      (call-with-current-continuation
       (lambda (_return258253_)
         (let* ((_head258255_ (make-u8vector '8))
                (_rd258257_ (read-subu8vector _head258255_ '0 '8 _port258251_))
                (_g311130_
                 (if (zero? _rd258257_) (_return258253_ (eof-object)) '#!void))
                (_g311131_
                 (if (fx< _rd258257_ '8)
                     (std/error#raise-io-error
                      'fcgi-read-record
                      '"incomplete record")
                     '#!void))
                (_ver258261_ (u8vector-ref _head258255_ '0))
                (_g311132_
                 (if (= _ver258261_ '1)
                     '#!void
                     (std/error#raise-io-error
                      'fcgi-read-record
                      '"version mismatch"
                      _ver258261_)))
                (_type258264_ (u8vector-ref _head258255_ '1))
                (_rid258266_
                 (fxior (fxarithmetic-shift (u8vector-ref _head258255_ '2) '8)
                        (u8vector-ref _head258255_ '3)))
                (_clen258268_
                 (fxior (fxarithmetic-shift (u8vector-ref _head258255_ '4) '8)
                        (u8vector-ref _head258255_ '5)))
                (_plen258270_ (u8vector-ref _head258255_ '6))
                (_dlen258272_ (fx+ _clen258268_ _plen258270_))
                (_data258274_ (make-u8vector _dlen258272_))
                (_rd258276_
                 (if (fxpositive? _dlen258272_)
                     (read-subu8vector
                      _data258274_
                      '0
                      _dlen258272_
                      _port258251_)
                     _rd258257_))
                (_g311133_
                 (if (fx< _rd258276_ _dlen258272_)
                     (std/error#raise-io-error
                      'fcgi-read-record
                      '"incomplete record")
                     '#!void))
                (_g311134_
                 (if (fxpositive? _plen258270_)
                     (u8vector-shrink! _data258274_ _clen258268_)
                     '#!void)))
           (values _type258264_ _rid258266_ _data258274_))))))
  (define std/web/fastcgi#fcgi-read-key-value-pairs
    (lambda (_port258208_)
      (letrec ((_read-length258210_
                (lambda (_port258235_)
                  (let ((_nb0258237_ (read-u8 _port258235_)))
                    (if (eof-object? _nb0258237_)
                        _nb0258237_
                        (if (zero? (fxarithmetic-shift _nb0258237_ '-7))
                            _nb0258237_
                            (let* ((_nb3258239_ (fxand _nb0258237_ '127))
                                   (_nb2258241_ (read-u8 _port258235_))
                                   (_g311135_
                                    (if (eof-object? _nb2258241_)
                                        (std/error#raise-io-error
                                         'fcgi-read-key-value-pairs
                                         '"premature port end")
                                        '#!void))
                                   (_nb1258244_ (read-u8 _port258235_))
                                   (_g311136_
                                    (if (eof-object? _nb1258244_)
                                        (std/error#raise-io-error
                                         'fcgi-read-key-value-pairs
                                         '"premature port end")
                                        '#!void))
                                   (_nb0258247_ (read-u8 _port258235_))
                                   (_g311137_
                                    (if (eof-object? _nb0258247_)
                                        (std/error#raise-io-error
                                         'fcgi-read-key-value-pairs
                                         '"premature port end")
                                        '#!void)))
                              (fxior (fxarithmetic-shift _nb3258239_ '24)
                                     (fxarithmetic-shift _nb2258241_ '16)
                                     (fxarithmetic-shift _nb1258244_ '8)
                                     _nb0258247_))))))))
        (let _lp258212_ ((_klen258214_ (_read-length258210_ _port258208_))
                         (_r258215_ '()))
          (if (eof-object? _klen258214_)
              (reverse _r258215_)
              (let* ((_vlen258217_ (_read-length258210_ _port258208_))
                     (_g311138_
                      (if (eof-object? _vlen258217_)
                          (std/error#raise-io-error
                           'fcgi-read-key-value-pairs
                           '"premature port end")
                          '#!void))
                     (_kdata258220_ (make-u8vector _klen258214_))
                     (_rd258222_
                      (read-subu8vector
                       _kdata258220_
                       '0
                       _klen258214_
                       _port258208_))
                     (_g311139_
                      (if (fx< _rd258222_ _klen258214_)
                          (std/error#raise-io-error
                           'fcgi-read-key-value-pairs
                           '"premature port end")
                          '#!void))
                     (_vdata258225_ (make-u8vector _vlen258217_))
                     (_rd258227_
                      (read-subu8vector
                       _vdata258225_
                       '0
                       _vlen258217_
                       _port258208_))
                     (_g311140_
                      (if (fx< _rd258227_ _vlen258217_)
                          (std/error#raise-io-error
                           'fcgi-read-key-value-pairs
                           '"premature port end")
                          '#!void))
                     (_key258230_
                      (string->symbol
                       (std/text/utf8#utf8->string__0 _kdata258220_)))
                     (_value258232_
                      (std/text/utf8#utf8->string__0 _vdata258225_)))
                (_lp258212_
                 (_read-length258210_ _port258208_)
                 (cons (cons _key258230_ _value258232_) _r258215_))))))))
  (define std/web/fastcgi#fcgi-write-record__%
    (lambda (_port258164_
             _type258165_
             _reqid258166_
             _data258167_
             _start258168_
             _end258169_)
      (let* ((_head258171_ (make-u8vector '8))
             (_end258176_
              (let ((_$e258173_ _end258169_))
                (if _$e258173_ _$e258173_ (u8vector-length _data258167_))))
             (_clen258178_ (fx- _end258176_ _start258168_)))
        (u8vector-set! _head258171_ '0 '1)
        (u8vector-set! _head258171_ '1 _type258165_)
        (u8vector-set!
         _head258171_
         '2
         (fxand (fxarithmetic-shift _reqid258166_ '-8) '255))
        (u8vector-set! _head258171_ '3 (fxand _reqid258166_ '255))
        (u8vector-set!
         _head258171_
         '4
         (fxand (fxarithmetic-shift _clen258178_ '-8) '255))
        (u8vector-set! _head258171_ '5 (fxand _clen258178_ '255))
        (write-subu8vector _head258171_ '0 '8 _port258164_)
        (write-subu8vector _data258167_ _start258168_ _end258176_ _port258164_)
        (force-output _port258164_))))
  (define std/web/fastcgi#fcgi-write-record__0
    (lambda (_port258184_ _type258185_ _reqid258186_ _data258187_)
      (let* ((_start258189_ '0) (_end258191_ '#f))
        (std/web/fastcgi#fcgi-write-record__%
         _port258184_
         _type258185_
         _reqid258186_
         _data258187_
         _start258189_
         _end258191_))))
  (define std/web/fastcgi#fcgi-write-record__1
    (lambda (_port258193_
             _type258194_
             _reqid258195_
             _data258196_
             _start258197_)
      (let ((_end258199_ '#f))
        (std/web/fastcgi#fcgi-write-record__%
         _port258193_
         _type258194_
         _reqid258195_
         _data258196_
         _start258197_
         _end258199_))))
  (define std/web/fastcgi#fcgi-write-record
    (lambda _g311142_
      (let ((_g311141_ (let () (declare (not safe)) (##length _g311142_))))
        (cond ((let () (declare (not safe)) (##fx= _g311141_ 4))
               (apply std/web/fastcgi#fcgi-write-record__0 _g311142_))
              ((let () (declare (not safe)) (##fx= _g311141_ 5))
               (apply std/web/fastcgi#fcgi-write-record__1 _g311142_))
              ((let () (declare (not safe)) (##fx= _g311141_ 6))
               (apply std/web/fastcgi#fcgi-write-record__% _g311142_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/web/fastcgi#fcgi-write-record
                _g311142_))))))
  (define std/web/fastcgi#fcgi-write-data
    (lambda (_port258147_ _type258148_ _reqid258149_ _data258150_)
      (let* ((_data258152_
              (if (string? _data258150_)
                  (std/text/utf8#string->utf8__0 _data258150_)
                  _data258150_))
             (_len258154_ (u8vector-length _data258152_)))
        (let _lp258157_ ((_start258159_ '0))
          (if (fx> (fx- _len258154_ _start258159_) '65535)
              (let ((_end258161_ (fx+ _start258159_ '65535)))
                (std/web/fastcgi#fcgi-write-record__%
                 _port258147_
                 _type258148_
                 _reqid258149_
                 _data258152_
                 _start258159_
                 _end258161_)
                (_lp258157_ _end258161_))
              (std/web/fastcgi#fcgi-write-record__%
               _port258147_
               _type258148_
               _reqid258149_
               _data258152_
               _start258159_
               _len258154_))))))
  (define std/web/fastcgi#fcgi-write-key-value-pairs
    (lambda (_port258068_ _alst258069_)
      (letrec ((_write-length258071_
                (lambda (_port258139_ _len258140_)
                  (if (fx< _len258140_ '128)
                      (write-u8 _len258140_ _port258139_)
                      (let ((_nb3258142_
                             (fxior (fxand (fxarithmetic-shift
                                            _len258140_
                                            '-24)
                                           '127)
                                    '128))
                            (_nb2258143_
                             (fxand (fxarithmetic-shift _len258140_ '-16)
                                    '255))
                            (_nb1258144_
                             (fxand (fxarithmetic-shift _len258140_ '-8) '255))
                            (_nb0258145_ (fxand _len258140_ '255)))
                        (write-u8 _nb3258142_ _port258139_)
                        (write-u8 _nb2258143_ _port258139_)
                        (write-u8 _nb1258144_ _port258139_)
                        (write-u8 _nb0258145_ _port258139_))))))
        (let ((_iterable258113_ _alst258069_)
              (_iter-do258115_
               (lambda (_val258073_)
                 (let* ((_val258075258082_ _val258073_)
                        (_E258077258086_
                         (lambda ()
                           (error '"No clause matching" _val258075258082_)))
                        (_K258078258101_
                         (lambda (_value258089_ _key258090_)
                           (let* ((_kdata258092_
                                   (std/text/utf8#string->utf8__0
                                    (symbol->string _key258090_)))
                                  (_klen258094_
                                   (u8vector-length _kdata258092_))
                                  (_vdata258096_
                                   (if (string? _value258089_)
                                       (std/text/utf8#string->utf8__0
                                        _value258089_)
                                       _value258089_))
                                  (_vlen258098_
                                   (u8vector-length _vdata258096_)))
                             (_write-length258071_ _port258068_ _klen258094_)
                             (_write-length258071_ _port258068_ _vlen258098_)
                             (write-subu8vector
                              _kdata258092_
                              '0
                              _klen258094_
                              _port258068_)
                             (write-subu8vector
                              _vdata258096_
                              '0
                              _vlen258098_
                              _port258068_)))))
                   (if (let ()
                         (declare (not safe))
                         (##pair? _val258075258082_))
                       (let ((_hd258079258104_
                              (let ()
                                (declare (not safe))
                                (##car _val258075258082_)))
                             (_tl258080258106_
                              (let ()
                                (declare (not safe))
                                (##cdr _val258075258082_))))
                         (let* ((_key258109_ _hd258079258104_)
                                (_value258111_ _tl258080258106_))
                           (_K258078258101_ _value258111_ _key258109_)))
                       (_E258077258086_))))))
          (if (pair? _iterable258113_)
              (for-each _iter-do258115_ _iterable258113_)
              (if (null? _iterable258113_)
                  '#!void
                  (let* ((_it258118_ (std/iter#iter _iterable258113_))
                         (_next!258121_
                          (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _it258118_
                             '2
                             std/iter#iterator::t
                             '#f))))
                    (declare (not safe))
                    (begin
                      (let _lp258126_ ()
                        (let ((_val258130_ (_next!258121_ _it258118_)))
                          (if (eq? std/iter#iter-end _val258130_)
                              '#!void
                              (begin
                                (_iter-do258115_ _val258130_)
                                (_lp258126_)))))
                      (let ((_$e258132_
                             (##unchecked-structure-ref
                              _it258118_
                              '3
                              std/iter#iterator::t
                              '#f)))
                        (if _$e258132_
                            ((lambda (_g258134258136_)
                               (_g258134258136_ _it258118_))
                             _$e258132_)
                            '#!void))
                      '#!void))))))))
  (define std/web/fastcgi#fcgi-begin-request-e
    (lambda (_data258063_)
      (let ((_role258065_
             (fxior (fxarithmetic-shift (u8vector-ref _data258063_ '0) '8)
                    (u8vector-ref _data258063_ '1)))
            (_flags258066_ (u8vector-ref _data258063_ '2)))
        (if (eq? _role258065_ std/web/fastcgi#FCGI-RESPONDER)
            (values 'FCGI-RESPONDER _flags258066_)
            (if (eq? _role258065_ std/web/fastcgi#FCGI-AUTHORIZER)
                (values 'FCGI-AUTHORIZER _flags258066_)
                (if (eq? _role258065_ std/web/fastcgi#FCGI-FILTER)
                    (values 'FCGI-FILTER _flags258066_)
                    (values _role258065_ _flags258066_)))))))
  (define std/web/fastcgi#fcgi-get-values-e
    (lambda (_data258061_)
      (map car
           (std/web/fastcgi#fcgi-read-key-value-pairs
            (open-input-u8vector _data258061_)))))
  (define std/web/fastcgi#fcgi-params-e
    (lambda (_data258059_)
      (std/web/fastcgi#fcgi-read-key-value-pairs
       (open-input-u8vector _data258059_))))
  (define std/web/fastcgi#fcgi-get-values-result-data
    (lambda (_alst258055_)
      (let ((_outp258057_ (open-output-u8vector)))
        (std/web/fastcgi#fcgi-write-key-value-pairs _outp258057_ _alst258055_)
        (get-output-u8vector _outp258057_))))
  (define std/web/fastcgi#fcgi-unknown-type-data
    (lambda (_type258051_)
      (let ((_data258053_ (make-u8vector '8)))
        (u8vector-set! _data258053_ '0 _type258051_)
        _data258053_)))
  (define std/web/fastcgi#fcgi-end-request-data
    (lambda (_app-status258046_ _proto-status258047_)
      (let ((_data258049_ (make-u8vector '8)))
        (u8vector-set!
         _data258049_
         '0
         (fxand (fxarithmetic-shift _app-status258046_ '-24) '255))
        (u8vector-set!
         _data258049_
         '1
         (fxand (fxarithmetic-shift _app-status258046_ '-16) '255))
        (u8vector-set!
         _data258049_
         '2
         (fxand (fxarithmetic-shift _app-status258046_ '-8) '255))
        (u8vector-set! _data258049_ '3 (fxand _app-status258046_ '255))
        (u8vector-set! _data258049_ '4 _proto-status258047_)
        _data258049_))))
