prelude: :gerbil/compiler/ssxi
package: std/db

(begin
  (declare-type
   std/db/leveldb#leveldb-error::t
   (@struct-type std/db/leveldb#leveldb-error::t error::t 0 #!void ()))
  (declare-type
   std/db/leveldb#leveldb-error?
   (@struct-pred std/db/leveldb#leveldb-error::t))
  (declare-type
   std/db/leveldb#make-leveldb-error
   (@struct-cons std/db/leveldb#leveldb-error::t))
  (declare-type std/db/leveldb#raise-leveldb-error (@lambda 2 #f))
  (declare-type std/db/leveldb#raise-leveldb-error/errptr (@lambda 2 #f))
  (declare-type std/db/leveldb#fixnum-positive? (@lambda 1 #f))
  (declare-type std/db/leveldb#value-bytes (@lambda 1 #f))
  (declare-type
   std/db/leveldb#leveldb::t
   (@struct-type std/db/leveldb#leveldb::t #f 2 #f ((final: . #t))))
  (declare-type
   std/db/leveldb#leveldb?
   (@struct-pred std/db/leveldb#leveldb::t))
  (declare-type
   std/db/leveldb#make-leveldb
   (@struct-cons std/db/leveldb#leveldb::t))
  (declare-type
   std/db/leveldb#leveldb-db
   (@struct-getf std/db/leveldb#leveldb::t 0 #f))
  (declare-type
   std/db/leveldb#leveldb-opt
   (@struct-getf std/db/leveldb#leveldb::t 1 #f))
  (declare-type
   std/db/leveldb#leveldb-db-set!
   (@struct-setf std/db/leveldb#leveldb::t 0 #f))
  (declare-type
   std/db/leveldb#leveldb-opt-set!
   (@struct-setf std/db/leveldb#leveldb::t 1 #f))
  (declare-type
   std/db/leveldb#leveldb-opts::t
   (@struct-type std/db/leveldb#leveldb-opts::t #f 3 #f ((final: . #t))))
  (declare-type
   std/db/leveldb#leveldb-opts?
   (@struct-pred std/db/leveldb#leveldb-opts::t))
  (declare-type
   std/db/leveldb#make-leveldb-opts
   (@struct-cons std/db/leveldb#leveldb-opts::t))
  (declare-type
   std/db/leveldb#leveldb-opts-e
   (@struct-getf std/db/leveldb#leveldb-opts::t 0 #f))
  (declare-type
   std/db/leveldb#leveldb-opts-cache
   (@struct-getf std/db/leveldb#leveldb-opts::t 1 #f))
  (declare-type
   std/db/leveldb#leveldb-opts-filter
   (@struct-getf std/db/leveldb#leveldb-opts::t 2 #f))
  (declare-type
   std/db/leveldb#leveldb-opts-e-set!
   (@struct-setf std/db/leveldb#leveldb-opts::t 0 #f))
  (declare-type
   std/db/leveldb#leveldb-opts-cache-set!
   (@struct-setf std/db/leveldb#leveldb-opts::t 1 #f))
  (declare-type
   std/db/leveldb#leveldb-opts-filter-set!
   (@struct-setf std/db/leveldb#leveldb-opts::t 2 #f))
  (declare-type
   std/db/leveldb#leveldb-itor::t
   (@struct-type std/db/leveldb#leveldb-itor::t #f 1 #f ((final: . #t))))
  (declare-type
   std/db/leveldb#leveldb-itor?
   (@struct-pred std/db/leveldb#leveldb-itor::t))
  (declare-type
   std/db/leveldb#make-leveldb-itor
   (@struct-cons std/db/leveldb#leveldb-itor::t))
  (declare-type
   std/db/leveldb#leveldb-itor-e
   (@struct-getf std/db/leveldb#leveldb-itor::t 0 #f))
  (declare-type
   std/db/leveldb#leveldb-itor-e-set!
   (@struct-setf std/db/leveldb#leveldb-itor::t 0 #f))
  (declare-type std/db/leveldb#leveldb-open__% (@lambda 2 #f))
  (declare-type std/db/leveldb#leveldb-open__0 (@lambda 1 #f))
  (declare-type
   std/db/leveldb#leveldb-open
   (@case-lambda
    (1 std/db/leveldb#leveldb-open__0)
    (2 std/db/leveldb#leveldb-open__%)))
  (declare-type std/db/leveldb#leveldb-close (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb::destroy (@lambda 1 #f))
  (declare-method
   std/db/leveldb#leveldb::t
   destroy
   std/db/leveldb#leveldb::destroy
   #f)
  (declare-type std/db/leveldb#leveldb-put__% (@lambda 4 #f))
  (declare-type std/db/leveldb#leveldb-put__0 (@lambda 3 #f))
  (declare-type
   std/db/leveldb#leveldb-put
   (@case-lambda
    (3 std/db/leveldb#leveldb-put__0)
    (4 std/db/leveldb#leveldb-put__%)))
  (declare-type std/db/leveldb#leveldb-get__% (@lambda 3 #f))
  (declare-type std/db/leveldb#leveldb-get__0 (@lambda 2 #f))
  (declare-type
   std/db/leveldb#leveldb-get
   (@case-lambda
    (2 std/db/leveldb#leveldb-get__0)
    (3 std/db/leveldb#leveldb-get__%)))
  (declare-type std/db/leveldb#leveldb-delete__% (@lambda 3 #f))
  (declare-type std/db/leveldb#leveldb-delete__0 (@lambda 2 #f))
  (declare-type
   std/db/leveldb#leveldb-delete
   (@case-lambda
    (2 std/db/leveldb#leveldb-delete__0)
    (3 std/db/leveldb#leveldb-delete__%)))
  (declare-type std/db/leveldb#leveldb-write__% (@lambda 3 #f))
  (declare-type std/db/leveldb#leveldb-write__0 (@lambda 2 #f))
  (declare-type
   std/db/leveldb#leveldb-write
   (@case-lambda
    (2 std/db/leveldb#leveldb-write__0)
    (3 std/db/leveldb#leveldb-write__%)))
  (declare-type std/db/leveldb#leveldb-key?__% (@lambda 3 #f))
  (declare-type std/db/leveldb#leveldb-key?__0 (@lambda 2 #f))
  (declare-type
   std/db/leveldb#leveldb-key?
   (@case-lambda
    (2 std/db/leveldb#leveldb-key?__0)
    (3 std/db/leveldb#leveldb-key?__%)))
  (declare-type std/db/leveldb#slice->bytes (@lambda 1 #f))
  (declare-type std/db/leveldb#get-errptr (@lambda 0 #f))
  (declare-type std/db/leveldb#leveldb-writebatch (@lambda 0 #f))
  (declare-type
   std/db/leveldb#leveldb-writebatch-clear
   (@lambda 1 std/db/_leveldb#leveldb_writebatch_clear))
  (declare-type std/db/leveldb#leveldb-writebatch-put (@lambda 3 #f))
  (declare-type std/db/leveldb#leveldb-writebatch-delete (@lambda 2 #f))
  (declare-type std/db/leveldb#leveldb-iterator__% (@lambda 2 #f))
  (declare-type std/db/leveldb#leveldb-iterator__0 (@lambda 1 #f))
  (declare-type
   std/db/leveldb#leveldb-iterator
   (@case-lambda
    (1 std/db/leveldb#leveldb-iterator__0)
    (2 std/db/leveldb#leveldb-iterator__%)))
  (declare-type std/db/leveldb#leveldb-iterator-close (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-itor::destroy (@lambda 1 #f))
  (declare-method
   std/db/leveldb#leveldb-itor::t
   destroy
   std/db/leveldb#leveldb-itor::destroy
   #f)
  (declare-type std/db/leveldb#leveldb-iterator-valid? (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-iterator-seek-first (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-iterator-seek-last (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-iterator-seek (@lambda 2 #f))
  (declare-type std/db/leveldb#leveldb-iterator-next (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-iterator-prev (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-iterator-key (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-iterator-value (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-iterator-error__% (@lambda 2 #f))
  (declare-type std/db/leveldb#leveldb-iterator-error__0 (@lambda 1 #f))
  (declare-type
   std/db/leveldb#leveldb-iterator-error
   (@case-lambda
    (1 std/db/leveldb#leveldb-iterator-error__0)
    (2 std/db/leveldb#leveldb-iterator-error__%)))
  (declare-type
   std/db/leveldb#leveldb-iter-state::t
   (@struct-type std/db/leveldb#leveldb-iter-state::t #f 4 #f ((final: . #t))))
  (declare-type
   std/db/leveldb#leveldb-iter-state?
   (@struct-pred std/db/leveldb#leveldb-iter-state::t))
  (declare-type
   std/db/leveldb#make-leveldb-iter-state
   (@struct-cons std/db/leveldb#leveldb-iter-state::t))
  (declare-type
   std/db/leveldb#leveldb-iter-state-itor
   (@struct-getf std/db/leveldb#leveldb-iter-state::t 0 #f))
  (declare-type
   std/db/leveldb#leveldb-iter-state-value
   (@struct-getf std/db/leveldb#leveldb-iter-state::t 1 #f))
  (declare-type
   std/db/leveldb#leveldb-iter-state-start
   (@struct-getf std/db/leveldb#leveldb-iter-state::t 2 #f))
  (declare-type
   std/db/leveldb#leveldb-iter-state-limit
   (@struct-getf std/db/leveldb#leveldb-iter-state::t 3 #f))
  (declare-type
   std/db/leveldb#leveldb-iter-state-itor-set!
   (@struct-setf std/db/leveldb#leveldb-iter-state::t 0 #f))
  (declare-type
   std/db/leveldb#leveldb-iter-state-value-set!
   (@struct-setf std/db/leveldb#leveldb-iter-state::t 1 #f))
  (declare-type
   std/db/leveldb#leveldb-iter-state-start-set!
   (@struct-setf std/db/leveldb#leveldb-iter-state::t 2 #f))
  (declare-type
   std/db/leveldb#leveldb-iter-state-limit-set!
   (@struct-setf std/db/leveldb#leveldb-iter-state::t 3 #f))
  (declare-type std/db/leveldb#in-leveldb__% (@lambda 3 #f))
  (declare-type std/db/leveldb#in-leveldb__0 (@lambda 1 #f))
  (declare-type std/db/leveldb#in-leveldb__1 (@lambda 2 #f))
  (declare-type
   std/db/leveldb#in-leveldb
   (@case-lambda
    (1 std/db/leveldb#in-leveldb__0)
    (2 std/db/leveldb#in-leveldb__1)
    (3 std/db/leveldb#in-leveldb__%)))
  (declare-type std/db/leveldb#in-leveldb-keys__% (@lambda 3 #f))
  (declare-type std/db/leveldb#in-leveldb-keys__0 (@lambda 1 #f))
  (declare-type std/db/leveldb#in-leveldb-keys__1 (@lambda 2 #f))
  (declare-type
   std/db/leveldb#in-leveldb-keys
   (@case-lambda
    (1 std/db/leveldb#in-leveldb-keys__0)
    (2 std/db/leveldb#in-leveldb-keys__1)
    (3 std/db/leveldb#in-leveldb-keys__%)))
  (declare-type std/db/leveldb#iter-leveldb (@lambda 2 #f))
  (declare-type std/db/leveldb#leveldb-iter-start (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-iter-key-value (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-iter-key (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-iter-next (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-iter-fini (@lambda 1 #f))
  (declare-type std/db/leveldb#iter-nil? (@lambda 1 #f))
  (declare-type std/db/leveldb#leveldb-compact-range (@lambda 3 #f))
  (declare-type std/db/leveldb#leveldb-destroy-db__% (@lambda 2 #f))
  (declare-type std/db/leveldb#leveldb-destroy-db__0 (@lambda 1 #f))
  (declare-type
   std/db/leveldb#leveldb-destroy-db
   (@case-lambda
    (1 std/db/leveldb#leveldb-destroy-db__0)
    (2 std/db/leveldb#leveldb-destroy-db__%)))
  (declare-type std/db/leveldb#leveldb-repair-db__% (@lambda 2 #f))
  (declare-type std/db/leveldb#leveldb-repair-db__0 (@lambda 1 #f))
  (declare-type
   std/db/leveldb#leveldb-repair-db
   (@case-lambda
    (1 std/db/leveldb#leveldb-repair-db__0)
    (2 std/db/leveldb#leveldb-repair-db__%)))
  (declare-type std/db/leveldb#leveldb-options__% (@lambda 11 #f))
  (declare-type
   std/db/leveldb#leveldb-options__@
   (@kw-lambda-dispatch
    (create-if-missing:
     error-if-exists:
     paranoid-checks:
     compression:
     write-buffer-size:
     max-open-files:
     block-size:
     block-restart-interval:
     lru-cache-capacity:
     bloom-filter-bits:)
    std/db/leveldb#leveldb-options__%))
  (declare-type
   std/db/leveldb#leveldb-options
   (@kw-lambda
    (bloom-filter-bits:
     error-if-exists:
     block-restart-interval:
     write-buffer-size:
     lru-cache-capacity:
     max-open-files:
     compression:
     paranoid-checks:
     block-size:
     create-if-missing:)
    std/db/leveldb#leveldb-options__@))
  (declare-type std/db/leveldb#leveldb-default-options (@lambda 0 #f))
  (declare-type std/db/leveldb#leveldb-read-options__% (@lambda 3 #f))
  (declare-type
   std/db/leveldb#leveldb-read-options__@
   (@kw-lambda-dispatch
    (verify-checksums: fill-cache:)
    std/db/leveldb#leveldb-read-options__%))
  (declare-type
   std/db/leveldb#leveldb-read-options
   (@kw-lambda
    (verify-checksums: fill-cache:)
    std/db/leveldb#leveldb-read-options__@))
  (declare-type std/db/leveldb#leveldb-default-read-options (@lambda 0 #f))
  (declare-type std/db/leveldb#leveldb-write-options__% (@lambda 2 #f))
  (declare-type
   std/db/leveldb#leveldb-write-options__@
   (@kw-lambda-dispatch (sync:) std/db/leveldb#leveldb-write-options__%))
  (declare-type
   std/db/leveldb#leveldb-write-options
   (@kw-lambda (sync:) std/db/leveldb#leveldb-write-options__@))
  (declare-type std/db/leveldb#leveldb-default-write-options (@lambda 0 #f)))
